import {
  OutpostsApi
} from "./chunk-KTEXPJ35.js";
import {
  AKChart
} from "./chunk-M4KJFWSR.js";
import "./chunk-OPXWXO3I.js";
import "./chunk-4AY3XIGK.js";
import "./chunk-7CZKKH2O.js";
import "./chunk-3TDT67BW.js";
import "./chunk-ZUWDONTY.js";
import "./chunk-3X7DLXST.js";
import "./chunk-CGOLHTC5.js";
import "./chunk-2LUBJULX.js";
import "./chunk-2NZOT42E.js";
import {
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-6JJ33NXU.js";
import "./chunk-RRWYRLM7.js";
import "./chunk-6WYMJISY.js";
import "./chunk-6BJ64FHW.js";
import "./chunk-FIVQNNAE.js";
import "./chunk-VGWABJEI.js";
import "./chunk-KP44AHRH.js";
import {
  banner_default
} from "./chunk-WJSRKCWV.js";
import "./chunk-FNV26V2B.js";
import "./chunk-GBQ42ZDA.js";
import "./chunk-VLOR6YDM.js";
import "./chunk-N3LMWQUH.js";
import "./chunk-WLIXXMRL.js";
import "./chunk-BBFDWDOB.js";
import "./chunk-UHE2QU34.js";
import "./chunk-7CDOLCSU.js";
import "./chunk-RKBUXRF5.js";
import "./chunk-IUFGI55K.js";
import "./chunk-TJN6LFOQ.js";
import "./chunk-3IFID2KX.js";
import "./chunk-2FYPY3KL.js";
import "./chunk-NRTFQ3WE.js";
import "./chunk-S3ILVWYD.js";
import "./chunk-PIENMLIY.js";
import "./chunk-P3SED4PH.js";
import "./chunk-QGUPPYUK.js";
import "./chunk-WMKINSDI.js";
import "./chunk-EA2TUCZW.js";
import "./chunk-VLXY3QNI.js";
import "./chunk-KSOTESV5.js";
import {
  browser_default
} from "./chunk-N57CGNDJ.js";
import "./chunk-SXPKNFZF.js";
import {
  ModelForm
} from "./chunk-3JQ4HF4T.js";
import {
  Form
} from "./chunk-Y4CBTB76.js";
import "./chunk-3PUBL4VQ.js";
import "./chunk-AMLNCECL.js";
import "./chunk-UY7EXP7Y.js";
import "./chunk-SXZF5VBA.js";
import "./chunk-SRK74APZ.js";
import "./chunk-WYSJXYDA.js";
import "./chunk-2GU5BCBP.js";
import "./chunk-UX7TDHO2.js";
import "./chunk-DK5NYREA.js";
import {
  grid_default
} from "./chunk-XCEM2TDB.js";
import {
  list_default
} from "./chunk-43ID2PET.js";
import {
  card_default
} from "./chunk-ITYWTYEW.js";
import "./chunk-WCAXL5N5.js";
import "./chunk-EEANTJCZ.js";
import {
  description_list_default
} from "./chunk-DJQHOO67.js";
import {
  Table,
  TableColumn
} from "./chunk-APZGZXW5.js";
import "./chunk-K3AR7TXW.js";
import "./chunk-RBLHQ2MQ.js";
import "./chunk-ADUGFWT2.js";
import {
  AKElement,
  CoreApi,
  DEFAULT_CONFIG,
  button_default,
  content_default,
  first,
  n,
  page_default,
  patternfly_base_default,
  r,
  t,
  to
} from "./chunk-MKGIUSP2.js";
import {
  ke,
  msg,
  str
} from "./chunk-BW7LVHGS.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/admin/applications/ApplicationAuthorizeChart.ts
var ApplicationAuthorizeChart = class extends AKChart {
  async apiRequest() {
    return new CoreApi(DEFAULT_CONFIG).coreApplicationsMetricsList({
      slug: this.applicationSlug
    });
  }
  timeTickCallback(tickValue, index, ticks) {
    const valueStamp = ticks[index];
    const delta = Date.now() - valueStamp.value;
    const ago = Math.round(delta / 1e3 / 3600 / 24);
    return msg(str`${ago} days ago`);
  }
  getChartData(data) {
    return {
      datasets: [
        {
          label: msg("Authorizations"),
          backgroundColor: "rgba(189, 229, 184, .5)",
          spanGaps: true,
          data: data.map((cord) => {
            return {
              x: cord.xCord || 0,
              y: cord.yCord || 0
            };
          }) || []
        }
      ]
    };
  }
};
__decorateClass([
  n()
], ApplicationAuthorizeChart.prototype, "applicationSlug", 2);
ApplicationAuthorizeChart = __decorateClass([
  t("ak-charts-application-authorize")
], ApplicationAuthorizeChart);

// src/admin/applications/ApplicationCheckAccessForm.ts
var ApplicationCheckAccessForm = class extends Form {
  getSuccessMessage() {
    return msg("Successfully sent test-request.");
  }
  async send(data) {
    this.request = data.forUser;
    const result = await new CoreApi(DEFAULT_CONFIG).coreApplicationsCheckAccessRetrieve({
      slug: this.application?.slug,
      forUser: data.forUser
    });
    return this.result = result;
  }
  resetForm() {
    super.resetForm();
    this.result = void 0;
  }
  static get styles() {
    return super.styles.concat(description_list_default);
  }
  renderResult() {
    return ke`
            <ak-form-element-horizontal label=${msg("Passing")}>
                <div class="pf-c-form__group-label">
                    <div class="c-form__horizontal-group">
                        <span class="pf-c-form__label-text">
                            <ak-status-label ?good=${this.result?.passing}></ak-status-label>
                        </span>
                    </div>
                </div>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Messages")}>
                <div class="pf-c-form__group-label">
                    <div class="c-form__horizontal-group">
                        <ul>
                            ${(this.result?.messages || []).length > 0 ? this.result?.messages?.map((m) => {
      return ke`<li>
                                          <span class="pf-c-form__label-text">${m}</span>
                                      </li>`;
    }) : ke`<li>
                                      <span class="pf-c-form__label-text">-</span>
                                  </li>`}
                        </ul>
                    </div>
                </div>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Log messages")}>
                <div class="pf-c-form__group-label">
                    <div class="c-form__horizontal-group">
                        <dl class="pf-c-description-list pf-m-horizontal">
                            <ak-log-viewer .logs=${this.result?.logMessages}></ak-log-viewer>
                        </dl>
                    </div>
                </div>
            </ak-form-element-horizontal>
        `;
  }
  renderForm() {
    return ke`<ak-form-element-horizontal
                label=${msg("User")}
                ?required=${true}
                name="forUser"
            >
                <ak-search-select
                    .fetchObjects=${async (query) => {
      const args = {
        ordering: "username"
      };
      if (query !== void 0) {
        args.search = query;
      }
      const users = await new CoreApi(DEFAULT_CONFIG).coreUsersList(args);
      return users.results;
    }}
                    .renderElement=${(user) => {
      return user.username;
    }}
                    .renderDescription=${(user) => {
      return ke`${user.name}`;
    }}
                    .value=${(user) => {
      return user?.pk;
    }}
                    .selected=${(user) => {
      return user.pk.toString() === this.request?.toString();
    }}
                >
                </ak-search-select>
            </ak-form-element-horizontal>
            ${this.result ? this.renderResult() : ke``}`;
  }
};
__decorateClass([
  n({ attribute: false })
], ApplicationCheckAccessForm.prototype, "application", 2);
__decorateClass([
  n({ attribute: false })
], ApplicationCheckAccessForm.prototype, "result", 2);
__decorateClass([
  n({ attribute: false })
], ApplicationCheckAccessForm.prototype, "request", 2);
ApplicationCheckAccessForm = __decorateClass([
  t("ak-application-check-access-form")
], ApplicationCheckAccessForm);

// src/admin/applications/entitlements/ApplicationEntitlementForm.ts
var ApplicationEntitlementForm = class extends ModelForm {
  async loadInstance(pk) {
    return new CoreApi(DEFAULT_CONFIG).coreApplicationEntitlementsRetrieve({
      pbmUuid: pk
    });
  }
  getSuccessMessage() {
    if (this.instance?.pbmUuid) {
      return msg("Successfully updated entitlement.");
    } else {
      return msg("Successfully created entitlement.");
    }
  }
  static get styles() {
    return [...super.styles, content_default];
  }
  send(data) {
    if (this.targetPk) {
      data.app = this.targetPk;
    }
    if (this.instance?.pbmUuid) {
      return new CoreApi(DEFAULT_CONFIG).coreApplicationEntitlementsUpdate({
        pbmUuid: this.instance.pbmUuid || "",
        applicationEntitlementRequest: data
      });
    } else {
      return new CoreApi(DEFAULT_CONFIG).coreApplicationEntitlementsCreate({
        applicationEntitlementRequest: data
      });
    }
  }
  renderForm() {
    return ke` <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${first(this.instance?.name, "")}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Attributes")}
                ?required=${false}
                name="attributes"
            >
                <ak-codemirror
                    mode=${"yaml" /* YAML */}
                    value="${browser_default.stringify(first(this.instance?.attributes, {}))}"
                >
                </ak-codemirror>
                <p class="pf-c-form__helper-text">
                    ${msg("Set custom attributes using YAML or JSON.")}
                </p>
            </ak-form-element-horizontal>`;
  }
};
__decorateClass([
  n()
], ApplicationEntitlementForm.prototype, "targetPk", 2);
ApplicationEntitlementForm = __decorateClass([
  t("ak-application-entitlement-form")
], ApplicationEntitlementForm);

// src/admin/applications/entitlements/ApplicationEntitlementPage.ts
var ApplicationEntitlementsPage = class extends Table {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.expandable = true;
    this.order = "order";
  }
  async apiEndpoint() {
    return new CoreApi(DEFAULT_CONFIG).coreApplicationEntitlementsList({
      ...await this.defaultEndpointConfig(),
      app: this.app || ""
    });
  }
  columns() {
    return [new TableColumn(msg("Name"), "name"), new TableColumn(msg("Actions"))];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return ke`<ak-forms-delete-bulk
            objectLabel=${msg("Application entitlement(s)")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new CoreApi(DEFAULT_CONFIG).coreApplicationEntitlementsUsedByList({
        pbmUuid: item.pbmUuid || ""
      });
    }}
            .delete=${(item) => {
      return new CoreApi(DEFAULT_CONFIG).coreApplicationEntitlementsDestroy({
        pbmUuid: item.pbmUuid || ""
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  row(item) {
    return [
      ke`${item.name}`,
      ke`<ak-forms-modal size=${"pf-m-md" /* Medium */}>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg("Update Entitlement")} </span>
                    <ak-application-entitlement-form
                        slot="form"
                        .instancePk=${item.pbmUuid}
                        targetPk=${to(this.app)}
                    >
                    </ak-application-entitlement-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Edit")}>
                            <i class="fas fa-edit"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>
                <ak-rbac-object-permission-modal
                    model=${RbacPermissionsAssignedByUsersListModelEnum.AuthentikCoreApplicationentitlement}
                    objectPk=${item.pbmUuid}
                >
                </ak-rbac-object-permission-modal>`
    ];
  }
  renderExpanded(item) {
    return ke`<td></td>
            <td role="cell" colspan="4">
                <div class="pf-c-table__expandable-row-content">
                    <div class="pf-c-content">
                        <p>
                            ${msg(
      "These bindings control which users have access to this entitlement."
    )}
                        </p>
                        <ak-bound-policies-list
                            .target=${item.pbmUuid}
                            .allowedTypes=${[
      "group" /* group */,
      "user" /* user */
    ]}
                        >
                        </ak-bound-policies-list>
                    </div>
                </div>
            </td>`;
  }
  renderEmpty() {
    return super.renderEmpty(
      ke`<ak-empty-state
                header=${msg("No app entitlements created.")}
                icon="pf-icon-module"
            >
                <div slot="body">
                    ${msg(
        "This application does currently not have any application entitlement defined."
      )}
                </div>
                <div slot="primary"></div>
            </ak-empty-state>`
    );
  }
  renderToolbar() {
    return ke`<ak-forms-modal size=${"pf-m-md" /* Medium */}>
            <span slot="submit"> ${msg("Create")} </span>
            <span slot="header"> ${msg("Create Entitlement")} </span>
            <ak-application-entitlement-form slot="form" targetPk=${to(this.app)}>
            </ak-application-entitlement-form>
            <button slot="trigger" class="pf-c-button pf-m-primary">
                ${msg("Create entitlement")}
            </button>
        </ak-forms-modal> `;
  }
};
__decorateClass([
  n()
], ApplicationEntitlementsPage.prototype, "app", 2);
ApplicationEntitlementsPage = __decorateClass([
  t("ak-application-entitlements-list")
], ApplicationEntitlementsPage);

// src/admin/applications/ApplicationViewPage.ts
var ApplicationViewPage = class extends AKElement {
  constructor() {
    super(...arguments);
    this.missingOutpost = false;
  }
  static get styles() {
    return [
      patternfly_base_default,
      list_default,
      banner_default,
      page_default,
      content_default,
      button_default,
      description_list_default,
      grid_default,
      card_default
    ];
  }
  fetchIsMissingOutpost(providersByPk) {
    new OutpostsApi(DEFAULT_CONFIG).outpostsInstancesList({
      providersByPk,
      pageSize: 1
    }).then((outposts) => {
      if (outposts.pagination.count < 1) {
        this.missingOutpost = true;
      }
    });
  }
  fetchApplication(slug) {
    new CoreApi(DEFAULT_CONFIG).coreApplicationsRetrieve({ slug }).then((app) => {
      this.application = app;
      if (app.providerObj && [
        RbacPermissionsAssignedByUsersListModelEnum.AuthentikProvidersProxyProxyprovider.toString(),
        RbacPermissionsAssignedByUsersListModelEnum.AuthentikProvidersLdapLdapprovider.toString()
      ].includes(app.providerObj.metaModelName)) {
        this.fetchIsMissingOutpost([app.provider || 0]);
      }
    });
  }
  willUpdate(changedProperties) {
    if (changedProperties.has("applicationSlug") && this.applicationSlug) {
      this.fetchApplication(this.applicationSlug);
    }
  }
  render() {
    return ke`<ak-page-header
                header=${this.application?.name || msg("Loading")}
                description=${to(this.application?.metaPublisher)}
                .iconImage=${true}
            >
                <ak-app-icon
                    size=${"pf-m-md" /* Medium */}
                    name=${to(this.application?.name || void 0)}
                    icon=${to(this.application?.metaIcon || void 0)}
                    slot="icon"
                ></ak-app-icon>
            </ak-page-header>
            ${this.renderApp()}`;
  }
  renderApp() {
    if (!this.application) {
      return ke`<ak-empty-state ?loading="${true}" header=${msg("Loading")}>
            </ak-empty-state>`;
    }
    return ke`<ak-tabs>
            ${this.missingOutpost ? ke`<div slot="header" class="pf-c-banner pf-m-warning">
                      ${msg("Warning: Application is not used by any Outpost.")}
                  </div>` : ke``}
            <section
                slot="page-overview"
                data-tab-title="${msg("Overview")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div
                        class="pf-c-card pf-l-grid__item pf-m-12-col pf-m-2-col-on-xl pf-m-2-col-on-2xl"
                    >
                        <div class="pf-c-card__title">${msg("Related")}</div>
                        <div class="pf-c-card__body">
                            <dl class="pf-c-description-list">
                                ${this.application.providerObj ? ke`<div class="pf-c-description-list__group">
                                          <dt class="pf-c-description-list__term">
                                              <span class="pf-c-description-list__text"
                                                  >${msg("Provider")}</span
                                              >
                                          </dt>
                                          <dd class="pf-c-description-list__description">
                                              <div class="pf-c-description-list__text">
                                                  <a
                                                      href="#/core/providers/${this.application.providerObj?.pk}"
                                                  >
                                                      ${this.application.providerObj?.name}
                                                      (${this.application.providerObj?.verboseName})
                                                  </a>
                                              </div>
                                          </dd>
                                      </div>` : ke``}
                                ${(this.application.backchannelProvidersObj || []).length > 0 ? ke`<div class="pf-c-description-list__group">
                                          <dt class="pf-c-description-list__term">
                                              <span class="pf-c-description-list__text"
                                                  >${msg("Backchannel Providers")}</span
                                              >
                                          </dt>
                                          <dd class="pf-c-description-list__description">
                                              <div class="pf-c-description-list__text">
                                                  <ul class="pf-c-list">
                                                      ${this.application.backchannelProvidersObj.map(
      (provider) => {
        return ke`
                                                                  <li>
                                                                      <a
                                                                          href="#/core/providers/${provider.pk}"
                                                                      >
                                                                          ${provider.name}
                                                                          (${provider.verboseName})
                                                                      </a>
                                                                  </li>
                                                              `;
      }
    )}
                                                  </ul>
                                              </div>
                                          </dd>
                                      </div>` : ke``}
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Policy engine mode")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            ${this.application.policyEngineMode?.toUpperCase()}
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Edit")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            <ak-forms-modal>
                                                <span slot="submit"> ${msg("Update")} </span>
                                                <span slot="header">
                                                    ${msg("Update Application")}
                                                </span>
                                                <ak-application-form
                                                    slot="form"
                                                    .instancePk=${this.application.slug}
                                                >
                                                </ak-application-form>
                                                <button
                                                    slot="trigger"
                                                    class="pf-c-button pf-m-secondary"
                                                >
                                                    ${msg("Edit")}
                                                </button>
                                            </ak-forms-modal>
                                        </div>
                                    </dd>
                                </div>
                                <div class="pf-c-description-list__group">
                                    <dt class="pf-c-description-list__term">
                                        <span class="pf-c-description-list__text"
                                            >${msg("Check access")}</span
                                        >
                                    </dt>
                                    <dd class="pf-c-description-list__description">
                                        <div class="pf-c-description-list__text">
                                            <ak-forms-modal .closeAfterSuccessfulSubmit=${false}>
                                                <span slot="submit"> ${msg("Check")} </span>
                                                <span slot="header">
                                                    ${msg("Check Application access")}
                                                </span>
                                                <ak-application-check-access-form
                                                    slot="form"
                                                    .application=${this.application}
                                                >
                                                </ak-application-check-access-form>
                                                <button
                                                    slot="trigger"
                                                    class="pf-c-button pf-m-secondary"
                                                >
                                                    ${msg("Test")}
                                                </button>
                                            </ak-forms-modal>
                                        </div>
                                    </dd>
                                </div>
                                ${this.application.launchUrl ? ke`<div class="pf-c-description-list__group">
                                          <dt class="pf-c-description-list__term">
                                              <span class="pf-c-description-list__text"
                                                  >${msg("Launch")}</span
                                              >
                                          </dt>
                                          <dd class="pf-c-description-list__description">
                                              <div class="pf-c-description-list__text">
                                                  <a
                                                      target="_blank"
                                                      href=${this.application.launchUrl}
                                                      slot="trigger"
                                                      class="pf-c-button pf-m-secondary"
                                                  >
                                                      ${msg("Launch")}
                                                  </a>
                                              </div>
                                          </dd>
                                      </div>` : ke``}
                            </dl>
                        </div>
                    </div>
                    <div
                        class="pf-c-card pf-l-grid__item pf-m-12-col pf-m-10-col-on-xl pf-m-10-col-on-2xl"
                    >
                        <div class="pf-c-card__title">
                            ${msg("Logins over the last week (per 8 hours)")}
                        </div>
                        <div class="pf-c-card__body">
                            ${this.application && ke` <ak-charts-application-authorize
                                applicationSlug=${this.application.slug}
                            >
                            </ak-charts-application-authorize>`}
                        </div>
                    </div>
                    <div class="pf-c-card pf-l-grid__item pf-m-12-col">
                        <div class="pf-c-card__title">${msg("Changelog")}</div>
                        <div class="pf-c-card__body">
                            <ak-object-changelog
                                targetModelPk=${this.application.pk || ""}
                                targetModelApp="authentik_core"
                                targetModelName="application"
                            >
                            </ak-object-changelog>
                        </div>
                    </div>
                </div>
            </section>
            <section
                slot="page-app-entitlements"
                data-tab-title="${msg("Application entitlements")}"
            >
                <div slot="header" class="pf-c-banner pf-m-info">
                    ${msg("Application entitlements are in preview.")}
                    <a href="mailto:hello+feature/app-ent@goauthentik.io"
                        >${msg("Send us feedback!")}</a
                    >
                </div>
                <div class="pf-c-page__main-section pf-m-no-padding-mobile">
                    <div class="pf-c-card">
                        <div class="pf-c-card__title">
                            ${msg(
      "These entitlements can be used to configure user access in this application."
    )}
                        </div>
                        <ak-application-entitlements-list .app=${this.application.pk}>
                        </ak-application-entitlements-list>
                    </div>
                </div>
            </section>
            <section
                slot="page-policy-bindings"
                data-tab-title="${msg("Policy / Group / User Bindings")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-c-card">
                    <div class="pf-c-card__title">
                        ${msg("These policies control which users can access this application.")}
                    </div>
                    <ak-bound-policies-list .target=${this.application.pk}>
                    </ak-bound-policies-list>
                </div>
            </section>
            <ak-rbac-object-permission-page
                slot="page-permissions"
                data-tab-title="${msg("Permissions")}"
                model=${RbacPermissionsAssignedByUsersListModelEnum.AuthentikCoreApplication}
                objectPk=${this.application.pk}
            ></ak-rbac-object-permission-page>
        </ak-tabs>`;
  }
};
__decorateClass([
  n({ type: String })
], ApplicationViewPage.prototype, "applicationSlug", 2);
__decorateClass([
  r()
], ApplicationViewPage.prototype, "application", 2);
__decorateClass([
  r()
], ApplicationViewPage.prototype, "missingOutpost", 2);
ApplicationViewPage = __decorateClass([
  t("ak-application-view")
], ApplicationViewPage);
export {
  ApplicationViewPage
};
//# sourceMappingURL=ApplicationViewPage-T23MLT3K.js.map
