import {
  EnterpriseApi
} from "./chunk-CXNEVRN4.js";
import "./chunk-NV4FC5TZ.js";
import "./chunk-3TDT67BW.js";
import "./chunk-2LUBJULX.js";
import {
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-6JJ33NXU.js";
import {
  split_default
} from "./chunk-6BJ64FHW.js";
import "./chunk-KP44AHRH.js";
import {
  banner_default
} from "./chunk-WJSRKCWV.js";
import "./chunk-FNV26V2B.js";
import "./chunk-FMBL57EI.js";
import {
  TablePage
} from "./chunk-JSGSR4RJ.js";
import "./chunk-BBFDWDOB.js";
import "./chunk-TJN6LFOQ.js";
import "./chunk-3IFID2KX.js";
import "./chunk-EA2TUCZW.js";
import "./chunk-N57CGNDJ.js";
import "./chunk-SXPKNFZF.js";
import {
  ModelForm
} from "./chunk-3JQ4HF4T.js";
import "./chunk-Y4CBTB76.js";
import {
  LicenseSummaryStatusEnum
} from "./chunk-SXZF5VBA.js";
import "./chunk-UX7TDHO2.js";
import "./chunk-DK5NYREA.js";
import {
  grid_default
} from "./chunk-XCEM2TDB.js";
import "./chunk-43ID2PET.js";
import {
  card_default
} from "./chunk-ITYWTYEW.js";
import "./chunk-EEANTJCZ.js";
import {
  description_list_default
} from "./chunk-DJQHOO67.js";
import {
  TableColumn,
  form_control_default
} from "./chunk-APZGZXW5.js";
import "./chunk-K3AR7TXW.js";
import "./chunk-RBLHQ2MQ.js";
import "./chunk-ADUGFWT2.js";
import {
  AKElement,
  DEFAULT_CONFIG,
  EVENT_REFRESH_ENTERPRISE,
  button_default,
  getRelativeTime,
  n,
  patternfly_base_default,
  r,
  t,
  to
} from "./chunk-MKGIUSP2.js";
import {
  D,
  i,
  ke,
  msg,
  str
} from "./chunk-BW7LVHGS.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/admin/enterprise/EnterpriseLicenseForm.ts
var EnterpriseLicenseForm = class extends ModelForm {
  loadInstance(pk) {
    return new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicenseRetrieve({
      licenseUuid: pk
    });
  }
  getSuccessMessage() {
    return this.instance ? msg("Successfully updated license.") : msg("Successfully created license.");
  }
  async load() {
    this.installID = (await new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicenseInstallIdRetrieve()).installId;
  }
  async send(data) {
    return (this.instance ? new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicensePartialUpdate({
      licenseUuid: this.instance.licenseUuid || "",
      patchedLicenseRequest: data
    }) : new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicenseCreate({
      licenseRequest: data
    })).then((data2) => {
      window.dispatchEvent(new CustomEvent(EVENT_REFRESH_ENTERPRISE));
      return data2;
    });
  }
  renderForm() {
    return ke` <ak-form-element-horizontal label=${msg("Install ID")}>
                <input
                    class="pf-c-form-control pf-m-monospace"
                    autocomplete="off"
                    spellcheck="false"
                    readonly
                    type="text"
                    value="${to(this.installID)}"
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                name="key"
                ?writeOnly=${this.instance !== void 0}
                label=${msg("License key")}
            >
                <textarea
                    class="pf-c-form-control pf-m-monospace"
                    autocomplete="off"
                    spellcheck="false"
                ></textarea>
            </ak-form-element-horizontal>`;
  }
};
__decorateClass([
  r()
], EnterpriseLicenseForm.prototype, "installID", 2);
EnterpriseLicenseForm = __decorateClass([
  t("ak-enterprise-license-form")
], EnterpriseLicenseForm);

// node_modules/@patternfly/patternfly/components/Progress/progress.css
var progress_default = '.pf-c-progress {\n  --pf-c-progress--GridGap: var(--pf-global--spacer--md);\n  --pf-c-progress__bar--before--BackgroundColor: var(--pf-global--primary-color--100);\n  --pf-c-progress__bar--Height: var(--pf-global--spacer--md);\n  --pf-c-progress__bar--BackgroundColor: var(--pf-global--BackgroundColor--light-100);\n  --pf-c-progress__measure--m-static-width--MinWidth: 4.5ch;\n  --pf-c-progress__status-icon--Color: var(--pf-global--Color--100);\n  --pf-c-progress__status-icon--MarginLeft: var(--pf-global--spacer--sm);\n  --pf-c-progress__bar--before--Opacity: .2;\n  --pf-c-progress__indicator--Height: var(--pf-c-progress__bar--Height);\n  --pf-c-progress__indicator--BackgroundColor: var(--pf-c-progress__bar--before--BackgroundColor);\n  --pf-c-progress__helper-text--MarginTop: calc(var(--pf-global--spacer--xs) - var(--pf-c-progress--GridGap));\n  --pf-c-progress--m-success__bar--BackgroundColor: var(--pf-global--success-color--100);\n  --pf-c-progress--m-warning__bar--BackgroundColor: var(--pf-global--warning-color--100);\n  --pf-c-progress--m-danger__bar--BackgroundColor: var(--pf-global--danger-color--100);\n  --pf-c-progress--m-success__status-icon--Color: var(--pf-global--success-color--100);\n  --pf-c-progress--m-warning__status-icon--Color: var(--pf-global--warning-color--100);\n  --pf-c-progress--m-danger__status-icon--Color: var(--pf-global--danger-color--100);\n  --pf-c-progress--m-inside__indicator--MinWidth: var(--pf-global--spacer--xl);\n  --pf-c-progress--m-inside__measure--Color: var(--pf-global--Color--light-100);\n  --pf-c-progress--m-success--m-inside__measure--Color: var(--pf-global--Color--light-100);\n  --pf-c-progress--m-warning--m-inside__measure--Color: var(--pf-global--Color--dark-100);\n  --pf-c-progress--m-inside__measure--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-progress--m-outside__measure--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-progress--m-sm__bar--Height: var(--pf-global--spacer--sm);\n  --pf-c-progress--m-sm__description--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-progress--m-sm__measure--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-progress--m-lg__bar--Height: var(--pf-global--spacer--lg);\n  display: grid;\n  align-items: end;\n  grid-gap: var(--pf-c-progress--GridGap);\n  grid-template-columns: auto auto;\n  grid-template-rows: 1fr auto;\n}\n.pf-c-progress.pf-m-sm {\n  --pf-c-progress__bar--Height: var(--pf-c-progress--m-sm__bar--Height);\n}\n.pf-c-progress.pf-m-sm .pf-c-progress__description {\n  font-size: var(--pf-c-progress--m-sm__description--FontSize);\n}\n.pf-c-progress.pf-m-sm .pf-c-progress__measure {\n  font-size: var(--pf-c-progress--m-sm__measure--FontSize);\n}\n.pf-c-progress.pf-m-lg {\n  --pf-c-progress__bar--Height: var(--pf-c-progress--m-lg__bar--Height);\n}\n.pf-c-progress.pf-m-inside .pf-c-progress__indicator {\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  min-width: var(--pf-c-progress--m-inside__indicator--MinWidth);\n}\n.pf-c-progress.pf-m-inside .pf-c-progress__measure {\n  font-size: var(--pf-c-progress--m-inside__measure--FontSize);\n  color: var(--pf-c-progress--m-inside__measure--Color);\n  text-align: center;\n}\n.pf-c-progress.pf-m-outside .pf-c-progress__description {\n  grid-column: 1/3;\n}\n.pf-c-progress.pf-m-outside .pf-c-progress__status {\n  grid-column: 2/3;\n  grid-row: 2/3;\n  align-self: center;\n}\n.pf-c-progress.pf-m-outside .pf-c-progress__measure {\n  display: inline-block;\n  font-size: var(--pf-c-progress--m-outside__measure--FontSize);\n}\n.pf-c-progress.pf-m-outside .pf-c-progress__measure.pf-m-static-width {\n  min-width: var(--pf-c-progress__measure--m-static-width--MinWidth);\n  text-align: left;\n}\n.pf-c-progress.pf-m-outside .pf-c-progress__bar,\n.pf-c-progress.pf-m-outside .pf-c-progress__indicator {\n  grid-column: 1/2;\n}\n.pf-c-progress.pf-m-singleline {\n  grid-template-rows: 1fr;\n}\n.pf-c-progress.pf-m-singleline .pf-c-progress__description {\n  display: none;\n  visibility: hidden;\n}\n.pf-c-progress.pf-m-singleline .pf-c-progress__bar {\n  grid-row: 1/2;\n  grid-column: 1/2;\n}\n.pf-c-progress.pf-m-singleline .pf-c-progress__status {\n  grid-row: 1/2;\n  grid-column: 2/3;\n}\n.pf-c-progress.pf-m-outside, .pf-c-progress.pf-m-singleline {\n  grid-template-columns: 1fr fit-content(50%);\n}\n.pf-c-progress.pf-m-success {\n  --pf-c-progress__bar--before--BackgroundColor: var(--pf-c-progress--m-success__bar--BackgroundColor);\n  --pf-c-progress__status-icon--Color: var(--pf-c-progress--m-success__status-icon--Color);\n  --pf-c-progress--m-inside__measure--Color: var(--pf-c-progress--m-success--m-inside__measure--Color);\n}\n.pf-c-progress.pf-m-warning {\n  --pf-c-progress__bar--before--BackgroundColor: var(--pf-c-progress--m-warning__bar--BackgroundColor);\n  --pf-c-progress__status-icon--Color: var(--pf-c-progress--m-warning__status-icon--Color);\n  --pf-c-progress--m-inside__measure--Color: var(--pf-c-progress--m-warning--m-inside__measure--Color);\n}\n.pf-c-progress.pf-m-danger {\n  --pf-c-progress__bar--before--BackgroundColor: var(--pf-c-progress--m-danger__bar--BackgroundColor);\n  --pf-c-progress__status-icon--Color: var(--pf-c-progress--m-danger__status-icon--Color);\n}\n\n.pf-c-progress__description {\n  word-break: break-word;\n  grid-column: 1/2;\n}\n.pf-c-progress__description.pf-m-truncate {\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n}\n\n.pf-c-progress__status {\n  grid-column: 2/3;\n  grid-row: 1/2;\n  text-align: right;\n  word-break: break-word;\n}\n\n.pf-c-progress__status-icon {\n  margin-left: var(--pf-c-progress__status-icon--MarginLeft);\n  color: var(--pf-c-progress__status-icon--Color);\n}\n\n.pf-c-progress__bar {\n  position: relative;\n  grid-column: 1/3;\n  grid-row: 2/3;\n  align-self: center;\n  height: var(--pf-c-progress__bar--Height);\n  background-color: var(--pf-c-progress__bar--BackgroundColor);\n}\n.pf-c-progress__bar::before {\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: 100%;\n  height: 100%;\n  content: "";\n  background-color: var(--pf-c-progress__bar--before--BackgroundColor);\n  opacity: var(--pf-c-progress__bar--before--Opacity);\n}\n\n.pf-c-progress__indicator {\n  position: absolute;\n  top: 0;\n  left: 0;\n  height: var(--pf-c-progress__indicator--Height);\n  background-color: var(--pf-c-progress__indicator--BackgroundColor);\n}\n\n.pf-c-progress__helper-text {\n  grid-column: 1/3;\n  grid-row: 3/4;\n  margin-top: var(--pf-c-progress__helper-text--MarginTop);\n}\n\n:where(.pf-theme-dark) .pf-c-progress {\n  --pf-c-progress--m-inside__measure--Color: var(--pf-global--palette--black-900);\n  --pf-c-progress--m-success--m-inside__measure--Color: var(--pf-global--palette--black-900);\n  --pf-c-progress--m-warning--m-inside__measure--Color: var(--pf-global--palette--black-900);\n}';

// src/admin/enterprise/EnterpriseStatusCard.ts
var EnterpriseStatusCard = class extends AKElement {
  static get styles() {
    return [patternfly_base_default, description_list_default, card_default, split_default, progress_default];
  }
  renderSummaryBadge() {
    switch (this.summary?.status) {
      case LicenseSummaryStatusEnum.Expired:
        return ke`<ak-label color=${"pf-m-red" /* Red */}>${msg("Expired")}</ak-label>`;
      case LicenseSummaryStatusEnum.ExpirySoon:
        return ke`<ak-label color=${"pf-m-orange" /* Orange */}>${msg("Expiring soon")}</ak-label>`;
      case LicenseSummaryStatusEnum.Unlicensed:
        return ke`<ak-label color=${"" /* Grey */}>${msg("Unlicensed")}</ak-label>`;
      case LicenseSummaryStatusEnum.ReadOnly:
        return ke`<ak-label color=${"pf-m-red" /* Red */}>${msg("Read Only")}</ak-label>`;
      case LicenseSummaryStatusEnum.Valid:
        return ke`<ak-label color=${"pf-m-green" /* Green */}>${msg("Valid")}</ak-label>`;
      default:
        return D;
    }
  }
  calcUserPercentage(licensed, current) {
    const percentage = licensed > 0 ? Math.ceil(current / (licensed / 100)) : 0;
    if (current > 0 && licensed === 0) return Infinity;
    return percentage;
  }
  render() {
    if (!this.forecast || !this.summary) {
      return ke`${msg("Loading")}`;
    }
    let internalUserPercentage = 0;
    let externalUserPercentage = 0;
    if (this.summary.status !== LicenseSummaryStatusEnum.Unlicensed) {
      internalUserPercentage = this.calcUserPercentage(
        this.summary.internalUsers,
        this.forecast.internalUsers
      );
      externalUserPercentage = this.calcUserPercentage(
        this.summary.externalUsers,
        this.forecast.externalUsers
      );
    }
    return ke`<div class="pf-c-card">
            <div class="pf-c-card__title">${msg("Current license status")}</div>
            <div class="pf-c-card__body">
                <div class="pf-l-split pf-m-gutter">
                    <dl class="pf-l-split__item pf-c-description-list pf-m-horizontal">
                        <div class="pf-c-description-list__group">
                            <dt class="pf-c-description-list__term">
                                <span class="pf-c-description-list__text"
                                    >${msg("Overall license status")}</span
                                >
                            </dt>
                            <dd class="pf-c-description-list__description">
                                <div class="pf-c-description-list__text">
                                    ${this.renderSummaryBadge()}
                                </div>
                            </dd>
                        </div>
                    </dl>
                    <div class="pf-l-split__item pf-m-fill">
                        <div
                            class="pf-c-progress ${internalUserPercentage > 100 ? "pf-m-danger" : ""} ${internalUserPercentage >= 80 ? "pf-m-warning" : ""}"
                            id="internalUsers"
                        >
                            <div class="pf-c-progress__description">
                                ${msg("Internal user usage")}
                            </div>
                            <div class="pf-c-progress__status" aria-hidden="true">
                                <span class="pf-c-progress__measure"
                                    >${msg(
      str`${internalUserPercentage < Infinity ? internalUserPercentage : "\u221E"}%`
    )}</span
                                >
                            </div>
                            <div
                                class="pf-c-progress__bar"
                                role="progressbar"
                                aria-valuemin="0"
                                aria-valuemax="100"
                                aria-valuenow="${internalUserPercentage}"
                            >
                                <div
                                    class="pf-c-progress__indicator"
                                    style="width:${Math.min(internalUserPercentage, 100)}%;"
                                ></div>
                            </div>
                        </div>
                        <div
                            class="pf-c-progress ${externalUserPercentage > 100 ? "pf-m-danger" : ""} ${externalUserPercentage >= 80 ? "pf-m-warning" : ""}"
                            id="externalUsers"
                        >
                            <div class="pf-c-progress__description">
                                ${msg("External user usage")}
                            </div>
                            <div class="pf-c-progress__status" aria-hidden="true">
                                <span class="pf-c-progress__measure"
                                    >${msg(
      str`${externalUserPercentage < Infinity ? externalUserPercentage : "\u221E"}%`
    )}</span
                                >
                            </div>
                            <div
                                class="pf-c-progress__bar"
                                role="progressbar"
                                aria-valuemin="0"
                                aria-valuemax="100"
                                aria-valuenow="${externalUserPercentage < Infinity ? externalUserPercentage : "\u221E"}"
                            >
                                <div
                                    class="pf-c-progress__indicator"
                                    style="width:${Math.min(externalUserPercentage, 100)}%;"
                                ></div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>`;
  }
};
__decorateClass([
  r()
], EnterpriseStatusCard.prototype, "forecast", 2);
__decorateClass([
  r()
], EnterpriseStatusCard.prototype, "summary", 2);
EnterpriseStatusCard = __decorateClass([
  t("ak-enterprise-status-card")
], EnterpriseStatusCard);

// src/admin/enterprise/EnterpriseLicenseListPage.ts
var EnterpriseLicenseListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
  }
  searchEnabled() {
    return true;
  }
  pageTitle() {
    return msg("Licenses");
  }
  pageDescription() {
    return msg("Manage enterprise licenses");
  }
  pageIcon() {
    return "pf-icon pf-icon-key";
  }
  static get styles() {
    return super.styles.concat(
      grid_default,
      banner_default,
      form_control_default,
      button_default,
      card_default,
      i`
                .pf-m-no-padding-bottom {
                    padding-bottom: 0;
                }
                .install-id {
                    word-break: break-all;
                }
            `
    );
  }
  async apiEndpoint() {
    this.forecast = await new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicenseForecastRetrieve();
    this.summary = await new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicenseSummaryRetrieve({
      cached: false
    });
    this.installID = (await new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicenseInstallIdRetrieve()).installId;
    return new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicenseList(
      await this.defaultEndpointConfig()
    );
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Users")),
      new TableColumn(msg("Expiry date")),
      new TableColumn(msg("Actions"))
    ];
  }
  // TODO: Make this more generic, maybe automatically get the plural name
  // of the object to use in the renderEmpty
  renderEmpty(inner) {
    return super.renderEmpty(ke`
            ${inner ? inner : ke`<ak-empty-state
                      icon=${this.pageIcon()}
                      header="${msg("No licenses found.")}"
                  >
                      <div slot="body">
                          ${this.searchEnabled() ? this.renderEmptyClearSearch() : ke``}
                      </div>
                      <div slot="primary">${this.renderObjectCreate()}</div>
                  </ak-empty-state>`}
        `);
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return ke`<ak-forms-delete-bulk
            objectLabel=${msg("License(s)")}
            .objects=${this.selectedElements}
            .metadata=${(item) => {
      return [
        { key: msg("Name"), value: item.name },
        { key: msg("Expiry"), value: item.expiry?.toLocaleString() }
      ];
    }}
            .usedBy=${(item) => {
      return new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicenseUsedByList({
        licenseUuid: item.licenseUuid
      });
    }}
            .delete=${(item) => {
      return new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicenseDestroy({
        licenseUuid: item.licenseUuid
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  renderSectionBefore() {
    return ke`
            <section class="pf-c-page__main-section pf-m-no-padding-bottom">
                <div
                    class="pf-l-grid pf-m-gutter pf-m-all-6-col-on-sm pf-m-all-4-col-on-md pf-m-all-3-col-on-lg pf-m-all-3-col-on-xl"
                >
                    ${this.renderGetLicenseCard()}
                    <ak-aggregate-card
                        class="pf-l-grid__item"
                        icon="pf-icon pf-icon-user"
                        header=${msg("Forecast internal users")}
                        subtext=${msg(
      str`Estimated user count one year from now based on ${this.forecast?.internalUsers} current internal users and ${this.forecast?.forecastedInternalUsers} forecasted internal users.`
    )}
                    >
                        ~&nbsp;${(this.forecast?.internalUsers || 0) + (this.forecast?.forecastedInternalUsers || 0)}
                    </ak-aggregate-card>
                    <ak-aggregate-card
                        class="pf-l-grid__item"
                        icon="pf-icon pf-icon-user"
                        header=${msg("Forecast external users")}
                        subtext=${msg(
      str`Estimated user count one year from now based on ${this.forecast?.externalUsers} current external users and ${this.forecast?.forecastedExternalUsers} forecasted external users.`
    )}
                    >
                        ~&nbsp;${(this.forecast?.externalUsers || 0) + (this.forecast?.forecastedExternalUsers || 0)}
                    </ak-aggregate-card>
                    <ak-aggregate-card
                        class="pf-l-grid__item"
                        icon="pf-icon pf-icon-user"
                        header=${msg("Expiry")}
                        subtext=${msg("Cumulative license expiry")}
                    >
                        ${this.summary && this.summary?.status !== LicenseSummaryStatusEnum.Unlicensed ? ke`<div>${getRelativeTime(this.summary.latestValid)}</div>
                                  <small>${this.summary.latestValid.toLocaleString()}</small>` : "-"}
                    </ak-aggregate-card>
                </div>
            </section>
            <section class="pf-c-page__main-section pf-m-no-padding-bottom">
                <ak-enterprise-status-card
                    .summary=${this.summary}
                    .forecast=${this.forecast}
                ></ak-enterprise-status-card>
            </section>
        `;
  }
  row(item) {
    let color = "pf-m-green" /* Green */;
    if (item.expiry) {
      const now = /* @__PURE__ */ new Date();
      const inAMonth = /* @__PURE__ */ new Date();
      inAMonth.setDate(inAMonth.getDate() + 30);
      if (item.expiry <= inAMonth) {
        color = "pf-m-orange" /* Orange */;
      }
      if (item.expiry <= now) {
        color = "pf-m-red" /* Red */;
      }
    }
    return [
      ke`<div>${item.name}</div>`,
      ke`<div>${msg(str`Internal: ${item.internalUsers}`)}</div>
                <div>${msg(str`External: ${item.externalUsers}`)}</div>`,
      ke`<ak-label color=${color}> ${item.expiry?.toLocaleString()} </ak-label>`,
      ke`<ak-forms-modal>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg("Update License")} </span>
                    <ak-enterprise-license-form slot="form" .instancePk=${item.licenseUuid}>
                    </ak-enterprise-license-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Edit")}>
                            <i class="fas fa-edit"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>
                <ak-rbac-object-permission-modal
                    model=${RbacPermissionsAssignedByUsersListModelEnum.AuthentikEnterpriseLicense}
                    objectPk=${item.licenseUuid}
                >
                </ak-rbac-object-permission-modal> `
    ];
  }
  renderGetLicenseCard() {
    const renderSpinner = () => ke` <div class="pf-c-card__body">
                <ak-spinner></ak-spinner>
            </div>`;
    const installURL = (installID) => [
      "https://customers.goauthentik.io/from_authentik/purchase/?install_id=",
      encodeURIComponent(installID),
      "&authentik_url=",
      encodeURI(window.location.origin)
    ].join("");
    const renderCard = (installID) => ke`
            <div class="pf-c-card__title">${msg("Your Install ID")}</div>
            <div class="pf-c-card__body install-id pf-m-monospace">${installID}</div>
            <div class="pf-c-card__body">
                <a
                    target="_blank"
                    href="${installURL(installID)}"
                    class="pf-c-button pf-m-primary pf-m-block"
                    >${msg("Go to Customer Portal")}</a
                >
            </div>
            <div class="pf-c-card__body">
                <a target="_blank" href="https://docs.goauthentik.io/docs/enterprise/get-started"
                    >${msg("Learn more")}</a
                >
            </div>
        `;
    return ke`<div class="pf-l-grid__item pf-c-card">
            ${this.installID ? renderCard(this.installID) : renderSpinner()}
        </div> `;
  }
  renderObjectCreate() {
    return ke`
            <ak-forms-modal>
                <span slot="submit"> ${msg("Install")} </span>
                <span slot="header"> ${msg("Install License")} </span>
                <ak-enterprise-license-form slot="form"> </ak-enterprise-license-form>
                <button slot="trigger" class="pf-c-button pf-m-primary">${msg("Install")}</button>
            </ak-forms-modal>
        `;
  }
};
__decorateClass([
  n()
], EnterpriseLicenseListPage.prototype, "order", 2);
__decorateClass([
  r()
], EnterpriseLicenseListPage.prototype, "forecast", 2);
__decorateClass([
  r()
], EnterpriseLicenseListPage.prototype, "summary", 2);
__decorateClass([
  r()
], EnterpriseLicenseListPage.prototype, "installID", 2);
EnterpriseLicenseListPage = __decorateClass([
  t("ak-enterprise-license-list")
], EnterpriseLicenseListPage);
export {
  EnterpriseLicenseListPage
};
//# sourceMappingURL=EnterpriseLicenseListPage-GAJXJT5I.js.map
