import "./chunk-RMZE7VW2.js";
import "./chunk-VLOR6YDM.js";
import "./chunk-EQMGXTJR.js";
import "./chunk-FMBL57EI.js";
import {
  TablePage
} from "./chunk-JSGSR4RJ.js";
import "./chunk-3B7GTLMQ.js";
import "./chunk-AZMGESG2.js";
import "./chunk-4P265EXJ.js";
import "./chunk-5ZU5CEYW.js";
import "./chunk-CZRYT5FG.js";
import "./chunk-RKBUXRF5.js";
import "./chunk-IUFGI55K.js";
import "./chunk-TJN6LFOQ.js";
import "./chunk-3IFID2KX.js";
import "./chunk-ENO5WGYQ.js";
import "./chunk-OSXL2ISG.js";
import "./chunk-TM5VGYRQ.js";
import "./chunk-WDG7SDZZ.js";
import "./chunk-WZUTIRBE.js";
import "./chunk-Q2C4IWV3.js";
import "./chunk-INWUBHFN.js";
import "./chunk-2FYPY3KL.js";
import "./chunk-NRTFQ3WE.js";
import "./chunk-S3ILVWYD.js";
import "./chunk-PIENMLIY.js";
import "./chunk-P3SED4PH.js";
import "./chunk-QGUPPYUK.js";
import "./chunk-WMKINSDI.js";
import "./chunk-EA2TUCZW.js";
import "./chunk-VLXY3QNI.js";
import "./chunk-KSOTESV5.js";
import "./chunk-N57CGNDJ.js";
import "./chunk-SXPKNFZF.js";
import "./chunk-3JQ4HF4T.js";
import {
  Form
} from "./chunk-Y4CBTB76.js";
import {
  ProvidersApi
} from "./chunk-3PUBL4VQ.js";
import "./chunk-TBCAGHBB.js";
import "./chunk-QIFCLRRP.js";
import "./chunk-AMLNCECL.js";
import "./chunk-UY7EXP7Y.js";
import "./chunk-SXZF5VBA.js";
import {
  FlowsInstancesListDesignationEnum
} from "./chunk-SRK74APZ.js";
import "./chunk-WYSJXYDA.js";
import "./chunk-2GU5BCBP.js";
import "./chunk-UX7TDHO2.js";
import "./chunk-DK5NYREA.js";
import "./chunk-XCEM2TDB.js";
import "./chunk-43ID2PET.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-WCAXL5N5.js";
import "./chunk-EEANTJCZ.js";
import "./chunk-DJQHOO67.js";
import {
  TableColumn
} from "./chunk-APZGZXW5.js";
import "./chunk-K3AR7TXW.js";
import "./chunk-RBLHQ2MQ.js";
import "./chunk-ADUGFWT2.js";
import {
  AKElement,
  DEFAULT_CONFIG,
  SentryIgnoredError,
  button_default,
  e,
  n,
  patternfly_base_default,
  t
} from "./chunk-MKGIUSP2.js";
import {
  ke,
  msg,
  str
} from "./chunk-BW7LVHGS.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/admin/providers/saml/SAMLProviderImportForm.ts
var SAMLProviderImportForm = class extends Form {
  getSuccessMessage() {
    return msg("Successfully imported provider.");
  }
  async send(data) {
    const file = this.getFormFiles()["metadata"];
    if (!file) {
      throw new SentryIgnoredError("No form data");
    }
    return new ProvidersApi(DEFAULT_CONFIG).providersSamlImportMetadataCreate({
      file,
      name: data.name,
      authorizationFlow: data.authorizationFlow || "",
      invalidationFlow: data.invalidationFlow || ""
    });
  }
  renderForm() {
    return ke`<ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input type="text" class="pf-c-form-control" required />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Authorization flow")}
                ?required=${true}
                name="authorizationFlow"
            >
                <ak-flow-search-no-default
                    flowType=${FlowsInstancesListDesignationEnum.Authorization}
                    required
                ></ak-flow-search-no-default>
                <p class="pf-c-form__helper-text">
                    ${msg("Flow used when authorizing this provider.")}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Invalidation flow")}
                ?required=${true}
                name="invalidationFlow"
            >
                <ak-flow-search-no-default
                    flowType=${FlowsInstancesListDesignationEnum.Invalidation}
                    defaultFlowSlug="default-provider-invalidation-flow"
                    required
                ></ak-flow-search-no-default>
                <p class="pf-c-form__helper-text">
                    ${msg("Flow used when logging out of this provider.")}
                </p>
            </ak-form-element-horizontal>

            <ak-form-element-horizontal label=${msg("Metadata")} name="metadata">
                <input type="file" value="" class="pf-c-form-control" />
            </ak-form-element-horizontal>`;
  }
};
SAMLProviderImportForm = __decorateClass([
  t("ak-provider-saml-import-form")
], SAMLProviderImportForm);

// src/admin/providers/ProviderWizard.ts
var ProviderWizard = class extends AKElement {
  constructor() {
    super(...arguments);
    this.createText = msg("Create");
    this.providerTypes = [];
    this.finalHandler = () => {
      return Promise.resolve();
    };
  }
  static get styles() {
    return [patternfly_base_default, button_default];
  }
  connectedCallback() {
    super.connectedCallback();
    new ProvidersApi(DEFAULT_CONFIG).providersAllTypesList().then((providerTypes) => {
      this.providerTypes = providerTypes;
    });
  }
  render() {
    return ke`
            <ak-wizard
                .steps=${["initial"]}
                header=${msg("New provider")}
                description=${msg("Create a new provider.")}
                .finalHandler=${() => {
      return this.finalHandler();
    }}
            >
                <ak-wizard-page-type-create
                    name="selectProviderType"
                    slot="initial"
                    layout=${"grid" /* grid */}
                    .types=${this.providerTypes}
                    @select=${(ev) => {
      if (!this.wizard) return;
      this.wizard.steps = ["initial", `type-${ev.detail.component}`];
      this.wizard.isValid = true;
    }}
                >
                </ak-wizard-page-type-create>
                ${this.providerTypes.map((type) => {
      return ke`
                        <ak-wizard-page-form
                            slot=${`type-${type.component}`}
                            .sidebarLabel=${() => msg(str`Create ${type.name}`)}
                        >
                            <ak-proxy-form type=${type.component}></ak-proxy-form>
                        </ak-wizard-page-form>
                    `;
    })}
                <button slot="trigger" class="pf-c-button pf-m-primary">${this.createText}</button>
            </ak-wizard>
        `;
  }
};
__decorateClass([
  n()
], ProviderWizard.prototype, "createText", 2);
__decorateClass([
  n({ attribute: false })
], ProviderWizard.prototype, "providerTypes", 2);
__decorateClass([
  n({ attribute: false })
], ProviderWizard.prototype, "finalHandler", 2);
__decorateClass([
  e("ak-wizard")
], ProviderWizard.prototype, "wizard", 2);
ProviderWizard = __decorateClass([
  t("ak-provider-wizard")
], ProviderWizard);

// src/admin/providers/ProviderListPage.ts
var ProviderListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
  }
  searchEnabled() {
    return true;
  }
  pageTitle() {
    return msg("Providers");
  }
  pageDescription() {
    return msg("Provide support for protocols like SAML and OAuth to assigned applications.");
  }
  pageIcon() {
    return "pf-icon pf-icon-integration";
  }
  async apiEndpoint() {
    return new ProvidersApi(DEFAULT_CONFIG).providersAllList(
      await this.defaultEndpointConfig()
    );
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Application")),
      new TableColumn(msg("Type")),
      new TableColumn(msg("Actions"))
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return ke`<ak-forms-delete-bulk
            objectLabel=${msg("Provider(s)")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new ProvidersApi(DEFAULT_CONFIG).providersAllUsedByList({
        id: item.pk
      });
    }}
            .delete=${(item) => {
      return new ProvidersApi(DEFAULT_CONFIG).providersAllDestroy({
        id: item.pk
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  rowApp(item) {
    if (item.assignedApplicationName) {
      return ke`<i class="pf-icon pf-icon-ok pf-m-success"></i>
                ${msg("Assigned to application ")}
                <a href="#/core/applications/${item.assignedApplicationSlug}"
                    >${item.assignedApplicationName}</a
                >`;
    }
    if (item.assignedBackchannelApplicationName) {
      return ke`<i class="pf-icon pf-icon-ok pf-m-success"></i>
                ${msg("Assigned to application (backchannel) ")}
                <a href="#/core/applications/${item.assignedBackchannelApplicationSlug}"
                    >${item.assignedBackchannelApplicationName}</a
                >`;
    }
    return ke`<i class="pf-icon pf-icon-warning-triangle pf-m-warning"></i> ${msg(
      "Warning: Provider not assigned to any application."
    )}`;
  }
  row(item) {
    return [
      ke`<a href="#/core/providers/${item.pk}"> ${item.name} </a>`,
      this.rowApp(item),
      ke`${item.verboseName}`,
      ke`<ak-forms-modal>
                <span slot="submit"> ${msg("Update")} </span>
                <span slot="header"> ${msg(str`Update ${item.verboseName}`)} </span>
                <ak-proxy-form
                    slot="form"
                    .args=${{
        instancePk: item.pk
      }}
                    type=${item.component}
                >
                </ak-proxy-form>
                <button slot="trigger" class="pf-c-button pf-m-plain">
                    <pf-tooltip position="top" content=${msg("Edit")}>
                        <i class="fas fa-edit"></i>
                    </pf-tooltip>
                </button>
            </ak-forms-modal>`
    ];
  }
  renderObjectCreate() {
    return ke`<ak-provider-wizard> </ak-provider-wizard> `;
  }
};
__decorateClass([
  n()
], ProviderListPage.prototype, "order", 2);
ProviderListPage = __decorateClass([
  t("ak-provider-list")
], ProviderListPage);
export {
  ProviderListPage
};
//# sourceMappingURL=ProviderListPage-PUGTFCXR.js.map
