import "./chunk-VGLLRIG2.js";
import "./chunk-42Q77LMM.js";
import "./chunk-3X7DLXST.js";
import "./chunk-CGOLHTC5.js";
import "./chunk-2LUBJULX.js";
import "./chunk-2NZOT42E.js";
import {
  RbacApi,
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-6JJ33NXU.js";
import "./chunk-6WYMJISY.js";
import "./chunk-6BJ64FHW.js";
import "./chunk-FIVQNNAE.js";
import "./chunk-VGWABJEI.js";
import "./chunk-KP44AHRH.js";
import "./chunk-WJSRKCWV.js";
import "./chunk-FNV26V2B.js";
import "./chunk-BBFDWDOB.js";
import {
  renderDescriptionList
} from "./chunk-5ZU5CEYW.js";
import "./chunk-TJN6LFOQ.js";
import "./chunk-3IFID2KX.js";
import "./chunk-EA2TUCZW.js";
import "./chunk-VLXY3QNI.js";
import "./chunk-KSOTESV5.js";
import "./chunk-N57CGNDJ.js";
import "./chunk-SXPKNFZF.js";
import "./chunk-3JQ4HF4T.js";
import "./chunk-Y4CBTB76.js";
import "./chunk-SRK74APZ.js";
import "./chunk-WYSJXYDA.js";
import "./chunk-2GU5BCBP.js";
import "./chunk-UX7TDHO2.js";
import "./chunk-DK5NYREA.js";
import {
  grid_default
} from "./chunk-XCEM2TDB.js";
import "./chunk-43ID2PET.js";
import {
  card_default
} from "./chunk-ITYWTYEW.js";
import "./chunk-WCAXL5N5.js";
import "./chunk-EEANTJCZ.js";
import {
  description_list_default
} from "./chunk-DJQHOO67.js";
import "./chunk-APZGZXW5.js";
import "./chunk-K3AR7TXW.js";
import "./chunk-RBLHQ2MQ.js";
import "./chunk-ADUGFWT2.js";
import {
  AKElement,
  DEFAULT_CONFIG,
  EVENT_REFRESH,
  button_default,
  content_default,
  display_default,
  n,
  page_default,
  patternfly_base_default,
  r,
  t
} from "./chunk-MKGIUSP2.js";
import {
  D,
  i,
  ke,
  msg,
  str
} from "./chunk-BW7LVHGS.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/admin/roles/RoleViewPage.ts
var RoleViewPage = class extends AKElement {
  set roleId(id) {
    new RbacApi(DEFAULT_CONFIG).rbacRolesRetrieve({
      uuid: id
    }).then((role) => {
      this._role = role;
    });
  }
  static get styles() {
    return [
      patternfly_base_default,
      page_default,
      button_default,
      display_default,
      grid_default,
      content_default,
      card_default,
      description_list_default,
      i`
                .pf-c-description-list__description ak-action-button {
                    margin-right: 6px;
                    margin-bottom: 6px;
                }
                .ak-button-collection {
                    max-width: 12em;
                }
            `
    ];
  }
  constructor() {
    super();
    this.addEventListener(EVENT_REFRESH, () => {
      if (!this._role?.pk) return;
      this.roleId = this._role?.pk;
    });
  }
  render() {
    return ke`<ak-page-header
                icon="fa fa-lock"
                header=${msg(str`Role ${this._role?.name || ""}`)}
            >
            </ak-page-header>
            ${this.renderBody()}`;
  }
  renderUpdateControl(role) {
    return ke` <div class="pf-c-description-list__text">
            <ak-forms-modal>
                <span slot="submit"> ${msg("Update")} </span>
                <span slot="header"> ${msg("Update Role")} </span>
                <ak-role-form slot="form" .instancePk=${role.pk}> </ak-role-form>
                <button slot="trigger" class="pf-c-button pf-m-primary">${msg("Edit")}</button>
            </ak-forms-modal>
        </div>`;
  }
  renderBody() {
    if (!this._role) {
      return D;
    }
    return ke` <ak-tabs>
            <section
                slot="page-overview"
                data-tab-title="${msg("Overview")}"
                class="pf-c-page__main-section pf-m-no-padding-mobile"
            >
                <div class="pf-l-grid pf-m-gutter">
                    <div
                        class="pf-c-card pf-l-grid__item pf-m-12-col pf-m-3-col-on-xl pf-m-3-col-on-2xl"
                    >
                        <div class="pf-c-card__title">${msg("Role Info")}</div>
                        <div class="pf-c-card__body">
                            ${renderDescriptionList([
      [msg("Name"), this._role.name],
      [msg("Edit"), this.renderUpdateControl(this._role)]
    ])}
                        </div>
                    </div>
                    <div
                        class="pf-c-card pf-l-grid__item pf-m-12-col pf-m-9-col-on-xl pf-m-9-col-on-2xl"
                    >
                        <div class="pf-c-card__title">${msg("Changelog")}</div>
                        <div class="pf-c-card__body">
                            <ak-object-changelog
                                targetModelPk=${this._role.pk}
                                targetModelApp="authentik_rbac"
                                targetModelName="role"
                            >
                            </ak-object-changelog>
                        </div>
                    </div>
                </div>
            </section>
            <ak-rbac-object-permission-page
                slot="page-permissions"
                data-tab-title="${msg("Permissions")}"
                model=${RbacPermissionsAssignedByUsersListModelEnum.AuthentikRbacRole}
                objectPk=${this._role.pk}
            ></ak-rbac-object-permission-page>
        </ak-tabs>`;
  }
};
__decorateClass([
  n({ type: String })
], RoleViewPage.prototype, "roleId", 1);
__decorateClass([
  r()
], RoleViewPage.prototype, "_role", 2);
RoleViewPage = __decorateClass([
  t("ak-role-view")
], RoleViewPage);
export {
  RoleViewPage
};
//# sourceMappingURL=RoleViewPage-5FI6Z4XD.js.map
