import "./chunk-OPXWXO3I.js";
import "./chunk-4AY3XIGK.js";
import "./chunk-7CZKKH2O.js";
import "./chunk-3TDT67BW.js";
import "./chunk-ZUWDONTY.js";
import "./chunk-CGOLHTC5.js";
import "./chunk-2LUBJULX.js";
import "./chunk-2NZOT42E.js";
import {
  RbacPermissionsAssignedByUsersListModelEnum
} from "./chunk-6JJ33NXU.js";
import "./chunk-RRWYRLM7.js";
import {
  severityToLabel
} from "./chunk-VGWABJEI.js";
import "./chunk-KP44AHRH.js";
import "./chunk-WJSRKCWV.js";
import "./chunk-VLOR6YDM.js";
import {
  TablePage
} from "./chunk-JSGSR4RJ.js";
import "./chunk-BBFDWDOB.js";
import "./chunk-IUFGI55K.js";
import "./chunk-TJN6LFOQ.js";
import "./chunk-3IFID2KX.js";
import "./chunk-ENO5WGYQ.js";
import "./chunk-S3ILVWYD.js";
import "./chunk-PIENMLIY.js";
import "./chunk-P3SED4PH.js";
import "./chunk-EA2TUCZW.js";
import "./chunk-VLXY3QNI.js";
import "./chunk-KSOTESV5.js";
import "./chunk-N57CGNDJ.js";
import "./chunk-SXPKNFZF.js";
import {
  ModelForm
} from "./chunk-3JQ4HF4T.js";
import "./chunk-Y4CBTB76.js";
import "./chunk-UY7EXP7Y.js";
import "./chunk-SXZF5VBA.js";
import "./chunk-2GU5BCBP.js";
import "./chunk-UX7TDHO2.js";
import "./chunk-DK5NYREA.js";
import "./chunk-XCEM2TDB.js";
import "./chunk-43ID2PET.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-WCAXL5N5.js";
import "./chunk-EEANTJCZ.js";
import {
  TableColumn
} from "./chunk-APZGZXW5.js";
import "./chunk-K3AR7TXW.js";
import "./chunk-RBLHQ2MQ.js";
import "./chunk-ADUGFWT2.js";
import {
  CoreApi,
  DEFAULT_CONFIG,
  EventsApi,
  SeverityEnum,
  n,
  t,
  to
} from "./chunk-MKGIUSP2.js";
import {
  ke,
  msg
} from "./chunk-BW7LVHGS.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/admin/events/RuleFormHelpers.ts
var transportToSelect = (transport) => [transport.pk, transport.name];
async function eventTransportsProvider(page = 1, search = "") {
  const eventTransports = await new EventsApi(DEFAULT_CONFIG).eventsTransportsList({
    ordering: "name",
    pageSize: 20,
    search: search.trim(),
    page
  });
  return {
    pagination: eventTransports.pagination,
    options: eventTransports.results.map(transportToSelect)
  };
}
function eventTransportsSelector(instanceTransports) {
  if (!instanceTransports) {
    return async (transports) => transports.filter(
      ([_0, _1, _2, stage]) => stage !== void 0
    );
  }
  return async () => {
    const transportsApi = new EventsApi(DEFAULT_CONFIG);
    const transports = await Promise.allSettled(
      instanceTransports.map(
        (instanceId) => transportsApi.eventsTransportsRetrieve({ uuid: instanceId })
      )
    );
    return transports.filter((s) => s.status === "fulfilled").map((s) => s.value).map(transportToSelect);
  };
}

// src/admin/events/RuleForm.ts
var RuleForm = class extends ModelForm {
  loadInstance(pk) {
    return new EventsApi(DEFAULT_CONFIG).eventsRulesRetrieve({
      pbmUuid: pk
    });
  }
  async load() {
    this.eventTransports = await new EventsApi(DEFAULT_CONFIG).eventsTransportsList({
      ordering: "name"
    });
  }
  getSuccessMessage() {
    return this.instance ? msg("Successfully updated rule.") : msg("Successfully created rule.");
  }
  async send(data) {
    if (this.instance) {
      return new EventsApi(DEFAULT_CONFIG).eventsRulesUpdate({
        pbmUuid: this.instance.pk || "",
        notificationRuleRequest: data
      });
    } else {
      return new EventsApi(DEFAULT_CONFIG).eventsRulesCreate({
        notificationRuleRequest: data
      });
    }
  }
  renderForm() {
    return ke` <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${to(this.instance?.name)}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Group")} name="group">
                <ak-search-select
                    .fetchObjects=${async (query) => {
      const args = {
        ordering: "name",
        includeUsers: false
      };
      if (query !== void 0) {
        args.search = query;
      }
      const groups = await new CoreApi(DEFAULT_CONFIG).coreGroupsList(args);
      return groups.results;
    }}
                    .renderElement=${(group) => {
      return group.name;
    }}
                    .value=${(group) => {
      return group?.pk;
    }}
                    .selected=${(group) => {
      return group.pk === this.instance?.group;
    }}
                    ?blankable=${true}
                >
                </ak-search-select>
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Select the group of users which the alerts are sent to. If no group is selected the rule is disabled."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Transports")}
                ?required=${true}
                name="transports"
            >
                <ak-dual-select-dynamic-selected
                    .provider=${eventTransportsProvider}
                    .selector=${eventTransportsSelector(this.instance?.transports)}
                    available-label="${msg("Available Transports")}"
                    selected-label="${msg("Selected Transports")}"
                ></ak-dual-select-dynamic-selected>
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Select which transports should be used to notify the user. If none are selected, the notification will only be shown in the authentik UI."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Severity")} ?required=${true} name="severity">
                <ak-radio
                    .options=${[
      {
        label: severityToLabel(SeverityEnum.Alert),
        value: SeverityEnum.Alert,
        default: true
      },
      {
        label: severityToLabel(SeverityEnum.Warning),
        value: SeverityEnum.Warning
      },
      {
        label: severityToLabel(SeverityEnum.Notice),
        value: SeverityEnum.Notice
      }
    ]}
                    .value=${this.instance?.severity}
                >
                </ak-radio>
            </ak-form-element-horizontal>`;
  }
};
RuleForm = __decorateClass([
  t("ak-event-rule-form")
], RuleForm);

// src/admin/events/RuleListPage.ts
var RuleListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.expandable = true;
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
  }
  searchEnabled() {
    return true;
  }
  pageTitle() {
    return msg("Notification Rules");
  }
  pageDescription() {
    return msg(
      "Send notifications whenever a specific Event is created and matched by policies."
    );
  }
  pageIcon() {
    return "pf-icon pf-icon-attention-bell";
  }
  async apiEndpoint() {
    return new EventsApi(DEFAULT_CONFIG).eventsRulesList(await this.defaultEndpointConfig());
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Severity"), "severity"),
      new TableColumn(msg("Sent to group"), "group"),
      new TableColumn(msg("Actions"))
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return ke`<ak-forms-delete-bulk
            objectLabel=${msg("Notification rule(s)")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new EventsApi(DEFAULT_CONFIG).eventsRulesUsedByList({
        pbmUuid: item.pk
      });
    }}
            .delete=${(item) => {
      return new EventsApi(DEFAULT_CONFIG).eventsRulesDestroy({
        pbmUuid: item.pk
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  row(item) {
    return [
      ke`${item.name}`,
      ke`${severityToLabel(item.severity)}`,
      ke`${item.groupObj ? ke`<a href="#/identity/groups/${item.groupObj.pk}">${item.groupObj.name}</a>` : msg("None (rule disabled)")}`,
      ke`<ak-forms-modal>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg("Update Notification Rule")} </span>
                    <ak-event-rule-form slot="form" .instancePk=${item.pk}> </ak-event-rule-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Edit")}>
                            <i class="fas fa-edit"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>

                <ak-rbac-object-permission-modal
                    model=${RbacPermissionsAssignedByUsersListModelEnum.AuthentikEventsNotificationrule}
                    objectPk=${item.pk}
                >
                </ak-rbac-object-permission-modal>`
    ];
  }
  renderObjectCreate() {
    return ke`
            <ak-forms-modal>
                <span slot="submit"> ${msg("Create")} </span>
                <span slot="header"> ${msg("Create Notification Rule")} </span>
                <ak-event-rule-form slot="form"> </ak-event-rule-form>
                <button slot="trigger" class="pf-c-button pf-m-primary">${msg("Create")}</button>
            </ak-forms-modal>
        `;
  }
  renderExpanded(item) {
    return ke` <td role="cell" colspan="4">
            <div class="pf-c-table__expandable-row-content">
                <p>
                    ${msg(
      `These bindings control upon which events this rule triggers.
Bindings to groups/users are checked against the user of the event.`
    )}
                </p>
                <ak-bound-policies-list .target=${item.pk}> </ak-bound-policies-list>
            </div>
        </td>`;
  }
};
__decorateClass([
  n()
], RuleListPage.prototype, "order", 2);
RuleListPage = __decorateClass([
  t("ak-event-rule-list")
], RuleListPage);
export {
  RuleListPage
};
//# sourceMappingURL=RuleListPage-C4AY5W2M.js.map
