import "./chunk-MSU7DZQK.js";
import {
  OutpostsApi
} from "./chunk-KTEXPJ35.js";
import "./chunk-3TDT67BW.js";
import "./chunk-2LUBJULX.js";
import "./chunk-6JJ33NXU.js";
import "./chunk-KP44AHRH.js";
import "./chunk-WJSRKCWV.js";
import "./chunk-VLOR6YDM.js";
import "./chunk-FMBL57EI.js";
import {
  TablePage
} from "./chunk-JSGSR4RJ.js";
import "./chunk-BBFDWDOB.js";
import "./chunk-TJN6LFOQ.js";
import "./chunk-3IFID2KX.js";
import "./chunk-WDG7SDZZ.js";
import "./chunk-WZUTIRBE.js";
import "./chunk-S3ILVWYD.js";
import "./chunk-PIENMLIY.js";
import "./chunk-EA2TUCZW.js";
import {
  browser_default
} from "./chunk-N57CGNDJ.js";
import "./chunk-SXPKNFZF.js";
import {
  ModelForm
} from "./chunk-3JQ4HF4T.js";
import "./chunk-Y4CBTB76.js";
import "./chunk-UY7EXP7Y.js";
import "./chunk-SXZF5VBA.js";
import "./chunk-UX7TDHO2.js";
import "./chunk-DK5NYREA.js";
import "./chunk-XCEM2TDB.js";
import "./chunk-43ID2PET.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-WCAXL5N5.js";
import "./chunk-EEANTJCZ.js";
import "./chunk-DJQHOO67.js";
import {
  TableColumn
} from "./chunk-APZGZXW5.js";
import "./chunk-K3AR7TXW.js";
import "./chunk-RBLHQ2MQ.js";
import "./chunk-ADUGFWT2.js";
import {
  AKElement,
  DEFAULT_CONFIG,
  button_default,
  e,
  first,
  n,
  patternfly_base_default,
  r,
  t,
  to
} from "./chunk-MKGIUSP2.js";
import {
  ke,
  msg,
  str
} from "./chunk-BW7LVHGS.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/admin/outposts/ServiceConnectionDockerForm.ts
var ServiceConnectionDockerForm = class extends ModelForm {
  loadInstance(pk) {
    return new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsDockerRetrieve({
      uuid: pk
    });
  }
  getSuccessMessage() {
    return this.instance ? msg("Successfully updated integration.") : msg("Successfully created integration.");
  }
  async send(data) {
    if (this.instance) {
      return new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsDockerUpdate({
        uuid: this.instance.pk || "",
        dockerServiceConnectionRequest: data
      });
    } else {
      return new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsDockerCreate({
        dockerServiceConnectionRequest: data
      });
    }
  }
  renderForm() {
    return ke` <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${to(this.instance?.name)}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal name="local">
                <label class="pf-c-switch">
                    <input
                        class="pf-c-switch__input"
                        type="checkbox"
                        ?checked=${first(this.instance?.local, false)}
                    />
                    <span class="pf-c-switch__toggle">
                        <span class="pf-c-switch__toggle-icon">
                            <i class="fas fa-check" aria-hidden="true"></i>
                        </span>
                    </span>
                    <span class="pf-c-switch__label">${msg("Local")}</span>
                </label>
                <p class="pf-c-form__helper-text">
                    ${msg(
      "If enabled, use the local connection. Required Docker socket/Kubernetes Integration."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Docker URL")} ?required=${true} name="url">
                <input
                    type="text"
                    value="${to(this.instance?.url)}"
                    class="pf-c-form-control pf-m-monospace"
                    autocomplete="off"
                    spellcheck="false"
                    inputmode="url"
                    required
                />
                <p class="pf-c-form__helper-text">
                    ${msg(
      ke`Can be in the format of <code>unix://</code> when connecting to a local
                            docker daemon, using <code>ssh://</code> to connect via SSH, or
                            <code>https://:2376</code> when connecting to a remote system.`
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("TLS Verification Certificate")}
                name="tlsVerification"
            >
                <ak-crypto-certificate-search
                    .certificate=${this.instance?.tlsVerification}
                ></ak-crypto-certificate-search>
                <p class="pf-c-form__helper-text">
                    ${msg(
      "CA which the endpoint's Certificate is verified against. Can be left empty for no validation."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("TLS Authentication Certificate/SSH Keypair")}
                name="tlsAuthentication"
            >
                <ak-crypto-certificate-search
                    .certificate=${this.instance?.tlsAuthentication}
                ></ak-crypto-certificate-search>
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Certificate/Key used for authentication. Can be left empty for no authentication."
    )}
                </p>
                <p class="pf-c-form__helper-text">
                    ${msg("When connecting via SSH, this keypair is used for authentication.")}
                </p>
            </ak-form-element-horizontal>`;
  }
};
ServiceConnectionDockerForm = __decorateClass([
  t("ak-service-connection-docker-form")
], ServiceConnectionDockerForm);

// src/admin/outposts/ServiceConnectionKubernetesForm.ts
var ServiceConnectionKubernetesForm = class extends ModelForm {
  loadInstance(pk) {
    return new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsKubernetesRetrieve({
      uuid: pk
    });
  }
  getSuccessMessage() {
    return this.instance ? msg("Successfully updated integration.") : msg("Successfully created integration.");
  }
  async send(data) {
    if (this.instance) {
      return new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsKubernetesUpdate({
        uuid: this.instance.pk || "",
        kubernetesServiceConnectionRequest: data
      });
    } else {
      return new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsKubernetesCreate({
        kubernetesServiceConnectionRequest: data
      });
    }
  }
  renderForm() {
    return ke` <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${to(this.instance?.name)}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal name="local">
                <label class="pf-c-switch">
                    <input
                        class="pf-c-switch__input"
                        type="checkbox"
                        ?checked=${first(this.instance?.local, false)}
                    />
                    <span class="pf-c-switch__toggle">
                        <span class="pf-c-switch__toggle-icon">
                            <i class="fas fa-check" aria-hidden="true"></i>
                        </span>
                    </span>
                    <span class="pf-c-switch__label">${msg("Local")}</span>
                </label>
                <p class="pf-c-form__helper-text">
                    ${msg(
      "If enabled, use the local connection. Required Docker socket/Kubernetes Integration."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Kubeconfig")} name="kubeconfig">
                <ak-codemirror
                    mode=${"yaml" /* YAML */}
                    value="${browser_default.stringify(first(this.instance?.kubeconfig, {}))}"
                >
                </ak-codemirror>
                <p class="pf-c-form__helper-text">
                    ${msg("Set custom attributes using YAML or JSON.")}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal name="verifySsl">
                <label class="pf-c-switch">
                    <input
                        class="pf-c-switch__input"
                        type="checkbox"
                        ?checked=${first(this.instance?.verifySsl, true)}
                    />
                    <span class="pf-c-switch__toggle">
                        <span class="pf-c-switch__toggle-icon">
                            <i class="fas fa-check" aria-hidden="true"></i>
                        </span>
                    </span>
                    <span class="pf-c-switch__label"
                        >${msg("Verify Kubernetes API SSL Certificate")}</span
                    >
                </label>
            </ak-form-element-horizontal>`;
  }
};
ServiceConnectionKubernetesForm = __decorateClass([
  t("ak-service-connection-kubernetes-form")
], ServiceConnectionKubernetesForm);

// src/admin/outposts/ServiceConnectionWizard.ts
var ServiceConnectionWizard = class extends AKElement {
  constructor() {
    super(...arguments);
    this.createText = msg("Create");
    this.connectionTypes = [];
  }
  static get styles() {
    return [patternfly_base_default, button_default];
  }
  firstUpdated() {
    new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsAllTypesList().then((types) => {
      this.connectionTypes = types;
    });
  }
  render() {
    return ke`
            <ak-wizard
                .steps=${["initial"]}
                header=${msg("New outpost integration")}
                description=${msg("Create a new outpost integration.")}
            >
                <ak-wizard-page-type-create
                    slot="initial"
                    .types=${this.connectionTypes}
                    @select=${(ev) => {
      if (!this.wizard) return;
      this.wizard.steps = [
        "initial",
        `type-${ev.detail.component}-${ev.detail.modelName}`
      ];
      this.wizard.isValid = true;
    }}
                >
                </ak-wizard-page-type-create>
                ${this.connectionTypes.map((type) => {
      return ke`
                        <ak-wizard-page-form
                            slot=${`type-${type.component}-${type.modelName}`}
                            .sidebarLabel=${() => msg(str`Create ${type.name}`)}
                        >
                            <ak-proxy-form type=${type.component}></ak-proxy-form>
                        </ak-wizard-page-form>
                    `;
    })}
                <button slot="trigger" class="pf-c-button pf-m-primary">${this.createText}</button>
            </ak-wizard>
        `;
  }
};
__decorateClass([
  n()
], ServiceConnectionWizard.prototype, "createText", 2);
__decorateClass([
  n({ attribute: false })
], ServiceConnectionWizard.prototype, "connectionTypes", 2);
__decorateClass([
  e("ak-wizard")
], ServiceConnectionWizard.prototype, "wizard", 2);
ServiceConnectionWizard = __decorateClass([
  t("ak-service-connection-wizard")
], ServiceConnectionWizard);

// src/admin/outposts/ServiceConnectionListPage.ts
var OutpostServiceConnectionListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.state = {};
    this.order = "name";
  }
  pageTitle() {
    return msg("Outpost integrations");
  }
  pageDescription() {
    return msg(
      "Outpost integrations define how authentik connects to external platforms to manage and deploy Outposts."
    );
  }
  pageIcon() {
    return "pf-icon pf-icon-integration";
  }
  searchEnabled() {
    return true;
  }
  async apiEndpoint() {
    const connections = await new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsAllList(
      await this.defaultEndpointConfig()
    );
    await Promise.all(
      connections.results.map((connection) => {
        return new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsAllStateRetrieve({
          uuid: connection.pk
        }).then((state) => {
          this.state[connection.pk] = state;
        });
      })
    );
    return connections;
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Type")),
      new TableColumn(msg("Local"), "local"),
      new TableColumn(msg("State")),
      new TableColumn(msg("Actions"))
    ];
  }
  row(item) {
    const itemState = this.state[item.pk];
    return [
      ke`${item.name}`,
      ke`${item.verboseName}`,
      ke`<ak-status-label type="info" ?good=${item.local}></ak-status-label>`,
      ke`${itemState?.healthy ? ke`<ak-label color=${"pf-m-green" /* Green */}>${to(itemState.version)}</ak-label>` : ke`<ak-label color=${"pf-m-red" /* Red */}>${msg("Unhealthy")}</ak-label>`}`,
      ke`
                <ak-forms-modal>
                    <span slot="submit"> ${msg("Update")} </span>
                    <span slot="header"> ${msg(str`Update ${item.verboseName}`)} </span>
                    <ak-proxy-form
                        slot="form"
                        .args=${{
        instancePk: item.pk
      }}
                        type=${to(item.component)}
                    >
                    </ak-proxy-form>
                    <button slot="trigger" class="pf-c-button pf-m-plain">
                        <pf-tooltip position="top" content=${msg("Edit")}>
                            <i class="fas fa-edit"></i>
                        </pf-tooltip>
                    </button>
                </ak-forms-modal>
                <ak-rbac-object-permission-modal model=${item.metaModelName} objectPk=${item.pk}>
                </ak-rbac-object-permission-modal>
            `
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return ke`<ak-forms-delete-bulk
            objectLabel=${msg("Outpost integration(s)")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsAllUsedByList({
        uuid: item.pk
      });
    }}
            .delete=${(item) => {
      return new OutpostsApi(DEFAULT_CONFIG).outpostsServiceConnectionsAllDestroy({
        uuid: item.pk
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  renderObjectCreate() {
    return ke`<ak-service-connection-wizard></ak-service-connection-wizard> `;
  }
};
__decorateClass([
  r()
], OutpostServiceConnectionListPage.prototype, "state", 2);
__decorateClass([
  n()
], OutpostServiceConnectionListPage.prototype, "order", 2);
OutpostServiceConnectionListPage = __decorateClass([
  t("ak-outpost-service-connection-list")
], OutpostServiceConnectionListPage);
export {
  OutpostServiceConnectionListPage
};
//# sourceMappingURL=ServiceConnectionListPage-NVF7WYWH.js.map
