import "./chunk-TUYGYBNK.js";
import "./chunk-ECIU5ZIT.js";
import "./chunk-VLOR6YDM.js";
import "./chunk-FMBL57EI.js";
import {
  TablePage
} from "./chunk-JSGSR4RJ.js";
import "./chunk-UHE2QU34.js";
import "./chunk-7CDOLCSU.js";
import "./chunk-ENO5WGYQ.js";
import "./chunk-OSXL2ISG.js";
import "./chunk-TM5VGYRQ.js";
import "./chunk-WDG7SDZZ.js";
import "./chunk-WZUTIRBE.js";
import "./chunk-Q2C4IWV3.js";
import "./chunk-INWUBHFN.js";
import "./chunk-2FYPY3KL.js";
import "./chunk-NRTFQ3WE.js";
import "./chunk-S3ILVWYD.js";
import "./chunk-PIENMLIY.js";
import "./chunk-P3SED4PH.js";
import "./chunk-QGUPPYUK.js";
import "./chunk-WMKINSDI.js";
import "./chunk-EA2TUCZW.js";
import "./chunk-VLXY3QNI.js";
import "./chunk-KSOTESV5.js";
import "./chunk-N57CGNDJ.js";
import "./chunk-SXPKNFZF.js";
import "./chunk-3JQ4HF4T.js";
import "./chunk-Y4CBTB76.js";
import {
  SourcesApi
} from "./chunk-TBCAGHBB.js";
import "./chunk-QIFCLRRP.js";
import "./chunk-AMLNCECL.js";
import "./chunk-UY7EXP7Y.js";
import "./chunk-SXZF5VBA.js";
import "./chunk-SRK74APZ.js";
import "./chunk-WYSJXYDA.js";
import "./chunk-2GU5BCBP.js";
import "./chunk-UX7TDHO2.js";
import "./chunk-DK5NYREA.js";
import "./chunk-XCEM2TDB.js";
import "./chunk-43ID2PET.js";
import "./chunk-ITYWTYEW.js";
import "./chunk-EEANTJCZ.js";
import {
  TableColumn
} from "./chunk-APZGZXW5.js";
import "./chunk-K3AR7TXW.js";
import "./chunk-RBLHQ2MQ.js";
import "./chunk-ADUGFWT2.js";
import {
  AKElement,
  DEFAULT_CONFIG,
  button_default,
  e,
  n,
  patternfly_base_default,
  t,
  to
} from "./chunk-MKGIUSP2.js";
import {
  ke,
  msg,
  str
} from "./chunk-BW7LVHGS.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/admin/sources/SourceWizard.ts
var SourceWizard = class extends AKElement {
  constructor() {
    super(...arguments);
    this.sourceTypes = [];
  }
  static get styles() {
    return [patternfly_base_default, button_default];
  }
  firstUpdated() {
    new SourcesApi(DEFAULT_CONFIG).sourcesAllTypesList().then((types) => {
      this.sourceTypes = types;
    });
  }
  render() {
    return ke`
            <ak-wizard
                .steps=${["initial"]}
                header=${msg("New source")}
                description=${msg("Create a new source.")}
            >
                <ak-wizard-page-type-create
                    slot="initial"
                    .types=${this.sourceTypes}
                    layout=${"grid" /* grid */}
                    @select=${(ev) => {
      if (!this.wizard) return;
      this.wizard.steps = [
        "initial",
        `type-${ev.detail.component}-${ev.detail.modelName}`
      ];
      this.wizard.isValid = true;
    }}
                >
                </ak-wizard-page-type-create>
                ${this.sourceTypes.map((type) => {
      return ke`
                        <ak-wizard-page-form
                            slot=${`type-${type.component}-${type.modelName}`}
                            .sidebarLabel=${() => msg(str`Create ${type.name}`)}
                        >
                            <ak-proxy-form
                                .args=${{
        modelName: type.modelName
      }}
                                type=${type.component}
                            ></ak-proxy-form>
                        </ak-wizard-page-form>
                    `;
    })}
                <button slot="trigger" class="pf-c-button pf-m-primary">${msg("Create")}</button>
            </ak-wizard>
        `;
  }
};
__decorateClass([
  n({ attribute: false })
], SourceWizard.prototype, "sourceTypes", 2);
__decorateClass([
  e("ak-wizard")
], SourceWizard.prototype, "wizard", 2);
SourceWizard = __decorateClass([
  t("ak-source-wizard")
], SourceWizard);

// src/admin/sources/SourceListPage.ts
var SourceListPage = class extends TablePage {
  constructor() {
    super(...arguments);
    this.checkbox = true;
    this.clearOnRefresh = true;
    this.order = "name";
  }
  pageTitle() {
    return msg("Federation and Social login");
  }
  pageDescription() {
    return msg(
      "Sources of identities, which can either be synced into authentik's database, or can be used by users to authenticate and enroll themselves."
    );
  }
  pageIcon() {
    return "pf-icon pf-icon-middleware";
  }
  searchEnabled() {
    return true;
  }
  async apiEndpoint() {
    return new SourcesApi(DEFAULT_CONFIG).sourcesAllList(await this.defaultEndpointConfig());
  }
  columns() {
    return [
      new TableColumn(msg("Name"), "name"),
      new TableColumn(msg("Type")),
      new TableColumn("")
    ];
  }
  renderToolbarSelected() {
    const disabled = this.selectedElements.length < 1;
    return ke`<ak-forms-delete-bulk
            objectLabel=${msg("Source(s)")}
            .objects=${this.selectedElements}
            .usedBy=${(item) => {
      return new SourcesApi(DEFAULT_CONFIG).sourcesAllUsedByList({
        slug: item.slug
      });
    }}
            .delete=${(item) => {
      return new SourcesApi(DEFAULT_CONFIG).sourcesAllDestroy({
        slug: item.slug
      });
    }}
        >
            <button ?disabled=${disabled} slot="trigger" class="pf-c-button pf-m-danger">
                ${msg("Delete")}
            </button>
        </ak-forms-delete-bulk>`;
  }
  row(item) {
    if (item.component === "") {
      return this.rowInbuilt(item);
    }
    return [
      ke`<a href="#/core/sources/${item.slug}">
                <div>${item.name}</div>
                ${item.enabled ? ke`` : ke`<ak-label color=${"pf-m-orange" /* Orange */} ?compact=${true}>
                          ${msg("Disabled")}</ak-label
                      >`}
            </a>`,
      ke`${item.verboseName}`,
      ke` <ak-forms-modal>
                <span slot="submit"> ${msg("Update")} </span>
                <span slot="header"> ${msg(str`Update ${item.verboseName}`)} </span>
                <ak-proxy-form
                    slot="form"
                    .args=${{
        instancePk: item.slug
      }}
                    type=${to(item.component)}
                >
                </ak-proxy-form>
                <button slot="trigger" class="pf-c-button pf-m-plain">
                    <pf-tooltip position="top" content=${msg("Edit")}>
                        <i class="fas fa-edit"></i>
                    </pf-tooltip>
                </button>
            </ak-forms-modal>`
    ];
  }
  rowInbuilt(item) {
    return [
      ke`<div>
                <div>${item.name}</div>
                <ak-label color=${"" /* Grey */} ?compact=${true}> ${msg("Built-in")}</ak-label>
            </div>`,
      ke`${msg("Built-in")}`,
      ke``
    ];
  }
  renderObjectCreate() {
    return ke`<ak-source-wizard> </ak-source-wizard> `;
  }
};
__decorateClass([
  n()
], SourceListPage.prototype, "order", 2);
SourceListPage = __decorateClass([
  t("ak-source-list")
], SourceListPage);
export {
  SourceListPage
};
//# sourceMappingURL=SourceListPage-C4ZGV4UX.js.map
