import {
  EventGeo,
  EventUser
} from "./chunk-6WYMJISY.js";
import {
  actionToLabel
} from "./chunk-VGWABJEI.js";
import {
  Table,
  TableColumn
} from "./chunk-APZGZXW5.js";
import {
  DEFAULT_CONFIG,
  EventsApi,
  getRelativeTime,
  n,
  t
} from "./chunk-MKGIUSP2.js";
import {
  ke,
  msg
} from "./chunk-BW7LVHGS.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/components/events/ObjectChangelog.ts
var ObjectChangelog = class extends Table {
  constructor() {
    super(...arguments);
    this.expandable = true;
    this.order = "-created";
    this.targetModelName = "";
  }
  async apiEndpoint() {
    let modelName = this.targetModelName;
    let appName = this.targetModelApp;
    if (this.targetModelName.indexOf(".") !== -1) {
      const parts = this.targetModelName.split(".", 1);
      appName = parts[0];
      modelName = parts[1];
    }
    if (this.targetModelName === "") {
      return Promise.reject();
    }
    return new EventsApi(DEFAULT_CONFIG).eventsEventsList({
      ...await this.defaultEndpointConfig(),
      action: "model_",
      contextModelApp: appName,
      contextModelName: modelName,
      contextModelPk: this.targetModelPk.toString()
    });
  }
  columns() {
    return [
      new TableColumn(msg("Action"), "action"),
      new TableColumn(msg("User"), "enabled"),
      new TableColumn(msg("Creation Date"), "created"),
      new TableColumn(msg("Client IP"), "client_ip")
    ];
  }
  willUpdate(changedProperties) {
    if (changedProperties.has("targetModelName") && this.targetModelName) {
      this.fetch();
    }
  }
  row(item) {
    return [
      ke`${actionToLabel(item.action)}`,
      EventUser(item),
      ke`<div>${getRelativeTime(item.created)}</div>
                <small>${item.created.toLocaleString()}</small>`,
      ke`<div>${item.clientIp || msg("-")}</div>

                <small>${EventGeo(item)}</small>`
    ];
  }
  renderExpanded(item) {
    return ke` <td role="cell" colspan="4">
                <div class="pf-c-table__expandable-row-content">
                    <ak-event-info .event=${item}></ak-event-info>
                </div>
            </td>
            <td></td>
            <td></td>
            <td></td>`;
  }
  renderEmpty() {
    return super.renderEmpty(
      ke`<ak-empty-state header=${msg("No Events found.")}>
                <div slot="body">${msg("No matching events could be found.")}</div>
            </ak-empty-state>`
    );
  }
};
__decorateClass([
  n()
], ObjectChangelog.prototype, "order", 2);
__decorateClass([
  n()
], ObjectChangelog.prototype, "targetModelPk", 2);
__decorateClass([
  n()
], ObjectChangelog.prototype, "targetModelApp", 2);
__decorateClass([
  n()
], ObjectChangelog.prototype, "targetModelName", 2);
ObjectChangelog = __decorateClass([
  t("ak-object-changelog")
], ObjectChangelog);
//# sourceMappingURL=chunk-3X7DLXST.js.map
