import {
  oo
} from "./chunk-UX7TDHO2.js";
import {
  Rt,
  first
} from "./chunk-MKGIUSP2.js";
import {
  D,
  ke
} from "./chunk-BW7LVHGS.js";

// src/components/DescriptionList.ts
var isDescriptionRecordCollection = (v) => v.length > 0 && typeof v[0] === "object" && !Array.isArray(v[0]);
function renderDescriptionGroup([term, description]) {
  return ke` <div class="pf-c-description-list__group">
        <dt class="pf-c-description-list__term">
            <span class="pf-c-description-list__text">${term}</span>
        </dt>
        <dd class="pf-c-description-list__description">
            <div class="pf-c-description-list__text">${description ?? D}</div>
        </dd>
    </div>`;
}
function recordToPair({ term, desc }) {
  return [term, desc];
}
function alignTermType(terms = []) {
  if (isDescriptionRecordCollection(terms)) {
    return terms.map(recordToPair);
  }
  return terms ?? [];
}
var defaultConfig = {
  horizontal: false,
  compact: false,
  twocolumn: false,
  threecolumn: false
};
function renderDescriptionList(terms = [], config = defaultConfig) {
  const checkedTerms = alignTermType(terms);
  const classes = Rt({
    "pf-m-horizontal": first(config.horizontal, false),
    "pf-m-compact": first(config.compact, false),
    "pf-m-2-col-on-lg": first(config.twocolumn, false),
    "pf-m-3-col-on-lg": first(config.threecolumn, false)
  });
  return ke`
        <dl class="pf-c-description-list ${classes}">
            ${oo(checkedTerms, renderDescriptionGroup)}
        </dl>
    `;
}
var DescriptionList_default = renderDescriptionList;

export {
  renderDescriptionList,
  DescriptionList_default
};
//# sourceMappingURL=chunk-5ZU5CEYW.js.map
