import {
  ModelEnumToJSON
} from "./chunk-3IFID2KX.js";
import {
  BaseAPI,
  JSONApiResponse,
  PaginationFromJSON,
  RequiredError,
  RoleFromJSON,
  UsedByFromJSON,
  VoidApiResponse
} from "./chunk-MKGIUSP2.js";

// node_modules/@goauthentik/api/dist/esm/models/ExtraRoleObjectPermission.js
function ExtraRoleObjectPermissionFromJSON(json) {
  return ExtraRoleObjectPermissionFromJSONTyped(json, false);
}
function ExtraRoleObjectPermissionFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "id": json["id"],
    "codename": json["codename"],
    "model": json["model"],
    "appLabel": json["app_label"],
    "objectPk": json["object_pk"],
    "name": json["name"],
    "appLabelVerbose": json["app_label_verbose"],
    "modelVerbose": json["model_verbose"],
    "objectDescription": json["object_description"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ExtraRoleObjectPermissionRequest.js
function ExtraRoleObjectPermissionRequestToJSON(json) {
  return ExtraRoleObjectPermissionRequestToJSONTyped(json, false);
}
function ExtraRoleObjectPermissionRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "object_pk": value["objectPk"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ExtraUserObjectPermission.js
function ExtraUserObjectPermissionFromJSON(json) {
  return ExtraUserObjectPermissionFromJSONTyped(json, false);
}
function ExtraUserObjectPermissionFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "id": json["id"],
    "codename": json["codename"],
    "model": json["model"],
    "appLabel": json["app_label"],
    "objectPk": json["object_pk"],
    "name": json["name"],
    "appLabelVerbose": json["app_label_verbose"],
    "modelVerbose": json["model_verbose"],
    "objectDescription": json["object_description"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ExtraUserObjectPermissionRequest.js
function ExtraUserObjectPermissionRequestToJSON(json) {
  return ExtraUserObjectPermissionRequestToJSONTyped(json, false);
}
function ExtraUserObjectPermissionRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "object_pk": value["objectPk"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedExtraRoleObjectPermissionList.js
function PaginatedExtraRoleObjectPermissionListFromJSON(json) {
  return PaginatedExtraRoleObjectPermissionListFromJSONTyped(json, false);
}
function PaginatedExtraRoleObjectPermissionListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(ExtraRoleObjectPermissionFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedExtraUserObjectPermissionList.js
function PaginatedExtraUserObjectPermissionListFromJSON(json) {
  return PaginatedExtraUserObjectPermissionListFromJSONTyped(json, false);
}
function PaginatedExtraUserObjectPermissionListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(ExtraUserObjectPermissionFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/Permission.js
function PermissionFromJSON(json) {
  return PermissionFromJSONTyped(json, false);
}
function PermissionFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "id": json["id"],
    "name": json["name"],
    "codename": json["codename"],
    "model": json["model"],
    "appLabel": json["app_label"],
    "appLabelVerbose": json["app_label_verbose"],
    "modelVerbose": json["model_verbose"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedPermissionList.js
function PaginatedPermissionListFromJSON(json) {
  return PaginatedPermissionListFromJSONTyped(json, false);
}
function PaginatedPermissionListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(PermissionFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/RoleObjectPermission.js
function RoleObjectPermissionFromJSON(json) {
  return RoleObjectPermissionFromJSONTyped(json, false);
}
function RoleObjectPermissionFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "id": json["id"],
    "codename": json["codename"],
    "model": json["model"],
    "appLabel": json["app_label"],
    "objectPk": json["object_pk"],
    "name": json["name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/RoleAssignedObjectPermission.js
function RoleAssignedObjectPermissionFromJSON(json) {
  return RoleAssignedObjectPermissionFromJSONTyped(json, false);
}
function RoleAssignedObjectPermissionFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "rolePk": json["role_pk"],
    "name": json["name"],
    "permissions": json["permissions"].map(RoleObjectPermissionFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedRoleAssignedObjectPermissionList.js
function PaginatedRoleAssignedObjectPermissionListFromJSON(json) {
  return PaginatedRoleAssignedObjectPermissionListFromJSONTyped(json, false);
}
function PaginatedRoleAssignedObjectPermissionListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(RoleAssignedObjectPermissionFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedRoleList.js
function PaginatedRoleListFromJSON(json) {
  return PaginatedRoleListFromJSONTyped(json, false);
}
function PaginatedRoleListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(RoleFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/UserObjectPermission.js
function UserObjectPermissionFromJSON(json) {
  return UserObjectPermissionFromJSONTyped(json, false);
}
function UserObjectPermissionFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "id": json["id"],
    "codename": json["codename"],
    "model": json["model"],
    "appLabel": json["app_label"],
    "objectPk": json["object_pk"],
    "name": json["name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/UserAssignedObjectPermission.js
function UserAssignedObjectPermissionFromJSON(json) {
  return UserAssignedObjectPermissionFromJSONTyped(json, false);
}
function UserAssignedObjectPermissionFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "username": json["username"],
    "name": json["name"],
    "isActive": json["is_active"] == null ? void 0 : json["is_active"],
    "lastLogin": json["last_login"] == null ? void 0 : new Date(json["last_login"]),
    "email": json["email"] == null ? void 0 : json["email"],
    "attributes": json["attributes"] == null ? void 0 : json["attributes"],
    "uid": json["uid"],
    "permissions": json["permissions"].map(UserObjectPermissionFromJSON),
    "isSuperuser": json["is_superuser"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedUserAssignedObjectPermissionList.js
function PaginatedUserAssignedObjectPermissionListFromJSON(json) {
  return PaginatedUserAssignedObjectPermissionListFromJSONTyped(json, false);
}
function PaginatedUserAssignedObjectPermissionListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(UserAssignedObjectPermissionFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedExtraRoleObjectPermissionRequest.js
function PatchedExtraRoleObjectPermissionRequestToJSON(json) {
  return PatchedExtraRoleObjectPermissionRequestToJSONTyped(json, false);
}
function PatchedExtraRoleObjectPermissionRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "object_pk": value["objectPk"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedExtraUserObjectPermissionRequest.js
function PatchedExtraUserObjectPermissionRequestToJSON(json) {
  return PatchedExtraUserObjectPermissionRequestToJSONTyped(json, false);
}
function PatchedExtraUserObjectPermissionRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "object_pk": value["objectPk"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedPermissionAssignRequest.js
function PatchedPermissionAssignRequestToJSON(json) {
  return PatchedPermissionAssignRequestToJSONTyped(json, false);
}
function PatchedPermissionAssignRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "permissions": value["permissions"],
    "model": ModelEnumToJSON(value["model"]),
    "object_pk": value["objectPk"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedRoleRequest.js
function PatchedRoleRequestToJSON(json) {
  return PatchedRoleRequestToJSONTyped(json, false);
}
function PatchedRoleRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PermissionAssignRequest.js
function PermissionAssignRequestToJSON(json) {
  return PermissionAssignRequestToJSONTyped(json, false);
}
function PermissionAssignRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "permissions": value["permissions"],
    "model": ModelEnumToJSON(value["model"]),
    "object_pk": value["objectPk"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PermissionAssignResult.js
function PermissionAssignResultFromJSON(json) {
  return PermissionAssignResultFromJSONTyped(json, false);
}
function PermissionAssignResultFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "id": json["id"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/RoleRequest.js
function RoleRequestToJSON(json) {
  return RoleRequestToJSONTyped(json, false);
}
function RoleRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/apis/RbacApi.js
var __awaiter = function(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function(resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function(resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var RbacApi = class extends BaseAPI {
  /**
   * Assign permission(s) to role. When `object_pk` is set, the permissions are only assigned to the specific object, otherwise they are assigned globally.
   */
  rbacPermissionsAssignedByRolesAssignRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["uuid"] == null) {
        throw new RequiredError("uuid", 'Required parameter "uuid" was null or undefined when calling rbacPermissionsAssignedByRolesAssign().');
      }
      if (requestParameters["permissionAssignRequest"] == null) {
        throw new RequiredError("permissionAssignRequest", 'Required parameter "permissionAssignRequest" was null or undefined when calling rbacPermissionsAssignedByRolesAssign().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/permissions/assigned_by_roles/{uuid}/assign/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters["uuid"]))),
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PermissionAssignRequestToJSON(requestParameters["permissionAssignRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(PermissionAssignResultFromJSON));
    });
  }
  /**
   * Assign permission(s) to role. When `object_pk` is set, the permissions are only assigned to the specific object, otherwise they are assigned globally.
   */
  rbacPermissionsAssignedByRolesAssign(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.rbacPermissionsAssignedByRolesAssignRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get assigned object permissions for a single object
   */
  rbacPermissionsAssignedByRolesListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["model"] == null) {
        throw new RequiredError("model", 'Required parameter "model" was null or undefined when calling rbacPermissionsAssignedByRolesList().');
      }
      const queryParameters = {};
      if (requestParameters["model"] != null) {
        queryParameters["model"] = requestParameters["model"];
      }
      if (requestParameters["objectPk"] != null) {
        queryParameters["object_pk"] = requestParameters["objectPk"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/permissions/assigned_by_roles/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedRoleAssignedObjectPermissionListFromJSON(jsonValue));
    });
  }
  /**
   * Get assigned object permissions for a single object
   */
  rbacPermissionsAssignedByRolesList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.rbacPermissionsAssignedByRolesListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Unassign permission(s) to role. When `object_pk` is set, the permissions are only assigned to the specific object, otherwise they are assigned globally.
   */
  rbacPermissionsAssignedByRolesUnassignPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["uuid"] == null) {
        throw new RequiredError("uuid", 'Required parameter "uuid" was null or undefined when calling rbacPermissionsAssignedByRolesUnassignPartialUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/permissions/assigned_by_roles/{uuid}/unassign/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters["uuid"]))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedPermissionAssignRequestToJSON(requestParameters["patchedPermissionAssignRequest"])
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Unassign permission(s) to role. When `object_pk` is set, the permissions are only assigned to the specific object, otherwise they are assigned globally.
   */
  rbacPermissionsAssignedByRolesUnassignPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.rbacPermissionsAssignedByRolesUnassignPartialUpdateRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Assign permission(s) to user
   */
  rbacPermissionsAssignedByUsersAssignRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["id"] == null) {
        throw new RequiredError("id", 'Required parameter "id" was null or undefined when calling rbacPermissionsAssignedByUsersAssign().');
      }
      if (requestParameters["permissionAssignRequest"] == null) {
        throw new RequiredError("permissionAssignRequest", 'Required parameter "permissionAssignRequest" was null or undefined when calling rbacPermissionsAssignedByUsersAssign().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/permissions/assigned_by_users/{id}/assign/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters["id"]))),
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PermissionAssignRequestToJSON(requestParameters["permissionAssignRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(PermissionAssignResultFromJSON));
    });
  }
  /**
   * Assign permission(s) to user
   */
  rbacPermissionsAssignedByUsersAssign(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.rbacPermissionsAssignedByUsersAssignRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get assigned object permissions for a single object
   */
  rbacPermissionsAssignedByUsersListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["model"] == null) {
        throw new RequiredError("model", 'Required parameter "model" was null or undefined when calling rbacPermissionsAssignedByUsersList().');
      }
      const queryParameters = {};
      if (requestParameters["model"] != null) {
        queryParameters["model"] = requestParameters["model"];
      }
      if (requestParameters["objectPk"] != null) {
        queryParameters["object_pk"] = requestParameters["objectPk"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/permissions/assigned_by_users/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedUserAssignedObjectPermissionListFromJSON(jsonValue));
    });
  }
  /**
   * Get assigned object permissions for a single object
   */
  rbacPermissionsAssignedByUsersList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.rbacPermissionsAssignedByUsersListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Unassign permission(s) to user. When `object_pk` is set, the permissions are only assigned to the specific object, otherwise they are assigned globally.
   */
  rbacPermissionsAssignedByUsersUnassignPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["id"] == null) {
        throw new RequiredError("id", 'Required parameter "id" was null or undefined when calling rbacPermissionsAssignedByUsersUnassignPartialUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/permissions/assigned_by_users/{id}/unassign/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters["id"]))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedPermissionAssignRequestToJSON(requestParameters["patchedPermissionAssignRequest"])
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Unassign permission(s) to user. When `object_pk` is set, the permissions are only assigned to the specific object, otherwise they are assigned globally.
   */
  rbacPermissionsAssignedByUsersUnassignPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.rbacPermissionsAssignedByUsersUnassignPartialUpdateRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Read-only list of all permissions, filterable by model and app
   */
  rbacPermissionsListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["codename"] != null) {
        queryParameters["codename"] = requestParameters["codename"];
      }
      if (requestParameters["contentTypeAppLabel"] != null) {
        queryParameters["content_type__app_label"] = requestParameters["contentTypeAppLabel"];
      }
      if (requestParameters["contentTypeModel"] != null) {
        queryParameters["content_type__model"] = requestParameters["contentTypeModel"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["role"] != null) {
        queryParameters["role"] = requestParameters["role"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      if (requestParameters["user"] != null) {
        queryParameters["user"] = requestParameters["user"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/permissions/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedPermissionListFromJSON(jsonValue));
    });
  }
  /**
   * Read-only list of all permissions, filterable by model and app
   */
  rbacPermissionsList() {
    return __awaiter(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.rbacPermissionsListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Read-only list of all permissions, filterable by model and app
   */
  rbacPermissionsRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["id"] == null) {
        throw new RequiredError("id", 'Required parameter "id" was null or undefined when calling rbacPermissionsRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/permissions/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters["id"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PermissionFromJSON(jsonValue));
    });
  }
  /**
   * Read-only list of all permissions, filterable by model and app
   */
  rbacPermissionsRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.rbacPermissionsRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a role\'s assigned object permissions
   */
  rbacPermissionsRolesDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["id"] == null) {
        throw new RequiredError("id", 'Required parameter "id" was null or undefined when calling rbacPermissionsRolesDestroy().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/permissions/roles/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters["id"]))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Get a role\'s assigned object permissions
   */
  rbacPermissionsRolesDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.rbacPermissionsRolesDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Get a role\'s assigned object permissions
   */
  rbacPermissionsRolesListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      if (requestParameters["uuid"] != null) {
        queryParameters["uuid"] = requestParameters["uuid"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/permissions/roles/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedExtraRoleObjectPermissionListFromJSON(jsonValue));
    });
  }
  /**
   * Get a role\'s assigned object permissions
   */
  rbacPermissionsRolesList() {
    return __awaiter(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.rbacPermissionsRolesListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a role\'s assigned object permissions
   */
  rbacPermissionsRolesPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["id"] == null) {
        throw new RequiredError("id", 'Required parameter "id" was null or undefined when calling rbacPermissionsRolesPartialUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/permissions/roles/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters["id"]))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedExtraRoleObjectPermissionRequestToJSON(requestParameters["patchedExtraRoleObjectPermissionRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ExtraRoleObjectPermissionFromJSON(jsonValue));
    });
  }
  /**
   * Get a role\'s assigned object permissions
   */
  rbacPermissionsRolesPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.rbacPermissionsRolesPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a role\'s assigned object permissions
   */
  rbacPermissionsRolesRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["id"] == null) {
        throw new RequiredError("id", 'Required parameter "id" was null or undefined when calling rbacPermissionsRolesRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/permissions/roles/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters["id"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ExtraRoleObjectPermissionFromJSON(jsonValue));
    });
  }
  /**
   * Get a role\'s assigned object permissions
   */
  rbacPermissionsRolesRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.rbacPermissionsRolesRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a role\'s assigned object permissions
   */
  rbacPermissionsRolesUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["id"] == null) {
        throw new RequiredError("id", 'Required parameter "id" was null or undefined when calling rbacPermissionsRolesUpdate().');
      }
      if (requestParameters["extraRoleObjectPermissionRequest"] == null) {
        throw new RequiredError("extraRoleObjectPermissionRequest", 'Required parameter "extraRoleObjectPermissionRequest" was null or undefined when calling rbacPermissionsRolesUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/permissions/roles/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters["id"]))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: ExtraRoleObjectPermissionRequestToJSON(requestParameters["extraRoleObjectPermissionRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ExtraRoleObjectPermissionFromJSON(jsonValue));
    });
  }
  /**
   * Get a role\'s assigned object permissions
   */
  rbacPermissionsRolesUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.rbacPermissionsRolesUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a users\'s assigned object permissions
   */
  rbacPermissionsUsersDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["id"] == null) {
        throw new RequiredError("id", 'Required parameter "id" was null or undefined when calling rbacPermissionsUsersDestroy().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/permissions/users/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters["id"]))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Get a users\'s assigned object permissions
   */
  rbacPermissionsUsersDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.rbacPermissionsUsersDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Get a users\'s assigned object permissions
   */
  rbacPermissionsUsersListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      if (requestParameters["userId"] != null) {
        queryParameters["user_id"] = requestParameters["userId"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/permissions/users/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedExtraUserObjectPermissionListFromJSON(jsonValue));
    });
  }
  /**
   * Get a users\'s assigned object permissions
   */
  rbacPermissionsUsersList() {
    return __awaiter(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.rbacPermissionsUsersListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a users\'s assigned object permissions
   */
  rbacPermissionsUsersPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["id"] == null) {
        throw new RequiredError("id", 'Required parameter "id" was null or undefined when calling rbacPermissionsUsersPartialUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/permissions/users/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters["id"]))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedExtraUserObjectPermissionRequestToJSON(requestParameters["patchedExtraUserObjectPermissionRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ExtraUserObjectPermissionFromJSON(jsonValue));
    });
  }
  /**
   * Get a users\'s assigned object permissions
   */
  rbacPermissionsUsersPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.rbacPermissionsUsersPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a users\'s assigned object permissions
   */
  rbacPermissionsUsersRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["id"] == null) {
        throw new RequiredError("id", 'Required parameter "id" was null or undefined when calling rbacPermissionsUsersRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/permissions/users/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters["id"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ExtraUserObjectPermissionFromJSON(jsonValue));
    });
  }
  /**
   * Get a users\'s assigned object permissions
   */
  rbacPermissionsUsersRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.rbacPermissionsUsersRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a users\'s assigned object permissions
   */
  rbacPermissionsUsersUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["id"] == null) {
        throw new RequiredError("id", 'Required parameter "id" was null or undefined when calling rbacPermissionsUsersUpdate().');
      }
      if (requestParameters["extraUserObjectPermissionRequest"] == null) {
        throw new RequiredError("extraUserObjectPermissionRequest", 'Required parameter "extraUserObjectPermissionRequest" was null or undefined when calling rbacPermissionsUsersUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/permissions/users/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters["id"]))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: ExtraUserObjectPermissionRequestToJSON(requestParameters["extraUserObjectPermissionRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ExtraUserObjectPermissionFromJSON(jsonValue));
    });
  }
  /**
   * Get a users\'s assigned object permissions
   */
  rbacPermissionsUsersUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.rbacPermissionsUsersUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Role viewset
   */
  rbacRolesCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["roleRequest"] == null) {
        throw new RequiredError("roleRequest", 'Required parameter "roleRequest" was null or undefined when calling rbacRolesCreate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/roles/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: RoleRequestToJSON(requestParameters["roleRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RoleFromJSON(jsonValue));
    });
  }
  /**
   * Role viewset
   */
  rbacRolesCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.rbacRolesCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Role viewset
   */
  rbacRolesDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["uuid"] == null) {
        throw new RequiredError("uuid", 'Required parameter "uuid" was null or undefined when calling rbacRolesDestroy().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/roles/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters["uuid"]))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Role viewset
   */
  rbacRolesDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.rbacRolesDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Role viewset
   */
  rbacRolesListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["groupName"] != null) {
        queryParameters["group__name"] = requestParameters["groupName"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/roles/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedRoleListFromJSON(jsonValue));
    });
  }
  /**
   * Role viewset
   */
  rbacRolesList() {
    return __awaiter(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.rbacRolesListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Role viewset
   */
  rbacRolesPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["uuid"] == null) {
        throw new RequiredError("uuid", 'Required parameter "uuid" was null or undefined when calling rbacRolesPartialUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/roles/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters["uuid"]))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedRoleRequestToJSON(requestParameters["patchedRoleRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RoleFromJSON(jsonValue));
    });
  }
  /**
   * Role viewset
   */
  rbacRolesPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.rbacRolesPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Role viewset
   */
  rbacRolesRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["uuid"] == null) {
        throw new RequiredError("uuid", 'Required parameter "uuid" was null or undefined when calling rbacRolesRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/roles/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters["uuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RoleFromJSON(jsonValue));
    });
  }
  /**
   * Role viewset
   */
  rbacRolesRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.rbacRolesRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Role viewset
   */
  rbacRolesUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["uuid"] == null) {
        throw new RequiredError("uuid", 'Required parameter "uuid" was null or undefined when calling rbacRolesUpdate().');
      }
      if (requestParameters["roleRequest"] == null) {
        throw new RequiredError("roleRequest", 'Required parameter "roleRequest" was null or undefined when calling rbacRolesUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/roles/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters["uuid"]))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: RoleRequestToJSON(requestParameters["roleRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => RoleFromJSON(jsonValue));
    });
  }
  /**
   * Role viewset
   */
  rbacRolesUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.rbacRolesUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  rbacRolesUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["uuid"] == null) {
        throw new RequiredError("uuid", 'Required parameter "uuid" was null or undefined when calling rbacRolesUsedByList().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rbac/roles/{uuid}/used_by/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters["uuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  rbacRolesUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.rbacRolesUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
};
var RbacPermissionsAssignedByRolesListModelEnum = {
  AuthentikBlueprintsBlueprintinstance: "authentik_blueprints.blueprintinstance",
  AuthentikBrandsBrand: "authentik_brands.brand",
  AuthentikCoreApplication: "authentik_core.application",
  AuthentikCoreApplicationentitlement: "authentik_core.applicationentitlement",
  AuthentikCoreGroup: "authentik_core.group",
  AuthentikCoreToken: "authentik_core.token",
  AuthentikCoreUser: "authentik_core.user",
  AuthentikCryptoCertificatekeypair: "authentik_crypto.certificatekeypair",
  AuthentikEnterpriseLicense: "authentik_enterprise.license",
  AuthentikEventsEvent: "authentik_events.event",
  AuthentikEventsNotification: "authentik_events.notification",
  AuthentikEventsNotificationrule: "authentik_events.notificationrule",
  AuthentikEventsNotificationtransport: "authentik_events.notificationtransport",
  AuthentikEventsNotificationwebhookmapping: "authentik_events.notificationwebhookmapping",
  AuthentikFlowsFlow: "authentik_flows.flow",
  AuthentikFlowsFlowstagebinding: "authentik_flows.flowstagebinding",
  AuthentikOutpostsDockerserviceconnection: "authentik_outposts.dockerserviceconnection",
  AuthentikOutpostsKubernetesserviceconnection: "authentik_outposts.kubernetesserviceconnection",
  AuthentikOutpostsOutpost: "authentik_outposts.outpost",
  AuthentikPoliciesPolicybinding: "authentik_policies.policybinding",
  AuthentikPoliciesDummyDummypolicy: "authentik_policies_dummy.dummypolicy",
  AuthentikPoliciesEventMatcherEventmatcherpolicy: "authentik_policies_event_matcher.eventmatcherpolicy",
  AuthentikPoliciesExpiryPasswordexpirypolicy: "authentik_policies_expiry.passwordexpirypolicy",
  AuthentikPoliciesExpressionExpressionpolicy: "authentik_policies_expression.expressionpolicy",
  AuthentikPoliciesGeoipGeoippolicy: "authentik_policies_geoip.geoippolicy",
  AuthentikPoliciesPasswordPasswordpolicy: "authentik_policies_password.passwordpolicy",
  AuthentikPoliciesReputationReputationpolicy: "authentik_policies_reputation.reputationpolicy",
  AuthentikProvidersGoogleWorkspaceGoogleworkspaceprovider: "authentik_providers_google_workspace.googleworkspaceprovider",
  AuthentikProvidersGoogleWorkspaceGoogleworkspaceprovidermapping: "authentik_providers_google_workspace.googleworkspaceprovidermapping",
  AuthentikProvidersLdapLdapprovider: "authentik_providers_ldap.ldapprovider",
  AuthentikProvidersMicrosoftEntraMicrosoftentraprovider: "authentik_providers_microsoft_entra.microsoftentraprovider",
  AuthentikProvidersMicrosoftEntraMicrosoftentraprovidermapping: "authentik_providers_microsoft_entra.microsoftentraprovidermapping",
  AuthentikProvidersOauth2Oauth2provider: "authentik_providers_oauth2.oauth2provider",
  AuthentikProvidersOauth2Scopemapping: "authentik_providers_oauth2.scopemapping",
  AuthentikProvidersProxyProxyprovider: "authentik_providers_proxy.proxyprovider",
  AuthentikProvidersRacEndpoint: "authentik_providers_rac.endpoint",
  AuthentikProvidersRacRacpropertymapping: "authentik_providers_rac.racpropertymapping",
  AuthentikProvidersRacRacprovider: "authentik_providers_rac.racprovider",
  AuthentikProvidersRadiusRadiusprovider: "authentik_providers_radius.radiusprovider",
  AuthentikProvidersRadiusRadiusproviderpropertymapping: "authentik_providers_radius.radiusproviderpropertymapping",
  AuthentikProvidersSamlSamlpropertymapping: "authentik_providers_saml.samlpropertymapping",
  AuthentikProvidersSamlSamlprovider: "authentik_providers_saml.samlprovider",
  AuthentikProvidersScimScimmapping: "authentik_providers_scim.scimmapping",
  AuthentikProvidersScimScimprovider: "authentik_providers_scim.scimprovider",
  AuthentikProvidersSsfSsfprovider: "authentik_providers_ssf.ssfprovider",
  AuthentikRbacRole: "authentik_rbac.role",
  AuthentikSourcesKerberosGroupkerberossourceconnection: "authentik_sources_kerberos.groupkerberossourceconnection",
  AuthentikSourcesKerberosKerberossource: "authentik_sources_kerberos.kerberossource",
  AuthentikSourcesKerberosKerberossourcepropertymapping: "authentik_sources_kerberos.kerberossourcepropertymapping",
  AuthentikSourcesKerberosUserkerberossourceconnection: "authentik_sources_kerberos.userkerberossourceconnection",
  AuthentikSourcesLdapLdapsource: "authentik_sources_ldap.ldapsource",
  AuthentikSourcesLdapLdapsourcepropertymapping: "authentik_sources_ldap.ldapsourcepropertymapping",
  AuthentikSourcesOauthGroupoauthsourceconnection: "authentik_sources_oauth.groupoauthsourceconnection",
  AuthentikSourcesOauthOauthsource: "authentik_sources_oauth.oauthsource",
  AuthentikSourcesOauthOauthsourcepropertymapping: "authentik_sources_oauth.oauthsourcepropertymapping",
  AuthentikSourcesOauthUseroauthsourceconnection: "authentik_sources_oauth.useroauthsourceconnection",
  AuthentikSourcesPlexGroupplexsourceconnection: "authentik_sources_plex.groupplexsourceconnection",
  AuthentikSourcesPlexPlexsource: "authentik_sources_plex.plexsource",
  AuthentikSourcesPlexPlexsourcepropertymapping: "authentik_sources_plex.plexsourcepropertymapping",
  AuthentikSourcesPlexUserplexsourceconnection: "authentik_sources_plex.userplexsourceconnection",
  AuthentikSourcesSamlGroupsamlsourceconnection: "authentik_sources_saml.groupsamlsourceconnection",
  AuthentikSourcesSamlSamlsource: "authentik_sources_saml.samlsource",
  AuthentikSourcesSamlSamlsourcepropertymapping: "authentik_sources_saml.samlsourcepropertymapping",
  AuthentikSourcesSamlUsersamlsourceconnection: "authentik_sources_saml.usersamlsourceconnection",
  AuthentikSourcesScimScimsource: "authentik_sources_scim.scimsource",
  AuthentikSourcesScimScimsourcepropertymapping: "authentik_sources_scim.scimsourcepropertymapping",
  AuthentikStagesAuthenticatorDuoAuthenticatorduostage: "authentik_stages_authenticator_duo.authenticatorduostage",
  AuthentikStagesAuthenticatorDuoDuodevice: "authentik_stages_authenticator_duo.duodevice",
  AuthentikStagesAuthenticatorEmailAuthenticatoremailstage: "authentik_stages_authenticator_email.authenticatoremailstage",
  AuthentikStagesAuthenticatorEmailEmaildevice: "authentik_stages_authenticator_email.emaildevice",
  AuthentikStagesAuthenticatorEndpointGdtcAuthenticatorendpointgdtcstage: "authentik_stages_authenticator_endpoint_gdtc.authenticatorendpointgdtcstage",
  AuthentikStagesAuthenticatorSmsAuthenticatorsmsstage: "authentik_stages_authenticator_sms.authenticatorsmsstage",
  AuthentikStagesAuthenticatorSmsSmsdevice: "authentik_stages_authenticator_sms.smsdevice",
  AuthentikStagesAuthenticatorStaticAuthenticatorstaticstage: "authentik_stages_authenticator_static.authenticatorstaticstage",
  AuthentikStagesAuthenticatorStaticStaticdevice: "authentik_stages_authenticator_static.staticdevice",
  AuthentikStagesAuthenticatorTotpAuthenticatortotpstage: "authentik_stages_authenticator_totp.authenticatortotpstage",
  AuthentikStagesAuthenticatorTotpTotpdevice: "authentik_stages_authenticator_totp.totpdevice",
  AuthentikStagesAuthenticatorValidateAuthenticatorvalidatestage: "authentik_stages_authenticator_validate.authenticatorvalidatestage",
  AuthentikStagesAuthenticatorWebauthnAuthenticatorwebauthnstage: "authentik_stages_authenticator_webauthn.authenticatorwebauthnstage",
  AuthentikStagesAuthenticatorWebauthnWebauthndevice: "authentik_stages_authenticator_webauthn.webauthndevice",
  AuthentikStagesCaptchaCaptchastage: "authentik_stages_captcha.captchastage",
  AuthentikStagesConsentConsentstage: "authentik_stages_consent.consentstage",
  AuthentikStagesConsentUserconsent: "authentik_stages_consent.userconsent",
  AuthentikStagesDenyDenystage: "authentik_stages_deny.denystage",
  AuthentikStagesDummyDummystage: "authentik_stages_dummy.dummystage",
  AuthentikStagesEmailEmailstage: "authentik_stages_email.emailstage",
  AuthentikStagesIdentificationIdentificationstage: "authentik_stages_identification.identificationstage",
  AuthentikStagesInvitationInvitation: "authentik_stages_invitation.invitation",
  AuthentikStagesInvitationInvitationstage: "authentik_stages_invitation.invitationstage",
  AuthentikStagesPasswordPasswordstage: "authentik_stages_password.passwordstage",
  AuthentikStagesPromptPrompt: "authentik_stages_prompt.prompt",
  AuthentikStagesPromptPromptstage: "authentik_stages_prompt.promptstage",
  AuthentikStagesRedirectRedirectstage: "authentik_stages_redirect.redirectstage",
  AuthentikStagesSourceSourcestage: "authentik_stages_source.sourcestage",
  AuthentikStagesUserDeleteUserdeletestage: "authentik_stages_user_delete.userdeletestage",
  AuthentikStagesUserLoginUserloginstage: "authentik_stages_user_login.userloginstage",
  AuthentikStagesUserLogoutUserlogoutstage: "authentik_stages_user_logout.userlogoutstage",
  AuthentikStagesUserWriteUserwritestage: "authentik_stages_user_write.userwritestage",
  AuthentikTenantsDomain: "authentik_tenants.domain",
  UnknownDefaultOpenApi: "11184809"
};
var RbacPermissionsAssignedByUsersListModelEnum = {
  AuthentikBlueprintsBlueprintinstance: "authentik_blueprints.blueprintinstance",
  AuthentikBrandsBrand: "authentik_brands.brand",
  AuthentikCoreApplication: "authentik_core.application",
  AuthentikCoreApplicationentitlement: "authentik_core.applicationentitlement",
  AuthentikCoreGroup: "authentik_core.group",
  AuthentikCoreToken: "authentik_core.token",
  AuthentikCoreUser: "authentik_core.user",
  AuthentikCryptoCertificatekeypair: "authentik_crypto.certificatekeypair",
  AuthentikEnterpriseLicense: "authentik_enterprise.license",
  AuthentikEventsEvent: "authentik_events.event",
  AuthentikEventsNotification: "authentik_events.notification",
  AuthentikEventsNotificationrule: "authentik_events.notificationrule",
  AuthentikEventsNotificationtransport: "authentik_events.notificationtransport",
  AuthentikEventsNotificationwebhookmapping: "authentik_events.notificationwebhookmapping",
  AuthentikFlowsFlow: "authentik_flows.flow",
  AuthentikFlowsFlowstagebinding: "authentik_flows.flowstagebinding",
  AuthentikOutpostsDockerserviceconnection: "authentik_outposts.dockerserviceconnection",
  AuthentikOutpostsKubernetesserviceconnection: "authentik_outposts.kubernetesserviceconnection",
  AuthentikOutpostsOutpost: "authentik_outposts.outpost",
  AuthentikPoliciesPolicybinding: "authentik_policies.policybinding",
  AuthentikPoliciesDummyDummypolicy: "authentik_policies_dummy.dummypolicy",
  AuthentikPoliciesEventMatcherEventmatcherpolicy: "authentik_policies_event_matcher.eventmatcherpolicy",
  AuthentikPoliciesExpiryPasswordexpirypolicy: "authentik_policies_expiry.passwordexpirypolicy",
  AuthentikPoliciesExpressionExpressionpolicy: "authentik_policies_expression.expressionpolicy",
  AuthentikPoliciesGeoipGeoippolicy: "authentik_policies_geoip.geoippolicy",
  AuthentikPoliciesPasswordPasswordpolicy: "authentik_policies_password.passwordpolicy",
  AuthentikPoliciesReputationReputationpolicy: "authentik_policies_reputation.reputationpolicy",
  AuthentikProvidersGoogleWorkspaceGoogleworkspaceprovider: "authentik_providers_google_workspace.googleworkspaceprovider",
  AuthentikProvidersGoogleWorkspaceGoogleworkspaceprovidermapping: "authentik_providers_google_workspace.googleworkspaceprovidermapping",
  AuthentikProvidersLdapLdapprovider: "authentik_providers_ldap.ldapprovider",
  AuthentikProvidersMicrosoftEntraMicrosoftentraprovider: "authentik_providers_microsoft_entra.microsoftentraprovider",
  AuthentikProvidersMicrosoftEntraMicrosoftentraprovidermapping: "authentik_providers_microsoft_entra.microsoftentraprovidermapping",
  AuthentikProvidersOauth2Oauth2provider: "authentik_providers_oauth2.oauth2provider",
  AuthentikProvidersOauth2Scopemapping: "authentik_providers_oauth2.scopemapping",
  AuthentikProvidersProxyProxyprovider: "authentik_providers_proxy.proxyprovider",
  AuthentikProvidersRacEndpoint: "authentik_providers_rac.endpoint",
  AuthentikProvidersRacRacpropertymapping: "authentik_providers_rac.racpropertymapping",
  AuthentikProvidersRacRacprovider: "authentik_providers_rac.racprovider",
  AuthentikProvidersRadiusRadiusprovider: "authentik_providers_radius.radiusprovider",
  AuthentikProvidersRadiusRadiusproviderpropertymapping: "authentik_providers_radius.radiusproviderpropertymapping",
  AuthentikProvidersSamlSamlpropertymapping: "authentik_providers_saml.samlpropertymapping",
  AuthentikProvidersSamlSamlprovider: "authentik_providers_saml.samlprovider",
  AuthentikProvidersScimScimmapping: "authentik_providers_scim.scimmapping",
  AuthentikProvidersScimScimprovider: "authentik_providers_scim.scimprovider",
  AuthentikProvidersSsfSsfprovider: "authentik_providers_ssf.ssfprovider",
  AuthentikRbacRole: "authentik_rbac.role",
  AuthentikSourcesKerberosGroupkerberossourceconnection: "authentik_sources_kerberos.groupkerberossourceconnection",
  AuthentikSourcesKerberosKerberossource: "authentik_sources_kerberos.kerberossource",
  AuthentikSourcesKerberosKerberossourcepropertymapping: "authentik_sources_kerberos.kerberossourcepropertymapping",
  AuthentikSourcesKerberosUserkerberossourceconnection: "authentik_sources_kerberos.userkerberossourceconnection",
  AuthentikSourcesLdapLdapsource: "authentik_sources_ldap.ldapsource",
  AuthentikSourcesLdapLdapsourcepropertymapping: "authentik_sources_ldap.ldapsourcepropertymapping",
  AuthentikSourcesOauthGroupoauthsourceconnection: "authentik_sources_oauth.groupoauthsourceconnection",
  AuthentikSourcesOauthOauthsource: "authentik_sources_oauth.oauthsource",
  AuthentikSourcesOauthOauthsourcepropertymapping: "authentik_sources_oauth.oauthsourcepropertymapping",
  AuthentikSourcesOauthUseroauthsourceconnection: "authentik_sources_oauth.useroauthsourceconnection",
  AuthentikSourcesPlexGroupplexsourceconnection: "authentik_sources_plex.groupplexsourceconnection",
  AuthentikSourcesPlexPlexsource: "authentik_sources_plex.plexsource",
  AuthentikSourcesPlexPlexsourcepropertymapping: "authentik_sources_plex.plexsourcepropertymapping",
  AuthentikSourcesPlexUserplexsourceconnection: "authentik_sources_plex.userplexsourceconnection",
  AuthentikSourcesSamlGroupsamlsourceconnection: "authentik_sources_saml.groupsamlsourceconnection",
  AuthentikSourcesSamlSamlsource: "authentik_sources_saml.samlsource",
  AuthentikSourcesSamlSamlsourcepropertymapping: "authentik_sources_saml.samlsourcepropertymapping",
  AuthentikSourcesSamlUsersamlsourceconnection: "authentik_sources_saml.usersamlsourceconnection",
  AuthentikSourcesScimScimsource: "authentik_sources_scim.scimsource",
  AuthentikSourcesScimScimsourcepropertymapping: "authentik_sources_scim.scimsourcepropertymapping",
  AuthentikStagesAuthenticatorDuoAuthenticatorduostage: "authentik_stages_authenticator_duo.authenticatorduostage",
  AuthentikStagesAuthenticatorDuoDuodevice: "authentik_stages_authenticator_duo.duodevice",
  AuthentikStagesAuthenticatorEmailAuthenticatoremailstage: "authentik_stages_authenticator_email.authenticatoremailstage",
  AuthentikStagesAuthenticatorEmailEmaildevice: "authentik_stages_authenticator_email.emaildevice",
  AuthentikStagesAuthenticatorEndpointGdtcAuthenticatorendpointgdtcstage: "authentik_stages_authenticator_endpoint_gdtc.authenticatorendpointgdtcstage",
  AuthentikStagesAuthenticatorSmsAuthenticatorsmsstage: "authentik_stages_authenticator_sms.authenticatorsmsstage",
  AuthentikStagesAuthenticatorSmsSmsdevice: "authentik_stages_authenticator_sms.smsdevice",
  AuthentikStagesAuthenticatorStaticAuthenticatorstaticstage: "authentik_stages_authenticator_static.authenticatorstaticstage",
  AuthentikStagesAuthenticatorStaticStaticdevice: "authentik_stages_authenticator_static.staticdevice",
  AuthentikStagesAuthenticatorTotpAuthenticatortotpstage: "authentik_stages_authenticator_totp.authenticatortotpstage",
  AuthentikStagesAuthenticatorTotpTotpdevice: "authentik_stages_authenticator_totp.totpdevice",
  AuthentikStagesAuthenticatorValidateAuthenticatorvalidatestage: "authentik_stages_authenticator_validate.authenticatorvalidatestage",
  AuthentikStagesAuthenticatorWebauthnAuthenticatorwebauthnstage: "authentik_stages_authenticator_webauthn.authenticatorwebauthnstage",
  AuthentikStagesAuthenticatorWebauthnWebauthndevice: "authentik_stages_authenticator_webauthn.webauthndevice",
  AuthentikStagesCaptchaCaptchastage: "authentik_stages_captcha.captchastage",
  AuthentikStagesConsentConsentstage: "authentik_stages_consent.consentstage",
  AuthentikStagesConsentUserconsent: "authentik_stages_consent.userconsent",
  AuthentikStagesDenyDenystage: "authentik_stages_deny.denystage",
  AuthentikStagesDummyDummystage: "authentik_stages_dummy.dummystage",
  AuthentikStagesEmailEmailstage: "authentik_stages_email.emailstage",
  AuthentikStagesIdentificationIdentificationstage: "authentik_stages_identification.identificationstage",
  AuthentikStagesInvitationInvitation: "authentik_stages_invitation.invitation",
  AuthentikStagesInvitationInvitationstage: "authentik_stages_invitation.invitationstage",
  AuthentikStagesPasswordPasswordstage: "authentik_stages_password.passwordstage",
  AuthentikStagesPromptPrompt: "authentik_stages_prompt.prompt",
  AuthentikStagesPromptPromptstage: "authentik_stages_prompt.promptstage",
  AuthentikStagesRedirectRedirectstage: "authentik_stages_redirect.redirectstage",
  AuthentikStagesSourceSourcestage: "authentik_stages_source.sourcestage",
  AuthentikStagesUserDeleteUserdeletestage: "authentik_stages_user_delete.userdeletestage",
  AuthentikStagesUserLoginUserloginstage: "authentik_stages_user_login.userloginstage",
  AuthentikStagesUserLogoutUserlogoutstage: "authentik_stages_user_logout.userlogoutstage",
  AuthentikStagesUserWriteUserwritestage: "authentik_stages_user_write.userwritestage",
  AuthentikTenantsDomain: "authentik_tenants.domain",
  UnknownDefaultOpenApi: "11184809"
};

export {
  RbacApi,
  RbacPermissionsAssignedByRolesListModelEnum,
  RbacPermissionsAssignedByUsersListModelEnum
};
//# sourceMappingURL=chunk-6JJ33NXU.js.map
