import {
  table_default
} from "./chunk-K3AR7TXW.js";
import {
  AKElement,
  BaseTaskButton,
  EVENT_REFRESH,
  ROUTE_SEPARATOR,
  ResponseError,
  Rt,
  button_default,
  dropdown_default,
  groupBy,
  n,
  parseAPIError,
  patternfly_base_default,
  r,
  t,
  to,
  uiConfig
} from "./chunk-MKGIUSP2.js";
import {
  i,
  ke,
  msg,
  str
} from "./chunk-BW7LVHGS.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// node_modules/@patternfly/patternfly/components/FormControl/form-control.css
var form_control_default = `.pf-c-form-control {
  --pf-global--Color--100: var(--pf-global--Color--dark-100);
  --pf-global--Color--200: var(--pf-global--Color--dark-200);
  --pf-global--BorderColor--100: var(--pf-global--BorderColor--dark-100);
  --pf-global--primary-color--100: var(--pf-global--primary-color--dark-100);
  --pf-global--link--Color: var(--pf-global--link--Color--dark);
  --pf-global--link--Color--hover: var(--pf-global--link--Color--dark--hover);
  --pf-global--BackgroundColor--100: var(--pf-global--BackgroundColor--light-100);
}

.pf-c-form-control {
  --pf-c-form-control--Color: var(--pf-global--Color--100);
  --pf-c-form-control--FontSize: var(--pf-global--FontSize--md);
  --pf-c-form-control--LineHeight: var(--pf-global--LineHeight--md);
  --pf-c-form-control--BorderWidth: var(--pf-global--BorderWidth--sm);
  --pf-c-form-control--BorderTopColor: var(--pf-global--BorderColor--300);
  --pf-c-form-control--BorderRightColor: var(--pf-global--BorderColor--300);
  --pf-c-form-control--BorderBottomColor: var(--pf-global--BorderColor--200);
  --pf-c-form-control--BorderLeftColor: var(--pf-global--BorderColor--300);
  --pf-c-form-control--BorderRadius: 0;
  --pf-c-form-control--BackgroundColor: var(--pf-global--BackgroundColor--100);
  --pf-c-form-control--Width: 100%;
  --pf-c-form-control--Height: calc(var(--pf-c-form-control--FontSize) * var(--pf-c-form-control--LineHeight) + var(--pf-c-form-control--BorderWidth) * 2 + var(--pf-c-form-control--PaddingTop) + var(--pf-c-form-control--PaddingBottom));
  --pf-c-form-control--inset--base: var(--pf-global--spacer--sm);
  --pf-c-form-control--PaddingTop: calc(var(--pf-global--spacer--form-element) - var(--pf-global--BorderWidth--sm));
  --pf-c-form-control--PaddingBottom: calc(var(--pf-global--spacer--form-element) - var(--pf-global--BorderWidth--sm));
  --pf-c-form-control--PaddingRight: var(--pf-c-form-control--inset--base);
  --pf-c-form-control--PaddingLeft: var(--pf-c-form-control--inset--base);
  --pf-c-form-control--hover--BorderBottomColor: var(--pf-global--primary-color--100);
  --pf-c-form-control--focus--BorderBottomWidth: var(--pf-global--BorderWidth--md);
  --pf-c-form-control--focus--PaddingBottom: calc(var(--pf-global--spacer--form-element) - var(--pf-c-form-control--focus--BorderBottomWidth));
  --pf-c-form-control--focus--BorderBottomColor: var(--pf-global--primary-color--100);
  --pf-c-form-control--m-expanded--BorderBottomWidth: var(--pf-global--BorderWidth--md);
  --pf-c-form-control--m-expanded--PaddingBottom: calc(var(--pf-global--spacer--form-element) - var(--pf-c-form-control--focus--BorderBottomWidth));
  --pf-c-form-control--m-expanded--BorderBottomColor: var(--pf-global--primary-color--100);
  --pf-c-form-control--placeholder--Color: var(--pf-global--Color--dark-200);
  --pf-c-form-control--placeholder--child--Color: var(--pf-global--Color--100);
  --pf-c-form-control--disabled--Color: var(--pf-global--disabled-color--100);
  --pf-c-form-control--disabled--BackgroundColor: var(--pf-global--disabled-color--300);
  --pf-c-form-control--disabled--BorderColor: transparent;
  --pf-c-form-control--readonly--BackgroundColor: var(--pf-global--disabled-color--300);
  --pf-c-form-control--readonly--hover--BorderBottomColor: var(--pf-global--BorderColor--200);
  --pf-c-form-control--readonly--focus--PaddingBottom: calc(var(--pf-global--spacer--form-element) - var(--pf-global--BorderWidth--sm));
  --pf-c-form-control--readonly--focus--BorderBottomWidth: var(--pf-global--BorderWidth--sm);
  --pf-c-form-control--readonly--focus--BorderBottomColor: var(--pf-global--BorderColor--200);
  --pf-c-form-control--readonly--m-plain--BackgroundColor: transparent;
  --pf-c-form-control--readonly--m-plain--inset--base: 0;
  --pf-c-form-control--success--BorderBottomWidth: var(--pf-global--BorderWidth--md);
  --pf-c-form-control--success--PaddingBottom: calc(var(--pf-global--spacer--form-element) - var(--pf-c-form-control--success--BorderBottomWidth));
  --pf-c-form-control--success--BorderBottomColor: var(--pf-global--success-color--100);
  --pf-c-form-control--success--PaddingRight: var(--pf-global--spacer--xl);
  --pf-c-form-control--success--BackgroundPositionX: calc(100% - var(--pf-c-form-control--PaddingLeft));
  --pf-c-form-control--success--BackgroundPositionY: center;
  --pf-c-form-control--success--BackgroundPosition: var(--pf-c-form-control--success--BackgroundPositionX) var(--pf-c-form-control--success--BackgroundPositionY);
  --pf-c-form-control--success--BackgroundSizeX: var(--pf-c-form-control--FontSize);
  --pf-c-form-control--success--BackgroundSizeY: var(--pf-c-form-control--FontSize);
  --pf-c-form-control--success--BackgroundSize: var(--pf-c-form-control--success--BackgroundSizeX) var(--pf-c-form-control--success--BackgroundSizeY);
  --pf-c-form-control--success--BackgroundUrl: url("data:image/svg+xml;charset=utf8,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 512 512'%3E%3Cpath fill='%233e8635' d='M504 256c0 136.967-111.033 248-248 248S8 392.967 8 256 119.033 8 256 8s248 111.033 248 248zM227.314 387.314l184-184c6.248-6.248 6.248-16.379 0-22.627l-22.627-22.627c-6.248-6.249-16.379-6.249-22.628 0L216 308.118l-70.059-70.059c-6.248-6.248-16.379-6.248-22.628 0l-22.627 22.627c-6.248 6.248-6.248 16.379 0 22.627l104 104c6.249 6.249 16.379 6.249 22.628.001z'/%3E%3C/svg%3E");
  --pf-c-form-control--m-warning--BorderBottomWidth: var(--pf-global--BorderWidth--md);
  --pf-c-form-control--m-warning--PaddingBottom: calc(var(--pf-global--spacer--form-element) - var(--pf-c-form-control--m-warning--BorderBottomWidth));
  --pf-c-form-control--m-warning--BorderBottomColor: var(--pf-global--warning-color--100);
  --pf-c-form-control--m-warning--PaddingRight: var(--pf-global--spacer--xl);
  --pf-c-form-control--m-warning--BackgroundPositionX: calc(100% - calc(var(--pf-c-form-control--PaddingLeft) - 0.0625rem));
  --pf-c-form-control--m-warning--BackgroundPositionY: center;
  --pf-c-form-control--m-warning--BackgroundPosition: var(--pf-c-form-control--m-warning--BackgroundPositionX) var(--pf-c-form-control--m-warning--BackgroundPositionY);
  --pf-c-form-control--m-warning--BackgroundSizeX: 1.25rem;
  --pf-c-form-control--m-warning--BackgroundSizeY: var(--pf-c-form-control--FontSize);
  --pf-c-form-control--m-warning--BackgroundSize: var(--pf-c-form-control--m-warning--BackgroundSizeX) var(--pf-c-form-control--m-warning--BackgroundSizeY);
  --pf-c-form-control--m-warning--BackgroundUrl: url("data:image/svg+xml;charset=utf8,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 512 512'%3E%3Cpath fill='%23f0ab00' d='M569.517 440.013C587.975 472.007 564.806 512 527.94 512H48.054c-36.937 0-59.999-40.055-41.577-71.987L246.423 23.985c18.467-32.009 64.72-31.951 83.154 0l239.94 416.028zM288 354c-25.405 0-46 20.595-46 46s20.595 46 46 46 46-20.595 46-46-20.595-46-46-46zm-43.673-165.346l7.418 136c.347 6.364 5.609 11.346 11.982 11.346h48.546c6.373 0 11.635-4.982 11.982-11.346l7.418-136c.375-6.874-5.098-12.654-11.982-12.654h-63.383c-6.884 0-12.356 5.78-11.981 12.654z'/%3E%3C/svg%3E");
  --pf-c-form-control--invalid--BorderBottomWidth: var(--pf-global--BorderWidth--md);
  --pf-c-form-control--invalid--PaddingBottom: calc(var(--pf-global--spacer--form-element) - var(--pf-c-form-control--invalid--BorderBottomWidth));
  --pf-c-form-control--invalid--BorderBottomColor: var(--pf-global--danger-color--100);
  --pf-c-form-control--invalid--PaddingRight: var(--pf-global--spacer--xl);
  --pf-c-form-control--invalid--BackgroundPositionX: calc(100% - var(--pf-c-form-control--PaddingLeft));
  --pf-c-form-control--invalid--BackgroundPositionY: center;
  --pf-c-form-control--invalid--BackgroundPosition: var(--pf-c-form-control--invalid--BackgroundPositionX) var(--pf-c-form-control--invalid--BackgroundPositionY);
  --pf-c-form-control--invalid--BackgroundSizeX: var(--pf-c-form-control--FontSize);
  --pf-c-form-control--invalid--BackgroundSizeY: var(--pf-c-form-control--FontSize);
  --pf-c-form-control--invalid--BackgroundSize: var(--pf-c-form-control--invalid--BackgroundSizeX) var(--pf-c-form-control--invalid--BackgroundSizeY);
  --pf-c-form-control--invalid--BackgroundUrl: url("data:image/svg+xml;charset=utf8,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 512 512'%3E%3Cpath fill='%23c9190b' d='M504 256c0 136.997-111.043 248-248 248S8 392.997 8 256C8 119.083 119.043 8 256 8s248 111.083 248 248zm-248 50c-25.405 0-46 20.595-46 46s20.595 46 46 46 46-20.595 46-46-20.595-46-46-46zm-43.673-165.346l7.418 136c.347 6.364 5.609 11.346 11.982 11.346h48.546c6.373 0 11.635-4.982 11.982-11.346l7.418-136c.375-6.874-5.098-12.654-11.982-12.654h-63.383c-6.884 0-12.356 5.78-11.981 12.654z'/%3E%3C/svg%3E");
  --pf-c-form-control--invalid--exclamation--Background: var(--pf-c-form-control--invalid--BackgroundUrl) var(--pf-c-form-control--invalid--BackgroundPosition) / var(--pf-c-form-control--invalid--BackgroundSize) no-repeat;
  --pf-c-form-control--invalid--Background: var(--pf-c-form-control--BackgroundColor) var(--pf-c-form-control--invalid--exclamation--Background);
  --pf-c-form-control--m-search--PaddingLeft: var(--pf-global--spacer--xl);
  --pf-c-form-control--m-search--BackgroundPosition: var(--pf-c-form-control--PaddingRight);
  --pf-c-form-control--m-search--BackgroundSize: var(--pf-c-form-control--FontSize) var(--pf-c-form-control--FontSize);
  --pf-c-form-control--m-search--BackgroundUrl: url("data:image/svg+xml;charset=utf8,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 512 512'%3E%3Cpath fill='%236a6e73' d='M505 442.7L405.3 343c-4.5-4.5-10.6-7-17-7H372c27.6-35.3 44-79.7 44-128C416 93.1 322.9 0 208 0S0 93.1 0 208s93.1 208 208 208c48.3 0 92.7-16.4 128-44v16.3c0 6.4 2.5 12.5 7 17l99.7 99.7c9.4 9.4 24.6 9.4 33.9 0l28.3-28.3c9.4-9.4 9.4-24.6.1-34zM208 336c-70.7 0-128-57.2-128-128 0-70.7 57.2-128 128-128 70.7 0 128 57.2 128 128 0 70.7-57.2 128-128 128z'/%3E%3C/svg%3E");
  --pf-c-form-control--m-icon--PaddingRight: calc(var(--pf-c-form-control--inset--base) + var(--pf-c-form-control--m-icon--BackgroundSizeX) + var(--pf-c-form-control--m-icon--icon--spacer));
  --pf-c-form-control--m-icon--BackgroundUrl: none;
  --pf-c-form-control--m-icon--BackgroundPositionX: calc(100% - var(--pf-c-form-control--inset--base));
  --pf-c-form-control--m-icon--BackgroundPositionY: center;
  --pf-c-form-control--m-icon--BackgroundSizeX: var(--pf-c-form-control--FontSize);
  --pf-c-form-control--m-icon--BackgroundSizeY: var(--pf-c-form-control--FontSize);
  --pf-c-form-control--m-icon--icon--spacer: var(--pf-global--spacer--sm);
  --pf-c-form-control--m-icon--icon--PaddingRight: calc(var(--pf-c-form-control--inset--base) + var(--pf-c-form-control--invalid--BackgroundSizeX) + var(--pf-c-form-control--m-icon--icon--spacer) + var(--pf-c-form-control--m-icon--BackgroundSizeX) + var(--pf-c-form-control--m-icon--icon--spacer));
  --pf-c-form-control--m-icon--icon--BackgroundPositionX: calc(var(--pf-c-form-control--m-icon--BackgroundPositionX) - var(--pf-c-form-control--m-icon--icon--spacer) - var(--pf-c-form-control--invalid--BackgroundSizeX));
  --pf-c-form-control--m-icon--invalid--BackgroundUrl: var(--pf-c-form-control--invalid--BackgroundUrl), var(--pf-c-form-control--m-icon--BackgroundUrl);
  --pf-c-form-control--m-icon--invalid--BackgroundPosition: var(--pf-c-form-control--invalid--BackgroundPosition), var(--pf-c-form-control--m-icon--icon--BackgroundPositionX) var(--pf-c-form-control--m-icon--BackgroundPositionY);
  --pf-c-form-control--m-icon--invalid--BackgroundSize: var(--pf-c-form-control--invalid--BackgroundSize), var(--pf-c-form-control--m-icon--BackgroundSizeX) var(--pf-c-form-control--m-icon--BackgroundSizeY);
  --pf-c-form-control--m-icon--success--BackgroundUrl: var(--pf-c-form-control--success--BackgroundUrl), var(--pf-c-form-control--m-icon--BackgroundUrl);
  --pf-c-form-control--m-icon--success--BackgroundPosition: var(--pf-c-form-control--success--BackgroundPosition), var(--pf-c-form-control--m-icon--icon--BackgroundPositionX) var(--pf-c-form-control--m-icon--BackgroundPositionY);
  --pf-c-form-control--m-icon--success--BackgroundSize: var(--pf-c-form-control--success--BackgroundSize), var(--pf-c-form-control--m-icon--BackgroundSizeX) var(--pf-c-form-control--m-icon--BackgroundSizeY);
  --pf-c-form-control--m-icon--m-warning--BackgroundUrl: var(--pf-c-form-control--m-warning--BackgroundUrl), var(--pf-c-form-control--m-icon--BackgroundUrl);
  --pf-c-form-control--m-icon--m-warning--BackgroundPosition: var(--pf-c-form-control--m-warning--BackgroundPosition), var(--pf-c-form-control--m-icon--icon--BackgroundPositionX) var(--pf-c-form-control--m-icon--BackgroundPositionY);
  --pf-c-form-control--m-icon--m-warning--BackgroundSize: var(--pf-c-form-control--m-warning--BackgroundSize), var(--pf-c-form-control--m-icon--BackgroundSizeX) var(--pf-c-form-control--m-icon--BackgroundSizeY);
  --pf-c-form-control--m-calendar--BackgroundUrl: url("data:image/svg+xml;charset=utf8,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 512 512'%3E%3Cpath fill='%236a6e73' d='M0 464c0 26.5 21.5 48 48 48h352c26.5 0 48-21.5 48-48V192H0v272zm320-196c0-6.6 5.4-12 12-12h40c6.6 0 12 5.4 12 12v40c0 6.6-5.4 12-12 12h-40c-6.6 0-12-5.4-12-12v-40zm0 128c0-6.6 5.4-12 12-12h40c6.6 0 12 5.4 12 12v40c0 6.6-5.4 12-12 12h-40c-6.6 0-12-5.4-12-12v-40zM192 268c0-6.6 5.4-12 12-12h40c6.6 0 12 5.4 12 12v40c0 6.6-5.4 12-12 12h-40c-6.6 0-12-5.4-12-12v-40zm0 128c0-6.6 5.4-12 12-12h40c6.6 0 12 5.4 12 12v40c0 6.6-5.4 12-12 12h-40c-6.6 0-12-5.4-12-12v-40zM64 268c0-6.6 5.4-12 12-12h40c6.6 0 12 5.4 12 12v40c0 6.6-5.4 12-12 12H76c-6.6 0-12-5.4-12-12v-40zm0 128c0-6.6 5.4-12 12-12h40c6.6 0 12 5.4 12 12v40c0 6.6-5.4 12-12 12H76c-6.6 0-12-5.4-12-12v-40zM400 64h-48V16c0-8.8-7.2-16-16-16h-32c-8.8 0-16 7.2-16 16v48H160V16c0-8.8-7.2-16-16-16h-32c-8.8 0-16 7.2-16 16v48H48C21.5 64 0 85.5 0 112v48h448v-48c0-26.5-21.5-48-48-48z'/%3E%3C/svg%3E");
  --pf-c-form-control--m-clock--BackgroundUrl: url("data:image/svg+xml;charset=utf8,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 512 512'%3E%3Cpath fill='%236a6e73' d='M256 8C119 8 8 119 8 256s111 248 248 248 248-111 248-248S393 8 256 8zm0 448c-110.5 0-200-89.5-200-200S145.5 56 256 56s200 89.5 200 200-89.5 200-200 200zm61.8-104.4l-84.9-61.7c-3.1-2.3-4.9-5.9-4.9-9.7V116c0-6.6 5.4-12 12-12h32c6.6 0 12 5.4 12 12v141.7l66.8 48.6c5.4 3.9 6.5 11.4 2.6 16.8L334.6 349c-3.9 5.3-11.4 6.5-16.8 2.6z'/%3E%3C/svg%3E");
  --pf-c-form-control__select--PaddingRight: calc(var(--pf-global--spacer--lg) + var(--pf-c-form-control--BorderWidth) + var(--pf-c-form-control--BorderWidth));
  --pf-c-form-control__select--PaddingLeft: calc(var(--pf-global--spacer--sm) - var(--pf-c-form-control--BorderWidth));
  --pf-c-form-control__select--BackgroundUrl: url("data:image/svg+xml;charset=utf8,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 320 512'%3E%3Cpath fill='%23urrentColor' d='M31.3 192h257.3c17.8 0 26.7 21.5 14.1 34.1L174.1 354.8c-7.8 7.8-20.5 7.8-28.3 0L17.2 226.1C4.6 213.5 13.5 192 31.3 192z'/%3E%3C/svg%3E");
  --pf-c-form-control__select--BackgroundSize: .625em;
  --pf-c-form-control__select--BackgroundPositionX: calc(100% - var(--pf-global--spacer--md) + 1px);
  --pf-c-form-control__select--BackgroundPositionY: center;
  --pf-c-form-control__select--BackgroundPosition: var(--pf-c-form-control__select--BackgroundPositionX) var(--pf-c-form-control__select--BackgroundPositionY);
  --pf-c-form-control__select--success--PaddingRight: var(--pf-global--spacer--3xl);
  --pf-c-form-control__select--success--BackgroundPosition: calc(var(--pf-c-form-control__select--BackgroundPositionX) - var(--pf-global--spacer--lg));
  --pf-c-form-control__select--m-warning--PaddingRight: var(--pf-global--spacer--3xl);
  --pf-c-form-control__select--m-warning--BackgroundPosition: calc(var(--pf-c-form-control__select--BackgroundPositionX) - var(--pf-global--spacer--lg) + 0.0625rem);
  --pf-c-form-control__select--invalid--PaddingRight: var(--pf-global--spacer--3xl);
  --pf-c-form-control__select--invalid--BackgroundPosition: calc(var(--pf-c-form-control__select--BackgroundPositionX) - var(--pf-global--spacer--lg));
  --pf-c-form-control--textarea--Width: var(--pf-c-form-control--Width);
  --pf-c-form-control--textarea--Height: auto;
  --pf-c-form-control--textarea--success--BackgroundPositionY: var(--pf-c-form-control--PaddingLeft);
  --pf-c-form-control--textarea--m-warning--BackgroundPositionY: var(--pf-c-form-control--PaddingLeft);
  --pf-c-form-control--textarea--invalid--BackgroundPositionY: var(--pf-c-form-control--PaddingLeft);
  --pf-c-form-control--m-icon-sprite--success--BackgroundUrl: url("../../assets/images/status-icon-sprite.svg#success");
  --pf-c-form-control--m-icon-sprite--m-warning--BackgroundUrl: url("../../assets/images/status-icon-sprite.svg#warning");
  --pf-c-form-control--m-icon-sprite--invalid--BackgroundUrl: url("../../assets/images/status-icon-sprite.svg#invalid");
  --pf-c-form-control--m-icon-sprite__select--BackgroundUrl: url("../../assets/images/status-icon-sprite.svg#select");
  --pf-c-form-control--m-icon-sprite--m-search--BackgroundUrl: url("../../assets/images/status-icon-sprite.svg#search");
  --pf-c-form-control--m-icon-sprite--m-calendar--BackgroundUrl: url("../../assets/images/status-icon-sprite.svg#calendar");
  --pf-c-form-control--m-icon-sprite--m-clock--BackgroundUrl: url("../../assets/images/status-icon-sprite.svg#clock");
  --pf-c-form-control--m-icon-sprite__select--BackgroundSize: var(--pf-c-form-control--FontSize);
  --pf-c-form-control--m-icon-sprite__select--BackgroundPositionX: calc(100% - var(--pf-global--spacer--md) + 7px);
  --pf-c-form-control--m-icon-sprite__select--success--BackgroundPosition: calc(100% - var(--pf-global--spacer--md) + 1px - var(--pf-global--spacer--lg));
  --pf-c-form-control--m-icon-sprite__select--m-warning--BackgroundPosition: calc(100% - var(--pf-global--spacer--md) - var(--pf-global--spacer--lg) + 0.0625rem);
  --pf-c-form-control--m-icon-sprite__select--invalid--BackgroundPosition: calc(100% - var(--pf-global--spacer--md) - var(--pf-global--spacer--lg));
  color: var(--pf-c-form-control--Color);
  width: var(--pf-c-form-control--Width);
  padding: var(--pf-c-form-control--PaddingTop) var(--pf-c-form-control--PaddingRight) var(--pf-c-form-control--PaddingBottom) var(--pf-c-form-control--PaddingLeft);
  font-size: var(--pf-c-form-control--FontSize);
  line-height: var(--pf-c-form-control--LineHeight);
  background-color: var(--pf-c-form-control--BackgroundColor);
  background-repeat: no-repeat;
  border: var(--pf-c-form-control--BorderWidth) solid;
  border-color: var(--pf-c-form-control--BorderTopColor) var(--pf-c-form-control--BorderRightColor) var(--pf-c-form-control--BorderBottomColor) var(--pf-c-form-control--BorderLeftColor);
  border-radius: var(--pf-c-form-control--BorderRadius);
  -moz-appearance: none;
  -webkit-appearance: none;
}
.pf-c-form-control::placeholder {
  color: var(--pf-c-form-control--placeholder--Color);
}
.pf-c-form-control:not(textarea) {
  height: var(--pf-c-form-control--Height);
  text-overflow: ellipsis;
}
.pf-c-form-control[readonly] {
  background-color: var(--pf-c-form-control--readonly--BackgroundColor);
}
.pf-c-form-control[readonly]:not(.pf-m-success):not([aria-invalid=true]):hover {
  --pf-c-form-control--BorderBottomColor: var(--pf-c-form-control--readonly--hover--BorderBottomColor);
}
.pf-c-form-control[readonly]:not(.pf-m-success):not([aria-invalid=true]):focus {
  --pf-c-form-control--focus--PaddingBottom: var(--pf-c-form-control--readonly--focus--PaddingBottom);
  --pf-c-form-control--focus--BorderBottomWidth: var(--pf-c-form-control--readonly--focus--BorderBottomWidth);
  --pf-c-form-control--focus--BorderBottomColor: var(--pf-c-form-control--readonly--focus--BorderBottomColor);
}
.pf-c-form-control[readonly].pf-m-plain {
  --pf-c-form-control--readonly--BackgroundColor: var(--pf-c-form-control--readonly--m-plain--BackgroundColor);
  --pf-c-form-control--inset--base: var(--pf-c-form-control--readonly--m-plain--inset--base);
  border-color: transparent;
}
.pf-c-form-control:hover {
  --pf-c-form-control--BorderBottomColor: var(--pf-c-form-control--hover--BorderBottomColor);
}
.pf-c-form-control:focus {
  --pf-c-form-control--BorderBottomColor: var(--pf-c-form-control--focus--BorderBottomColor);
  padding-bottom: var(--pf-c-form-control--focus--PaddingBottom);
  border-bottom-width: var(--pf-c-form-control--focus--BorderBottomWidth);
}
.pf-c-form-control.pf-m-expanded {
  --pf-c-form-control--BorderBottomColor: var(--pf-c-form-control--m-expanded--BorderBottomColor);
  padding-bottom: var(--pf-c-form-control--m-expanded--PaddingBottom);
  border-bottom-width: var(--pf-c-form-control--m-expanded--BorderBottomWidth);
}
.pf-c-form-control:disabled {
  --pf-c-form-control--BackgroundColor: var(--pf-c-form-control--disabled--BackgroundColor);
  color: var(--pf-c-form-control--disabled--Color);
  cursor: not-allowed;
  border-color: var(--pf-c-form-control--disabled--BorderColor);
}
.pf-c-form-control[aria-invalid=true] {
  --pf-c-form-control--PaddingRight: var(--pf-c-form-control--invalid--PaddingRight);
  --pf-c-form-control--BorderBottomColor: var(--pf-c-form-control--invalid--BorderBottomColor);
  padding-bottom: var(--pf-c-form-control--invalid--PaddingBottom);
  background-image: var(--pf-c-form-control--invalid--BackgroundUrl);
  background-position: var(--pf-c-form-control--invalid--BackgroundPosition);
  background-size: var(--pf-c-form-control--invalid--BackgroundSize);
  border-bottom-width: var(--pf-c-form-control--invalid--BorderBottomWidth);
}
.pf-c-form-control[aria-invalid=true].pf-m-icon {
  --pf-c-form-control--PaddingRight: var(--pf-c-form-control--m-icon--icon--PaddingRight);
  background-image: var(--pf-c-form-control--m-icon--invalid--BackgroundUrl);
  background-position: var(--pf-c-form-control--m-icon--invalid--BackgroundPosition);
  background-size: var(--pf-c-form-control--m-icon--invalid--BackgroundSize);
}
.pf-c-form-control.pf-m-success {
  --pf-c-form-control--PaddingRight: var(--pf-c-form-control--success--PaddingRight);
  --pf-c-form-control--BorderBottomColor: var(--pf-c-form-control--success--BorderBottomColor);
  padding-bottom: var(--pf-c-form-control--success--PaddingBottom);
  background-image: var(--pf-c-form-control--success--BackgroundUrl);
  background-position: var(--pf-c-form-control--success--BackgroundPosition);
  background-size: var(--pf-c-form-control--success--BackgroundSize);
  border-bottom-width: var(--pf-c-form-control--success--BorderBottomWidth);
}
.pf-c-form-control.pf-m-success.pf-m-icon {
  --pf-c-form-control--PaddingRight: var(--pf-c-form-control--m-icon--icon--PaddingRight);
  background-image: var(--pf-c-form-control--m-icon--success--BackgroundUrl);
  background-position: var(--pf-c-form-control--m-icon--success--BackgroundPosition);
  background-size: var(--pf-c-form-control--m-icon--success--BackgroundSize);
}
.pf-c-form-control.pf-m-warning {
  --pf-c-form-control--PaddingRight: var(--pf-c-form-control--m-warning--PaddingRight);
  --pf-c-form-control--BorderBottomColor: var(--pf-c-form-control--m-warning--BorderBottomColor);
  padding-bottom: var(--pf-c-form-control--m-warning--PaddingBottom);
  background-image: var(--pf-c-form-control--m-warning--BackgroundUrl);
  background-position: var(--pf-c-form-control--m-warning--BackgroundPosition);
  background-size: var(--pf-c-form-control--m-warning--BackgroundSize);
  border-bottom-width: var(--pf-c-form-control--m-warning--BorderBottomWidth);
}
.pf-c-form-control.pf-m-warning.pf-m-icon {
  --pf-c-form-control--PaddingRight: var(--pf-c-form-control--m-icon--icon--PaddingRight);
  background-image: var(--pf-c-form-control--m-icon--m-warning--BackgroundUrl);
  background-position: var(--pf-c-form-control--m-icon--m-warning--BackgroundPosition);
  background-size: var(--pf-c-form-control--m-icon--m-warning--BackgroundSize);
}
.pf-c-form-control.pf-m-search {
  --pf-c-form-control--PaddingLeft: var(--pf-c-form-control--m-search--PaddingLeft);
  background-image: var(--pf-c-form-control--m-search--BackgroundUrl);
  background-position: var(--pf-c-form-control--m-search--BackgroundPosition);
  background-size: var(--pf-c-form-control--m-search--BackgroundSize);
}
.pf-c-form-control.pf-m-icon {
  --pf-c-form-control--PaddingRight: var(--pf-c-form-control--m-icon--PaddingRight);
  background-image: var(--pf-c-form-control--m-icon--BackgroundUrl);
  background-position: var(--pf-c-form-control--m-icon--BackgroundPositionX) var(--pf-c-form-control--m-icon--BackgroundPositionY);
  background-size: var(--pf-c-form-control--m-icon--BackgroundSizeX) var(--pf-c-form-control--m-icon--BackgroundSizeY);
}
.pf-c-form-control.pf-m-icon.pf-m-calendar {
  --pf-c-form-control--m-icon--BackgroundUrl: var(--pf-c-form-control--m-calendar--BackgroundUrl);
}
.pf-c-form-control.pf-m-icon.pf-m-clock {
  --pf-c-form-control--m-icon--BackgroundUrl: var(--pf-c-form-control--m-clock--BackgroundUrl);
}
.pf-c-form-control.pf-m-icon-sprite {
  --pf-c-form-control--success--BackgroundUrl: var(--pf-c-form-control--m-icon-sprite--success--BackgroundUrl);
  --pf-c-form-control--m-warning--BackgroundUrl: var(--pf-c-form-control--m-icon-sprite--m-warning--BackgroundUrl);
  --pf-c-form-control--invalid--BackgroundUrl: var(--pf-c-form-control--m-icon-sprite--invalid--BackgroundUrl);
  --pf-c-form-control__select--BackgroundUrl: var(--pf-c-form-control--m-icon-sprite__select--BackgroundUrl);
  --pf-c-form-control--m-search--BackgroundUrl: var(--pf-c-form-control--m-icon-sprite--m-search--BackgroundUrl);
  --pf-c-form-control--m-calendar--BackgroundUrl: var(--pf-c-form-control--m-icon-sprite--m-calendar--BackgroundUrl);
  --pf-c-form-control--m-clock--BackgroundUrl: var(--pf-c-form-control--m-icon-sprite--m-clock--BackgroundUrl);
  --pf-c-form-control__select--BackgroundSize: var(--pf-c-form-control--m-icon-sprite__select--BackgroundSize);
  --pf-c-form-control__select--BackgroundPositionX: var(--pf-c-form-control--m-icon-sprite__select--BackgroundPositionX);
  --pf-c-form-control__select--success--BackgroundPosition: var(--pf-c-form-control--m-icon-sprite__select--success--BackgroundPosition);
  --pf-c-form-control__select--m-warning--BackgroundPosition: var(--pf-c-form-control--m-icon-sprite__select--m-warning--BackgroundPosition);
  --pf-c-form-control__select--invalid--BackgroundPosition: var(--pf-c-form-control--m-icon-sprite__select--invalid--BackgroundPosition);
}
select.pf-c-form-control {
  --pf-c-form-control--PaddingRight: var(--pf-c-form-control__select--PaddingRight);
  --pf-c-form-control--PaddingLeft: var(--pf-c-form-control__select--PaddingLeft);
  background-image: var(--pf-c-form-control__select--BackgroundUrl);
  background-position: var(--pf-c-form-control__select--BackgroundPosition);
  background-size: var(--pf-c-form-control__select--BackgroundSize);
}
@-moz-document url-prefix() {
  select.pf-c-form-control {
    --pf-c-form-control--PaddingRight: calc(var(--pf-c-form-control__select--PaddingRight) - 1px);
    --pf-c-form-control--PaddingLeft: calc(var(--pf-c-form-control__select--PaddingLeft) - 4px);
  }
}
select.pf-c-form-control[aria-invalid=true] {
  --pf-c-form-control--PaddingRight: var(--pf-c-form-control__select--invalid--PaddingRight);
  --pf-c-form-control--invalid--BackgroundPosition: var(--pf-c-form-control__select--invalid--BackgroundPosition);
  background-image: var(--pf-c-form-control__select--BackgroundUrl), var(--pf-c-form-control--invalid--BackgroundUrl);
  background-position: var(--pf-c-form-control__select--BackgroundPosition), var(--pf-c-form-control--invalid--BackgroundPosition);
  background-size: var(--pf-c-form-control__select--BackgroundSize), var(--pf-c-form-control--invalid--BackgroundSize);
}
select.pf-c-form-control.pf-m-success {
  --pf-c-form-control--PaddingRight: var(--pf-c-form-control__select--success--PaddingRight);
  --pf-c-form-control--success--BackgroundPosition: var(--pf-c-form-control__select--success--BackgroundPosition);
  background-image: var(--pf-c-form-control__select--BackgroundUrl), var(--pf-c-form-control--success--BackgroundUrl);
  background-position: var(--pf-c-form-control__select--BackgroundPosition), var(--pf-c-form-control--success--BackgroundPosition);
  background-size: var(--pf-c-form-control__select--BackgroundSize), var(--pf-c-form-control--success--BackgroundSize);
}
select.pf-c-form-control.pf-m-warning {
  --pf-c-form-control--PaddingRight: var(--pf-c-form-control__select--m-warning--PaddingRight);
  background-image: var(--pf-c-form-control__select--BackgroundUrl), var(--pf-c-form-control--m-warning--BackgroundUrl);
  background-position: var(--pf-c-form-control__select--BackgroundPosition), var(--pf-c-form-control__select--m-warning--BackgroundPosition);
  background-size: var(--pf-c-form-control__select--BackgroundSize), var(--pf-c-form-control--m-warning--BackgroundSize);
}
select.pf-c-form-control.pf-m-placeholder {
  color: var(--pf-c-form-control--placeholder--Color);
}
select.pf-c-form-control.pf-m-placeholder * {
  color: var(--pf-c-form-control--placeholder--child--Color);
}
select.pf-c-form-control.pf-m-placeholder *:disabled {
  color: revert;
}

textarea.pf-c-form-control {
  --pf-c-form-control--success--BackgroundPositionY: var(--pf-c-form-control--textarea--success--BackgroundPositionY);
  --pf-c-form-control--invalid--BackgroundPositionY: var(--pf-c-form-control--textarea--invalid--BackgroundPositionY);
  --pf-c-form-control--m-warning--BackgroundPositionY: var(--pf-c-form-control--textarea--m-warning--BackgroundPositionY);
  width: var(--pf-c-form-control--textarea--Width);
  height: var(--pf-c-form-control--textarea--Height);
  vertical-align: bottom;
}

.pf-c-form-control.pf-m-resize-vertical {
  resize: vertical;
}
.pf-c-form-control.pf-m-resize-horizontal {
  resize: horizontal;
}

:where(.pf-theme-dark) .pf-c-form-control {
  --pf-c-form-control__select--BackgroundUrl: url("data:image/svg+xml;charset=utf8,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 320 512'%3E%3Cpath fill='%23e0e0e0' d='M31.3 192h257.3c17.8 0 26.7 21.5 14.1 34.1L174.1 354.8c-7.8 7.8-20.5 7.8-28.3 0L17.2 226.1C4.6 213.5 13.5 192 31.3 192z'/%3E%3C/svg%3E");
  --pf-c-form-control--BorderTopColor: transparent;
  --pf-c-form-control--BorderRightColor: transparent;
  --pf-c-form-control--BorderBottomColor: var(--pf-global--BorderColor--400);
  --pf-c-form-control--BorderLeftColor: transparent;
  --pf-c-form-control--BackgroundColor: var(--pf-global--BackgroundColor--400);
  --pf-c-form-control--disabled--Color: var(--pf-global--disabled-color--300);
  --pf-c-form-control--disabled--BackgroundColor: var(--pf-global--disabled-color--200);
  --pf-c-form-control--readonly--BackgroundColor: var(--pf-global--BackgroundColor--400);
  color: var(--pf-global--Color--100);
}
:where(.pf-theme-dark) .pf-c-form-control::-webkit-calendar-picker-indicator {
  filter: invert(1);
}
:where(.pf-theme-dark) .pf-c-form-control[readonly] {
  border-bottom-color: var(--pf-global--palette--black-700);
}
:where(.pf-theme-dark) .pf-c-form-control:disabled {
  color: var(--pf-global--palette--black-100);
}`;

// src/elements/router/RouteMatch.ts
var RouteMatch = class {
  constructor(route) {
    this.route = route;
    this.arguments = {};
  }
  render() {
    return this.route.render(this.arguments);
  }
  toString() {
    return `<RouteMatch url=${this.fullUrl} route=${this.route} arguments=${JSON.stringify(
      this.arguments
    )}>`;
  }
};
function getURLParam(key, fallback) {
  const params = getURLParams();
  if (key in params) {
    return params[key];
  }
  return fallback;
}
function getURLParams() {
  const params = {};
  if (window.location.hash.includes(ROUTE_SEPARATOR)) {
    const urlParts = window.location.hash.slice(1, Infinity).split(ROUTE_SEPARATOR, 2);
    const rawParams = decodeURIComponent(urlParts[1]);
    try {
      return JSON.parse(rawParams);
    } catch {
      return params;
    }
  }
  return params;
}
function setURLParams(params, replace = true) {
  const paramsString = JSON.stringify(params);
  const currentUrl = window.location.hash.slice(1, Infinity).split(ROUTE_SEPARATOR)[0];
  const newUrl = `#${currentUrl};${encodeURIComponent(paramsString)}`;
  if (replace) {
    history.replaceState(void 0, "", newUrl);
  } else {
    history.pushState(void 0, "", newUrl);
  }
}
function updateURLParams(params, replace = true) {
  const currentParams = getURLParams();
  for (const key in params) {
    currentParams[key] = params[key];
  }
  setURLParams(currentParams, replace);
}

// src/elements/buttons/SpinnerButton/ak-spinner-button.ts
var SpinnerButton = class extends BaseTaskButton {
};
__decorateClass([
  n({ type: Object, attribute: false })
], SpinnerButton.prototype, "callAction", 2);
SpinnerButton = __decorateClass([
  t("ak-spinner-button")
], SpinnerButton);

// node_modules/@patternfly/patternfly/components/Chip/chip.css
var chip_default = '.pf-c-chip {\n  --pf-global--Color--100: var(--pf-global--Color--dark-100);\n  --pf-global--Color--200: var(--pf-global--Color--dark-200);\n  --pf-global--BorderColor--100: var(--pf-global--BorderColor--dark-100);\n  --pf-global--primary-color--100: var(--pf-global--primary-color--dark-100);\n  --pf-global--link--Color: var(--pf-global--link--Color--dark);\n  --pf-global--link--Color--hover: var(--pf-global--link--Color--dark--hover);\n  --pf-global--BackgroundColor--100: var(--pf-global--BackgroundColor--light-100);\n}\n\n.pf-c-chip {\n  --pf-c-chip--PaddingTop: var(--pf-global--spacer--xs);\n  --pf-c-chip--PaddingRight: var(--pf-global--spacer--sm);\n  --pf-c-chip--PaddingBottom: var(--pf-global--spacer--xs);\n  --pf-c-chip--PaddingLeft: var(--pf-global--spacer--sm);\n  --pf-c-chip--BackgroundColor: var(--pf-global--Color--light-100);\n  --pf-c-chip--BorderRadius: var(--pf-global--BorderRadius--sm);\n  --pf-c-chip--before--BorderColor: var(--pf-global--BorderColor--300);\n  --pf-c-chip--before--BorderWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-chip--before--BorderRadius: var(--pf-c-chip--BorderRadius);\n  --pf-c-chip--m-overflow__text--Color: var(--pf-global--primary-color--100);\n  --pf-c-chip--m-draggable--BackgroundColor: var(--pf-global--BackgroundColor--200);\n  --pf-c-chip--m-draggable--BoxShadow: var(--pf-global--BoxShadow--sm);\n  --pf-c-chip--m-draggable__icon--FontSize: var(--pf-global--icon--FontSize--sm);\n  --pf-c-chip__text--FontSize: var(--pf-global--FontSize--xs);\n  --pf-c-chip__text--Color: var(--pf-global--Color--100);\n  --pf-c-chip__text--MaxWidth: 16ch;\n  --pf-c-chip__c-button--PaddingTop: var(--pf-global--spacer--xs);\n  --pf-c-chip__c-button--PaddingRight: var(--pf-global--spacer--sm);\n  --pf-c-chip__c-button--PaddingBottom: var(--pf-global--spacer--xs);\n  --pf-c-chip__c-button--PaddingLeft: var(--pf-global--spacer--sm);\n  --pf-c-chip__c-button--MarginTop: calc(var(--pf-c-chip--PaddingTop) * -1);\n  --pf-c-chip__c-button--MarginRight: calc(var(--pf-c-chip--PaddingRight) / 2 * -1);\n  --pf-c-chip__c-button--MarginBottom: calc(var(--pf-c-chip--PaddingBottom) * -1);\n  --pf-c-chip__c-button--FontSize: var(--pf-global--FontSize--xs);\n  --pf-c-chip__c-badge--MarginLeft: var(--pf-global--spacer--xs);\n  --pf-c-chip__icon--MarginLeft: var(--pf-global--spacer--sm);\n  color: var(--pf-global--Color--100);\n  position: relative;\n  display: inline-flex;\n  align-items: center;\n  min-width: 0;\n  padding: var(--pf-c-chip--PaddingTop) var(--pf-c-chip--PaddingRight) var(--pf-c-chip--PaddingBottom) var(--pf-c-chip--PaddingLeft);\n  list-style: none;\n  background-color: var(--pf-c-chip--BackgroundColor);\n  border-radius: var(--pf-c-chip--BorderRadius);\n}\n.pf-c-chip::before {\n  position: absolute;\n  top: 0;\n  right: 0;\n  bottom: 0;\n  left: 0;\n  content: "";\n  border: var(--pf-c-chip--before--BorderWidth) solid var(--pf-c-chip--before--BorderColor);\n  border-radius: var(--pf-c-chip--before--BorderRadius);\n}\n.pf-c-chip.pf-m-overflow {\n  border: 0;\n}\n.pf-c-chip.pf-m-overflow .pf-c-chip__text {\n  color: var(--pf-c-chip--m-overflow__text--Color);\n}\n.pf-c-chip.pf-m-draggable {\n  --pf-c-chip--BackgroundColor: var(--pf-c-chip--m-draggable--BackgroundColor);\n  box-shadow: var(--pf-c-chip--m-draggable--BoxShadow);\n}\n.pf-c-chip.pf-m-draggable .pf-c-chip__icon {\n  font-size: var(--pf-c-chip--m-draggable__icon--FontSize);\n}\n.pf-c-chip .pf-c-button {\n  --pf-c-button--PaddingTop: var(--pf-c-chip__c-button--PaddingTop);\n  --pf-c-button--PaddingRight: var(--pf-c-chip__c-button--PaddingRight);\n  --pf-c-button--PaddingBottom: var(--pf-c-chip__c-button--PaddingBottom);\n  --pf-c-button--PaddingLeft: var(--pf-c-chip__c-button--PaddingLeft);\n  --pf-c-button--FontSize: var(--pf-c-chip__c-button--FontSize);\n  margin-top: var(--pf-c-chip__c-button--MarginTop);\n  margin-right: var(--pf-c-chip__c-button--MarginRight);\n  margin-bottom: var(--pf-c-chip__c-button--MarginBottom);\n}\n.pf-c-chip .pf-c-badge {\n  margin-left: var(--pf-c-chip__c-badge--MarginLeft);\n}\n\n.pf-c-chip__text {\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  position: relative;\n  max-width: var(--pf-c-chip__text--MaxWidth);\n  font-size: var(--pf-c-chip__text--FontSize);\n  color: var(--pf-c-chip__text--Color);\n}\n\n.pf-c-chip__icon + .pf-c-chip__text,\n.pf-c-chip__text + .pf-c-chip__icon {\n  margin-left: var(--pf-c-chip__icon--MarginLeft);\n}\n\n:where(.pf-theme-dark) .pf-c-chip {\n  --pf-c-chip--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-chip--before--BorderColor: var(--pf-global--BorderColor--100);\n  --pf-c-chip--m-draggable--BackgroundColor: var(--pf-global--palette--black-600);\n}';

// src/elements/chips/Chip.ts
var Chip = class extends AKElement {
  constructor() {
    super(...arguments);
    this.removable = false;
  }
  static get styles() {
    return [patternfly_base_default, button_default, chip_default];
  }
  render() {
    return ke`<li class="pf-c-chip-group__list-item">
            <div class="pf-c-chip">
                <span class="pf-c-chip__text">
                    <slot></slot>
                </span>
                ${this.removable ? ke`<button
                          class="pf-c-button pf-m-plain"
                          type="button"
                          @click=${() => {
      this.dispatchEvent(
        new CustomEvent("remove", {
          bubbles: true,
          composed: true
        })
      );
    }}
                      >
                          <pf-tooltip position="top" content=${msg("Remove item")}>
                              <i class="fas fa-times" aria-hidden="true"></i>
                          </pf-tooltip>
                      </button>` : ke``}
            </div>
        </li>`;
  }
};
__decorateClass([
  n()
], Chip.prototype, "value", 2);
__decorateClass([
  n({ type: Boolean })
], Chip.prototype, "removable", 2);
Chip = __decorateClass([
  t("ak-chip")
], Chip);

// node_modules/@patternfly/patternfly/components/ChipGroup/chip-group.css
var chip_group_default = ".pf-c-chip-group {\n  --pf-global--Color--100: var(--pf-global--Color--dark-100);\n  --pf-global--Color--200: var(--pf-global--Color--dark-200);\n  --pf-global--BorderColor--100: var(--pf-global--BorderColor--dark-100);\n  --pf-global--primary-color--100: var(--pf-global--primary-color--dark-100);\n  --pf-global--link--Color: var(--pf-global--link--Color--dark);\n  --pf-global--link--Color--hover: var(--pf-global--link--Color--dark--hover);\n  --pf-global--BackgroundColor--100: var(--pf-global--BackgroundColor--light-100);\n}\n\n.pf-c-chip-group {\n  color: var(--pf-global--Color--100);\n  --pf-c-chip-group__list--MarginBottom: calc(var(--pf-global--spacer--xs) * -1);\n  --pf-c-chip-group__list--MarginRight: calc(var(--pf-global--spacer--xs) * -1);\n  --pf-c-chip-group--m-category--PaddingTop: var(--pf-global--spacer--xs);\n  --pf-c-chip-group--m-category--PaddingRight: var(--pf-global--spacer--xs);\n  --pf-c-chip-group--m-category--PaddingBottom: var(--pf-global--spacer--xs);\n  --pf-c-chip-group--m-category--PaddingLeft: var(--pf-global--spacer--sm);\n  --pf-c-chip-group--m-category--BorderRadius: var(--pf-global--BorderRadius--sm);\n  --pf-c-chip-group--m-category--BackgroundColor: var(--pf-global--BackgroundColor--200);\n  --pf-c-chip-group__label--MarginRight: var(--pf-global--spacer--sm);\n  --pf-c-chip-group__label--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-chip-group__label--MaxWidth: 18ch;\n  --pf-c-chip-group__close--MarginTop: calc(var(--pf-global--spacer--xs) * -1);\n  --pf-c-chip-group__close--MarginBottom: calc(var(--pf-global--spacer--xs) * -1);\n  --pf-c-chip-group__list-item--MarginRight: var(--pf-global--spacer--xs);\n  --pf-c-chip-group__list-item--MarginBottom: var(--pf-global--spacer--xs);\n  max-width: 100%;\n}\n.pf-c-chip-group.pf-m-category {\n  padding-top: var(--pf-c-chip-group--m-category--PaddingTop);\n  padding-right: var(--pf-c-chip-group--m-category--PaddingRight);\n  padding-bottom: var(--pf-c-chip-group--m-category--PaddingBottom);\n  padding-left: var(--pf-c-chip-group--m-category--PaddingLeft);\n  background-color: var(--pf-c-chip-group--m-category--BackgroundColor);\n  border-radius: var(--pf-c-chip-group--m-category--BorderRadius);\n}\n\n.pf-c-chip-group__main {\n  display: flex;\n  flex: 1;\n  flex-wrap: wrap;\n  align-items: baseline;\n  min-width: 0;\n}\n\n.pf-c-chip-group__list {\n  margin-right: var(--pf-c-chip-group__list--MarginRight);\n  margin-bottom: var(--pf-c-chip-group__list--MarginBottom);\n}\n\n.pf-c-chip-group,\n.pf-c-chip-group__list {\n  display: inline-flex;\n  flex-wrap: wrap;\n  align-items: center;\n  min-width: 0;\n}\n\n.pf-c-chip-group__list-item {\n  display: inline-flex;\n  min-width: 0;\n  margin-right: var(--pf-c-chip-group__list-item--MarginRight);\n  margin-bottom: var(--pf-c-chip-group__list-item--MarginBottom);\n}\n\n.pf-c-chip-group__label {\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  max-width: var(--pf-c-chip-group__label--MaxWidth);\n  margin-right: var(--pf-c-chip-group__label--MarginRight);\n  font-size: var(--pf-c-chip-group__label--FontSize);\n}\n\n.pf-c-chip-group__close {\n  display: flex;\n  align-self: flex-start;\n  margin-top: var(--pf-c-chip-group__close--MarginTop);\n  margin-bottom: var(--pf-c-chip-group__close--MarginBottom);\n}";

// src/elements/chips/ChipGroup.ts
var ChipGroup = class extends AKElement {
  static get styles() {
    return [
      patternfly_base_default,
      chip_default,
      chip_group_default,
      button_default,
      i`
                ::slotted(*) {
                    margin: 0 2px;
                }
                .pf-c-chip-group {
                    margin-bottom: 8px;
                }
            `
    ];
  }
  set value(v) {
    return;
  }
  get value() {
    const values = [];
    this.querySelectorAll("ak-chip").forEach((chip) => {
      values.push(chip.value);
    });
    return values;
  }
  render() {
    return ke`<div class="pf-c-chip-group">
            <div class="pf-c-chip-group__main">
                <ul class="pf-c-chip-group__list" role="list">
                    <slot></slot>
                </ul>
            </div>
        </div>`;
  }
};
__decorateClass([
  n()
], ChipGroup.prototype, "name", 2);
ChipGroup = __decorateClass([
  t("ak-chip-group")
], ChipGroup);

// node_modules/@patternfly/patternfly/components/Pagination/pagination.css
var pagination_default = ".pf-c-pagination__nav-page-select .pf-c-form-control {\n  appearance: textfield;\n}\n.pf-c-pagination__nav-page-select .pf-c-form-control::-webkit-inner-spin-button, .pf-c-pagination__nav-page-select .pf-c-form-control::-webkit-outer-spin-button {\n  appearance: none;\n  margin: 0;\n}\n\n.pf-c-pagination {\n  --pf-c-pagination--inset: 0;\n  --pf-c-pagination--PaddingRight: var(--pf-c-pagination--inset);\n  --pf-c-pagination--PaddingLeft: var(--pf-c-pagination--inset);\n  --pf-c-pagination--m-page-insets--inset: var(--pf-global--spacer--md);\n  --pf-c-pagination--m-page-insets--xl--inset: var(--pf-global--spacer--lg);\n  --pf-c-pagination--child--MarginRight: var(--pf-global--spacer--lg);\n  --pf-c-pagination--m-bottom--child--MarginRight: 0;\n  --pf-c-pagination--m-bottom--child--md--MarginRight: var(--pf-global--spacer--lg);\n  --pf-c-pagination--m-compact--child--MarginRight: var(--pf-global--spacer--sm);\n  --pf-c-pagination--c-options-menu__toggle--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-pagination__nav--Display: none;\n  --pf-c-pagination__nav--Visibility: hidden;\n  --pf-c-pagination--m-display-summary__nav--Display: none;\n  --pf-c-pagination--m-display-summary__nav--Visibility: hidden;\n  --pf-c-pagination--m-display-full__nav--Display: inline-flex;\n  --pf-c-pagination--m-display-full__nav--Visibility: visible;\n  --pf-c-pagination__nav-control--c-button--PaddingRight: var(--pf-global--spacer--sm);\n  --pf-c-pagination__nav-control--c-button--PaddingLeft: var(--pf-global--spacer--sm);\n  --pf-c-pagination__nav-control--c-button--FontSize: var(--pf-global--FontSize--md);\n  --pf-c-pagination--m-bottom__nav-control--c-button--OutlineOffset: calc(var(--pf-global--spacer--xs) * -1);\n  --pf-c-pagination--m-bottom__nav-control--c-button--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-pagination--m-bottom__nav-control--c-button--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-pagination--m-bottom__nav-control--c-button--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-pagination--m-bottom__nav-control--c-button--md--PaddingTop: var(--pf-global--spacer--form-element);\n  --pf-c-pagination--m-bottom__nav-control--c-button--md--PaddingRight: var(--pf-global--spacer--sm);\n  --pf-c-pagination--m-bottom__nav-control--c-button--md--PaddingBottom: var(--pf-global--spacer--form-element);\n  --pf-c-pagination--m-bottom__nav-control--c-button--md--PaddingLeft: var(--pf-global--spacer--sm);\n  --pf-c-pagination--m-compact__nav-control--nav-control--MarginLeft: var(--pf-global--spacer--md);\n  --pf-c-pagination__nav-page-select--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-pagination__nav-page-select--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-pagination__nav-page-select--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-pagination__nav-page-select--child--MarginRight: var(--pf-global--spacer--xs);\n  --pf-c-pagination__nav-page-select--c-form-control--width-base: calc(var(--pf-global--spacer--sm) * 2 + var(--pf-global--BorderWidth--sm) * 2);\n  --pf-c-pagination__nav-page-select--c-form-control--width-chars: 2;\n  --pf-c-pagination__nav-page-select--c-form-control--Width: calc(var(--pf-c-pagination__nav-page-select--c-form-control--width-base) + (var(--pf-c-pagination__nav-page-select--c-form-control--width-chars) * 1ch));\n  --pf-c-pagination__total-items--Display: block;\n  --pf-c-pagination__total-items--Visibility: visible;\n  --pf-c-pagination--m-display-summary__total-items--Display: block;\n  --pf-c-pagination--m-display-summary__total-items--Visibility: visible;\n  --pf-c-pagination--m-display-full__total-items--Display: none;\n  --pf-c-pagination--m-display-full__total-items--Visibility: hidden;\n  --pf-c-pagination--m-sticky--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-pagination--m-sticky--BoxShadow: var(--pf-global--BoxShadow--sm-bottom);\n  --pf-c-pagination--m-sticky--md--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-pagination--m-sticky--md--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-pagination--m-sticky--md--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-pagination--m-sticky--md--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-pagination--m-sticky--ZIndex: var(--pf-global--ZIndex--xs);\n  --pf-c-pagination--m-sticky--Top: 0;\n  --pf-c-pagination--m-bottom--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-pagination--m-bottom--BoxShadow: var(--pf-global--BoxShadow--sm-top);\n  --pf-c-pagination--m-bottom--Bottom: 0;\n  --pf-c-pagination--m-bottom--md--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-pagination--m-bottom--md--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-pagination--m-bottom--md--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-pagination--m-bottom--md--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-pagination--m-bottom--xl--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-pagination--m-bottom--xl--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-pagination--m-bottom--m-sticky--BoxShadow: var(--pf-global--BoxShadow--sm-top);\n  --pf-c-pagination--c-options-menu--Display: none;\n  --pf-c-pagination--c-options-menu--Visibility: hidden;\n  --pf-c-pagination--m-display-summary--c-options-menu--Display: none;\n  --pf-c-pagination--m-display-summary--c-options-menu--Visibility: hidden;\n  --pf-c-pagination--m-display-full--c-options-menu--Display: inline-flex;\n  --pf-c-pagination--m-display-full--c-options-menu--Visibility: visible;\n  display: flex;\n  flex-wrap: wrap;\n  align-items: center;\n  justify-content: flex-end;\n  padding-right: var(--pf-c-pagination--PaddingRight);\n  padding-left: var(--pf-c-pagination--PaddingLeft);\n}\n@media screen and (min-width: 768px) {\n  .pf-c-pagination {\n    --pf-c-pagination--m-bottom__nav-control--c-button--PaddingTop: var(--pf-c-pagination--m-bottom__nav-control--c-button--md--PaddingTop);\n    --pf-c-pagination--m-bottom__nav-control--c-button--PaddingRight: var(--pf-c-pagination--m-bottom__nav-control--c-button--md--PaddingRight);\n    --pf-c-pagination--m-bottom__nav-control--c-button--PaddingBottom: var(--pf-c-pagination--m-bottom__nav-control--c-button--md--PaddingBottom);\n    --pf-c-pagination--m-bottom__nav-control--c-button--PaddingLeft: var(--pf-c-pagination--m-bottom__nav-control--c-button--md--PaddingLeft);\n    --pf-c-pagination--m-bottom--child--MarginRight: var(--pf-c-pagination--m-bottom--child--md--MarginRight);\n    --pf-c-pagination--m-bottom__nav-control--c-button--OutlineOffset: 0;\n    --pf-c-pagination--m-bottom--BoxShadow: none;\n    --pf-c-pagination--c-options-menu--Display: inline-flex;\n    --pf-c-pagination--c-options-menu--Visibility: visible;\n    --pf-c-pagination__nav--Display: inline-flex;\n    --pf-c-pagination__nav--Visibility: visible;\n    --pf-c-pagination__total-items--Display: none;\n    --pf-c-pagination__total-items--Visibility: hidden;\n  }\n}\n@media screen and (min-width: 1200px) {\n  .pf-c-pagination {\n    --pf-c-pagination--m-bottom--md--PaddingRight: var(--pf-c-pagination--m-bottom--xl--PaddingRight);\n    --pf-c-pagination--m-bottom--md--PaddingLeft: var(--pf-c-pagination--m-bottom--xl--PaddingLeft);\n    --pf-c-pagination__scroll-button--Width: var(--pf-c-pagination__scroll-button--xl--Width);\n    --pf-c-pagination--m-page-insets--inset: var(--pf-c-pagination--m-page-insets--xl--inset);\n  }\n}\n.pf-c-pagination > *:not(:last-child):not(.pf-c-pagination__total-items) {\n  margin-right: var(--pf-c-pagination--child--MarginRight);\n}\n.pf-c-pagination .pf-c-options-menu {\n  display: var(--pf-c-pagination--c-options-menu--Display);\n  visibility: var(--pf-c-pagination--c-options-menu--Visibility);\n}\n.pf-c-pagination.pf-m-bottom {\n  --pf-c-pagination--child--MarginRight: var(--pf-c-pagination--m-bottom--child--MarginRight);\n  --pf-c-pagination__nav-control--c-button--PaddingRight: var(--pf-c-pagination--m-bottom__nav-control--c-button--PaddingRight);\n  --pf-c-pagination__nav-control--c-button--PaddingLeft: var(--pf-c-pagination--m-bottom__nav-control--c-button--PaddingRight);\n  --pf-c-pagination--m-sticky--BoxShadow: var(--pf-c-pagination--m-bottom--m-sticky--BoxShadow);\n  --pf-c-pagination--m-sticky--Top: auto;\n  position: sticky;\n  bottom: var(--pf-c-pagination--m-bottom--Bottom);\n  justify-content: center;\n  background-color: var(--pf-c-pagination--m-bottom--BackgroundColor);\n  box-shadow: var(--pf-c-pagination--m-bottom--BoxShadow);\n}\n.pf-c-pagination.pf-m-bottom .pf-c-pagination__nav-control .pf-c-button {\n  --pf-c-button--PaddingTop: var(--pf-c-pagination--m-bottom__nav-control--c-button--PaddingTop);\n  --pf-c-button--PaddingBottom: var(--pf-c-pagination--m-bottom__nav-control--c-button--PaddingBottom);\n  outline-offset: var(--pf-c-pagination--m-bottom__nav-control--c-button--OutlineOffset);\n}\n.pf-c-pagination.pf-m-bottom.pf-m-static {\n  --pf-c-pagination--m-bottom--MarginTop: 0;\n  --pf-c-pagination--m-bottom--BorderTopWidth: 0;\n  position: relative;\n  box-shadow: none;\n}\n.pf-c-pagination.pf-m-bottom .pf-c-pagination__nav-control.pf-m-first,\n.pf-c-pagination.pf-m-bottom .pf-c-pagination__nav-control.pf-m-last,\n.pf-c-pagination.pf-m-bottom .pf-c-pagination__nav-page-select {\n  display: none;\n  visibility: hidden;\n}\n.pf-c-pagination.pf-m-bottom .pf-c-options-menu {\n  position: absolute;\n  display: block;\n  visibility: visible;\n}\n.pf-c-pagination.pf-m-bottom .pf-c-pagination__nav {\n  display: flex;\n  flex-basis: 100%;\n  justify-content: space-between;\n  visibility: visible;\n}\n@media screen and (min-width: 768px) {\n  .pf-c-pagination.pf-m-bottom {\n    --pf-c-pagination--m-bottom--BorderTopWidth: 0;\n    --pf-c-pagination--m-bottom--MarginTop: 0;\n    --pf-c-pagination--m-bottom--Bottom: auto;\n    position: relative;\n    justify-content: flex-end;\n    padding: var(--pf-c-pagination--m-bottom--md--PaddingTop) var(--pf-c-pagination--m-bottom--md--PaddingRight) var(--pf-c-pagination--m-bottom--md--PaddingBottom) var(--pf-c-pagination--m-bottom--md--PaddingLeft);\n  }\n  .pf-c-pagination.pf-m-bottom .pf-c-pagination__nav-control.pf-m-first,\n.pf-c-pagination.pf-m-bottom .pf-c-pagination__nav-control.pf-m-last,\n.pf-c-pagination.pf-m-bottom .pf-c-pagination__nav-page-select {\n    display: block;\n    visibility: visible;\n  }\n  .pf-c-pagination.pf-m-bottom .pf-c-options-menu {\n    position: relative;\n  }\n  .pf-c-pagination.pf-m-bottom .pf-c-pagination__nav {\n    display: inline-flex;\n    flex-basis: auto;\n  }\n}\n.pf-c-pagination.pf-m-sticky {\n  --pf-c-pagination--m-bottom--Bottom: 0;\n  position: sticky;\n  top: var(--pf-c-pagination--m-sticky--Top);\n  z-index: var(--pf-c-pagination--m-sticky--ZIndex);\n  padding-top: var(--pf-c-pagination--m-sticky--PaddingTop);\n  padding-right: var(--pf-c-pagination--m-sticky--PaddingRight);\n  padding-bottom: var(--pf-c-pagination--m-sticky--PaddingBottom);\n  padding-left: var(--pf-c-pagination--m-sticky--PaddingLeft);\n  background-color: var(--pf-c-pagination--m-sticky--BackgroundColor);\n  box-shadow: var(--pf-c-pagination--m-sticky--BoxShadow);\n}\n@media screen and (min-width: 768px) {\n  .pf-c-pagination.pf-m-sticky {\n    padding: var(--pf-c-pagination--m-sticky--md--PaddingTop) var(--pf-c-pagination--m-sticky--md--PaddingRight) var(--pf-c-pagination--m-sticky--md--PaddingBottom) var(--pf-c-pagination--m-sticky--md--PaddingLeft);\n  }\n}\n.pf-c-pagination .pf-c-options-menu__toggle {\n  font-size: var(--pf-c-pagination--c-options-menu__toggle--FontSize);\n}\n.pf-c-pagination.pf-m-compact {\n  --pf-c-pagination--child--MarginRight: var(--pf-c-pagination--m-compact--child--MarginRight);\n}\n.pf-c-pagination.pf-m-page-insets {\n  --pf-c-pagination--inset: var(--pf-c-pagination--m-page-insets--inset);\n}\n\n.pf-c-pagination__nav {\n  display: var(--pf-c-pagination__nav--Display);\n  justify-content: flex-end;\n  visibility: var(--pf-c-pagination__nav--Visibility);\n}\n\n.pf-c-pagination__nav-control .pf-c-button {\n  padding-right: var(--pf-c-pagination__nav-control--c-button--PaddingRight);\n  padding-left: var(--pf-c-pagination__nav-control--c-button--PaddingLeft);\n  font-size: var(--pf-c-pagination__nav-control--c-button--FontSize);\n}\n.pf-c-pagination.pf-m-compact .pf-c-pagination__nav-control + .pf-c-pagination__nav-control {\n  margin-left: var(--pf-c-pagination--m-compact__nav-control--nav-control--MarginLeft);\n}\n\n.pf-c-pagination__nav-page-select {\n  display: flex;\n  align-items: center;\n  padding-right: var(--pf-c-pagination__nav-page-select--PaddingRight);\n  padding-left: var(--pf-c-pagination__nav-page-select--PaddingLeft);\n}\n.pf-c-pagination__nav-page-select > * {\n  font-size: var(--pf-c-pagination__nav-page-select--FontSize);\n  white-space: nowrap;\n}\n.pf-c-pagination__nav-page-select > *:not(:last-child) {\n  margin-right: var(--pf-c-pagination__nav-page-select--child--MarginRight);\n}\n.pf-c-pagination__nav-page-select .pf-c-form-control {\n  width: var(--pf-c-pagination__nav-page-select--c-form-control--Width);\n}\n\n.pf-c-pagination__total-items {\n  display: var(--pf-c-pagination__total-items--Display);\n  visibility: var(--pf-c-pagination__total-items--Visibility);\n}\n\n.pf-c-pagination.pf-m-display-summary {\n  --pf-c-pagination__nav--Display: var(--pf-c-pagination--m-display-summary__nav--Display);\n  --pf-c-pagination__nav--Visibility: var(--pf-c-pagination--m-display-summary__nav--Visibility);\n  --pf-c-pagination--c-options-menu--Display: var(--pf-c-pagination--m-display-summary--c-options-menu--Display);\n  --pf-c-pagination--c-options-menu--Visibility: var(--pf-c-pagination--m-display-summary--c-options-menu--Visibility);\n  --pf-c-pagination__total-items--Display: var(--pf-c-pagination--m-display-summary__total-items--Display);\n  --pf-c-pagination__total-items--Visibility: var(--pf-c-pagination--m-display-summary__total-items--Visibility);\n}\n.pf-c-pagination.pf-m-display-full {\n  --pf-c-pagination__nav--Display: var(--pf-c-pagination--m-display-full__nav--Display);\n  --pf-c-pagination__nav--Visibility: var(--pf-c-pagination--m-display-full__nav--Visibility);\n  --pf-c-pagination--c-options-menu--Display: var(--pf-c-pagination--m-display-full--c-options-menu--Display);\n  --pf-c-pagination--c-options-menu--Visibility: var(--pf-c-pagination--m-display-full--c-options-menu--Visibility);\n  --pf-c-pagination__total-items--Display: var(--pf-c-pagination--m-display-full__total-items--Display);\n  --pf-c-pagination__total-items--Visibility: var(--pf-c-pagination--m-display-full__total-items--Visibility);\n}\n.pf-c-pagination.pf-m-inset-none {\n  --pf-c-pagination--inset: 0;\n}\n.pf-c-pagination.pf-m-inset-sm {\n  --pf-c-pagination--inset: var(--pf-global--spacer--sm);\n}\n.pf-c-pagination.pf-m-inset-md {\n  --pf-c-pagination--inset: var(--pf-global--spacer--md);\n}\n.pf-c-pagination.pf-m-inset-lg {\n  --pf-c-pagination--inset: var(--pf-global--spacer--lg);\n}\n.pf-c-pagination.pf-m-inset-xl {\n  --pf-c-pagination--inset: var(--pf-global--spacer--xl);\n}\n.pf-c-pagination.pf-m-inset-2xl {\n  --pf-c-pagination--inset: var(--pf-global--spacer--2xl);\n}\n@media (min-width: 576px) {\n  .pf-c-pagination.pf-m-display-summary-on-sm {\n    --pf-c-pagination__nav--Display: var(--pf-c-pagination--m-display-summary__nav--Display);\n    --pf-c-pagination__nav--Visibility: var(--pf-c-pagination--m-display-summary__nav--Visibility);\n    --pf-c-pagination--c-options-menu--Display: var(--pf-c-pagination--m-display-summary--c-options-menu--Display);\n    --pf-c-pagination--c-options-menu--Visibility: var(--pf-c-pagination--m-display-summary--c-options-menu--Visibility);\n    --pf-c-pagination__total-items--Display: var(--pf-c-pagination--m-display-summary__total-items--Display);\n    --pf-c-pagination__total-items--Visibility: var(--pf-c-pagination--m-display-summary__total-items--Visibility);\n  }\n  .pf-c-pagination.pf-m-display-full-on-sm {\n    --pf-c-pagination__nav--Display: var(--pf-c-pagination--m-display-full__nav--Display);\n    --pf-c-pagination__nav--Visibility: var(--pf-c-pagination--m-display-full__nav--Visibility);\n    --pf-c-pagination--c-options-menu--Display: var(--pf-c-pagination--m-display-full--c-options-menu--Display);\n    --pf-c-pagination--c-options-menu--Visibility: var(--pf-c-pagination--m-display-full--c-options-menu--Visibility);\n    --pf-c-pagination__total-items--Display: var(--pf-c-pagination--m-display-full__total-items--Display);\n    --pf-c-pagination__total-items--Visibility: var(--pf-c-pagination--m-display-full__total-items--Visibility);\n  }\n  .pf-c-pagination.pf-m-inset-none-on-sm {\n    --pf-c-pagination--inset: 0;\n  }\n  .pf-c-pagination.pf-m-inset-sm-on-sm {\n    --pf-c-pagination--inset: var(--pf-global--spacer--sm);\n  }\n  .pf-c-pagination.pf-m-inset-md-on-sm {\n    --pf-c-pagination--inset: var(--pf-global--spacer--md);\n  }\n  .pf-c-pagination.pf-m-inset-lg-on-sm {\n    --pf-c-pagination--inset: var(--pf-global--spacer--lg);\n  }\n  .pf-c-pagination.pf-m-inset-xl-on-sm {\n    --pf-c-pagination--inset: var(--pf-global--spacer--xl);\n  }\n  .pf-c-pagination.pf-m-inset-2xl-on-sm {\n    --pf-c-pagination--inset: var(--pf-global--spacer--2xl);\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-pagination.pf-m-display-summary-on-md {\n    --pf-c-pagination__nav--Display: var(--pf-c-pagination--m-display-summary__nav--Display);\n    --pf-c-pagination__nav--Visibility: var(--pf-c-pagination--m-display-summary__nav--Visibility);\n    --pf-c-pagination--c-options-menu--Display: var(--pf-c-pagination--m-display-summary--c-options-menu--Display);\n    --pf-c-pagination--c-options-menu--Visibility: var(--pf-c-pagination--m-display-summary--c-options-menu--Visibility);\n    --pf-c-pagination__total-items--Display: var(--pf-c-pagination--m-display-summary__total-items--Display);\n    --pf-c-pagination__total-items--Visibility: var(--pf-c-pagination--m-display-summary__total-items--Visibility);\n  }\n  .pf-c-pagination.pf-m-display-full-on-md {\n    --pf-c-pagination__nav--Display: var(--pf-c-pagination--m-display-full__nav--Display);\n    --pf-c-pagination__nav--Visibility: var(--pf-c-pagination--m-display-full__nav--Visibility);\n    --pf-c-pagination--c-options-menu--Display: var(--pf-c-pagination--m-display-full--c-options-menu--Display);\n    --pf-c-pagination--c-options-menu--Visibility: var(--pf-c-pagination--m-display-full--c-options-menu--Visibility);\n    --pf-c-pagination__total-items--Display: var(--pf-c-pagination--m-display-full__total-items--Display);\n    --pf-c-pagination__total-items--Visibility: var(--pf-c-pagination--m-display-full__total-items--Visibility);\n  }\n  .pf-c-pagination.pf-m-inset-none-on-md {\n    --pf-c-pagination--inset: 0;\n  }\n  .pf-c-pagination.pf-m-inset-sm-on-md {\n    --pf-c-pagination--inset: var(--pf-global--spacer--sm);\n  }\n  .pf-c-pagination.pf-m-inset-md-on-md {\n    --pf-c-pagination--inset: var(--pf-global--spacer--md);\n  }\n  .pf-c-pagination.pf-m-inset-lg-on-md {\n    --pf-c-pagination--inset: var(--pf-global--spacer--lg);\n  }\n  .pf-c-pagination.pf-m-inset-xl-on-md {\n    --pf-c-pagination--inset: var(--pf-global--spacer--xl);\n  }\n  .pf-c-pagination.pf-m-inset-2xl-on-md {\n    --pf-c-pagination--inset: var(--pf-global--spacer--2xl);\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-pagination.pf-m-display-summary-on-lg {\n    --pf-c-pagination__nav--Display: var(--pf-c-pagination--m-display-summary__nav--Display);\n    --pf-c-pagination__nav--Visibility: var(--pf-c-pagination--m-display-summary__nav--Visibility);\n    --pf-c-pagination--c-options-menu--Display: var(--pf-c-pagination--m-display-summary--c-options-menu--Display);\n    --pf-c-pagination--c-options-menu--Visibility: var(--pf-c-pagination--m-display-summary--c-options-menu--Visibility);\n    --pf-c-pagination__total-items--Display: var(--pf-c-pagination--m-display-summary__total-items--Display);\n    --pf-c-pagination__total-items--Visibility: var(--pf-c-pagination--m-display-summary__total-items--Visibility);\n  }\n  .pf-c-pagination.pf-m-display-full-on-lg {\n    --pf-c-pagination__nav--Display: var(--pf-c-pagination--m-display-full__nav--Display);\n    --pf-c-pagination__nav--Visibility: var(--pf-c-pagination--m-display-full__nav--Visibility);\n    --pf-c-pagination--c-options-menu--Display: var(--pf-c-pagination--m-display-full--c-options-menu--Display);\n    --pf-c-pagination--c-options-menu--Visibility: var(--pf-c-pagination--m-display-full--c-options-menu--Visibility);\n    --pf-c-pagination__total-items--Display: var(--pf-c-pagination--m-display-full__total-items--Display);\n    --pf-c-pagination__total-items--Visibility: var(--pf-c-pagination--m-display-full__total-items--Visibility);\n  }\n  .pf-c-pagination.pf-m-inset-none-on-lg {\n    --pf-c-pagination--inset: 0;\n  }\n  .pf-c-pagination.pf-m-inset-sm-on-lg {\n    --pf-c-pagination--inset: var(--pf-global--spacer--sm);\n  }\n  .pf-c-pagination.pf-m-inset-md-on-lg {\n    --pf-c-pagination--inset: var(--pf-global--spacer--md);\n  }\n  .pf-c-pagination.pf-m-inset-lg-on-lg {\n    --pf-c-pagination--inset: var(--pf-global--spacer--lg);\n  }\n  .pf-c-pagination.pf-m-inset-xl-on-lg {\n    --pf-c-pagination--inset: var(--pf-global--spacer--xl);\n  }\n  .pf-c-pagination.pf-m-inset-2xl-on-lg {\n    --pf-c-pagination--inset: var(--pf-global--spacer--2xl);\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-pagination.pf-m-display-summary-on-xl {\n    --pf-c-pagination__nav--Display: var(--pf-c-pagination--m-display-summary__nav--Display);\n    --pf-c-pagination__nav--Visibility: var(--pf-c-pagination--m-display-summary__nav--Visibility);\n    --pf-c-pagination--c-options-menu--Display: var(--pf-c-pagination--m-display-summary--c-options-menu--Display);\n    --pf-c-pagination--c-options-menu--Visibility: var(--pf-c-pagination--m-display-summary--c-options-menu--Visibility);\n    --pf-c-pagination__total-items--Display: var(--pf-c-pagination--m-display-summary__total-items--Display);\n    --pf-c-pagination__total-items--Visibility: var(--pf-c-pagination--m-display-summary__total-items--Visibility);\n  }\n  .pf-c-pagination.pf-m-display-full-on-xl {\n    --pf-c-pagination__nav--Display: var(--pf-c-pagination--m-display-full__nav--Display);\n    --pf-c-pagination__nav--Visibility: var(--pf-c-pagination--m-display-full__nav--Visibility);\n    --pf-c-pagination--c-options-menu--Display: var(--pf-c-pagination--m-display-full--c-options-menu--Display);\n    --pf-c-pagination--c-options-menu--Visibility: var(--pf-c-pagination--m-display-full--c-options-menu--Visibility);\n    --pf-c-pagination__total-items--Display: var(--pf-c-pagination--m-display-full__total-items--Display);\n    --pf-c-pagination__total-items--Visibility: var(--pf-c-pagination--m-display-full__total-items--Visibility);\n  }\n  .pf-c-pagination.pf-m-inset-none-on-xl {\n    --pf-c-pagination--inset: 0;\n  }\n  .pf-c-pagination.pf-m-inset-sm-on-xl {\n    --pf-c-pagination--inset: var(--pf-global--spacer--sm);\n  }\n  .pf-c-pagination.pf-m-inset-md-on-xl {\n    --pf-c-pagination--inset: var(--pf-global--spacer--md);\n  }\n  .pf-c-pagination.pf-m-inset-lg-on-xl {\n    --pf-c-pagination--inset: var(--pf-global--spacer--lg);\n  }\n  .pf-c-pagination.pf-m-inset-xl-on-xl {\n    --pf-c-pagination--inset: var(--pf-global--spacer--xl);\n  }\n  .pf-c-pagination.pf-m-inset-2xl-on-xl {\n    --pf-c-pagination--inset: var(--pf-global--spacer--2xl);\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-pagination.pf-m-display-summary-on-2xl {\n    --pf-c-pagination__nav--Display: var(--pf-c-pagination--m-display-summary__nav--Display);\n    --pf-c-pagination__nav--Visibility: var(--pf-c-pagination--m-display-summary__nav--Visibility);\n    --pf-c-pagination--c-options-menu--Display: var(--pf-c-pagination--m-display-summary--c-options-menu--Display);\n    --pf-c-pagination--c-options-menu--Visibility: var(--pf-c-pagination--m-display-summary--c-options-menu--Visibility);\n    --pf-c-pagination__total-items--Display: var(--pf-c-pagination--m-display-summary__total-items--Display);\n    --pf-c-pagination__total-items--Visibility: var(--pf-c-pagination--m-display-summary__total-items--Visibility);\n  }\n  .pf-c-pagination.pf-m-display-full-on-2xl {\n    --pf-c-pagination__nav--Display: var(--pf-c-pagination--m-display-full__nav--Display);\n    --pf-c-pagination__nav--Visibility: var(--pf-c-pagination--m-display-full__nav--Visibility);\n    --pf-c-pagination--c-options-menu--Display: var(--pf-c-pagination--m-display-full--c-options-menu--Display);\n    --pf-c-pagination--c-options-menu--Visibility: var(--pf-c-pagination--m-display-full--c-options-menu--Visibility);\n    --pf-c-pagination__total-items--Display: var(--pf-c-pagination--m-display-full__total-items--Display);\n    --pf-c-pagination__total-items--Visibility: var(--pf-c-pagination--m-display-full__total-items--Visibility);\n  }\n  .pf-c-pagination.pf-m-inset-none-on-2xl {\n    --pf-c-pagination--inset: 0;\n  }\n  .pf-c-pagination.pf-m-inset-sm-on-2xl {\n    --pf-c-pagination--inset: var(--pf-global--spacer--sm);\n  }\n  .pf-c-pagination.pf-m-inset-md-on-2xl {\n    --pf-c-pagination--inset: var(--pf-global--spacer--md);\n  }\n  .pf-c-pagination.pf-m-inset-lg-on-2xl {\n    --pf-c-pagination--inset: var(--pf-global--spacer--lg);\n  }\n  .pf-c-pagination.pf-m-inset-xl-on-2xl {\n    --pf-c-pagination--inset: var(--pf-global--spacer--xl);\n  }\n  .pf-c-pagination.pf-m-inset-2xl-on-2xl {\n    --pf-c-pagination--inset: var(--pf-global--spacer--2xl);\n  }\n}\n\n:where(.pf-theme-dark) .pf-c-pagination {\n  --pf-c-pagination--m-sticky--BackgroundColor: var(--pf-global--BackgroundColor--300);\n}";

// src/elements/table/TablePagination.ts
var TablePagination = class extends AKElement {
  constructor() {
    super(...arguments);
    this.pageChangeHandler = () => {
      return;
    };
  }
  static get styles() {
    return [
      patternfly_base_default,
      button_default,
      pagination_default,
      i`
                :host([theme="dark"]) .pf-c-pagination__nav-control .pf-c-button {
                    color: var(--pf-c-button--m-plain--disabled--Color);
                    --pf-c-button--disabled--Color: var(--pf-c-button--m-plain--Color);
                }
                :host([theme="dark"]) .pf-c-pagination__nav-control .pf-c-button:disabled {
                    color: var(--pf-c-button--disabled--Color);
                }
            `
    ];
  }
  render() {
    if (!this.pages) {
      return ke``;
    }
    return ke` <div class="pf-c-pagination pf-m-compact pf-m-hidden pf-m-visible-on-md">
            <div class="pf-c-pagination pf-m-compact pf-m-compact pf-m-hidden pf-m-visible-on-md">
                <div class="pf-c-options-menu">
                    <div class="pf-c-options-menu__toggle pf-m-text pf-m-plain">
                        <span class="pf-c-options-menu__toggle-text">
                            ${msg(
      str`${this.pages?.startIndex} - ${this.pages?.endIndex} of ${this.pages?.count}`
    )}
                        </span>
                    </div>
                </div>
                <nav class="pf-c-pagination__nav" aria-label=${msg("Pagination")}>
                    <div class="pf-c-pagination__nav-control pf-m-prev">
                        <button
                            class="pf-c-button pf-m-plain"
                            @click=${() => {
      this.pageChangeHandler(this.pages?.previous || 0);
    }}
                            ?disabled="${(this.pages?.previous || 0) < 1}"
                            aria-label="${msg("Go to previous page")}"
                        >
                            <i class="fas fa-angle-left" aria-hidden="true"></i>
                        </button>
                    </div>
                    <div class="pf-c-pagination__nav-control pf-m-next">
                        <button
                            class="pf-c-button pf-m-plain"
                            @click=${() => {
      this.pageChangeHandler(this.pages?.next || 0);
    }}
                            ?disabled="${(this.pages?.next || 0) <= 0}"
                            aria-label="${msg("Go to next page")}"
                        >
                            <i class="fas fa-angle-right" aria-hidden="true"></i>
                        </button>
                    </div>
                </nav>
            </div>
        </div>`;
  }
};
__decorateClass([
  n({ attribute: false })
], TablePagination.prototype, "pages", 2);
__decorateClass([
  n({ attribute: false })
], TablePagination.prototype, "pageChangeHandler", 2);
TablePagination = __decorateClass([
  t("ak-table-pagination")
], TablePagination);

// node_modules/@patternfly/patternfly/components/InputGroup/input-group.css
var input_group_default = ".pf-c-input-group {\n  --pf-global--Color--100: var(--pf-global--Color--dark-100);\n  --pf-global--Color--200: var(--pf-global--Color--dark-200);\n  --pf-global--BorderColor--100: var(--pf-global--BorderColor--dark-100);\n  --pf-global--primary-color--100: var(--pf-global--primary-color--dark-100);\n  --pf-global--link--Color: var(--pf-global--link--Color--dark);\n  --pf-global--link--Color--hover: var(--pf-global--link--Color--dark--hover);\n  --pf-global--BackgroundColor--100: var(--pf-global--BackgroundColor--light-100);\n}\n\n.pf-c-input-group {\n  --pf-c-input-group--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-input-group--child--ZIndex: var(--pf-global--ZIndex--xs);\n  --pf-c-input-group__text--FontSize: var(--pf-global--FontSize--md);\n  --pf-c-input-group__text--PaddingRight: var(--pf-global--spacer--sm);\n  --pf-c-input-group__text--PaddingLeft: var(--pf-global--spacer--sm);\n  --pf-c-input-group__text--Color: var(--pf-global--Color--dark-200);\n  --pf-c-input-group__text--BorderWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-input-group__text--BorderTopColor: var(--pf-global--BorderColor--300);\n  --pf-c-input-group__text--BorderRightColor: var(--pf-global--BorderColor--300);\n  --pf-c-input-group__text--BorderBottomColor: var(--pf-global--BorderColor--200);\n  --pf-c-input-group__text--BorderLeftColor: var(--pf-global--BorderColor--300);\n  --pf-c-input-group__text--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-input-group__textarea--MinHeight: var(--pf-global--spacer--xl);\n  --pf-c-input-group__text--m-disabled--Color: var(--pf-global--disabled-color--100);\n  --pf-c-input-group__text--m-disabled--BackgroundColor: var(--pf-global--disabled-color--300);\n  --pf-c-input-group__text--m-disabled--BorderBottomColor: transparent;\n  --pf-c-input-group--c-form-control--invalid--ZIndex: var(--pf-global--ZIndex--xs);\n  --pf-c-input-group--c-form-control--MarginRight: 0;\n  color: var(--pf-global--Color--100);\n  display: flex;\n  width: 100%;\n  background-color: var(--pf-c-input-group--BackgroundColor);\n}\n.pf-c-input-group.pf-m-plain {\n  --pf-c-input-group--BackgroundColor: transparent;\n}\n.pf-c-input-group > * + * {\n  margin-left: -1px;\n}\n.pf-c-input-group > :focus,\n.pf-c-input-group > :focus-within {\n  z-index: var(--pf-c-input-group--child--ZIndex);\n}\n.pf-c-input-group .pf-c-form-control[aria-invalid=true]:not(:last-child) {\n  margin-right: var(--pf-c-input-group--c-form-control--MarginRight);\n}\n.pf-c-input-group input:not([type=checkbox]):not([type=radio]),\n.pf-c-input-group textarea {\n  flex: 2;\n  min-width: 0;\n}\n.pf-c-input-group textarea {\n  min-height: var(--pf-c-input-group__textarea--MinHeight);\n}\n\n.pf-c-input-group__text {\n  display: flex;\n  align-items: center;\n  padding-right: var(--pf-c-input-group__text--PaddingRight);\n  padding-left: var(--pf-c-input-group__text--PaddingLeft);\n  font-size: var(--pf-c-input-group__text--FontSize);\n  color: var(--pf-c-input-group__text--Color);\n  text-align: center;\n  background-color: var(--pf-c-input-group__text--BackgroundColor);\n  border: var(--pf-c-input-group__text--BorderWidth) solid;\n  border-color: var(--pf-c-input-group__text--BorderTopColor) var(--pf-c-input-group__text--BorderRightColor) var(--pf-c-input-group__text--BorderBottomColor) var(--pf-c-input-group__text--BorderLeftColor);\n}\nlabel.pf-c-input-group__text {\n  cursor: pointer;\n}\n\n.pf-c-input-group__text.pf-m-plain {\n  --pf-c-input-group__text--BorderWidth: 0;\n  margin-left: 0;\n}\n.pf-c-input-group__text.pf-m-disabled {\n  --pf-c-input-group__text--Color: var(--pf-c-input-group__text--m-disabled--Color);\n  --pf-c-input-group__text--BackgroundColor: var(--pf-c-input-group__text--m-disabled--BackgroundColor);\n  --pf-c-input-group__text--BorderBottomColor: var(--pf-c-input-group__text--m-disabled--BorderBottomColor);\n}\n\n:where(.pf-theme-dark) .pf-c-input-group {\n  --pf-c-input-group--BackgroundColor: transparent;\n  --pf-c-input-group__text--BorderTopColor: transparent;\n  --pf-c-input-group__text--BorderRightColor: transparent;\n  --pf-c-input-group__text--BorderBottomColor: var(--pf-global--BorderColor--400);\n  --pf-c-input-group__text--BorderLeftColor: transparent;\n  --pf-c-input-group__text--BackgroundColor: var(--pf-global--palette--black-600);\n  --pf-c-input-group__text--m-disabled--Color: var(--pf-global--palette--black-100);\n  --pf-c-input-group__text--m-disabled--BackgroundColor: var(--pf-global--disabled-color--200);\n}\n:where(.pf-theme-dark) .pf-c-input-group > * + * {\n  margin-left: 0;\n  border-left: 1px solid var(--pf-global--palette--black-700);\n}\n:where(.pf-theme-dark) .pf-c-input-group__text {\n  --pf-c-input-group__text--BorderTopColor: transparent;\n  --pf-c-input-group__text--BorderRightColor: transparent;\n  --pf-c-input-group__text--BorderBottomColor: var(--pf-global--BorderColor--400);\n  --pf-c-input-group__text--BorderLeftColor: transparent;\n}\n:where(.pf-theme-dark) .pf-c-input-group__text.pf-m-plain {\n  --pf-c-input-group__text--BackgroundColor: transparent;\n}\n:where(.pf-theme-dark) .pf-c-input-group__text.pf-m-disabled {\n  --pf-c-input-group__text--BackgroundColor: var(--pf-c-input-group__text--m-disabled--BackgroundColor);\n  color: var(--pf-c-input-group__text--m-disabled--Color);\n}";

// node_modules/@patternfly/patternfly/components/Toolbar/toolbar.css
var toolbar_default = ".pf-c-toolbar__content-section, .pf-c-toolbar__content, .pf-c-toolbar__item, .pf-c-toolbar__group {\n  --pf-hidden-visible--visible--Visibility: visible;\n  --pf-hidden-visible--hidden--Display: none;\n  --pf-hidden-visible--hidden--Visibility: hidden;\n  --pf-hidden-visible--Display: var(--pf-hidden-visible--visible--Display);\n  --pf-hidden-visible--Visibility: var(--pf-hidden-visible--visible--Visibility);\n  display: var(--pf-hidden-visible--Display);\n  visibility: var(--pf-hidden-visible--Visibility);\n}\n.pf-m-hidden.pf-c-toolbar__content-section, .pf-m-hidden.pf-c-toolbar__content, .pf-m-hidden.pf-c-toolbar__item, .pf-m-hidden.pf-c-toolbar__group {\n  --pf-hidden-visible--Display: var(--pf-hidden-visible--hidden--Display);\n  --pf-hidden-visible--Visibility: var(--pf-hidden-visible--hidden--Visibility);\n}\n@media screen and (min-width: 576px) {\n  .pf-m-hidden-on-sm.pf-c-toolbar__content-section, .pf-m-hidden-on-sm.pf-c-toolbar__content, .pf-m-hidden-on-sm.pf-c-toolbar__item, .pf-m-hidden-on-sm.pf-c-toolbar__group {\n    --pf-hidden-visible--Display: var(--pf-hidden-visible--hidden--Display);\n    --pf-hidden-visible--Visibility: var(--pf-hidden-visible--hidden--Visibility);\n  }\n  .pf-m-visible-on-sm.pf-c-toolbar__content-section, .pf-m-visible-on-sm.pf-c-toolbar__content, .pf-m-visible-on-sm.pf-c-toolbar__item, .pf-m-visible-on-sm.pf-c-toolbar__group {\n    --pf-hidden-visible--Display: var(--pf-hidden-visible--visible--Display);\n    --pf-hidden-visible--Visibility: var(--pf-hidden-visible--visible--Visibility);\n  }\n}\n@media screen and (min-width: 768px) {\n  .pf-m-hidden-on-md.pf-c-toolbar__content-section, .pf-m-hidden-on-md.pf-c-toolbar__content, .pf-m-hidden-on-md.pf-c-toolbar__item, .pf-m-hidden-on-md.pf-c-toolbar__group {\n    --pf-hidden-visible--Display: var(--pf-hidden-visible--hidden--Display);\n    --pf-hidden-visible--Visibility: var(--pf-hidden-visible--hidden--Visibility);\n  }\n  .pf-m-visible-on-md.pf-c-toolbar__content-section, .pf-m-visible-on-md.pf-c-toolbar__content, .pf-m-visible-on-md.pf-c-toolbar__item, .pf-m-visible-on-md.pf-c-toolbar__group {\n    --pf-hidden-visible--Display: var(--pf-hidden-visible--visible--Display);\n    --pf-hidden-visible--Visibility: var(--pf-hidden-visible--visible--Visibility);\n  }\n}\n@media screen and (min-width: 992px) {\n  .pf-m-hidden-on-lg.pf-c-toolbar__content-section, .pf-m-hidden-on-lg.pf-c-toolbar__content, .pf-m-hidden-on-lg.pf-c-toolbar__item, .pf-m-hidden-on-lg.pf-c-toolbar__group {\n    --pf-hidden-visible--Display: var(--pf-hidden-visible--hidden--Display);\n    --pf-hidden-visible--Visibility: var(--pf-hidden-visible--hidden--Visibility);\n  }\n  .pf-m-visible-on-lg.pf-c-toolbar__content-section, .pf-m-visible-on-lg.pf-c-toolbar__content, .pf-m-visible-on-lg.pf-c-toolbar__item, .pf-m-visible-on-lg.pf-c-toolbar__group {\n    --pf-hidden-visible--Display: var(--pf-hidden-visible--visible--Display);\n    --pf-hidden-visible--Visibility: var(--pf-hidden-visible--visible--Visibility);\n  }\n}\n@media screen and (min-width: 1200px) {\n  .pf-m-hidden-on-xl.pf-c-toolbar__content-section, .pf-m-hidden-on-xl.pf-c-toolbar__content, .pf-m-hidden-on-xl.pf-c-toolbar__item, .pf-m-hidden-on-xl.pf-c-toolbar__group {\n    --pf-hidden-visible--Display: var(--pf-hidden-visible--hidden--Display);\n    --pf-hidden-visible--Visibility: var(--pf-hidden-visible--hidden--Visibility);\n  }\n  .pf-m-visible-on-xl.pf-c-toolbar__content-section, .pf-m-visible-on-xl.pf-c-toolbar__content, .pf-m-visible-on-xl.pf-c-toolbar__item, .pf-m-visible-on-xl.pf-c-toolbar__group {\n    --pf-hidden-visible--Display: var(--pf-hidden-visible--visible--Display);\n    --pf-hidden-visible--Visibility: var(--pf-hidden-visible--visible--Visibility);\n  }\n}\n@media screen and (min-width: 1450px) {\n  .pf-m-hidden-on-2xl.pf-c-toolbar__content-section, .pf-m-hidden-on-2xl.pf-c-toolbar__content, .pf-m-hidden-on-2xl.pf-c-toolbar__item, .pf-m-hidden-on-2xl.pf-c-toolbar__group {\n    --pf-hidden-visible--Display: var(--pf-hidden-visible--hidden--Display);\n    --pf-hidden-visible--Visibility: var(--pf-hidden-visible--hidden--Visibility);\n  }\n  .pf-m-visible-on-2xl.pf-c-toolbar__content-section, .pf-m-visible-on-2xl.pf-c-toolbar__content, .pf-m-visible-on-2xl.pf-c-toolbar__item, .pf-m-visible-on-2xl.pf-c-toolbar__group {\n    --pf-hidden-visible--Display: var(--pf-hidden-visible--visible--Display);\n    --pf-hidden-visible--Visibility: var(--pf-hidden-visible--visible--Visibility);\n  }\n}\n\n.pf-c-toolbar {\n  --pf-c-toolbar--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-toolbar--RowGap: var(--pf-global--spacer--lg);\n  --pf-c-toolbar--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-toolbar--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-toolbar__item--Display: block;\n  --pf-c-toolbar__item--MinWidth--base: auto;\n  --pf-c-toolbar__group--Display: flex;\n  --pf-c-toolbar--m-sticky--ZIndex: var(--pf-global--ZIndex--xs);\n  --pf-c-toolbar--m-sticky--BoxShadow: var(--pf-global--BoxShadow--sm-bottom);\n  --pf-c-toolbar__content--Display: flex;\n  --pf-c-toolbar__content--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-toolbar__content--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-toolbar__content-section--Display: flex;\n  --pf-c-toolbar--m-page-insets--inset: var(--pf-global--spacer--md);\n  --pf-c-toolbar--m-page-insets--xl--inset: var(--pf-global--spacer--lg);\n  --pf-c-toolbar__expandable-content--Display: grid;\n  --pf-c-toolbar__expandable-content--PaddingTop: var(--pf-c-toolbar--RowGap);\n  --pf-c-toolbar__expandable-content--PaddingRight: var(--pf-c-toolbar__content--PaddingRight);\n  --pf-c-toolbar__expandable-content--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-toolbar__expandable-content--PaddingLeft: var(--pf-c-toolbar__content--PaddingLeft);\n  --pf-c-toolbar__expandable-content--lg--PaddingRight: 0;\n  --pf-c-toolbar__expandable-content--lg--PaddingBottom: 0;\n  --pf-c-toolbar__expandable-content--lg--PaddingLeft: 0;\n  --pf-c-toolbar__expandable-content--ZIndex: var(--pf-global--ZIndex--sm);\n  --pf-c-toolbar__expandable-content--BoxShadow: var(--pf-global--BoxShadow--md-bottom);\n  --pf-c-toolbar__expandable-content--BackgroundColor: var(--pf-c-toolbar--BackgroundColor);\n  --pf-c-toolbar__expandable-content--m-expanded--GridRowGap: var(--pf-global--gutter--md);\n  --pf-c-toolbar__group--m-chip-container--MarginTop: calc(var(--pf-global--spacer--md) * -1);\n  --pf-c-toolbar__group--m-chip-container__item--MarginTop: var(--pf-global--spacer--md);\n  --pf-c-toolbar--spacer--base: var(--pf-global--spacer--md);\n  --pf-c-toolbar__item--spacer: var(--pf-c-toolbar--spacer--base);\n  --pf-c-toolbar__group--spacer: var(--pf-c-toolbar--spacer--base);\n  --pf-c-toolbar__item--Width: auto;\n  --pf-c-toolbar__group--m-toggle-group--spacer: var(--pf-global--spacer--sm);\n  --pf-c-toolbar__group--m-toggle-group--m-show--spacer: var(--pf-c-toolbar__group--spacer);\n  --pf-c-toolbar__group--m-icon-button-group--spacer: var(--pf-c-toolbar__group--spacer);\n  --pf-c-toolbar__group--m-icon-button-group--space-items: 0;\n  --pf-c-toolbar__group--m-button-group--spacer: var(--pf-c-toolbar__group--spacer);\n  --pf-c-toolbar__group--m-button-group--space-items: var(--pf-global--spacer--sm);\n  --pf-c-toolbar__group--m-filter-group--spacer: var(--pf-c-toolbar__group--spacer);\n  --pf-c-toolbar__group--m-filter-group--space-items: 0;\n  --pf-c-toolbar__item--m-overflow-menu--spacer: var(--pf-c-toolbar__item--spacer);\n  --pf-c-toolbar__item--m-bulk-select--spacer: var(--pf-global--spacer--lg);\n  --pf-c-toolbar__expand-all-icon--Rotate: 0;\n  --pf-c-toolbar__expand-all-icon--Transition: var(--pf-global--Transition);\n  --pf-c-toolbar__item--m-expand-all--m-expanded__expand-all-icon--Rotate: 90deg;\n  --pf-c-toolbar__item--m-search-filter--spacer: var(--pf-global--spacer--sm);\n  --pf-c-toolbar__item--m-chip-group--spacer: var(--pf-global--spacer--sm);\n  --pf-c-toolbar__item--m-label--spacer: var(--pf-c-toolbar__item--spacer);\n  --pf-c-toolbar__item--m-label--FontWeight: var(--pf-global--FontWeight--bold);\n  --pf-c-toolbar__expandable-content__item--m-label--MarginBottom: calc(-1 * var(--pf-c-toolbar__expandable-content--m-expanded--GridRowGap) + var(--pf-global--spacer--sm));\n  --pf-c-toolbar__expandable-content__item--m-label--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-toolbar__toggle--m-expanded__c-button--m-plain--Color: var(--pf-global--Color--100);\n  --pf-c-toolbar--c-divider--m-vertical--spacer: var(--pf-c-toolbar--spacer--base);\n  --pf-c-toolbar--m-full-height--PaddingTop: 0;\n  --pf-c-toolbar--m-full-height--PaddingBottom: 0;\n  --pf-c-toolbar--m-full-height__item--Display: flex;\n  --pf-c-toolbar--m-full-height__item--AlignItems: center;\n  position: relative;\n  row-gap: var(--pf-c-toolbar--RowGap);\n  display: grid;\n  padding-top: var(--pf-c-toolbar--PaddingTop);\n  padding-bottom: var(--pf-c-toolbar--PaddingBottom);\n  background-color: var(--pf-c-toolbar--BackgroundColor);\n}\n@media screen and (min-width: 992px) {\n  .pf-c-toolbar {\n    --pf-c-toolbar__expandable-content--PaddingRight: var(--pf-c-toolbar__expandable-content--lg--PaddingRight);\n    --pf-c-toolbar__expandable-content--PaddingBottom: var(--pf-c-toolbar__expandable-content--lg--PaddingBottom);\n    --pf-c-toolbar__expandable-content--PaddingLeft: var(--pf-c-toolbar__expandable-content--lg--PaddingLeft);\n  }\n}\n@media screen and (min-width: 1200px) {\n  .pf-c-toolbar {\n    --pf-c-toolbar--m-page-insets--inset: var(--pf-c-toolbar--m-page-insets--xl--inset);\n  }\n}\n.pf-c-toolbar.pf-m-page-insets {\n  --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--m-page-insets--inset);\n  --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--m-page-insets--inset);\n}\n.pf-c-toolbar.pf-m-sticky {\n  position: sticky;\n  top: 0;\n  z-index: var(--pf-c-toolbar--m-sticky--ZIndex);\n  box-shadow: var(--pf-c-toolbar--m-sticky--BoxShadow);\n}\n.pf-c-toolbar.pf-m-full-height {\n  --pf-c-toolbar--PaddingTop: var(--pf-c-toolbar--m-full-height--PaddingTop);\n  --pf-c-toolbar--PaddingBottom: var(--pf-c-toolbar--m-full-height--PaddingTop);\n  --pf-c-toolbar__item--Display: var(--pf-c-toolbar--m-full-height__item--Display);\n  height: 100%;\n}\n.pf-c-toolbar.pf-m-full-height,\n.pf-c-toolbar.pf-m-full-height .pf-c-toolbar__content,\n.pf-c-toolbar.pf-m-full-height .pf-c-toolbar__content-section,\n.pf-c-toolbar.pf-m-full-height .pf-c-toolbar__expandable-content,\n.pf-c-toolbar.pf-m-full-height .pf-c-toolbar__group {\n  min-width: 0;\n}\n.pf-c-toolbar.pf-m-full-height,\n.pf-c-toolbar.pf-m-full-height .pf-c-toolbar__content,\n.pf-c-toolbar.pf-m-full-height .pf-c-toolbar__content-section,\n.pf-c-toolbar.pf-m-full-height .pf-c-toolbar__group,\n.pf-c-toolbar.pf-m-full-height .pf-c-toolbar__item {\n  align-self: stretch;\n}\n.pf-c-toolbar.pf-m-full-height .pf-c-toolbar__item {\n  align-items: var(--pf-c-toolbar--m-full-height__item--AlignItems);\n}\n.pf-c-toolbar.pf-m-static,\n.pf-c-toolbar.pf-m-static .pf-c-toolbar__content {\n  position: static;\n}\n.pf-c-toolbar.pf-m-static .pf-c-toolbar__expandable-content {\n  position: absolute;\n}\n\n.pf-c-toolbar__content-section > .pf-c-divider,\n.pf-c-toolbar__group > .pf-c-divider {\n  --pf-c-toolbar--spacer: var(--pf-c-toolbar--c-divider--m-vertical--spacer);\n}\n.pf-c-toolbar__content-section > .pf-c-divider.pf-m-vertical,\n.pf-c-toolbar__group > .pf-c-divider.pf-m-vertical {\n  margin-right: var(--pf-c-toolbar--spacer);\n}\n.pf-c-toolbar__content-section > .pf-c-divider.pf-m-vertical:last-child,\n.pf-c-toolbar__group > .pf-c-divider.pf-m-vertical:last-child {\n  --pf-c-toolbar--spacer: 0;\n}\n\n.pf-c-toolbar__group {\n  --pf-c-toolbar--spacer: var(--pf-c-toolbar__group--spacer);\n  --pf-hidden-visible--visible--Display: var(--pf-c-toolbar__group--Display);\n  align-items: center;\n  margin-right: var(--pf-c-toolbar--spacer);\n}\n.pf-c-toolbar__group.pf-m-button-group {\n  --pf-c-toolbar--spacer: var(--pf-c-toolbar__group--m-button-group--spacer);\n}\n.pf-c-toolbar__group.pf-m-button-group > * {\n  --pf-c-toolbar--spacer: var(--pf-c-toolbar__group--m-button-group--space-items);\n}\n.pf-c-toolbar__group.pf-m-icon-button-group {\n  --pf-c-toolbar--spacer: var(--pf-c-toolbar__group--m-icon-button-group--spacer);\n}\n.pf-c-toolbar__group.pf-m-icon-button-group > * {\n  --pf-c-toolbar--spacer: var(--pf-c-toolbar__group--m-icon-button-group--space-items);\n}\n.pf-c-toolbar__group.pf-m-filter-group {\n  --pf-c-toolbar--spacer: var(--pf-c-toolbar__group--m-filter-group--spacer);\n}\n.pf-c-toolbar__group.pf-m-filter-group > * {\n  --pf-c-toolbar--spacer: var(--pf-c-toolbar__group--m-filter-group--space-items);\n}\n.pf-c-toolbar__group.pf-m-filter-group > * + * {\n  margin-left: -1px;\n}\n.pf-c-toolbar__group.pf-m-toggle-group {\n  --pf-c-toolbar--spacer: var(--pf-c-toolbar__group--m-toggle-group--spacer);\n}\n.pf-c-toolbar__group.pf-m-toggle-group .pf-c-toolbar__group,\n.pf-c-toolbar__group.pf-m-toggle-group .pf-c-toolbar__item {\n  display: none;\n  visibility: hidden;\n}\n.pf-c-toolbar__group.pf-m-toggle-group .pf-c-toolbar__toggle {\n  display: inline-block;\n  visibility: visible;\n}\n.pf-c-toolbar__group:last-child {\n  --pf-c-toolbar--spacer: 0;\n}\n\n.pf-c-toolbar__item {\n  --pf-c-toolbar--spacer: var(--pf-c-toolbar__item--spacer);\n  --pf-c-toolbar__item--Width--base: var(--pf-c-toolbar__item--Width);\n  --pf-c-toolbar__item--MinWidth--base: var(--pf-c-toolbar__item--MinWidth);\n  --pf-hidden-visible--visible--Display: var(--pf-c-toolbar__item--Display);\n  width: var(--pf-c-toolbar__item--Width--base);\n  min-width: var(--pf-c-toolbar__item--MinWidth--base);\n  margin-right: var(--pf-c-toolbar--spacer);\n}\n@media (min-width: 576px) {\n  .pf-c-toolbar__item {\n    --pf-c-toolbar__item--Width--base: var(--pf-c-toolbar__item--Width-on-sm, var(--pf-c-toolbar__item--Width));\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-toolbar__item {\n    --pf-c-toolbar__item--Width--base: var(--pf-c-toolbar__item--Width-on-md, var(--pf-c-toolbar__item--Width-on-sm, var(--pf-c-toolbar__item--Width)));\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-toolbar__item {\n    --pf-c-toolbar__item--Width--base: var(--pf-c-toolbar__item--Width-on-lg, var(--pf-c-toolbar__item--Width-on-md, var(--pf-c-toolbar__item--Width-on-sm, var(--pf-c-toolbar__item--Width))));\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-toolbar__item {\n    --pf-c-toolbar__item--Width--base: var(--pf-c-toolbar__item--Width-on-xl, var(--pf-c-toolbar__item--Width-on-lg, var(--pf-c-toolbar__item--Width-on-md, var(--pf-c-toolbar__item--Width-on-sm, var(--pf-c-toolbar__item--Width)))));\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-toolbar__item {\n    --pf-c-toolbar__item--Width--base: var(--pf-c-toolbar__item--Width-on-2xl, var(--pf-c-toolbar__item--Width-on-xl, var(--pf-c-toolbar__item--Width-on-lg, var(--pf-c-toolbar__item--Width-on-md, var(--pf-c-toolbar__item--Width-on-sm, var(--pf-c-toolbar__item--Width))))));\n  }\n}\n@media (min-width: 576px) {\n  .pf-c-toolbar__item {\n    --pf-c-toolbar__item--MinWidth--base: var(--pf-c-toolbar__item--MinWidth-on-sm, var(--pf-c-toolbar__item--MinWidth));\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-toolbar__item {\n    --pf-c-toolbar__item--MinWidth--base: var(--pf-c-toolbar__item--MinWidth-on-md, var(--pf-c-toolbar__item--MinWidth-on-sm, var(--pf-c-toolbar__item--MinWidth)));\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-toolbar__item {\n    --pf-c-toolbar__item--MinWidth--base: var(--pf-c-toolbar__item--MinWidth-on-lg, var(--pf-c-toolbar__item--MinWidth-on-md, var(--pf-c-toolbar__item--MinWidth-on-sm, var(--pf-c-toolbar__item--MinWidth))));\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-toolbar__item {\n    --pf-c-toolbar__item--MinWidth--base: var(--pf-c-toolbar__item--MinWidth-on-xl, var(--pf-c-toolbar__item--MinWidth-on-lg, var(--pf-c-toolbar__item--MinWidth-on-md, var(--pf-c-toolbar__item--MinWidth-on-sm, var(--pf-c-toolbar__item--MinWidth)))));\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-toolbar__item {\n    --pf-c-toolbar__item--MinWidth--base: var(--pf-c-toolbar__item--MinWidth-on-2xl, var(--pf-c-toolbar__item--MinWidth-on-xl, var(--pf-c-toolbar__item--MinWidth-on-lg, var(--pf-c-toolbar__item--MinWidth-on-md, var(--pf-c-toolbar__item--MinWidth-on-sm, var(--pf-c-toolbar__item--MinWidth))))));\n  }\n}\n.pf-c-toolbar__item.pf-m-overflow-menu {\n  --pf-c-toolbar--spacer: var(--pf-c-toolbar__item--m-overflow-menu--spacer);\n}\n.pf-c-toolbar__item.pf-m-bulk-select {\n  --pf-c-toolbar--spacer: var(--pf-c-toolbar__item--m-bulk-select--spacer);\n}\n.pf-c-toolbar__item.pf-m-expand-all.pf-m-expanded {\n  --pf-c-toolbar__expand-all-icon--Rotate: var(--pf-c-toolbar__item--m-expand-all--m-expanded__expand-all-icon--Rotate);\n}\n.pf-c-toolbar__item.pf-m-search-filter {\n  --pf-c-toolbar--spacer: var(--pf-c-toolbar__item--m-search-filter--spacer);\n}\n.pf-c-toolbar__item.pf-m-chip-group {\n  --pf-c-toolbar--spacer: var(--pf-c-toolbar__item--m-chip-group--spacer);\n}\n.pf-c-toolbar__item.pf-m-label {\n  --pf-c-toolbar--spacer: var(--pf-c-toolbar__item--m-label--spacer);\n  font-weight: var(--pf-c-toolbar__item--m-label--FontWeight);\n}\n.pf-c-toolbar__item.pf-m-pagination {\n  margin-left: auto;\n}\n.pf-c-toolbar__item.pf-m-pagination .pf-c-pagination {\n  flex-wrap: nowrap;\n}\n.pf-c-toolbar__item:last-child {\n  --pf-c-toolbar--spacer: 0;\n}\n\n.pf-c-toolbar__group.pf-m-overflow-container,\n.pf-c-toolbar__item.pf-m-overflow-container {\n  flex: 1;\n  overflow: hidden;\n}\n\n.pf-c-toolbar__expand-all-icon {\n  display: inline-block;\n  transition: var(--pf-c-toolbar__expand-all-icon--Transition);\n  transform: rotate(var(--pf-c-toolbar__expand-all-icon--Rotate));\n}\n\n.pf-c-toolbar__content,\n.pf-c-toolbar__content-section {\n  flex-wrap: wrap;\n  align-items: center;\n}\n\n.pf-c-toolbar__content {\n  --pf-hidden-visible--visible--Display: var(--pf-c-toolbar__content--Display);\n  position: relative;\n  padding-right: var(--pf-c-toolbar__content--PaddingRight);\n  padding-left: var(--pf-c-toolbar__content--PaddingLeft);\n}\n\n.pf-c-toolbar__content-section {\n  --pf-hidden-visible--visible--Display: var(--pf-c-toolbar__content-section--Display);\n  width: 100%;\n}\n\n.pf-c-toolbar__expandable-content {\n  position: absolute;\n  top: 100%;\n  right: 0;\n  left: 0;\n  z-index: var(--pf-c-toolbar__expandable-content--ZIndex);\n  display: none;\n  width: 100%;\n  padding: var(--pf-c-toolbar__expandable-content--PaddingTop) var(--pf-c-toolbar__expandable-content--PaddingRight) var(--pf-c-toolbar__expandable-content--PaddingBottom) var(--pf-c-toolbar__expandable-content--PaddingLeft);\n  visibility: hidden;\n  background-color: var(--pf-c-toolbar__expandable-content--BackgroundColor);\n  box-shadow: var(--pf-c-toolbar__expandable-content--BoxShadow);\n}\n@media screen and (min-width: 992px) {\n  .pf-c-toolbar__expandable-content {\n    position: static;\n    box-shadow: none;\n  }\n}\n.pf-c-toolbar__expandable-content.pf-m-expanded {\n  display: grid;\n  grid-row-gap: var(--pf-c-toolbar__expandable-content--m-expanded--GridRowGap);\n  visibility: visible;\n}\n.pf-c-toolbar__expandable-content .pf-c-toolbar__group,\n.pf-c-toolbar__expandable-content .pf-c-toolbar__item {\n  --pf-c-toolbar--spacer: 0;\n}\n.pf-c-toolbar__expandable-content .pf-c-toolbar__group {\n  display: grid;\n  grid-row-gap: var(--pf-c-toolbar__expandable-content--m-expanded--GridRowGap);\n}\n.pf-c-toolbar__expandable-content .pf-m-label {\n  margin-bottom: var(--pf-c-toolbar__expandable-content__item--m-label--MarginBottom);\n  font-size: var(--pf-c-toolbar__expandable-content__item--m-label--FontSize);\n}\n\n.pf-c-toolbar__content.pf-m-chip-container,\n.pf-c-toolbar__group.pf-m-chip-container {\n  display: flex;\n  flex-wrap: wrap;\n  align-items: baseline;\n  margin-top: var(--pf-c-toolbar__group--m-chip-container--MarginTop);\n  grid-row-gap: 0;\n}\n.pf-c-toolbar__content.pf-m-chip-container .pf-c-toolbar__item,\n.pf-c-toolbar__group.pf-m-chip-container .pf-c-toolbar__item {\n  --pf-c-toolbar--spacer: var(--pf-c-toolbar__item--spacer);\n  margin-top: var(--pf-c-toolbar__group--m-chip-container__item--MarginTop);\n}\n.pf-c-toolbar__content.pf-m-chip-container .pf-c-toolbar__group,\n.pf-c-toolbar__group.pf-m-chip-container .pf-c-toolbar__group {\n  --pf-c-toolbar--spacer: var(--pf-c-toolbar__group--spacer);\n  display: flex;\n  flex-wrap: wrap;\n  grid-row-gap: 0;\n}\n.pf-c-toolbar__content.pf-m-chip-container .pf-c-toolbar__group:last-child,\n.pf-c-toolbar__content.pf-m-chip-container .pf-c-toolbar__item:last-child,\n.pf-c-toolbar__group.pf-m-chip-container .pf-c-toolbar__group:last-child,\n.pf-c-toolbar__group.pf-m-chip-container .pf-c-toolbar__item:last-child {\n  --pf-c-toolbar--spacer: 0;\n}\n\n.pf-c-toolbar .pf-c-chip-group:last-child {\n  --pf-c-chip-group--MarginRight: 0;\n}\n\n.pf-c-toolbar .pf-c-chip-group li:last-child {\n  --pf-c-chip-group__li--m-toolbar--MarginRight: 0;\n}\n\n.pf-c-toolbar__toggle.pf-m-expanded .pf-c-button.pf-m-plain {\n  color: var(--pf-c-toolbar__toggle--m-expanded__c-button--m-plain--Color);\n}\n\n.pf-m-toggle-group.pf-m-show {\n  --pf-c-toolbar--spacer: var(--pf-c-toolbar__group--m-toggle-group--m-show--spacer);\n}\n.pf-m-toggle-group.pf-m-show .pf-c-toolbar__group,\n.pf-m-toggle-group.pf-m-show .pf-c-toolbar__item {\n  display: flex;\n  flex: 0 1 auto;\n  visibility: visible;\n}\n.pf-m-toggle-group.pf-m-show .pf-c-toolbar__toggle {\n  display: none;\n  visibility: hidden;\n}\n\n@media (min-width: 576px) {\n  .pf-m-toggle-group.pf-m-show-on-sm {\n    --pf-c-toolbar--spacer: var(--pf-c-toolbar__group--m-toggle-group--m-show--spacer);\n  }\n  .pf-m-toggle-group.pf-m-show-on-sm .pf-c-toolbar__group,\n.pf-m-toggle-group.pf-m-show-on-sm .pf-c-toolbar__item {\n    display: flex;\n    flex: 0 1 auto;\n    visibility: visible;\n  }\n  .pf-m-toggle-group.pf-m-show-on-sm .pf-c-toolbar__toggle {\n    display: none;\n    visibility: hidden;\n  }\n}\n@media (min-width: 768px) {\n  .pf-m-toggle-group.pf-m-show-on-md {\n    --pf-c-toolbar--spacer: var(--pf-c-toolbar__group--m-toggle-group--m-show--spacer);\n  }\n  .pf-m-toggle-group.pf-m-show-on-md .pf-c-toolbar__group,\n.pf-m-toggle-group.pf-m-show-on-md .pf-c-toolbar__item {\n    display: flex;\n    flex: 0 1 auto;\n    visibility: visible;\n  }\n  .pf-m-toggle-group.pf-m-show-on-md .pf-c-toolbar__toggle {\n    display: none;\n    visibility: hidden;\n  }\n}\n@media (min-width: 992px) {\n  .pf-m-toggle-group.pf-m-show-on-lg {\n    --pf-c-toolbar--spacer: var(--pf-c-toolbar__group--m-toggle-group--m-show--spacer);\n  }\n  .pf-m-toggle-group.pf-m-show-on-lg .pf-c-toolbar__group,\n.pf-m-toggle-group.pf-m-show-on-lg .pf-c-toolbar__item {\n    display: flex;\n    flex: 0 1 auto;\n    visibility: visible;\n  }\n  .pf-m-toggle-group.pf-m-show-on-lg .pf-c-toolbar__toggle {\n    display: none;\n    visibility: hidden;\n  }\n}\n@media (min-width: 1200px) {\n  .pf-m-toggle-group.pf-m-show-on-xl {\n    --pf-c-toolbar--spacer: var(--pf-c-toolbar__group--m-toggle-group--m-show--spacer);\n  }\n  .pf-m-toggle-group.pf-m-show-on-xl .pf-c-toolbar__group,\n.pf-m-toggle-group.pf-m-show-on-xl .pf-c-toolbar__item {\n    display: flex;\n    flex: 0 1 auto;\n    visibility: visible;\n  }\n  .pf-m-toggle-group.pf-m-show-on-xl .pf-c-toolbar__toggle {\n    display: none;\n    visibility: hidden;\n  }\n}\n@media (min-width: 1450px) {\n  .pf-m-toggle-group.pf-m-show-on-2xl {\n    --pf-c-toolbar--spacer: var(--pf-c-toolbar__group--m-toggle-group--m-show--spacer);\n  }\n  .pf-m-toggle-group.pf-m-show-on-2xl .pf-c-toolbar__group,\n.pf-m-toggle-group.pf-m-show-on-2xl .pf-c-toolbar__item {\n    display: flex;\n    flex: 0 1 auto;\n    visibility: visible;\n  }\n  .pf-m-toggle-group.pf-m-show-on-2xl .pf-c-toolbar__toggle {\n    display: none;\n    visibility: hidden;\n  }\n}\n.pf-c-toolbar .pf-c-toolbar__item.pf-m-align-right,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-right {\n  margin-left: auto;\n}\n.pf-c-toolbar .pf-c-toolbar__item.pf-m-align-right ~ .pf-m-pagination,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-right ~ .pf-m-pagination {\n  margin-left: 0;\n}\n.pf-c-toolbar .pf-c-toolbar__item.pf-m-align-left,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-left {\n  margin-left: 0;\n}\n.pf-c-toolbar .pf-c-toolbar__item.pf-m-align-left ~ .pf-m-pagination,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-left ~ .pf-m-pagination {\n  margin-left: auto;\n}\n.pf-c-toolbar .pf-c-toolbar__content-section.pf-m-nowrap,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-nowrap {\n  flex-wrap: nowrap;\n}\n.pf-c-toolbar .pf-c-toolbar__content-section.pf-m-wrap,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-wrap {\n  flex-wrap: wrap;\n}\n@media (min-width: 576px) {\n  .pf-c-toolbar .pf-c-toolbar__item.pf-m-align-right-on-sm,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-right-on-sm {\n    margin-left: auto;\n  }\n  .pf-c-toolbar .pf-c-toolbar__item.pf-m-align-right-on-sm ~ .pf-m-pagination,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-right-on-sm ~ .pf-m-pagination {\n    margin-left: 0;\n  }\n  .pf-c-toolbar .pf-c-toolbar__item.pf-m-align-left-on-sm,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-left-on-sm {\n    margin-left: 0;\n  }\n  .pf-c-toolbar .pf-c-toolbar__item.pf-m-align-left-on-sm ~ .pf-m-pagination,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-left-on-sm ~ .pf-m-pagination {\n    margin-left: auto;\n  }\n  .pf-c-toolbar .pf-c-toolbar__content-section.pf-m-nowrap-on-sm,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-nowrap-on-sm {\n    flex-wrap: nowrap;\n  }\n  .pf-c-toolbar .pf-c-toolbar__content-section.pf-m-wrap-on-sm,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-wrap-on-sm {\n    flex-wrap: wrap;\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-toolbar .pf-c-toolbar__item.pf-m-align-right-on-md,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-right-on-md {\n    margin-left: auto;\n  }\n  .pf-c-toolbar .pf-c-toolbar__item.pf-m-align-right-on-md ~ .pf-m-pagination,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-right-on-md ~ .pf-m-pagination {\n    margin-left: 0;\n  }\n  .pf-c-toolbar .pf-c-toolbar__item.pf-m-align-left-on-md,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-left-on-md {\n    margin-left: 0;\n  }\n  .pf-c-toolbar .pf-c-toolbar__item.pf-m-align-left-on-md ~ .pf-m-pagination,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-left-on-md ~ .pf-m-pagination {\n    margin-left: auto;\n  }\n  .pf-c-toolbar .pf-c-toolbar__content-section.pf-m-nowrap-on-md,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-nowrap-on-md {\n    flex-wrap: nowrap;\n  }\n  .pf-c-toolbar .pf-c-toolbar__content-section.pf-m-wrap-on-md,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-wrap-on-md {\n    flex-wrap: wrap;\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-toolbar .pf-c-toolbar__item.pf-m-align-right-on-lg,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-right-on-lg {\n    margin-left: auto;\n  }\n  .pf-c-toolbar .pf-c-toolbar__item.pf-m-align-right-on-lg ~ .pf-m-pagination,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-right-on-lg ~ .pf-m-pagination {\n    margin-left: 0;\n  }\n  .pf-c-toolbar .pf-c-toolbar__item.pf-m-align-left-on-lg,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-left-on-lg {\n    margin-left: 0;\n  }\n  .pf-c-toolbar .pf-c-toolbar__item.pf-m-align-left-on-lg ~ .pf-m-pagination,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-left-on-lg ~ .pf-m-pagination {\n    margin-left: auto;\n  }\n  .pf-c-toolbar .pf-c-toolbar__content-section.pf-m-nowrap-on-lg,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-nowrap-on-lg {\n    flex-wrap: nowrap;\n  }\n  .pf-c-toolbar .pf-c-toolbar__content-section.pf-m-wrap-on-lg,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-wrap-on-lg {\n    flex-wrap: wrap;\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-toolbar .pf-c-toolbar__item.pf-m-align-right-on-xl,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-right-on-xl {\n    margin-left: auto;\n  }\n  .pf-c-toolbar .pf-c-toolbar__item.pf-m-align-right-on-xl ~ .pf-m-pagination,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-right-on-xl ~ .pf-m-pagination {\n    margin-left: 0;\n  }\n  .pf-c-toolbar .pf-c-toolbar__item.pf-m-align-left-on-xl,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-left-on-xl {\n    margin-left: 0;\n  }\n  .pf-c-toolbar .pf-c-toolbar__item.pf-m-align-left-on-xl ~ .pf-m-pagination,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-left-on-xl ~ .pf-m-pagination {\n    margin-left: auto;\n  }\n  .pf-c-toolbar .pf-c-toolbar__content-section.pf-m-nowrap-on-xl,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-nowrap-on-xl {\n    flex-wrap: nowrap;\n  }\n  .pf-c-toolbar .pf-c-toolbar__content-section.pf-m-wrap-on-xl,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-wrap-on-xl {\n    flex-wrap: wrap;\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-toolbar .pf-c-toolbar__item.pf-m-align-right-on-2xl,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-right-on-2xl {\n    margin-left: auto;\n  }\n  .pf-c-toolbar .pf-c-toolbar__item.pf-m-align-right-on-2xl ~ .pf-m-pagination,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-right-on-2xl ~ .pf-m-pagination {\n    margin-left: 0;\n  }\n  .pf-c-toolbar .pf-c-toolbar__item.pf-m-align-left-on-2xl,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-left-on-2xl {\n    margin-left: 0;\n  }\n  .pf-c-toolbar .pf-c-toolbar__item.pf-m-align-left-on-2xl ~ .pf-m-pagination,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-align-left-on-2xl ~ .pf-m-pagination {\n    margin-left: auto;\n  }\n  .pf-c-toolbar .pf-c-toolbar__content-section.pf-m-nowrap-on-2xl,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-nowrap-on-2xl {\n    flex-wrap: nowrap;\n  }\n  .pf-c-toolbar .pf-c-toolbar__content-section.pf-m-wrap-on-2xl,\n.pf-c-toolbar .pf-c-toolbar__group.pf-m-wrap-on-2xl {\n    flex-wrap: wrap;\n  }\n}\n.pf-c-toolbar .pf-m-space-items-none > * {\n  --pf-c-toolbar--spacer: 0;\n}\n.pf-c-toolbar .pf-m-space-items-none > :last-child {\n  --pf-c-toolbar--spacer: 0;\n}\n.pf-c-toolbar .pf-m-space-items-sm > * {\n  --pf-c-toolbar--spacer: var(--pf-global--spacer--sm);\n}\n.pf-c-toolbar .pf-m-space-items-sm > :last-child {\n  --pf-c-toolbar--spacer: 0;\n}\n.pf-c-toolbar .pf-m-space-items-md > * {\n  --pf-c-toolbar--spacer: var(--pf-global--spacer--md);\n}\n.pf-c-toolbar .pf-m-space-items-md > :last-child {\n  --pf-c-toolbar--spacer: 0;\n}\n.pf-c-toolbar .pf-m-space-items-lg > * {\n  --pf-c-toolbar--spacer: var(--pf-global--spacer--lg);\n}\n.pf-c-toolbar .pf-m-space-items-lg > :last-child {\n  --pf-c-toolbar--spacer: 0;\n}\n@media (min-width: 576px) {\n  .pf-c-toolbar .pf-m-space-items-none-on-sm > * {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-space-items-none-on-sm > :last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-space-items-sm-on-sm > * {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--sm);\n  }\n  .pf-c-toolbar .pf-m-space-items-sm-on-sm > :last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-space-items-md-on-sm > * {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--md);\n  }\n  .pf-c-toolbar .pf-m-space-items-md-on-sm > :last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-space-items-lg-on-sm > * {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--lg);\n  }\n  .pf-c-toolbar .pf-m-space-items-lg-on-sm > :last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-toolbar .pf-m-space-items-none-on-md > * {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-space-items-none-on-md > :last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-space-items-sm-on-md > * {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--sm);\n  }\n  .pf-c-toolbar .pf-m-space-items-sm-on-md > :last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-space-items-md-on-md > * {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--md);\n  }\n  .pf-c-toolbar .pf-m-space-items-md-on-md > :last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-space-items-lg-on-md > * {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--lg);\n  }\n  .pf-c-toolbar .pf-m-space-items-lg-on-md > :last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-toolbar .pf-m-space-items-none-on-lg > * {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-space-items-none-on-lg > :last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-space-items-sm-on-lg > * {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--sm);\n  }\n  .pf-c-toolbar .pf-m-space-items-sm-on-lg > :last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-space-items-md-on-lg > * {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--md);\n  }\n  .pf-c-toolbar .pf-m-space-items-md-on-lg > :last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-space-items-lg-on-lg > * {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--lg);\n  }\n  .pf-c-toolbar .pf-m-space-items-lg-on-lg > :last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-toolbar .pf-m-space-items-none-on-xl > * {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-space-items-none-on-xl > :last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-space-items-sm-on-xl > * {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--sm);\n  }\n  .pf-c-toolbar .pf-m-space-items-sm-on-xl > :last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-space-items-md-on-xl > * {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--md);\n  }\n  .pf-c-toolbar .pf-m-space-items-md-on-xl > :last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-space-items-lg-on-xl > * {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--lg);\n  }\n  .pf-c-toolbar .pf-m-space-items-lg-on-xl > :last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-toolbar .pf-m-space-items-none-on-2xl > * {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-space-items-none-on-2xl > :last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-space-items-sm-on-2xl > * {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--sm);\n  }\n  .pf-c-toolbar .pf-m-space-items-sm-on-2xl > :last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-space-items-md-on-2xl > * {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--md);\n  }\n  .pf-c-toolbar .pf-m-space-items-md-on-2xl > :last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-space-items-lg-on-2xl > * {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--lg);\n  }\n  .pf-c-toolbar .pf-m-space-items-lg-on-2xl > :last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n}\n.pf-c-toolbar .pf-m-spacer-none {\n  --pf-c-toolbar--spacer: 0;\n}\n.pf-c-toolbar .pf-m-spacer-none:last-child {\n  --pf-c-toolbar--spacer: 0;\n}\n.pf-c-toolbar .pf-m-spacer-sm {\n  --pf-c-toolbar--spacer: var(--pf-global--spacer--sm);\n}\n.pf-c-toolbar .pf-m-spacer-sm:last-child {\n  --pf-c-toolbar--spacer: var(--pf-global--spacer--sm);\n}\n.pf-c-toolbar .pf-m-spacer-md {\n  --pf-c-toolbar--spacer: var(--pf-global--spacer--md);\n}\n.pf-c-toolbar .pf-m-spacer-md:last-child {\n  --pf-c-toolbar--spacer: var(--pf-global--spacer--md);\n}\n.pf-c-toolbar .pf-m-spacer-lg {\n  --pf-c-toolbar--spacer: var(--pf-global--spacer--lg);\n}\n.pf-c-toolbar .pf-m-spacer-lg:last-child {\n  --pf-c-toolbar--spacer: var(--pf-global--spacer--lg);\n}\n@media (min-width: 576px) {\n  .pf-c-toolbar .pf-m-spacer-none-on-sm {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-spacer-none-on-sm:last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-spacer-sm-on-sm {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--sm);\n  }\n  .pf-c-toolbar .pf-m-spacer-sm-on-sm:last-child {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--sm);\n  }\n  .pf-c-toolbar .pf-m-spacer-md-on-sm {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--md);\n  }\n  .pf-c-toolbar .pf-m-spacer-md-on-sm:last-child {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--md);\n  }\n  .pf-c-toolbar .pf-m-spacer-lg-on-sm {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--lg);\n  }\n  .pf-c-toolbar .pf-m-spacer-lg-on-sm:last-child {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--lg);\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-toolbar .pf-m-spacer-none-on-md {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-spacer-none-on-md:last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-spacer-sm-on-md {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--sm);\n  }\n  .pf-c-toolbar .pf-m-spacer-sm-on-md:last-child {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--sm);\n  }\n  .pf-c-toolbar .pf-m-spacer-md-on-md {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--md);\n  }\n  .pf-c-toolbar .pf-m-spacer-md-on-md:last-child {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--md);\n  }\n  .pf-c-toolbar .pf-m-spacer-lg-on-md {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--lg);\n  }\n  .pf-c-toolbar .pf-m-spacer-lg-on-md:last-child {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--lg);\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-toolbar .pf-m-spacer-none-on-lg {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-spacer-none-on-lg:last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-spacer-sm-on-lg {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--sm);\n  }\n  .pf-c-toolbar .pf-m-spacer-sm-on-lg:last-child {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--sm);\n  }\n  .pf-c-toolbar .pf-m-spacer-md-on-lg {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--md);\n  }\n  .pf-c-toolbar .pf-m-spacer-md-on-lg:last-child {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--md);\n  }\n  .pf-c-toolbar .pf-m-spacer-lg-on-lg {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--lg);\n  }\n  .pf-c-toolbar .pf-m-spacer-lg-on-lg:last-child {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--lg);\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-toolbar .pf-m-spacer-none-on-xl {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-spacer-none-on-xl:last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-spacer-sm-on-xl {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--sm);\n  }\n  .pf-c-toolbar .pf-m-spacer-sm-on-xl:last-child {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--sm);\n  }\n  .pf-c-toolbar .pf-m-spacer-md-on-xl {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--md);\n  }\n  .pf-c-toolbar .pf-m-spacer-md-on-xl:last-child {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--md);\n  }\n  .pf-c-toolbar .pf-m-spacer-lg-on-xl {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--lg);\n  }\n  .pf-c-toolbar .pf-m-spacer-lg-on-xl:last-child {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--lg);\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-toolbar .pf-m-spacer-none-on-2xl {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-spacer-none-on-2xl:last-child {\n    --pf-c-toolbar--spacer: 0;\n  }\n  .pf-c-toolbar .pf-m-spacer-sm-on-2xl {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--sm);\n  }\n  .pf-c-toolbar .pf-m-spacer-sm-on-2xl:last-child {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--sm);\n  }\n  .pf-c-toolbar .pf-m-spacer-md-on-2xl {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--md);\n  }\n  .pf-c-toolbar .pf-m-spacer-md-on-2xl:last-child {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--md);\n  }\n  .pf-c-toolbar .pf-m-spacer-lg-on-2xl {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--lg);\n  }\n  .pf-c-toolbar .pf-m-spacer-lg-on-2xl:last-child {\n    --pf-c-toolbar--spacer: var(--pf-global--spacer--lg);\n  }\n}\n.pf-c-toolbar.pf-m-inset-none {\n  --pf-c-toolbar--inset: 0;\n  --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n  --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n}\n.pf-c-toolbar.pf-m-inset-sm {\n  --pf-c-toolbar--inset: var(--pf-global--spacer--sm);\n  --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n  --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n}\n.pf-c-toolbar.pf-m-inset-md {\n  --pf-c-toolbar--inset: var(--pf-global--spacer--md);\n  --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n  --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n}\n.pf-c-toolbar.pf-m-inset-lg {\n  --pf-c-toolbar--inset: var(--pf-global--spacer--lg);\n  --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n  --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n}\n.pf-c-toolbar.pf-m-inset-xl {\n  --pf-c-toolbar--inset: var(--pf-global--spacer--xl);\n  --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n  --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n}\n.pf-c-toolbar.pf-m-inset-2xl {\n  --pf-c-toolbar--inset: var(--pf-global--spacer--2xl);\n  --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n  --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n}\n@media (min-width: 576px) {\n  .pf-c-toolbar.pf-m-inset-none-on-sm {\n    --pf-c-toolbar--inset: 0;\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-sm-on-sm {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--sm);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-md-on-sm {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--md);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-lg-on-sm {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--lg);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-xl-on-sm {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--xl);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-2xl-on-sm {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--2xl);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-toolbar.pf-m-inset-none-on-md {\n    --pf-c-toolbar--inset: 0;\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-sm-on-md {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--sm);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-md-on-md {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--md);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-lg-on-md {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--lg);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-xl-on-md {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--xl);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-2xl-on-md {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--2xl);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-toolbar.pf-m-inset-none-on-lg {\n    --pf-c-toolbar--inset: 0;\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-sm-on-lg {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--sm);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-md-on-lg {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--md);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-lg-on-lg {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--lg);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-xl-on-lg {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--xl);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-2xl-on-lg {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--2xl);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-toolbar.pf-m-inset-none-on-xl {\n    --pf-c-toolbar--inset: 0;\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-sm-on-xl {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--sm);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-md-on-xl {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--md);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-lg-on-xl {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--lg);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-xl-on-xl {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--xl);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-2xl-on-xl {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--2xl);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-toolbar.pf-m-inset-none-on-2xl {\n    --pf-c-toolbar--inset: 0;\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-sm-on-2xl {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--sm);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-md-on-2xl {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--md);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-lg-on-2xl {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--lg);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-xl-on-2xl {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--xl);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n  .pf-c-toolbar.pf-m-inset-2xl-on-2xl {\n    --pf-c-toolbar--inset: var(--pf-global--spacer--2xl);\n    --pf-c-toolbar__content--PaddingRight: var(--pf-c-toolbar--inset);\n    --pf-c-toolbar__content--PaddingLeft: var(--pf-c-toolbar--inset);\n  }\n}\n\n.pf-c-toolbar__content-section > :last-child {\n  --pf-c-toolbar--spacer: 0;\n}";

// src/elements/table/TableSearch.ts
var TableSearch = class extends AKElement {
  static get styles() {
    return [
      patternfly_base_default,
      button_default,
      toolbar_default,
      input_group_default,
      form_control_default,
      i`
                ::-webkit-search-cancel-button {
                    display: none;
                }
            `
    ];
  }
  render() {
    return ke`<form
            class="pf-c-input-group"
            method="GET"
            @submit=${(e) => {
      e.preventDefault();
      if (!this.onSearch) return;
      const el = this.shadowRoot?.querySelector("input[type=search]");
      if (!el) return;
      if (el.value === "") return;
      this.onSearch(el?.value);
    }}
        >
            <input
                class="pf-c-form-control"
                name="search"
                type="search"
                placeholder=${msg("Search...")}
                value="${to(this.value)}"
                @search=${(ev) => {
      if (!this.onSearch) return;
      this.onSearch(ev.target.value);
    }}
            />
            <button
                class="pf-c-button pf-m-control"
                type="reset"
                @click=${() => {
      if (!this.onSearch) return;
      this.onSearch("");
    }}
            >
                <i class="fas fa-times" aria-hidden="true"></i>
            </button>
            <button class="pf-c-button pf-m-control" type="submit">
                <i class="fas fa-search" aria-hidden="true"></i>
            </button>
        </form>`;
  }
};
__decorateClass([
  n()
], TableSearch.prototype, "value", 2);
__decorateClass([
  n()
], TableSearch.prototype, "onSearch", 2);
TableSearch = __decorateClass([
  t("ak-table-search")
], TableSearch);

// node_modules/@patternfly/patternfly/components/Switch/switch.css
var switch_default = '.pf-c-switch {\n  --pf-c-switch--FontSize: var(--pf-global--FontSize--md);\n  --pf-c-switch__label--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-switch--ColumnGap: var(--pf-c-switch__label--PaddingLeft);\n  --pf-c-switch__toggle-icon--FontSize: calc(var(--pf-c-switch--FontSize) * .625);\n  --pf-c-switch__toggle-icon--Color: var(--pf-global--Color--light-100);\n  --pf-c-switch__toggle-icon--Left: calc(var(--pf-c-switch--FontSize) * .4);\n  --pf-c-switch__toggle-icon--Offset: 0.125rem;\n  --pf-c-switch--LineHeight: var(--pf-global--LineHeight--md);\n  --pf-c-switch--Height: auto;\n  --pf-c-switch__input--checked__toggle--BackgroundColor: var(--pf-global--primary-color--100);\n  --pf-c-switch__input--checked__toggle--before--TranslateX: calc(100% + var(--pf-c-switch__toggle-icon--Offset));\n  --pf-c-switch__input--checked__label--Color: var(--pf-global--Color--dark-100);\n  --pf-c-switch__input--not-checked__label--Color: var(--pf-global--disabled-color--100);\n  --pf-c-switch__input--disabled__label--Color: var(--pf-global--disabled-color--100);\n  --pf-c-switch__input--disabled__toggle--BackgroundColor: var(--pf-global--disabled-color--200);\n  --pf-c-switch__input--disabled__toggle--before--BackgroundColor: var(--pf-global--palette--black-150);\n  --pf-c-switch__input--focus__toggle--OutlineWidth: var(--pf-global--BorderWidth--md);\n  --pf-c-switch__input--focus__toggle--OutlineOffset: var(--pf-global--spacer--sm);\n  --pf-c-switch__input--focus__toggle--OutlineColor: var(--pf-global--primary-color--100);\n  --pf-c-switch__toggle--Height: calc(var(--pf-c-switch--FontSize) * var(--pf-c-switch--LineHeight));\n  --pf-c-switch__toggle--BackgroundColor: var(--pf-global--palette--black-500);\n  --pf-c-switch__toggle--BorderRadius: var(--pf-c-switch__toggle--Height);\n  --pf-c-switch__toggle--before--Width: calc(var(--pf-c-switch--FontSize) - var(--pf-c-switch__toggle-icon--Offset));\n  --pf-c-switch__toggle--before--Height: var(--pf-c-switch__toggle--before--Width);\n  --pf-c-switch__toggle--before--Top: calc((var(--pf-c-switch__toggle--Height) - var(--pf-c-switch__toggle--before--Height)) / 2);\n  --pf-c-switch__toggle--before--Left: var(--pf-c-switch__toggle--before--Top);\n  --pf-c-switch__toggle--before--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-switch__toggle--before--BorderRadius: var(--pf-global--BorderRadius--lg);\n  --pf-c-switch__toggle--before--BoxShadow: var(--pf-global--BoxShadow--md);\n  --pf-c-switch__toggle--before--Transition: transform .25s ease 0s;\n  --pf-c-switch__toggle--Width: calc(var(--pf-c-switch__toggle--Height) + var(--pf-c-switch__toggle-icon--Offset) + var(--pf-c-switch__toggle--before--Width));\n  --pf-c-switch__label--Color: var(--pf-global--Color--dark-100);\n  position: relative;\n  display: inline-grid;\n  grid-template-columns: auto;\n  grid-auto-columns: 1fr;\n  column-gap: var(--pf-c-switch--ColumnGap);\n  height: var(--pf-c-switch--Height);\n  font-size: var(--pf-c-switch--FontSize);\n  line-height: var(--pf-c-switch--LineHeight);\n  vertical-align: middle;\n  cursor: pointer;\n}\n.pf-c-switch.pf-m-reverse .pf-c-switch__label,\n.pf-c-switch.pf-m-reverse .pf-c-switch__toggle {\n  grid-row: 1;\n}\n.pf-c-switch.pf-m-reverse .pf-c-switch__label {\n  grid-column: 1;\n}\n\n.pf-c-switch__input {\n  position: absolute;\n  cursor: pointer;\n  opacity: 0;\n}\n.pf-c-switch__input:focus ~ .pf-c-switch__toggle {\n  outline: var(--pf-c-switch__input--focus__toggle--OutlineWidth) solid var(--pf-c-switch__input--focus__toggle--OutlineColor);\n  outline-offset: var(--pf-c-switch__input--focus__toggle--OutlineOffset);\n}\n.pf-c-switch__input:checked ~ .pf-c-switch__label {\n  color: var(--pf-c-switch__input--checked__label--Color);\n}\n.pf-c-switch__input:checked ~ .pf-c-switch__toggle {\n  background-color: var(--pf-c-switch__input--checked__toggle--BackgroundColor);\n}\n.pf-c-switch__input:checked ~ .pf-c-switch__toggle::before {\n  transform: translateX(var(--pf-c-switch__input--checked__toggle--before--TranslateX));\n}\n.pf-c-switch__input:checked ~ .pf-m-off {\n  display: none;\n}\n.pf-c-switch__input:not(:checked) ~ .pf-c-switch__label {\n  color: var(--pf-c-switch__input--not-checked__label--Color);\n}\n.pf-c-switch__input:not(:checked) ~ .pf-c-switch__toggle .pf-c-switch__toggle-icon {\n  display: none;\n  visibility: hidden;\n}\n.pf-c-switch__input:not(:checked) ~ .pf-m-on {\n  display: none;\n}\n.pf-c-switch__input:disabled {\n  cursor: not-allowed;\n}\n.pf-c-switch__input:disabled ~ .pf-c-switch__label {\n  color: var(--pf-c-switch__input--disabled__label--Color);\n  cursor: not-allowed;\n}\n.pf-c-switch__input:disabled ~ .pf-c-switch__toggle {\n  cursor: not-allowed;\n  background-color: var(--pf-c-switch__input--disabled__toggle--BackgroundColor);\n}\n.pf-c-switch__input:disabled ~ .pf-c-switch__toggle::before {\n  background-color: var(--pf-c-switch__input--disabled__toggle--before--BackgroundColor);\n}\n\n.pf-c-switch__toggle {\n  position: relative;\n  display: inline-block;\n  width: var(--pf-c-switch__toggle--Width);\n  height: var(--pf-c-switch__toggle--Height);\n  background-color: var(--pf-c-switch__toggle--BackgroundColor);\n  border-radius: var(--pf-c-switch__toggle--BorderRadius);\n}\n.pf-c-switch__toggle::before {\n  position: absolute;\n  top: var(--pf-c-switch__toggle--before--Top);\n  left: var(--pf-c-switch__toggle--before--Left);\n  display: block;\n  width: var(--pf-c-switch__toggle--before--Width);\n  height: var(--pf-c-switch__toggle--before--Height);\n  content: "";\n  background-color: var(--pf-c-switch__toggle--before--BackgroundColor);\n  border-radius: var(--pf-c-switch__toggle--before--BorderRadius);\n  box-shadow: var(--pf-c-switch__toggle--before--BoxShadow);\n  transition: var(--pf-c-switch__toggle--before--Transition);\n}\n\n.pf-c-switch__toggle-icon {\n  position: absolute;\n  top: 0;\n  bottom: 0;\n  left: var(--pf-c-switch__toggle-icon--Left);\n  display: flex;\n  align-items: center;\n  font-size: var(--pf-c-switch__toggle-icon--FontSize);\n  color: var(--pf-c-switch__toggle-icon--Color);\n}\n\n.pf-c-switch__label {\n  display: inline-block;\n  grid-column: 2;\n  color: var(--pf-c-switch__label--Color);\n  vertical-align: top;\n}\n\n:where(.pf-theme-dark) .pf-c-switch {\n  --pf-c-switch__toggle-icon--Color: var(--pf-global--BackgroundColor--100);\n  --pf-c-switch__input--not-checked__label--Color: var(--pf-global--Color--100);\n  --pf-c-switch__input--disabled__toggle--before--BackgroundColor: var(--pf-global--disabled-color--100);\n  --pf-c-switch__toggle--before--BoxShadow: none;\n}';

// node_modules/@patternfly/patternfly/layouts/Bullseye/bullseye.css
var bullseye_default = ".pf-l-bullseye {\n  --pf-l-bullseye--Padding: 0;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  height: 100%;\n  padding: var(--pf-l-bullseye--Padding);\n  margin: 0;\n}";

// src/elements/table/Table.ts
var TableColumn = class {
  constructor(title, orderBy) {
    this.title = title;
    this.orderBy = orderBy;
  }
  headerClickHandler(table) {
    if (!this.orderBy) {
      return;
    }
    table.order = table.order === this.orderBy ? `-${this.orderBy}` : this.orderBy;
    table.fetch();
  }
  getSortIndicator(table) {
    switch (table.order) {
      case this.orderBy:
        return "fa-long-arrow-alt-down";
      case `-${this.orderBy}`:
        return "fa-long-arrow-alt-up";
      default:
        return "fa-arrows-alt-v";
    }
  }
  renderSortable(table) {
    return ke` <button
            class="pf-c-table__button"
            @click=${() => this.headerClickHandler(table)}
        >
            <div class="pf-c-table__button-content">
                <span class="pf-c-table__text">${this.title}</span>
                <span class="pf-c-table__sort-indicator">
                    <i class="fas ${this.getSortIndicator(table)}"></i>
                </span>
            </div>
        </button>`;
  }
  render(table) {
    const classes = {
      "pf-c-table__sort": !!this.orderBy,
      "pf-m-selected": table.order === this.orderBy || table.order === `-${this.orderBy}`
    };
    return ke`<th role="columnheader" scope="col" class="${Rt(classes)}">
            ${this.orderBy ? this.renderSortable(table) : ke`${this.title}`}
        </th>`;
  }
};
var Table = class extends AKElement {
  constructor() {
    super();
    this.isLoading = false;
    this.page = getURLParam("tablePage", 1);
    this.clearOnRefresh = false;
    this.search = "";
    this.checkbox = false;
    this.clickable = false;
    this.clickHandler = () => {
    };
    this.radioSelect = false;
    this.checkboxChip = false;
    this.selectedElements = [];
    this.paginated = true;
    this.expandable = false;
    this.expandedElements = [];
    this.addEventListener(EVENT_REFRESH, async () => {
      await this.fetch();
      if (this.clearOnRefresh) {
        this.selectedElements = [];
      }
    });
    if (this.searchEnabled()) {
      this.search = getURLParam("search", "");
    }
  }
  searchEnabled() {
    return false;
  }
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  renderExpanded(item) {
    if (this.expandable) {
      throw new Error("Expandable is enabled but renderExpanded is not overridden!");
    }
    return ke``;
  }
  static get styles() {
    return [
      patternfly_base_default,
      table_default,
      bullseye_default,
      button_default,
      switch_default,
      toolbar_default,
      dropdown_default,
      pagination_default,
      i`
                .pf-c-table thead .pf-c-table__check {
                    min-width: 3rem;
                }
                .pf-c-table tbody .pf-c-table__check input {
                    margin-top: calc(var(--pf-c-table__check--input--MarginTop) + 1px);
                }
                .pf-c-toolbar__content {
                    row-gap: var(--pf-global--spacer--sm);
                }
                .pf-c-toolbar__item .pf-c-input-group {
                    padding: 0 var(--pf-global--spacer--sm);
                }
            `
    ];
  }
  async defaultEndpointConfig() {
    return {
      ordering: this.order,
      page: this.page,
      pageSize: (await uiConfig()).pagination.perPage,
      search: this.searchEnabled() ? this.search || "" : void 0
    };
  }
  groupBy(items) {
    return groupBy(items, () => {
      return "";
    });
  }
  async fetch() {
    if (this.isLoading) {
      return;
    }
    this.isLoading = true;
    try {
      this.data = await this.apiEndpoint();
      this.error = void 0;
      this.page = this.data.pagination.current;
      const newExpanded = [];
      this.data.results.forEach((res) => {
        const jsonRes = JSON.stringify(res);
        let comp = (item) => {
          return JSON.stringify(item) === jsonRes;
        };
        if (Object.hasOwn(res, "pk")) {
          comp = (item) => {
            return item.pk === res.pk;
          };
        }
        const expandedIndex = this.expandedElements.findIndex(comp);
        if (expandedIndex > -1) {
          newExpanded.push(res);
        }
      });
      this.isLoading = false;
      this.expandedElements = newExpanded;
    } catch (ex) {
      this.isLoading = false;
      this.error = await parseAPIError(ex);
    }
  }
  renderLoading() {
    return ke`<tr role="row">
            <td role="cell" colspan="25">
                <div class="pf-l-bullseye">
                    <ak-empty-state loading header=${msg("Loading")}> </ak-empty-state>
                </div>
            </td>
        </tr>`;
  }
  renderEmpty(inner) {
    return ke`<tbody role="rowgroup">
            <tr role="row">
                <td role="cell" colspan="8">
                    <div class="pf-l-bullseye">
                        ${inner ?? ke`<ak-empty-state header="${msg("No objects found.")}"
                            ><div slot="primary">${this.renderObjectCreate()}</div>
                        </ak-empty-state>`}
                    </div>
                </td>
            </tr>
        </tbody>`;
  }
  renderObjectCreate() {
    return ke``;
  }
  renderError() {
    return this.error ? ke`<ak-empty-state header="${msg("Failed to fetch objects.")}" icon="fa-times">
                  ${this.error instanceof ResponseError ? ke` <div slot="body">${this.error.message}</div> ` : ke`<div slot="body">${this.error.detail}</div>`}
              </ak-empty-state>` : ke``;
  }
  renderRows() {
    if (this.error) {
      return [this.renderEmpty(this.renderError())];
    }
    if (!this.data || this.isLoading) {
      return [this.renderLoading()];
    }
    if (this.data.pagination.count === 0) {
      return [this.renderEmpty()];
    }
    const groupedResults = this.groupBy(this.data.results);
    if (groupedResults.length === 1 && groupedResults[0][0] === "") {
      return this.renderRowGroup(groupedResults[0][1]);
    }
    return groupedResults.map(([group, items]) => {
      return ke`<thead>
                    <tr role="row">
                        <th role="columnheader" scope="row" colspan="200">${group}</th>
                    </tr>
                </thead>
                ${this.renderRowGroup(items)}`;
    });
  }
  renderRowGroup(items) {
    return items.map((item) => {
      const itemSelectHandler = (ev) => {
        const target = ev.target;
        if (ev instanceof PointerEvent && target.classList.contains("ignore-click")) {
          return;
        }
        const selected = this.selectedElements.includes(item);
        const checked = ev instanceof PointerEvent ? !selected : target.checked;
        if (checked && selected || !(checked || selected)) {
          return;
        }
        this.selectedElements = this.selectedElements.filter((i2) => i2 !== item);
        if (checked) {
          this.selectedElements.push(item);
        }
        const selectAllCheckbox = this.shadowRoot?.querySelector("[name=select-all]");
        if (selectAllCheckbox && this.selectedElements.length < 1) {
          selectAllCheckbox.checked = false;
        }
        this.requestUpdate();
      };
      const renderCheckbox = () => ke`<td class="pf-c-table__check" role="cell">
                    <label class="ignore-click"
                        ><input
                            type="checkbox"
                            class="ignore-click"
                            .checked=${this.selectedElements.includes(item)}
                            @input=${itemSelectHandler}
                            @click=${(ev) => {
        ev.stopPropagation();
      }}
                    /></label>
                </td>`;
      const handleExpansion = (ev) => {
        ev.stopPropagation();
        const expanded = this.expandedElements.includes(item);
        this.expandedElements = this.expandedElements.filter((i2) => i2 !== item);
        if (!expanded) {
          this.expandedElements.push(item);
        }
        this.requestUpdate();
      };
      const expandedClass = {
        "pf-m-expanded": this.expandedElements.includes(item)
      };
      const renderExpansion = () => {
        return ke`<td class="pf-c-table__toggle" role="cell">
                    <button
                        class="pf-c-button pf-m-plain ${Rt(expandedClass)}"
                        @click=${handleExpansion}
                    >
                        <div class="pf-c-table__toggle-icon">
                            &nbsp;<i class="fas fa-angle-down" aria-hidden="true"></i>&nbsp;
                        </div>
                    </button>
                </td>`;
      };
      return ke`<tbody role="rowgroup" class="${Rt(expandedClass)}">
                <tr
                    role="row"
                    class="${this.checkbox || this.clickable ? "pf-m-hoverable" : ""}"
                    @click=${this.clickable ? () => {
        this.clickHandler(item);
      } : itemSelectHandler}
                >
                    ${this.checkbox ? renderCheckbox() : ke``}
                    ${this.expandable ? renderExpansion() : ke``}
                    ${this.row(item).map((col) => {
        return ke`<td role="cell">${col}</td>`;
      })}
                </tr>
                <tr class="pf-c-table__expandable-row ${Rt(expandedClass)}" role="row">
                    <td></td>
                    ${this.expandedElements.includes(item) ? this.renderExpanded(item) : ke``}
                </tr>
            </tbody>`;
    });
  }
  renderToolbar() {
    return ke` ${this.renderObjectCreate()}
            <ak-spinner-button
                .callAction=${() => {
      return this.fetch();
    }}
                class="pf-m-secondary"
            >
                ${msg("Refresh")}</ak-spinner-button
            >`;
  }
  renderToolbarSelected() {
    return ke``;
  }
  renderToolbarAfter() {
    return ke``;
  }
  renderSearch() {
    const runSearch = (value) => {
      this.search = value;
      updateURLParams({
        search: value
      });
      this.fetch();
    };
    return !this.searchEnabled() ? ke`` : ke`<div class="pf-c-toolbar__group pf-m-search-filter">
                  <ak-table-search
                      class="pf-c-toolbar__item pf-m-search-filter"
                      value=${to(this.search)}
                      .onSearch=${runSearch}
                  >
                  </ak-table-search>
              </div>`;
  }
  renderToolbarContainer() {
    return ke`<div class="pf-c-toolbar">
            <div class="pf-c-toolbar__content">
                ${this.renderSearch()}
                <div class="pf-c-toolbar__bulk-select">${this.renderToolbar()}</div>
                <div class="pf-c-toolbar__group">${this.renderToolbarAfter()}</div>
                <div class="pf-c-toolbar__group">${this.renderToolbarSelected()}</div>
                ${this.paginated ? this.renderTablePagination() : ke``}
            </div>
        </div>`;
  }
  firstUpdated() {
    this.fetch();
  }
  /* The checkbox on the table header row that allows the user to "activate all on this page,"
   * "deactivate all on this page" with a single click.
   */
  renderAllOnThisPageCheckbox() {
    const checked = this.selectedElements.length === this.data?.results.length && this.selectedElements.length > 0;
    const onInput = (ev) => {
      this.selectedElements = ev.target.checked ? this.data?.results.slice(0) || [] : [];
    };
    return ke`<td class="pf-c-table__check" role="cell">
            <input
                name="select-all"
                type="checkbox"
                aria-label=${msg("Select all rows")}
                .checked=${checked}
                @input=${onInput}
            />
        </td>`;
  }
  /* For very large tables where the user is selecting a limited number of entries, we provide a
   * chip-based subtable at the top that shows the list of selected entries. Long text result in
   * ellipsized chips, which is sub-optimal.
   */
  renderSelectedChip(_item) {
    return ke``;
  }
  get needChipGroup() {
    return this.checkbox && this.checkboxChip;
  }
  renderChipGroup() {
    return ke`<ak-chip-group>
            ${this.selectedElements.map((el) => {
      return ke`<ak-chip>${this.renderSelectedChip(el)}</ak-chip>`;
    })}
        </ak-chip-group>`;
  }
  /* A simple pagination display, shown at both the top and bottom of the page. */
  renderTablePagination() {
    const handler = (page) => {
      updateURLParams({ tablePage: page });
      this.page = page;
      this.fetch();
    };
    return ke`
            <ak-table-pagination
                class="pf-c-toolbar__item pf-m-pagination"
                .pages=${this.data?.pagination}
                .pageChangeHandler=${handler}
            >
            </ak-table-pagination>
        `;
  }
  renderTable() {
    const renderBottomPagination = () => ke`<div class="pf-c-pagination pf-m-bottom">${this.renderTablePagination()}</div>`;
    return ke` ${this.needChipGroup ? this.renderChipGroup() : ke``}
            ${this.renderToolbarContainer()}
            <table class="pf-c-table pf-m-compact pf-m-grid-md pf-m-expandable">
                <thead>
                    <tr role="row">
                        ${this.checkbox ? this.renderAllOnThisPageCheckbox() : ke``}
                        ${this.expandable ? ke`<td role="cell"></td>` : ke``}
                        ${this.columns().map((col) => col.render(this))}
                    </tr>
                </thead>
                ${this.renderRows()}
            </table>
            ${this.paginated ? renderBottomPagination() : ke``}`;
  }
  render() {
    return this.renderTable();
  }
};
__decorateClass([
  n({ attribute: false })
], Table.prototype, "data", 2);
__decorateClass([
  n({ type: Number })
], Table.prototype, "page", 2);
__decorateClass([
  n({ attribute: "clear-on-refresh", type: Boolean, reflect: true })
], Table.prototype, "clearOnRefresh", 2);
__decorateClass([
  n({ type: String })
], Table.prototype, "order", 2);
__decorateClass([
  n({ type: String })
], Table.prototype, "search", 2);
__decorateClass([
  n({ type: Boolean })
], Table.prototype, "checkbox", 2);
__decorateClass([
  n({ type: Boolean })
], Table.prototype, "clickable", 2);
__decorateClass([
  n({ attribute: false })
], Table.prototype, "clickHandler", 2);
__decorateClass([
  n({ type: Boolean })
], Table.prototype, "radioSelect", 2);
__decorateClass([
  n({ type: Boolean })
], Table.prototype, "checkboxChip", 2);
__decorateClass([
  n({ attribute: false })
], Table.prototype, "selectedElements", 2);
__decorateClass([
  n({ type: Boolean })
], Table.prototype, "paginated", 2);
__decorateClass([
  n({ type: Boolean })
], Table.prototype, "expandable", 2);
__decorateClass([
  n({ attribute: false })
], Table.prototype, "expandedElements", 2);
__decorateClass([
  r()
], Table.prototype, "error", 2);

export {
  form_control_default,
  bullseye_default,
  RouteMatch,
  getURLParam,
  getURLParams,
  setURLParams,
  updateURLParams,
  pagination_default,
  input_group_default,
  toolbar_default,
  switch_default,
  TableColumn,
  Table
};
//# sourceMappingURL=chunk-APZGZXW5.js.map
