import {
  randomId
} from "./chunk-Y4CBTB76.js";
import {
  oo
} from "./chunk-UX7TDHO2.js";
import {
  form_default
} from "./chunk-DK5NYREA.js";
import {
  AKElement,
  CustomEmitterElement,
  n,
  patternfly_base_default,
  t
} from "./chunk-MKGIUSP2.js";
import {
  D,
  i,
  ke
} from "./chunk-BW7LVHGS.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// node_modules/@patternfly/patternfly/components/Radio/radio.css
var radio_default = ".pf-c-radio {\n  --pf-c-radio--GridGap: var(--pf-global--spacer--xs) var(--pf-global--spacer--sm);\n  --pf-c-radio__label--disabled--Color: var(--pf-global--disabled-color--100);\n  --pf-c-radio__label--Color: var(--pf-global--Color--100);\n  --pf-c-radio__label--FontWeight: var(--pf-global--FontWeight--normal);\n  --pf-c-radio__label--FontSize: var(--pf-global--FontSize--md);\n  --pf-c-radio__label--LineHeight: var(--pf-global--LineHeight--sm);\n  --pf-c-radio__input--Height: var(--pf-c-radio__label--FontSize);\n  --pf-c-radio__input--MarginTop: calc(((var(--pf-c-radio__label--FontSize) * var(--pf-c-radio__label--LineHeight)) - var(--pf-c-radio__input--Height)) / 2);\n  --pf-c-radio__input--first-child--MarginLeft: 0.0625rem;\n  --pf-c-radio__input--last-child--MarginRight: 0.0625rem;\n  --pf-c-radio__description--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-radio__description--Color: var(--pf-global--Color--200);\n  --pf-c-radio__body--MarginTop: var(--pf-global--spacer--sm);\n  display: grid;\n  grid-template-columns: auto 1fr;\n  grid-gap: var(--pf-c-radio--GridGap);\n  align-items: start;\n  justify-items: start;\n}\n.pf-c-radio.pf-m-standalone {\n  --pf-c-radio--GridGap: 0;\n  --pf-c-radio__input--Height: auto;\n  --pf-c-radio__input--MarginTop: 0;\n  display: inline-grid;\n  line-height: 1;\n}\n\n.pf-c-radio__label {\n  font-size: var(--pf-c-radio__label--FontSize);\n  font-weight: var(--pf-c-radio__label--FontWeight);\n  line-height: var(--pf-c-radio__label--LineHeight);\n  color: var(--pf-c-radio__label--Color);\n}\n\n.pf-c-radio__input {\n  height: var(--pf-c-radio__input--Height);\n  margin-top: var(--pf-c-radio__input--MarginTop);\n}\n.pf-c-radio__input:first-child {\n  margin-left: var(--pf-c-radio__input--first-child--MarginLeft);\n}\n.pf-c-radio__input:last-child {\n  margin-right: var(--pf-c-radio__input--last-child--MarginRight);\n}\n\n.pf-c-radio__description {\n  grid-column: 2;\n  font-size: var(--pf-c-radio__description--FontSize);\n  color: var(--pf-c-radio__description--Color);\n}\n\n.pf-c-radio__body {\n  grid-column: 2;\n  margin-top: var(--pf-c-radio__body--MarginTop);\n}\n\nlabel.pf-c-radio, .pf-c-radio__label,\n.pf-c-radio__input {\n  cursor: pointer;\n}\n\n.pf-c-radio__label:disabled, .pf-c-radio__label.pf-m-disabled,\n.pf-c-radio__input:disabled,\n.pf-c-radio__input.pf-m-disabled {\n  --pf-c-radio__label--Color: var(--pf-c-radio__label--disabled--Color);\n  cursor: not-allowed;\n}";

// src/elements/forms/Radio.ts
var Radio = class extends CustomEmitterElement(AKElement) {
  constructor() {
    super();
    this.options = [];
    this.name = "";
    this.renderRadio = this.renderRadio.bind(this);
    this.buildChangeHandler = this.buildChangeHandler.bind(this);
    this.internalId = this.name || `radio-${randomId(8)}`;
  }
  static get styles() {
    return [
      patternfly_base_default,
      radio_default,
      form_default,
      i`
                .pf-c-form__group-control {
                    padding-top: calc(
                        var(--pf-c-form--m-horizontal__group-label--md--PaddingTop) * 1.3
                    );
                }
                .pf-c-radio label,
                .pf-c-radio span {
                    user-select: none;
                }
            `
    ];
  }
  // Set the value if it's not set already. Property changes inside the `willUpdate()` method do
  // not trigger an element update.
  willUpdate() {
    if (!this.value) {
      const maybeDefault = this.options.filter((opt) => opt.default);
      if (maybeDefault.length > 0) {
        this.value = maybeDefault[0].value;
      }
    }
  }
  // When a user clicks on `type="radio"`, *two* events happen in rapid succession: the original
  // radio loses its setting, and the selected radio gains its setting. We want radio buttons to
  // present a unified event interface, so we prevent the event from triggering if the value is
  // already set.
  buildChangeHandler(option) {
    return (ev) => {
      ev.stopPropagation();
      if (option.disabled) {
        return;
      }
      this.value = option.value;
      this.dispatchCustomEvent("change", { value: option.value });
      this.dispatchCustomEvent("input", { value: option.value });
    };
  }
  renderRadio(option, index) {
    const elId = `${this.internalId}-${index}`;
    const handler = this.buildChangeHandler(option);
    return ke`<div class="pf-c-radio" @click=${handler}>
            <input
                class="pf-c-radio__input"
                type="radio"
                name="${this.name}"
                id=${elId}
                .checked=${option.value === this.value}
                .disabled=${option.disabled}
            />
            <label class="pf-c-radio__label" for=${elId}>${option.label}</label>
            ${option.description ? ke`<span class="pf-c-radio__description">${option.description}</span>` : D}
        </div>`;
  }
  render() {
    return ke`<div class="pf-c-form__group-control pf-m-stack">
            ${oo(this.options, this.renderRadio)}
        </div>`;
  }
};
__decorateClass([
  n({ attribute: false })
], Radio.prototype, "options", 2);
__decorateClass([
  n()
], Radio.prototype, "name", 2);
__decorateClass([
  n({ attribute: false })
], Radio.prototype, "value", 2);
Radio = __decorateClass([
  t("ak-radio")
], Radio);

export {
  radio_default
};
//# sourceMappingURL=chunk-EA2TUCZW.js.map
