import {
  propertyMappingsProvider,
  propertyMappingsSelector,
  renderForm,
  renderForm2,
  renderForm3,
  renderForm4,
  renderForm5,
  renderForm6
} from "./chunk-3B7GTLMQ.js";
import {
  Qt
} from "./chunk-AZMGESG2.js";
import {
  renderDescriptionList
} from "./chunk-5ZU5CEYW.js";
import {
  policyOptions
} from "./chunk-RKBUXRF5.js";
import {
  PoliciesApi
} from "./chunk-IUFGI55K.js";
import {
  progress_stepper_default,
  wizard_default
} from "./chunk-S3ILVWYD.js";
import {
  HorizontalLightComponent
} from "./chunk-WMKINSDI.js";
import {
  radio_default
} from "./chunk-EA2TUCZW.js";
import {
  SearchSelectBase
} from "./chunk-SXPKNFZF.js";
import {
  randomId,
  serializeForm
} from "./chunk-Y4CBTB76.js";
import {
  ProvidersApi
} from "./chunk-3PUBL4VQ.js";
import {
  SourcesApi
} from "./chunk-TBCAGHBB.js";
import {
  WithLicenseSummary
} from "./chunk-UY7EXP7Y.js";
import {
  FlowsInstancesListDesignationEnum
} from "./chunk-SRK74APZ.js";
import {
  oo
} from "./chunk-UX7TDHO2.js";
import {
  ModalButton,
  bound,
  form_default
} from "./chunk-DK5NYREA.js";
import {
  card_default
} from "./chunk-ITYWTYEW.js";
import {
  label_default
} from "./chunk-EEANTJCZ.js";
import {
  description_list_default
} from "./chunk-DJQHOO67.js";
import {
  bullseye_default,
  form_control_default,
  getURLParam,
  input_group_default,
  switch_default,
  toolbar_default
} from "./chunk-APZGZXW5.js";
import {
  table_default
} from "./chunk-K3AR7TXW.js";
import {
  empty_state_default,
  title_default
} from "./chunk-RBLHQ2MQ.js";
import {
  AKElement,
  ClientTypeEnum,
  CoreApi,
  CustomEmitterElement,
  DEFAULT_CONFIG,
  EVENT_REFRESH,
  LOCALSTORAGE_AUTHENTIK_KEY,
  MatchingModeEnum,
  N,
  ProviderModelEnum,
  ProxyMode,
  Rt,
  WithBrandConfig,
  alert_default,
  button_default,
  c,
  camelToSnake,
  content_default,
  convertToSlug,
  e,
  groupBy,
  i2,
  isSlug,
  n,
  n2,
  page_default,
  parseAPIError,
  patternfly_base_default,
  r,
  r2,
  se,
  t,
  to,
  z
} from "./chunk-MKGIUSP2.js";
import {
  D,
  Oe,
  Se,
  i,
  ke,
  msg,
  str
} from "./chunk-BW7LVHGS.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/components/ak-wizard/events.ts
var WizardNavigationEvent = class _WizardNavigationEvent extends Event {
  static {
    this.eventName = "ak-wizard-navigation";
  }
  constructor(destination, details) {
    super(_WizardNavigationEvent.eventName, { bubbles: true, composed: true });
    this.destination = destination;
    this.details = details;
  }
};
var WizardUpdateEvent = class _WizardUpdateEvent extends Event {
  static {
    this.eventName = "ak-wizard-update";
  }
  constructor(content) {
    super(_WizardUpdateEvent.eventName, { bubbles: true, composed: true });
    this.content = content;
  }
};
var WizardCloseEvent = class _WizardCloseEvent extends Event {
  static {
    this.eventName = "ak-wizard-close";
  }
  constructor() {
    super(_WizardCloseEvent.eventName, { bubbles: true, composed: true });
  }
};

// src/components/ak-wizard/WizardContexts.ts
var wizardStepContext = n2(
  Symbol("authentik-wizard-step-labels")
);

// src/components/ak-wizard/ak-wizard-steps.ts
var WizardStepsManager = class extends AKElement {
  constructor() {
    super();
    this.slots = [];
    this.wizardStepContext = new i2(this, {
      context: wizardStepContext,
      initialValue: {
        currentStep: void 0,
        stepLabels: []
      }
    });
    this.addEventListener(WizardNavigationEvent.eventName, this.onNavigation);
    this.addEventListener("slotchange", this.onSlotchange);
  }
  findSlots() {
    this.slots = Array.from(this.querySelectorAll("[slot]"));
  }
  findSlot(name) {
    const target = this.slots.find((slot) => slot.slot === name);
    if (!target) {
      throw new Error(`Request for wizard panel that does not exist: ${name}`);
    }
    return target;
  }
  get stepLabels() {
    return this.slots.filter((slot) => !slot.hide).map((slot) => ({
      label: slot.label,
      id: slot.slot,
      active: true,
      enabled: slot.enabled
    }));
  }
  findStepLabels() {
    this.wizardStepContext.setValue({
      ...this.wizardStepContext.value,
      stepLabels: this.stepLabels
    });
  }
  connectedCallback() {
    super.connectedCallback();
    this.findSlots();
    this.findStepLabels();
    if (!this.currentStep && this.slots.length > 0) {
      const currentStep = this.slots[0].getAttribute("slot");
      if (!currentStep) {
        throw new Error("All steps managed by this component must have a slot definition.");
      }
      this.currentStep = currentStep;
      this.wizardStepContext.setValue({
        stepLabels: this.stepLabels,
        currentStep
      });
    }
  }
  onSlotchange(ev) {
    ev.stopPropagation();
    this.findSlots();
    this.findSlot(this.currentStep);
    this.findStepLabels();
  }
  // This event sequence handles the following possibilities:
  // - The user on a step validated and wants to move forward. We want to make sure the *next*
  //   step in enabled.
  // - The user went *back* and changed a step and it is no longer valid. We want to disable all
  //   future steps until that is corrected. Yes, in this case the flow is "Now you have to go
  //   through the entire wizard," but since the user invalidated a prior, that shouldn't be
  //   unexpected.  None of the data will have been lost.
  updateStepAvailability(details) {
    const asArr = (v) => v === void 0 ? [] : Array.isArray(v) ? v : [v];
    const enabled = asArr(details.enable);
    enabled.forEach((name) => {
      this.findSlot(name).enabled = true;
    });
    if (details.disabled !== void 0) {
      const disabled = asArr(details.disabled);
      this.slots.forEach((slot) => {
        slot.enabled = !disabled.includes(slot.slot);
      });
    }
    if (details.hidden !== void 0) {
      const hidden = asArr(details.hidden);
      this.slots.forEach((slot) => {
        slot.hide = hidden.includes(slot.slot);
      });
    }
  }
  onNavigation(ev) {
    ev.stopPropagation();
    const { destination, details } = ev;
    if (details) {
      this.updateStepAvailability(details);
    }
    if (!destination) {
      return;
    }
    const target = this.slots.find((slot) => slot.slot === destination);
    if (!target) {
      throw new Error(`Attempted to navigate to unknown step: ${destination}`);
    }
    if (!target.enabled) {
      throw new Error(`Attempted to navigate to disabled step: ${destination}`);
    }
    if (target.slot === this.currentStep) {
      return;
    }
    this.currentStep = target.slot;
    this.wizardStepContext.setValue({
      stepLabels: this.stepLabels,
      currentStep: target.slot
    });
  }
  render() {
    return this.currentStep ? ke`<slot name=${this.currentStep}></slot>` : D;
  }
  firstUpdated() {
    this.findStepLabels();
  }
};
__decorateClass([
  n({ type: String, attribute: true })
], WizardStepsManager.prototype, "currentStep", 2);
__decorateClass([
  bound
], WizardStepsManager.prototype, "onSlotchange", 1);
__decorateClass([
  bound
], WizardStepsManager.prototype, "onNavigation", 1);
WizardStepsManager = __decorateClass([
  t("ak-wizard-steps")
], WizardStepsManager);

// src/admin/applications/wizard/ContextIdentity.ts
var applicationWizardProvidersContext = n2(
  Symbol("ak-application-wizard-providers-context")
);

// src/admin/applications/wizard/steps/ProviderChoices.ts
var providerTypeRenderers = {
  oauth2provider: {
    render: () => ke`<ak-application-wizard-authentication-by-oauth></ak-application-wizard-authentication-by-oauth>`,
    order: 90
  },
  ldapprovider: {
    render: () => ke`<ak-application-wizard-authentication-by-ldap></ak-application-wizard-authentication-by-ldap>`,
    order: 70
  },
  proxyprovider: {
    render: () => ke`<ak-application-wizard-authentication-for-reverse-proxy></ak-application-wizard-authentication-for-reverse-proxy>`,
    order: 75
  },
  racprovider: {
    render: () => ke`<ak-application-wizard-authentication-for-rac></ak-application-wizard-authentication-for-rac>`,
    order: 80
  },
  samlprovider: {
    render: () => ke`<ak-application-wizard-authentication-by-saml-configuration></ak-application-wizard-authentication-by-saml-configuration>`,
    order: 80
  },
  radiusprovider: {
    render: () => ke`<ak-application-wizard-authentication-by-radius></ak-application-wizard-authentication-by-radius>`,
    order: 70
  },
  scimprovider: {
    render: () => ke`<ak-application-wizard-authentication-by-scim></ak-application-wizard-authentication-by-scim>`,
    order: 60
  }
};

// src/admin/applications/wizard/ApplicationWizardFormStepStyles.css.ts
var styles = [
  patternfly_base_default,
  card_default,
  button_default,
  form_default,
  alert_default,
  radio_default,
  input_group_default,
  form_control_default,
  switch_default,
  wizard_default,
  i`
        select[multiple] {
            height: 15em;
        }
    `
];

// src/components/ak-wizard/WizardStep.ts
var isNavigable = (b) => "destination" in b && typeof b.destination === "string" && b.destination.length > 0;
var BUTTON_KIND_TO_CLASS = {
  next: "pf-m-primary",
  back: "pf-m-secondary",
  close: "pf-m-link",
  cancel: "pf-m-link"
};
var BUTTON_KIND_TO_LABEL = {
  next: msg("Next"),
  back: msg("Back"),
  cancel: msg("Cancel"),
  close: msg("Close")
};
var WizardStep = class extends AKElement {
  constructor() {
    super(...arguments);
    this.enabled = false;
    this.wizardStepState = { currentStep: void 0, stepLabels: [] };
    /**
     * What appears in the titlebar of the Wizard. Usually, but not necessarily, the same for all
     * steps. Recommendation: Set this, the description, and `canCancel` in a subclass, and stop
     * worrying about them.
     */
    this.wizardTitle = "--unset--";
    /**
     * Show the [Cancel] icon and offer the [Cancel] button
     */
    this.canCancel = false;
    /**
     * The ID of the current step.
     */
    this.id = "";
    /**
     *The label of the current step.  Displayed in the navigation bar.
     */
    this.label = "--unset--";
    /**
     * If true, this step's label will not be shown in the navigation bar
     */
    this.hide = false;
  }
  // These additions are necessary because we don't want to inherit *all* of the modal box
  // modifiers, just the ones related to managing the height of the display box.
  static get styles() {
    return [
      wizard_default,
      content_default,
      title_default,
      i`
                .ak-wizard-box {
                    height: 75%;
                    height: 75vh;
                    display: flex;
                    flex-direction: column;
                    position: relative;
                    z-index: 500;
                }
            `
    ];
  }
  //  ___      _    _ _        _   ___ ___
  // | _ \_  _| |__| (_)__    /_\ | _ \_ _|
  // |  _/ || | '_ \ | / _|  / _ \|  _/| |
  // |_|  \_,_|_.__/_|_\__| /_/ \_\_| |___|
  //
  // Override this and provide the buttons for this step. The button type is documented in the
  // [types](./types.ts) file, but in short, there are four "kinds": "next", "back", "cancel", and
  // "close."
  get buttons() {
    return [];
  }
  // Override this to provide the form.
  renderMain() {
    throw new Error("This must be overridden in client classes");
  }
  // Override this to intercept 'next' and 'back' events, perform validation, and include enabling
  // before allowing navigation to continue.
  handleButton(button, details) {
    if (["close", "cancel"].includes(button.kind)) {
      this.dispatchEvent(new WizardCloseEvent());
      return;
    }
    if (isNavigable(button)) {
      this.dispatchEvent(new WizardNavigationEvent(button.destination, details));
      return;
    }
    throw new Error(`Incoherent button passed: ${JSON.stringify(button, null, 2)}`);
  }
  handleEnabling(details) {
    this.dispatchEvent(new WizardNavigationEvent(void 0, details));
  }
  // END Public API
  connectedCallback() {
    super.connectedCallback();
    if (!this.name) {
      const name = this.getAttribute("slot");
      if (!name) {
        throw new Error("Steps must have a unique slot attribute.");
      }
      this.name = name;
    }
  }
  onWizardNavigationEvent(ev, button) {
    ev.stopPropagation();
    if (!isNavigable(button)) {
      throw new Error("Non-navigable button sent to handleNavigationEvent");
    }
    this.handleButton(button);
  }
  onWizardCloseEvent(ev) {
    ev.stopPropagation();
    this.dispatchEvent(new WizardCloseEvent());
  }
  onSidebarNav(ev) {
    ev.stopPropagation();
    const target = ev.target.value;
    this.dispatchEvent(new WizardNavigationEvent(target));
  }
  getButtonLabel(button) {
    return button.label ?? BUTTON_KIND_TO_LABEL[button.kind];
  }
  getButtonClasses(button) {
    return {
      "pf-c-button": true,
      [BUTTON_KIND_TO_CLASS[button.kind]]: true
    };
  }
  renderCloseButton(button) {
    return ke`<div class="pf-c-wizard__footer-cancel">
            <button
                class=${Rt(this.getButtonClasses(button))}
                type="button"
                @click=${this.onWizardCloseEvent}
            >
                ${this.getButtonLabel(button)}
            </button>
        </div>`;
  }
  renderDisabledButton(button) {
    return ke`<button class=${Rt(this.getButtonClasses(button))} type="button" disabled>
            ${this.getButtonLabel(button)}
        </button>`;
  }
  renderNavigableButton(button) {
    return ke`<button
            class=${Rt(this.getButtonClasses(button))}
            type="button"
            @click=${(ev) => this.onWizardNavigationEvent(ev, button)}
            data-ouid-button-kind="wizard-${button.kind}"
        >
            ${this.getButtonLabel(button)}
        </button>`;
  }
  renderButton(button) {
    return z(button).with({ kind: N.union("close", "cancel") }, () => this.renderCloseButton(button)).with({ destination: N.string }, () => this.renderNavigableButton(button)).otherwise(() => {
      throw new Error("Button type is not close, disabled, or navigable?");
    });
  }
  renderHeaderCancelIcon() {
    return ke`<button
            class="pf-c-button pf-m-plain pf-c-wizard__close"
            type="button"
            aria-label="${msg("Close")}"
            @click=${this.onWizardCloseEvent}
        >
            <i class="fas fa-times" aria-hidden="true"></i>
        </button>`;
  }
  renderSidebarStep(step) {
    const buttonClasses = {
      "pf-c-wizard__nav-link": true,
      "pf-m-disabled": !step.enabled,
      "pf-m-current": step.id === this.wizardStepState.currentStep
    };
    return ke`
                <li class="pf-c-wizard__nav-item">
                    <button
                        class=${Rt(buttonClasses)}
                        ?disabled=${!step.enabled}
                        @click=${this.onSidebarNav}
                        value=${step.id}
                    >
                        ${step.label}
                    </button>
                </li>
            </div>
        `;
  }
  render() {
    return this.wizardStepState.currentStep === this.getAttribute("slot") ? ke` <div class="pf-c-modal-box ak-wizard-box">
                  <div class="pf-c-wizard">
                      <div class="pf-c-wizard__header" data-ouid-component-id="wizard-header">
                          ${this.canCancel ? this.renderHeaderCancelIcon() : D}
                          <h1 class="pf-c-title pf-m-3xl pf-c-wizard__title">
                              ${this.wizardTitle}
                          </h1>
                          <p class="pf-c-wizard__description">${this.wizardDescription}</p>
                      </div>

                      <div class="pf-c-wizard__outer-wrap">
                          <div class="pf-c-wizard__inner-wrap">
                              <nav class="pf-c-wizard__nav" data-ouid-component-id="wizard-navbar">
                                  <ol class="pf-c-wizard__nav-list">
                                      ${oo(
      this.wizardStepState.stepLabels,
      this.renderSidebarStep
    )}
                                  </ol>
                              </nav>
                              <main class="pf-c-wizard__main">
                                  <div
                                      id="main-content"
                                      class="pf-c-wizard__main-body"
                                      data-ouid-component-id="wizard-body"
                                  >
                                      ${this.renderMain()}
                                  </div>
                              </main>
                          </div>
                          <footer
                              class="pf-c-wizard__footer"
                              data-ouid-component-id="wizard-footer"
                          >
                              ${this.buttons.map(this.renderButton)}
                          </footer>
                      </div>
                  </div>
              </div>` : D;
  }
};
__decorateClass([
  n({ type: Boolean, attribute: true, reflect: true })
], WizardStep.prototype, "enabled", 2);
__decorateClass([
  n({ type: String, attribute: true, reflect: true })
], WizardStep.prototype, "name", 2);
__decorateClass([
  c({ context: wizardStepContext, subscribe: true })
], WizardStep.prototype, "wizardStepState", 2);
__decorateClass([
  bound
], WizardStep.prototype, "onWizardNavigationEvent", 1);
__decorateClass([
  bound
], WizardStep.prototype, "onWizardCloseEvent", 1);
__decorateClass([
  bound
], WizardStep.prototype, "onSidebarNav", 1);
__decorateClass([
  bound
], WizardStep.prototype, "renderCloseButton", 1);
__decorateClass([
  bound
], WizardStep.prototype, "renderDisabledButton", 1);
__decorateClass([
  bound
], WizardStep.prototype, "renderNavigableButton", 1);
__decorateClass([
  bound
], WizardStep.prototype, "renderButton", 1);
__decorateClass([
  bound
], WizardStep.prototype, "renderSidebarStep", 1);

// src/admin/applications/wizard/ApplicationWizardStep.ts
var ApplicationWizardStep = class extends WizardStep {
  constructor() {
    super(...arguments);
    // As recommended in [WizardStep](../../../components/ak-wizard/WizardStep.ts), we override
    // these fields and provide them to all the child classes.
    this.wizardTitle = msg("New application");
    this.wizardDescription = msg("Create a new application and configure a provider for it.");
    this.canCancel = true;
  }
  static get styles() {
    return [...WizardStep.styles, ...styles];
  }
  get formValues() {
    const elements = [
      ...Array.from(
        this.form.querySelectorAll("ak-form-element-horizontal")
      ),
      ...Array.from(this.form.querySelectorAll("[data-ak-control=true]"))
    ];
    return serializeForm(elements);
  }
  removeErrors(keyToDelete) {
    if (!this.wizard.errors) {
      return void 0;
    }
    const empty = {};
    const errors = Object.entries(this.wizard.errors).reduce(
      (acc, [key, value]) => key === keyToDelete || value === void 0 || Array.isArray(this.wizard?.errors?.[key]) && this.wizard.errors[key].length === 0 ? acc : { ...acc, [key]: value },
      empty
    );
    return errors;
  }
  // This pattern became visible during development, and the order is important: wizard updating
  // and validation must complete before navigation is attempted.
  handleUpdate(update, destination, enable) {
    if (update) {
      this.dispatchEvent(new WizardUpdateEvent(update));
    }
    if (destination || enable) {
      this.dispatchEvent(new WizardNavigationEvent(destination, enable));
    }
  }
};
__decorateClass([
  n({ type: Object, attribute: false })
], ApplicationWizardStep.prototype, "wizard", 2);
__decorateClass([
  e("form")
], ApplicationWizardStep.prototype, "form", 2);

// src/admin/applications/wizard/ak-wizard-title.ts
var AkWizardTitle = class extends AKElement {
  static get styles() {
    return [
      content_default,
      title_default,
      i`
                .ak-bottom-spacing {
                    padding-bottom: var(--pf-global--spacer--lg);
                }
            `
    ];
  }
  render() {
    return ke`<div class="ak-bottom-spacing pf-c-content">
            <h3><slot></slot></h3>
        </div>`;
  }
};
AkWizardTitle = __decorateClass([
  t("ak-wizard-title")
], AkWizardTitle);

// src/components/ak-slug-input.ts
var AkSlugInput = class extends HorizontalLightComponent {
  constructor() {
    super();
    this.value = "";
    this.source = "";
    this.touched = false;
    this.slugify = this.slugify.bind(this);
    this.handleTouch = this.handleTouch.bind(this);
  }
  firstUpdated() {
    this.input.addEventListener("input", this.handleTouch);
  }
  // Do not stop propagation of this event; it must be sent up the tree so that a parent
  // component, such as a custom forms manager, may receive it.
  handleTouch(ev) {
    this.input.value = convertToSlug(this.input.value);
    this.value = this.input.value;
    if (this.origin && this.origin.value === "" && this.input.value === "") {
      this.touched = false;
      return;
    }
    if (ev && ev.target && ev.target instanceof HTMLInputElement) {
      this.touched = true;
    }
  }
  slugify(ev) {
    if (!(ev && ev.target && ev.target instanceof HTMLInputElement)) {
      return;
    }
    if (ev.target.value === "" && this.input.value === "") {
      this.touched = false;
    }
    if (this.touched) {
      return;
    }
    const newSlug = convertToSlug(ev.target.value);
    const oldSlug = this.input.value;
    const [shorter, longer] = newSlug.length < oldSlug.length ? [newSlug, oldSlug] : [oldSlug, newSlug];
    if (longer.substring(0, shorter.length) !== shorter) {
      return;
    }
    this.value = this.input.value = newSlug;
    this.dispatchEvent(
      new Event("input", {
        bubbles: true,
        cancelable: true
      })
    );
  }
  connectedCallback() {
    super.connectedCallback();
    setTimeout(() => {
      if (this.source) {
        const rootNode = this.getRootNode();
        if (rootNode instanceof ShadowRoot || rootNode instanceof Document) {
          this.origin = rootNode.querySelector(this.source);
        }
        if (this.origin) {
          this.origin.addEventListener("input", this.slugify);
        }
      }
    }, 0);
  }
  disconnectedCallback() {
    if (this.origin) {
      this.origin.removeEventListener("input", this.slugify);
    }
    super.disconnectedCallback();
  }
  renderControl() {
    return ke`<input
            type="text"
            value=${to(this.value)}
            class="pf-c-form-control"
            ?required=${this.required}
        />`;
  }
};
__decorateClass([
  n({ type: String, reflect: true })
], AkSlugInput.prototype, "value", 2);
__decorateClass([
  n({ type: String })
], AkSlugInput.prototype, "source", 2);
__decorateClass([
  e("input")
], AkSlugInput.prototype, "input", 2);
AkSlugInput = __decorateClass([
  t("ak-slug-input")
], AkSlugInput);

// src/admin/applications/wizard/steps/ak-application-wizard-application-step.ts
var autoTrim = (v) => typeof v === "string" ? v.trim() : v;
var trimMany = (o2, vs) => Object.fromEntries(vs.map((v) => [v, autoTrim(o2[v])]));
var isStr = (v) => typeof v === "string";
var ApplicationWizardApplicationStep = class extends ApplicationWizardStep {
  constructor() {
    super();
    this.label = msg("Application");
    this.errors = /* @__PURE__ */ new Map();
    this.enabled = true;
  }
  errorMessages(name) {
    return this.errors.has(name) ? [this.errors.get(name)] : this.wizard.errors?.app?.[name] ?? this.wizard.errors?.app?.[camelToSnake(name)] ?? [];
  }
  get buttons() {
    return [{ kind: "next", destination: "provider-choice" }, { kind: "cancel" }];
  }
  get valid() {
    this.errors = /* @__PURE__ */ new Map();
    const values = trimMany(this.formValues ?? {}, ["metaLaunchUrl", "name", "slug"]);
    if (values["name"] === "") {
      this.errors.set("name", msg("An application name is required"));
    }
    if (!(isStr(values["metaLaunchUrl"]) && (values["metaLaunchUrl"] === "" || URL.canParse(values["metaLaunchUrl"])))) {
      this.errors.set("metaLaunchUrl", msg("Not a valid URL"));
    }
    if (!(isStr(values["slug"]) && values["slug"] !== "" && isSlug(values["slug"]))) {
      this.errors.set("slug", msg("Not a valid slug"));
    }
    return this.errors.size === 0;
  }
  handleButton(button) {
    if (button.kind === "next") {
      if (!this.valid) {
        this.handleEnabling({
          disabled: ["provider-choice", "provider", "bindings", "submit"]
        });
        return;
      }
      const app = this.formValues;
      let payload = {
        app: this.formValues,
        errors: this.removeErrors("app")
      };
      if (app.name && (this.wizard.provider?.name ?? "").trim() === "") {
        payload = {
          ...payload,
          provider: { name: `Provider for ${app.name}` }
        };
      }
      this.handleUpdate(payload, button.destination, {
        enable: "provider-choice"
      });
      return;
    }
    super.handleButton(button);
  }
  renderForm(app, errors) {
    return ke` <ak-wizard-title>${msg("Configure The Application")}</ak-wizard-title>
            <form id="applicationform" class="pf-c-form pf-m-horizontal" slot="form">
                <ak-text-input
                    name="name"
                    value=${to(app.name)}
                    label=${msg("Name")}
                    required
                    ?invalid=${this.errors.has("name")}
                    .errorMessages=${errors.name ?? this.errorMessages("name")}
                    help=${msg("Application's display Name.")}
                    id="ak-application-wizard-details-name"
                ></ak-text-input>
                <ak-slug-input
                    name="slug"
                    value=${to(app.slug)}
                    label=${msg("Slug")}
                    source="#ak-application-wizard-details-name"
                    required
                    ?invalid=${errors.slug ?? this.errors.has("slug")}
                    .errorMessages=${this.errorMessages("slug")}
                    help=${msg("Internal application name used in URLs.")}
                    inputHint="code"
                ></ak-slug-input>
                <ak-text-input
                    name="group"
                    value=${to(app.group)}
                    label=${msg("Group")}
                    .errorMessages=${errors.group ?? []}
                    help=${msg(
      "Optionally enter a group name. Applications with identical groups are shown grouped together."
    )}
                    inputHint="code"
                ></ak-text-input>
                <ak-radio-input
                    label=${msg("Policy engine mode")}
                    required
                    name="policyEngineMode"
                    .options=${policyOptions}
                    .value=${app.policyEngineMode}
                    .errorMessages=${errors.policyEngineMode ?? []}
                ></ak-radio-input>
                <ak-form-group aria-label=${msg("UI Settings")}>
                    <span slot="header"> ${msg("UI Settings")} </span>
                    <div slot="body" class="pf-c-form">
                        <ak-text-input
                            name="metaLaunchUrl"
                            label=${msg("Launch URL")}
                            value=${to(app.metaLaunchUrl)}
                            ?invalid=${this.errors.has("metaLaunchUrl")}
                            .errorMessages=${errors.metaLaunchUrl ?? this.errorMessages("metaLaunchUrl")}
                            help=${msg(
      "If left empty, authentik will try to extract the launch URL based on the selected provider."
    )}
                            inputHint="code"
                        ></ak-text-input>
                        <ak-switch-input
                            name="openInNewTab"
                            ?checked=${app.openInNewTab ?? false}
                            label=${msg("Open in new tab")}
                            help=${msg(
      "If checked, the launch URL will open in a new browser tab or window from the user's application library."
    )}
                        >
                        </ak-switch-input>
                    </div>
                </ak-form-group>
            </form>`;
  }
  renderMain() {
    if (!(this.wizard.app && this.wizard.errors)) {
      throw new Error("Application Step received uninitialized wizard context.");
    }
    return this.renderForm(
      this.wizard.app,
      this.wizard.errors?.app ?? {}
    );
  }
};
__decorateClass([
  r()
], ApplicationWizardApplicationStep.prototype, "errors", 2);
__decorateClass([
  e("form#applicationform")
], ApplicationWizardApplicationStep.prototype, "form", 2);
ApplicationWizardApplicationStep = __decorateClass([
  t("ak-application-wizard-application-step")
], ApplicationWizardApplicationStep);

// src/elements/ak-table/TableColumn.ts
var TableSortEvent = class _TableSortEvent extends Event {
  static {
    this.eventName = "tablesort";
  }
  constructor(value) {
    super(_TableSortEvent.eventName, { composed: true, bubbles: true });
    this.value = value;
  }
};
var TableColumn = class {
  constructor(value, orderBy, host) {
    this.value = value;
    this.orderBy = orderBy;
    if (host) {
      this.host = host;
    }
  }
  onSort() {
    if (this.host && this.orderBy) {
      this.host.dispatchEvent(new TableSortEvent(this.orderBy));
    }
  }
  sortIndicator(orderBy) {
    switch (orderBy) {
      case this.orderBy:
        return "fa-long-arrow-alt-down";
      case `-${this.orderBy}`:
        return "fa-long-arrow-alt-up";
      default:
        return "fa-arrows-alt-v";
    }
  }
  sortButton(orderBy) {
    return ke` <button class="pf-c-table__button" @click=${this.onSort}>
            <div class="pf-c-table__button-content">
                <span part="column-text" class="pf-c-table__text">${this.value}</span>
                <span part="column-sort" class="pf-c-table__sort-indicator">
                    <i class="fas ${this.sortIndicator(orderBy)}"></i>
                </span>
            </div>
        </button>`;
  }
  render(orderBy) {
    const isSelected = orderBy === this.orderBy || orderBy === `-${this.orderBy}`;
    const classes = {
      "pf-c-table__sort": Boolean(this.host && this.orderBy),
      "pf-m-selected": Boolean(this.host && isSelected)
    };
    return ke`<td
            part="column-item"
            role="columnheader"
            scope="col"
            class="${Rt(classes)}"
        >
            ${orderBy && this.orderBy ? this.sortButton(orderBy) : ke`${this.value}`}
        </td>`;
  }
};
__decorateClass([
  bound
], TableColumn.prototype, "onSort", 1);

// src/elements/ak-table/utils.ts
var isTableRows = (v) => Array.isArray(v) && v.length > 0 && typeof v[0] === "object" && v[0] !== null && !("kind" in v[0]) && "content" in v[0];
var isTableGrouped = (v) => typeof v === "object" && v !== null && "kind" in v && v.kind === "groups";
var isTableFlat = (v) => typeof v === "object" && v !== null && "kind" in v && v.kind === "flat";
function convertContent(content, { groupBy: groupBy2, keyBy } = {}) {
  if (isTableGrouped(content)) {
    if (groupBy2 || keyBy) {
      console.warn("Passed processor function when content is already marked as grouped");
    }
    return content;
  }
  if (isTableFlat(content)) {
    if (groupBy2 || keyBy) {
      console.warn("Passed processor function when content is already marked as flat");
    }
    return content;
  }
  if (isTableRows(content)) {
    if (groupBy2) {
      console.warn(
        "Passed processor function when content is processed and can't be analyzed for grouping"
      );
    }
    return {
      kind: "flat",
      content
    };
  }
  if (Array.isArray(content) && content.length === 0) {
    return {
      kind: "flat",
      content: []
    };
  }
  const templatizeAsNeeded = (rows) => rows.map((row) => ({
    ...keyBy ? { key: keyBy(row) } : {},
    content: row.map((item) => typeof item === "object" ? item : ke`${item}`)
  }));
  if (groupBy2) {
    const groupedContent = groupBy(content, groupBy2);
    return {
      kind: "groups",
      content: groupedContent.map(([group, rowsForGroup]) => ({
        kind: "group",
        group,
        content: templatizeAsNeeded(rowsForGroup)
      }))
    };
  }
  return {
    kind: "flat",
    content: templatizeAsNeeded(content)
  };
}

// src/elements/ak-table/ak-simple-table.ts
var SimpleTable = class extends AKElement {
  constructor() {
    super(...arguments);
    this.columns = [];
    this._content = {
      kind: "flat",
      content: []
    };
  }
  static get styles() {
    return [
      patternfly_base_default,
      table_default,
      i`
                .pf-c-table thead .pf-c-table__check {
                    min-width: 3rem;
                }
                .pf-c-table tbody .pf-c-table__check input {
                    margin-top: calc(var(--pf-c-table__check--input--MarginTop) + 1px);
                }
                .pf-c-toolbar__content {
                    row-gap: var(--pf-global--spacer--sm);
                }
                .pf-c-toolbar__item .pf-c-input-group {
                    padding: 0 var(--pf-global--spacer--sm);
                }
            `
    ];
  }
  set content(content) {
    this._content = convertContent(content);
  }
  get content() {
    return this._content;
  }
  get icolumns() {
    const hosted = (column) => {
      column.host = this;
      return column;
    };
    return this.columns.map(
      (column) => typeof column === "string" ? hosted(new TableColumn(column)) : Array.isArray(column) ? hosted(new TableColumn(...column)) : hosted(column)
    );
  }
  ouiaTypeDeclaration() {
    this.setAttribute("data-ouia-component-type", "ak-simple-table");
  }
  connectedCallback() {
    super.connectedCallback();
    this.ouiaTypeDeclaration();
    this.setAttribute("data-ouia-component-id", this.getAttribute("id") || randomId());
  }
  performUpdate() {
    this.removeAttribute("data-ouia-component-safe");
    super.performUpdate();
  }
  renderRow(row, _rownum) {
    return ke` <tr part="row">
            ${oo(
      row.content,
      (col, idx) => ke`<td part="cell cell-${idx}" role="cell">${col}</td>`
    )}
        </tr>`;
  }
  renderRows(rows) {
    return ke`<tbody part="body">
            ${Qt(rows, (row) => row.key, this.renderRow)}
        </tbody>`;
  }
  renderRowGroup({ group, content }) {
    return ke`<thead part="group-header">
                <tr part="group-row">
                    <td role="columnheader" scope="row" colspan="200" part="group-head">
                        ${group}
                    </td>
                </tr>
            </thead>
            ${this.renderRows(content)}`;
  }
  renderRowGroups(rowGroups) {
    return ke`${oo(rowGroups, this.renderRowGroup)}`;
  }
  renderBody() {
    return this.content.kind === "flat" ? this.renderRows(this.content.content) : this.renderRowGroups(this.content.content);
  }
  renderColumnHeaders() {
    return ke`<tr part="column-row" role="row">
            ${oo(this.icolumns, (col) => col.render(this.order))}
        </tr>`;
  }
  renderTable() {
    return ke`
            <table part="table" class="pf-c-table pf-m-compact pf-m-grid-md pf-m-expandable">
                <thead part="column-header">
                    ${this.renderColumnHeaders()}
                </thead>
                ${this.renderBody()}
            </table>
        `;
  }
  render() {
    return this.renderTable();
  }
  updated() {
    this.setAttribute("data-ouia-component-safe", "true");
  }
};
__decorateClass([
  n({ type: String, attribute: true, reflect: true })
], SimpleTable.prototype, "order", 2);
__decorateClass([
  n({ type: Array, attribute: false })
], SimpleTable.prototype, "columns", 2);
__decorateClass([
  n({ type: Object, attribute: false })
], SimpleTable.prototype, "content", 1);
__decorateClass([
  bound
], SimpleTable.prototype, "renderRowGroup", 1);
__decorateClass([
  bound
], SimpleTable.prototype, "renderRowGroups", 1);
SimpleTable = __decorateClass([
  t("ak-simple-table")
], SimpleTable);

// src/elements/ak-table/ak-select-table.ts
var SelectTable = class extends SimpleTable {
  constructor() {
    super(...arguments);
    this._value = "";
    this.multiple = false;
    this.valueSep = ";";
    this._selected = [];
  }
  set value(value) {
    this._value = value;
    this._selected = value.split(this.valueSep).filter((v) => v.trim() !== "");
  }
  get value() {
    return this._value;
  }
  set selected(selected) {
    this._selected = selected;
    this._value = this._selected.toSorted().join(this.valueSep);
  }
  get selected() {
    return this._selected;
  }
  json() {
    return this._selected;
  }
  get valuesOnPage() {
    return Array.from(this.selectCheckboxesOnPage).map((checkbox) => checkbox.value);
  }
  get checkedValuesOnPage() {
    return Array.from(this.selectCheckboxesOnPage).filter((checkbox) => checkbox.checked).map((checkbox) => checkbox.value);
  }
  get selectedOnPage() {
    return this.checkedValuesOnPage.filter((value) => this._selected.includes(value));
  }
  clear() {
    this.selected = [];
  }
  onSelect(ev) {
    ev.stopPropagation();
    const value = ev.target.value;
    if (this.multiple) {
      this.selected = this.selected.includes(value) ? this.selected.filter((v) => v !== value) : [...this.selected, value];
    } else {
      this.selected = this.selected.includes(value) ? [] : [value];
    }
    this.dispatchEvent(new Event("change"));
  }
  ouiaTypeDeclaration() {
    this.setAttribute("data-ouia-component-type", "ak-select-table");
  }
  connectedCallback() {
    super.connectedCallback();
    this.dataset.akControl = "true";
  }
  willUpdate(changed) {
    super.willUpdate(changed);
    this.setAttribute("value", this._value);
  }
  renderCheckbox(key) {
    if (key === void 0) {
      return ke`<td class="pf-c-table__check" role="cell"></td>`;
    }
    const checked = this.selected.includes(key);
    return ke`<td part="select-cell" class="pf-c-table__check" role="cell">
            <input
                type="checkbox"
                name="${key}"
                part="select-input"
                data-ouia-component-type="checkbox"
                data-ouia-component-role="select"
                value=${key}
                ?checked=${checked}
                .checked=${checked}
                @click=${this.onSelect}
            />
        </td>`;
  }
  renderRow(row, _rowidx) {
    return ke` <tr part="row">
            ${this.renderCheckbox(row.key)}
            ${oo(
      row.content,
      (col, idx) => ke`<td part="cell cell-${idx}" role="cell">${col}</td>`
    )}
        </tr>`;
  }
  renderAllOnThisPageCheckbox() {
    const checked = this.selectedOnPage.length && this.selectedOnPage.length === this.valuesOnPage.length;
    const onInput = (ev) => {
      const selected = [...this.selected];
      const values = this.valuesOnPage;
      this.selected = ev.target.checked ? (
        // add to `selected` all values not already present
        [...selected, ...values.filter((i3) => !selected.includes(i3))]
      ) : (
        // remove from `selected` all values present
        this.selected.filter((i3) => !values.includes(i3))
      );
    };
    return ke`<td part="select-all-header" class="pf-c-table__check" role="cell">
            <input
                part="select-all-input"
                name="select-all-input"
                type="checkbox"
                aria-label=${msg("Select all rows")}
                .checked=${checked}
                @input=${onInput}
            />
        </td>`;
  }
  // This override makes room for the select checkbox.
  renderColumnHeaders() {
    return ke`<tr part="column-row" role="row">
            ${this.multiple ? this.renderAllOnThisPageCheckbox() : ke`<td></td>`}
            ${oo(this.icolumns, (col) => col.render(this.order))}
        </tr>`;
  }
};
__decorateClass([
  n({ type: String, attribute: true, reflect: true })
], SelectTable.prototype, "value", 1);
__decorateClass([
  n({ type: Boolean, attribute: true })
], SelectTable.prototype, "multiple", 2);
__decorateClass([
  n({ type: String, attribute: true })
], SelectTable.prototype, "valueSep", 2);
__decorateClass([
  n({ attribute: false })
], SelectTable.prototype, "selected", 1);
__decorateClass([
  r2('input[data-ouia-component-role="select"]')
], SelectTable.prototype, "selectCheckboxesOnPage", 2);
__decorateClass([
  bound
], SelectTable.prototype, "onSelect", 1);
__decorateClass([
  bound
], SelectTable.prototype, "renderRow", 1);
SelectTable = __decorateClass([
  t("ak-select-table")
], SelectTable);

// src/admin/applications/wizard/steps/bindings/ak-application-wizard-bindings-edit-button.ts
var ApplicationWizardBindingStepEditButton = class extends AKElement {
  constructor() {
    super(...arguments);
    this.value = -1;
  }
  static get styles() {
    return [button_default];
  }
  onClick(ev) {
    ev.stopPropagation();
    this.dispatchEvent(
      new CustomEvent("click-edit", {
        bubbles: true,
        composed: true,
        detail: this.value
      })
    );
  }
  render() {
    return ke`<button class="pf-c-button pf-c-secondary" @click=${this.onClick}>
            ${msg("Edit")}
        </button>`;
  }
};
__decorateClass([
  n({ type: Number })
], ApplicationWizardBindingStepEditButton.prototype, "value", 2);
__decorateClass([
  bound
], ApplicationWizardBindingStepEditButton.prototype, "onClick", 1);
ApplicationWizardBindingStepEditButton = __decorateClass([
  t("ak-application-wizard-binding-step-edit-button")
], ApplicationWizardBindingStepEditButton);
function makeEditButton(label, value, handler) {
  return ke`<ak-application-wizard-binding-step-edit-button
        class="pf-c-button pf-m-secondary"
        .value=${value}
        @click-edit=${handler}
    >
        ${label}
    </ak-application-wizard-binding-step-edit-button>`;
}

// src/admin/applications/wizard/steps/bindings/ak-application-wizard-bindings-toolbar.ts
var ApplicationWizardBindingsToolbar = class extends AKElement {
  constructor() {
    super(...arguments);
    this.canDelete = false;
  }
  static get styles() {
    return [patternfly_base_default, button_default, toolbar_default];
  }
  notify(eventName) {
    this.dispatchEvent(new Event(eventName, { bubbles: true, composed: true }));
  }
  render() {
    return ke`
            <div class="pf-c-toolbar">
                <div class="pf-c-toolbar__content">
                    <div class="pf-c-toolbar__group">
                        <button
                            class="pf-c-button pf-m-primary"
                            @click=${() => this.notify("clickNew")}
                        >
                            ${msg("Bind existing policy/group/user")}
                        </button>
                    </div>
                    <button
                        class="pf-c-button pf-m-danger"
                        ?disabled=${!this.canDelete}
                        @click=${() => this.notify("clickDelete")}
                    >
                        ${msg("Delete")}
                    </button>
                </div>
            </div>
        `;
  }
};
__decorateClass([
  n({ type: Boolean, attribute: "can-delete", reflect: true })
], ApplicationWizardBindingsToolbar.prototype, "canDelete", 2);
ApplicationWizardBindingsToolbar = __decorateClass([
  t("ak-application-wizard-bindings-toolbar")
], ApplicationWizardBindingsToolbar);

// src/admin/applications/wizard/steps/ak-application-wizard-bindings-step.ts
var COLUMNS = [
  [msg("Order"), "order"],
  [msg("Binding")],
  [msg("Enabled"), "enabled"],
  [msg("Timeout"), "timeout"],
  [msg("Actions")]
];
var ApplicationWizardBindingsStep = class extends ApplicationWizardStep {
  constructor() {
    super(...arguments);
    this.label = msg("Configure Bindings");
  }
  get buttons() {
    return [
      { kind: "next", destination: "submit" },
      { kind: "back", destination: "provider" },
      { kind: "cancel" }
    ];
  }
  static get styles() {
    return super.styles.concat(
      card_default,
      i`
                .pf-c-card {
                    margin-top: 1em;
                }
            `
    );
  }
  get bindingsAsColumns() {
    return this.wizard.bindings.map((binding, index) => {
      const { order, enabled, timeout } = binding;
      const isSet = N.union(N.string.minLength(1), N.number);
      const policy = z(binding).with({ policy: isSet }, (v) => msg(str`Policy ${v.policyObj?.name}`)).with({ group: isSet }, (v) => msg(str`Group ${v.groupObj?.name}`)).with({ user: isSet }, (v) => msg(str`User ${v.userObj?.name}`)).otherwise(() => msg("-"));
      return {
        key: index,
        content: [
          order,
          policy,
          ke`<ak-status-label type="warning" ?good=${enabled}></ak-status-label>`,
          timeout,
          makeEditButton(
            msg("Edit"),
            index,
            (ev) => this.onBindingEvent(ev.detail)
          )
        ]
      };
    });
  }
  // TODO Fix those dispatches so that we handle them here, in this component, and *choose* how to
  // forward them.
  onBindingEvent(binding) {
    this.handleUpdate({ currentBinding: binding ?? -1 }, "edit-binding", {
      enable: "edit-binding"
    });
  }
  onDeleteBindings() {
    const toDelete = this.selectTable.json().map((i3) => typeof i3 === "string" ? parseInt(i3, 10) : i3);
    const bindings = this.wizard.bindings.filter((binding, index) => !toDelete.includes(index));
    this.handleUpdate({ bindings }, "bindings");
  }
  renderEmptyCollection() {
    return ke`<ak-wizard-title
                >${msg("Configure Policy/User/Group Bindings")}</ak-wizard-title
            >
            <h6 class="pf-c-title pf-m-md">
                ${msg("These policies control which users can access this application.")}
            </h6>
            <div class="pf-c-card">
                <ak-application-wizard-bindings-toolbar
                    @clickNew=${() => this.onBindingEvent()}
                    @clickDelete=${() => this.onDeleteBindings()}
                ></ak-application-wizard-bindings-toolbar>
                <ak-select-table
                    multiple
                    id="bindings"
                    order="order"
                    .columns=${COLUMNS}
                    .content=${[]}
                ></ak-select-table>
                <ak-empty-state header=${msg("No bound policies.")} icon="pf-icon-module">
                    <div slot="body">${msg("No policies are currently bound to this object.")}</div>
                    <div slot="primary">
                        <button
                            @click=${() => this.onBindingEvent()}
                            class="pf-c-button pf-m-primary"
                        >
                            ${msg("Bind policy/group/user")}
                        </button>
                    </div>
                </ak-empty-state>
            </div>`;
  }
  renderCollection() {
    return ke` <ak-wizard-title>${msg("Configure Policy Bindings")}</ak-wizard-title>
            <h6 class="pf-c-title pf-m-md">
                ${msg("These policies control which users can access this application.")}
            </h6>
            <ak-application-wizard-bindings-toolbar
                @clickNew=${() => this.onBindingEvent()}
                @clickDelete=${() => this.onDeleteBindings()}
                ?can-delete=${this.wizard.bindings.length > 0}
            ></ak-application-wizard-bindings-toolbar>
            <ak-select-table
                multiple
                id="bindings"
                order="order"
                .columns=${COLUMNS}
                .content=${this.bindingsAsColumns}
            ></ak-select-table>`;
  }
  renderMain() {
    if ((this.wizard.bindings ?? []).length === 0) {
      return this.renderEmptyCollection();
    }
    return this.renderCollection();
  }
};
__decorateClass([
  e("ak-select-table")
], ApplicationWizardBindingsStep.prototype, "selectTable", 2);
ApplicationWizardBindingsStep = __decorateClass([
  t("ak-application-wizard-bindings-step")
], ApplicationWizardBindingsStep);

// src/elements/forms/SearchSelect/ak-search-select-ez.ts
var SearchSelectEz = class extends SearchSelectBase {
  static get styles() {
    return [...SearchSelectBase.styles];
  }
  connectedCallback() {
    this.fetchObjects = this.config.fetchObjects;
    this.renderElement = this.config.renderElement;
    this.renderDescription = this.config.renderDescription;
    this.value = this.config.value;
    this.selected = this.config.selected;
    if (this.config.groupBy !== void 0) {
      this.groupBy = this.config.groupBy;
    }
    super.connectedCallback();
  }
};
__decorateClass([
  n({ type: Object, attribute: false })
], SearchSelectEz.prototype, "config", 2);
SearchSelectEz = __decorateClass([
  t("ak-search-select-ez")
], SearchSelectEz);

// src/admin/applications/wizard/steps/ak-application-wizard-edit-binding-step.ts
var withQuery = (search, args) => search ? { ...args, search } : args;
var policyObjectKeys = {
  ["policy" /* policy */]: "policyObj",
  ["group" /* group */]: "groupObj",
  ["user" /* user */]: "userObj"
};
var PASS_FAIL = [
  [msg("Pass"), true, false],
  [msg("Don't Pass"), false, true]
].map(([label, value, d]) => ({ label, value, default: d }));
var ApplicationWizardEditBindingStep = class extends ApplicationWizardStep {
  constructor() {
    super(...arguments);
    this.label = msg("Edit Binding");
    this.hide = true;
    this.policyGroupUser = "policy" /* policy */;
    this.instanceId = -1;
  }
  get buttons() {
    return [
      { kind: "next", label: msg("Save Binding"), destination: "bindings" },
      { kind: "back", destination: "bindings" },
      { kind: "cancel" }
    ];
  }
  handleButton(button) {
    if (button.kind === "next") {
      if (!this.form.checkValidity()) {
        return;
      }
      const policyObject = this.searchSelect.selectedObject;
      const policyKey = policyObjectKeys[this.policyGroupUser];
      const newBinding = {
        ...this.formValues,
        [policyKey]: policyObject
      };
      const bindings = [...this.wizard.bindings ?? []];
      if (this.instanceId === -1) {
        bindings.push(newBinding);
      } else {
        bindings[this.instanceId] = newBinding;
      }
      this.instanceId = -1;
      this.handleUpdate({ bindings }, "bindings");
      return;
    }
    super.handleButton(button);
  }
  // The search select configurations for the three different types of fetches that we care about,
  // policy, user, and group, all using the SearchSelectEZ protocol.
  searchSelectConfigs(kind) {
    switch (kind) {
      case "policy" /* policy */:
        return {
          fetchObjects: async (query) => {
            const policies = await new PoliciesApi(DEFAULT_CONFIG).policiesAllList(
              withQuery(query, {
                ordering: "name"
              })
            );
            return policies.results;
          },
          groupBy: (items) => groupBy(items, (policy) => policy.verboseNamePlural),
          renderElement: (policy) => policy.name,
          value: (policy) => policy?.pk,
          selected: (policy) => policy.pk === this.instance?.policy
        };
      case "group" /* group */:
        return {
          fetchObjects: async (query) => {
            const groups = await new CoreApi(DEFAULT_CONFIG).coreGroupsList(
              withQuery(query, {
                ordering: "name",
                includeUsers: false
              })
            );
            return groups.results;
          },
          renderElement: (group) => group.name,
          value: (group) => group?.pk,
          selected: (group) => group.pk === this.instance?.group
        };
      case "user" /* user */:
        return {
          fetchObjects: async (query) => {
            const users = await new CoreApi(DEFAULT_CONFIG).coreUsersList(
              withQuery(query, {
                ordering: "username"
              })
            );
            return users.results;
          },
          renderElement: (user) => user.username,
          renderDescription: (user) => ke`${user.name}`,
          value: (user) => user?.pk,
          selected: (user) => user.pk === this.instance?.user
        };
      default:
        throw new Error(`Unrecognized policy binding target ${kind}`);
    }
  }
  renderSearch(title, policyKind) {
    if (policyKind !== this.policyGroupUser) {
      return D;
    }
    return ke`<ak-form-element-horizontal label=${title} name=${policyKind}>
            <ak-search-select-ez
                .config=${this.searchSelectConfigs(policyKind)}
                class="policy-search-select"
                blankable
            ></ak-search-select-ez>
        </ak-form-element-horizontal>`;
  }
  renderForm(instance) {
    return ke`<ak-wizard-title>${msg("Create a Policy/User/Group Binding")}</ak-wizard-title>
            <form id="bindingform" class="pf-c-form pf-m-horizontal" slot="form">
                <div class="pf-c-card pf-m-selectable pf-m-selected">
                    <div class="pf-c-card__body">
                        <ak-toggle-group
                            value=${this.policyGroupUser}
                            @ak-toggle=${(ev) => {
      this.policyGroupUser = ev.detail.value;
    }}
                        >
                            <option value=${"policy" /* policy */}>${msg("Policy")}</option>
                            <option value=${"group" /* group */}>${msg("Group")}</option>
                            <option value=${"user" /* user */}>${msg("User")}</option>
                        </ak-toggle-group>
                    </div>
                    <div class="pf-c-card__footer">
                        ${this.renderSearch(msg("Policy"), "policy" /* policy */)}
                        ${this.renderSearch(msg("Group"), "group" /* group */)}
                        ${this.renderSearch(msg("User"), "user" /* user */)}
                    </div>
                </div>
                <ak-switch-input
                    name="enabled"
                    ?checked=${instance?.enabled ?? true}
                    label=${msg("Enabled")}
                ></ak-switch-input>
                <ak-switch-input
                    name="negate"
                    ?checked=${instance?.negate ?? false}
                    label=${msg("Negate result")}
                    help=${msg("Negates the outcome of the binding. Messages are unaffected.")}
                ></ak-switch-input>
                <ak-number-input
                    label=${msg("Order")}
                    name="order"
                    value="${instance?.order ?? 0}"
                    required
                ></ak-number-input>
                <ak-number-input
                    label=${msg("Timeout")}
                    name="timeout"
                    value="${instance?.timeout ?? 30}"
                    required
                ></ak-number-input>
                <ak-radio-input
                    name="failureResult"
                    label=${msg("Failure result")}
                    .options=${PASS_FAIL}
                ></ak-radio-input>
            </form>`;
  }
  renderMain() {
    if (!(this.wizard.bindings && this.wizard.errors)) {
      throw new Error("Application Step received uninitialized wizard context.");
    }
    const currentBinding = this.wizard.currentBinding ?? -1;
    if (this.instanceId !== currentBinding) {
      this.instanceId = currentBinding;
      this.instance = this.instanceId === -1 ? void 0 : this.wizard.bindings[this.instanceId];
    }
    return this.renderForm(this.instance);
  }
};
__decorateClass([
  e("form#bindingform")
], ApplicationWizardEditBindingStep.prototype, "form", 2);
__decorateClass([
  e(".policy-search-select")
], ApplicationWizardEditBindingStep.prototype, "searchSelect", 2);
__decorateClass([
  r()
], ApplicationWizardEditBindingStep.prototype, "policyGroupUser", 2);
ApplicationWizardEditBindingStep = __decorateClass([
  t("ak-application-wizard-edit-binding-step")
], ApplicationWizardEditBindingStep);

// src/admin/applications/wizard/steps/ak-application-wizard-provider-choice-step.ts
var ApplicationWizardProviderChoiceStep = class extends WithLicenseSummary(ApplicationWizardStep) {
  constructor() {
    super(...arguments);
    this.label = msg("Choose A Provider");
    this.failureMessage = "";
  }
  get buttons() {
    return [
      { kind: "next", destination: "provider" },
      { kind: "back", destination: "application" },
      { kind: "cancel" }
    ];
  }
  handleButton(button) {
    this.failureMessage = "";
    if (button.kind === "next") {
      if (!this.wizard.providerModel) {
        this.failureMessage = msg("Please choose a provider type before proceeding.");
        this.handleEnabling({ disabled: ["provider", "bindings", "submit"] });
        return;
      }
      this.handleUpdate(void 0, button.destination, { enable: "provider" });
      return;
    }
    super.handleButton(button);
  }
  onSelect(ev) {
    ev.stopPropagation();
    const detail = ev.detail;
    this.handleUpdate({ providerModel: detail.modelName });
  }
  renderMain() {
    const selectedTypes = this.providerModelsList.filter(
      (t3) => t3.modelName === this.wizard.providerModel
    );
    return this.providerModelsList.length > 0 ? ke` <ak-wizard-title>${msg("Choose a Provider Type")}</ak-wizard-title>
                  <form class="pf-c-form pf-m-horizontal">
                      <ak-wizard-page-type-create
                          .types=${this.providerModelsList}
                          name="selectProviderType"
                          layout=${"grid" /* grid */}
                          .selectedType=${selectedTypes.length > 0 ? selectedTypes[0] : void 0}
                          @select=${(ev) => {
      this.handleUpdate(
        {
          ...this.wizard,
          providerModel: ev.detail.modelName
        },
        void 0,
        { enable: "provider" }
      );
    }}
                      ></ak-wizard-page-type-create>
                  </form>` : ke`<ak-empty-state loading header=${msg("Loading")}></ak-empty-state>`;
  }
};
__decorateClass([
  r()
], ApplicationWizardProviderChoiceStep.prototype, "failureMessage", 2);
__decorateClass([
  c({ context: applicationWizardProvidersContext, subscribe: true })
], ApplicationWizardProviderChoiceStep.prototype, "providerModelsList", 2);
__decorateClass([
  bound
], ApplicationWizardProviderChoiceStep.prototype, "onSelect", 1);
ApplicationWizardProviderChoiceStep = __decorateClass([
  t("ak-application-wizard-provider-choice-step")
], ApplicationWizardProviderChoiceStep);

// node_modules/lit-html/static.js
var $e = Symbol.for("");
var xe = (t3) => {
  if (t3?.r === $e) return t3?._$litStatic$;
};
var tr = (t3) => ({ _$litStatic$: t3, r: $e });
var Te = /* @__PURE__ */ new Map();
var Ee = (t3) => (r5, ...e2) => {
  const a = e2.length;
  let o2, s;
  const i3 = [], l = [];
  let n4, u = 0, c2 = false;
  for (; u < a; ) {
    for (n4 = r5[u]; u < a && void 0 !== (s = e2[u], o2 = xe(s)); ) n4 += o2 + r5[++u], c2 = true;
    u !== a && l.push(s), i3.push(n4), u++;
  }
  if (u === a && i3.push(r5[a]), c2) {
    const t4 = i3.join("$$lit$$");
    void 0 === (r5 = Te.get(t4)) && (i3.raw = i3, Te.set(t4, r5 = i3)), e2 = l;
  }
  return t3(r5, ...e2);
};
var ke2 = Ee(ke);
var Oe2 = Ee(Oe);
var Se2 = Ee(Se);

// src/admin/applications/wizard/steps/providers/ApplicationWizardProviderForm.ts
var ApplicationWizardProviderForm = class extends AKElement {
  constructor() {
    super(...arguments);
    this.label = "";
    this.errors = {};
  }
  static get styles() {
    return styles;
  }
  get formValues() {
    const elements = [
      ...Array.from(
        this.form.querySelectorAll("ak-form-element-horizontal")
      ),
      ...Array.from(this.form.querySelectorAll("[data-ak-control=true]"))
    ];
    return serializeForm(elements);
  }
  get valid() {
    this.errors = {};
    return this.form.checkValidity();
  }
  errorMessages(name) {
    return name in this.errors ? [this.errors[name]] : this.wizard.errors?.provider?.[name] ?? this.wizard.errors?.provider?.[camelToSnake(name)] ?? [];
  }
  isValid(name) {
    return !((this.wizard.errors?.provider?.[name] ?? []).length > 0 || this.errors?.[name] !== void 0);
  }
};
__decorateClass([
  n({ type: Object, attribute: false })
], ApplicationWizardProviderForm.prototype, "wizard", 2);
__decorateClass([
  n({ type: Object, attribute: false })
], ApplicationWizardProviderForm.prototype, "errors", 2);
__decorateClass([
  e("form#providerform")
], ApplicationWizardProviderForm.prototype, "form", 2);

// src/admin/applications/wizard/steps/providers/ak-application-wizard-provider-for-ldap.ts
var ApplicationWizardLdapProviderForm = class extends WithBrandConfig(
  ApplicationWizardProviderForm
) {
  constructor() {
    super(...arguments);
    this.label = msg("Configure LDAP Provider");
  }
  renderForm(provider, errors) {
    return ke`
            <ak-wizard-title>${this.label}</ak-wizard-title>
            <form id="providerform" class="pf-c-form pf-m-horizontal" slot="form">
                ${renderForm(provider ?? {}, errors, this.brand)}
            </form>
        `;
  }
  render() {
    if (!(this.wizard.provider && this.wizard.errors)) {
      throw new Error("LDAP Provider Step received uninitialized wizard context.");
    }
    return this.renderForm(
      this.wizard.provider,
      this.wizard.errors.provider ?? {}
    );
  }
};
ApplicationWizardLdapProviderForm = __decorateClass([
  t("ak-application-wizard-provider-for-ldap")
], ApplicationWizardLdapProviderForm);

// src/admin/applications/wizard/steps/providers/ak-application-wizard-provider-for-oauth.ts
var ApplicationWizardOauth2ProviderForm = class extends ApplicationWizardProviderForm {
  constructor() {
    super();
    this.label = msg("Configure OAuth2 Provider");
    this.showClientSecret = true;
    new SourcesApi(DEFAULT_CONFIG).sourcesOauthList({
      ordering: "name",
      hasJwks: true
    }).then((oauthSources) => {
      this.oauthSources = oauthSources;
    });
  }
  renderForm(provider, errors) {
    const showClientSecretCallback = (show) => {
      this.showClientSecret = show;
    };
    return ke` <ak-wizard-title>${this.label}</ak-wizard-title>
            <form id="providerform" class="pf-c-form pf-m-horizontal" slot="form">
                ${renderForm2(
      provider ?? {},
      errors,
      this.showClientSecret,
      showClientSecretCallback
    )}
            </form>`;
  }
  render() {
    if (!(this.wizard.provider && this.wizard.errors)) {
      throw new Error("Oauth2 Provider Step received uninitialized wizard context.");
    }
    return this.renderForm(this.wizard.provider, this.wizard.errors);
  }
};
__decorateClass([
  r()
], ApplicationWizardOauth2ProviderForm.prototype, "showClientSecret", 2);
__decorateClass([
  r()
], ApplicationWizardOauth2ProviderForm.prototype, "oauthSources", 2);
ApplicationWizardOauth2ProviderForm = __decorateClass([
  t("ak-application-wizard-provider-for-oauth")
], ApplicationWizardOauth2ProviderForm);

// src/admin/applications/wizard/steps/providers/ak-application-wizard-provider-for-proxy.ts
var ApplicationWizardProxyProviderForm = class extends ApplicationWizardProviderForm {
  constructor() {
    super(...arguments);
    this.label = msg("Configure Proxy Provider");
    this.showHttpBasic = true;
  }
  renderForm(provider, errors) {
    const onSetMode = (ev) => {
      this.dispatchEvent(
        new WizardUpdateEvent({ ...this.wizard, proxyMode: ev.detail.value })
      );
      window.setTimeout(() => this.requestUpdate(), 0);
    };
    const onSetShowHttpBasic = (ev) => {
      const el = ev.target;
      this.showHttpBasic = el.checked;
    };
    return ke` <ak-wizard-title>${this.label}</ak-wizard-title>
            <form id="providerform" class="pf-c-form pf-m-horizontal" slot="form">
                ${renderForm3(provider ?? {}, errors ?? [], {
      mode: this.wizard.proxyMode ?? ProxyMode.Proxy,
      onSetMode,
      showHttpBasic: this.showHttpBasic,
      onSetShowHttpBasic
    })}
            </form>`;
  }
  render() {
    if (!(this.wizard.provider && this.wizard.errors)) {
      throw new Error("Proxy Provider Step received uninitialized wizard context.");
    }
    return this.renderForm(
      this.wizard.provider,
      this.wizard.errors?.provider ?? {}
    );
  }
};
__decorateClass([
  r()
], ApplicationWizardProxyProviderForm.prototype, "showHttpBasic", 2);
ApplicationWizardProxyProviderForm = __decorateClass([
  t("ak-application-wizard-provider-for-proxy")
], ApplicationWizardProxyProviderForm);

// src/admin/applications/wizard/steps/providers/ak-application-wizard-provider-for-rac.ts
var ApplicationWizardRACProviderForm = class extends ApplicationWizardProviderForm {
  constructor() {
    super(...arguments);
    this.label = msg("Configure Remote Access Provider");
  }
  renderForm(provider) {
    return ke`
            <ak-wizard-title>${this.label}</ak-wizard-title>
            <form id="providerform" class="pf-c-form pf-m-horizontal" slot="form">
                <ak-text-input
                    name="name"
                    label=${msg("Name")}
                    value=${to(provider.name)}
                    .errorMessages=${this.errorMessages("name")}
                    required
                ></ak-text-input>

                <ak-form-element-horizontal
                    name="authorizationFlow"
                    label=${msg("Authorization flow")}
                    ?required=${true}
                >
                    <ak-flow-search
                        flowType=${FlowsInstancesListDesignationEnum.Authorization}
                        .currentFlow=${provider.authorizationFlow}
                        required
                    ></ak-flow-search>
                    <p class="pf-c-form__helper-text">
                        ${msg("Flow used when authorizing this provider.")}
                    </p>
                </ak-form-element-horizontal>

                <ak-text-input
                    name="connectionExpiry"
                    label=${msg("Connection expiry")}
                    required
                    value="${provider.connectionExpiry ?? "hours=8"}"
                    help=${msg(
      "Determines how long a session lasts before being disconnected and requiring re-authorization."
    )}
                    inputHint="code"
                ></ak-text-input>

                <ak-form-group .expanded=${true}>
                    <span slot="header"> ${msg("Protocol settings")} </span>
                    <div slot="body" class="pf-c-form">
                        <ak-form-element-horizontal
                            label=${msg("Property mappings")}
                            name="propertyMappings"
                        >
                            <ak-dual-select-dynamic-selected
                                .provider=${propertyMappingsProvider}
                                .selector=${propertyMappingsSelector(provider?.propertyMappings)}
                                available-label="${msg("Available Property Mappings")}"
                                selected-label="${msg("Selected Property Mappings")}"
                            ></ak-dual-select-dynamic-selected>
                        </ak-form-element-horizontal>
                    </div>
                </ak-form-group>
            </form>
        `;
  }
  render() {
    if (!(this.wizard.provider && this.wizard.errors)) {
      throw new Error("RAC Provider Step received uninitialized wizard context.");
    }
    return this.renderForm(this.wizard.provider);
  }
};
ApplicationWizardRACProviderForm = __decorateClass([
  t("ak-application-wizard-provider-for-rac")
], ApplicationWizardRACProviderForm);

// src/admin/applications/wizard/steps/providers/ak-application-wizard-provider-for-radius.ts
var ApplicationWizardRadiusProviderForm = class extends WithBrandConfig(
  ApplicationWizardProviderForm
) {
  constructor() {
    super(...arguments);
    this.label = msg("Configure Radius Provider");
  }
  renderForm(provider, errors) {
    return ke` <ak-wizard-title>${this.label}</ak-wizard-title>
            <form id="providerform" class="pf-c-form pf-m-horizontal" slot="form">
                ${renderForm4(provider ?? {}, errors, this.brand)}
            </form>`;
  }
  render() {
    if (!(this.wizard.provider && this.wizard.errors)) {
      throw new Error("RAC Provider Step received uninitialized wizard context.");
    }
    return this.renderForm(
      this.wizard.provider,
      this.wizard.errors?.provider ?? {}
    );
  }
};
ApplicationWizardRadiusProviderForm = __decorateClass([
  t("ak-application-wizard-provider-for-radius")
], ApplicationWizardRadiusProviderForm);

// src/admin/applications/wizard/steps/providers/ak-application-wizard-provider-for-saml.ts
var ApplicationWizardProviderSamlForm = class extends ApplicationWizardProviderForm {
  constructor() {
    super(...arguments);
    this.label = msg("Configure SAML Provider");
    this.hasSigningKp = false;
  }
  renderForm() {
    const setHasSigningKp = (ev) => {
      const target = ev.target;
      if (!target) return;
      this.hasSigningKp = !!target.selectedKeypair;
    };
    return ke` <ak-wizard-title>${this.label}</ak-wizard-title>
            <form id="providerform" class="pf-c-form pf-m-horizontal" slot="form">
                ${renderForm5(
      this.wizard.provider ?? {},
      this.wizard.errors?.provider ?? {},
      setHasSigningKp,
      this.hasSigningKp
    )}
            </form>`;
  }
  render() {
    if (!(this.wizard.provider && this.wizard.errors)) {
      throw new Error("SAML Provider Step received uninitialized wizard context.");
    }
    return this.renderForm();
  }
};
__decorateClass([
  r()
], ApplicationWizardProviderSamlForm.prototype, "hasSigningKp", 2);
ApplicationWizardProviderSamlForm = __decorateClass([
  t("ak-application-wizard-provider-for-saml")
], ApplicationWizardProviderSamlForm);

// src/admin/applications/wizard/steps/providers/ak-application-wizard-provider-for-scim.ts
var ApplicationWizardSCIMProvider = class extends ApplicationWizardProviderForm {
  constructor() {
    super(...arguments);
    this.label = msg("Configure SCIM Provider");
  }
  render() {
    return ke`<ak-wizard-title>${this.label}</ak-wizard-title>
            <form id="providerform" class="pf-c-form pf-m-horizontal" slot="form">
                ${renderForm6(
      this.wizard.provider ?? {},
      this.wizard.errors.provider
    )}
            </form>`;
  }
};
__decorateClass([
  r()
], ApplicationWizardSCIMProvider.prototype, "propertyMappings", 2);
ApplicationWizardSCIMProvider = __decorateClass([
  t("ak-application-wizard-provider-for-scim")
], ApplicationWizardSCIMProvider);

// src/admin/applications/wizard/steps/ak-application-wizard-provider-step.ts
var providerToTag = /* @__PURE__ */ new Map([
  ["ldapprovider", "ak-application-wizard-provider-for-ldap"],
  ["oauth2provider", "ak-application-wizard-provider-for-oauth"],
  ["proxyprovider", "ak-application-wizard-provider-for-proxy"],
  ["racprovider", "ak-application-wizard-provider-for-rac"],
  ["radiusprovider", "ak-application-wizard-provider-for-radius"],
  ["samlprovider", "ak-application-wizard-provider-for-saml"],
  ["scimprovider", "ak-application-wizard-provider-for-scim"]
]);
var ApplicationWizardProviderStep = class extends ApplicationWizardStep {
  constructor() {
    super(...arguments);
    this.label = msg("Configure Provider");
  }
  get valid() {
    return this.element.valid;
  }
  get formValues() {
    return this.element.formValues;
  }
  handleButton(button) {
    if (button.kind === "next") {
      if (!this.valid) {
        this.handleEnabling({
          disabled: ["bindings", "submit"]
        });
        return;
      }
      const payload = {
        provider: {
          ...this.formValues,
          mode: this.wizard.proxyMode
        },
        errors: this.removeErrors("provider")
      };
      this.handleUpdate(payload, button.destination, {
        enable: ["bindings", "submit"]
      });
      return;
    }
    super.handleButton(button);
  }
  get buttons() {
    return [
      { kind: "next", destination: "bindings" },
      { kind: "back", destination: "provider-choice" },
      { kind: "cancel" }
    ];
  }
  renderMain() {
    if (!this.wizard.providerModel) {
      throw new Error("Attempted to access provider page without providing a provider type.");
    }
    const tag = providerToTag.get(this.wizard.providerModel);
    return tag ? (
      // eslint-disable-next-line lit/binding-positions,lit/no-invalid-html
      ke2`<${tr(tag)}
                id="providerform"
            .wizard=${this.wizard}
            .errors=${this.wizard.errors?.provider ?? {}}

            ></${/* eslint-disable-next-line lit/binding-positions,lit/no-invalid-html */
      tr(tag)}>`
    ) : D;
  }
  updated(changed) {
    if (changed.has("wizard")) {
      const label = this.element?.label ?? this.label;
      if (label !== this.label) {
        this.label = label;
      }
    }
  }
};
__decorateClass([
  r()
], ApplicationWizardProviderStep.prototype, "label", 2);
__decorateClass([
  e("#providerform")
], ApplicationWizardProviderStep.prototype, "element", 2);
ApplicationWizardProviderStep = __decorateClass([
  t("ak-application-wizard-provider-step")
], ApplicationWizardProviderStep);

// src/admin/applications/wizard/steps/SubmitStepOverviewRenderers.ts
var renderSummary = (type, name, fields) => renderDescriptionList([[msg("Type"), type], [msg("Name"), name], ...fields], {
  threecolumn: true
});
function renderSAMLOverview(rawProvider) {
  const provider = rawProvider;
  return renderSummary("SAML", provider.name, [
    [msg("ACS URL"), provider.acsUrl],
    [msg("Audience"), provider.audience || "-"],
    [msg("Issuer"), provider.issuer]
  ]);
}
function renderSCIMOverview(rawProvider) {
  const provider = rawProvider;
  return renderSummary("SCIM", provider.name, [[msg("URL"), provider.url]]);
}
function renderRadiusOverview(rawProvider) {
  const provider = rawProvider;
  return renderSummary("Radius", provider.name, [
    [msg("Client Networks"), provider.clientNetworks]
  ]);
}
function renderRACOverview(rawProvider) {
  const _provider = rawProvider;
}
function formatRedirectUris(uris = []) {
  return uris.length > 0 ? ke`<ul class="pf-c-list pf-m-plain">
              ${uris.map(
    (uri) => ke`<li>
                          ${uri.url}
                          (${uri.matchingMode === MatchingModeEnum.Strict ? msg("strict") : msg("regexp")})
                      </li>`
  )}
          </ul>` : "-";
}
var proxyModeToLabel = /* @__PURE__ */ new Map([
  [ProxyMode.Proxy, msg("Proxy")],
  [ProxyMode.ForwardSingle, msg("Forward auth (single application)")],
  [ProxyMode.ForwardDomain, msg("Forward auth (domain-level)")],
  [ProxyMode.UnknownDefaultOpenApi, msg("Unknown proxy mode")]
]);
function renderProxyOverview(rawProvider) {
  const provider = rawProvider;
  return renderSummary("Proxy", provider.name, [
    [msg("Mode"), proxyModeToLabel.get(provider.mode ?? ProxyMode.Proxy)],
    ...z(provider.mode).with(
      ProxyMode.Proxy,
      () => [
        [msg("Internal Host"), provider.internalHost],
        [msg("External Host"), provider.externalHost]
      ]
    ).with(
      ProxyMode.ForwardSingle,
      () => [[msg("External Host"), provider.externalHost]]
    ).with(
      ProxyMode.ForwardDomain,
      () => [
        [msg("Authentication URL"), provider.externalHost],
        [msg("Cookie domain"), provider.cookieDomain]
      ]
    ).otherwise(() => {
      throw new Error(
        `Unrecognized proxy mode: ${provider.mode?.toString() ?? "-- undefined __"}`
      );
    }),
    [
      msg("Basic-Auth"),
      ke` <ak-status-label
                type="info"
                ?good=${provider.basicAuthEnabled}
            ></ak-status-label>`
    ]
  ]);
}
var clientTypeToLabel = /* @__PURE__ */ new Map([
  [ClientTypeEnum.Confidential, msg("Confidential")],
  [ClientTypeEnum.Public, msg("Public")],
  [ClientTypeEnum.UnknownDefaultOpenApi, msg("Unknown type")]
]);
function renderOAuth2Overview(rawProvider) {
  const provider = rawProvider;
  return renderSummary("OAuth2", provider.name, [
    [msg("Client type"), provider.clientType ? clientTypeToLabel.get(provider.clientType) : ""],
    [msg("Client ID"), provider.clientId],
    [msg("Redirect URIs"), formatRedirectUris(provider.redirectUris)]
  ]);
}
function renderLDAPOverview(rawProvider) {
  const provider = rawProvider;
  return renderSummary("Proxy", provider.name, [[msg("Base DN"), provider.baseDn]]);
}
var providerName = (p) => p.toString().split(".")[1];
var providerRenderers = /* @__PURE__ */ new Map([
  [providerName(ProviderModelEnum.AuthentikProvidersSamlSamlprovider), renderSAMLOverview],
  [providerName(ProviderModelEnum.AuthentikProvidersScimScimprovider), renderSCIMOverview],
  [providerName(ProviderModelEnum.AuthentikProvidersRadiusRadiusprovider), renderRadiusOverview],
  [providerName(ProviderModelEnum.AuthentikProvidersRacRacprovider), renderRACOverview],
  [providerName(ProviderModelEnum.AuthentikProvidersProxyProxyprovider), renderProxyOverview],
  [providerName(ProviderModelEnum.AuthentikProvidersOauth2Oauth2provider), renderOAuth2Overview],
  [providerName(ProviderModelEnum.AuthentikProvidersLdapLdapprovider), renderLDAPOverview]
]);

// src/admin/applications/wizard/steps/ak-application-wizard-submit-step.ts
var providerMap = Object.values(ProviderModelEnum).filter((value) => /^authentik_providers_/.test(value) && /provider$/.test(value)).reduce((acc, value) => {
  acc.set(value.split(".")[1], value);
  return acc;
}, /* @__PURE__ */ new Map());
var isNotEmpty = (arr) => Array.isArray(arr) && arr.length > 0;
var cleanApplication = (app) => ({
  name: "",
  slug: "",
  ...app
});
var cleanBinding = (binding) => ({
  policy: binding.policy,
  group: binding.group,
  user: binding.user,
  negate: binding.negate,
  enabled: binding.enabled,
  order: binding.order,
  timeout: binding.timeout,
  failureResult: binding.failureResult
});
var ApplicationWizardSubmitStep = class extends CustomEmitterElement(ApplicationWizardStep) {
  constructor() {
    super(...arguments);
    this.label = msg("Review and Submit Application");
    this.state = "reviewing";
  }
  static get styles() {
    return [
      ...ApplicationWizardStep.styles,
      bullseye_default,
      empty_state_default,
      title_default,
      progress_stepper_default,
      description_list_default,
      i`
                .ak-wizard-main-content .pf-c-title {
                    padding-bottom: var(--pf-global--spacer--md);
                    padding-top: var(--pf-global--spacer--md);
                }
            `
    ];
  }
  async send() {
    const app = this.wizard.app;
    const provider = this.wizard.provider;
    if (app === void 0) {
      throw new Error("Reached the submit state with the app undefined");
    }
    if (provider === void 0) {
      throw new Error("Reached the submit state with the provider undefined");
    }
    const providerModel = providerMap.get(this.wizard.providerModel);
    provider.providerModel = providerModel;
    if (this.wizard.providerModel === "proxyprovider") {
      provider.mode = this.wizard.proxyMode;
      if (provider.mode !== ProxyMode.ForwardDomain) {
        provider.cookieDomain = "";
      }
    }
    const request = {
      app: cleanApplication(this.wizard.app),
      providerModel,
      provider,
      policyBindings: (this.wizard.bindings ?? []).map(cleanBinding)
    };
    this.state = "running";
    return new CoreApi(DEFAULT_CONFIG).coreTransactionalApplicationsUpdate({
      transactionApplicationRequest: request
    }).then((_response) => {
      this.dispatchCustomEvent(EVENT_REFRESH);
      this.state = "submitted";
    }).catch(async (resolution) => {
      const errors = await parseAPIError(
        await resolution
      );
      if (Array.isArray(errors?.app?.provider)) {
        const providerError = errors.app.provider;
        errors.provider = errors.provider ?? {};
        errors.provider.name = providerError;
        delete errors.app.provider;
        if (Object.keys(errors.app).length === 0) {
          delete errors.app;
        }
      }
      this.handleUpdate({ errors });
      this.state = "reviewing";
    });
  }
  handleButton(button) {
    z([button.kind, this.state]).with([N.union("back", "cancel"), N._], () => {
      super.handleButton(button);
    }).with(["close", "submitted"], () => {
      super.handleButton(button);
    }).with(["next", "reviewing"], () => {
      this.send();
    }).with([N._, "running"], () => {
      throw new Error("No buttons should be showing when running submit phase");
    }).otherwise(() => {
      throw new Error(
        `Submit step received incoherent button/state combination: ${[button.kind, r]}`
      );
    });
  }
  get buttons() {
    const forReview = [
      { kind: "next", label: msg("Submit"), destination: "here" },
      { kind: "back", destination: "bindings" },
      { kind: "cancel" }
    ];
    const forSubmit = [{ kind: "close" }];
    return z(this.state).with("submitted", () => forSubmit).with("running", () => []).with("reviewing", () => forReview).exhaustive();
  }
  renderInfo(state, label, icons, extraInfo = D) {
    const icon = Rt(icons.reduce((acc, icon2) => ({ ...acc, [icon2]: true }), {}));
    return ke`<div data-ouid-component-state=${this.state} class="ak-wizard-main-content">
            <div class="pf-l-bullseye">
                <div class="pf-c-empty-state pf-m-lg">
                    <div class="pf-c-empty-state__content">
                        <i class="fas ${icon} pf-c-empty-state__icon" aria-hidden="true"></i>
                        <h1 data-ouia-commit-state=${state} class="pf-c-title pf-m-lg">${label}</h1>
                        ${extraInfo}
                    </div>
                </div>
            </div>
        </div>`;
  }
  renderError() {
    if (Object.keys(this.wizard.errors).length === 0) {
      return D;
    }
    const navTo = (step) => () => this.dispatchEvent(new WizardNavigationEvent(step));
    const errors = this.wizard.errors;
    return ke` <hr class="pf-c-divider" />
            ${z(errors).with(
      { app: N.nonNullable },
      () => ke`<p>${msg("There was an error in the application.")}</p>
                            <p>
                                <a @click=${navTo("application")}
                                    >${msg("Review the application.")}</a
                                >
                            </p>`
    ).with(
      { provider: N.nonNullable },
      () => ke`<p>${msg("There was an error in the provider.")}</p>
                            <p>
                                <a @click=${navTo("provider")}>${msg("Review the provider.")}</a>
                            </p>`
    ).with(
      { detail: N.nonNullable },
      () => `<p>${msg("There was an error. Please go back and review the application.")}: ${errors.detail}</p>`
    ).with(
      {
        nonFieldErrors: N.when(isNotEmpty)
      },
      () => ke`<p>${msg("There was an error:")}:</p>
                            <ul>
                                ${(errors.nonFieldErrors ?? []).map(
        (e2) => ke`<li>${e2}</li>`
      )}
                            </ul>
                            <p>${msg("Please go back and review the application.")}</p>`
    ).otherwise(
      () => ke`<p>
                            ${msg(
        "There was an error creating the application, but no error message was sent. Please review the server logs."
      )}
                        </p>`
    )}`;
  }
  renderReview(app, provider) {
    const renderer = providerRenderers.get(this.wizard.providerModel);
    if (!renderer) {
      throw new Error(
        `Provider ${this.wizard.providerModel ?? "-- undefined --"} has no summary renderer.`
      );
    }
    return ke`
            <div class="ak-wizard-main-content">
                <ak-wizard-title>${msg("Review the Application and Provider")}</ak-wizard-title>
                <h2 class="pf-c-title pf-m-xl">${msg("Application")}</h2>
                <dl class="pf-c-description-list">
                    <div class="pf-c-description-list__group">
                        <dt class="pf-c-description-list__term">${msg("Name")}</dt>
                        <dt class="pf-c-description-list__description">${app.name}</dt>
                    </div>
                    <div class="pf-c-description-list__group">
                        <dt class="pf-c-description-list__term">${msg("Group")}</dt>
                        <dt class="pf-c-description-list__description">${app.group || msg("-")}</dt>
                    </div>
                    <div class="pf-c-description-list__group">
                        <dt class="pf-c-description-list__term">${msg("Policy engine mode")}</dt>
                        <dt class="pf-c-description-list__description">
                            ${app.policyEngineMode?.toUpperCase()}
                        </dt>
                    </div>
                    ${(app.metaLaunchUrl ?? "").trim() !== "" ? ke` <div class="pf-c-description-list__group">
                              <dt class="pf-c-description-list__term">${msg("Launch URL")}</dt>
                              <dt class="pf-c-description-list__description">
                                  ${app.metaLaunchUrl}
                              </dt>
                          </div>` : D}
                </dl>
                ${renderer ? ke` <h2 class="pf-c-title pf-m-xl pf-u-pt-xl">${msg("Provider")}</h2>
                          ${renderer(provider)}` : D}
            </div>
        `;
  }
  renderMain() {
    const app = this.wizard.app;
    const provider = this.wizard.provider;
    if (!(this.wizard && app && provider)) {
      throw new Error("Submit step received uninitialized wizard context");
    }
    const keys = Object.keys(this.wizard.errors);
    return z([this.state, keys]).with(
      ["submitted", N._],
      () => this.renderInfo("success", msg("Your application has been saved"), [
        "fa-check-circle",
        "pf-m-success"
      ])
    ).with(
      ["running", N._],
      () => this.renderInfo("running", msg("Saving application..."), ["fa-cogs", "pf-m-info"])
    ).with(["reviewing", []], () => this.renderReview(app, provider)).with(
      ["reviewing", [N.any, ...N.array()]],
      () => this.renderInfo(
        "error",
        msg("authentik was unable to complete this process."),
        ["fa-times-circle", "pf-m-danger"],
        this.renderError()
      )
    ).exhaustive();
  }
};
__decorateClass([
  r()
], ApplicationWizardSubmitStep.prototype, "state", 2);
ApplicationWizardSubmitStep = __decorateClass([
  t("ak-application-wizard-submit-step")
], ApplicationWizardSubmitStep);

// src/admin/applications/wizard/ak-application-wizard-main.ts
var freshWizardState = () => ({
  providerModel: "",
  currentBinding: -1,
  app: {},
  provider: {},
  proxyMode: ProxyMode.Proxy,
  bindings: [],
  errors: {}
});
var AkApplicationWizardMain = class extends AKElement {
  constructor() {
    super();
    this.wizard = freshWizardState();
    this.wizardProviderProvider = new i2(this, {
      context: applicationWizardProvidersContext,
      initialValue: []
    });
    this.addEventListener(WizardUpdateEvent.eventName, this.handleUpdate);
  }
  connectedCallback() {
    super.connectedCallback();
    new ProvidersApi(DEFAULT_CONFIG).providersAllTypesList().then((providerTypes) => {
      const wizardReadyProviders = Object.keys(providerTypeRenderers);
      this.wizardProviderProvider.setValue(
        providerTypes.filter((providerType) => wizardReadyProviders.includes(providerType.modelName)).map((providerType) => ({
          ...providerType,
          renderer: providerTypeRenderers[providerType.modelName].render
        })).sort(
          (a, b) => providerTypeRenderers[a.modelName].order - providerTypeRenderers[b.modelName].order
        ).reverse()
      );
    });
  }
  // This is the actual top of the Wizard; so this is where we accept the update information and
  // incorporate it into the wizard.
  handleUpdate(ev) {
    ev.stopPropagation();
    const update = ev.content;
    if (update !== void 0) {
      this.wizard = {
        ...this.wizard,
        ...update
      };
    }
  }
  render() {
    return ke`<ak-wizard-steps>
            <ak-application-wizard-application-step
                slot="application"
                .wizard=${this.wizard}
            ></ak-application-wizard-application-step>
            <ak-application-wizard-provider-choice-step
                slot="provider-choice"
                .wizard=${this.wizard}
            ></ak-application-wizard-provider-choice-step>
            <ak-application-wizard-provider-step
                slot="provider"
                .wizard=${this.wizard}
            ></ak-application-wizard-provider-step>
            <ak-application-wizard-bindings-step
                slot="bindings"
                .wizard=${this.wizard}
            ></ak-application-wizard-bindings-step>
            <ak-application-wizard-edit-binding-step
                slot="edit-binding"
                .wizard=${this.wizard}
            ></ak-application-wizard-edit-binding-step>
            <ak-application-wizard-submit-step
                slot="submit"
                .wizard=${this.wizard}
            ></ak-application-wizard-submit-step>
        </ak-wizard-steps>`;
  }
};
__decorateClass([
  r()
], AkApplicationWizardMain.prototype, "wizard", 2);
AkApplicationWizardMain = __decorateClass([
  t("ak-application-wizard-main")
], AkApplicationWizardMain);

// src/admin/applications/wizard/ak-application-wizard.ts
var AkApplicationWizard = class extends ModalButton {
  constructor() {
    super();
    this.addEventListener(WizardCloseEvent.eventName, this.onCloseEvent);
  }
  onCloseEvent(ev) {
    ev.stopPropagation();
    this.open = false;
  }
  renderModalInner() {
    return ke` <ak-application-wizard-main> </ak-application-wizard-main>`;
  }
};
__decorateClass([
  bound
], AkApplicationWizard.prototype, "onCloseEvent", 1);
AkApplicationWizard = __decorateClass([
  t("ak-application-wizard")
], AkApplicationWizard);

// src/components/ak-hint/ShowHintController.ts
var getCurrentStorageValue = () => {
  try {
    return JSON.parse(window?.localStorage.getItem(LOCALSTORAGE_AUTHENTIK_KEY) ?? "{}");
  } catch (_err) {
    return {};
  }
};
var ShowHintController = class {
  constructor(host, hintToken) {
    (this.host = host).addController(this);
    this.hintToken = hintToken;
    this.hide = this.hide.bind(this);
    this.show = this.show.bind(this);
  }
  setTheHint(state = false) {
    window?.localStorage.setItem(
      LOCALSTORAGE_AUTHENTIK_KEY,
      JSON.stringify({
        ...getCurrentStorageValue(),
        [this.hintToken]: state
      })
    );
    this.host.showHint = state;
  }
  hide() {
    this.setTheHint(false);
  }
  show() {
    this.setTheHint(true);
  }
  hostConnected() {
    const localStores = getCurrentStorageValue();
    if (!(this.hintToken in localStores)) {
      return;
    }
    this.host.showHint = localStores[this.hintToken];
  }
  render() {
    return ke`<ak-hint-footer
            ><div style="text-align: right">
                <input type="checkbox" @input=${this.hide} />&nbsp;${msg(
      "Don't show this message again."
    )}
            </div></ak-hint-footer
        >`;
  }
};

// src/components/ak-hint/ak-hint.ts
var styles2 = i`
    :host {
        --ak-hint--GridRowGap: var(--pf-global--spacer--md);
        --ak-hint--PaddingTop: var(--pf-global--spacer--md);
        --ak-hint--PaddingRight: var(--pf-global--spacer--lg);
        --ak-hint--PaddingBottom: var(--pf-global--spacer--md);
        --ak-hint--PaddingLeft: var(--pf-global--spacer--lg);
        --ak-hint--BackgroundColor: var(--pf-global--palette--blue-50);
        --ak-hint--BorderColor: var(--pf-global--palette--blue-100);
        --ak-hint--BorderWidth: var(--pf-global--BorderWidth--sm);
        --ak-hint--BoxShadow: var(--pf-global--BoxShadow--sm);
        --ak-hint--Color: var(--pf-global--Color--100);

        /* Hint Title */
        --ak-hint__title--FontSize: var(--pf-global--FontSize--lg);

        /* Hint Body */
        --ak-hint__body--FontSize: var(--pf-global--FontSize--md);

        /* Hint Footer */
        --ak-hint__footer--child--MarginRight: var(--pf-global--spacer--md);

        /* Hint Actions */
        --ak-hint__actions--MarginLeft: var(--pf-global--spacer--2xl);
        --ak-hint__actions--c-dropdown--MarginTop: calc(
            var(--pf-global--spacer--form-element) * -1
        );
    }

    :host([theme="dark"]) {
        --ak-hint--BackgroundColor: var(--ak-dark-background-darker);
        --ak-hint--BorderColor: var(--ak-dark-background-lighter);
        --ak-hint--Color: var(--ak-dark-foreground);
    }

    div#host {
        display: flex;
        flex-direction: column;
        gap: var(--ak-hint--GridRowGap);
        background-color: var(--ak-hint--BackgroundColor);
        color: var(--ak-hint--Color);
        border: var(--ak-hint--BorderWidth) solid var(--ak-hint--BorderColor);
        box-shadow: var(--ak-hint--BoxShadow);
        padding: var(--ak-hint--PaddingTop) var(--ak-hint--PaddingRight)
            var(--ak-hint--PaddingBottom) var(--ak-hint--PaddingLeft);
    }

    ::slotted(ak-hint-title),
    ::slotted(ak-hint-body) {
        display: grid;
        grid-template-columns: 1fr auto;
        grid-row-gap: var(--ak-hint--GridRowGap);
    }
`;
var AkHint = class extends AKElement {
  static get styles() {
    return [styles2];
  }
  render() {
    return ke`<div part="ak-hint" id="host"><slot></slot></div>`;
  }
};
AkHint = __decorateClass([
  t("ak-hint")
], AkHint);

// src/components/ak-hint/ak-hint-body.ts
var style = i`
    div {
        grid-column: 1 / -1;
        font-size: var(--ak-hint__body--FontSize);
    }
`;
var AkHintBody = class extends AKElement {
  static get styles() {
    return [style];
  }
  render() {
    return ke`<div part="ak-hint-body"><slot></slot></div>`;
  }
};
AkHintBody = __decorateClass([
  t("ak-hint-body")
], AkHintBody);

// src/admin/applications/ApplicationWizardHint.ts
var closeButtonIcon = ke`<svg
    fill="currentColor"
    height="1em"
    width="1em"
    viewBox="0 0 352 512"
    aria-hidden="true"
    role="img"
    style="vertical-align: -0.125em;"
>
    <path
        d="M242.72 256l100.07-100.07c12.28-12.28 12.28-32.19 0-44.48l-22.24-22.24c-12.28-12.28-32.19-12.28-44.48 0L176 189.28 75.93 89.21c-12.28-12.28-32.19-12.28-44.48 0L9.21 111.45c-12.28 12.28-12.28 32.19 0 44.48L109.28 256 9.21 356.07c-12.28 12.28-12.28 32.19 0 44.48l22.24 22.24c12.28 12.28 32.2 12.28 44.48 0L176 322.72l100.07 100.07c12.28 12.28 32.2 12.28 44.48 0l22.24-22.24c12.28-12.28 12.28-32.19 0-44.48L242.72 256z"
    ></path>
</svg>`;
var AkApplicationWizardHint = class extends AKElement {
  constructor() {
    super();
    this.forceHint = false;
    this.showHint = true;
    this.showHintController = new ShowHintController(
      this,
      "202310-application-wizard-announcement"
    );
  }
  static get styles() {
    return [
      patternfly_base_default,
      button_default,
      page_default,
      label_default,
      i`
                .pf-c-page__main-section {
                    padding-bottom: 0;
                }
                .ak-hint-text {
                    padding-bottom: var(--pf-global--spacer--md);
                }
            `
    ];
  }
  renderReminder() {
    const sectionStyles = {
      paddingBottom: "0",
      marginBottom: "-0.5rem",
      marginRight: "0.0625rem",
      textAlign: "right"
    };
    const textStyle = { maxWidth: "60ch" };
    return ke`<section
            class="pf-c-page__main-section pf-m-no-padding-mobile"
            style="${se(sectionStyles)}"
        >
            <span class="pf-c-label">
                <a class="pf-c-label__content" @click=${this.showHintController.show}>
                    <span class="pf-c-label__text" style="${se(textStyle)}">
                        ${msg("One hint, 'New Application Wizard', is currently hidden")}
                    </span>
                    <button
                        aria-disabled="false"
                        aria-label=${msg("Restore Application Wizard Hint")}
                        class="pf-c-button pf-m-plain"
                        type="button"
                        data-ouia-safe="true"
                    >
                        ${closeButtonIcon}
                    </button>
                </a>
            </span>
        </section>`;
  }
  renderHint() {
    return ke` <section class="pf-c-page__main-section pf-m-no-padding-mobile">
            <ak-hint>
                <ak-hint-body>
                    <p class="ak-hint-text">
                        You can now configure both an application and its authentication provider at
                        the same time with our new Application Wizard.
                        <!-- <a href="(link to docs)">Learn more about the wizard here.</a> -->
                    </p>
                    <ak-application-wizard .open=${getURLParam("createWizard", false)}>
                        <button
                            slot="trigger"
                            class="pf-c-button pf-m-primary"
                            data-ouia-component-id="start-application-wizard"
                        >
                            ${msg("Create with wizard")}
                        </button>
                    </ak-application-wizard>
                </ak-hint-body>
                ${this.showHintController.render()}
            </ak-hint>
        </section>`;
  }
  render() {
    return this.showHint || this.forceHint ? this.renderHint() : this.renderReminder();
  }
};
__decorateClass([
  n({ type: Boolean, attribute: "show-hint" })
], AkApplicationWizardHint.prototype, "forceHint", 2);
__decorateClass([
  r()
], AkApplicationWizardHint.prototype, "showHint", 2);
AkApplicationWizardHint = __decorateClass([
  t("ak-application-wizard-hint")
], AkApplicationWizardHint);
/*! Bundled license information:

lit-html/static.js:
  (**
   * @license
   * Copyright 2020 Google LLC
   * SPDX-License-Identifier: BSD-3-Clause
   *)
*/
//# sourceMappingURL=chunk-EQMGXTJR.js.map
