import {
  label_default
} from "./chunk-EEANTJCZ.js";
import {
  AKElement,
  Rt,
  n,
  patternfly_base_default,
  t
} from "./chunk-MKGIUSP2.js";
import {
  ke
} from "./chunk-BW7LVHGS.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/elements/Label.ts
var chromeList = [
  ["danger", "pf-m-red" /* Red */, "pf-m-red", "fa-times"],
  ["warning", "pf-m-orange" /* Orange */, "pf-m-orange", "fa-exclamation-triangle"],
  ["success", "pf-m-green" /* Green */, "pf-m-green", "fa-check"],
  ["info", "" /* Grey */, "pf-m-grey", "fa-info-circle"]
];
var Label = class extends AKElement {
  constructor() {
    super(...arguments);
    this.color = "" /* Grey */;
    this.compact = false;
  }
  static get styles() {
    return [patternfly_base_default, label_default];
  }
  get classesAndIcon() {
    const chrome = chromeList.find(
      ([level, color]) => this.color === level || this.color === color
    );
    const [illo, icon] = chrome ? chrome.slice(2) : ["pf-m-grey", "fa-info-circle"];
    return {
      classes: {
        "pf-c-label": true,
        "pf-m-compact": this.compact,
        ...illo ? { [illo]: true } : {}
      },
      icon: this.icon ? this.icon : icon
    };
  }
  render() {
    const { classes, icon } = this.classesAndIcon;
    return ke`<span class=${Rt(classes)}>
            <span class="pf-c-label__content">
                <span class="pf-c-label__icon">
                    <i class="fas fa-fw ${icon}" aria-hidden="true"></i>
                </span>
                <slot></slot>
            </span>
        </span>`;
  }
};
__decorateClass([
  n()
], Label.prototype, "color", 2);
__decorateClass([
  n()
], Label.prototype, "icon", 2);
__decorateClass([
  n({ type: Boolean })
], Label.prototype, "compact", 2);
Label = __decorateClass([
  t("ak-label")
], Label);
//# sourceMappingURL=chunk-FMBL57EI.js.map
