import {
  ModelEnumFromJSON,
  ModelEnumToJSON
} from "./chunk-3IFID2KX.js";
import {
  CacheFromJSON
} from "./chunk-2GU5BCBP.js";
import {
  BaseAPI,
  COLLECTION_FORMATS,
  EventActionsFromJSON,
  EventActionsToJSON,
  GroupFromJSON,
  JSONApiResponse,
  PaginationFromJSON,
  PolicyTestResultFromJSON,
  RequiredError,
  TypeCreateFromJSON,
  UsedByFromJSON,
  UserFromJSON,
  VoidApiResponse
} from "./chunk-MKGIUSP2.js";

// node_modules/@goauthentik/api/dist/esm/models/AppEnum.js
function AppEnumFromJSON(json) {
  return AppEnumFromJSONTyped(json, false);
}
function AppEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function AppEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/CountryCodeEnum.js
function CountryCodeEnumFromJSON(json) {
  return CountryCodeEnumFromJSONTyped(json, false);
}
function CountryCodeEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function CountryCodeEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/DetailedCountry.js
function DetailedCountryFromJSON(json) {
  return DetailedCountryFromJSONTyped(json, false);
}
function DetailedCountryFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "code": CountryCodeEnumFromJSON(json["code"]),
    "name": json["name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/DetailedCountryField.js
function DetailedCountryFieldFromJSON(json) {
  return DetailedCountryFieldFromJSONTyped(json, false);
}
function DetailedCountryFieldFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "code": CountryCodeEnumFromJSON(json["code"]),
    "name": json["name"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/DummyPolicy.js
function DummyPolicyFromJSON(json) {
  return DummyPolicyFromJSONTyped(json, false);
}
function DummyPolicyFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "executionLogging": json["execution_logging"] == null ? void 0 : json["execution_logging"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "boundTo": json["bound_to"],
    "result": json["result"] == null ? void 0 : json["result"],
    "waitMin": json["wait_min"] == null ? void 0 : json["wait_min"],
    "waitMax": json["wait_max"] == null ? void 0 : json["wait_max"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/DummyPolicyRequest.js
function DummyPolicyRequestToJSON(json) {
  return DummyPolicyRequestToJSONTyped(json, false);
}
function DummyPolicyRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"],
    "execution_logging": value["executionLogging"],
    "result": value["result"],
    "wait_min": value["waitMin"],
    "wait_max": value["waitMax"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/EventMatcherPolicy.js
function EventMatcherPolicyFromJSON(json) {
  return EventMatcherPolicyFromJSONTyped(json, false);
}
function EventMatcherPolicyFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "executionLogging": json["execution_logging"] == null ? void 0 : json["execution_logging"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "boundTo": json["bound_to"],
    "action": json["action"] == null ? void 0 : EventActionsFromJSON(json["action"]),
    "clientIp": json["client_ip"] == null ? void 0 : json["client_ip"],
    "app": json["app"] == null ? void 0 : AppEnumFromJSON(json["app"]),
    "model": json["model"] == null ? void 0 : ModelEnumFromJSON(json["model"])
  };
}

// node_modules/@goauthentik/api/dist/esm/models/EventMatcherPolicyRequest.js
function EventMatcherPolicyRequestToJSON(json) {
  return EventMatcherPolicyRequestToJSONTyped(json, false);
}
function EventMatcherPolicyRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"],
    "execution_logging": value["executionLogging"],
    "action": EventActionsToJSON(value["action"]),
    "client_ip": value["clientIp"],
    "app": AppEnumToJSON(value["app"]),
    "model": ModelEnumToJSON(value["model"])
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ExpressionPolicy.js
function ExpressionPolicyFromJSON(json) {
  return ExpressionPolicyFromJSONTyped(json, false);
}
function ExpressionPolicyFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "executionLogging": json["execution_logging"] == null ? void 0 : json["execution_logging"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "boundTo": json["bound_to"],
    "expression": json["expression"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ExpressionPolicyRequest.js
function ExpressionPolicyRequestToJSON(json) {
  return ExpressionPolicyRequestToJSONTyped(json, false);
}
function ExpressionPolicyRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"],
    "execution_logging": value["executionLogging"],
    "expression": value["expression"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/GeoIPPolicy.js
function GeoIPPolicyFromJSON(json) {
  return GeoIPPolicyFromJSONTyped(json, false);
}
function GeoIPPolicyFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "executionLogging": json["execution_logging"] == null ? void 0 : json["execution_logging"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "boundTo": json["bound_to"],
    "asns": json["asns"] == null ? void 0 : json["asns"],
    "countries": json["countries"].map(CountryCodeEnumFromJSON),
    "countriesObj": json["countries_obj"].map(DetailedCountryFieldFromJSON),
    "checkHistoryDistance": json["check_history_distance"] == null ? void 0 : json["check_history_distance"],
    "historyMaxDistanceKm": json["history_max_distance_km"] == null ? void 0 : json["history_max_distance_km"],
    "distanceToleranceKm": json["distance_tolerance_km"] == null ? void 0 : json["distance_tolerance_km"],
    "historyLoginCount": json["history_login_count"] == null ? void 0 : json["history_login_count"],
    "checkImpossibleTravel": json["check_impossible_travel"] == null ? void 0 : json["check_impossible_travel"],
    "impossibleToleranceKm": json["impossible_tolerance_km"] == null ? void 0 : json["impossible_tolerance_km"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/GeoIPPolicyRequest.js
function GeoIPPolicyRequestToJSON(json) {
  return GeoIPPolicyRequestToJSONTyped(json, false);
}
function GeoIPPolicyRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"],
    "execution_logging": value["executionLogging"],
    "asns": value["asns"],
    "countries": value["countries"].map(CountryCodeEnumToJSON),
    "check_history_distance": value["checkHistoryDistance"],
    "history_max_distance_km": value["historyMaxDistanceKm"],
    "distance_tolerance_km": value["distanceToleranceKm"],
    "history_login_count": value["historyLoginCount"],
    "check_impossible_travel": value["checkImpossibleTravel"],
    "impossible_tolerance_km": value["impossibleToleranceKm"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedDummyPolicyList.js
function PaginatedDummyPolicyListFromJSON(json) {
  return PaginatedDummyPolicyListFromJSONTyped(json, false);
}
function PaginatedDummyPolicyListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(DummyPolicyFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedEventMatcherPolicyList.js
function PaginatedEventMatcherPolicyListFromJSON(json) {
  return PaginatedEventMatcherPolicyListFromJSONTyped(json, false);
}
function PaginatedEventMatcherPolicyListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(EventMatcherPolicyFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedExpressionPolicyList.js
function PaginatedExpressionPolicyListFromJSON(json) {
  return PaginatedExpressionPolicyListFromJSONTyped(json, false);
}
function PaginatedExpressionPolicyListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(ExpressionPolicyFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedGeoIPPolicyList.js
function PaginatedGeoIPPolicyListFromJSON(json) {
  return PaginatedGeoIPPolicyListFromJSONTyped(json, false);
}
function PaginatedGeoIPPolicyListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(GeoIPPolicyFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PasswordExpiryPolicy.js
function PasswordExpiryPolicyFromJSON(json) {
  return PasswordExpiryPolicyFromJSONTyped(json, false);
}
function PasswordExpiryPolicyFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "executionLogging": json["execution_logging"] == null ? void 0 : json["execution_logging"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "boundTo": json["bound_to"],
    "days": json["days"],
    "denyOnly": json["deny_only"] == null ? void 0 : json["deny_only"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedPasswordExpiryPolicyList.js
function PaginatedPasswordExpiryPolicyListFromJSON(json) {
  return PaginatedPasswordExpiryPolicyListFromJSONTyped(json, false);
}
function PaginatedPasswordExpiryPolicyListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(PasswordExpiryPolicyFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PasswordPolicy.js
function PasswordPolicyFromJSON(json) {
  return PasswordPolicyFromJSONTyped(json, false);
}
function PasswordPolicyFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "executionLogging": json["execution_logging"] == null ? void 0 : json["execution_logging"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "boundTo": json["bound_to"],
    "passwordField": json["password_field"] == null ? void 0 : json["password_field"],
    "amountDigits": json["amount_digits"] == null ? void 0 : json["amount_digits"],
    "amountUppercase": json["amount_uppercase"] == null ? void 0 : json["amount_uppercase"],
    "amountLowercase": json["amount_lowercase"] == null ? void 0 : json["amount_lowercase"],
    "amountSymbols": json["amount_symbols"] == null ? void 0 : json["amount_symbols"],
    "lengthMin": json["length_min"] == null ? void 0 : json["length_min"],
    "symbolCharset": json["symbol_charset"] == null ? void 0 : json["symbol_charset"],
    "errorMessage": json["error_message"] == null ? void 0 : json["error_message"],
    "checkStaticRules": json["check_static_rules"] == null ? void 0 : json["check_static_rules"],
    "checkHaveIBeenPwned": json["check_have_i_been_pwned"] == null ? void 0 : json["check_have_i_been_pwned"],
    "checkZxcvbn": json["check_zxcvbn"] == null ? void 0 : json["check_zxcvbn"],
    "hibpAllowedCount": json["hibp_allowed_count"] == null ? void 0 : json["hibp_allowed_count"],
    "zxcvbnScoreThreshold": json["zxcvbn_score_threshold"] == null ? void 0 : json["zxcvbn_score_threshold"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedPasswordPolicyList.js
function PaginatedPasswordPolicyListFromJSON(json) {
  return PaginatedPasswordPolicyListFromJSONTyped(json, false);
}
function PaginatedPasswordPolicyListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(PasswordPolicyFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/Policy.js
function PolicyFromJSON(json) {
  return PolicyFromJSONTyped(json, false);
}
function PolicyFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "executionLogging": json["execution_logging"] == null ? void 0 : json["execution_logging"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "boundTo": json["bound_to"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PolicyBinding.js
function PolicyBindingFromJSON(json) {
  return PolicyBindingFromJSONTyped(json, false);
}
function PolicyBindingFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "policy": json["policy"] == null ? void 0 : json["policy"],
    "group": json["group"] == null ? void 0 : json["group"],
    "user": json["user"] == null ? void 0 : json["user"],
    "policyObj": PolicyFromJSON(json["policy_obj"]),
    "groupObj": GroupFromJSON(json["group_obj"]),
    "userObj": UserFromJSON(json["user_obj"]),
    "target": json["target"],
    "negate": json["negate"] == null ? void 0 : json["negate"],
    "enabled": json["enabled"] == null ? void 0 : json["enabled"],
    "order": json["order"],
    "timeout": json["timeout"] == null ? void 0 : json["timeout"],
    "failureResult": json["failure_result"] == null ? void 0 : json["failure_result"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedPolicyBindingList.js
function PaginatedPolicyBindingListFromJSON(json) {
  return PaginatedPolicyBindingListFromJSONTyped(json, false);
}
function PaginatedPolicyBindingListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(PolicyBindingFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedPolicyList.js
function PaginatedPolicyListFromJSON(json) {
  return PaginatedPolicyListFromJSONTyped(json, false);
}
function PaginatedPolicyListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(PolicyFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/Reputation.js
function ReputationFromJSON(json) {
  return ReputationFromJSONTyped(json, false);
}
function ReputationFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"] == null ? void 0 : json["pk"],
    "identifier": json["identifier"],
    "ip": json["ip"],
    "ipGeoData": json["ip_geo_data"] == null ? void 0 : json["ip_geo_data"],
    "ipAsnData": json["ip_asn_data"] == null ? void 0 : json["ip_asn_data"],
    "score": json["score"] == null ? void 0 : json["score"],
    "updated": new Date(json["updated"])
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedReputationList.js
function PaginatedReputationListFromJSON(json) {
  return PaginatedReputationListFromJSONTyped(json, false);
}
function PaginatedReputationListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(ReputationFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ReputationPolicy.js
function ReputationPolicyFromJSON(json) {
  return ReputationPolicyFromJSONTyped(json, false);
}
function ReputationPolicyFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "executionLogging": json["execution_logging"] == null ? void 0 : json["execution_logging"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "boundTo": json["bound_to"],
    "checkIp": json["check_ip"] == null ? void 0 : json["check_ip"],
    "checkUsername": json["check_username"] == null ? void 0 : json["check_username"],
    "threshold": json["threshold"] == null ? void 0 : json["threshold"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedReputationPolicyList.js
function PaginatedReputationPolicyListFromJSON(json) {
  return PaginatedReputationPolicyListFromJSONTyped(json, false);
}
function PaginatedReputationPolicyListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(ReputationPolicyFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PasswordExpiryPolicyRequest.js
function PasswordExpiryPolicyRequestToJSON(json) {
  return PasswordExpiryPolicyRequestToJSONTyped(json, false);
}
function PasswordExpiryPolicyRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"],
    "execution_logging": value["executionLogging"],
    "days": value["days"],
    "deny_only": value["denyOnly"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PasswordPolicyRequest.js
function PasswordPolicyRequestToJSON(json) {
  return PasswordPolicyRequestToJSONTyped(json, false);
}
function PasswordPolicyRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"],
    "execution_logging": value["executionLogging"],
    "password_field": value["passwordField"],
    "amount_digits": value["amountDigits"],
    "amount_uppercase": value["amountUppercase"],
    "amount_lowercase": value["amountLowercase"],
    "amount_symbols": value["amountSymbols"],
    "length_min": value["lengthMin"],
    "symbol_charset": value["symbolCharset"],
    "error_message": value["errorMessage"],
    "check_static_rules": value["checkStaticRules"],
    "check_have_i_been_pwned": value["checkHaveIBeenPwned"],
    "check_zxcvbn": value["checkZxcvbn"],
    "hibp_allowed_count": value["hibpAllowedCount"],
    "zxcvbn_score_threshold": value["zxcvbnScoreThreshold"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedDummyPolicyRequest.js
function PatchedDummyPolicyRequestToJSON(json) {
  return PatchedDummyPolicyRequestToJSONTyped(json, false);
}
function PatchedDummyPolicyRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"],
    "execution_logging": value["executionLogging"],
    "result": value["result"],
    "wait_min": value["waitMin"],
    "wait_max": value["waitMax"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedEventMatcherPolicyRequest.js
function PatchedEventMatcherPolicyRequestToJSON(json) {
  return PatchedEventMatcherPolicyRequestToJSONTyped(json, false);
}
function PatchedEventMatcherPolicyRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"],
    "execution_logging": value["executionLogging"],
    "action": EventActionsToJSON(value["action"]),
    "client_ip": value["clientIp"],
    "app": AppEnumToJSON(value["app"]),
    "model": ModelEnumToJSON(value["model"])
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedExpressionPolicyRequest.js
function PatchedExpressionPolicyRequestToJSON(json) {
  return PatchedExpressionPolicyRequestToJSONTyped(json, false);
}
function PatchedExpressionPolicyRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"],
    "execution_logging": value["executionLogging"],
    "expression": value["expression"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedGeoIPPolicyRequest.js
function PatchedGeoIPPolicyRequestToJSON(json) {
  return PatchedGeoIPPolicyRequestToJSONTyped(json, false);
}
function PatchedGeoIPPolicyRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"],
    "execution_logging": value["executionLogging"],
    "asns": value["asns"],
    "countries": value["countries"] == null ? void 0 : value["countries"].map(CountryCodeEnumToJSON),
    "check_history_distance": value["checkHistoryDistance"],
    "history_max_distance_km": value["historyMaxDistanceKm"],
    "distance_tolerance_km": value["distanceToleranceKm"],
    "history_login_count": value["historyLoginCount"],
    "check_impossible_travel": value["checkImpossibleTravel"],
    "impossible_tolerance_km": value["impossibleToleranceKm"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedPasswordExpiryPolicyRequest.js
function PatchedPasswordExpiryPolicyRequestToJSON(json) {
  return PatchedPasswordExpiryPolicyRequestToJSONTyped(json, false);
}
function PatchedPasswordExpiryPolicyRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"],
    "execution_logging": value["executionLogging"],
    "days": value["days"],
    "deny_only": value["denyOnly"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedPasswordPolicyRequest.js
function PatchedPasswordPolicyRequestToJSON(json) {
  return PatchedPasswordPolicyRequestToJSONTyped(json, false);
}
function PatchedPasswordPolicyRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"],
    "execution_logging": value["executionLogging"],
    "password_field": value["passwordField"],
    "amount_digits": value["amountDigits"],
    "amount_uppercase": value["amountUppercase"],
    "amount_lowercase": value["amountLowercase"],
    "amount_symbols": value["amountSymbols"],
    "length_min": value["lengthMin"],
    "symbol_charset": value["symbolCharset"],
    "error_message": value["errorMessage"],
    "check_static_rules": value["checkStaticRules"],
    "check_have_i_been_pwned": value["checkHaveIBeenPwned"],
    "check_zxcvbn": value["checkZxcvbn"],
    "hibp_allowed_count": value["hibpAllowedCount"],
    "zxcvbn_score_threshold": value["zxcvbnScoreThreshold"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedPolicyBindingRequest.js
function PatchedPolicyBindingRequestToJSON(json) {
  return PatchedPolicyBindingRequestToJSONTyped(json, false);
}
function PatchedPolicyBindingRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "policy": value["policy"],
    "group": value["group"],
    "user": value["user"],
    "target": value["target"],
    "negate": value["negate"],
    "enabled": value["enabled"],
    "order": value["order"],
    "timeout": value["timeout"],
    "failure_result": value["failureResult"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedReputationPolicyRequest.js
function PatchedReputationPolicyRequestToJSON(json) {
  return PatchedReputationPolicyRequestToJSONTyped(json, false);
}
function PatchedReputationPolicyRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"],
    "execution_logging": value["executionLogging"],
    "check_ip": value["checkIp"],
    "check_username": value["checkUsername"],
    "threshold": value["threshold"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PolicyBindingRequest.js
function PolicyBindingRequestToJSON(json) {
  return PolicyBindingRequestToJSONTyped(json, false);
}
function PolicyBindingRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "policy": value["policy"],
    "group": value["group"],
    "user": value["user"],
    "target": value["target"],
    "negate": value["negate"],
    "enabled": value["enabled"],
    "order": value["order"],
    "timeout": value["timeout"],
    "failure_result": value["failureResult"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PolicyTestRequest.js
function PolicyTestRequestToJSON(json) {
  return PolicyTestRequestToJSONTyped(json, false);
}
function PolicyTestRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "user": value["user"],
    "context": value["context"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ReputationPolicyRequest.js
function ReputationPolicyRequestToJSON(json) {
  return ReputationPolicyRequestToJSONTyped(json, false);
}
function ReputationPolicyRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"],
    "execution_logging": value["executionLogging"],
    "check_ip": value["checkIp"],
    "check_username": value["checkUsername"],
    "threshold": value["threshold"]
  };
}

// node_modules/@goauthentik/api/dist/esm/apis/PoliciesApi.js
var __awaiter = function(thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function(resolve) {
      resolve(value);
    });
  }
  return new (P || (P = Promise))(function(resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var PoliciesApi = class extends BaseAPI {
  /**
   * Clear policy cache
   */
  policiesAllCacheClearCreateRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/all/cache_clear/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Clear policy cache
   */
  policiesAllCacheClearCreate(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesAllCacheClearCreateRaw(initOverrides);
    });
  }
  /**
   * Info about cached policies
   */
  policiesAllCacheInfoRetrieveRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/all/cache_info/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => CacheFromJSON(jsonValue));
    });
  }
  /**
   * Info about cached policies
   */
  policiesAllCacheInfoRetrieve(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesAllCacheInfoRetrieveRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Policy Viewset
   */
  policiesAllDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesAllDestroy().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/all/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Policy Viewset
   */
  policiesAllDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesAllDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Policy Viewset
   */
  policiesAllListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["bindingsIsnull"] != null) {
        queryParameters["bindings__isnull"] = requestParameters["bindingsIsnull"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["promptstageIsnull"] != null) {
        queryParameters["promptstage__isnull"] = requestParameters["promptstageIsnull"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/all/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedPolicyListFromJSON(jsonValue));
    });
  }
  /**
   * Policy Viewset
   */
  policiesAllList() {
    return __awaiter(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.policiesAllListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Policy Viewset
   */
  policiesAllRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesAllRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/all/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PolicyFromJSON(jsonValue));
    });
  }
  /**
   * Policy Viewset
   */
  policiesAllRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesAllRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Test policy
   */
  policiesAllTestCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesAllTestCreate().');
      }
      if (requestParameters["policyTestRequest"] == null) {
        throw new RequiredError("policyTestRequest", 'Required parameter "policyTestRequest" was null or undefined when calling policiesAllTestCreate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/all/{policy_uuid}/test/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PolicyTestRequestToJSON(requestParameters["policyTestRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PolicyTestResultFromJSON(jsonValue));
    });
  }
  /**
   * Test policy
   */
  policiesAllTestCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesAllTestCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get all creatable types
   */
  policiesAllTypesListRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/all/types/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(TypeCreateFromJSON));
    });
  }
  /**
   * Get all creatable types
   */
  policiesAllTypesList(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesAllTypesListRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesAllUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesAllUsedByList().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/all/{policy_uuid}/used_by/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesAllUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesAllUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyBindingRequest"] == null) {
        throw new RequiredError("policyBindingRequest", 'Required parameter "policyBindingRequest" was null or undefined when calling policiesBindingsCreate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/bindings/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PolicyBindingRequestToJSON(requestParameters["policyBindingRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PolicyBindingFromJSON(jsonValue));
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesBindingsCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyBindingUuid"] == null) {
        throw new RequiredError("policyBindingUuid", 'Required parameter "policyBindingUuid" was null or undefined when calling policiesBindingsDestroy().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/bindings/{policy_binding_uuid}/`.replace(`{${"policy_binding_uuid"}}`, encodeURIComponent(String(requestParameters["policyBindingUuid"]))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesBindingsDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["enabled"] != null) {
        queryParameters["enabled"] = requestParameters["enabled"];
      }
      if (requestParameters["order"] != null) {
        queryParameters["order"] = requestParameters["order"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["policy"] != null) {
        queryParameters["policy"] = requestParameters["policy"];
      }
      if (requestParameters["policyIsnull"] != null) {
        queryParameters["policy__isnull"] = requestParameters["policyIsnull"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      if (requestParameters["target"] != null) {
        queryParameters["target"] = requestParameters["target"];
      }
      if (requestParameters["targetIn"] != null) {
        queryParameters["target_in"] = requestParameters["targetIn"];
      }
      if (requestParameters["timeout"] != null) {
        queryParameters["timeout"] = requestParameters["timeout"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/bindings/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedPolicyBindingListFromJSON(jsonValue));
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsList() {
    return __awaiter(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.policiesBindingsListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyBindingUuid"] == null) {
        throw new RequiredError("policyBindingUuid", 'Required parameter "policyBindingUuid" was null or undefined when calling policiesBindingsPartialUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/bindings/{policy_binding_uuid}/`.replace(`{${"policy_binding_uuid"}}`, encodeURIComponent(String(requestParameters["policyBindingUuid"]))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedPolicyBindingRequestToJSON(requestParameters["patchedPolicyBindingRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PolicyBindingFromJSON(jsonValue));
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesBindingsPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyBindingUuid"] == null) {
        throw new RequiredError("policyBindingUuid", 'Required parameter "policyBindingUuid" was null or undefined when calling policiesBindingsRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/bindings/{policy_binding_uuid}/`.replace(`{${"policy_binding_uuid"}}`, encodeURIComponent(String(requestParameters["policyBindingUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PolicyBindingFromJSON(jsonValue));
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesBindingsRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyBindingUuid"] == null) {
        throw new RequiredError("policyBindingUuid", 'Required parameter "policyBindingUuid" was null or undefined when calling policiesBindingsUpdate().');
      }
      if (requestParameters["policyBindingRequest"] == null) {
        throw new RequiredError("policyBindingRequest", 'Required parameter "policyBindingRequest" was null or undefined when calling policiesBindingsUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/bindings/{policy_binding_uuid}/`.replace(`{${"policy_binding_uuid"}}`, encodeURIComponent(String(requestParameters["policyBindingUuid"]))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: PolicyBindingRequestToJSON(requestParameters["policyBindingRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PolicyBindingFromJSON(jsonValue));
    });
  }
  /**
   * PolicyBinding Viewset
   */
  policiesBindingsUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesBindingsUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesBindingsUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyBindingUuid"] == null) {
        throw new RequiredError("policyBindingUuid", 'Required parameter "policyBindingUuid" was null or undefined when calling policiesBindingsUsedByList().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/bindings/{policy_binding_uuid}/used_by/`.replace(`{${"policy_binding_uuid"}}`, encodeURIComponent(String(requestParameters["policyBindingUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesBindingsUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesBindingsUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["dummyPolicyRequest"] == null) {
        throw new RequiredError("dummyPolicyRequest", 'Required parameter "dummyPolicyRequest" was null or undefined when calling policiesDummyCreate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/dummy/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: DummyPolicyRequestToJSON(requestParameters["dummyPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DummyPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesDummyCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesDummyDestroy().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/dummy/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesDummyDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["created"] != null) {
        queryParameters["created"] = requestParameters["created"].toISOString();
      }
      if (requestParameters["executionLogging"] != null) {
        queryParameters["execution_logging"] = requestParameters["executionLogging"];
      }
      if (requestParameters["lastUpdated"] != null) {
        queryParameters["last_updated"] = requestParameters["lastUpdated"].toISOString();
      }
      if (requestParameters["name"] != null) {
        queryParameters["name"] = requestParameters["name"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["policyUuid"] != null) {
        queryParameters["policy_uuid"] = requestParameters["policyUuid"];
      }
      if (requestParameters["result"] != null) {
        queryParameters["result"] = requestParameters["result"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      if (requestParameters["waitMax"] != null) {
        queryParameters["wait_max"] = requestParameters["waitMax"];
      }
      if (requestParameters["waitMin"] != null) {
        queryParameters["wait_min"] = requestParameters["waitMin"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/dummy/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedDummyPolicyListFromJSON(jsonValue));
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyList() {
    return __awaiter(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.policiesDummyListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesDummyPartialUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/dummy/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedDummyPolicyRequestToJSON(requestParameters["patchedDummyPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DummyPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesDummyPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesDummyRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/dummy/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DummyPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesDummyRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesDummyUpdate().');
      }
      if (requestParameters["dummyPolicyRequest"] == null) {
        throw new RequiredError("dummyPolicyRequest", 'Required parameter "dummyPolicyRequest" was null or undefined when calling policiesDummyUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/dummy/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: DummyPolicyRequestToJSON(requestParameters["dummyPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => DummyPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Dummy Viewset
   */
  policiesDummyUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesDummyUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesDummyUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesDummyUsedByList().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/dummy/{policy_uuid}/used_by/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesDummyUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesDummyUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["eventMatcherPolicyRequest"] == null) {
        throw new RequiredError("eventMatcherPolicyRequest", 'Required parameter "eventMatcherPolicyRequest" was null or undefined when calling policiesEventMatcherCreate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/event_matcher/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: EventMatcherPolicyRequestToJSON(requestParameters["eventMatcherPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EventMatcherPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesEventMatcherCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesEventMatcherDestroy().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/event_matcher/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesEventMatcherDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["action"] != null) {
        queryParameters["action"] = requestParameters["action"];
      }
      if (requestParameters["app"] != null) {
        queryParameters["app"] = requestParameters["app"];
      }
      if (requestParameters["clientIp"] != null) {
        queryParameters["client_ip"] = requestParameters["clientIp"];
      }
      if (requestParameters["created"] != null) {
        queryParameters["created"] = requestParameters["created"].toISOString();
      }
      if (requestParameters["executionLogging"] != null) {
        queryParameters["execution_logging"] = requestParameters["executionLogging"];
      }
      if (requestParameters["lastUpdated"] != null) {
        queryParameters["last_updated"] = requestParameters["lastUpdated"].toISOString();
      }
      if (requestParameters["model"] != null) {
        queryParameters["model"] = requestParameters["model"];
      }
      if (requestParameters["name"] != null) {
        queryParameters["name"] = requestParameters["name"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["policyUuid"] != null) {
        queryParameters["policy_uuid"] = requestParameters["policyUuid"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/event_matcher/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedEventMatcherPolicyListFromJSON(jsonValue));
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherList() {
    return __awaiter(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.policiesEventMatcherListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesEventMatcherPartialUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/event_matcher/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedEventMatcherPolicyRequestToJSON(requestParameters["patchedEventMatcherPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EventMatcherPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesEventMatcherPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesEventMatcherRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/event_matcher/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EventMatcherPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesEventMatcherRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesEventMatcherUpdate().');
      }
      if (requestParameters["eventMatcherPolicyRequest"] == null) {
        throw new RequiredError("eventMatcherPolicyRequest", 'Required parameter "eventMatcherPolicyRequest" was null or undefined when calling policiesEventMatcherUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/event_matcher/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: EventMatcherPolicyRequestToJSON(requestParameters["eventMatcherPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EventMatcherPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Event Matcher Policy Viewset
   */
  policiesEventMatcherUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesEventMatcherUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesEventMatcherUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesEventMatcherUsedByList().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/event_matcher/{policy_uuid}/used_by/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesEventMatcherUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesEventMatcherUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["expressionPolicyRequest"] == null) {
        throw new RequiredError("expressionPolicyRequest", 'Required parameter "expressionPolicyRequest" was null or undefined when calling policiesExpressionCreate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/expression/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: ExpressionPolicyRequestToJSON(requestParameters["expressionPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ExpressionPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesExpressionCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesExpressionDestroy().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/expression/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesExpressionDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["created"] != null) {
        queryParameters["created"] = requestParameters["created"].toISOString();
      }
      if (requestParameters["executionLogging"] != null) {
        queryParameters["execution_logging"] = requestParameters["executionLogging"];
      }
      if (requestParameters["expression"] != null) {
        queryParameters["expression"] = requestParameters["expression"];
      }
      if (requestParameters["lastUpdated"] != null) {
        queryParameters["last_updated"] = requestParameters["lastUpdated"].toISOString();
      }
      if (requestParameters["name"] != null) {
        queryParameters["name"] = requestParameters["name"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["policyUuid"] != null) {
        queryParameters["policy_uuid"] = requestParameters["policyUuid"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/expression/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedExpressionPolicyListFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionList() {
    return __awaiter(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.policiesExpressionListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesExpressionPartialUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/expression/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedExpressionPolicyRequestToJSON(requestParameters["patchedExpressionPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ExpressionPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesExpressionPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesExpressionRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/expression/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ExpressionPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesExpressionRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesExpressionUpdate().');
      }
      if (requestParameters["expressionPolicyRequest"] == null) {
        throw new RequiredError("expressionPolicyRequest", 'Required parameter "expressionPolicyRequest" was null or undefined when calling policiesExpressionUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/expression/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: ExpressionPolicyRequestToJSON(requestParameters["expressionPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ExpressionPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Source Viewset
   */
  policiesExpressionUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesExpressionUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesExpressionUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesExpressionUsedByList().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/expression/{policy_uuid}/used_by/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesExpressionUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesExpressionUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GeoIP Viewset
   */
  policiesGeoipCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["geoIPPolicyRequest"] == null) {
        throw new RequiredError("geoIPPolicyRequest", 'Required parameter "geoIPPolicyRequest" was null or undefined when calling policiesGeoipCreate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/geoip/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: GeoIPPolicyRequestToJSON(requestParameters["geoIPPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => GeoIPPolicyFromJSON(jsonValue));
    });
  }
  /**
   * GeoIP Viewset
   */
  policiesGeoipCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesGeoipCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GeoIP Viewset
   */
  policiesGeoipDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesGeoipDestroy().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/geoip/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * GeoIP Viewset
   */
  policiesGeoipDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesGeoipDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Get all countries in ISO-3166-1
   */
  policiesGeoipIso3166ListRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/geoip_iso3166/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(DetailedCountryFromJSON));
    });
  }
  /**
   * Get all countries in ISO-3166-1
   */
  policiesGeoipIso3166List(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesGeoipIso3166ListRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * GeoIP Viewset
   */
  policiesGeoipListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["name"] != null) {
        queryParameters["name"] = requestParameters["name"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/geoip/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedGeoIPPolicyListFromJSON(jsonValue));
    });
  }
  /**
   * GeoIP Viewset
   */
  policiesGeoipList() {
    return __awaiter(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.policiesGeoipListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GeoIP Viewset
   */
  policiesGeoipPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesGeoipPartialUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/geoip/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedGeoIPPolicyRequestToJSON(requestParameters["patchedGeoIPPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => GeoIPPolicyFromJSON(jsonValue));
    });
  }
  /**
   * GeoIP Viewset
   */
  policiesGeoipPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesGeoipPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GeoIP Viewset
   */
  policiesGeoipRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesGeoipRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/geoip/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => GeoIPPolicyFromJSON(jsonValue));
    });
  }
  /**
   * GeoIP Viewset
   */
  policiesGeoipRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesGeoipRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * GeoIP Viewset
   */
  policiesGeoipUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesGeoipUpdate().');
      }
      if (requestParameters["geoIPPolicyRequest"] == null) {
        throw new RequiredError("geoIPPolicyRequest", 'Required parameter "geoIPPolicyRequest" was null or undefined when calling policiesGeoipUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/geoip/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: GeoIPPolicyRequestToJSON(requestParameters["geoIPPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => GeoIPPolicyFromJSON(jsonValue));
    });
  }
  /**
   * GeoIP Viewset
   */
  policiesGeoipUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesGeoipUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesGeoipUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesGeoipUsedByList().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/geoip/{policy_uuid}/used_by/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesGeoipUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesGeoipUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["passwordPolicyRequest"] == null) {
        throw new RequiredError("passwordPolicyRequest", 'Required parameter "passwordPolicyRequest" was null or undefined when calling policiesPasswordCreate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PasswordPolicyRequestToJSON(requestParameters["passwordPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PasswordPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesPasswordDestroy().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesPasswordDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["passwordExpiryPolicyRequest"] == null) {
        throw new RequiredError("passwordExpiryPolicyRequest", 'Required parameter "passwordExpiryPolicyRequest" was null or undefined when calling policiesPasswordExpiryCreate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password_expiry/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: PasswordExpiryPolicyRequestToJSON(requestParameters["passwordExpiryPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PasswordExpiryPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordExpiryCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesPasswordExpiryDestroy().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password_expiry/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesPasswordExpiryDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["created"] != null) {
        queryParameters["created"] = requestParameters["created"].toISOString();
      }
      if (requestParameters["days"] != null) {
        queryParameters["days"] = requestParameters["days"];
      }
      if (requestParameters["denyOnly"] != null) {
        queryParameters["deny_only"] = requestParameters["denyOnly"];
      }
      if (requestParameters["executionLogging"] != null) {
        queryParameters["execution_logging"] = requestParameters["executionLogging"];
      }
      if (requestParameters["lastUpdated"] != null) {
        queryParameters["last_updated"] = requestParameters["lastUpdated"].toISOString();
      }
      if (requestParameters["name"] != null) {
        queryParameters["name"] = requestParameters["name"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["policyUuid"] != null) {
        queryParameters["policy_uuid"] = requestParameters["policyUuid"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password_expiry/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedPasswordExpiryPolicyListFromJSON(jsonValue));
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryList() {
    return __awaiter(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.policiesPasswordExpiryListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesPasswordExpiryPartialUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password_expiry/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedPasswordExpiryPolicyRequestToJSON(requestParameters["patchedPasswordExpiryPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PasswordExpiryPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordExpiryPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesPasswordExpiryRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password_expiry/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PasswordExpiryPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordExpiryRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesPasswordExpiryUpdate().');
      }
      if (requestParameters["passwordExpiryPolicyRequest"] == null) {
        throw new RequiredError("passwordExpiryPolicyRequest", 'Required parameter "passwordExpiryPolicyRequest" was null or undefined when calling policiesPasswordExpiryUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password_expiry/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: PasswordExpiryPolicyRequestToJSON(requestParameters["passwordExpiryPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PasswordExpiryPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Password Expiry Viewset
   */
  policiesPasswordExpiryUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordExpiryUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesPasswordExpiryUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesPasswordExpiryUsedByList().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password_expiry/{policy_uuid}/used_by/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesPasswordExpiryUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordExpiryUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["amountDigits"] != null) {
        queryParameters["amount_digits"] = requestParameters["amountDigits"];
      }
      if (requestParameters["amountLowercase"] != null) {
        queryParameters["amount_lowercase"] = requestParameters["amountLowercase"];
      }
      if (requestParameters["amountSymbols"] != null) {
        queryParameters["amount_symbols"] = requestParameters["amountSymbols"];
      }
      if (requestParameters["amountUppercase"] != null) {
        queryParameters["amount_uppercase"] = requestParameters["amountUppercase"];
      }
      if (requestParameters["checkHaveIBeenPwned"] != null) {
        queryParameters["check_have_i_been_pwned"] = requestParameters["checkHaveIBeenPwned"];
      }
      if (requestParameters["checkStaticRules"] != null) {
        queryParameters["check_static_rules"] = requestParameters["checkStaticRules"];
      }
      if (requestParameters["checkZxcvbn"] != null) {
        queryParameters["check_zxcvbn"] = requestParameters["checkZxcvbn"];
      }
      if (requestParameters["created"] != null) {
        queryParameters["created"] = requestParameters["created"].toISOString();
      }
      if (requestParameters["errorMessage"] != null) {
        queryParameters["error_message"] = requestParameters["errorMessage"];
      }
      if (requestParameters["executionLogging"] != null) {
        queryParameters["execution_logging"] = requestParameters["executionLogging"];
      }
      if (requestParameters["hibpAllowedCount"] != null) {
        queryParameters["hibp_allowed_count"] = requestParameters["hibpAllowedCount"];
      }
      if (requestParameters["lastUpdated"] != null) {
        queryParameters["last_updated"] = requestParameters["lastUpdated"].toISOString();
      }
      if (requestParameters["lengthMin"] != null) {
        queryParameters["length_min"] = requestParameters["lengthMin"];
      }
      if (requestParameters["name"] != null) {
        queryParameters["name"] = requestParameters["name"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["passwordField"] != null) {
        queryParameters["password_field"] = requestParameters["passwordField"];
      }
      if (requestParameters["policyUuid"] != null) {
        queryParameters["policy_uuid"] = requestParameters["policyUuid"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      if (requestParameters["symbolCharset"] != null) {
        queryParameters["symbol_charset"] = requestParameters["symbolCharset"];
      }
      if (requestParameters["zxcvbnScoreThreshold"] != null) {
        queryParameters["zxcvbn_score_threshold"] = requestParameters["zxcvbnScoreThreshold"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedPasswordPolicyListFromJSON(jsonValue));
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordList() {
    return __awaiter(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.policiesPasswordListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesPasswordPartialUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedPasswordPolicyRequestToJSON(requestParameters["patchedPasswordPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PasswordPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesPasswordRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PasswordPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesPasswordUpdate().');
      }
      if (requestParameters["passwordPolicyRequest"] == null) {
        throw new RequiredError("passwordPolicyRequest", 'Required parameter "passwordPolicyRequest" was null or undefined when calling policiesPasswordUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: PasswordPolicyRequestToJSON(requestParameters["passwordPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PasswordPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Password Policy Viewset
   */
  policiesPasswordUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesPasswordUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesPasswordUsedByList().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/password/{policy_uuid}/used_by/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesPasswordUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesPasswordUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationCreateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["reputationPolicyRequest"] == null) {
        throw new RequiredError("reputationPolicyRequest", 'Required parameter "reputationPolicyRequest" was null or undefined when calling policiesReputationCreate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: ReputationPolicyRequestToJSON(requestParameters["reputationPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ReputationPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationCreate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesReputationCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesReputationDestroy().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesReputationDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["checkIp"] != null) {
        queryParameters["check_ip"] = requestParameters["checkIp"];
      }
      if (requestParameters["checkUsername"] != null) {
        queryParameters["check_username"] = requestParameters["checkUsername"];
      }
      if (requestParameters["created"] != null) {
        queryParameters["created"] = requestParameters["created"].toISOString();
      }
      if (requestParameters["executionLogging"] != null) {
        queryParameters["execution_logging"] = requestParameters["executionLogging"];
      }
      if (requestParameters["lastUpdated"] != null) {
        queryParameters["last_updated"] = requestParameters["lastUpdated"].toISOString();
      }
      if (requestParameters["name"] != null) {
        queryParameters["name"] = requestParameters["name"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["policyUuid"] != null) {
        queryParameters["policy_uuid"] = requestParameters["policyUuid"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      if (requestParameters["threshold"] != null) {
        queryParameters["threshold"] = requestParameters["threshold"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedReputationPolicyListFromJSON(jsonValue));
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationList() {
    return __awaiter(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.policiesReputationListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesReputationPartialUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedReputationPolicyRequestToJSON(requestParameters["patchedReputationPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ReputationPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationPartialUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesReputationPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesReputationRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ReputationPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesReputationRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Reputation Viewset
   */
  policiesReputationScoresDestroyRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["reputationUuid"] == null) {
        throw new RequiredError("reputationUuid", 'Required parameter "reputationUuid" was null or undefined when calling policiesReputationScoresDestroy().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/scores/{reputation_uuid}/`.replace(`{${"reputation_uuid"}}`, encodeURIComponent(String(requestParameters["reputationUuid"]))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Reputation Viewset
   */
  policiesReputationScoresDestroy(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      yield this.policiesReputationScoresDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Reputation Viewset
   */
  policiesReputationScoresListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["identifier"] != null) {
        queryParameters["identifier"] = requestParameters["identifier"];
      }
      if (requestParameters["identifierIn"] != null) {
        queryParameters["identifier_in"] = requestParameters["identifierIn"].join(COLLECTION_FORMATS["csv"]);
      }
      if (requestParameters["ip"] != null) {
        queryParameters["ip"] = requestParameters["ip"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["score"] != null) {
        queryParameters["score"] = requestParameters["score"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/scores/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedReputationListFromJSON(jsonValue));
    });
  }
  /**
   * Reputation Viewset
   */
  policiesReputationScoresList() {
    return __awaiter(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.policiesReputationScoresListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Reputation Viewset
   */
  policiesReputationScoresRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["reputationUuid"] == null) {
        throw new RequiredError("reputationUuid", 'Required parameter "reputationUuid" was null or undefined when calling policiesReputationScoresRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/scores/{reputation_uuid}/`.replace(`{${"reputation_uuid"}}`, encodeURIComponent(String(requestParameters["reputationUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ReputationFromJSON(jsonValue));
    });
  }
  /**
   * Reputation Viewset
   */
  policiesReputationScoresRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesReputationScoresRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesReputationScoresUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["reputationUuid"] == null) {
        throw new RequiredError("reputationUuid", 'Required parameter "reputationUuid" was null or undefined when calling policiesReputationScoresUsedByList().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/scores/{reputation_uuid}/used_by/`.replace(`{${"reputation_uuid"}}`, encodeURIComponent(String(requestParameters["reputationUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesReputationScoresUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesReputationScoresUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesReputationUpdate().');
      }
      if (requestParameters["reputationPolicyRequest"] == null) {
        throw new RequiredError("reputationPolicyRequest", 'Required parameter "reputationPolicyRequest" was null or undefined when calling policiesReputationUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/{policy_uuid}/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: ReputationPolicyRequestToJSON(requestParameters["reputationPolicyRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ReputationPolicyFromJSON(jsonValue));
    });
  }
  /**
   * Reputation Policy Viewset
   */
  policiesReputationUpdate(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesReputationUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesReputationUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["policyUuid"] == null) {
        throw new RequiredError("policyUuid", 'Required parameter "policyUuid" was null or undefined when calling policiesReputationUsedByList().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/policies/reputation/{policy_uuid}/used_by/`.replace(`{${"policy_uuid"}}`, encodeURIComponent(String(requestParameters["policyUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  policiesReputationUsedByList(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.policiesReputationUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
};

export {
  PoliciesApi
};
//# sourceMappingURL=chunk-IUFGI55K.js.map
