import {
  description_list_default
} from "./chunk-DJQHOO67.js";
import {
  AKElement,
  getRelativeTime,
  n,
  patternfly_base_default,
  t
} from "./chunk-MKGIUSP2.js";
import {
  i,
  ke,
  msg,
  str
} from "./chunk-BW7LVHGS.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/admin/outposts/OutpostHealth.ts
var OutpostHealthElement = class extends AKElement {
  static get styles() {
    return [
      patternfly_base_default,
      description_list_default,
      i`
                li {
                    margin: 5px 0;
                }
            `
    ];
  }
  render() {
    if (!this.outpostHealth) {
      return ke`<ak-spinner></ak-spinner>`;
    }
    let versionString = this.outpostHealth.version;
    if (this.outpostHealth.buildHash) {
      versionString = msg(
        str`${versionString} (build ${this.outpostHealth.buildHash.substring(0, 8)})`
      );
    }
    if (this.outpostHealth.fipsEnabled) {
      versionString = msg(str`${versionString} (FIPS)`);
    }
    return ke`<dl class="pf-c-description-list pf-m-compact">
            <div class="pf-c-description-list__group">
                <dt class="pf-c-description-list__term">
                    <span class="pf-c-description-list__text">${msg("Last seen")}</span>
                </dt>
                <dd class="pf-c-description-list__description">
                    <div class="pf-c-description-list__text">
                        <ak-label color=${"pf-m-green" /* Green */} ?compact=${true}>
                            ${msg(
      str`${getRelativeTime(this.outpostHealth.lastSeen)} (${this.outpostHealth.lastSeen?.toLocaleTimeString()})`
    )}
                        </ak-label>
                    </div>
                </dd>
            </div>
            <div class="pf-c-description-list__group">
                <dt class="pf-c-description-list__term">
                    <span class="pf-c-description-list__text">${msg("Version")}</span>
                </dt>
                <dd class="pf-c-description-list__description">
                    <div class="pf-c-description-list__text">
                        ${this.outpostHealth.versionOutdated ? ke`<ak-label color=${"pf-m-red" /* Red */} ?compact=${true}
                                  >${msg(
      str`${this.outpostHealth.version}, should be ${this.outpostHealth.versionShould}`
    )}
                              </ak-label>` : ke`<ak-label color=${"pf-m-green" /* Green */} ?compact=${true}
                                  >${versionString}
                              </ak-label>`}
                    </div>
                </dd>
            </div>
            <div class="pf-c-description-list__group">
                <dt class="pf-c-description-list__term">
                    <span class="pf-c-description-list__text">${msg("Hostname")}</span>
                </dt>
                <dd class="pf-c-description-list__description">
                    <div class="pf-c-description-list__text">${this.outpostHealth.hostname}</div>
                </dd>
            </div>
        </dl> `;
  }
};
__decorateClass([
  n({ attribute: false })
], OutpostHealthElement.prototype, "outpostHealth", 2);
OutpostHealthElement = __decorateClass([
  t("ak-outpost-health")
], OutpostHealthElement);
//# sourceMappingURL=chunk-MSU7DZQK.js.map
