import {
  AKElement,
  Rt,
  alert_default,
  n,
  patternfly_base_default,
  t
} from "./chunk-MKGIUSP2.js";
import {
  ke
} from "./chunk-BW7LVHGS.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/elements/Alert.ts
var levelNames = ["warning", "info", "success", "danger"];
var Alert = class extends AKElement {
  constructor() {
    super(...arguments);
    this.inline = false;
    this.plain = false;
    this.level = "pf-m-warning" /* Warning */;
    this.icon = "fa-exclamation-circle";
  }
  static get styles() {
    return [patternfly_base_default, alert_default];
  }
  get classmap() {
    const level = levelNames.includes(this.level) ? `pf-m-${this.level}` : this.level;
    return {
      "pf-c-alert": true,
      "pf-m-inline": this.inline,
      "pf-m-plain": this.plain,
      [level]: true
    };
  }
  render() {
    return ke`<div class="${Rt(this.classmap)}">
            <div class="pf-c-alert__icon">
                <i class="fas ${this.icon}"></i>
            </div>
            <h4 class="pf-c-alert__title"><slot></slot></h4>
        </div>`;
  }
};
__decorateClass([
  n({ type: Boolean })
], Alert.prototype, "inline", 2);
__decorateClass([
  n({ type: Boolean })
], Alert.prototype, "plain", 2);
__decorateClass([
  n()
], Alert.prototype, "level", 2);
__decorateClass([
  n()
], Alert.prototype, "icon", 2);
Alert = __decorateClass([
  t("ak-alert")
], Alert);
//# sourceMappingURL=chunk-PIENMLIY.js.map
