import {
  check_default
} from "./chunk-OKSORNCU.js";
import {
  AuthTypeEnum,
  AuthenticatorAttachmentEnum,
  BackendsEnum,
  ConsentStageModeEnum,
  DeviceClassesEnum,
  DigitsEnum,
  GeoipBindingEnum,
  NetworkBindingEnum,
  NotConfiguredActionEnum,
  ProviderEnum,
  RedirectStageModeEnum,
  ResidentKeyRequirementEnum,
  StagesApi,
  UserFieldsEnum,
  UserVerificationEnum
} from "./chunk-AVWUV543.js";
import {
  PoliciesApi
} from "./chunk-IUFGI55K.js";
import {
  PropertymappingsApi
} from "./chunk-TM5VGYRQ.js";
import {
  RenderFlowOption
} from "./chunk-INWUBHFN.js";
import {
  AkControlElement
} from "./chunk-SXPKNFZF.js";
import {
  ModelForm
} from "./chunk-3JQ4HF4T.js";
import {
  SourcesApi
} from "./chunk-TBCAGHBB.js";
import {
  FlowsApi,
  FlowsInstancesListDesignationEnum
} from "./chunk-SRK74APZ.js";
import {
  oo
} from "./chunk-UX7TDHO2.js";
import {
  form_default
} from "./chunk-DK5NYREA.js";
import {
  AKElement,
  CoreApi,
  CustomEmitterElement,
  DEFAULT_CONFIG,
  UserTypeEnum,
  button_default,
  e,
  first,
  groupBy,
  n,
  patternfly_base_default,
  r,
  r2,
  t,
  to
} from "./chunk-MKGIUSP2.js";
import {
  D,
  i,
  ke,
  msg,
  str
} from "./chunk-BW7LVHGS.js";
import {
  __commonJS,
  __decorateClass,
  __toESM
} from "./chunk-KZ3QJOBN.js";

// node_modules/@goauthentik/api/dist/models/UserCreationModeEnum.js
var require_UserCreationModeEnum = __commonJS({
  "node_modules/@goauthentik/api/dist/models/UserCreationModeEnum.js"(exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.UserCreationModeEnum = void 0;
    exports.instanceOfUserCreationModeEnum = instanceOfUserCreationModeEnum;
    exports.UserCreationModeEnumFromJSON = UserCreationModeEnumFromJSON;
    exports.UserCreationModeEnumFromJSONTyped = UserCreationModeEnumFromJSONTyped;
    exports.UserCreationModeEnumToJSON = UserCreationModeEnumToJSON;
    exports.UserCreationModeEnumToJSONTyped = UserCreationModeEnumToJSONTyped;
    exports.UserCreationModeEnum = {
      NeverCreate: "never_create",
      CreateWhenRequired: "create_when_required",
      AlwaysCreate: "always_create",
      UnknownDefaultOpenApi: "11184809"
    };
    function instanceOfUserCreationModeEnum(value) {
      for (const key in exports.UserCreationModeEnum) {
        if (Object.prototype.hasOwnProperty.call(exports.UserCreationModeEnum, key)) {
          if (exports.UserCreationModeEnum[key] === value) {
            return true;
          }
        }
      }
      return false;
    }
    function UserCreationModeEnumFromJSON(json) {
      return UserCreationModeEnumFromJSONTyped(json, false);
    }
    function UserCreationModeEnumFromJSONTyped(json, ignoreDiscriminator) {
      return json;
    }
    function UserCreationModeEnumToJSON(value) {
      return value;
    }
    function UserCreationModeEnumToJSONTyped(value, ignoreDiscriminator) {
      return value;
    }
  }
});

// src/admin/stages/BaseStageForm.ts
var BaseStageForm = class extends ModelForm {
  getSuccessMessage() {
    return this.instance ? msg("Successfully updated stage.") : msg("Successfully created stage.");
  }
};

// src/admin/stages/authenticator_duo/AuthenticatorDuoStageForm.ts
var AuthenticatorDuoStageForm = class extends BaseStageForm {
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorDuoRetrieve({
      stageUuid: pk
    });
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorDuoPartialUpdate({
        stageUuid: this.instance.pk || "",
        patchedAuthenticatorDuoStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorDuoCreate({
        authenticatorDuoStageRequest: data
      });
    }
  }
  renderForm() {
    return ke` <span>
                ${msg(
      "Stage used to configure a duo-based authenticator. This stage should be used for configuration flows."
    )}
            </span>
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${first(this.instance?.name, "")}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Authenticator type name")}
                ?required=${false}
                name="friendlyName"
            >
                <input
                    type="text"
                    value="${first(this.instance?.friendlyName, "")}"
                    class="pf-c-form-control"
                />
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Display name of this authenticator, used by users when they enroll an authenticator."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("API Hostname")}
                ?required=${true}
                name="apiHostname"
            >
                <input
                    type="text"
                    value="${first(this.instance?.apiHostname, "")}"
                    class="pf-c-form-control pf-m-monospace"
                    autocomplete="off"
                    spellcheck="false"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("Duo Auth API")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Integration key")}
                        ?required=${true}
                        name="clientId"
                    >
                        <input
                            type="text"
                            value="${first(this.instance?.clientId, "")}"
                            class="pf-c-form-control"
                            required
                        />
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Secret key")}
                        ?required=${true}
                        ?writeOnly=${this.instance !== void 0}
                        name="clientSecret"
                    >
                        <input
                            type="text"
                            value=""
                            class="pf-c-form-control pf-m-monospace"
                            autocomplete="off"
                            spellcheck="false"
                            required
                        />
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>
            <ak-form-group>
                <span slot="header">${msg("Duo Admin API (optional)")}</span>
                <span slot="description">
                    ${msg(
      `When using a Duo MFA, Access or Beyond plan, an Admin API application can be created.
            This will allow authentik to import devices automatically.`
    )}
                </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Integration key")}
                        name="adminIntegrationKey"
                    >
                        <input
                            type="text"
                            value="${first(this.instance?.adminIntegrationKey, "")}"
                            class="pf-c-form-control pf-m-monospace"
                            autocomplete="off"
                            spellcheck="false"
                        />
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Secret key")}
                        ?writeOnly=${this.instance !== void 0}
                        name="adminSecretKey"
                    >
                        <input
                            type="text"
                            value=""
                            class="pf-c-form-control pf-m-monospace"
                            autocomplete="off"
                            spellcheck="false"
                        />
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>
            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("Stage-specific settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Configuration flow")}
                        name="configureFlow"
                    >
                        <ak-search-select
                            .fetchObjects=${async (query) => {
      const args = {
        ordering: "slug",
        designation: FlowsInstancesListDesignationEnum.StageConfiguration
      };
      if (query !== void 0) {
        args.search = query;
      }
      const flows = await new FlowsApi(DEFAULT_CONFIG).flowsInstancesList(
        args
      );
      return flows.results;
    }}
                            .renderElement=${(flow) => {
      return RenderFlowOption(flow);
    }}
                            .renderDescription=${(flow) => {
      return ke`${flow.name}`;
    }}
                            .value=${(flow) => {
      return flow?.pk;
    }}
                            .selected=${(flow) => {
      return this.instance?.configureFlow === flow.pk;
    }}
                            ?blankable=${true}
                        >
                        </ak-search-select>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Flow used by an authenticated user to configure this Stage. If empty, user will not be able to configure this stage."
    )}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>`;
  }
};
AuthenticatorDuoStageForm = __decorateClass([
  t("ak-stage-authenticator-duo-form")
], AuthenticatorDuoStageForm);

// src/admin/stages/authenticator_email/AuthenticatorEmailStageForm.ts
var AuthenticatorEmailStageForm = class extends BaseStageForm {
  constructor() {
    super(...arguments);
    this.showConnectionSettings = false;
  }
  async loadInstance(pk) {
    const stage = await new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorEmailRetrieve({
      stageUuid: pk
    });
    this.showConnectionSettings = !stage.useGlobalSettings;
    return stage;
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorEmailUpdate({
        stageUuid: this.instance.pk || "",
        authenticatorEmailStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorEmailCreate({
        authenticatorEmailStageRequest: data
      });
    }
  }
  renderConnectionSettings() {
    if (!this.showConnectionSettings) {
      return ke``;
    }
    return ke`<ak-form-group .expanded=${true}>
            <span slot="header"> ${msg("Connection settings")} </span>
            <div slot="body" class="pf-c-form">
                <ak-form-element-horizontal label=${msg("SMTP Host")} ?required=${true} name="host">
                    <input
                        type="text"
                        value="${to(this.instance?.host || "")}"
                        class="pf-c-form-control"
                        required
                    />
                </ak-form-element-horizontal>
                <ak-form-element-horizontal label=${msg("SMTP Port")} ?required=${true} name="port">
                    <input
                        type="number"
                        value="${first(this.instance?.port, 25)}"
                        class="pf-c-form-control"
                        required
                    />
                </ak-form-element-horizontal>
                <ak-form-element-horizontal label=${msg("SMTP Username")} name="username">
                    <input
                        type="text"
                        value="${to(this.instance?.username || "")}"
                        class="pf-c-form-control"
                    />
                </ak-form-element-horizontal>
                <ak-form-element-horizontal
                    label=${msg("SMTP Password")}
                    ?writeOnly=${this.instance !== void 0}
                    name="password"
                >
                    <input type="text" value="" class="pf-c-form-control" />
                </ak-form-element-horizontal>
                <ak-form-element-horizontal name="useTls">
                    <label class="pf-c-switch">
                        <input
                            class="pf-c-switch__input"
                            type="checkbox"
                            ?checked=${first(this.instance?.useTls, true)}
                        />
                        <span class="pf-c-switch__toggle">
                            <span class="pf-c-switch__toggle-icon">
                                <i class="fas fa-check" aria-hidden="true"></i>
                            </span>
                        </span>
                        <span class="pf-c-switch__label">${msg("Use TLS")}</span>
                    </label>
                </ak-form-element-horizontal>
                <ak-form-element-horizontal name="useSsl">
                    <label class="pf-c-switch">
                        <input
                            class="pf-c-switch__input"
                            type="checkbox"
                            ?checked=${first(this.instance?.useSsl, false)}
                        />
                        <span class="pf-c-switch__toggle">
                            <span class="pf-c-switch__toggle-icon">
                                <i class="fas fa-check" aria-hidden="true"></i>
                            </span>
                        </span>
                        <span class="pf-c-switch__label">${msg("Use SSL")}</span>
                    </label>
                </ak-form-element-horizontal>
                <ak-form-element-horizontal
                    label=${msg("Timeout")}
                    ?required=${true}
                    name="timeout"
                >
                    <input
                        type="number"
                        value="${first(this.instance?.timeout, 30)}"
                        class="pf-c-form-control"
                        required
                    />
                </ak-form-element-horizontal>
                <ak-form-element-horizontal
                    label=${msg("From address")}
                    ?required=${true}
                    name="fromAddress"
                >
                    <input
                        type="text"
                        value="${to(this.instance?.fromAddress || "system@authentik.local")}"
                        class="pf-c-form-control"
                        required
                    />
                    <p class="pf-c-form__helper-text">
                        ${msg("Email address the verification email will be sent from.")}
                    </p>
                </ak-form-element-horizontal>
            </div>
        </ak-form-group>`;
  }
  renderForm() {
    return ke` <span> ${msg("Stage used to configure an email-based authenticator.")} </span>
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${first(this.instance?.name, "")}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Authenticator type name")}
                ?required=${false}
                name="friendlyName"
            >
                <input
                    type="text"
                    value="${first(this.instance?.friendlyName, "")}"
                    class="pf-c-form-control"
                />
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Display name of this authenticator, used by users when they enroll an authenticator."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal name="useGlobalSettings">
                <label class="pf-c-switch">
                    <input
                        class="pf-c-switch__input"
                        type="checkbox"
                        ?checked=${first(this.instance?.useGlobalSettings, true)}
                        @change=${(ev) => {
      const target = ev.target;
      this.showConnectionSettings = !target.checked;
    }}
                    />
                    <span class="pf-c-switch__toggle">
                        <span class="pf-c-switch__toggle-icon">
                            <i class="fas fa-check" aria-hidden="true"></i>
                        </span>
                    </span>
                    <span class="pf-c-switch__label">${msg("Use global connection settings")}</span>
                </label>
                <p class="pf-c-form__helper-text">
                    ${msg(
      "When enabled, global email connection settings will be used and connection settings below will be ignored."
    )}
                </p>
            </ak-form-element-horizontal>
            ${this.renderConnectionSettings()}
            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("Stage-specific settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Subject")}
                        ?required=${true}
                        name="subject"
                    >
                        <input
                            type="text"
                            value="${first(this.instance?.subject, "authentik Sign-in code")}"
                            class="pf-c-form-control"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg("Subject of the verification email.")}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Token expiration")}
                        ?required=${true}
                        name="tokenExpiry"
                    >
                        <input
                            type="text"
                            value="${first(this.instance?.tokenExpiry, "minutes=15")}"
                            class="pf-c-form-control"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Time the token sent is valid (Format: hours=3,minutes=17,seconds=300)."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Configuration flow")}
                        name="configureFlow"
                    >
                        <ak-search-select
                            .fetchObjects=${async (query) => {
      const args = {
        ordering: "slug",
        designation: FlowsInstancesListDesignationEnum.StageConfiguration
      };
      if (query !== void 0) {
        args.search = query;
      }
      const flows = await new FlowsApi(DEFAULT_CONFIG).flowsInstancesList(
        args
      );
      return flows.results;
    }}
                            .renderElement=${(flow) => {
      return RenderFlowOption(flow);
    }}
                            .renderDescription=${(flow) => {
      return ke`${flow.name}`;
    }}
                            .value=${(flow) => {
      return flow?.pk;
    }}
                            .selected=${(flow) => {
      return this.instance?.configureFlow === flow.pk;
    }}
                            ?blankable=${true}
                        >
                        </ak-search-select>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Flow used by an authenticated user to configure this Stage. If empty, user will not be able to configure this stage."
    )}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>`;
  }
};
__decorateClass([
  n({ type: Boolean })
], AuthenticatorEmailStageForm.prototype, "showConnectionSettings", 2);
AuthenticatorEmailStageForm = __decorateClass([
  t("ak-stage-authenticator-email-form")
], AuthenticatorEmailStageForm);

// src/admin/stages/authenticator_sms/AuthenticatorSMSStageForm.ts
var AuthenticatorSMSStageForm = class extends BaseStageForm {
  constructor() {
    super(...arguments);
    this.provider = ProviderEnum.Twilio;
  }
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorSmsRetrieve({
      stageUuid: pk
    }).then((stage) => {
      this.provider = stage.provider;
      this.authType = stage.authType;
      return stage;
    });
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorSmsUpdate({
        stageUuid: this.instance.pk || "",
        authenticatorSMSStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorSmsCreate({
        authenticatorSMSStageRequest: data
      });
    }
  }
  renderProviderTwillio() {
    return ke` <ak-form-element-horizontal
                label=${msg("Twilio Account SID")}
                ?required=${true}
                name="accountSid"
            >
                <input
                    type="text"
                    value="${first(this.instance?.accountSid, "")}"
                    class="pf-c-form-control pf-m-monospace"
                    autocomplete="off"
                    spellcheck="false"
                    required
                />
                <p class="pf-c-form__helper-text">
                    ${msg("Get this value from https://console.twilio.com")}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Twilio Auth Token")}
                ?required=${true}
                name="auth"
            >
                <input
                    type="text"
                    value="${first(this.instance?.auth, "")}"
                    class="pf-c-form-control pf-m-monospace"
                    autocomplete="off"
                    spellcheck="false"
                    required
                />
                <p class="pf-c-form__helper-text">
                    ${msg("Get this value from https://console.twilio.com")}
                </p>
            </ak-form-element-horizontal>`;
  }
  renderProviderGeneric() {
    return ke`
            <ak-form-element-horizontal
                label=${msg("Authentication Type")}
                @change=${(ev) => {
      const current = ev.target.value;
      this.authType = current;
    }}
                ?required=${true}
                name="authType"
            >
                <ak-radio
                    .options=${[
      {
        label: msg("Basic Auth"),
        value: AuthTypeEnum.Basic,
        default: true
      },
      {
        label: msg("Bearer Token"),
        value: AuthTypeEnum.Bearer
      }
    ]}
                    .value=${this.instance?.authType}
                >
                </ak-radio>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("External API URL")}
                ?required=${true}
                name="accountSid"
            >
                <input
                    type="text"
                    value="${first(this.instance?.accountSid, "")}"
                    class="pf-c-form-control pf-m-monospace"
                    autocomplete="off"
                    spellcheck="false"
                    required
                />
                <p class="pf-c-form__helper-text">
                    ${msg("This is the full endpoint to send POST requests to.")}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("API Auth Username")}
                ?required=${true}
                name="auth"
            >
                <input
                    type="text"
                    value="${first(this.instance?.auth, "")}"
                    class="pf-c-form-control pf-m-monospace"
                    autocomplete="off"
                    spellcheck="false"
                />
                <p class="pf-c-form__helper-text">
                    ${msg(
      "This is the username to be used with basic auth or the token when used with bearer token"
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("API Auth password")}
                ?required=${false}
                name="authPassword"
            >
                <input
                    type="text"
                    value="${first(this.instance?.authPassword, "")}"
                    class="pf-c-form-control pf-m-monospace"
                    autocomplete="off"
                    spellcheck="false"
                />
                <p class="pf-c-form__helper-text">
                    ${msg("This is the password to be used with basic auth")}
                </p>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Mapping")} name="mapping">
                <ak-search-select
                    .fetchObjects=${async (query) => {
      const args = {
        ordering: "saml_name"
      };
      if (query !== void 0) {
        args.search = query;
      }
      const items = await new PropertymappingsApi(
        DEFAULT_CONFIG
      ).propertymappingsNotificationList(args);
      return items.results;
    }}
                    .renderElement=${(item) => {
      return item.name;
    }}
                    .value=${(item) => {
      return item?.pk;
    }}
                    .selected=${(item) => {
      return this.instance?.mapping === item.pk;
    }}
                    ?blankable=${true}
                >
                </ak-search-select>
                <p class="pf-c-form__helper-text">
                    ${msg("Modify the payload sent to the custom provider.")}
                </p>
            </ak-form-element-horizontal>
        `;
  }
  renderForm() {
    return ke` <span>
                ${msg("Stage used to configure an SMS-based TOTP authenticator.")}
            </span>
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${first(this.instance?.name, "")}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Authenticator type name")}
                ?required=${false}
                name="friendlyName"
            >
                <input
                    type="text"
                    value="${first(this.instance?.friendlyName, "")}"
                    class="pf-c-form-control"
                />
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Display name of this authenticator, used by users when they enroll an authenticator."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("Stage-specific settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Provider")}
                        ?required=${true}
                        name="provider"
                    >
                        <select
                            class="pf-c-form-control"
                            @change=${(ev) => {
      const current = ev.target.value;
      this.provider = current;
    }}
                        >
                            <option
                                value="${ProviderEnum.Twilio}"
                                ?selected=${this.instance?.provider === ProviderEnum.Twilio}
                            >
                                ${msg("Twilio")}
                            </option>
                            <option
                                value="${ProviderEnum.Generic}"
                                ?selected=${this.instance?.provider === ProviderEnum.Generic}
                            >
                                ${msg("Generic")}
                            </option>
                        </select>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("From number")}
                        ?required=${true}
                        name="fromNumber"
                    >
                        <input
                            type="text"
                            value="${first(this.instance?.fromNumber, "")}"
                            class="pf-c-form-control pf-m-monospace"
                            autocomplete="off"
                            spellcheck="false"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg("Number the SMS will be sent from.")}
                        </p>
                    </ak-form-element-horizontal>
                    ${this.provider === ProviderEnum.Generic ? this.renderProviderGeneric() : this.renderProviderTwillio()}
                    <ak-form-element-horizontal name="verifyOnly">
                        <label class="pf-c-switch">
                            <input
                                class="pf-c-switch__input"
                                type="checkbox"
                                ?checked=${first(this.instance?.verifyOnly, false)}
                            />
                            <span class="pf-c-switch__toggle">
                                <span class="pf-c-switch__toggle-icon">
                                    <i class="fas fa-check" aria-hidden="true"></i>
                                </span>
                            </span>
                            <span class="pf-c-switch__label">${msg("Hash phone number")}</span>
                        </label>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "If enabled, only a hash of the phone number will be saved. This can be done for data-protection reasons. Devices created from a stage with this enabled cannot be used with the authenticator validation stage."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Configuration flow")}
                        name="configureFlow"
                    >
                        <ak-search-select
                            .fetchObjects=${async (query) => {
      const args = {
        ordering: "slug",
        designation: FlowsInstancesListDesignationEnum.StageConfiguration
      };
      if (query !== void 0) {
        args.search = query;
      }
      const flows = await new FlowsApi(DEFAULT_CONFIG).flowsInstancesList(
        args
      );
      return flows.results;
    }}
                            .renderElement=${(flow) => {
      return RenderFlowOption(flow);
    }}
                            .renderDescription=${(flow) => {
      return ke`${flow.name}`;
    }}
                            .value=${(flow) => {
      return flow?.pk;
    }}
                            .selected=${(flow) => {
      return this.instance?.configureFlow === flow.pk;
    }}
                            ?blankable=${true}
                        >
                        </ak-search-select>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Flow used by an authenticated user to configure this Stage. If empty, user will not be able to configure this stage."
    )}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>`;
  }
};
__decorateClass([
  n({ attribute: false })
], AuthenticatorSMSStageForm.prototype, "provider", 2);
__decorateClass([
  n({ attribute: false })
], AuthenticatorSMSStageForm.prototype, "authType", 2);
AuthenticatorSMSStageForm = __decorateClass([
  t("ak-stage-authenticator-sms-form")
], AuthenticatorSMSStageForm);

// src/admin/stages/authenticator_static/AuthenticatorStaticStageForm.ts
var AuthenticatorStaticStageForm = class extends BaseStageForm {
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorStaticRetrieve({
      stageUuid: pk
    });
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorStaticUpdate({
        stageUuid: this.instance.pk || "",
        authenticatorStaticStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorStaticCreate({
        authenticatorStaticStageRequest: data
      });
    }
  }
  renderForm() {
    return ke` <span>
                ${msg(
      "Stage used to configure a static authenticator (i.e. static tokens). This stage should be used for configuration flows."
    )}
            </span>
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${first(this.instance?.name, "")}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Authenticator type name")}
                ?required=${false}
                name="friendlyName"
            >
                <input
                    type="text"
                    value="${first(this.instance?.friendlyName, "")}"
                    class="pf-c-form-control"
                />
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Display name of this authenticator, used by users when they enroll an authenticator."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("Stage-specific settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Token count")}
                        ?required=${true}
                        name="tokenCount"
                    >
                        <input
                            type="text"
                            value="${first(this.instance?.tokenCount, 6)}"
                            class="pf-c-form-control"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "The number of tokens generated whenever this stage is used. Every token generated per stage execution will be attached to a single static device."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Token length")}
                        ?required=${true}
                        name="tokenLength"
                    >
                        <input
                            type="text"
                            value="${first(this.instance?.tokenLength, 12)}"
                            class="pf-c-form-control"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "The length of the individual generated tokens. Can be increased to improve security."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Configuration flow")}
                        name="configureFlow"
                    >
                        <ak-search-select
                            .fetchObjects=${async (query) => {
      const args = {
        ordering: "slug",
        designation: FlowsInstancesListDesignationEnum.StageConfiguration
      };
      if (query !== void 0) {
        args.search = query;
      }
      const flows = await new FlowsApi(DEFAULT_CONFIG).flowsInstancesList(
        args
      );
      return flows.results;
    }}
                            .renderElement=${(flow) => {
      return RenderFlowOption(flow);
    }}
                            .renderDescription=${(flow) => {
      return ke`${flow.name}`;
    }}
                            .value=${(flow) => {
      return flow?.pk;
    }}
                            .selected=${(flow) => {
      return this.instance?.configureFlow === flow.pk;
    }}
                            ?blankable=${true}
                        >
                        </ak-search-select>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Flow used by an authenticated user to configure this Stage. If empty, user will not be able to configure this stage."
    )}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>`;
  }
};
AuthenticatorStaticStageForm = __decorateClass([
  t("ak-stage-authenticator-static-form")
], AuthenticatorStaticStageForm);

// src/admin/stages/authenticator_totp/AuthenticatorTOTPStageForm.ts
var AuthenticatorTOTPStageForm = class extends BaseStageForm {
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorTotpRetrieve({
      stageUuid: pk
    });
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorTotpUpdate({
        stageUuid: this.instance.pk || "",
        authenticatorTOTPStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorTotpCreate({
        authenticatorTOTPStageRequest: data
      });
    }
  }
  renderForm() {
    return ke` <span>
                ${msg(
      "Stage used to configure a TOTP authenticator (i.e. Authy/Google Authenticator)."
    )}
            </span>
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${first(this.instance?.name, "")}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Authenticator type name")}
                ?required=${false}
                name="friendlyName"
            >
                <input
                    type="text"
                    value="${first(this.instance?.friendlyName, "")}"
                    class="pf-c-form-control"
                />
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Display name of this authenticator, used by users when they enroll an authenticator."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("Stage-specific settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Digits")}
                        ?required=${true}
                        name="digits"
                    >
                        <select name="users" class="pf-c-form-control">
                            <option
                                value="${DigitsEnum._6}"
                                ?selected=${this.instance?.digits === DigitsEnum._6}
                            >
                                ${msg("6 digits, widely compatible")}
                            </option>
                            <option
                                value="${DigitsEnum._8}"
                                ?selected=${this.instance?.digits === DigitsEnum._8}
                            >
                                ${msg(
      "8 digits, not compatible with apps like Google Authenticator"
    )}
                            </option>
                        </select>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Configuration flow")}
                        name="configureFlow"
                    >
                        <ak-search-select
                            .fetchObjects=${async (query) => {
      const args = {
        ordering: "slug",
        designation: FlowsInstancesListDesignationEnum.StageConfiguration
      };
      if (query !== void 0) {
        args.search = query;
      }
      const flows = await new FlowsApi(DEFAULT_CONFIG).flowsInstancesList(
        args
      );
      return flows.results;
    }}
                            .renderElement=${(flow) => {
      return RenderFlowOption(flow);
    }}
                            .renderDescription=${(flow) => {
      return ke`${flow.name}`;
    }}
                            .value=${(flow) => {
      return flow?.pk;
    }}
                            .selected=${(flow) => {
      return this.instance?.configureFlow === flow.pk;
    }}
                            ?blankable=${true}
                        >
                        </ak-search-select>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Flow used by an authenticated user to configure this Stage. If empty, user will not be able to configure this stage."
    )}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>`;
  }
};
AuthenticatorTOTPStageForm = __decorateClass([
  t("ak-stage-authenticator-totp-form")
], AuthenticatorTOTPStageForm);

// src/admin/stages/authenticator_webauthn/utils.ts
function deviceTypeRestrictionPair(item) {
  const label = item.description ? item.description : item.aaguid;
  return [
    item.aaguid,
    ke`<div class="selection-main">${label}</div>
            <div class="selection-desc">${item.aaguid}</div>`,
    label
  ];
}

// src/admin/stages/authenticator_validate/AuthenticatorValidateStageFormHelpers.ts
var stageToSelect = (stage) => [stage.pk, `${stage.name} (${stage.verboseName})`];
async function stagesProvider(page = 1, search = "") {
  const stages = await new StagesApi(DEFAULT_CONFIG).stagesAllList({
    ordering: "name",
    pageSize: 20,
    search: search.trim(),
    page
  });
  return {
    pagination: stages.pagination,
    options: stages.results.map(stageToSelect)
  };
}
function stagesSelector(instanceStages) {
  if (!instanceStages) {
    return async (stages) => stages.filter(([_0, _1, _2, stage]) => stage !== void 0);
  }
  return async () => {
    const stagesApi = new StagesApi(DEFAULT_CONFIG);
    const stages = await Promise.allSettled(
      instanceStages.map(
        (instanceId) => stagesApi.stagesAllRetrieve({ stageUuid: instanceId })
      )
    );
    return stages.filter((s) => s.status === "fulfilled").map((s) => s.value).map(stageToSelect);
  };
}
async function authenticatorWebauthnDeviceTypesListProvider(page = 1, search = "") {
  const devicetypes = await new StagesApi(
    DEFAULT_CONFIG
  ).stagesAuthenticatorWebauthnDeviceTypesList({
    pageSize: 20,
    search: search.trim(),
    page
  });
  return {
    pagination: devicetypes.pagination,
    options: devicetypes.results.map(deviceTypeRestrictionPair)
  };
}

// src/admin/stages/authenticator_validate/AuthenticatorValidateStageForm.ts
var AuthenticatorValidateStageForm = class extends BaseStageForm {
  constructor() {
    super(...arguments);
    this.showConfigurationStages = true;
  }
  async loadInstance(pk) {
    const stage = await new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorValidateRetrieve({
      stageUuid: pk
    });
    this.showConfigurationStages = stage.notConfiguredAction === NotConfiguredActionEnum.Configure;
    return stage;
  }
  async load() {
    this.stages = await new StagesApi(DEFAULT_CONFIG).stagesAllList({
      ordering: "name"
    });
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorValidateUpdate({
        stageUuid: this.instance.pk || "",
        authenticatorValidateStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorValidateCreate({
        authenticatorValidateStageRequest: data
      });
    }
  }
  isDeviceClassSelected(field) {
    return (this.instance?.deviceClasses || []).filter((isField) => {
      return field === isField;
    }).length > 0;
  }
  renderForm() {
    const authenticators = [
      [DeviceClassesEnum.Static, msg("Static Tokens")],
      [DeviceClassesEnum.Totp, msg("TOTP Authenticators")],
      [DeviceClassesEnum.Webauthn, msg("WebAuthn Authenticators")],
      [DeviceClassesEnum.Duo, msg("Duo Authenticators")],
      [DeviceClassesEnum.Sms, msg("SMS-based Authenticators")],
      [DeviceClassesEnum.Email, msg("Email-based Authenticators")]
    ];
    return ke`
            <span>
                ${msg(
      "Stage used to validate any authenticator. This stage should be used during authentication or authorization flows."
    )}
            </span>
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${to(this.instance?.name || "")}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("Stage-specific settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Device classes")}
                        ?required=${true}
                        name="deviceClasses"
                    >
                        <ak-checkbox-group
                            name="users"
                            class="user-field-select"
                            .options=${authenticators}
                            .value=${authenticators.map((authenticator) => authenticator[0]).filter(
      (name) => this.isDeviceClassSelected(name)
    )}
                        ></ak-checkbox-group>
                        <p class="pf-c-form__helper-text">
                            ${msg("Device classes which can be used to authenticate.")}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Last validation threshold")}
                        ?required=${true}
                        name="lastAuthThreshold"
                    >
                        <input
                            type="text"
                            value="${this.instance?.lastAuthThreshold || "seconds=0"}"
                            class="pf-c-form-control pf-m-monospace"
                            autocomplete="off"
                            spellcheck="false"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "If the user has successfully authenticated with a device in the classes listed above within this configured duration, this stage will be skipped."
    )}
                        </p>
                        <ak-utils-time-delta-help></ak-utils-time-delta-help>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Not configured action")}
                        ?required=${true}
                        name="notConfiguredAction"
                    >
                        <select
                            class="pf-c-form-control"
                            @change=${(ev) => {
      const target = ev.target;
      if (target.selectedOptions[0].value === NotConfiguredActionEnum.Configure) {
        this.showConfigurationStages = true;
      } else {
        this.showConfigurationStages = false;
      }
    }}
                        >
                            <option
                                value=${NotConfiguredActionEnum.Configure}
                                ?selected=${this.instance?.notConfiguredAction === NotConfiguredActionEnum.Configure}
                            >
                                ${msg("Force the user to configure an authenticator")}
                            </option>
                            <option
                                value=${NotConfiguredActionEnum.Deny}
                                ?selected=${this.instance?.notConfiguredAction === NotConfiguredActionEnum.Deny}
                            >
                                ${msg("Deny the user access")}
                            </option>
                            <option
                                value=${NotConfiguredActionEnum.Skip}
                                ?selected=${this.instance?.notConfiguredAction === NotConfiguredActionEnum.Skip}
                            >
                                ${msg("Continue")}
                            </option>
                        </select>
                    </ak-form-element-horizontal>
                    ${this.showConfigurationStages ? ke`
                              <ak-form-element-horizontal
                                  label=${msg("Configuration stages")}
                                  name="configurationStages"
                              >
                                  <ak-dual-select-dynamic-selected
                                      .provider=${stagesProvider}
                                      .selector=${stagesSelector(
      this.instance?.configurationStages
    )}
                                      available-label="${msg("Available Stages")}"
                                      selected-label="${msg("Selected Stages")}"
                                  ></ak-dual-select-dynamic-selected>
                                  <p class="pf-c-form__helper-text">
                                      ${msg(
      "Stages used to configure Authenticator when user doesn't have any compatible devices. After this configuration Stage passes, the user is not prompted again."
    )}
                                  </p>
                                  <p class="pf-c-form__helper-text">
                                      ${msg(
      "When multiple stages are selected, the user can choose which one they want to enroll."
    )}
                                  </p>
                              </ak-form-element-horizontal>
                          ` : ke``}
                </div>
            </ak-form-group>
            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("WebAuthn-specific settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("WebAuthn User verification")}
                        ?required=${true}
                        name="webauthnUserVerification"
                    >
                        <ak-radio
                            .options=${[
      {
        label: msg("User verification must occur."),
        value: UserVerificationEnum.Required,
        default: true
      },
      {
        label: msg(
          "User verification is preferred if available, but not required."
        ),
        value: UserVerificationEnum.Preferred
      },
      {
        label: msg("User verification should not occur."),
        value: UserVerificationEnum.Discouraged
      }
    ]}
                            .value=${this.instance?.webauthnUserVerification}
                        >
                        </ak-radio>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("WebAuthn Device type restrictions")}
                        name="webauthnAllowedDeviceTypes"
                    >
                        <ak-dual-select-provider
                            .provider=${authenticatorWebauthnDeviceTypesListProvider}
                            .selected=${(this.instance?.webauthnAllowedDeviceTypesObj ?? []).map(
      deviceTypeRestrictionPair
    )}
                            available-label="${msg("Available Device types")}"
                            selected-label="${msg("Selected Device types")}"
                        ></ak-dual-select-provider>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Optionally restrict which WebAuthn device types may be used. When no device types are selected, all devices are allowed."
    )}
                        </p>
                        <ak-alert ?inline=${true}>
                            ${/* TODO: Remove this after 2024.6..or maybe later? */
    msg(
      "This restriction only applies to devices created in authentik 2024.4 or later."
    )}
                        </ak-alert>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>
        `;
  }
};
__decorateClass([
  n({ type: Boolean })
], AuthenticatorValidateStageForm.prototype, "showConfigurationStages", 2);
AuthenticatorValidateStageForm = __decorateClass([
  t("ak-stage-authenticator-validate-form")
], AuthenticatorValidateStageForm);

// src/admin/stages/authenticator_webauthn/AuthenticatorWebAuthnStageForm.ts
var AuthenticatorWebAuthnStageForm = class extends BaseStageForm {
  async loadInstance(pk) {
    return await new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorWebauthnRetrieve({
      stageUuid: pk
    });
  }
  async send(data) {
    if (data.authenticatorAttachment?.toString() === "") {
      data.authenticatorAttachment = null;
    }
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorWebauthnUpdate({
        stageUuid: this.instance.pk || "",
        authenticatorWebAuthnStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorWebauthnCreate({
        authenticatorWebAuthnStageRequest: data
      });
    }
  }
  renderForm() {
    return ke` <span>
                ${msg(
      "Stage used to configure a WebAuthn authenticator (i.e. Yubikey, FaceID/Windows Hello)."
    )}
            </span>
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${first(this.instance?.name, "")}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Authenticator type name")}
                ?required=${false}
                name="friendlyName"
            >
                <input
                    type="text"
                    value="${first(this.instance?.friendlyName, "")}"
                    class="pf-c-form-control"
                />
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Display name of this authenticator, used by users when they enroll an authenticator."
    )}
                </p>
            </ak-form-element-horizontal>
            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("Stage-specific settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("User verification")}
                        ?required=${true}
                        name="userVerification"
                    >
                        <ak-radio
                            .options=${[
      {
        label: msg("Required: User verification must occur."),
        value: UserVerificationEnum.Required,
        default: true
      },
      {
        label: msg(
          "Preferred: User verification is preferred if available, but not required."
        ),
        value: UserVerificationEnum.Preferred
      },
      {
        label: msg("Discouraged: User verification should not occur."),
        value: UserVerificationEnum.Discouraged
      }
    ]}
                            .value=${this.instance?.userVerification}
                        >
                        </ak-radio>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Resident key requirement")}
                        ?required=${true}
                        name="residentKeyRequirement"
                    >
                        <ak-radio
                            .options=${[
      {
        label: msg(
          "Required: The authenticator MUST create a dedicated credential. If it cannot, the RP is prepared for an error to occur"
        ),
        value: ResidentKeyRequirementEnum.Required,
        default: true
      },
      {
        label: msg(
          "Preferred: The authenticator can create and store a dedicated credential, but if it doesn't that's alright too"
        ),
        value: ResidentKeyRequirementEnum.Preferred
      },
      {
        label: msg(
          "Discouraged: The authenticator should not create a dedicated credential"
        ),
        value: ResidentKeyRequirementEnum.Discouraged
      }
    ]}
                            .value=${this.instance?.residentKeyRequirement}
                        >
                        </ak-radio>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Authenticator Attachment")}
                        ?required=${true}
                        name="authenticatorAttachment"
                    >
                        <ak-radio
                            .options=${[
      {
        label: msg("No preference is sent"),
        value: null,
        default: true
      },
      {
        label: msg(
          "A non-removable authenticator, like TouchID or Windows Hello"
        ),
        value: AuthenticatorAttachmentEnum.Platform
      },
      {
        label: msg('A "roaming" authenticator, like a YubiKey'),
        value: AuthenticatorAttachmentEnum.CrossPlatform
      }
    ]}
                            .value=${this.instance?.authenticatorAttachment}
                        >
                        </ak-radio>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Device type restrictions")}
                        name="deviceTypeRestrictions"
                    >
                        <ak-dual-select-provider
                            .provider=${(page, search) => {
      return new StagesApi(DEFAULT_CONFIG).stagesAuthenticatorWebauthnDeviceTypesList({
        page,
        search
      }).then((results) => {
        return {
          pagination: results.pagination,
          options: results.results.map(deviceTypeRestrictionPair)
        };
      });
    }}
                            .selected=${(this.instance?.deviceTypeRestrictionsObj ?? []).map(
      deviceTypeRestrictionPair
    )}
                            available-label="${msg("Available Device types")}"
                            selected-label="${msg("Selected Device types")}"
                        ></ak-dual-select-provider>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Optionally restrict which WebAuthn device types may be used. When no device types are selected, all devices are allowed."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Configuration flow")}
                        name="configureFlow"
                    >
                        <ak-search-select
                            .fetchObjects=${async (query) => {
      const args = {
        ordering: "slug",
        designation: FlowsInstancesListDesignationEnum.StageConfiguration
      };
      if (query !== void 0) {
        args.search = query;
      }
      const flows = await new FlowsApi(DEFAULT_CONFIG).flowsInstancesList(
        args
      );
      return flows.results;
    }}
                            .renderElement=${(flow) => {
      return RenderFlowOption(flow);
    }}
                            .renderDescription=${(flow) => {
      return ke`${flow.name}`;
    }}
                            .value=${(flow) => {
      return flow?.pk;
    }}
                            .selected=${(flow) => {
      return this.instance?.configureFlow === flow.pk;
    }}
                            ?blankable=${true}
                        >
                        </ak-search-select>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Flow used by an authenticated user to configure this Stage. If empty, user will not be able to configure this stage."
    )}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>`;
  }
};
AuthenticatorWebAuthnStageForm = __decorateClass([
  t("ak-stage-authenticator-webauthn-form")
], AuthenticatorWebAuthnStageForm);

// src/admin/stages/captcha/CaptchaStageForm.ts
var CaptchaStageForm = class extends BaseStageForm {
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesCaptchaRetrieve({
      stageUuid: pk
    });
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesCaptchaPartialUpdate({
        stageUuid: this.instance.pk || "",
        patchedCaptchaStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesCaptchaCreate({
        captchaStageRequest: data
      });
    }
  }
  renderForm() {
    return ke` <span>
                ${msg(
      "This stage checks the user's current session against the Google reCaptcha (or compatible) service."
    )}
            </span>
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${to(this.instance?.name || "")}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("Stage-specific settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Public Key")}
                        ?required=${true}
                        name="publicKey"
                    >
                        <input
                            type="text"
                            value="${to(this.instance?.publicKey || "")}"
                            class="pf-c-form-control pf-m-monospace"
                            autocomplete="off"
                            spellcheck="false"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Public key, acquired from https://www.google.com/recaptcha/intro/v3.html."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Private Key")}
                        ?required=${true}
                        ?writeOnly=${this.instance !== void 0}
                        name="privateKey"
                    >
                        <input
                            type="text"
                            value=""
                            class="pf-c-form-control pf-m-monospace"
                            autocomplete="off"
                            spellcheck="false"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Private key, acquired from https://www.google.com/recaptcha/intro/v3.html."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-switch-input
                        name="interactive"
                        label=${msg("Interactive")}
                        ?checked="${this.instance?.interactive}"
                        help=${msg(
      "Enable this flag if the configured captcha requires User-interaction. Required for reCAPTCHA v2, hCaptcha and Cloudflare Turnstile."
    )}
                    >
                    </ak-switch-input>
                    <ak-number-input
                        label=${msg("Score minimum threshold")}
                        required
                        name="scoreMinThreshold"
                        value="${to(this.instance?.scoreMinThreshold || 0.5)}"
                        help=${msg("Minimum required score to allow continuing")}
                    ></ak-number-input>
                    <ak-number-input
                        label=${msg("Score maximum threshold")}
                        required
                        name="scoreMaxThreshold"
                        value="${to(this.instance?.scoreMaxThreshold || -1)}"
                        help=${msg("Maximum allowed score to allow continuing")}
                    ></ak-number-input>
                    <ak-form-element-horizontal name="errorOnInvalidScore">
                        <label class="pf-c-switch">
                            <input
                                class="pf-c-switch__input"
                                type="checkbox"
                                ?checked=${first(this.instance?.errorOnInvalidScore, true)}
                            />
                            <span class="pf-c-switch__toggle">
                                <span class="pf-c-switch__toggle-icon">
                                    <i class="fas fa-check" aria-hidden="true"></i>
                                </span>
                            </span>
                            <span class="pf-c-switch__label">${msg("Error on invalid score")}</span>
                        </label>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "When enabled and the resultant score is outside the threshold, the user will not be able to continue. When disabled, the user will be able to continue and the score can be used in policies to customize further stages."
    )}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>
            <ak-form-group>
                <span slot="header"> ${msg("Advanced settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("JS URL")}
                        ?required=${true}
                        name="jsUrl"
                    >
                        <input
                            type="url"
                            value="${to(
      this.instance?.jsUrl || "https://www.recaptcha.net/recaptcha/api.js"
    )}"
                            class="pf-c-form-control pf-m-monospace"
                            autocomplete="off"
                            spellcheck="false"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "URL to fetch JavaScript from, defaults to recaptcha. Can be replaced with any compatible alternative."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("API URL")}
                        ?required=${true}
                        name="apiUrl"
                    >
                        <input
                            type="url"
                            value="${to(
      this.instance?.apiUrl || "https://www.recaptcha.net/recaptcha/api/siteverify"
    )}"
                            class="pf-c-form-control pf-m-monospace"
                            autocomplete="off"
                            spellcheck="false"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "URL used to validate captcha response, defaults to recaptcha. Can be replaced with any compatible alternative."
    )}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>`;
  }
};
CaptchaStageForm = __decorateClass([
  t("ak-stage-captcha-form")
], CaptchaStageForm);

// src/admin/stages/consent/ConsentStageForm.ts
var ConsentStageForm = class extends BaseStageForm {
  constructor() {
    super(...arguments);
    this.showExpiresIn = false;
  }
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesConsentRetrieve({
      stageUuid: pk
    }).then((stage) => {
      this.showExpiresIn = stage.mode === ConsentStageModeEnum.Expiring;
      return stage;
    });
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesConsentUpdate({
        stageUuid: this.instance.pk || "",
        consentStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesConsentCreate({
        consentStageRequest: data
      });
    }
  }
  renderForm() {
    return ke` <span>
                ${msg(
      "Prompt for the user's consent. The consent can either be permanent or expire in a defined amount of time."
    )}
            </span>
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${to(this.instance?.name || "")}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("Stage-specific settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal label=${msg("Mode")} ?required=${true} name="mode">
                        <select
                            class="pf-c-form-control"
                            @change=${(ev) => {
      const target = ev.target;
      if (target.selectedOptions[0].value === ConsentStageModeEnum.Expiring) {
        this.showExpiresIn = true;
      } else {
        this.showExpiresIn = false;
      }
    }}
                        >
                            <option
                                value=${ConsentStageModeEnum.AlwaysRequire}
                                ?selected=${this.instance?.mode === ConsentStageModeEnum.AlwaysRequire}
                            >
                                ${msg("Always require consent")}
                            </option>
                            <option
                                value=${ConsentStageModeEnum.Permanent}
                                ?selected=${this.instance?.mode === ConsentStageModeEnum.Permanent}
                            >
                                ${msg("Consent given lasts indefinitely")}
                            </option>
                            <option
                                value=${ConsentStageModeEnum.Expiring}
                                ?selected=${this.instance?.mode === ConsentStageModeEnum.Expiring}
                            >
                                ${msg("Consent expires")}
                            </option>
                        </select>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        ?hidden=${!this.showExpiresIn}
                        label=${msg("Consent expires in")}
                        ?required=${true}
                        name="consentExpireIn"
                    >
                        <input
                            type="text"
                            value="${to(this.instance?.consentExpireIn || "weeks=4")}"
                            class="pf-c-form-control"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg("Offset after which consent expires.")}
                        </p>
                        <ak-utils-time-delta-help></ak-utils-time-delta-help>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>`;
  }
};
__decorateClass([
  n({ type: Boolean })
], ConsentStageForm.prototype, "showExpiresIn", 2);
ConsentStageForm = __decorateClass([
  t("ak-stage-consent-form")
], ConsentStageForm);

// src/admin/stages/deny/DenyStageForm.ts
var DenyStageForm = class extends BaseStageForm {
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesDenyRetrieve({
      stageUuid: pk
    });
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesDenyUpdate({
        stageUuid: this.instance.pk || "",
        denyStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesDenyCreate({
        denyStageRequest: data
      });
    }
  }
  renderForm() {
    return ke`
            <span>
                ${msg(
      "Statically deny the flow. To use this stage effectively, disable *Evaluate when flow is planned* on the respective binding."
    )}
            </span>
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${to(this.instance?.name || "")}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("Stage-specific settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal label=${msg("Deny message")} name="denyMessage">
                        <input
                            type="text"
                            value="${to(this.instance?.denyMessage || "")}"
                            class="pf-c-form-control"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg("Message shown when this stage is run.")}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>
        `;
  }
};
DenyStageForm = __decorateClass([
  t("ak-stage-deny-form")
], DenyStageForm);

// src/admin/stages/dummy/DummyStageForm.ts
var DummyStageForm = class extends BaseStageForm {
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesDummyRetrieve({
      stageUuid: pk
    });
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesDummyUpdate({
        stageUuid: this.instance.pk || "",
        dummyStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesDummyCreate({
        dummyStageRequest: data
      });
    }
  }
  renderForm() {
    return ke` <span>
                ${msg(
      "Dummy stage used for testing. Shows a simple continue button and always passes."
    )}
            </span>
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${to(this.instance?.name || "")}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal name="throwError">
                <label class="pf-c-switch">
                    <input
                        class="pf-c-switch__input"
                        type="checkbox"
                        ?checked=${first(this.instance?.throwError, false)}
                    />
                    <span class="pf-c-switch__toggle">
                        <span class="pf-c-switch__toggle-icon">
                            <i class="fas fa-check" aria-hidden="true"></i>
                        </span>
                    </span>
                    <span class="pf-c-switch__label">${msg("Throw error?")}</span>
                </label>
            </ak-form-element-horizontal>`;
  }
};
DummyStageForm = __decorateClass([
  t("ak-stage-dummy-form")
], DummyStageForm);

// src/admin/stages/email/EmailStageForm.ts
var EmailStageForm = class extends BaseStageForm {
  constructor() {
    super(...arguments);
    this.showConnectionSettings = false;
  }
  async loadInstance(pk) {
    const stage = await new StagesApi(DEFAULT_CONFIG).stagesEmailRetrieve({
      stageUuid: pk
    });
    this.showConnectionSettings = !stage.useGlobalSettings;
    return stage;
  }
  async load() {
    this.templates = await new StagesApi(DEFAULT_CONFIG).stagesEmailTemplatesList();
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesEmailPartialUpdate({
        stageUuid: this.instance.pk || "",
        patchedEmailStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesEmailCreate({
        emailStageRequest: data
      });
    }
  }
  renderConnectionSettings() {
    if (!this.showConnectionSettings) {
      return ke``;
    }
    return ke`<ak-form-group>
            <span slot="header"> ${msg("Connection settings")} </span>
            <div slot="body" class="pf-c-form">
                <ak-form-element-horizontal label=${msg("SMTP Host")} ?required=${true} name="host">
                    <input
                        type="text"
                        value="${to(this.instance?.host || "")}"
                        class="pf-c-form-control"
                        required
                    />
                </ak-form-element-horizontal>
                <ak-form-element-horizontal label=${msg("SMTP Port")} ?required=${true} name="port">
                    <input
                        type="number"
                        value="${first(this.instance?.port, 25)}"
                        class="pf-c-form-control"
                        required
                    />
                </ak-form-element-horizontal>
                <ak-form-element-horizontal label=${msg("SMTP Username")} name="username">
                    <input
                        type="text"
                        value="${to(this.instance?.username || "")}"
                        class="pf-c-form-control"
                    />
                </ak-form-element-horizontal>
                <ak-form-element-horizontal
                    label=${msg("SMTP Password")}
                    ?writeOnly=${this.instance !== void 0}
                    name="password"
                >
                    <input type="text" value="" class="pf-c-form-control" />
                </ak-form-element-horizontal>
                <ak-form-element-horizontal name="useTls">
                    <label class="pf-c-switch">
                        <input
                            class="pf-c-switch__input"
                            type="checkbox"
                            ?checked=${first(this.instance?.useTls, true)}
                        />
                        <span class="pf-c-switch__toggle">
                            <span class="pf-c-switch__toggle-icon">
                                <i class="fas fa-check" aria-hidden="true"></i>
                            </span>
                        </span>
                        <span class="pf-c-switch__label">${msg("Use TLS")}</span>
                    </label>
                </ak-form-element-horizontal>
                <ak-form-element-horizontal name="useSsl">
                    <label class="pf-c-switch">
                        <input
                            class="pf-c-switch__input"
                            type="checkbox"
                            ?checked=${first(this.instance?.useSsl, false)}
                        />
                        <span class="pf-c-switch__toggle">
                            <span class="pf-c-switch__toggle-icon">
                                <i class="fas fa-check" aria-hidden="true"></i>
                            </span>
                        </span>
                        <span class="pf-c-switch__label">${msg("Use SSL")}</span>
                    </label>
                </ak-form-element-horizontal>
                <ak-form-element-horizontal
                    label=${msg("Timeout")}
                    ?required=${true}
                    name="timeout"
                >
                    <input
                        type="number"
                        value="${first(this.instance?.timeout, 30)}"
                        class="pf-c-form-control"
                        required
                    />
                </ak-form-element-horizontal>
                <ak-form-element-horizontal
                    label=${msg("From address")}
                    ?required=${true}
                    name="fromAddress"
                >
                    <input
                        type="text"
                        value="${to(this.instance?.fromAddress || "system@authentik.local")}"
                        class="pf-c-form-control"
                        required
                    />
                </ak-form-element-horizontal>
            </div>
        </ak-form-group>`;
  }
  renderForm() {
    return ke` <span>
                ${msg(
      "Verify the user's email address by sending them a one-time-link. Can also be used for recovery to verify the user's authenticity."
    )}
            </span>
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${to(this.instance?.name || "")}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("Stage-specific settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal name="activateUserOnSuccess">
                        <label class="pf-c-switch">
                            <input
                                class="pf-c-switch__input"
                                type="checkbox"
                                ?checked=${first(this.instance?.activateUserOnSuccess, true)}
                            />
                            <span class="pf-c-switch__toggle">
                                <span class="pf-c-switch__toggle-icon">
                                    <i class="fas fa-check" aria-hidden="true"></i>
                                </span>
                            </span>
                            <span class="pf-c-switch__label"
                                >${msg("Activate pending user on success")}</span
                            >
                        </label>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "When a user returns from the email successfully, their account will be activated."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal name="useGlobalSettings">
                        <label class="pf-c-switch">
                            <input
                                class="pf-c-switch__input"
                                type="checkbox"
                                ?checked=${first(this.instance?.useGlobalSettings, true)}
                                @change=${(ev) => {
      const target = ev.target;
      this.showConnectionSettings = !target.checked;
    }}
                            />
                            <span class="pf-c-switch__toggle">
                                <span class="pf-c-switch__toggle-icon">
                                    <i class="fas fa-check" aria-hidden="true"></i>
                                </span>
                            </span>
                            <span class="pf-c-switch__label">${msg("Use global settings")}</span>
                        </label>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "When enabled, global Email connection settings will be used and connection settings below will be ignored."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Token expiry")}
                        ?required=${true}
                        name="tokenExpiry"
                    >
                        <input
                            type="number"
                            value="${first(this.instance?.tokenExpiry, 30)}"
                            class="pf-c-form-control"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg("Time in minutes the token sent is valid.")}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Subject")}
                        ?required=${true}
                        name="subject"
                    >
                        <input
                            type="text"
                            value="${first(this.instance?.subject, "authentik")}"
                            class="pf-c-form-control"
                            required
                        />
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Template")}
                        ?required=${true}
                        name="template"
                    >
                        <select name="users" class="pf-c-form-control">
                            ${this.templates?.map((template) => {
      const selected = this.instance?.template === template.name;
      return ke`<option
                                    value=${to(template.name)}
                                    ?selected=${selected}
                                >
                                    ${template.description}
                                </option>`;
    })}
                        </select>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>
            ${this.renderConnectionSettings()}`;
  }
};
__decorateClass([
  n({ type: Boolean })
], EmailStageForm.prototype, "showConnectionSettings", 2);
EmailStageForm = __decorateClass([
  t("ak-stage-email-form")
], EmailStageForm);

// src/elements/ak-checkbox-group/ak-checkbox-group.ts
var isCheckboxPr = (t2) => Array.isArray(t2);
function* kvToPairs(items) {
  for (const item of items) {
    yield isCheckboxPr(item) ? item : [item.name, item.label];
  }
}
var AkElementWithCustomEvents = CustomEmitterElement(AkControlElement);
var CheckboxGroup = class extends AkElementWithCustomEvents {
  constructor() {
    super();
    this.options = [];
    this.value = [];
    this.required = false;
    this.values = [];
    this.doneFirstUpdate = false;
    this.onClick = this.onClick.bind(this);
  }
  static get styles() {
    return [
      patternfly_base_default,
      form_default,
      check_default,
      i`
                .pf-c-form__group-control {
                    padding-top: calc(
                        var(--pf-c-form--m-horizontal__group-label--md--PaddingTop) * 1.3
                    );
                }
            `
    ];
  }
  static get formAssociated() {
    return true;
  }
  json() {
    return this.values;
  }
  get formValue() {
    if (this.name === void 0) {
      throw new Error("This cannot be called without having the name set.");
    }
    const name = this.name;
    const entries = new FormData();
    this.values.forEach((v) => entries.append(name, v));
    return entries;
  }
  onClick(ev) {
    ev.stopPropagation();
    this.values = Array.from(this.checkboxes).filter((checkbox) => checkbox.checked).map((checkbox) => checkbox.name);
    this.dispatchCustomEvent("change", this.values);
    this.dispatchCustomEvent("input", this.values);
    if (this.internals) {
      this.internals.setValidity({});
      if (this.required && this.values.length === 0) {
        this.internals.setValidity(
          {
            valueMissing: true
          },
          msg("A selection is required"),
          this
        );
      }
      this.internals.setFormValue(this.formValue);
    }
    this.value = this.values;
  }
  willUpdate(changed) {
    if (changed.has("value") && !this.doneFirstUpdate) {
      this.doneFirstUpdate = true;
      this.values = this.value;
    }
  }
  connectedCallback() {
    super.connectedCallback();
    this.dataset.akControl = "true";
    if (this.name && !this.internals) {
      this.internals = this.attachInternals();
    }
    if (this.internals && this.name) {
      this.internals.ariaRequired = this.required ? "true" : "false";
    }
    if (this.required && !this.internals) {
      console.warn(
        "Setting `required` on ak-checkbox-group has no effect when the `name` attribute is unset"
      );
    }
    this.addEventListener("input", (ev) => {
      ev.stopPropagation();
    });
    this.addEventListener("change", (ev) => {
      ev.stopPropagation();
    });
  }
  render() {
    const renderOne = ([name, label]) => {
      const selected = this.values.includes(name);
      const blockFwd = (e2) => {
        e2.stopImmediatePropagation();
      };
      return ke` <div part="checkbox" class="pf-c-check" @click=${this.onClick}>
                <input
                    part="input"
                    @change=${blockFwd}
                    @input=${blockFwd}
                    name="${name}"
                    class="pf-c-check__input"
                    type="checkbox"
                    ?checked=${selected}
                    id="ak-check-${name}"
                />
                <label part="label" class="pf-c-check__label" for="ak-check-${name}"
                    >${label}</label
                >
            </div>`;
    };
    return ke`<div part="checkbox-group" class="pf-c-form__group-control pf-m-stack">
            ${oo(kvToPairs(this.options), renderOne)}
        </div>`;
  }
};
__decorateClass([
  n({ type: Array })
], CheckboxGroup.prototype, "options", 2);
__decorateClass([
  n({ type: Array })
], CheckboxGroup.prototype, "value", 2);
__decorateClass([
  n({ type: String })
], CheckboxGroup.prototype, "name", 2);
__decorateClass([
  n({ type: Boolean })
], CheckboxGroup.prototype, "required", 2);
__decorateClass([
  r2('input[type="checkbox"]')
], CheckboxGroup.prototype, "checkboxes", 2);
__decorateClass([
  r()
], CheckboxGroup.prototype, "values", 2);
CheckboxGroup = __decorateClass([
  t("ak-checkbox-group")
], CheckboxGroup);

// src/admin/stages/identification/IdentificationStageFormHelpers.ts
var sourceToSelect = (source) => [source.pk, source.name, source.name, source];
async function sourcesProvider(page = 1, search = "") {
  const sources = await new SourcesApi(DEFAULT_CONFIG).sourcesAllList({
    ordering: "slug",
    pageSize: 20,
    search: search.trim(),
    page
  });
  return {
    pagination: sources.pagination,
    options: sources.results.filter((source) => source.component !== "").map(sourceToSelect)
  };
}
function sourcesSelector(instanceSources) {
  if (!instanceSources) {
    return async (sources) => sources.filter(([_0, _1, _2, source]) => source !== void 0);
  }
  return async () => {
    const sourcesApi = new SourcesApi(DEFAULT_CONFIG);
    const sources = await Promise.allSettled(
      instanceSources.map((instanceId) => sourcesApi.sourcesAllList({ pbmUuid: instanceId }))
    );
    return sources.filter((s) => s.status === "fulfilled").map((s) => s.value).filter((s) => s.pagination.count > 0).map((s) => s.results[0]).map(sourceToSelect);
  };
}

// src/admin/stages/identification/IdentificationStageForm.ts
var IdentificationStageForm = class extends BaseStageForm {
  static get styles() {
    return [
      ...super.styles,
      i`
                ak-checkbox-group::part(checkbox-group) {
                    padding-top: var(--pf-c-form--m-horizontal__group-label--md--PaddingTop);
                }
            `
    ];
  }
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesIdentificationRetrieve({
      stageUuid: pk
    });
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesIdentificationUpdate({
        stageUuid: this.instance.pk || "",
        identificationStageRequest: data
      });
    }
    return new StagesApi(DEFAULT_CONFIG).stagesIdentificationCreate({
      identificationStageRequest: data
    });
  }
  isUserFieldSelected(field) {
    return (this.instance?.userFields || []).filter((isField) => {
      return field === isField;
    }).length > 0;
  }
  renderForm() {
    const userSelectFields = [
      { name: UserFieldsEnum.Username, label: msg("Username") },
      { name: UserFieldsEnum.Email, label: msg("Email") },
      { name: UserFieldsEnum.Upn, label: msg("UPN") }
    ];
    return ke`<span>
                ${msg("Let the user identify themselves with their username or Email address.")}
            </span>
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${to(this.instance?.name || "")}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("Stage-specific settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal label=${msg("User fields")} name="userFields">
                        <ak-checkbox-group
                            class="user-field-select"
                            .options=${userSelectFields}
                            .value=${userSelectFields.map(({ name }) => name).filter((name) => this.isUserFieldSelected(name))}
                        ></ak-checkbox-group>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Fields a user can identify themselves with. If no fields are selected, the user will only be able to use sources."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal label=${msg("Password stage")} name="passwordStage">
                        <ak-search-select
                            .fetchObjects=${async (query) => {
      const args = {
        ordering: "name"
      };
      if (query !== void 0) {
        args.search = query;
      }
      const stages = await new StagesApi(
        DEFAULT_CONFIG
      ).stagesPasswordList(args);
      return stages.results;
    }}
                            .groupBy=${(items) => groupBy(items, (stage) => stage.verboseNamePlural)}
                            .renderElement=${(stage) => stage.name}
                            .value=${(stage) => stage?.pk}
                            .selected=${(stage) => stage.pk === this.instance?.passwordStage}
                            blankable
                        >
                        </ak-search-select>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "When selected, a password field is shown on the same page instead of a separate page. This prevents username enumeration attacks."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal label=${msg("Captcha stage")} name="captchaStage">
                        <ak-search-select
                            .fetchObjects=${async (query) => {
      const args = {
        ordering: "name"
      };
      if (query !== void 0) {
        args.search = query;
      }
      const stages = await new StagesApi(
        DEFAULT_CONFIG
      ).stagesCaptchaList(args);
      return stages.results;
    }}
                            .groupBy=${(items) => groupBy(items, (stage) => stage.verboseNamePlural)}
                            .renderElement=${(stage) => stage.name}
                            .value=${(stage) => stage?.pk}
                            .selected=${(stage) => stage.pk === this.instance?.captchaStage}
                            blankable
                        >
                        </ak-search-select>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "When set, adds functionality exactly like a Captcha stage, but baked into the Identification stage."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal name="caseInsensitiveMatching">
                        <label class="pf-c-switch">
                            <input
                                class="pf-c-switch__input"
                                type="checkbox"
                                ?checked=${first(this.instance?.caseInsensitiveMatching, true)}
                            />
                            <span class="pf-c-switch__toggle">
                                <span class="pf-c-switch__toggle-icon">
                                    <i class="fas fa-check" aria-hidden="true"></i>
                                </span>
                            </span>
                            <span class="pf-c-switch__label"
                                >${msg("Case insensitive matching")}</span
                            >
                        </label>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "When enabled, user fields are matched regardless of their casing."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal name="pretendUserExists">
                        <label class="pf-c-switch">
                            <input
                                class="pf-c-switch__input"
                                type="checkbox"
                                ?checked=${first(this.instance?.pretendUserExists, true)}
                            />
                            <span class="pf-c-switch__toggle">
                                <span class="pf-c-switch__toggle-icon">
                                    <i class="fas fa-check" aria-hidden="true"></i>
                                </span>
                            </span>
                            <span class="pf-c-switch__label">${msg("Pretend user exists")}</span>
                        </label>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "When enabled, the stage will always accept the given user identifier and continue."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal name="showMatchedUser">
                        <label class="pf-c-switch">
                            <input
                                class="pf-c-switch__input"
                                type="checkbox"
                                ?checked=${first(this.instance?.showMatchedUser, true)}
                            />
                            <span class="pf-c-switch__toggle">
                                <span class="pf-c-switch__toggle-icon">
                                    <i class="fas fa-check" aria-hidden="true"></i>
                                </span>
                            </span>
                            <span class="pf-c-switch__label">${msg("Show matched user")}</span>
                        </label>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "When a valid username/email has been entered, and this option is enabled, the user's username and avatar will be shown. Otherwise, the text that the user entered will be shown."
    )}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>
            <ak-form-group>
                <span slot="header"> ${msg("Source settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Sources")}
                        ?required=${true}
                        name="sources"
                    >
                        <ak-dual-select-dynamic-selected
                            .provider=${sourcesProvider}
                            .selector=${sourcesSelector(this.instance?.sources)}
                            available-label="${msg("Available Sources")}"
                            selected-label="${msg("Selected Sources")}"
                        ></ak-dual-select-dynamic-selected>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Select sources should be shown for users to authenticate with. This only affects web-based sources, not LDAP."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal name="showSourceLabels">
                        <label class="pf-c-switch">
                            <input
                                class="pf-c-switch__input"
                                type="checkbox"
                                ?checked=${first(this.instance?.showSourceLabels, false)}
                            />
                            <span class="pf-c-switch__toggle">
                                <span class="pf-c-switch__toggle-icon">
                                    <i class="fas fa-check" aria-hidden="true"></i>
                                </span>
                            </span>
                            <span class="pf-c-switch__label">${msg("Show sources' labels")}</span>
                        </label>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "By default, only icons are shown for sources. Enable this to show their full names."
    )}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>
            <ak-form-group>
                <span slot="header">${msg("Flow settings")}</span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Passwordless flow")}
                        name="passwordlessFlow"
                    >
                        <ak-flow-search
                            flowType=${FlowsInstancesListDesignationEnum.Authentication}
                            .currentFlow=${this.instance?.passwordlessFlow}
                        ></ak-flow-search>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Optional passwordless flow, which is linked at the bottom of the page. When configured, users can use this flow to authenticate with a WebAuthn authenticator, without entering any details."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Enrollment flow")}
                        name="enrollmentFlow"
                    >
                        <ak-flow-search
                            flowType=${FlowsInstancesListDesignationEnum.Enrollment}
                            .currentFlow=${this.instance?.enrollmentFlow}
                        ></ak-flow-search>

                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Optional enrollment flow, which is linked at the bottom of the page."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal label=${msg("Recovery flow")} name="recoveryFlow">
                        <ak-flow-search
                            flowType=${FlowsInstancesListDesignationEnum.Recovery}
                            .currentFlow=${this.instance?.recoveryFlow}
                        ></ak-flow-search>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Optional recovery flow, which is linked at the bottom of the page."
    )}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>`;
  }
};
IdentificationStageForm = __decorateClass([
  t("ak-stage-identification-form")
], IdentificationStageForm);

// src/admin/stages/invitation/InvitationStageForm.ts
var InvitationStageForm = class extends BaseStageForm {
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesInvitationStagesRetrieve({
      stageUuid: pk
    });
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesInvitationStagesUpdate({
        stageUuid: this.instance.pk || "",
        invitationStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesInvitationStagesCreate({
        invitationStageRequest: data
      });
    }
  }
  renderForm() {
    return ke` <span>
                ${msg("This stage can be included in enrollment flows to accept invitations.")}
            </span>
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${this.instance?.name || ""}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("Stage-specific settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal name="continueFlowWithoutInvitation">
                        <label class="pf-c-switch">
                            <input
                                class="pf-c-switch__input"
                                type="checkbox"
                                ?checked=${first(
      this.instance?.continueFlowWithoutInvitation,
      false
    )}
                            />
                            <span class="pf-c-switch__toggle">
                                <span class="pf-c-switch__toggle-icon">
                                    <i class="fas fa-check" aria-hidden="true"></i>
                                </span>
                            </span>
                            <span class="pf-c-switch__label"
                                >${msg("Continue flow without invitation")}</span
                            >
                        </label>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "If this flag is set, this Stage will jump to the next Stage when no Invitation is given. By default this Stage will cancel the Flow when no invitation is given."
    )}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>`;
  }
};
InvitationStageForm = __decorateClass([
  t("ak-stage-invitation-form")
], InvitationStageForm);

// src/admin/stages/password/PasswordStageForm.ts
var PasswordStageForm = class extends BaseStageForm {
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesPasswordRetrieve({
      stageUuid: pk
    });
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesPasswordUpdate({
        stageUuid: this.instance.pk || "",
        passwordStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesPasswordCreate({
        passwordStageRequest: data
      });
    }
  }
  isBackendSelected(field) {
    if (!this.instance) {
      return true;
    }
    return this.instance.backends.filter((isField) => {
      return field === isField;
    }).length > 0;
  }
  renderForm() {
    const backends = [
      {
        name: BackendsEnum.AuthentikCoreAuthInbuiltBackend,
        label: msg("User database + standard password")
      },
      {
        name: BackendsEnum.AuthentikCoreAuthTokenBackend,
        label: msg("User database + app passwords")
      },
      {
        name: BackendsEnum.AuthentikSourcesLdapAuthLdapBackend,
        label: msg("User database + LDAP password")
      },
      {
        name: BackendsEnum.AuthentikSourcesKerberosAuthKerberosBackend,
        label: msg("User database + Kerberos password")
      }
    ];
    return ke` <span>
                ${msg("Validate the user's password against the selected backend(s).")}
            </span>
            <ak-form-element-horizontal label=${msg("Name")} required name="name">
                <input
                    type="text"
                    value="${this.instance?.name || ""}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("Stage-specific settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Backends")}
                        ?required=${true}
                        name="backends"
                    >
                        <ak-checkbox-group
                            class="user-field-select"
                            .options=${backends}
                            .value=${backends.map(({ name }) => name).filter((name) => this.isBackendSelected(name))}
                        ></ak-checkbox-group>
                        <p class="pf-c-form__helper-text">
                            ${msg("Selection of backends to test the password against.")}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Configuration flow")}
                        ?required=${true}
                        name="configureFlow"
                    >
                        <ak-search-select
                            .fetchObjects=${async (query) => {
      const args = {
        ordering: "slug",
        designation: FlowsInstancesListDesignationEnum.StageConfiguration
      };
      if (query !== void 0) {
        args.search = query;
      }
      const flows = await new FlowsApi(DEFAULT_CONFIG).flowsInstancesList(
        args
      );
      return flows.results;
    }}
                            .renderElement=${(flow) => {
      return RenderFlowOption(flow);
    }}
                            .renderDescription=${(flow) => {
      return ke`${flow.name}`;
    }}
                            .value=${(flow) => {
      return flow?.pk;
    }}
                            .selected=${(flow) => {
      let selected = this.instance?.configureFlow === flow.pk;
      if (!this.instance?.pk && !this.instance?.configureFlow && flow.slug === "default-password-change") {
        selected = true;
      }
      return selected;
    }}
                            ?blankable=${true}
                        >
                        </ak-search-select>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Flow used by an authenticated user to configure their password. If empty, user will not be able to configure change their password."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Failed attempts before cancel")}
                        ?required=${true}
                        name="failedAttemptsBeforeCancel"
                    >
                        <input
                            type="number"
                            value="${this.instance?.failedAttemptsBeforeCancel ?? 5}"
                            class="pf-c-form-control"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "How many attempts a user has before the flow is canceled. To lock the user out, use a reputation policy and a user_write stage."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-switch-input
                        name="allowShowPassword"
                        label="Allow Show Password"
                        ?checked=${this.instance?.allowShowPassword ?? false}
                        help=${msg("Provide users with a 'show password' button.")}
                    ></ak-switch-input>
                </div>
            </ak-form-group>`;
  }
};
PasswordStageForm = __decorateClass([
  t("ak-stage-password-form")
], PasswordStageForm);

// src/admin/stages/prompt/PromptStageFormHelpers.ts
var promptToSelect = (p) => [
  p.pk,
  msg(str`${p.name} ("${p.fieldKey}", of type ${p.type})`),
  p.name,
  p
];
async function promptFieldsProvider(page = 1, search = "") {
  const prompts = await new StagesApi(DEFAULT_CONFIG).stagesPromptPromptsList({
    ordering: "field_name,order",
    pageSize: 20,
    search: search.trim(),
    page
  });
  return {
    pagination: prompts.pagination,
    options: prompts.results.map(promptToSelect)
  };
}
function promptFieldsSelector(instanceFields) {
  if (!instanceFields) {
    return async (options) => options.filter(([_0, _1, _2, prompt]) => prompt !== void 0);
  }
  return async () => {
    const stages = new StagesApi(DEFAULT_CONFIG);
    const prompts = await Promise.allSettled(
      instanceFields.map(
        (instanceId) => stages.stagesPromptPromptsRetrieve({ promptUuid: instanceId })
      )
    );
    return prompts.filter((p) => p.status === "fulfilled").map((p) => p.value).map(promptToSelect);
  };
}
var policyToSelect = (p) => [p.pk, `${p.name} (${p.verboseName})`, p.name, p];
async function policiesProvider(page = 1, search = "") {
  const policies = await new PoliciesApi(DEFAULT_CONFIG).policiesAllList({
    ordering: "name",
    pageSize: 20,
    search: search.trim(),
    page
  });
  return {
    pagination: policies.pagination,
    options: policies.results.map(policyToSelect)
  };
}
function policiesSelector(instancePolicies) {
  if (!instancePolicies) {
    return async (options) => options.filter(([_0, _1, _2, policy]) => policy !== void 0);
  }
  return async () => {
    const policy = new PoliciesApi(DEFAULT_CONFIG);
    const policies = await Promise.allSettled(
      instancePolicies.map(
        (instanceId) => policy.policiesAllRetrieve({ policyUuid: instanceId })
      )
    );
    return policies.filter((p) => p.status === "fulfilled").map((p) => p.value).map(policyToSelect);
  };
}

// src/admin/stages/prompt/PromptStageForm.ts
var PromptStageForm = class extends BaseStageForm {
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesPromptStagesRetrieve({
      stageUuid: pk
    });
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesPromptStagesUpdate({
        stageUuid: this.instance.pk || "",
        promptStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesPromptStagesCreate({
        promptStageRequest: data
      });
    }
  }
  renderForm() {
    return ke` <span>
                ${msg(
      "Show arbitrary input fields to the user, for example during enrollment. Data is saved in the flow context under the 'prompt_data' variable."
    )}
            </span>
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${to(this.instance?.name || "")}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("Stage-specific settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Fields")}
                        ?required=${true}
                        name="fields"
                    >
                        <ak-dual-select-dynamic-selected
                            .provider=${promptFieldsProvider}
                            .selector=${promptFieldsSelector(this.instance?.fields)}
                            available-label="${msg("Available Fields")}"
                            selected-label="${msg("Selected Fields")}"
                        ></ak-dual-select-dynamic-selected>
                        ${this.instance ? ke`<ak-forms-modal size=${"pf-m-xl" /* XLarge */}>
                                  <span slot="submit"> ${msg("Create")} </span>
                                  <span slot="header"> ${msg("Create Prompt")} </span>
                                  <ak-prompt-form slot="form"> </ak-prompt-form>
                                  <button
                                      type="button"
                                      slot="trigger"
                                      class="pf-c-button pf-m-primary"
                                  >
                                      ${msg("Create")}
                                  </button>
                              </ak-forms-modal>` : D}
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Validation Policies")}
                        name="validationPolicies"
                    >
                        <ak-dual-select-dynamic-selected
                            .provider=${policiesProvider}
                            .selector=${policiesSelector(this.instance?.validationPolicies)}
                            available-label="${msg("Available Policies")}"
                            selected-label="${msg("Selected Policies")}"
                        ></ak-dual-select-dynamic-selected>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Selected policies are executed when the stage is submitted to validate the data."
    )}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>`;
  }
};
PromptStageForm = __decorateClass([
  t("ak-stage-prompt-form")
], PromptStageForm);

// src/admin/stages/redirect/RedirectStageForm.ts
var RedirectStageForm = class extends BaseStageForm {
  constructor() {
    super(...arguments);
    this.mode = RedirectStageModeEnum.Static;
  }
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesRedirectRetrieve({
      stageUuid: pk
    }).then((stage) => {
      this.mode = stage.mode ?? RedirectStageModeEnum.Static;
      return stage;
    });
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesRedirectUpdate({
        stageUuid: this.instance.pk || "",
        redirectStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesRedirectCreate({
        redirectStageRequest: data
      });
    }
  }
  renderForm() {
    return ke`<span>
                ${msg("Redirect the user to another flow, potentially with all gathered context")}
            </span>
            <ak-form-element-horizontal label=${msg("Name")} required name="name">
                <input
                    type="text"
                    value="${this.instance?.name ?? ""}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-group expanded>
                <span slot="header"> ${msg("Stage-specific settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal label=${msg("Mode")} required name="mode">
                        <select
                            class="pf-c-form-control"
                            @change=${(ev) => {
      const target = ev.target;
      this.mode = target.selectedOptions[0].value;
    }}
                        >
                            <option
                                value=${RedirectStageModeEnum.Static}
                                ?selected=${this.instance?.mode === RedirectStageModeEnum.Static}
                            >
                                ${msg("Static")}
                            </option>
                            <option
                                value=${RedirectStageModeEnum.Flow}
                                ?selected=${this.instance?.mode === RedirectStageModeEnum.Flow}
                            >
                                ${msg("Flow")}
                            </option>
                        </select>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        ?hidden=${this.mode !== RedirectStageModeEnum.Static}
                        label=${msg("Target URL")}
                        name="targetStatic"
                        required
                    >
                        <input
                            type="text"
                            value="${this.instance?.targetStatic ?? ""}"
                            class="pf-c-form-control pf-m-monospace"
                            autocomplete="off"
                            spellcheck="false"
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg("Redirect the user to a static URL.")}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        ?hidden=${this.mode !== RedirectStageModeEnum.Flow}
                        label=${msg("Target Flow")}
                        name="targetFlow"
                        required
                    >
                        <ak-search-select
                            .fetchObjects=${async (query) => {
      const args = {
        ordering: "slug"
      };
      if (query !== void 0) {
        args.search = query;
      }
      const flows = await new FlowsApi(DEFAULT_CONFIG).flowsInstancesList(
        args
      );
      return flows.results;
    }}
                            .renderElement=${(flow) => RenderFlowOption(flow)}
                            .renderDescription=${(flow) => ke`${flow.name}`}
                            .value=${(flow) => flow?.pk}
                            .selected=${(flow) => this.instance?.targetFlow === flow.pk}
                            blankable
                        >
                        </ak-search-select>
                        <p class="pf-c-form__helper-text">${msg("Redirect the user to a Flow.")}</p>
                    </ak-form-element-horizontal>
                    <ak-switch-input
                        ?hidden=${this.mode !== RedirectStageModeEnum.Flow}
                        name="keepContext"
                        label=${msg("Keep flow context")}
                        ?checked="${this.instance?.keepContext ?? true}"
                    >
                    </ak-switch-input>
                </div>
            </ak-form-group>`;
  }
};
__decorateClass([
  n({ type: String })
], RedirectStageForm.prototype, "mode", 2);
RedirectStageForm = __decorateClass([
  t("ak-stage-redirect-form")
], RedirectStageForm);

// src/admin/stages/source/SourceStageForm.ts
var SourceStageForm = class extends BaseStageForm {
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesSourceRetrieve({
      stageUuid: pk
    });
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesSourceUpdate({
        stageUuid: this.instance.pk || "",
        sourceStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesSourceCreate({
        sourceStageRequest: data
      });
    }
  }
  renderForm() {
    return ke`
            <span
                >${msg(
      "Inject an OAuth or SAML Source into the flow execution. This allows for additional user verification, or to dynamically access different sources for different user identifiers (username, email address, etc)."
    )}</span
            >
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${to(this.instance?.name || "")}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-element-horizontal label=${msg("Source")} ?required=${true} name="source">
                <ak-search-select
                    .fetchObjects=${async (query) => {
      const args = {
        ordering: "name"
      };
      if (query !== void 0) {
        args.search = query;
      }
      const users = await new SourcesApi(DEFAULT_CONFIG).sourcesAllList(args);
      return users.results;
    }}
                    .renderElement=${(source) => {
      return source.name;
    }}
                    .renderDescription=${(source) => {
      return ke`${source.verboseName}`;
    }}
                    .value=${(source) => {
      return source?.pk;
    }}
                    .selected=${(source) => {
      return source.pk === this.instance?.source;
    }}
                >
                </ak-search-select>
            </ak-form-element-horizontal>
            <ak-form-element-horizontal
                label=${msg("Resume timeout")}
                ?required=${true}
                name="resumeTimeout"
            >
                <input
                    type="text"
                    value="${to(this.instance?.resumeTimeout || "minutes=10")}"
                    class="pf-c-form-control"
                    required
                />
                <p class="pf-c-form__helper-text">
                    ${msg(
      "Amount of time a user can take to return from the source to continue the flow."
    )}
                </p>
                <ak-utils-time-delta-help></ak-utils-time-delta-help>
            </ak-form-element-horizontal>
        `;
  }
};
SourceStageForm = __decorateClass([
  t("ak-stage-source-form")
], SourceStageForm);

// src/admin/stages/user_delete/UserDeleteStageForm.ts
var UserDeleteStageForm = class extends BaseStageForm {
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesUserDeleteRetrieve({
      stageUuid: pk
    });
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesUserDeleteUpdate({
        stageUuid: this.instance.pk || "",
        userDeleteStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesUserDeleteCreate({
        userDeleteStageRequest: data
      });
    }
  }
  renderForm() {
    return ke` <span>
                ${msg(
      "Delete the currently pending user. CAUTION, this stage does not ask for confirmation. Use a consent stage to ensure the user is aware of their actions."
    )}
            </span>
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${to(this.instance?.name || "")}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>`;
  }
};
UserDeleteStageForm = __decorateClass([
  t("ak-stage-user-delete-form")
], UserDeleteStageForm);

// src/admin/stages/user_login/UserLoginStageForm.ts
var UserLoginStageForm = class extends BaseStageForm {
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesUserLoginRetrieve({
      stageUuid: pk
    });
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesUserLoginUpdate({
        stageUuid: this.instance.pk || "",
        userLoginStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesUserLoginCreate({
        userLoginStageRequest: data
      });
    }
  }
  renderForm() {
    return ke` <span>${msg("Log the currently pending user in.")}</span>
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${first(this.instance?.name, "")}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("Stage-specific settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal
                        label=${msg("Session duration")}
                        ?required=${true}
                        name="sessionDuration"
                    >
                        <input
                            type="text"
                            value="${first(this.instance?.sessionDuration, "seconds=0")}"
                            class="pf-c-form-control pf-m-monospace"
                            autocomplete="off"
                            spellcheck="false"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Determines how long a session lasts. Default of 0 seconds means that the sessions lasts until the browser is closed."
    )}
                        </p>
                        <ak-utils-time-delta-help></ak-utils-time-delta-help>
                        <ak-alert ?inline=${true}>
                            ${msg(
      "Different browsers handle session cookies differently, and might not remove them even when the browser is closed."
    )}
                            <a
                                href="https://developer.mozilla.org/en-US/docs/Web/HTTP/Headers/Set-Cookie#expiresdate"
                                target="_blank"
                            >
                                ${msg("See here.")}
                            </a>
                        </ak-alert>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Stay signed in offset")}
                        ?required=${true}
                        name="rememberMeOffset"
                    >
                        <input
                            type="text"
                            value="${first(this.instance?.rememberMeOffset, "seconds=0")}"
                            class="pf-c-form-control pf-m-monospace"
                            autocomplete="off"
                            spellcheck="false"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg(
      'If set to a duration above 0, the user will have the option to choose to "stay signed in", which will extend their session by the time specified here.'
    )}
                        </p>
                        <ak-utils-time-delta-help></ak-utils-time-delta-help>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("Network binding")}
                        ?required=${true}
                        name="networkBinding"
                    >
                        <ak-radio
                            .options=${[
      {
        label: msg("No binding"),
        value: NetworkBindingEnum.NoBinding
      },
      {
        label: msg("Bind ASN"),
        value: NetworkBindingEnum.BindAsn,
        default: true
      },
      {
        label: msg("Bind ASN and Network"),
        value: NetworkBindingEnum.BindAsnNetwork
      },
      {
        label: msg("Bind ASN, Network and IP"),
        value: NetworkBindingEnum.BindAsnNetworkIp
      }
    ]}
                            .value=${this.instance?.networkBinding}
                        >
                        </ak-radio>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Configure if sessions created by this stage should be bound to the Networks they were created in."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("GeoIP binding")}
                        ?required=${true}
                        name="geoipBinding"
                    >
                        <ak-radio
                            .options=${[
      {
        label: msg("No binding"),
        value: GeoipBindingEnum.NoBinding
      },
      {
        label: msg("Bind Continent"),
        value: GeoipBindingEnum.BindContinent,
        default: true
      },
      {
        label: msg("Bind Continent and Country"),
        value: GeoipBindingEnum.BindContinentCountry
      },
      {
        label: msg("Bind Continent, Country and City"),
        value: GeoipBindingEnum.BindContinentCountryCity
      }
    ]}
                            .value=${this.instance?.geoipBinding}
                        >
                        </ak-radio>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Configure if sessions created by this stage should be bound to their GeoIP-based location"
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal name="terminateOtherSessions">
                        <label class="pf-c-switch">
                            <input
                                class="pf-c-switch__input"
                                type="checkbox"
                                ?checked=${first(this.instance?.terminateOtherSessions, false)}
                            />
                            <span class="pf-c-switch__toggle">
                                <span class="pf-c-switch__toggle-icon">
                                    <i class="fas fa-check" aria-hidden="true"></i>
                                </span>
                            </span>
                            <span class="pf-c-switch__label"
                                >${msg("Terminate other sessions")}</span
                            >
                        </label>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "When enabled, all previous sessions of the user will be terminated."
    )}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>`;
  }
};
UserLoginStageForm = __decorateClass([
  t("ak-stage-user-login-form")
], UserLoginStageForm);

// src/admin/stages/user_logout/UserLogoutStageForm.ts
var UserLogoutStageForm = class extends BaseStageForm {
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesUserLogoutRetrieve({
      stageUuid: pk
    });
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesUserLogoutUpdate({
        stageUuid: this.instance.pk || "",
        userLogoutStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesUserLogoutCreate({
        userLogoutStageRequest: data
      });
    }
  }
  renderForm() {
    return ke` <span>${msg("Remove the user from the current session.")}</span>
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${to(this.instance?.name || "")}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>`;
  }
};
UserLogoutStageForm = __decorateClass([
  t("ak-stage-user-logout-form")
], UserLogoutStageForm);

// src/admin/stages/user_write/UserWriteStageForm.ts
var import_UserCreationModeEnum = __toESM(require_UserCreationModeEnum(), 1);
var UserWriteStageForm = class extends BaseStageForm {
  loadInstance(pk) {
    return new StagesApi(DEFAULT_CONFIG).stagesUserWriteRetrieve({
      stageUuid: pk
    });
  }
  async send(data) {
    if (this.instance) {
      return new StagesApi(DEFAULT_CONFIG).stagesUserWriteUpdate({
        stageUuid: this.instance.pk || "",
        userWriteStageRequest: data
      });
    } else {
      return new StagesApi(DEFAULT_CONFIG).stagesUserWriteCreate({
        userWriteStageRequest: data
      });
    }
  }
  renderForm() {
    return ke` <span>
                ${msg(
      `Write any data from the flow's context's 'prompt_data' to the currently pending user. If no user
        is pending, a new user is created, and data is written to them.`
    )}
            </span>
            <ak-form-element-horizontal label=${msg("Name")} ?required=${true} name="name">
                <input
                    type="text"
                    value="${to(this.instance?.name || "")}"
                    class="pf-c-form-control"
                    required
                />
            </ak-form-element-horizontal>
            <ak-form-group .expanded=${true}>
                <span slot="header"> ${msg("Stage-specific settings")} </span>
                <div slot="body" class="pf-c-form">
                    <ak-form-element-horizontal name="userCreationMode">
                        <ak-radio
                            .options=${[
      {
        label: msg("Never create users"),
        value: import_UserCreationModeEnum.UserCreationModeEnum.NeverCreate,
        description: ke`${msg(
          "When no user is present in the flow context, the stage will fail."
        )}`
      },
      {
        label: msg("Create users when required"),
        value: import_UserCreationModeEnum.UserCreationModeEnum.CreateWhenRequired,
        default: true,
        description: ke`${msg(
          "When no user is present in the the flow context, a new user is created."
        )}`
      },
      {
        label: msg("Always create new users"),
        value: import_UserCreationModeEnum.UserCreationModeEnum.AlwaysCreate,
        description: ke`${msg(
          "Create a new user even if a user is in the flow context."
        )}`
      }
    ]}
                            .value=${this.instance?.userCreationMode}
                        >
                        </ak-radio>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal name="createUsersAsInactive">
                        <label class="pf-c-switch">
                            <input
                                class="pf-c-switch__input"
                                type="checkbox"
                                ?checked=${first(this.instance?.createUsersAsInactive, true)}
                            />
                            <span class="pf-c-switch__toggle">
                                <span class="pf-c-switch__toggle-icon">
                                    <i class="fas fa-check" aria-hidden="true"></i>
                                </span>
                            </span>
                            <span class="pf-c-switch__label"
                                >${msg("Create users as inactive")}</span
                            >
                        </label>
                        <p class="pf-c-form__helper-text">
                            ${msg("Mark newly created users as inactive.")}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal label=${msg("User type")} name="userType">
                        <ak-radio
                            .options=${[
      {
        label: msg("Internal"),
        value: UserTypeEnum.Internal,
        default: true,
        description: ke`${msg(
          "Internal users might be users such as company employees, which will get access to the full Enterprise feature set."
        )}`
      },
      {
        label: msg("External"),
        value: UserTypeEnum.External,
        description: ke`${msg(
          "External users might be external consultants or B2C customers. These users don't get access to enterprise features."
        )}`
      },
      {
        label: msg("Service account"),
        value: UserTypeEnum.ServiceAccount,
        description: ke`${msg(
          "Service accounts should be used for machine-to-machine authentication or other automations."
        )}`
      }
    ]}
                            .value=${this.instance?.userType}
                        >
                        </ak-radio>
                        <p class="pf-c-form__helper-text">
                            ${msg("User type used for newly created users.")}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal
                        label=${msg("User path template")}
                        name="userPathTemplate"
                    >
                        <input
                            type="text"
                            value="${first(this.instance?.userPathTemplate, "")}"
                            class="pf-c-form-control pf-m-monospace"
                            autocomplete="off"
                            spellcheck="false"
                            required
                        />
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Path new users will be created under. If left blank, the default path will be used."
    )}
                        </p>
                    </ak-form-element-horizontal>
                    <ak-form-element-horizontal label=${msg("Group")} name="createUsersGroup">
                        <ak-search-select
                            .fetchObjects=${async (query) => {
      const args = {
        ordering: "name",
        includeUsers: false
      };
      if (query !== void 0) {
        args.search = query;
      }
      const groups = await new CoreApi(DEFAULT_CONFIG).coreGroupsList(
        args
      );
      return groups.results;
    }}
                            .renderElement=${(group) => {
      return group.name;
    }}
                            .value=${(group) => {
      return group ? group.pk : void 0;
    }}
                            .selected=${(group) => {
      return group.pk === this.instance?.createUsersGroup;
    }}
                            ?blankable=${true}
                        >
                        </ak-search-select>
                        <p class="pf-c-form__helper-text">
                            ${msg(
      "Newly created users are added to this group, if a group is selected."
    )}
                        </p>
                    </ak-form-element-horizontal>
                </div>
            </ak-form-group>`;
  }
};
UserWriteStageForm = __decorateClass([
  t("ak-stage-user-write-form")
], UserWriteStageForm);

// src/admin/stages/StageWizard.ts
var StageWizard = class extends AKElement {
  constructor() {
    super(...arguments);
    this.createText = msg("Create");
    this.showBindingPage = false;
    this.stageTypes = [];
  }
  static get styles() {
    return [patternfly_base_default, button_default];
  }
  firstUpdated() {
    new StagesApi(DEFAULT_CONFIG).stagesAllTypesList().then((types) => {
      this.stageTypes = types;
    });
  }
  render() {
    return ke`
            <ak-wizard
                .steps=${this.showBindingPage ? ["initial", "create-binding"] : ["initial"]}
                header=${msg("New stage")}
                description=${msg("Create a new stage.")}
            >
                <ak-wizard-page-type-create
                    slot="initial"
                    .types=${this.stageTypes}
                    @select=${(ev) => {
      if (!this.wizard) return;
      const idx = this.wizard.steps.indexOf("initial") + 1;
      this.wizard.steps = this.wizard.steps.filter(
        (step) => !step.startsWith("type-")
      );
      this.wizard.steps.splice(
        idx,
        0,
        `type-${ev.detail.component}-${ev.detail.modelName}`
      );
      this.wizard.isValid = true;
    }}
                >
                </ak-wizard-page-type-create>
                ${this.stageTypes.map((type) => {
      return ke`
                        <ak-wizard-page-form
                            slot=${`type-${type.component}-${type.modelName}`}
                            .sidebarLabel=${() => msg(str`Create ${type.name}`)}
                        >
                            <ak-proxy-form type=${type.component}></ak-proxy-form>
                        </ak-wizard-page-form>
                    `;
    })}
                ${this.showBindingPage ? ke`<ak-wizard-page-form
                          slot="create-binding"
                          .sidebarLabel=${() => msg("Create Binding")}
                          .activePageCallback=${async (context) => {
      const createSlot = context.host.steps[1];
      const bindingForm = context.querySelector("ak-stage-binding-form");
      if (!bindingForm) return;
      bindingForm.instance = {
        stage: context.host.state[createSlot].pk
      };
    }}
                      >
                          <ak-stage-binding-form
                              .targetPk=${this.bindingTarget}
                          ></ak-stage-binding-form>
                      </ak-wizard-page-form>` : ke``}
                <button slot="trigger" class="pf-c-button pf-m-primary">${this.createText}</button>
            </ak-wizard>
        `;
  }
};
__decorateClass([
  n()
], StageWizard.prototype, "createText", 2);
__decorateClass([
  n({ type: Boolean })
], StageWizard.prototype, "showBindingPage", 2);
__decorateClass([
  n()
], StageWizard.prototype, "bindingTarget", 2);
__decorateClass([
  n({ attribute: false })
], StageWizard.prototype, "stageTypes", 2);
__decorateClass([
  e("ak-wizard")
], StageWizard.prototype, "wizard", 2);
StageWizard = __decorateClass([
  t("ak-stage-wizard")
], StageWizard);

export {
  BaseStageForm
};
//# sourceMappingURL=chunk-RBE5DWO6.js.map
