import {
  HorizontalLightComponent
} from "./chunk-WMKINSDI.js";
import {
  PolicyEngineMode,
  n,
  t
} from "./chunk-MKGIUSP2.js";
import {
  D,
  ke,
  msg
} from "./chunk-BW7LVHGS.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/admin/applications/PolicyOptions.ts
var policyOptions = [
  {
    label: "any",
    value: PolicyEngineMode.Any,
    default: true,
    description: ke`${msg("Any policy must match to grant access")}`
  },
  {
    label: "all",
    value: PolicyEngineMode.All,
    description: ke`${msg("All policies must match to grant access")}`
  }
];

// src/components/ak-radio-input.ts
var AkRadioInput = class extends HorizontalLightComponent {
  constructor() {
    super(...arguments);
    this.options = [];
  }
  handleInput(ev) {
    if ("detail" in ev) {
      this.value = ev.detail.value;
    }
  }
  renderHelp() {
    return [D];
  }
  renderControl() {
    return ke`<ak-radio
                .options=${this.options}
                .value=${this.value}
                @input=${this.handleInput}
            ></ak-radio>
            ${this.help.trim() ? ke`<p class="pf-c-form__helper-radio">${this.help}</p>` : D}`;
  }
};
__decorateClass([
  n({ type: Object })
], AkRadioInput.prototype, "value", 2);
__decorateClass([
  n({ type: Array })
], AkRadioInput.prototype, "options", 2);
AkRadioInput = __decorateClass([
  t("ak-radio-input")
], AkRadioInput);

export {
  policyOptions
};
//# sourceMappingURL=chunk-RKBUXRF5.js.map
