import {
  radio_default
} from "./chunk-EA2TUCZW.js";
import {
  Form,
  Kt,
  ii
} from "./chunk-Y4CBTB76.js";
import {
  WithLicenseSummary
} from "./chunk-UY7EXP7Y.js";
import {
  form_default
} from "./chunk-DK5NYREA.js";
import {
  grid_default
} from "./chunk-XCEM2TDB.js";
import {
  card_default
} from "./chunk-ITYWTYEW.js";
import {
  AKElement,
  n,
  patternfly_base_default,
  t
} from "./chunk-MKGIUSP2.js";
import {
  D,
  i,
  ke,
  msg,
  str
} from "./chunk-BW7LVHGS.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/elements/forms/ProxyForm.ts
var ProxyForm = class extends Form {
  constructor() {
    super(...arguments);
    this.args = {};
    this.typeMap = {};
  }
  async submit(ev) {
    return this.innerElement?.submit(ev);
  }
  resetForm() {
    this.innerElement?.resetForm();
  }
  getSuccessMessage() {
    return this.innerElement?.getSuccessMessage() || "";
  }
  async requestUpdate(name, oldValue) {
    const result = await super.requestUpdate(name, oldValue);
    await this.innerElement?.requestUpdate();
    return result;
  }
  renderVisible() {
    let elementName = this.type;
    if (this.type in this.typeMap) {
      elementName = this.typeMap[this.type];
    }
    if (!this.innerElement) {
      this.innerElement = document.createElement(elementName);
    }
    this.innerElement.viewportCheck = this.viewportCheck;
    for (const k in this.args) {
      this.innerElement.setAttribute(k, this.args[k]);
      this.innerElement[k] = this.args[k];
    }
    return ke`${this.innerElement}`;
  }
};
__decorateClass([
  n()
], ProxyForm.prototype, "type", 2);
__decorateClass([
  n({ attribute: false })
], ProxyForm.prototype, "args", 2);
__decorateClass([
  n({ attribute: false })
], ProxyForm.prototype, "typeMap", 2);
ProxyForm = __decorateClass([
  t("ak-proxy-form")
], ProxyForm);

// src/admin/common/ak-license-notice.ts
var AkLicenceNotice = class extends WithLicenseSummary(AKElement) {
  constructor() {
    super(...arguments);
    this.notice = msg("Enterprise only");
  }
  render() {
    return this.hasEnterpriseLicense ? D : ke`
                  <ak-alert class="pf-c-radio__description" inline plain>
                      <a href="#/enterprise/licenses">${this.notice}</a>
                  </ak-alert>
              `;
  }
};
__decorateClass([
  n()
], AkLicenceNotice.prototype, "notice", 2);
AkLicenceNotice = __decorateClass([
  t("ak-license-notice")
], AkLicenceNotice);

// src/elements/wizard/WizardPage.ts
var WizardPage = class extends AKElement {
  constructor() {
    super(...arguments);
    this.sidebarLabel = () => {
      return "UNNAMED";
    };
    /**
     * Called when this is the page brought into view.
     */
    this.activeCallback = () => {
      this.host.isValid = false;
    };
    /**
     * Called when the `next` button on the wizard is pressed. For forms, results in the submission
     * of the current form to the back-end before being allowed to proceed to the next page. This is
     * sub-optimal if we want to collect multiple bits of data before finishing the whole course.
     *
     * @returns `true` if the wizard can proceed to the next page, `false` otherwise.
     */
    this.nextCallback = () => {
      return Promise.resolve(true);
    };
  }
  static get styles() {
    return [patternfly_base_default];
  }
  get host() {
    return this.parentElement;
  }
  /**
   * Reset the page to its initial state.
   *
   * @abstract
   */
  reset() {
    console.debug(`authentik/wizard ${this.localName}: reset)`);
  }
  requestUpdate(name, oldValue, options) {
    this.querySelectorAll("*").forEach((el) => {
      if ("requestUpdate" in el) {
        el.requestUpdate();
      }
    });
    return super.requestUpdate(name, oldValue, options);
  }
  render() {
    return ke`<slot></slot>`;
  }
};
__decorateClass([
  n()
], WizardPage.prototype, "sidebarLabel", 2);
WizardPage = __decorateClass([
  t("ak-wizard-page")
], WizardPage);

// src/elements/wizard/TypeCreateWizardPage.ts
var TypeCreateWizardPage = class extends WithLicenseSummary(WizardPage) {
  constructor() {
    super(...arguments);
    this.types = [];
    this.layout = "list" /* list */;
    //#region Refs
    this.formRef = ii();
    //#endregion
    this.sidebarLabel = () => msg("Select type");
    this.reset = () => {
      super.reset();
      this.selectedType = void 0;
      this.formRef.value?.reset();
    };
    this.activeCallback = () => {
      const form = this.formRef.value;
      this.host.isValid = form?.checkValidity() ?? false;
      if (this.selectedType) {
        this.selectDispatch(this.selectedType);
      }
    };
  }
  //#endregion
  static get styles() {
    return [
      patternfly_base_default,
      form_default,
      grid_default,
      radio_default,
      card_default,
      i`
                .pf-c-card__header-main img {
                    max-height: 2em;
                    min-height: 2em;
                }
                :host([theme="dark"]) .pf-c-card__header-main img {
                    filter: invert(1);
                }
            `
    ];
  }
  selectDispatch(type) {
    this.dispatchEvent(
      new CustomEvent("select", {
        detail: type,
        bubbles: true,
        composed: true
      })
    );
  }
  renderGrid() {
    return ke`<div
            class="pf-l-grid pf-m-gutter"
            data-ouid-component-type="ak-type-create-grid"
        >
            ${this.types.map((type, idx) => {
      const requiresEnterprise = type.requiresEnterprise && !this.hasEnterpriseLicense;
      const componentName = type.modelName.includes(".") ? type.modelName.split(".")[1] ?? "--unknown--" : type.modelName;
      return ke`<div
                    class="pf-l-grid__item pf-m-3-col pf-c-card ${requiresEnterprise ? "pf-m-non-selectable-raised" : "pf-m-selectable-raised"} ${this.selectedType == type ? "pf-m-selected-raised" : ""}"
                    tabindex=${idx}
                    data-ouid-component-type="ak-type-create-grid-card"
                    data-ouid-component-name=${componentName}
                    @click=${() => {
        if (requiresEnterprise) return;
        this.selectDispatch(type);
        this.selectedType = type;
      }}
                >
                    ${type.iconUrl ? ke`<div class="pf-c-card__header">
                              <div class="pf-c-card__header-main">
                                  <img src=${type.iconUrl} alt=${msg(str`${type.name} Icon`)} />
                              </div>
                          </div>` : D}
                    <div class="pf-c-card__title">${type.name}</div>
                    <div class="pf-c-card__body">${type.description}</div>
                    ${requiresEnterprise ? ke`<div class="pf-c-card__footer">
                              <ak-license-notice></ak-license-notice>
                          </div> ` : D}
                </div>`;
    })}
        </div>`;
  }
  renderList() {
    return ke`<form
            ${Kt(this.formRef)}
            class="pf-c-form pf-m-horizontal"
            data-ouid-component-type="ak-type-create-list"
        >
            ${this.types.map((type) => {
      const requiresEnterprise = type.requiresEnterprise && !this.hasEnterpriseLicense;
      return ke`<div
                    class="pf-c-radio"
                    data-ouid-component-type="ak-type-create-list-card"
                    data-ouid-component-name=${type.modelName.split(".")[1] ?? "--unknown--"}
                >
                    <input
                        class="pf-c-radio__input"
                        type="radio"
                        name="type"
                        id=${`${type.component}-${type.modelName}`}
                        @change=${() => {
        this.selectDispatch(type);
      }}
                        ?disabled=${requiresEnterprise}
                    />
                    <label class="pf-c-radio__label" for=${`${type.component}-${type.modelName}`}
                        >${type.name}</label
                    >
                    <span class="pf-c-radio__description"
                        >${type.description}
                        ${requiresEnterprise ? ke`<ak-license-notice></ak-license-notice>` : D}
                    </span>
                </div>`;
    })}
        </form>`;
  }
  render() {
    switch (this.layout) {
      case "grid" /* grid */:
        return this.renderGrid();
      case "list" /* list */:
        return this.renderList();
      default:
        throw new Error(`Unknown layout: ${this.layout}`);
    }
  }
};
__decorateClass([
  n({ attribute: false })
], TypeCreateWizardPage.prototype, "types", 2);
__decorateClass([
  n({ attribute: false })
], TypeCreateWizardPage.prototype, "selectedType", 2);
__decorateClass([
  n({ type: String })
], TypeCreateWizardPage.prototype, "layout", 2);
TypeCreateWizardPage = __decorateClass([
  t("ak-wizard-page-type-create")
], TypeCreateWizardPage);

// node_modules/@patternfly/patternfly/components/Wizard/wizard.css
var wizard_default = ".pf-c-wizard__header {\n  --pf-global--Color--100: var(--pf-global--Color--light-100);\n  --pf-global--Color--200: var(--pf-global--Color--light-200);\n  --pf-global--BorderColor--100: var(--pf-global--BorderColor--light-100);\n  --pf-global--primary-color--100: var(--pf-global--primary-color--light-100);\n  --pf-global--link--Color: var(--pf-global--link--Color--light);\n  --pf-global--link--Color--hover: var(--pf-global--link--Color--light);\n  --pf-global--BackgroundColor--100: var(--pf-global--BackgroundColor--dark-100);\n}\n.pf-c-wizard__header .pf-c-card {\n  --pf-c-card--BackgroundColor: var(--pf-global--BackgroundColor--dark-transparent-200);\n}\n.pf-c-wizard__header .pf-c-button {\n  --pf-c-button--m-primary--Color: var(--pf-global--primary-color--dark-100);\n  --pf-c-button--m-primary--hover--Color: var(--pf-global--primary-color--dark-100);\n  --pf-c-button--m-primary--focus--Color: var(--pf-global--primary-color--dark-100);\n  --pf-c-button--m-primary--active--Color: var(--pf-global--primary-color--dark-100);\n  --pf-c-button--m-primary--BackgroundColor: var(--pf-global--BackgroundColor--light-100);\n  --pf-c-button--m-primary--hover--BackgroundColor: var(--pf-global--BackgroundColor--light-300);\n  --pf-c-button--m-primary--focus--BackgroundColor: var(--pf-global--BackgroundColor--light-300);\n  --pf-c-button--m-primary--active--BackgroundColor: var(--pf-global--BackgroundColor--light-300);\n  --pf-c-button--m-secondary--Color: var(--pf-global--Color--light-100);\n  --pf-c-button--m-secondary--hover--Color: var(--pf-global--Color--light-100);\n  --pf-c-button--m-secondary--focus--Color: var(--pf-global--Color--light-100);\n  --pf-c-button--m-secondary--active--Color: var(--pf-global--Color--light-100);\n  --pf-c-button--m-secondary--BorderColor: var(--pf-global--Color--light-100);\n  --pf-c-button--m-secondary--hover--BorderColor: var(--pf-global--Color--light-100);\n  --pf-c-button--m-secondary--focus--BorderColor: var(--pf-global--Color--light-100);\n  --pf-c-button--m-secondary--active--BorderColor: var(--pf-global--Color--light-100);\n}\n\n.pf-c-wizard {\n  --pf-c-wizard--Height: 100%;\n  --pf-c-modal-box--c-wizard--FlexBasis: 47.625rem;\n  --pf-c-wizard__header--BackgroundColor: var(--pf-global--BackgroundColor--dark-100);\n  --pf-c-wizard__header--ZIndex: var(--pf-global--ZIndex--md);\n  --pf-c-wizard__header--PaddingTop: var(--pf-global--spacer--lg);\n  --pf-c-wizard__header--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-wizard__header--PaddingBottom: var(--pf-global--spacer--lg);\n  --pf-c-wizard__header--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-wizard__header--lg--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-wizard__header--lg--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-wizard__header--xl--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-wizard__header--xl--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-wizard__close--Top: calc(var(--pf-global--spacer--lg) - var(--pf-global--spacer--form-element));\n  --pf-c-wizard__close--Right: 0;\n  --pf-c-wizard__close--xl--Right: var(--pf-global--spacer--lg);\n  --pf-c-wizard__close--FontSize: var(--pf-global--FontSize--xl);\n  --pf-c-wizard__title--PaddingRight: var(--pf-global--spacer--2xl);\n  --pf-c-wizard__description--PaddingTop: var(--pf-global--spacer--sm);\n  --pf-c-wizard__description--Color: var(--pf-global--Color--light-200);\n  --pf-c-wizard__nav-link--Color: var(--pf-global--Color--100);\n  --pf-c-wizard__nav-link--TextDecoration: var(--pf-global--link--TextDecoration);\n  --pf-c-wizard__nav-link--hover--Color: var(--pf-global--link--Color);\n  --pf-c-wizard__nav-link--focus--Color: var(--pf-global--link--Color);\n  --pf-c-wizard__nav-link--m-current--Color: var(--pf-global--link--Color);\n  --pf-c-wizard__nav-link--m-current--FontWeight: var(--pf-global--FontWeight--normal);\n  --pf-c-wizard__nav-link--m-disabled--Color: var(--pf-global--Color--dark-200);\n  --pf-c-wizard__nav-list__nav-list__nav-link--m-current--FontWeight: var(--pf-global--FontWeight--normal);\n  --pf-c-wizard__nav-link-toggle--PaddingRight: var(--pf-global--spacer--sm);\n  --pf-c-wizard__nav-link-toggle--PaddingLeft: var(--pf-global--spacer--sm);\n  --pf-c-wizard__nav-link-toggle--Color: var(--pf-global--Color--200);\n  --pf-c-wizard__nav-link--hover__nav-link-toggle-icon--Color: var(--pf-global--Color--100);\n  --pf-c-wizard__nav-link--focus__nav-link-toggle-icon--Color: var(--pf-global--Color--100);\n  --pf-c-wizard__nav-link-toggle-icon--Transition: var(--pf-global--Transition);\n  --pf-c-wizard__nav-link-toggle-icon--Rotate: 0;\n  --pf-c-wizard__nav-item--m-expanded__link-toggle-icon--Rotate: 90deg;\n  --pf-c-wizard__nav-link--before--Width: 1.5rem;\n  --pf-c-wizard__nav-link--before--Height: 1.5rem;\n  --pf-c-wizard__nav-link--before--Top: 0;\n  --pf-c-wizard__nav-link--before--BackgroundColor: var(--pf-global--BackgroundColor--200);\n  --pf-c-wizard__nav-link--before--BorderRadius: var(--pf-global--BorderRadius--lg);\n  --pf-c-wizard__nav-link--before--Color: var(--pf-global--Color--100);\n  --pf-c-wizard__nav-link--before--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-wizard__nav-link--before--TranslateX: calc(-100% - var(--pf-global--spacer--sm));\n  --pf-c-wizard__nav-link--m-current--before--BackgroundColor: var(--pf-global--active-color--100);\n  --pf-c-wizard__nav-link--m-current--before--Color: var(--pf-global--Color--light-100);\n  --pf-c-wizard__nav-link--m-disabled--before--BackgroundColor: transparent;\n  --pf-c-wizard__nav-link--m-disabled--before--Color: var(--pf-global--Color--dark-200);\n  --pf-c-wizard__toggle--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-wizard__toggle--ZIndex: var(--pf-global--ZIndex--md);\n  --pf-c-wizard__toggle--BoxShadow: var(--pf-global--BoxShadow--md-bottom);\n  --pf-c-wizard__toggle--PaddingTop: var(--pf-global--spacer--lg);\n  --pf-c-wizard__toggle--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-wizard__toggle--PaddingBottom: var(--pf-global--spacer--lg);\n  --pf-c-wizard__toggle--PaddingLeft: calc(var(--pf-global--spacer--md) + var(--pf-c-wizard__nav-link--before--Width) + var(--pf-global--spacer--sm));\n  --pf-c-wizard__toggle--m-expanded--BorderBottomWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-wizard__toggle--m-expanded--BorderBottomColor: var(--pf-global--BorderColor--100);\n  --pf-c-wizard--m-in-page__toggle--xl--PaddingLeft: calc(var(--pf-global--spacer--xl) + var(--pf-c-wizard__nav-link--before--Width) + var(--pf-global--spacer--sm));\n  --pf-c-wizard__toggle-num--before--Top: 0;\n  --pf-c-wizard__toggle-list-item--not-last-child--MarginRight: var(--pf-global--spacer--sm);\n  --pf-c-wizard__toggle-list-item--MarginBottom: var(--pf-global--spacer--xs);\n  --pf-c-wizard__toggle-list--MarginRight: var(--pf-global--spacer--sm);\n  --pf-c-wizard__toggle-list--MarginBottom: calc(var(--pf-c-wizard__toggle-list-item--MarginBottom) * -1);\n  --pf-c-wizard__toggle-separator--MarginLeft: var(--pf-global--spacer--sm);\n  --pf-c-wizard__toggle-separator--Color: var(--pf-global--BorderColor--200);\n  --pf-c-wizard__toggle-icon--LineHeight: var(--pf-global--LineHeight--md);\n  --pf-c-wizard__toggle--m-expanded__toggle-icon--Rotate: 180deg;\n  --pf-c-wizard__nav--ZIndex: var(--pf-global--ZIndex--sm);\n  --pf-c-wizard__nav--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-wizard__nav--BoxShadow: var(--pf-global--BoxShadow--md-bottom);\n  --pf-c-wizard__nav--Width: 100%;\n  --pf-c-wizard__nav--lg--Width: 15.625rem;\n  --pf-c-wizard__nav--lg--BorderRightWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-wizard__nav--lg--BorderRightColor: var(--pf-global--BorderColor--100);\n  --pf-c-wizard__nav-list--PaddingTop: var(--pf-global--spacer--lg);\n  --pf-c-wizard__nav-list--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-wizard__nav-list--PaddingBottom: var(--pf-global--spacer--lg);\n  --pf-c-wizard__nav-list--PaddingLeft: calc(var(--pf-global--spacer--md) + var(--pf-c-wizard__nav-link--before--Width) + var(--pf-global--spacer--sm));\n  --pf-c-wizard__nav-list--lg--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-wizard__nav-list--lg--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-wizard__nav-list--lg--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-wizard__nav-list--xl--PaddingTop: var(--pf-global--spacer--lg);\n  --pf-c-wizard__nav-list--xl--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-wizard__nav-list--xl--PaddingBottom: var(--pf-global--spacer--lg);\n  --pf-c-wizard__nav-list--xl--PaddingLeft: calc(var(--pf-global--spacer--lg) + var(--pf-c-wizard__nav-link--before--Width) + var(--pf-global--spacer--sm));\n  --pf-c-wizard__nav-list--nested--MarginLeft: var(--pf-global--spacer--md);\n  --pf-c-wizard__nav-list--nested--MarginTop: var(--pf-global--spacer--md);\n  --pf-c-wizard__nav-item--MarginTop: var(--pf-global--spacer--md);\n  --pf-c-wizard__outer-wrap--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-wizard__outer-wrap--lg--PaddingLeft: var(--pf-c-wizard__nav--Width);\n  --pf-c-wizard__outer-wrap--MinHeight: 15.625rem;\n  --pf-c-wizard__main--ZIndex: var(--pf-global--ZIndex--xs);\n  --pf-c-wizard__main-body--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-wizard__main-body--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-wizard__main-body--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-wizard__main-body--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-wizard__main-body--xl--PaddingTop: var(--pf-global--spacer--lg);\n  --pf-c-wizard__main-body--xl--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-wizard__main-body--xl--PaddingBottom: var(--pf-global--spacer--lg);\n  --pf-c-wizard__main-body--xl--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-wizard__footer--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-wizard__footer--ZIndex: var(--pf-global--ZIndex--sm);\n  --pf-c-wizard__footer--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-wizard__footer--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-wizard__footer--PaddingBottom: var(--pf-global--spacer--sm);\n  --pf-c-wizard__footer--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-wizard__footer--xl--PaddingTop: var(--pf-global--spacer--lg);\n  --pf-c-wizard__footer--xl--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-wizard__footer--xl--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-wizard__footer--xl--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-wizard__footer--BoxShadow: var(--pf-global--BoxShadow--sm-top);\n  --pf-c-wizard__footer--child--MarginRight: var(--pf-global--spacer--md);\n  --pf-c-wizard__footer--child--MarginBottom: var(--pf-global--spacer--sm);\n  --pf-c-wizard__footer-cancel--MarginLeft: calc(var(--pf-global--spacer--2xl) - var(--pf-c-wizard__footer--child--MarginRight));\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  height: var(--pf-c-wizard--Height);\n}\n@media screen and (min-width: 992px) {\n  .pf-c-wizard {\n    --pf-c-wizard__header--PaddingRight: var(--pf-c-wizard__header--lg--PaddingRight);\n    --pf-c-wizard__header--PaddingLeft: var(--pf-c-wizard__header--lg--PaddingLeft);\n  }\n}\n@media screen and (min-width: 1200px) {\n  .pf-c-wizard {\n    --pf-c-wizard__header--PaddingRight: var(--pf-c-wizard__header--xl--PaddingRight);\n    --pf-c-wizard__header--PaddingLeft: var(--pf-c-wizard__header--xl--PaddingLeft);\n  }\n}\n@media screen and (min-width: 1200px) {\n  .pf-c-wizard {\n    --pf-c-wizard__close--Right: var(--pf-c-wizard__close--xl--Right);\n  }\n}\n@media screen and (min-width: 992px) {\n  .pf-c-wizard {\n    --pf-c-wizard__nav--Width: var(--pf-c-wizard__nav--lg--Width);\n    --pf-c-wizard__nav--BoxShadow: none;\n  }\n}\n@media screen and (min-width: 992px) {\n  .pf-c-wizard {\n    --pf-c-wizard__nav-list--PaddingTop: var(--pf-c-wizard__nav-list--lg--PaddingTop);\n    --pf-c-wizard__nav-list--PaddingRight: var(--pf-c-wizard__nav-list--lg--PaddingRight);\n    --pf-c-wizard__nav-list--PaddingBottom: var(--pf-c-wizard__nav-list--lg--PaddingBottom);\n  }\n}\n@media screen and (min-width: 1200px) {\n  .pf-c-wizard {\n    --pf-c-wizard__nav-list--PaddingTop: var(--pf-c-wizard__nav-list--xl--PaddingTop);\n    --pf-c-wizard__nav-list--PaddingRight: var(--pf-c-wizard__nav-list--xl--PaddingRight);\n    --pf-c-wizard__nav-list--PaddingBottom: var(--pf-c-wizard__nav-list--xl--PaddingBottom);\n    --pf-c-wizard__nav-list--PaddingLeft: var(--pf-c-wizard__nav-list--xl--PaddingLeft);\n  }\n}\n@media screen and (min-width: 1200px) {\n  .pf-c-wizard {\n    --pf-c-wizard__main-body--PaddingTop: var(--pf-c-wizard__main-body--xl--PaddingTop);\n    --pf-c-wizard__main-body--PaddingRight: var(--pf-c-wizard__main-body--xl--PaddingRight);\n    --pf-c-wizard__main-body--PaddingBottom: var(--pf-c-wizard__main-body--xl--PaddingBottom);\n    --pf-c-wizard__main-body--PaddingLeft: var(--pf-c-wizard__main-body--xl--PaddingLeft);\n  }\n}\n@media screen and (min-width: 1200px) {\n  .pf-c-wizard {\n    --pf-c-wizard__footer--PaddingTop: var(--pf-c-wizard__footer--xl--PaddingTop);\n    --pf-c-wizard__footer--PaddingRight: var(--pf-c-wizard__footer--xl--PaddingRight);\n    --pf-c-wizard__footer--PaddingBottom: var(--pf-c-wizard__footer--xl--PaddingBottom);\n    --pf-c-wizard__footer--PaddingLeft: var(--pf-c-wizard__footer--xl--PaddingLeft);\n  }\n}\n.pf-c-modal-box .pf-c-wizard {\n  flex: 1 1 var(--pf-c-modal-box--c-wizard--FlexBasis);\n  min-height: 0;\n}\n.pf-c-wizard > :not(.pf-c-wizard__outer-wrap):not(.pf-c-drawer) {\n  flex-shrink: 0;\n}\n.pf-c-wizard.pf-m-finished {\n  --pf-c-wizard__outer-wrap--lg--PaddingLeft: 0;\n}\n.pf-c-wizard.pf-m-finished .pf-c-wizard__nav,\n.pf-c-wizard.pf-m-finished .pf-c-wizard__footer,\n.pf-c-wizard.pf-m-finished .pf-c-wizard__toggle {\n  display: none;\n  visibility: hidden;\n}\n\n.pf-c-wizard__header {\n  color: var(--pf-global--Color--100);\n  position: relative;\n  z-index: var(--pf-c-wizard__header--ZIndex);\n  padding: var(--pf-c-wizard__header--PaddingTop) var(--pf-c-wizard__header--PaddingRight) var(--pf-c-wizard__header--PaddingBottom) var(--pf-c-wizard__header--PaddingLeft);\n  background-color: var(--pf-c-wizard__header--BackgroundColor);\n}\n.pf-c-wizard__header .pf-c-wizard__close {\n  position: absolute;\n  top: var(--pf-c-wizard__close--Top);\n  right: var(--pf-c-wizard__close--Right);\n  font-size: var(--pf-c-wizard__close--FontSize);\n}\n\n.pf-c-wizard__title {\n  padding-right: var(--pf-c-wizard__title--PaddingRight);\n  word-wrap: break-word;\n}\n\n.pf-c-wizard__description {\n  display: none;\n  padding-top: var(--pf-c-wizard__description--PaddingTop);\n  color: var(--pf-c-wizard__description--Color);\n  visibility: hidden;\n}\n@media screen and (min-width: 992px) {\n  .pf-c-wizard__description {\n    display: block;\n    visibility: visible;\n  }\n}\n\n.pf-c-wizard__toggle {\n  position: relative;\n  z-index: var(--pf-c-wizard__toggle--ZIndex);\n  display: flex;\n  justify-content: space-between;\n  width: 100%;\n  padding: var(--pf-c-wizard__toggle--PaddingTop) var(--pf-c-wizard__toggle--PaddingRight) var(--pf-c-wizard__toggle--PaddingBottom) var(--pf-c-wizard__toggle--PaddingLeft);\n  background-color: var(--pf-c-wizard__toggle--BackgroundColor);\n  border: 0;\n  box-shadow: var(--pf-c-wizard__toggle--BoxShadow);\n}\n@media screen and (min-width: 992px) {\n  .pf-c-wizard__toggle {\n    display: none;\n    visibility: hidden;\n  }\n}\n.pf-c-wizard__toggle.pf-m-expanded {\n  --pf-c-wizard__toggle--BoxShadow: none;\n  border-bottom: var(--pf-c-wizard__toggle--m-expanded--BorderBottomWidth) solid var(--pf-c-wizard__toggle--m-expanded--BorderBottomColor);\n}\n.pf-c-wizard__toggle.pf-m-expanded .pf-c-wizard__toggle-icon {\n  transform: rotate(var(--pf-c-wizard__toggle--m-expanded__toggle-icon--Rotate));\n}\n\n.pf-c-wizard__toggle-list {\n  position: relative;\n  display: flex;\n  flex-wrap: wrap;\n  align-items: baseline;\n  margin-right: var(--pf-c-wizard__toggle-list--MarginRight);\n  margin-bottom: var(--pf-c-wizard__toggle-list--MarginBottom);\n  list-style: none;\n}\n\n.pf-c-wizard__toggle-list-item {\n  margin-bottom: var(--pf-c-wizard__toggle-list-item--MarginBottom);\n  text-align: left;\n  word-break: break-word;\n}\n.pf-c-wizard__toggle-list-item:not(:last-child) {\n  margin-right: var(--pf-c-wizard__toggle-list-item--not-last-child--MarginRight);\n}\n\n.pf-c-wizard__toggle-num {\n  --pf-c-wizard__nav-link--before--Top: var(--pf-c-wizard__toggle-num--before--Top);\n}\n\n.pf-c-wizard__toggle-separator {\n  margin-left: var(--pf-c-wizard__toggle-separator--MarginLeft);\n  color: var(--pf-c-wizard__toggle-separator--Color);\n}\n\n.pf-c-wizard__toggle-icon {\n  line-height: var(--pf-c-wizard__toggle-icon--LineHeight);\n}\n\n.pf-c-wizard__outer-wrap {\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  flex-grow: 1;\n  min-height: var(--pf-c-wizard__outer-wrap--MinHeight);\n  background-color: var(--pf-c-wizard__outer-wrap--BackgroundColor);\n}\n@media screen and (min-width: 992px) {\n  .pf-c-wizard__outer-wrap {\n    padding-left: var(--pf-c-wizard__outer-wrap--lg--PaddingLeft);\n  }\n}\n\n.pf-c-wizard__inner-wrap {\n  position: relative;\n  display: flex;\n  flex-direction: column;\n  flex-grow: 1;\n  min-height: 0;\n}\n@media screen and (min-width: 992px) {\n  .pf-c-wizard__inner-wrap {\n    position: static;\n  }\n}\n\n.pf-c-wizard__nav {\n  position: absolute;\n  top: 0;\n  left: 0;\n  z-index: var(--pf-c-wizard__nav--ZIndex);\n  display: none;\n  width: var(--pf-c-wizard__nav--Width);\n  max-height: 100%;\n  overflow-y: auto;\n  -webkit-overflow-scrolling: touch;\n  visibility: hidden;\n  background-color: var(--pf-c-wizard__nav--BackgroundColor);\n  box-shadow: var(--pf-c-wizard__nav--BoxShadow);\n}\n.pf-c-wizard__nav.pf-m-expanded {\n  display: block;\n  visibility: visible;\n}\n@media screen and (min-width: 992px) {\n  .pf-c-wizard__nav {\n    display: block;\n    height: 100%;\n    visibility: visible;\n    border-right: var(--pf-c-wizard__nav--lg--BorderRightWidth) solid var(--pf-c-wizard__nav--lg--BorderRightColor);\n  }\n}\n\n.pf-c-wizard__nav-list {\n  padding-top: var(--pf-c-wizard__nav-list--PaddingTop);\n  padding-right: var(--pf-c-wizard__nav-list--PaddingRight);\n  padding-bottom: var(--pf-c-wizard__nav-list--PaddingBottom);\n  padding-left: var(--pf-c-wizard__nav-list--PaddingLeft);\n  list-style: none;\n  counter-reset: wizard-nav-count;\n}\n.pf-c-wizard__nav-list .pf-c-wizard__nav-list {\n  padding: 0;\n  margin-top: var(--pf-c-wizard__nav-list--nested--MarginTop);\n  margin-left: var(--pf-c-wizard__nav-list--nested--MarginLeft);\n}\n.pf-c-wizard__nav-list .pf-c-wizard__nav-list .pf-c-wizard__nav-link::before {\n  content: none;\n}\n.pf-c-wizard__nav-list .pf-c-wizard__nav-list .pf-c-wizard__nav-link.pf-m-current {\n  font-weight: var(--pf-c-wizard__nav-list__nav-list__nav-link--m-current--FontWeight);\n}\n\n.pf-c-wizard__nav-item + .pf-c-wizard__nav-item {\n  margin-top: var(--pf-c-wizard__nav-item--MarginTop);\n}\n.pf-c-wizard__nav-item.pf-m-expandable > .pf-c-wizard__nav-link {\n  display: flex;\n}\n.pf-c-wizard__nav-item.pf-m-expandable > .pf-c-wizard__nav-list {\n  display: none;\n  visibility: hidden;\n}\n.pf-c-wizard__nav-item.pf-m-expanded > .pf-c-wizard__nav-list {\n  display: block;\n  visibility: visible;\n}\n.pf-c-wizard__nav-item.pf-m-expanded > .pf-c-wizard__nav-link {\n  --pf-c-wizard__nav-link-toggle-icon--Rotate: var(--pf-c-wizard__nav-item--m-expanded__link-toggle-icon--Rotate);\n}\n\n.pf-c-wizard__nav-link {\n  position: relative;\n  display: inline-block;\n  width: 100%;\n  color: var(--pf-c-wizard__nav-link--Color);\n  text-align: left;\n  text-decoration: var(--pf-c-wizard__nav-link--TextDecoration);\n  word-break: break-word;\n  border: 0;\n}\n.pf-c-wizard__toggle-num, .pf-c-wizard__nav-link::before {\n  position: absolute;\n  top: var(--pf-c-wizard__nav-link--before--Top);\n  left: 0;\n  display: inline-flex;\n  align-items: center;\n  justify-content: center;\n  width: var(--pf-c-wizard__nav-link--before--Width);\n  height: var(--pf-c-wizard__nav-link--before--Height);\n  font-size: var(--pf-c-wizard__nav-link--before--FontSize);\n  line-height: 1;\n  color: var(--pf-c-wizard__nav-link--before--Color);\n  background-color: var(--pf-c-wizard__nav-link--before--BackgroundColor);\n  border-radius: var(--pf-c-wizard__nav-link--before--BorderRadius);\n  transform: translateX(var(--pf-c-wizard__nav-link--before--TranslateX));\n}\n\n.pf-c-wizard__nav-link::before {\n  top: 0;\n  content: counter(wizard-nav-count);\n  counter-increment: wizard-nav-count;\n}\n.pf-c-wizard__nav-link:hover {\n  --pf-c-wizard__nav-link--Color: var(--pf-c-wizard__nav-link--hover--Color);\n  --pf-c-wizard__nav-link-toggle--Color: var(--pf-c-wizard__nav-link--hover__nav-link-toggle-icon--Color);\n}\n.pf-c-wizard__nav-link:focus {\n  --pf-c-wizard__nav-link--Color: var(--pf-c-wizard__nav-link--focus--Color);\n  --pf-c-wizard__nav-link-toggle--Color: var(--pf-c-wizard__nav-link--focus__nav-link-toggle-icon--Color);\n}\n.pf-c-wizard__nav-link.pf-m-current {\n  --pf-c-wizard__nav-link--Color: var(--pf-c-wizard__nav-link--m-current--Color);\n  font-weight: var(--pf-c-wizard__nav-link--m-current--FontWeight);\n}\n.pf-c-wizard__toggle-num, .pf-c-wizard__nav-link.pf-m-current::before {\n  --pf-c-wizard__nav-link--before--BackgroundColor: var(--pf-c-wizard__nav-link--m-current--before--BackgroundColor);\n  --pf-c-wizard__nav-link--before--Color: var(--pf-c-wizard__nav-link--m-current--before--Color);\n}\n\n.pf-c-wizard__nav-link:disabled, .pf-c-wizard__nav-link.pf-m-disabled {\n  --pf-c-wizard__nav-link--Color: var(--pf-c-wizard__nav-link--m-disabled--Color);\n  pointer-events: none;\n}\n.pf-c-wizard__nav-link:disabled::before, .pf-c-wizard__nav-link.pf-m-disabled::before {\n  --pf-c-wizard__nav-link--before--BackgroundColor: var(--pf-c-wizard__nav-link--m-disabled--before--BackgroundColor);\n  --pf-c-wizard__nav-link--before--Color: var(--pf-c-wizard__nav-link--m-disabled--before--Color);\n}\n\n.pf-c-wizard__nav-link-text {\n  flex-grow: 1;\n}\n\n.pf-c-wizard__nav-link-toggle {\n  padding-right: var(--pf-c-wizard__nav-link-toggle--PaddingRight);\n  padding-left: var(--pf-c-wizard__nav-link-toggle--PaddingLeft);\n  color: var(--pf-c-wizard__nav-link-toggle--Color);\n}\n\n.pf-c-wizard__nav-link-toggle-icon {\n  display: inline-block;\n  transition: var(--pf-c-wizard__nav-link-toggle-icon--Transition);\n  transform: rotate(var(--pf-c-wizard__nav-link-toggle-icon--Rotate));\n}\n\n.pf-c-wizard__main {\n  z-index: var(--pf-c-wizard__main--ZIndex);\n  flex: 1 1 auto;\n  overflow-x: hidden;\n  overflow-y: auto;\n  word-break: break-word;\n}\n\n.pf-c-wizard__main-body {\n  padding: var(--pf-c-wizard__main-body--PaddingTop) var(--pf-c-wizard__main-body--PaddingRight) var(--pf-c-wizard__main-body--PaddingBottom) var(--pf-c-wizard__main-body--PaddingLeft);\n}\n.pf-c-wizard__main-body.pf-m-no-padding {\n  padding: 0;\n}\n\n.pf-c-wizard__footer {\n  position: relative;\n  z-index: var(--pf-c-wizard__footer--ZIndex);\n  display: flex;\n  flex-wrap: wrap;\n  flex-shrink: 0;\n  padding: var(--pf-c-wizard__footer--PaddingTop) var(--pf-c-wizard__footer--PaddingRight) var(--pf-c-wizard__footer--PaddingBottom) var(--pf-c-wizard__footer--PaddingLeft);\n  background-color: var(--pf-c-wizard__footer--BackgroundColor);\n}\n.pf-c-wizard__footer > * {\n  margin-bottom: var(--pf-c-wizard__footer--child--MarginBottom);\n}\n.pf-c-wizard__footer > *:not(:last-child) {\n  margin-right: var(--pf-c-wizard__footer--child--MarginRight);\n}\n.pf-c-page__main-wizard .pf-c-wizard__footer, .pf-c-modal-box .pf-c-wizard__footer, .pf-c-drawer > .pf-c-wizard__footer {\n  box-shadow: var(--pf-c-wizard__footer--BoxShadow);\n}\n\n.pf-c-wizard__footer-cancel {\n  margin-left: var(--pf-c-wizard__footer-cancel--MarginLeft);\n}\n\n:where(.pf-theme-dark) .pf-c-wizard__header {\n  --pf-global--Color--100: #e0e0e0;\n  --pf-global--Color--200: #aaabac;\n  --pf-global--BorderColor--100: #444548;\n  --pf-global--primary-color--100: #1fa7f8;\n  --pf-global--link--Color: #1fa7f8;\n  --pf-global--link--Color--hover: #73bcf7;\n  --pf-global--BackgroundColor--100: #1b1d21;\n}\n:where(.pf-theme-dark) .pf-c-wizard__header .pf-c-card {\n  --pf-c-card--BackgroundColor: var(--pf-global--BackgroundColor--100);\n}\n:where(.pf-theme-dark) .pf-c-wizard__header .pf-c-button {\n  --pf-c-button--m-primary--Color: var(--pf-global--Color--light-100);\n  --pf-c-button--m-primary--hover--Color: var(--pf-global--Color--light-100);\n  --pf-c-button--m-primary--focus--Color: var(--pf-global--Color--light-100);\n  --pf-c-button--m-primary--active--Color: var(--pf-global--Color--light-100);\n  --pf-c-button--m-primary--BackgroundColor: var(--pf-global--primary-color--300);\n  --pf-c-button--m-primary--hover--BackgroundColor: var(--pf-global--primary-color--200);\n  --pf-c-button--m-primary--focus--BackgroundColor: var(--pf-global--primary-color--200);\n  --pf-c-button--m-primary--active--BackgroundColor: var(--pf-global--primary-color--200);\n  --pf-c-button--m-secondary--Color: var(--pf-global--primary-color--100);\n  --pf-c-button--m-secondary--hover--Color: var(--pf-global--primary-color--100);\n  --pf-c-button--m-secondary--focus--Color: var(--pf-global--primary-color--100);\n  --pf-c-button--m-secondary--active--Color: var(--pf-global--primary-color--100);\n}\n\n:where(.pf-theme-dark) .pf-c-wizard {\n  --pf-c-wizard__header--BackgroundColor: var(--pf-global--palette--black-1000);\n  --pf-c-wizard__nav-link--before--BackgroundColor: var(--pf-global--palette--black-500);\n  --pf-c-wizard__nav-link--m-disabled--Color: var(--pf-global--disabled-color--300);\n  --pf-c-wizard__nav-link--m-disabled--before--Color: var(--pf-global--disabled-color--300);\n}\n:where(.pf-theme-dark) .pf-c-wizard__header {\n  color: var(--pf-global--Color--100);\n}";

// node_modules/@patternfly/patternfly/components/ProgressStepper/progress-stepper.css
var progress_stepper_default = '.pf-c-progress-stepper {\n  --pf-c-progress-stepper--m-vertical--GridAutoFlow: row;\n  --pf-c-progress-stepper--m-vertical--GridTemplateColumns: auto 1fr;\n  --pf-c-progress-stepper--m-vertical__step-connector--before--Top: 0;\n  --pf-c-progress-stepper--m-vertical__step-connector--before--Left: calc(var(--pf-c-progress-stepper__step-icon--Width) / 2);\n  --pf-c-progress-stepper--m-vertical__step-connector--before--Width: auto;\n  --pf-c-progress-stepper--m-vertical__step-connector--before--Height: 100%;\n  --pf-c-progress-stepper--m-vertical__step-connector--before--BorderRightWidth: var(--pf-global--BorderWidth--md);\n  --pf-c-progress-stepper--m-vertical__step-connector--before--BorderRightColor: var(--pf-global--BorderColor--100);\n  --pf-c-progress-stepper--m-vertical__step-connector--before--BorderBottomWidth: 0;\n  --pf-c-progress-stepper--m-vertical__step-connector--before--BorderBottomColor: transparent;\n  --pf-c-progress-stepper--m-vertical__step-connector--before--Transform: translateX(-50%);\n  --pf-c-progress-stepper--m-vertical__step-main--MarginTop: var(--pf-global--spacer--xs);\n  --pf-c-progress-stepper--m-vertical__step-main--MarginRight: 0;\n  --pf-c-progress-stepper--m-vertical__step-main--MarginBottom: var(--pf-global--spacer--xl);\n  --pf-c-progress-stepper--m-vertical__step-main--MarginLeft: var(--pf-global--spacer--xs);\n  --pf-c-progress-stepper--m-vertical--m-compact--GridTemplateColumns: 1fr;\n  --pf-c-progress-stepper--m-vertical--m-compact__step-connector--PaddingBottom: var(--pf-global--spacer--sm);\n  --pf-c-progress-stepper--m-vertical--m-compact__step-connector--GridRow: auto;\n  --pf-c-progress-stepper--m-vertical--m-compact__step-main--MarginRight: 0;\n  --pf-c-progress-stepper--m-vertical--m-center__step-main--MarginRight: 0;\n  --pf-c-progress-stepper--m-vertical--m-center__step-main--MarginLeft: 0;\n  --pf-c-progress-stepper--m-horizontal--GridAutoFlow: column;\n  --pf-c-progress-stepper--m-horizontal--GridTemplateColumns: initial;\n  --pf-c-progress-stepper--m-horizontal__step-connector--before--Top: calc(var(--pf-c-progress-stepper__step-icon--Height) / 2);\n  --pf-c-progress-stepper--m-horizontal__step-connector--before--Left: 0;\n  --pf-c-progress-stepper--m-horizontal__step-connector--before--Width: 100%;\n  --pf-c-progress-stepper--m-horizontal__step-connector--before--Height: auto;\n  --pf-c-progress-stepper--m-horizontal__step-connector--before--BorderRightWidth: 0;\n  --pf-c-progress-stepper--m-horizontal__step-connector--before--BorderRightColor: unset;\n  --pf-c-progress-stepper--m-horizontal__step-connector--before--BorderBottomWidth: var(--pf-global--BorderWidth--md);\n  --pf-c-progress-stepper--m-horizontal__step-connector--before--BorderBottomColor: var(--pf-global--BorderColor--100);\n  --pf-c-progress-stepper--m-horizontal__step-connector--before--Transform: translateY(-50%);\n  --pf-c-progress-stepper--m-horizontal__step-main--MarginTop: var(--pf-global--spacer--sm);\n  --pf-c-progress-stepper--m-horizontal__step-main--MarginRight: var(--pf-global--spacer--sm);\n  --pf-c-progress-stepper--m-horizontal__step-main--MarginBottom: 0;\n  --pf-c-progress-stepper--m-horizontal__step-main--MarginLeft: 0;\n  --pf-c-progress-stepper--m-horizontal--m-compact--GridTemplateColumns: repeat(auto-fill, 1.75rem);\n  --pf-c-progress-stepper--m-horizontal--m-compact__step-connector--PaddingBottom: 0;\n  --pf-c-progress-stepper--m-horizontal--m-compact__step-connector--GridRow: 2;\n  --pf-c-progress-stepper--m-compact--GridAutoFlow: row;\n  --pf-c-progress-stepper--m-compact__step-main--MarginTop: 0;\n  --pf-c-progress-stepper--m-compact__step-main--MarginBottom: var(--pf-global--spacer--sm);\n  --pf-c-progress-stepper--m-compact__step-connector--MinWidth: 1.75rem;\n  --pf-c-progress-stepper--m-compact__step-icon--Width: 1.125rem;\n  --pf-c-progress-stepper--m-compact__step-icon--FontSize: var(--pf-global--icon--FontSize--sm);\n  --pf-c-progress-stepper--m-compact__step-title--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-progress-stepper--m-compact__step-title--FontWeight: var(--pf-global--FontWeight--normal);\n  --pf-c-progress-stepper--m-compact__pficon--MarginTop: 2px;\n  --pf-c-progress-stepper--m-compact__fa-exclamation-triangle--MarginTop: -3px;\n  --pf-c-progress-stepper--m-center__step-connector--before--Left: 50%;\n  --pf-c-progress-stepper--m-center--GridTemplateColumns: 1fr;\n  --pf-c-progress-stepper--m-center__step-connector--JustifyContent: center;\n  --pf-c-progress-stepper--m-center__step-main--MarginRight: var(--pf-global--spacer--xs);\n  --pf-c-progress-stepper--m-center__step-main--MarginLeft: var(--pf-global--spacer--xs);\n  --pf-c-progress-stepper--m-center__step-main--TextAlign: center;\n  --pf-c-progress-stepper--m-center__step-description--MarginRight: 0;\n  --pf-c-progress-stepper--m-center__step-description--MarginLeft: 0;\n  --pf-c-progress-stepper--GridTemplateRows: auto 1fr;\n  --pf-c-progress-stepper__step-connector--JustifyContent: start;\n  --pf-c-progress-stepper__step-icon--ZIndex: var(--pf-global--ZIndex--xs);\n  --pf-c-progress-stepper__step-icon--Width: 1.75rem;\n  --pf-c-progress-stepper__step-icon--Height: var(--pf-c-progress-stepper__step-icon--Width);\n  --pf-c-progress-stepper__step-icon--FontSize: var(--pf-global--icon--FontSize--md);\n  --pf-c-progress-stepper__step-icon--Color: var(--pf-global--Color--100);\n  --pf-c-progress-stepper__step-icon--BackgroundColor: var(--pf-global--BackgroundColor--light-200);\n  --pf-c-progress-stepper__step-icon--BorderWidth: var(--pf-global--BorderWidth--md);\n  --pf-c-progress-stepper__step-icon--BorderColor: var(--pf-global--BorderColor--100);\n  --pf-c-progress-stepper__pficon--MarginTop: 3px;\n  --pf-c-progress-stepper__fa-exclamation-triangle--MarginTop: -5px;\n  --pf-c-progress-stepper__step-title--Color: var(--pf-global--Color--100);\n  --pf-c-progress-stepper__step-title--TextAlign: left;\n  --pf-c-progress-stepper__step-title--FontSize: var(--pf-global--FontSize--md);\n  --pf-c-progress-stepper__step-title--FontWeight: var(--pf-global--FontWeight--normal);\n  --pf-c-progress-stepper__step--m-current__step-title--FontWeight: var(--pf-global--FontWeight--bold);\n  --pf-c-progress-stepper__step--m-current__step-title--Color: var(--pf-global--Color--100);\n  --pf-c-progress-stepper__step--m-pending__step-title--Color: var(--pf-global--Color--200);\n  --pf-c-progress-stepper__step--m-danger__step-title--Color: var(--pf-global--danger-color--100);\n  --pf-c-progress-stepper__step-title--m-help-text--TextDecorationColor: var(--pf-global--BorderColor--200);\n  --pf-c-progress-stepper__step-title--m-help-text--TextDecorationThickness: var(--pf-global--BorderWidth--sm);\n  --pf-c-progress-stepper__step-title--m-help-text--TextUnderlineOffset: 0.25rem;\n  --pf-c-progress-stepper__step-title--m-help-text--hover--TextDecorationColor: var(--pf-global--Color--100);\n  --pf-c-progress-stepper__step-title--m-help-text--focus--TextDecorationColor: var(--pf-global--Color--100);\n  --pf-c-progress-stepper__step-title--m-help-text--hover--Color: var(--pf-global--Color--100);\n  --pf-c-progress-stepper__step-title--m-help-text--focus--Color: var(--pf-global--Color--100);\n  --pf-c-progress-stepper__step--m-danger__step-title--m-help-text--hover--Color: var(--pf-global--danger-color--200);\n  --pf-c-progress-stepper__step--m-danger__step-title--m-help-text--focus--Color: var(--pf-global--danger-color--200);\n  --pf-c-progress-stepper__step--m-danger__step-title--m-help-text--TextDecorationColor: var(--pf-global--danger-color--100);\n  --pf-c-progress-stepper__step--m-danger__step-title--m-help-text--hover--TextDecorationColor: var(--pf-global--danger-color--200);\n  --pf-c-progress-stepper__step--m-danger__step-title--m-help-text--focus--TextDecorationColor: var(--pf-global--danger-color--200);\n  --pf-c-progress-stepper__step-description--MarginTop: var(--pf-global--spacer--xs);\n  --pf-c-progress-stepper__step-description--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-progress-stepper__step-description--Color: var(--pf-global--Color--200);\n  --pf-c-progress-stepper__step-description--TextAlign: left;\n  --pf-c-progress-stepper--GridAutoFlow: var(--pf-c-progress-stepper--m-vertical--GridAutoFlow);\n  --pf-c-progress-stepper--GridTemplateColumns: var(--pf-c-progress-stepper--m-vertical--GridTemplateColumns);\n  --pf-c-progress-stepper__step-connector--before--Top: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Top);\n  --pf-c-progress-stepper__step-connector--before--Left: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Left);\n  --pf-c-progress-stepper__step-connector--before--Width: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Width);\n  --pf-c-progress-stepper__step-connector--before--Height: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Height);\n  --pf-c-progress-stepper__step-connector--before--BorderRightWidth: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderRightWidth);\n  --pf-c-progress-stepper__step-connector--before--BorderRightColor: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderRightColor);\n  --pf-c-progress-stepper__step-connector--before--BorderBottomWidth: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderBottomWidth);\n  --pf-c-progress-stepper__step-connector--before--BorderBottomColor: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderBottomColor);\n  --pf-c-progress-stepper__step-connector--before--Transform: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Transform);\n  --pf-c-progress-stepper__step-main--MarginTop: var(--pf-c-progress-stepper--m-vertical__step-main--MarginTop);\n  --pf-c-progress-stepper__step-main--MarginRight: var(--pf-c-progress-stepper--m-vertical__step-main--MarginRight);\n  --pf-c-progress-stepper__step-main--MarginBottom: var(--pf-c-progress-stepper--m-vertical__step-main--MarginBottom);\n  --pf-c-progress-stepper__step-main--MarginLeft: var(--pf-c-progress-stepper--m-vertical__step-main--MarginLeft);\n  --pf-c-progress-stepper--m-compact--GridTemplateColumns: var(--pf-c-progress-stepper--m-vertical--m-compact--GridTemplateColumns);\n  --pf-c-progress-stepper--m-compact__step-connector--GridRow: var(--pf-c-progress-stepper--m-vertical--m-compact__step-connector--GridRow);\n  --pf-c-progress-stepper--m-compact__step-connector--PaddingBottom: var(--pf-c-progress-stepper--m-vertical--m-compact__step-connector--PaddingBottom);\n  --pf-c-progress-stepper--m-center__step-connector--before--Content: none;\n  --pf-c-progress-stepper--m-center__step-main--before--Content: "";\n  position: relative;\n  display: grid;\n  grid-auto-flow: var(--pf-c-progress-stepper--GridAutoFlow);\n  grid-template-columns: var(--pf-c-progress-stepper--GridTemplateColumns);\n  grid-template-rows: var(--pf-c-progress-stepper--GridTemplateRows);\n  grid-auto-columns: 1fr;\n}\n@media screen and (min-width: 768px) {\n  .pf-c-progress-stepper {\n    --pf-c-progress-stepper--GridAutoFlow: var(--pf-c-progress-stepper--m-horizontal--GridAutoFlow);\n    --pf-c-progress-stepper--GridTemplateColumns: var(--pf-c-progress-stepper--m-horizontal--GridTemplateColumns);\n    --pf-c-progress-stepper__step-connector--before--Top: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Top);\n    --pf-c-progress-stepper__step-connector--before--Left: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Left);\n    --pf-c-progress-stepper__step-connector--before--Width: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Width);\n    --pf-c-progress-stepper__step-connector--before--Height: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Height);\n    --pf-c-progress-stepper__step-connector--before--BorderRightWidth: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderRightWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderRightColor: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderRightColor);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomWidth: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderBottomWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomColor: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderBottomColor);\n    --pf-c-progress-stepper__step-connector--before--Transform: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Transform);\n    --pf-c-progress-stepper__step-main--MarginTop: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginTop);\n    --pf-c-progress-stepper__step-main--MarginRight: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginRight);\n    --pf-c-progress-stepper__step-main--MarginBottom: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginBottom);\n    --pf-c-progress-stepper__step-main--MarginLeft: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginLeft);\n    --pf-c-progress-stepper--m-compact--GridTemplateColumns: var(--pf-c-progress-stepper--m-horizontal--m-compact--GridTemplateColumns);\n    --pf-c-progress-stepper--m-compact__step-connector--GridRow: var(--pf-c-progress-stepper--m-horizontal--m-compact__step-connector--GridRow);\n    --pf-c-progress-stepper--m-compact__step-connector--PaddingBottom: var(--pf-c-progress-stepper--m-horizontal--m-compact__step-connector--PaddingBottom);\n    --pf-c-progress-stepper--m-center__step-connector--before--Content: "";\n    --pf-c-progress-stepper--m-center__step-main--before--Content: none;\n  }\n}\n.pf-c-progress-stepper.pf-m-center {\n  --pf-c-progress-stepper__step-connector--JustifyContent: var(--pf-c-progress-stepper--m-center__step-connector--JustifyContent);\n  --pf-c-progress-stepper__step-main--MarginRight: var(--pf-c-progress-stepper--m-center__step-main--MarginRight);\n  --pf-c-progress-stepper__step-main--MarginLeft: var(--pf-c-progress-stepper--m-center__step-main--MarginLeft);\n  --pf-c-progress-stepper--step-main--TextAlign: var(--pf-c-progress-stepper--m-center__step-main--TextAlign, auto);\n  --pf-c-progress-stepper__step-title--TextAlign: var(--pf-c-progress-stepper--m-center__step-title--TextAlign, auto);\n  --pf-c-progress-stepper__step-description--MarginRight: var(--pf-c-progress-stepper--m-center__step-description--MarginRight);\n  --pf-c-progress-stepper__step-description--MarginLeft: var(--pf-c-progress-stepper--m-center__step-description--MarginLeft);\n  --pf-c-progress-stepper__step-description--TextAlign: var(--pf-c-progress-stepper--m-center__step-description--TextAlign, auto);\n  --pf-c-progress-stepper--m-vertical__step-main--MarginRight: var(--pf-c-progress-stepper--m-vertical--m-center__step-main--MarginRight);\n  --pf-c-progress-stepper--m-vertical__step-main--MarginLeft: var(--pf-c-progress-stepper--m-vertical--m-center__step-main--MarginLeft);\n  grid-template-columns: var(--pf-c-progress-stepper--m-center--GridTemplateColumns);\n}\n.pf-c-progress-stepper.pf-m-center .pf-c-progress-stepper__step-main {\n  position: relative;\n}\n.pf-c-progress-stepper.pf-m-center .pf-c-progress-stepper__step:not(:last-of-type) > .pf-c-progress-stepper__step-connector::before {\n  left: var(--pf-c-progress-stepper--m-center__step-connector--before--Left);\n}\n.pf-c-progress-stepper.pf-m-center:not(.pf-m-compact) .pf-c-progress-stepper__step:not(:last-of-type) > .pf-c-progress-stepper__step-main::before {\n  content: var(--pf-c-progress-stepper--m-center__step-main--before--Content);\n}\n.pf-c-progress-stepper.pf-m-center:not(.pf-m-compact) .pf-c-progress-stepper__step:not(:last-of-type) > .pf-c-progress-stepper__step-connector::before {\n  content: var(--pf-c-progress-stepper--m-center__step-connector--before--Content);\n}\n.pf-c-progress-stepper.pf-m-compact {\n  --pf-c-progress-stepper__step-main--MarginTop: var(--pf-c-progress-stepper--m-compact__step-main--MarginTop);\n  --pf-c-progress-stepper__step-main--MarginBottom: var(--pf-c-progress-stepper--m-compact__step-main--MarginBottom);\n  --pf-c-progress-stepper__step-icon--Width: var(--pf-c-progress-stepper--m-compact__step-icon--Width);\n  --pf-c-progress-stepper__step-icon--FontSize: var(--pf-c-progress-stepper--m-compact__step-icon--FontSize);\n  --pf-c-progress-stepper__step-title--FontSize: var(--pf-c-progress-stepper--m-compact__step-title--FontSize);\n  --pf-c-progress-stepper__step--m-current__step-title--FontWeight: var(--pf-c-progress-stepper--m-compact__step-title--FontWeight);\n  --pf-c-progress-stepper__pficon--MarginTop: var(--pf-c-progress-stepper--m-compact__pficon--MarginTop);\n  --pf-c-progress-stepper__fa-exclamation-triangle--MarginTop: var(--pf-c-progress-stepper--m-compact__fa-exclamation-triangle--MarginTop);\n  --pf-c-progress-stepper--m-vertical__step-main--MarginLeft: var(--pf-c-progress-stepper--m-vertical--m-compact__step-main--MarginLeft);\n  --pf-c-progress-stepper--m-vertical__step-main--MarginRight: var(--pf-c-progress-stepper--m-vertical--m-compact__step-main--MarginRight);\n  display: inline-grid;\n  grid-template-columns: var(--pf-c-progress-stepper--m-compact--GridTemplateColumns);\n  grid-auto-flow: var(--pf-c-progress-stepper--m-compact--GridAutoFlow);\n}\n.pf-c-progress-stepper.pf-m-compact .pf-c-progress-stepper__step-connector {\n  min-width: var(--pf-c-progress-stepper--m-compact__step-connector--MinWidth);\n  grid-row: var(--pf-c-progress-stepper--m-compact__step-connector--GridRow);\n  padding-bottom: var(--pf-c-progress-stepper--m-compact__step-connector--PaddingBottom);\n}\n.pf-c-progress-stepper.pf-m-compact .pf-c-progress-stepper__step-main {\n  margin-bottom: var(--pf-c-progress-stepper--m-compact__step-main--MarginBottom);\n}\n.pf-c-progress-stepper.pf-m-compact .pf-c-progress-stepper__step:not(.pf-m-current) .pf-c-progress-stepper__step-main {\n  position: fixed;\n  top: 0;\n  left: 0;\n  overflow: hidden;\n  clip: rect(0, 0, 0, 0);\n  white-space: nowrap;\n  border: 0;\n}\n.pf-c-progress-stepper.pf-m-compact .pf-c-progress-stepper__step.pf-m-current .pf-c-progress-stepper__step-main {\n  grid-column: 1/-1;\n  grid-row: 1/2;\n}\n.pf-c-progress-stepper.pf-m-compact .pf-c-progress-stepper__step-description {\n  display: none;\n}\n\n.pf-c-progress-stepper__step {\n  display: contents;\n}\n.pf-c-progress-stepper__step.pf-m-current {\n  --pf-c-progress-stepper__step-title--FontWeight: var(--pf-c-progress-stepper__step--m-current__step-title--FontWeight);\n  --pf-c-progress-stepper__step-title--Color: var(--pf-c-progress-stepper__step--m-current__step-title--Color);\n}\n.pf-c-progress-stepper__step.pf-m-pending {\n  --pf-c-progress-stepper__step-title--Color: var(--pf-c-progress-stepper__step--m-pending__step-title--Color);\n}\n.pf-c-progress-stepper__step.pf-m-success {\n  --pf-c-progress-stepper__step-icon--Color: var(--pf-global--success-color--100);\n}\n.pf-c-progress-stepper__step.pf-m-danger {\n  --pf-c-progress-stepper__step-icon--Color: var(--pf-global--danger-color--100);\n  --pf-c-progress-stepper__step-title--Color: var(--pf-c-progress-stepper__step--m-danger__step-title--Color);\n  --pf-c-progress-stepper__step-title--m-help-text--hover--Color: var(--pf-c-progress-stepper__step--m-danger__step-title--m-help-text--hover--Color);\n  --pf-c-progress-stepper__step-title--m-help-text--focus--Color: var(--pf-c-progress-stepper__step--m-danger__step-title--m-help-text--focus--Color);\n  --pf-c-progress-stepper__step-title--m-help-text--TextDecorationColor: var(--pf-c-progress-stepper__step--m-danger__step-title--m-help-text--TextDecorationColor);\n  --pf-c-progress-stepper__step-title--m-help-text--hover--TextDecorationColor: var(--pf-c-progress-stepper__step--m-danger__step-title--m-help-text--hover--TextDecorationColor);\n  --pf-c-progress-stepper__step-title--m-help-text--focus--TextDecorationColor: var(--pf-c-progress-stepper__step--m-danger__step-title--m-help-text--focus--TextDecorationColor);\n}\n.pf-c-progress-stepper__step.pf-m-warning {\n  --pf-c-progress-stepper__step-icon--Color: var(--pf-global--warning-color--100);\n}\n.pf-c-progress-stepper__step.pf-m-info {\n  --pf-c-progress-stepper__step-icon--Color: var(--pf-global--info-color--100);\n}\n.pf-c-progress-stepper__step:last-child {\n  --pf-c-progress-stepper__step-main--MarginBottom: 0;\n}\n\n.pf-c-progress-stepper__step-connector {\n  position: relative;\n  display: flex;\n  justify-content: var(--pf-c-progress-stepper__step-connector--JustifyContent);\n  width: 100%;\n}\n.pf-c-progress-stepper__step:not(:last-of-type) > .pf-c-progress-stepper__step-connector::before {\n  position: absolute;\n  top: var(--pf-c-progress-stepper__step-connector--before--Top);\n  left: var(--pf-c-progress-stepper__step-connector--before--Left);\n  width: var(--pf-c-progress-stepper__step-connector--before--Width);\n  height: var(--pf-c-progress-stepper__step-connector--before--Height);\n  content: "";\n  border-right: var(--pf-c-progress-stepper__step-connector--before--BorderRightWidth) solid var(--pf-c-progress-stepper__step-connector--before--BorderRightColor);\n  border-bottom: var(--pf-c-progress-stepper__step-connector--before--BorderBottomWidth) solid var(--pf-c-progress-stepper__step-connector--before--BorderBottomColor);\n  transform: var(--pf-c-progress-stepper__step-connector--before--Transform);\n}\n\n.pf-c-progress-stepper__step-icon {\n  z-index: var(--pf-c-progress-stepper__step-icon--ZIndex);\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  width: var(--pf-c-progress-stepper__step-icon--Width);\n  height: var(--pf-c-progress-stepper__step-icon--Height);\n  font-size: var(--pf-c-progress-stepper__step-icon--FontSize);\n  color: var(--pf-c-progress-stepper__step-icon--Color);\n  background-color: var(--pf-c-progress-stepper__step-icon--BackgroundColor);\n  border: var(--pf-c-progress-stepper__step-icon--BorderWidth) solid var(--pf-c-progress-stepper__step-icon--BorderColor);\n  border-radius: 50%;\n}\n.pf-c-progress-stepper__step-icon .pficon {\n  margin-top: var(--pf-c-progress-stepper__pficon--MarginTop);\n}\n.pf-c-progress-stepper__step-icon .fa-exclamation-triangle {\n  margin-top: var(--pf-c-progress-stepper__fa-exclamation-triangle--MarginTop);\n}\n\n.pf-c-progress-stepper__step-main {\n  min-width: 0;\n  margin: var(--pf-c-progress-stepper__step-main--MarginTop) var(--pf-c-progress-stepper__step-main--MarginRight) var(--pf-c-progress-stepper__step-main--MarginBottom) var(--pf-c-progress-stepper__step-main--MarginLeft);\n  text-align: var(--pf-c-progress-stepper--step-main--TextAlign, auto);\n  overflow-wrap: anywhere;\n}\n.pf-c-progress-stepper__step:not(:last-of-type) > .pf-c-progress-stepper__step-main::before {\n  position: absolute;\n  top: calc(100% + var(--pf-c-progress-stepper__step-main--MarginTop));\n  left: calc(50% - var(--pf-c-progress-stepper__step-connector--before--BorderRightWidth) / 2);\n  width: auto;\n  height: calc(var(--pf-c-progress-stepper__step-main--MarginTop) + var(--pf-c-progress-stepper__step-main--MarginBottom));\n  border-right: var(--pf-c-progress-stepper__step-connector--before--BorderRightWidth) solid var(--pf-c-progress-stepper__step-connector--before--BorderRightColor);\n}\n\n.pf-c-progress-stepper__step-title {\n  font-size: var(--pf-c-progress-stepper__step-title--FontSize);\n  font-weight: var(--pf-c-progress-stepper__step-title--FontWeight);\n  color: var(--pf-c-progress-stepper__step-title--Color);\n  text-align: var(--pf-c-progress-stepper__step-title--TextAlign);\n  border: 0;\n}\n.pf-c-progress-stepper__step-title.pf-m-help-text {\n  text-decoration: underline;\n  cursor: pointer;\n  text-decoration-style: dashed;\n  text-decoration-color: var(--pf-c-progress-stepper__step-title--m-help-text--TextDecorationColor);\n  text-decoration-thickness: var(--pf-c-progress-stepper__step-title--m-help-text--TextDecorationThickness);\n  text-underline-offset: var(--pf-c-progress-stepper__step-title--m-help-text--TextUnderlineOffset);\n}\n.pf-c-progress-stepper__step-title.pf-m-help-text:hover {\n  --pf-c-progress-stepper__step-title--Color: var(--pf-c-progress-stepper__step-title--m-help-text--hover--Color);\n  --pf-c-progress-stepper__step-title--m-help-text--TextDecorationColor: var(--pf-c-progress-stepper__step-title--m-help-text--hover--TextDecorationColor);\n}\n.pf-c-progress-stepper__step-title.pf-m-help-text:focus {\n  --pf-c-progress-stepper__step-title--Color: var(--pf-c-progress-stepper__step-title--m-help-text--focus--Color);\n  --pf-c-progress-stepper__step-title--m-help-text--TextDecorationColor: var(--pf-c-progress-stepper__step-title--m-help-text--focus--TextDecorationColor);\n}\n\n.pf-c-progress-stepper__step-description {\n  margin-top: var(--pf-c-progress-stepper__step-description--MarginTop);\n  font-size: var(--pf-c-progress-stepper__step-description--FontSize);\n  color: var(--pf-c-progress-stepper__step-description--Color);\n  text-align: var(--pf-c-progress-stepper__step-description--TextAlign);\n}\n\n.pf-c-progress-stepper.pf-m-horizontal {\n  --pf-c-progress-stepper--GridAutoFlow: var(--pf-c-progress-stepper--m-horizontal--GridAutoFlow);\n  --pf-c-progress-stepper--GridTemplateColumns: var(--pf-c-progress-stepper--m-horizontal--GridTemplateColumns);\n  --pf-c-progress-stepper__step-connector--before--Top: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Top);\n  --pf-c-progress-stepper__step-connector--before--Left: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Left);\n  --pf-c-progress-stepper__step-connector--before--Width: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Width);\n  --pf-c-progress-stepper__step-connector--before--Height: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Height);\n  --pf-c-progress-stepper__step-connector--before--BorderRightWidth: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderRightWidth);\n  --pf-c-progress-stepper__step-connector--before--BorderRightColor: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderRightColor);\n  --pf-c-progress-stepper__step-connector--before--BorderBottomWidth: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderBottomWidth);\n  --pf-c-progress-stepper__step-connector--before--BorderBottomColor: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderBottomColor);\n  --pf-c-progress-stepper__step-connector--before--Transform: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Transform);\n  --pf-c-progress-stepper__step-main--MarginTop: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginTop);\n  --pf-c-progress-stepper__step-main--MarginRight: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginRight);\n  --pf-c-progress-stepper__step-main--MarginBottom: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginBottom);\n  --pf-c-progress-stepper__step-main--MarginLeft: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginLeft);\n  --pf-c-progress-stepper--m-compact--GridTemplateColumns: var(--pf-c-progress-stepper--m-horizontal--m-compact--GridTemplateColumns);\n  --pf-c-progress-stepper--m-compact__step-connector--GridRow: var(--pf-c-progress-stepper--m-horizontal--m-compact__step-connector--GridRow);\n  --pf-c-progress-stepper--m-compact__step-connector--PaddingBottom: var(--pf-c-progress-stepper--m-horizontal--m-compact__step-connector--PaddingBottom);\n  --pf-c-progress-stepper--m-center__step-connector--before--Content: "";\n  --pf-c-progress-stepper--m-center__step-main--before--Content: none;\n}\n.pf-c-progress-stepper.pf-m-vertical {\n  --pf-c-progress-stepper--GridAutoFlow: var(--pf-c-progress-stepper--m-vertical--GridAutoFlow);\n  --pf-c-progress-stepper--GridTemplateColumns: var(--pf-c-progress-stepper--m-vertical--GridTemplateColumns);\n  --pf-c-progress-stepper__step-connector--before--Top: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Top);\n  --pf-c-progress-stepper__step-connector--before--Left: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Left);\n  --pf-c-progress-stepper__step-connector--before--Width: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Width);\n  --pf-c-progress-stepper__step-connector--before--Height: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Height);\n  --pf-c-progress-stepper__step-connector--before--BorderRightWidth: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderRightWidth);\n  --pf-c-progress-stepper__step-connector--before--BorderRightColor: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderRightColor);\n  --pf-c-progress-stepper__step-connector--before--BorderBottomWidth: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderBottomWidth);\n  --pf-c-progress-stepper__step-connector--before--BorderBottomColor: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderBottomColor);\n  --pf-c-progress-stepper__step-connector--before--Transform: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Transform);\n  --pf-c-progress-stepper__step-main--MarginTop: var(--pf-c-progress-stepper--m-vertical__step-main--MarginTop);\n  --pf-c-progress-stepper__step-main--MarginRight: var(--pf-c-progress-stepper--m-vertical__step-main--MarginRight);\n  --pf-c-progress-stepper__step-main--MarginBottom: var(--pf-c-progress-stepper--m-vertical__step-main--MarginBottom);\n  --pf-c-progress-stepper__step-main--MarginLeft: var(--pf-c-progress-stepper--m-vertical__step-main--MarginLeft);\n  --pf-c-progress-stepper--m-compact--GridTemplateColumns: var(--pf-c-progress-stepper--m-vertical--m-compact--GridTemplateColumns);\n  --pf-c-progress-stepper--m-compact__step-connector--GridRow: var(--pf-c-progress-stepper--m-vertical--m-compact__step-connector--GridRow);\n  --pf-c-progress-stepper--m-compact__step-connector--PaddingBottom: var(--pf-c-progress-stepper--m-vertical--m-compact__step-connector--PaddingBottom);\n  --pf-c-progress-stepper--m-center__step-connector--before--Content: none;\n  --pf-c-progress-stepper--m-center__step-main--before--Content: "";\n}\n@media (min-width: 576px) {\n  .pf-c-progress-stepper.pf-m-horizontal-on-sm {\n    --pf-c-progress-stepper--GridAutoFlow: var(--pf-c-progress-stepper--m-horizontal--GridAutoFlow);\n    --pf-c-progress-stepper--GridTemplateColumns: var(--pf-c-progress-stepper--m-horizontal--GridTemplateColumns);\n    --pf-c-progress-stepper__step-connector--before--Top: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Top);\n    --pf-c-progress-stepper__step-connector--before--Left: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Left);\n    --pf-c-progress-stepper__step-connector--before--Width: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Width);\n    --pf-c-progress-stepper__step-connector--before--Height: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Height);\n    --pf-c-progress-stepper__step-connector--before--BorderRightWidth: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderRightWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderRightColor: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderRightColor);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomWidth: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderBottomWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomColor: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderBottomColor);\n    --pf-c-progress-stepper__step-connector--before--Transform: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Transform);\n    --pf-c-progress-stepper__step-main--MarginTop: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginTop);\n    --pf-c-progress-stepper__step-main--MarginRight: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginRight);\n    --pf-c-progress-stepper__step-main--MarginBottom: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginBottom);\n    --pf-c-progress-stepper__step-main--MarginLeft: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginLeft);\n    --pf-c-progress-stepper--m-compact--GridTemplateColumns: var(--pf-c-progress-stepper--m-horizontal--m-compact--GridTemplateColumns);\n    --pf-c-progress-stepper--m-compact__step-connector--GridRow: var(--pf-c-progress-stepper--m-horizontal--m-compact__step-connector--GridRow);\n    --pf-c-progress-stepper--m-compact__step-connector--PaddingBottom: var(--pf-c-progress-stepper--m-horizontal--m-compact__step-connector--PaddingBottom);\n    --pf-c-progress-stepper--m-center__step-connector--before--Content: "";\n    --pf-c-progress-stepper--m-center__step-main--before--Content: none;\n  }\n  .pf-c-progress-stepper.pf-m-vertical-on-sm {\n    --pf-c-progress-stepper--GridAutoFlow: var(--pf-c-progress-stepper--m-vertical--GridAutoFlow);\n    --pf-c-progress-stepper--GridTemplateColumns: var(--pf-c-progress-stepper--m-vertical--GridTemplateColumns);\n    --pf-c-progress-stepper__step-connector--before--Top: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Top);\n    --pf-c-progress-stepper__step-connector--before--Left: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Left);\n    --pf-c-progress-stepper__step-connector--before--Width: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Width);\n    --pf-c-progress-stepper__step-connector--before--Height: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Height);\n    --pf-c-progress-stepper__step-connector--before--BorderRightWidth: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderRightWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderRightColor: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderRightColor);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomWidth: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderBottomWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomColor: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderBottomColor);\n    --pf-c-progress-stepper__step-connector--before--Transform: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Transform);\n    --pf-c-progress-stepper__step-main--MarginTop: var(--pf-c-progress-stepper--m-vertical__step-main--MarginTop);\n    --pf-c-progress-stepper__step-main--MarginRight: var(--pf-c-progress-stepper--m-vertical__step-main--MarginRight);\n    --pf-c-progress-stepper__step-main--MarginBottom: var(--pf-c-progress-stepper--m-vertical__step-main--MarginBottom);\n    --pf-c-progress-stepper__step-main--MarginLeft: var(--pf-c-progress-stepper--m-vertical__step-main--MarginLeft);\n    --pf-c-progress-stepper--m-compact--GridTemplateColumns: var(--pf-c-progress-stepper--m-vertical--m-compact--GridTemplateColumns);\n    --pf-c-progress-stepper--m-compact__step-connector--GridRow: var(--pf-c-progress-stepper--m-vertical--m-compact__step-connector--GridRow);\n    --pf-c-progress-stepper--m-compact__step-connector--PaddingBottom: var(--pf-c-progress-stepper--m-vertical--m-compact__step-connector--PaddingBottom);\n    --pf-c-progress-stepper--m-center__step-connector--before--Content: none;\n    --pf-c-progress-stepper--m-center__step-main--before--Content: "";\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-progress-stepper.pf-m-horizontal-on-md {\n    --pf-c-progress-stepper--GridAutoFlow: var(--pf-c-progress-stepper--m-horizontal--GridAutoFlow);\n    --pf-c-progress-stepper--GridTemplateColumns: var(--pf-c-progress-stepper--m-horizontal--GridTemplateColumns);\n    --pf-c-progress-stepper__step-connector--before--Top: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Top);\n    --pf-c-progress-stepper__step-connector--before--Left: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Left);\n    --pf-c-progress-stepper__step-connector--before--Width: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Width);\n    --pf-c-progress-stepper__step-connector--before--Height: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Height);\n    --pf-c-progress-stepper__step-connector--before--BorderRightWidth: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderRightWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderRightColor: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderRightColor);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomWidth: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderBottomWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomColor: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderBottomColor);\n    --pf-c-progress-stepper__step-connector--before--Transform: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Transform);\n    --pf-c-progress-stepper__step-main--MarginTop: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginTop);\n    --pf-c-progress-stepper__step-main--MarginRight: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginRight);\n    --pf-c-progress-stepper__step-main--MarginBottom: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginBottom);\n    --pf-c-progress-stepper__step-main--MarginLeft: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginLeft);\n    --pf-c-progress-stepper--m-compact--GridTemplateColumns: var(--pf-c-progress-stepper--m-horizontal--m-compact--GridTemplateColumns);\n    --pf-c-progress-stepper--m-compact__step-connector--GridRow: var(--pf-c-progress-stepper--m-horizontal--m-compact__step-connector--GridRow);\n    --pf-c-progress-stepper--m-compact__step-connector--PaddingBottom: var(--pf-c-progress-stepper--m-horizontal--m-compact__step-connector--PaddingBottom);\n    --pf-c-progress-stepper--m-center__step-connector--before--Content: "";\n    --pf-c-progress-stepper--m-center__step-main--before--Content: none;\n  }\n  .pf-c-progress-stepper.pf-m-vertical-on-md {\n    --pf-c-progress-stepper--GridAutoFlow: var(--pf-c-progress-stepper--m-vertical--GridAutoFlow);\n    --pf-c-progress-stepper--GridTemplateColumns: var(--pf-c-progress-stepper--m-vertical--GridTemplateColumns);\n    --pf-c-progress-stepper__step-connector--before--Top: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Top);\n    --pf-c-progress-stepper__step-connector--before--Left: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Left);\n    --pf-c-progress-stepper__step-connector--before--Width: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Width);\n    --pf-c-progress-stepper__step-connector--before--Height: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Height);\n    --pf-c-progress-stepper__step-connector--before--BorderRightWidth: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderRightWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderRightColor: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderRightColor);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomWidth: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderBottomWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomColor: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderBottomColor);\n    --pf-c-progress-stepper__step-connector--before--Transform: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Transform);\n    --pf-c-progress-stepper__step-main--MarginTop: var(--pf-c-progress-stepper--m-vertical__step-main--MarginTop);\n    --pf-c-progress-stepper__step-main--MarginRight: var(--pf-c-progress-stepper--m-vertical__step-main--MarginRight);\n    --pf-c-progress-stepper__step-main--MarginBottom: var(--pf-c-progress-stepper--m-vertical__step-main--MarginBottom);\n    --pf-c-progress-stepper__step-main--MarginLeft: var(--pf-c-progress-stepper--m-vertical__step-main--MarginLeft);\n    --pf-c-progress-stepper--m-compact--GridTemplateColumns: var(--pf-c-progress-stepper--m-vertical--m-compact--GridTemplateColumns);\n    --pf-c-progress-stepper--m-compact__step-connector--GridRow: var(--pf-c-progress-stepper--m-vertical--m-compact__step-connector--GridRow);\n    --pf-c-progress-stepper--m-compact__step-connector--PaddingBottom: var(--pf-c-progress-stepper--m-vertical--m-compact__step-connector--PaddingBottom);\n    --pf-c-progress-stepper--m-center__step-connector--before--Content: none;\n    --pf-c-progress-stepper--m-center__step-main--before--Content: "";\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-progress-stepper.pf-m-horizontal-on-lg {\n    --pf-c-progress-stepper--GridAutoFlow: var(--pf-c-progress-stepper--m-horizontal--GridAutoFlow);\n    --pf-c-progress-stepper--GridTemplateColumns: var(--pf-c-progress-stepper--m-horizontal--GridTemplateColumns);\n    --pf-c-progress-stepper__step-connector--before--Top: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Top);\n    --pf-c-progress-stepper__step-connector--before--Left: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Left);\n    --pf-c-progress-stepper__step-connector--before--Width: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Width);\n    --pf-c-progress-stepper__step-connector--before--Height: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Height);\n    --pf-c-progress-stepper__step-connector--before--BorderRightWidth: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderRightWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderRightColor: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderRightColor);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomWidth: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderBottomWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomColor: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderBottomColor);\n    --pf-c-progress-stepper__step-connector--before--Transform: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Transform);\n    --pf-c-progress-stepper__step-main--MarginTop: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginTop);\n    --pf-c-progress-stepper__step-main--MarginRight: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginRight);\n    --pf-c-progress-stepper__step-main--MarginBottom: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginBottom);\n    --pf-c-progress-stepper__step-main--MarginLeft: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginLeft);\n    --pf-c-progress-stepper--m-compact--GridTemplateColumns: var(--pf-c-progress-stepper--m-horizontal--m-compact--GridTemplateColumns);\n    --pf-c-progress-stepper--m-compact__step-connector--GridRow: var(--pf-c-progress-stepper--m-horizontal--m-compact__step-connector--GridRow);\n    --pf-c-progress-stepper--m-compact__step-connector--PaddingBottom: var(--pf-c-progress-stepper--m-horizontal--m-compact__step-connector--PaddingBottom);\n    --pf-c-progress-stepper--m-center__step-connector--before--Content: "";\n    --pf-c-progress-stepper--m-center__step-main--before--Content: none;\n  }\n  .pf-c-progress-stepper.pf-m-vertical-on-lg {\n    --pf-c-progress-stepper--GridAutoFlow: var(--pf-c-progress-stepper--m-vertical--GridAutoFlow);\n    --pf-c-progress-stepper--GridTemplateColumns: var(--pf-c-progress-stepper--m-vertical--GridTemplateColumns);\n    --pf-c-progress-stepper__step-connector--before--Top: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Top);\n    --pf-c-progress-stepper__step-connector--before--Left: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Left);\n    --pf-c-progress-stepper__step-connector--before--Width: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Width);\n    --pf-c-progress-stepper__step-connector--before--Height: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Height);\n    --pf-c-progress-stepper__step-connector--before--BorderRightWidth: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderRightWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderRightColor: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderRightColor);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomWidth: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderBottomWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomColor: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderBottomColor);\n    --pf-c-progress-stepper__step-connector--before--Transform: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Transform);\n    --pf-c-progress-stepper__step-main--MarginTop: var(--pf-c-progress-stepper--m-vertical__step-main--MarginTop);\n    --pf-c-progress-stepper__step-main--MarginRight: var(--pf-c-progress-stepper--m-vertical__step-main--MarginRight);\n    --pf-c-progress-stepper__step-main--MarginBottom: var(--pf-c-progress-stepper--m-vertical__step-main--MarginBottom);\n    --pf-c-progress-stepper__step-main--MarginLeft: var(--pf-c-progress-stepper--m-vertical__step-main--MarginLeft);\n    --pf-c-progress-stepper--m-compact--GridTemplateColumns: var(--pf-c-progress-stepper--m-vertical--m-compact--GridTemplateColumns);\n    --pf-c-progress-stepper--m-compact__step-connector--GridRow: var(--pf-c-progress-stepper--m-vertical--m-compact__step-connector--GridRow);\n    --pf-c-progress-stepper--m-compact__step-connector--PaddingBottom: var(--pf-c-progress-stepper--m-vertical--m-compact__step-connector--PaddingBottom);\n    --pf-c-progress-stepper--m-center__step-connector--before--Content: none;\n    --pf-c-progress-stepper--m-center__step-main--before--Content: "";\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-progress-stepper.pf-m-horizontal-on-xl {\n    --pf-c-progress-stepper--GridAutoFlow: var(--pf-c-progress-stepper--m-horizontal--GridAutoFlow);\n    --pf-c-progress-stepper--GridTemplateColumns: var(--pf-c-progress-stepper--m-horizontal--GridTemplateColumns);\n    --pf-c-progress-stepper__step-connector--before--Top: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Top);\n    --pf-c-progress-stepper__step-connector--before--Left: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Left);\n    --pf-c-progress-stepper__step-connector--before--Width: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Width);\n    --pf-c-progress-stepper__step-connector--before--Height: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Height);\n    --pf-c-progress-stepper__step-connector--before--BorderRightWidth: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderRightWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderRightColor: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderRightColor);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomWidth: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderBottomWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomColor: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderBottomColor);\n    --pf-c-progress-stepper__step-connector--before--Transform: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Transform);\n    --pf-c-progress-stepper__step-main--MarginTop: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginTop);\n    --pf-c-progress-stepper__step-main--MarginRight: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginRight);\n    --pf-c-progress-stepper__step-main--MarginBottom: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginBottom);\n    --pf-c-progress-stepper__step-main--MarginLeft: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginLeft);\n    --pf-c-progress-stepper--m-compact--GridTemplateColumns: var(--pf-c-progress-stepper--m-horizontal--m-compact--GridTemplateColumns);\n    --pf-c-progress-stepper--m-compact__step-connector--GridRow: var(--pf-c-progress-stepper--m-horizontal--m-compact__step-connector--GridRow);\n    --pf-c-progress-stepper--m-compact__step-connector--PaddingBottom: var(--pf-c-progress-stepper--m-horizontal--m-compact__step-connector--PaddingBottom);\n    --pf-c-progress-stepper--m-center__step-connector--before--Content: "";\n    --pf-c-progress-stepper--m-center__step-main--before--Content: none;\n  }\n  .pf-c-progress-stepper.pf-m-vertical-on-xl {\n    --pf-c-progress-stepper--GridAutoFlow: var(--pf-c-progress-stepper--m-vertical--GridAutoFlow);\n    --pf-c-progress-stepper--GridTemplateColumns: var(--pf-c-progress-stepper--m-vertical--GridTemplateColumns);\n    --pf-c-progress-stepper__step-connector--before--Top: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Top);\n    --pf-c-progress-stepper__step-connector--before--Left: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Left);\n    --pf-c-progress-stepper__step-connector--before--Width: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Width);\n    --pf-c-progress-stepper__step-connector--before--Height: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Height);\n    --pf-c-progress-stepper__step-connector--before--BorderRightWidth: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderRightWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderRightColor: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderRightColor);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomWidth: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderBottomWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomColor: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderBottomColor);\n    --pf-c-progress-stepper__step-connector--before--Transform: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Transform);\n    --pf-c-progress-stepper__step-main--MarginTop: var(--pf-c-progress-stepper--m-vertical__step-main--MarginTop);\n    --pf-c-progress-stepper__step-main--MarginRight: var(--pf-c-progress-stepper--m-vertical__step-main--MarginRight);\n    --pf-c-progress-stepper__step-main--MarginBottom: var(--pf-c-progress-stepper--m-vertical__step-main--MarginBottom);\n    --pf-c-progress-stepper__step-main--MarginLeft: var(--pf-c-progress-stepper--m-vertical__step-main--MarginLeft);\n    --pf-c-progress-stepper--m-compact--GridTemplateColumns: var(--pf-c-progress-stepper--m-vertical--m-compact--GridTemplateColumns);\n    --pf-c-progress-stepper--m-compact__step-connector--GridRow: var(--pf-c-progress-stepper--m-vertical--m-compact__step-connector--GridRow);\n    --pf-c-progress-stepper--m-compact__step-connector--PaddingBottom: var(--pf-c-progress-stepper--m-vertical--m-compact__step-connector--PaddingBottom);\n    --pf-c-progress-stepper--m-center__step-connector--before--Content: none;\n    --pf-c-progress-stepper--m-center__step-main--before--Content: "";\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-progress-stepper.pf-m-horizontal-on-2xl {\n    --pf-c-progress-stepper--GridAutoFlow: var(--pf-c-progress-stepper--m-horizontal--GridAutoFlow);\n    --pf-c-progress-stepper--GridTemplateColumns: var(--pf-c-progress-stepper--m-horizontal--GridTemplateColumns);\n    --pf-c-progress-stepper__step-connector--before--Top: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Top);\n    --pf-c-progress-stepper__step-connector--before--Left: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Left);\n    --pf-c-progress-stepper__step-connector--before--Width: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Width);\n    --pf-c-progress-stepper__step-connector--before--Height: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Height);\n    --pf-c-progress-stepper__step-connector--before--BorderRightWidth: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderRightWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderRightColor: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderRightColor);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomWidth: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderBottomWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomColor: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--BorderBottomColor);\n    --pf-c-progress-stepper__step-connector--before--Transform: var(--pf-c-progress-stepper--m-horizontal__step-connector--before--Transform);\n    --pf-c-progress-stepper__step-main--MarginTop: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginTop);\n    --pf-c-progress-stepper__step-main--MarginRight: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginRight);\n    --pf-c-progress-stepper__step-main--MarginBottom: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginBottom);\n    --pf-c-progress-stepper__step-main--MarginLeft: var(--pf-c-progress-stepper--m-horizontal__step-main--MarginLeft);\n    --pf-c-progress-stepper--m-compact--GridTemplateColumns: var(--pf-c-progress-stepper--m-horizontal--m-compact--GridTemplateColumns);\n    --pf-c-progress-stepper--m-compact__step-connector--GridRow: var(--pf-c-progress-stepper--m-horizontal--m-compact__step-connector--GridRow);\n    --pf-c-progress-stepper--m-compact__step-connector--PaddingBottom: var(--pf-c-progress-stepper--m-horizontal--m-compact__step-connector--PaddingBottom);\n    --pf-c-progress-stepper--m-center__step-connector--before--Content: "";\n    --pf-c-progress-stepper--m-center__step-main--before--Content: none;\n  }\n  .pf-c-progress-stepper.pf-m-vertical-on-2xl {\n    --pf-c-progress-stepper--GridAutoFlow: var(--pf-c-progress-stepper--m-vertical--GridAutoFlow);\n    --pf-c-progress-stepper--GridTemplateColumns: var(--pf-c-progress-stepper--m-vertical--GridTemplateColumns);\n    --pf-c-progress-stepper__step-connector--before--Top: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Top);\n    --pf-c-progress-stepper__step-connector--before--Left: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Left);\n    --pf-c-progress-stepper__step-connector--before--Width: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Width);\n    --pf-c-progress-stepper__step-connector--before--Height: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Height);\n    --pf-c-progress-stepper__step-connector--before--BorderRightWidth: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderRightWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderRightColor: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderRightColor);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomWidth: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderBottomWidth);\n    --pf-c-progress-stepper__step-connector--before--BorderBottomColor: var(--pf-c-progress-stepper--m-vertical__step-connector--before--BorderBottomColor);\n    --pf-c-progress-stepper__step-connector--before--Transform: var(--pf-c-progress-stepper--m-vertical__step-connector--before--Transform);\n    --pf-c-progress-stepper__step-main--MarginTop: var(--pf-c-progress-stepper--m-vertical__step-main--MarginTop);\n    --pf-c-progress-stepper__step-main--MarginRight: var(--pf-c-progress-stepper--m-vertical__step-main--MarginRight);\n    --pf-c-progress-stepper__step-main--MarginBottom: var(--pf-c-progress-stepper--m-vertical__step-main--MarginBottom);\n    --pf-c-progress-stepper__step-main--MarginLeft: var(--pf-c-progress-stepper--m-vertical__step-main--MarginLeft);\n    --pf-c-progress-stepper--m-compact--GridTemplateColumns: var(--pf-c-progress-stepper--m-vertical--m-compact--GridTemplateColumns);\n    --pf-c-progress-stepper--m-compact__step-connector--GridRow: var(--pf-c-progress-stepper--m-vertical--m-compact__step-connector--GridRow);\n    --pf-c-progress-stepper--m-compact__step-connector--PaddingBottom: var(--pf-c-progress-stepper--m-vertical--m-compact__step-connector--PaddingBottom);\n    --pf-c-progress-stepper--m-center__step-connector--before--Content: none;\n    --pf-c-progress-stepper--m-center__step-main--before--Content: "";\n  }\n}';

export {
  wizard_default,
  WizardPage,
  progress_stepper_default
};
//# sourceMappingURL=chunk-S3ILVWYD.js.map
