import {
  CryptoApi
} from "./chunk-WZUTIRBE.js";
import {
  AKElement,
  CustomListenerElement,
  DEFAULT_CONFIG,
  e,
  n,
  t,
  to
} from "./chunk-MKGIUSP2.js";
import {
  ke
} from "./chunk-BW7LVHGS.js";
import {
  __decorateClass
} from "./chunk-KZ3QJOBN.js";

// src/admin/common/ak-crypto-certificate-search.ts
var renderElement = (item) => item.name;
var renderValue = (item) => item?.pk;
var AkCryptoCertificateSearch = class extends CustomListenerElement(AKElement) {
  constructor() {
    super();
    this.noKey = false;
    this.singleton = false;
    this.selected = this.selected.bind(this);
    this.fetchObjects = this.fetchObjects.bind(this);
    this.handleSearchUpdate = this.handleSearchUpdate.bind(this);
  }
  get value() {
    return this.selectedKeypair ? renderValue(this.selectedKeypair) : null;
  }
  connectedCallback() {
    super.connectedCallback();
    const horizontalContainer = this.closest("ak-form-element-horizontal[name]");
    if (!horizontalContainer) {
      throw new Error("This search can only be used in a named ak-form-element-horizontal");
    }
    const name = horizontalContainer.getAttribute("name");
    const myName = this.getAttribute("name");
    if (name !== null && name !== myName) {
      this.setAttribute("name", name);
    }
  }
  handleSearchUpdate(ev) {
    ev.stopPropagation();
    this.selectedKeypair = ev.detail.value;
    this.dispatchEvent(new InputEvent("input", { bubbles: true, composed: true }));
  }
  async fetchObjects(query) {
    const args = {
      ordering: "name",
      hasKey: !this.noKey,
      includeDetails: false
    };
    if (query !== void 0) {
      args.search = query;
    }
    const certificates = await new CryptoApi(DEFAULT_CONFIG).cryptoCertificatekeypairsList(
      args
    );
    return certificates.results;
  }
  selected(item, items) {
    return this.singleton && !this.certificate && items.length === 1 || !!this.certificate && this.certificate === item.pk;
  }
  render() {
    return ke`
            <ak-search-select
                name=${to(this.name ?? void 0)}
                .fetchObjects=${this.fetchObjects}
                .renderElement=${renderElement}
                .value=${renderValue}
                .selected=${this.selected}
                @ak-change=${this.handleSearchUpdate}
                ?blankable=${true}
            >
            </ak-search-select>
        `;
  }
};
__decorateClass([
  n({ type: String, reflect: true })
], AkCryptoCertificateSearch.prototype, "certificate", 2);
__decorateClass([
  e("ak-search-select")
], AkCryptoCertificateSearch.prototype, "search", 2);
__decorateClass([
  n({ type: String })
], AkCryptoCertificateSearch.prototype, "name", 2);
__decorateClass([
  n({ type: Boolean, attribute: "nokey" })
], AkCryptoCertificateSearch.prototype, "noKey", 2);
__decorateClass([
  n({ type: Boolean, attribute: "singleton" })
], AkCryptoCertificateSearch.prototype, "singleton", 2);
AkCryptoCertificateSearch = __decorateClass([
  t("ak-crypto-certificate-search")
], AkCryptoCertificateSearch);
//# sourceMappingURL=chunk-WDG7SDZZ.js.map
