import {
  PolicyEngineModeFromJSON
} from "./chunk-MKGIUSP2.js";

// node_modules/@goauthentik/api/dist/esm/models/FlowDesignationEnum.js
var FlowDesignationEnum = {
  Authentication: "authentication",
  Authorization: "authorization",
  Invalidation: "invalidation",
  Enrollment: "enrollment",
  Unenrollment: "unenrollment",
  Recovery: "recovery",
  StageConfiguration: "stage_configuration",
  UnknownDefaultOpenApi: "11184809"
};
function FlowDesignationEnumFromJSON(json) {
  return FlowDesignationEnumFromJSONTyped(json, false);
}
function FlowDesignationEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function FlowDesignationEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/DeniedActionEnum.js
var DeniedActionEnum = {
  MessageContinue: "message_continue",
  Message: "message",
  Continue: "continue",
  UnknownDefaultOpenApi: "11184809"
};
function DeniedActionEnumFromJSON(json) {
  return DeniedActionEnumFromJSONTyped(json, false);
}
function DeniedActionEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function DeniedActionEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/FlowLayoutEnum.js
var FlowLayoutEnum = {
  Stacked: "stacked",
  ContentLeft: "content_left",
  ContentRight: "content_right",
  SidebarLeft: "sidebar_left",
  SidebarRight: "sidebar_right",
  UnknownDefaultOpenApi: "11184809"
};
function FlowLayoutEnumFromJSON(json) {
  return FlowLayoutEnumFromJSONTyped(json, false);
}
function FlowLayoutEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function FlowLayoutEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/PromptTypeEnum.js
var PromptTypeEnum = {
  Text: "text",
  TextArea: "text_area",
  TextReadOnly: "text_read_only",
  TextAreaReadOnly: "text_area_read_only",
  Username: "username",
  Email: "email",
  Password: "password",
  Number: "number",
  Checkbox: "checkbox",
  RadioButtonGroup: "radio-button-group",
  Dropdown: "dropdown",
  Date: "date",
  DateTime: "date-time",
  File: "file",
  Separator: "separator",
  Hidden: "hidden",
  Static: "static",
  AkLocale: "ak-locale",
  UnknownDefaultOpenApi: "11184809"
};
function PromptTypeEnumFromJSON(json) {
  return PromptTypeEnumFromJSONTyped(json, false);
}
function PromptTypeEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function PromptTypeEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/ContextualFlowInfoLayoutEnum.js
function ContextualFlowInfoLayoutEnumFromJSON(json) {
  return ContextualFlowInfoLayoutEnumFromJSONTyped(json, false);
}
function ContextualFlowInfoLayoutEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}

// node_modules/@goauthentik/api/dist/esm/models/ContextualFlowInfo.js
function ContextualFlowInfoFromJSON(json) {
  return ContextualFlowInfoFromJSONTyped(json, false);
}
function ContextualFlowInfoFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "title": json["title"] == null ? void 0 : json["title"],
    "background": json["background"] == null ? void 0 : json["background"],
    "cancelUrl": json["cancel_url"],
    "layout": ContextualFlowInfoLayoutEnumFromJSON(json["layout"])
  };
}

// node_modules/@goauthentik/api/dist/esm/models/StagePrompt.js
function StagePromptFromJSON(json) {
  return StagePromptFromJSONTyped(json, false);
}
function StagePromptFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "fieldKey": json["field_key"],
    "label": json["label"],
    "type": PromptTypeEnumFromJSON(json["type"]),
    "required": json["required"],
    "placeholder": json["placeholder"],
    "initialValue": json["initial_value"],
    "order": json["order"],
    "subText": json["sub_text"],
    "choices": json["choices"] == null ? null : json["choices"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PromptChallenge.js
function PromptChallengeFromJSON(json) {
  return PromptChallengeFromJSONTyped(json, false);
}
function PromptChallengeFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "flowInfo": json["flow_info"] == null ? void 0 : ContextualFlowInfoFromJSON(json["flow_info"]),
    "component": json["component"] == null ? void 0 : json["component"],
    "responseErrors": json["response_errors"] == null ? void 0 : json["response_errors"],
    "fields": json["fields"].map(StagePromptFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/AuthenticationEnum.js
function AuthenticationEnumFromJSON(json) {
  return AuthenticationEnumFromJSONTyped(json, false);
}
function AuthenticationEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function AuthenticationEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/Flow.js
function FlowFromJSON(json) {
  return FlowFromJSONTyped(json, false);
}
function FlowFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "policybindingmodelPtrId": json["policybindingmodel_ptr_id"],
    "name": json["name"],
    "slug": json["slug"],
    "title": json["title"],
    "designation": FlowDesignationEnumFromJSON(json["designation"]),
    "background": json["background"],
    "stages": json["stages"],
    "policies": json["policies"],
    "cacheCount": json["cache_count"],
    "policyEngineMode": json["policy_engine_mode"] == null ? void 0 : PolicyEngineModeFromJSON(json["policy_engine_mode"]),
    "compatibilityMode": json["compatibility_mode"] == null ? void 0 : json["compatibility_mode"],
    "exportUrl": json["export_url"],
    "layout": json["layout"] == null ? void 0 : FlowLayoutEnumFromJSON(json["layout"]),
    "deniedAction": json["denied_action"] == null ? void 0 : DeniedActionEnumFromJSON(json["denied_action"]),
    "authentication": json["authentication"] == null ? void 0 : AuthenticationEnumFromJSON(json["authentication"])
  };
}

// node_modules/@goauthentik/api/dist/esm/models/FlowSet.js
function FlowSetFromJSON(json) {
  return FlowSetFromJSONTyped(json, false);
}
function FlowSetFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "policybindingmodelPtrId": json["policybindingmodel_ptr_id"],
    "name": json["name"],
    "slug": json["slug"],
    "title": json["title"],
    "designation": FlowDesignationEnumFromJSON(json["designation"]),
    "background": json["background"],
    "policyEngineMode": json["policy_engine_mode"] == null ? void 0 : PolicyEngineModeFromJSON(json["policy_engine_mode"]),
    "compatibilityMode": json["compatibility_mode"] == null ? void 0 : json["compatibility_mode"],
    "exportUrl": json["export_url"],
    "layout": json["layout"] == null ? void 0 : FlowLayoutEnumFromJSON(json["layout"]),
    "deniedAction": json["denied_action"] == null ? void 0 : DeniedActionEnumFromJSON(json["denied_action"])
  };
}

// node_modules/@goauthentik/api/dist/esm/models/Stage.js
function StageFromJSON(json) {
  return StageFromJSONTyped(json, false);
}
function StageFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "component": json["component"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "flowSet": json["flow_set"] == null ? void 0 : json["flow_set"].map(FlowSetFromJSON)
  };
}

export {
  ContextualFlowInfoFromJSON,
  AuthenticationEnumToJSON,
  DeniedActionEnum,
  DeniedActionEnumToJSON,
  FlowLayoutEnum,
  FlowLayoutEnumToJSON,
  FlowDesignationEnum,
  FlowDesignationEnumFromJSON,
  FlowDesignationEnumToJSON,
  FlowSetFromJSON,
  PromptTypeEnum,
  PromptTypeEnumFromJSON,
  PromptTypeEnumToJSON,
  PromptChallengeFromJSON,
  PromptChallengeFromJSONTyped,
  FlowFromJSON,
  StageFromJSON
};
//# sourceMappingURL=chunk-WYSJXYDA.js.map
