import "./chunk-GJQSSHIG.js";
import "./chunk-YYSHHG77.js";
import {
  button_default
} from "./chunk-E4FQAZYR.js";
import "./chunk-YNUUMIC2.js";
import {
  form_control_default,
  form_default,
  login_default
} from "./chunk-RVW7F5SR.js";
import {
  BaseStage,
  title_default,
  to
} from "./chunk-HCX57C2Q.js";
import "./chunk-UFA2R4ZV.js";
import {
  patternfly_base_default,
  t
} from "./chunk-TYHQZR4W.js";
import {
  i,
  ke,
  msg
} from "./chunk-AW3QUPVO.js";
import {
  __decorateClass
} from "./chunk-NMZOY6WS.js";

// src/flow/stages/authenticator_static/AuthenticatorStaticStage.ts
var AuthenticatorStaticStage = class extends BaseStage {
  static get styles() {
    return [
      patternfly_base_default,
      login_default,
      form_default,
      form_control_default,
      title_default,
      button_default,
      i`
                /* Static OTP Tokens */
                ul {
                    list-style: circle;
                    columns: 2;
                    -webkit-columns: 2;
                    -moz-columns: 2;
                    column-width: 1em;
                    margin-left: var(--pf-global--spacer--xs);
                }
                ul li {
                    font-size: var(--pf-global--FontSize--2xl);
                    margin: 0 2rem;
                }
            `
    ];
  }
  render() {
    if (!this.challenge) {
      return ke`<ak-empty-state loading> </ak-empty-state>`;
    }
    return ke`<header class="pf-c-login__main-header">
                <h1 class="pf-c-title pf-m-3xl">${this.challenge.flowInfo?.title}</h1>
            </header>
            <div class="pf-c-login__main-body">
                <form
                    class="pf-c-form"
                    @submit=${(e) => {
      this.submitForm(e);
    }}
                >
                    <ak-form-static
                        class="pf-c-form__group"
                        userAvatar="${this.challenge.pendingUserAvatar}"
                        user=${this.challenge.pendingUser}
                    >
                        <div slot="link">
                            <a href="${to(this.challenge.flowInfo?.cancelUrl)}"
                                >${msg("Not you?")}</a
                            >
                        </div>
                    </ak-form-static>
                    <ak-form-element label="" class="pf-c-form__group">
                        <ul>
                            ${this.challenge.codes.map((token) => {
      return ke`<li class="pf-m-monospace">${token}</li>`;
    })}
                        </ul>
                    </ak-form-element>
                    <p>${msg("Make sure to keep these tokens in a safe place.")}</p>

                    <div class="pf-c-form__group pf-m-action">
                        <button type="submit" class="pf-c-button pf-m-primary pf-m-block">
                            ${msg("Continue")}
                        </button>
                    </div>
                </form>
            </div>
            <footer class="pf-c-login__main-footer">
                <ul class="pf-c-login__main-footer-links"></ul>
            </footer>`;
  }
};
AuthenticatorStaticStage = __decorateClass([
  t("ak-stage-authenticator-static")
], AuthenticatorStaticStage);
export {
  AuthenticatorStaticStage
};
//# sourceMappingURL=AuthenticatorStaticStage-TLHM7ZI7.js.map
