import {
  FlowsApi
} from "./chunk-FLMADM5M.js";
import {
  DeviceClassesEnum
} from "./chunk-643NLCM7.js";
import {
  DEFAULT_CONFIG
} from "./chunk-LMXKGCRX.js";
import {
  PasswordManagerPrefill
} from "./chunk-YXXWQLM7.js";
import {
  button_default
} from "./chunk-E4FQAZYR.js";
import {
  form_control_default,
  form_default,
  login_default
} from "./chunk-RVW7F5SR.js";
import {
  BaseStage,
  title_default
} from "./chunk-HCX57C2Q.js";
import {
  n,
  patternfly_base_default,
  r,
  t
} from "./chunk-TYHQZR4W.js";
import {
  D,
  i,
  ke,
  msg,
  str
} from "./chunk-AW3QUPVO.js";
import {
  __commonJS,
  __decorateClass,
  __toESM
} from "./chunk-NMZOY6WS.js";

// node_modules/base64-js/index.js
var require_base64_js = __commonJS({
  "node_modules/base64-js/index.js"(exports) {
    "use strict";
    exports.byteLength = byteLength;
    exports.toByteArray = toByteArray;
    exports.fromByteArray = fromByteArray2;
    var lookup = [];
    var revLookup = [];
    var Arr = typeof Uint8Array !== "undefined" ? Uint8Array : Array;
    var code = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    for (i2 = 0, len = code.length; i2 < len; ++i2) {
      lookup[i2] = code[i2];
      revLookup[code.charCodeAt(i2)] = i2;
    }
    var i2;
    var len;
    revLookup["-".charCodeAt(0)] = 62;
    revLookup["_".charCodeAt(0)] = 63;
    function getLens(b64) {
      var len2 = b64.length;
      if (len2 % 4 > 0) {
        throw new Error("Invalid string. Length must be a multiple of 4");
      }
      var validLen = b64.indexOf("=");
      if (validLen === -1) validLen = len2;
      var placeHoldersLen = validLen === len2 ? 0 : 4 - validLen % 4;
      return [validLen, placeHoldersLen];
    }
    function byteLength(b64) {
      var lens = getLens(b64);
      var validLen = lens[0];
      var placeHoldersLen = lens[1];
      return (validLen + placeHoldersLen) * 3 / 4 - placeHoldersLen;
    }
    function _byteLength(b64, validLen, placeHoldersLen) {
      return (validLen + placeHoldersLen) * 3 / 4 - placeHoldersLen;
    }
    function toByteArray(b64) {
      var tmp;
      var lens = getLens(b64);
      var validLen = lens[0];
      var placeHoldersLen = lens[1];
      var arr = new Arr(_byteLength(b64, validLen, placeHoldersLen));
      var curByte = 0;
      var len2 = placeHoldersLen > 0 ? validLen - 4 : validLen;
      var i3;
      for (i3 = 0; i3 < len2; i3 += 4) {
        tmp = revLookup[b64.charCodeAt(i3)] << 18 | revLookup[b64.charCodeAt(i3 + 1)] << 12 | revLookup[b64.charCodeAt(i3 + 2)] << 6 | revLookup[b64.charCodeAt(i3 + 3)];
        arr[curByte++] = tmp >> 16 & 255;
        arr[curByte++] = tmp >> 8 & 255;
        arr[curByte++] = tmp & 255;
      }
      if (placeHoldersLen === 2) {
        tmp = revLookup[b64.charCodeAt(i3)] << 2 | revLookup[b64.charCodeAt(i3 + 1)] >> 4;
        arr[curByte++] = tmp & 255;
      }
      if (placeHoldersLen === 1) {
        tmp = revLookup[b64.charCodeAt(i3)] << 10 | revLookup[b64.charCodeAt(i3 + 1)] << 4 | revLookup[b64.charCodeAt(i3 + 2)] >> 2;
        arr[curByte++] = tmp >> 8 & 255;
        arr[curByte++] = tmp & 255;
      }
      return arr;
    }
    function tripletToBase64(num) {
      return lookup[num >> 18 & 63] + lookup[num >> 12 & 63] + lookup[num >> 6 & 63] + lookup[num & 63];
    }
    function encodeChunk(uint8, start, end) {
      var tmp;
      var output = [];
      for (var i3 = start; i3 < end; i3 += 3) {
        tmp = (uint8[i3] << 16 & 16711680) + (uint8[i3 + 1] << 8 & 65280) + (uint8[i3 + 2] & 255);
        output.push(tripletToBase64(tmp));
      }
      return output.join("");
    }
    function fromByteArray2(uint8) {
      var tmp;
      var len2 = uint8.length;
      var extraBytes = len2 % 3;
      var parts = [];
      var maxChunkLength = 16383;
      for (var i3 = 0, len22 = len2 - extraBytes; i3 < len22; i3 += maxChunkLength) {
        parts.push(encodeChunk(uint8, i3, i3 + maxChunkLength > len22 ? len22 : i3 + maxChunkLength));
      }
      if (extraBytes === 1) {
        tmp = uint8[len2 - 1];
        parts.push(
          lookup[tmp >> 2] + lookup[tmp << 4 & 63] + "=="
        );
      } else if (extraBytes === 2) {
        tmp = (uint8[len2 - 2] << 8) + uint8[len2 - 1];
        parts.push(
          lookup[tmp >> 10] + lookup[tmp >> 4 & 63] + lookup[tmp << 2 & 63] + "="
        );
      }
      return parts.join("");
    }
  }
});

// src/flow/stages/authenticator_validate/base.ts
var BaseDeviceStage = class extends BaseStage {
  constructor() {
    super(...arguments);
    this.showBackButton = false;
  }
  static get styles() {
    return [
      patternfly_base_default,
      login_default,
      form_default,
      form_control_default,
      title_default,
      button_default,
      i`
                .pf-c-form__group.pf-m-action {
                    display: flex;
                    gap: 16px;
                    margin-top: 0;
                    margin-bottom: calc(var(--pf-c-form__group--m-action--MarginTop) / 2);
                    flex-direction: column;
                }
            `
    ];
  }
  submit(payload) {
    return this.host?.submit(payload) || Promise.resolve();
  }
  renderReturnToDevicePicker() {
    if (!this.showBackButton) {
      return D;
    }
    return ke`<button
            class="pf-c-button pf-m-secondary pf-m-block"
            @click=${() => {
      if (!this.host) return;
      this.host.selectedDeviceChallenge = void 0;
    }}
        >
            ${msg("Select another authentication method")}
        </button>`;
  }
};
__decorateClass([
  n({ attribute: false })
], BaseDeviceStage.prototype, "deviceChallenge", 2);
__decorateClass([
  n({ type: Boolean })
], BaseDeviceStage.prototype, "showBackButton", 2);

// src/flow/stages/authenticator_validate/AuthenticatorValidateStageCode.ts
var AuthenticatorValidateStageWebCode = class extends BaseDeviceStage {
  static get styles() {
    return super.styles.concat(i`
            .icon-description {
                display: flex;
            }
            .icon-description i {
                font-size: 2em;
                padding: 0.25em;
                padding-right: 0.5em;
            }
        `);
  }
  deviceMessage() {
    switch (this.deviceChallenge?.deviceClass) {
      case DeviceClassesEnum.Email: {
        const email = this.deviceChallenge.challenge?.email;
        return msg(str`A code has been sent to you via email${email ? ` ${email}` : ""}`);
      }
      case DeviceClassesEnum.Sms:
        return msg("A code has been sent to you via SMS.");
      case DeviceClassesEnum.Totp:
        return msg(
          "Open your two-factor authenticator app to view your authentication code."
        );
      case DeviceClassesEnum.Static:
        return msg("Enter a one-time recovery code for this user.");
    }
    return msg("Enter the code from your authenticator device.");
  }
  deviceIcon() {
    switch (this.deviceChallenge?.deviceClass) {
      case DeviceClassesEnum.Email:
        return "fa-envelope-o";
      case DeviceClassesEnum.Sms:
        return "fa-mobile-alt";
      case DeviceClassesEnum.Totp:
        return "fa-clock";
      case DeviceClassesEnum.Static:
        return "fa-key";
    }
    return "fa-mobile-alt";
  }
  render() {
    if (!this.challenge) {
      return ke`<ak-empty-state loading> </ak-empty-state>`;
    }
    return ke`<div class="pf-c-login__main-body">
                <form
                    class="pf-c-form"
                    @submit=${(e) => {
      this.submitForm(e);
    }}
                >
                    ${this.renderUserInfo()}
                    <div class="icon-description">
                        <i class="fa ${this.deviceIcon()}" aria-hidden="true"></i>
                        <p>${this.deviceMessage()}</p>
                    </div>
                    <ak-form-element
                        label="${this.deviceChallenge?.deviceClass === DeviceClassesEnum.Static ? msg("Static token") : msg("Authentication code")}"
                        required
                        class="pf-c-form__group"
                        .errors=${(this.challenge?.responseErrors || {})["code"]}
                    >
                        <!-- @ts-ignore -->
                        <input
                            type="text"
                            name="code"
                            inputmode="${this.deviceChallenge?.deviceClass === DeviceClassesEnum.Static ? "text" : "numeric"}"
                            pattern="${this.deviceChallenge?.deviceClass === DeviceClassesEnum.Static ? "[0-9a-zA-Z]*" : "[0-9]*"}"
                            placeholder="${msg("Please enter your code")}"
                            autofocus=""
                            autocomplete="one-time-code"
                            class="pf-c-form-control"
                            value="${PasswordManagerPrefill.totp || ""}"
                            required
                        />
                    </ak-form-element>

                    <div class="pf-c-form__group pf-m-action">
                        <button type="submit" class="pf-c-button pf-m-primary pf-m-block">
                            ${msg("Continue")}
                        </button>
                        ${this.renderReturnToDevicePicker()}
                    </div>
                </form>
            </div>
            <footer class="pf-c-login__main-footer">
                <ul class="pf-c-login__main-footer-links"></ul>
            </footer>`;
  }
};
AuthenticatorValidateStageWebCode = __decorateClass([
  t("ak-stage-authenticator-validate-code")
], AuthenticatorValidateStageWebCode);

// src/flow/stages/authenticator_validate/AuthenticatorValidateStageDuo.ts
var AuthenticatorValidateStageWebDuo = class extends BaseDeviceStage {
  constructor() {
    super(...arguments);
    this.showBackButton = false;
    this.authenticating = false;
  }
  updated(changedProperties) {
    if (changedProperties.has("challenge") && this.challenge !== void 0) {
      this.authenticating = true;
      this.host?.submit(
        {
          duo: this.deviceChallenge?.deviceUid
        },
        { invisible: true }
      ).then(() => {
        this.authenticating = false;
      }).catch(() => {
        this.authenticating = false;
      });
    }
  }
  render() {
    if (!this.challenge) {
      return ke`<ak-empty-state loading> </ak-empty-state>`;
    }
    const errors = this.challenge.responseErrors?.duo || [];
    const errorMessage = errors.map((err) => err.string);
    return ke`<div class="pf-c-login__main-body">
            <form
                class="pf-c-form"
                @submit=${(e) => {
      this.submitForm(e);
    }}
            >
                ${this.renderUserInfo()}
                <ak-empty-state
                    ?loading="${this.authenticating}"
                    header=${this.authenticating ? msg("Sending Duo push notification...") : errorMessage.join(", ") || msg("Failed to authenticate")}
                    icon="fas fa-times"
                >
                </ak-empty-state>
                <div class="pf-c-form__group pf-m-action">${this.renderReturnToDevicePicker()}</div>
            </form>
        </div>`;
  }
};
__decorateClass([
  n({ attribute: false })
], AuthenticatorValidateStageWebDuo.prototype, "deviceChallenge", 2);
__decorateClass([
  n({ type: Boolean })
], AuthenticatorValidateStageWebDuo.prototype, "showBackButton", 2);
__decorateClass([
  r()
], AuthenticatorValidateStageWebDuo.prototype, "authenticating", 2);
AuthenticatorValidateStageWebDuo = __decorateClass([
  t("ak-stage-authenticator-validate-duo")
], AuthenticatorValidateStageWebDuo);

// src/common/helpers/webauthn.ts
var base64js = __toESM(require_base64_js(), 1);
function b64enc(buf) {
  return base64js.fromByteArray(buf).replace(/\+/g, "-").replace(/\//g, "_").replace(/=/g, "");
}
function b64RawEnc(buf) {
  return base64js.fromByteArray(buf).replace(/\+/g, "-").replace(/\//g, "_");
}
function u8arr(input) {
  return Uint8Array.from(
    atob(input.replace(/_/g, "/").replace(/-/g, "+")),
    (c) => c.charCodeAt(0)
  );
}
function checkWebAuthnSupport() {
  if ("credentials" in navigator) {
    return;
  }
  if (window.location.protocol === "http:" && window.location.hostname !== "localhost") {
    throw new Error(msg("WebAuthn requires this page to be accessed via HTTPS."));
  }
  throw new Error(msg("WebAuthn not supported by browser."));
}
function transformCredentialCreateOptions(credentialCreateOptions, userId) {
  const user = credentialCreateOptions.user;
  const stringId = decodeURIComponent(window.atob(userId));
  user.id = u8arr(b64enc(u8arr(stringId)));
  const challenge = u8arr(credentialCreateOptions.challenge.toString());
  return {
    ...credentialCreateOptions,
    challenge,
    user
  };
}
function transformNewAssertionForServer(newAssertion) {
  const attObj = new Uint8Array(
    newAssertion.response.attestationObject
  );
  const clientDataJSON = new Uint8Array(newAssertion.response.clientDataJSON);
  const rawId = new Uint8Array(newAssertion.rawId);
  const registrationClientExtensions = newAssertion.getClientExtensionResults();
  return {
    id: newAssertion.id,
    rawId: b64enc(rawId),
    type: newAssertion.type,
    registrationClientExtensions: JSON.stringify(registrationClientExtensions),
    response: {
      clientDataJSON: b64enc(clientDataJSON),
      attestationObject: b64enc(attObj)
    }
  };
}
function transformCredentialRequestOptions(credentialRequestOptions) {
  const challenge = u8arr(credentialRequestOptions.challenge.toString());
  const allowCredentials = (credentialRequestOptions.allowCredentials || []).map(
    (credentialDescriptor) => {
      const id = u8arr(credentialDescriptor.id.toString());
      return Object.assign({}, credentialDescriptor, { id });
    }
  );
  return {
    ...credentialRequestOptions,
    challenge,
    allowCredentials
  };
}
function transformAssertionForServer(newAssertion) {
  const response = newAssertion.response;
  const authData = new Uint8Array(response.authenticatorData);
  const clientDataJSON = new Uint8Array(response.clientDataJSON);
  const rawId = new Uint8Array(newAssertion.rawId);
  const sig = new Uint8Array(response.signature);
  const assertionClientExtensions = newAssertion.getClientExtensionResults();
  return {
    id: newAssertion.id,
    rawId: b64enc(rawId),
    type: newAssertion.type,
    assertionClientExtensions: JSON.stringify(assertionClientExtensions),
    response: {
      clientDataJSON: b64RawEnc(clientDataJSON),
      signature: b64RawEnc(sig),
      authenticatorData: b64RawEnc(authData),
      userHandle: null
    }
  };
}

// src/flow/stages/authenticator_validate/AuthenticatorValidateStageWebAuthn.ts
var AuthenticatorValidateStageWebAuthn = class extends BaseDeviceStage {
  constructor() {
    super(...arguments);
    this.showBackButton = false;
    this.authenticating = false;
  }
  async authenticate() {
    let assertion;
    checkWebAuthnSupport();
    try {
      assertion = await navigator.credentials.get({
        publicKey: this.transformedCredentialRequestOptions
      });
      if (!assertion) {
        throw new Error("Assertions is empty");
      }
    } catch (err) {
      throw new Error(`Error when creating credential: ${err}`);
    }
    const transformedAssertionForServer = transformAssertionForServer(
      assertion
    );
    try {
      await this.host?.submit(
        {
          webauthn: transformedAssertionForServer
        },
        {
          invisible: true
        }
      );
    } catch (err) {
      throw new Error(`Error when validating assertion on server: ${err}`);
    }
  }
  updated(changedProperties) {
    if (changedProperties.has("challenge") && this.challenge !== void 0) {
      const credentialRequestOptions = this.deviceChallenge?.challenge;
      this.transformedCredentialRequestOptions = transformCredentialRequestOptions(credentialRequestOptions);
      this.authenticateWrapper();
    }
  }
  async authenticateWrapper() {
    if (this.authenticating) {
      return;
    }
    this.authenticating = true;
    this.authenticate().catch((e) => {
      console.warn("authentik/flows/authenticator_validate/webauthn: failed to auth", e);
      this.errorMessage = msg("Authentication failed. Please try again.");
    }).finally(() => {
      this.authenticating = false;
    });
  }
  render() {
    return ke`<div class="pf-c-login__main-body">
            <form class="pf-c-form">
                ${this.renderUserInfo()}
                <ak-empty-state
                    ?loading="${this.authenticating}"
                    header=${this.authenticating ? msg("Authenticating...") : this.errorMessage || msg("Loading")}
                    icon="fa-times"
                >
                </ak-empty-state>
                <div class="pf-c-form__group pf-m-action">
                    ${!this.authenticating ? ke` <button
                              class="pf-c-button pf-m-primary pf-m-block"
                              @click=${() => {
      this.authenticateWrapper();
    }}
                              type="button"
                          >
                              ${msg("Retry authentication")}
                          </button>` : D}
                    ${this.renderReturnToDevicePicker()}
                </div>
            </form>
        </div>`;
  }
};
__decorateClass([
  n({ attribute: false })
], AuthenticatorValidateStageWebAuthn.prototype, "deviceChallenge", 2);
__decorateClass([
  n()
], AuthenticatorValidateStageWebAuthn.prototype, "errorMessage", 2);
__decorateClass([
  n({ type: Boolean })
], AuthenticatorValidateStageWebAuthn.prototype, "showBackButton", 2);
__decorateClass([
  r()
], AuthenticatorValidateStageWebAuthn.prototype, "authenticating", 2);
AuthenticatorValidateStageWebAuthn = __decorateClass([
  t("ak-stage-authenticator-validate-webauthn")
], AuthenticatorValidateStageWebAuthn);

// src/flow/stages/authenticator_validate/AuthenticatorValidateStage.ts
var customCSS = i`
    ul {
        padding-top: 1rem;
    }
    ul > li:not(:last-child) {
        padding-bottom: 1rem;
    }
    .authenticator-button {
        display: flex;
        align-items: center;
    }
    :host([theme="dark"]) .authenticator-button {
        color: var(--ak-dark-foreground) !important;
    }
    i {
        font-size: 1.5rem;
        padding: 1rem 0;
        width: 3rem;
    }
    .right {
        display: flex;
        flex-direction: column;
        justify-content: space-between;
        height: 100%;
        text-align: left;
    }
    .right > * {
        height: 50%;
    }
`;
var AuthenticatorValidateStage = class extends BaseStage {
  constructor() {
    super(...arguments);
    this.flowSlug = "";
    this._firstInitialized = false;
  }
  static get styles() {
    return [patternfly_base_default, login_default, form_default, form_control_default, title_default, button_default, customCSS];
  }
  set loading(value) {
    this.host.loading = value;
  }
  get loading() {
    return this.host.loading;
  }
  get brand() {
    return this.host.brand;
  }
  set selectedDeviceChallenge(value) {
    const previousChallenge = this._selectedDeviceChallenge;
    this._selectedDeviceChallenge = value;
    if (value === void 0 || value === previousChallenge) {
      return;
    }
    new FlowsApi(DEFAULT_CONFIG).flowsExecutorSolve({
      flowSlug: this.host?.flowSlug || "",
      query: window.location.search.substring(1),
      flowChallengeResponseRequest: {
        // @ts-ignore
        component: this.challenge.component || "",
        selectedChallenge: value
      }
    });
  }
  get selectedDeviceChallenge() {
    return this._selectedDeviceChallenge;
  }
  submit(payload, options) {
    return this.host?.submit(payload, options) || Promise.resolve();
  }
  willUpdate(_changed) {
    if (this._firstInitialized || !this.challenge) {
      return;
    }
    this._firstInitialized = true;
    if (this.challenge.deviceChallenges.length === 1) {
      this.selectedDeviceChallenge = this.challenge.deviceChallenges[0];
      return;
    }
    const totpChallenge = this.challenge.deviceChallenges.find(
      (challenge) => challenge.deviceClass === DeviceClassesEnum.Totp
    );
    if (PasswordManagerPrefill.totp && totpChallenge) {
      console.debug(
        "authentik/stages/authenticator_validate: found prefill totp code, selecting totp challenge"
      );
      this.selectedDeviceChallenge = totpChallenge;
      return;
    }
    const lastUsedChallenge = this.challenge.deviceChallenges.filter((deviceChallenge) => deviceChallenge.lastUsed).sort((a, b) => b.lastUsed.valueOf() - a.lastUsed.valueOf())[0];
    if (lastUsedChallenge && lastUsedChallenge.deviceClass !== DeviceClassesEnum.Static) {
      this.selectedDeviceChallenge = lastUsedChallenge;
    }
  }
  renderDevicePickerSingle(deviceChallenge) {
    switch (deviceChallenge.deviceClass) {
      case DeviceClassesEnum.Duo:
        return ke`<i class="fas fa-mobile-alt"></i>
                    <div class="right">
                        <p>${msg("Duo push-notifications")}</p>
                        <small>${msg("Receive a push notification on your device.")}</small>
                    </div>`;
      case DeviceClassesEnum.Webauthn:
        return ke`<i class="fas fa-mobile-alt"></i>
                    <div class="right">
                        <p>${msg("Authenticator")}</p>
                        <small>${msg("Use a security key to prove your identity.")}</small>
                    </div>`;
      case DeviceClassesEnum.Totp:
        return ke`<i class="fas fa-clock"></i>
                    <div class="right">
                        <p>${msg("Traditional authenticator")}</p>
                        <small>${msg("Use a code-based authenticator.")}</small>
                    </div>`;
      case DeviceClassesEnum.Static:
        return ke`<i class="fas fa-key"></i>
                    <div class="right">
                        <p>${msg("Recovery keys")}</p>
                        <small>${msg("In case you can't access any other method.")}</small>
                    </div>`;
      case DeviceClassesEnum.Sms:
        return ke`<i class="fas fa-mobile-alt"></i>
                    <div class="right">
                        <p>${msg("SMS")}</p>
                        <small>${msg("Tokens sent via SMS.")}</small>
                    </div>`;
      case DeviceClassesEnum.Email:
        return ke`<i class="fas fa-envelope-o"></i>
                    <div class="right">
                        <p>${msg("Email")}</p>
                        <small>${msg("Tokens sent via email.")}</small>
                    </div>`;
      default:
        break;
    }
    return D;
  }
  renderDevicePicker() {
    return ke`<ul>
            ${this.challenge?.deviceChallenges.map((challenges) => {
      return ke`<li>
                    <button
                        class="pf-c-button authenticator-button"
                        type="button"
                        @click=${() => {
        this.selectedDeviceChallenge = challenges;
      }}
                    >
                        ${this.renderDevicePickerSingle(challenges)}
                    </button>
                </li>`;
    })}
        </ul>`;
  }
  renderStagePicker() {
    return ke`<ul>
            ${this.challenge?.configurationStages.map((stage) => {
      return ke`<li>
                    <button
                        class="pf-c-button authenticator-button"
                        type="button"
                        @click=${() => {
        this.submit({
          component: this.challenge.component || "",
          selectedStage: stage.pk
        });
      }}
                    >
                        <div class="right">
                            <p>${stage.name}</p>
                            <small>${stage.verboseName}</small>
                        </div>
                    </button>
                </li>`;
    })}
        </ul>`;
  }
  renderDeviceChallenge() {
    if (!this.selectedDeviceChallenge) {
      return D;
    }
    switch (this.selectedDeviceChallenge?.deviceClass) {
      case DeviceClassesEnum.Static:
      case DeviceClassesEnum.Totp:
      case DeviceClassesEnum.Email:
      case DeviceClassesEnum.Sms:
        return ke` <ak-stage-authenticator-validate-code
                    .host=${this}
                    .challenge=${this.challenge}
                    .deviceChallenge=${this.selectedDeviceChallenge}
                    .showBackButton=${(this.challenge?.deviceChallenges || []).length > 1}
                >
                </ak-stage-authenticator-validate-code>`;
      case DeviceClassesEnum.Webauthn:
        return ke` <ak-stage-authenticator-validate-webauthn
                    .host=${this}
                    .challenge=${this.challenge}
                    .deviceChallenge=${this.selectedDeviceChallenge}
                    .showBackButton=${(this.challenge?.deviceChallenges || []).length > 1}
                >
                </ak-stage-authenticator-validate-webauthn>`;
      case DeviceClassesEnum.Duo:
        return ke` <ak-stage-authenticator-validate-duo
                    .host=${this}
                    .challenge=${this.challenge}
                    .deviceChallenge=${this.selectedDeviceChallenge}
                    .showBackButton=${(this.challenge?.deviceChallenges || []).length > 1}
                >
                </ak-stage-authenticator-validate-duo>`;
    }
    return D;
  }
  render() {
    return this.challenge ? ke`<header class="pf-c-login__main-header">
                      <h1 class="pf-c-title pf-m-3xl">${this.challenge.flowInfo?.title}</h1>
                  </header>
                  ${this.selectedDeviceChallenge ? this.renderDeviceChallenge() : ke`<div class="pf-c-login__main-body">
                                <form class="pf-c-form">
                                    ${this.renderUserInfo()}
                                    ${this.selectedDeviceChallenge ? "" : ke`<p>${msg("Select an authentication method.")}</p>`}
                                    ${this.challenge.configurationStages.length > 0 ? this.renderStagePicker() : ke``}
                                </form>
                                ${this.renderDevicePicker()}
                            </div>
                            <footer class="pf-c-login__main-footer">
                                <ul class="pf-c-login__main-footer-links"></ul>
                            </footer>`}` : ke`<ak-empty-state loading> </ak-empty-state>`;
  }
};
__decorateClass([
  r()
], AuthenticatorValidateStage.prototype, "_firstInitialized", 2);
__decorateClass([
  r()
], AuthenticatorValidateStage.prototype, "_selectedDeviceChallenge", 2);
AuthenticatorValidateStage = __decorateClass([
  t("ak-stage-authenticator-validate")
], AuthenticatorValidateStage);

export {
  checkWebAuthnSupport,
  transformCredentialCreateOptions,
  transformNewAssertionForServer,
  AuthenticatorValidateStage
};
//# sourceMappingURL=chunk-CO3CQRL5.js.map
