import {
  AKElement,
  BaseAPI,
  BaseTaskButton,
  CoordinateFromJSON,
  CoreApi,
  DEFAULT_CONFIG,
  EVENT_API_DRAWER_TOGGLE,
  EVENT_LOCALE_CHANGE,
  EVENT_LOCALE_REQUEST,
  EVENT_MESSAGE,
  EVENT_NOTIFICATION_DRAWER_TOGGLE,
  EVENT_REFRESH,
  EVENT_REFRESH_ENTERPRISE,
  EVENT_REQUEST_POST,
  EVENT_SIDEBAR_TOGGLE,
  EVENT_WS_MESSAGE,
  EventActionsFromJSON,
  EventActionsToJSON,
  GroupFromJSON,
  GroupMemberFromJSON,
  JSONApiResponse,
  LOCALES,
  MODAL_BUTTON_STYLES,
  ModalOrchestrationController,
  ModalShowEvent,
  PaginationFromJSON,
  QUERY_MEDIA_COLOR_LIGHT,
  ROUTE_SEPARATOR,
  RequiredError,
  RootApi,
  RouteMatch,
  Rt,
  SeverityEnumFromJSON,
  SeverityEnumToJSON,
  SystemTaskFromJSON,
  Table,
  TableColumn,
  TypeCreateFromJSON,
  UiThemeEnum,
  UsedByFromJSON,
  VoidApiResponse,
  WithBrandConfig,
  actionToLabel,
  authentikBrandContext,
  authentikConfigContext,
  authentikEnterpriseContext,
  authentikVersionContext,
  backdrop_default,
  be,
  bound,
  bullseye_default,
  button_default,
  c,
  card_default,
  configureSentry,
  content_default,
  display_default,
  docLink,
  dropdown_default,
  e,
  empty_state_default,
  enLocale,
  ensureCSSStyleSheet,
  getRelativeTime,
  getURLParam,
  globalAK,
  groupBy,
  i as i2,
  me,
  modal_box_default,
  n,
  page_default,
  patternfly_base_default,
  r,
  rootInterface,
  se,
  showMessage,
  stack_default,
  t,
  title_default,
  to,
  truncateWords,
  uiConfig,
  updateURLParams
} from "./chunk-4K6I5NCX.js";
import "./chunk-5XDLRHIR.js";
import {
  D,
  configureLocalization,
  i,
  ke,
  localized,
  msg,
  str
} from "./chunk-547S67GN.js";
import {
  __decorateClass
} from "./chunk-7AZWKBZW.js";

// node_modules/@goauthentik/api/dist/esm/models/App.js
function AppFromJSON(json) {
  return AppFromJSONTyped(json, false);
}
function AppFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "name": json["name"],
    "label": json["label"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/AuthModeEnum.js
function AuthModeEnumFromJSON(json) {
  return AuthModeEnumFromJSONTyped(json, false);
}
function AuthModeEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function AuthModeEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/ProtocolEnum.js
function ProtocolEnumFromJSON(json) {
  return ProtocolEnumFromJSONTyped(json, false);
}
function ProtocolEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function ProtocolEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/RACProvider.js
function RACProviderFromJSON(json) {
  return RACProviderFromJSONTyped(json, false);
}
function RACProviderFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "authenticationFlow": json["authentication_flow"] == null ? void 0 : json["authentication_flow"],
    "authorizationFlow": json["authorization_flow"],
    "propertyMappings": json["property_mappings"] == null ? void 0 : json["property_mappings"],
    "component": json["component"],
    "assignedApplicationSlug": json["assigned_application_slug"],
    "assignedApplicationName": json["assigned_application_name"],
    "assignedBackchannelApplicationSlug": json["assigned_backchannel_application_slug"],
    "assignedBackchannelApplicationName": json["assigned_backchannel_application_name"],
    "verboseName": json["verbose_name"],
    "verboseNamePlural": json["verbose_name_plural"],
    "metaModelName": json["meta_model_name"],
    "settings": json["settings"] == null ? void 0 : json["settings"],
    "outpostSet": json["outpost_set"],
    "connectionExpiry": json["connection_expiry"] == null ? void 0 : json["connection_expiry"],
    "deleteTokenOnDisconnect": json["delete_token_on_disconnect"] == null ? void 0 : json["delete_token_on_disconnect"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/Endpoint.js
function EndpointFromJSON(json) {
  return EndpointFromJSONTyped(json, false);
}
function EndpointFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "provider": json["provider"],
    "providerObj": RACProviderFromJSON(json["provider_obj"]),
    "protocol": ProtocolEnumFromJSON(json["protocol"]),
    "host": json["host"],
    "settings": json["settings"] == null ? void 0 : json["settings"],
    "propertyMappings": json["property_mappings"] == null ? void 0 : json["property_mappings"],
    "authMode": AuthModeEnumFromJSON(json["auth_mode"]),
    "launchUrl": json["launch_url"],
    "maximumConnections": json["maximum_connections"] == null ? void 0 : json["maximum_connections"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ConnectionToken.js
function ConnectionTokenFromJSON(json) {
  return ConnectionTokenFromJSONTyped(json, false);
}
function ConnectionTokenFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"] == null ? void 0 : json["pk"],
    "provider": json["provider"],
    "providerObj": RACProviderFromJSON(json["provider_obj"]),
    "endpoint": json["endpoint"],
    "endpointObj": EndpointFromJSON(json["endpoint_obj"]),
    "user": GroupMemberFromJSON(json["user"])
  };
}

// node_modules/@goauthentik/api/dist/esm/models/ConnectionTokenRequest.js
function ConnectionTokenRequestToJSON(json) {
  return ConnectionTokenRequestToJSONTyped(json, false);
}
function ConnectionTokenRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "pk": value["pk"],
    "provider": value["provider"],
    "endpoint": value["endpoint"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/EndpointRequest.js
function EndpointRequestToJSON(json) {
  return EndpointRequestToJSONTyped(json, false);
}
function EndpointRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"],
    "provider": value["provider"],
    "protocol": ProtocolEnumToJSON(value["protocol"]),
    "host": value["host"],
    "settings": value["settings"],
    "property_mappings": value["propertyMappings"],
    "auth_mode": AuthModeEnumToJSON(value["authMode"]),
    "maximum_connections": value["maximumConnections"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/Event.js
function EventFromJSON(json) {
  return EventFromJSONTyped(json, false);
}
function EventFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "user": json["user"] == null ? void 0 : json["user"],
    "action": EventActionsFromJSON(json["action"]),
    "app": json["app"],
    "context": json["context"] == null ? void 0 : json["context"],
    "clientIp": json["client_ip"] == null ? void 0 : json["client_ip"],
    "created": new Date(json["created"]),
    "expires": json["expires"] == null ? void 0 : new Date(json["expires"]),
    "brand": json["brand"] == null ? void 0 : json["brand"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/EventRequest.js
function EventRequestToJSON(json) {
  return EventRequestToJSONTyped(json, false);
}
function EventRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "user": value["user"],
    "action": EventActionsToJSON(value["action"]),
    "app": value["app"],
    "context": value["context"],
    "client_ip": value["clientIp"],
    "expires": value["expires"] == null ? void 0 : value["expires"].toISOString(),
    "brand": value["brand"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/EventTopPerUser.js
function EventTopPerUserFromJSON(json) {
  return EventTopPerUserFromJSONTyped(json, false);
}
function EventTopPerUserFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "application": json["application"],
    "countedEvents": json["counted_events"],
    "uniqueUsers": json["unique_users"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/InstallID.js
function InstallIDFromJSON(json) {
  return InstallIDFromJSONTyped(json, false);
}
function InstallIDFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "installId": json["install_id"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/License.js
function LicenseFromJSON(json) {
  return LicenseFromJSONTyped(json, false);
}
function LicenseFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "licenseUuid": json["license_uuid"],
    "name": json["name"],
    "key": json["key"],
    "expiry": new Date(json["expiry"]),
    "internalUsers": json["internal_users"],
    "externalUsers": json["external_users"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/LicenseFlagsEnum.js
var LicenseFlagsEnum = {
  Trial: "trial",
  NonProduction: "non_production",
  UnknownDefaultOpenApi: "11184809"
};
function LicenseFlagsEnumFromJSON(json) {
  return LicenseFlagsEnumFromJSONTyped(json, false);
}
function LicenseFlagsEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}

// node_modules/@goauthentik/api/dist/esm/models/LicenseForecast.js
function LicenseForecastFromJSON(json) {
  return LicenseForecastFromJSONTyped(json, false);
}
function LicenseForecastFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "internalUsers": json["internal_users"],
    "externalUsers": json["external_users"],
    "forecastedInternalUsers": json["forecasted_internal_users"],
    "forecastedExternalUsers": json["forecasted_external_users"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/LicenseRequest.js
function LicenseRequestToJSON(json) {
  return LicenseRequestToJSONTyped(json, false);
}
function LicenseRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "key": value["key"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/LicenseSummaryStatusEnum.js
var LicenseSummaryStatusEnum = {
  Unlicensed: "unlicensed",
  Valid: "valid",
  Expired: "expired",
  ExpirySoon: "expiry_soon",
  LimitExceededAdmin: "limit_exceeded_admin",
  LimitExceededUser: "limit_exceeded_user",
  ReadOnly: "read_only",
  UnknownDefaultOpenApi: "11184809"
};
function LicenseSummaryStatusEnumFromJSON(json) {
  return LicenseSummaryStatusEnumFromJSONTyped(json, false);
}
function LicenseSummaryStatusEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}

// node_modules/@goauthentik/api/dist/esm/models/LicenseSummary.js
function LicenseSummaryFromJSON(json) {
  return LicenseSummaryFromJSONTyped(json, false);
}
function LicenseSummaryFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "internalUsers": json["internal_users"],
    "externalUsers": json["external_users"],
    "status": LicenseSummaryStatusEnumFromJSON(json["status"]),
    "latestValid": new Date(json["latest_valid"]),
    "licenseFlags": json["license_flags"].map(LicenseFlagsEnumFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/LoginMetrics.js
function LoginMetricsFromJSON(json) {
  return LoginMetricsFromJSONTyped(json, false);
}
function LoginMetricsFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "logins": json["logins"].map(CoordinateFromJSON),
    "loginsFailed": json["logins_failed"].map(CoordinateFromJSON),
    "authorizations": json["authorizations"].map(CoordinateFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/Notification.js
function NotificationFromJSON(json) {
  return NotificationFromJSONTyped(json, false);
}
function NotificationFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "severity": SeverityEnumFromJSON(json["severity"]),
    "body": json["body"],
    "created": new Date(json["created"]),
    "event": json["event"] == null ? void 0 : EventFromJSON(json["event"]),
    "seen": json["seen"] == null ? void 0 : json["seen"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/NotificationRequest.js
function NotificationRequestToJSON(json) {
  return NotificationRequestToJSONTyped(json, false);
}
function NotificationRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "event": EventRequestToJSON(value["event"]),
    "seen": value["seen"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/NotificationRule.js
function NotificationRuleFromJSON(json) {
  return NotificationRuleFromJSONTyped(json, false);
}
function NotificationRuleFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "transports": json["transports"] == null ? void 0 : json["transports"],
    "severity": json["severity"] == null ? void 0 : SeverityEnumFromJSON(json["severity"]),
    "group": json["group"] == null ? void 0 : json["group"],
    "groupObj": GroupFromJSON(json["group_obj"])
  };
}

// node_modules/@goauthentik/api/dist/esm/models/NotificationRuleRequest.js
function NotificationRuleRequestToJSON(json) {
  return NotificationRuleRequestToJSONTyped(json, false);
}
function NotificationRuleRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"],
    "transports": value["transports"],
    "severity": SeverityEnumToJSON(value["severity"]),
    "group": value["group"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/NotificationTransportModeEnum.js
function NotificationTransportModeEnumFromJSON(json) {
  return NotificationTransportModeEnumFromJSONTyped(json, false);
}
function NotificationTransportModeEnumFromJSONTyped(json, ignoreDiscriminator) {
  return json;
}
function NotificationTransportModeEnumToJSON(value) {
  return value;
}

// node_modules/@goauthentik/api/dist/esm/models/NotificationTransport.js
function NotificationTransportFromJSON(json) {
  return NotificationTransportFromJSONTyped(json, false);
}
function NotificationTransportFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pk": json["pk"],
    "name": json["name"],
    "mode": json["mode"] == null ? void 0 : NotificationTransportModeEnumFromJSON(json["mode"]),
    "modeVerbose": json["mode_verbose"],
    "webhookUrl": json["webhook_url"] == null ? void 0 : json["webhook_url"],
    "webhookMapping": json["webhook_mapping"] == null ? void 0 : json["webhook_mapping"],
    "sendOnce": json["send_once"] == null ? void 0 : json["send_once"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/NotificationTransportRequest.js
function NotificationTransportRequestToJSON(json) {
  return NotificationTransportRequestToJSONTyped(json, false);
}
function NotificationTransportRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"],
    "mode": NotificationTransportModeEnumToJSON(value["mode"]),
    "webhook_url": value["webhookUrl"],
    "webhook_mapping": value["webhookMapping"],
    "send_once": value["sendOnce"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/NotificationTransportTest.js
function NotificationTransportTestFromJSON(json) {
  return NotificationTransportTestFromJSONTyped(json, false);
}
function NotificationTransportTestFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "messages": json["messages"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedConnectionTokenList.js
function PaginatedConnectionTokenListFromJSON(json) {
  return PaginatedConnectionTokenListFromJSONTyped(json, false);
}
function PaginatedConnectionTokenListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(ConnectionTokenFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedEndpointList.js
function PaginatedEndpointListFromJSON(json) {
  return PaginatedEndpointListFromJSONTyped(json, false);
}
function PaginatedEndpointListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(EndpointFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedEventList.js
function PaginatedEventListFromJSON(json) {
  return PaginatedEventListFromJSONTyped(json, false);
}
function PaginatedEventListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(EventFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedLicenseList.js
function PaginatedLicenseListFromJSON(json) {
  return PaginatedLicenseListFromJSONTyped(json, false);
}
function PaginatedLicenseListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(LicenseFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedNotificationList.js
function PaginatedNotificationListFromJSON(json) {
  return PaginatedNotificationListFromJSONTyped(json, false);
}
function PaginatedNotificationListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(NotificationFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedNotificationRuleList.js
function PaginatedNotificationRuleListFromJSON(json) {
  return PaginatedNotificationRuleListFromJSONTyped(json, false);
}
function PaginatedNotificationRuleListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(NotificationRuleFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedNotificationTransportList.js
function PaginatedNotificationTransportListFromJSON(json) {
  return PaginatedNotificationTransportListFromJSONTyped(json, false);
}
function PaginatedNotificationTransportListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(NotificationTransportFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PaginatedSystemTaskList.js
function PaginatedSystemTaskListFromJSON(json) {
  return PaginatedSystemTaskListFromJSONTyped(json, false);
}
function PaginatedSystemTaskListFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pagination": PaginationFromJSON(json["pagination"]),
    "results": json["results"].map(SystemTaskFromJSON)
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedConnectionTokenRequest.js
function PatchedConnectionTokenRequestToJSON(json) {
  return PatchedConnectionTokenRequestToJSONTyped(json, false);
}
function PatchedConnectionTokenRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "pk": value["pk"],
    "provider": value["provider"],
    "endpoint": value["endpoint"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedEndpointRequest.js
function PatchedEndpointRequestToJSON(json) {
  return PatchedEndpointRequestToJSONTyped(json, false);
}
function PatchedEndpointRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"],
    "provider": value["provider"],
    "protocol": ProtocolEnumToJSON(value["protocol"]),
    "host": value["host"],
    "settings": value["settings"],
    "property_mappings": value["propertyMappings"],
    "auth_mode": AuthModeEnumToJSON(value["authMode"]),
    "maximum_connections": value["maximumConnections"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedEventRequest.js
function PatchedEventRequestToJSON(json) {
  return PatchedEventRequestToJSONTyped(json, false);
}
function PatchedEventRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "user": value["user"],
    "action": EventActionsToJSON(value["action"]),
    "app": value["app"],
    "context": value["context"],
    "client_ip": value["clientIp"],
    "expires": value["expires"] == null ? void 0 : value["expires"].toISOString(),
    "brand": value["brand"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedLicenseRequest.js
function PatchedLicenseRequestToJSON(json) {
  return PatchedLicenseRequestToJSONTyped(json, false);
}
function PatchedLicenseRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "key": value["key"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedNotificationRequest.js
function PatchedNotificationRequestToJSON(json) {
  return PatchedNotificationRequestToJSONTyped(json, false);
}
function PatchedNotificationRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "event": EventRequestToJSON(value["event"]),
    "seen": value["seen"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedNotificationRuleRequest.js
function PatchedNotificationRuleRequestToJSON(json) {
  return PatchedNotificationRuleRequestToJSONTyped(json, false);
}
function PatchedNotificationRuleRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"],
    "transports": value["transports"],
    "severity": SeverityEnumToJSON(value["severity"]),
    "group": value["group"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedNotificationTransportRequest.js
function PatchedNotificationTransportRequestToJSON(json) {
  return PatchedNotificationTransportRequestToJSONTyped(json, false);
}
function PatchedNotificationTransportRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "name": value["name"],
    "mode": NotificationTransportModeEnumToJSON(value["mode"]),
    "webhook_url": value["webhookUrl"],
    "webhook_mapping": value["webhookMapping"],
    "send_once": value["sendOnce"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/PatchedSettingsRequest.js
function PatchedSettingsRequestToJSON(json) {
  return PatchedSettingsRequestToJSONTyped(json, false);
}
function PatchedSettingsRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "avatars": value["avatars"],
    "default_user_change_name": value["defaultUserChangeName"],
    "default_user_change_email": value["defaultUserChangeEmail"],
    "default_user_change_username": value["defaultUserChangeUsername"],
    "event_retention": value["eventRetention"],
    "footer_links": value["footerLinks"],
    "gdpr_compliance": value["gdprCompliance"],
    "impersonation": value["impersonation"],
    "impersonation_require_reason": value["impersonationRequireReason"],
    "default_token_duration": value["defaultTokenDuration"],
    "default_token_length": value["defaultTokenLength"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/Settings.js
function SettingsFromJSON(json) {
  return SettingsFromJSONTyped(json, false);
}
function SettingsFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "avatars": json["avatars"] == null ? void 0 : json["avatars"],
    "defaultUserChangeName": json["default_user_change_name"] == null ? void 0 : json["default_user_change_name"],
    "defaultUserChangeEmail": json["default_user_change_email"] == null ? void 0 : json["default_user_change_email"],
    "defaultUserChangeUsername": json["default_user_change_username"] == null ? void 0 : json["default_user_change_username"],
    "eventRetention": json["event_retention"] == null ? void 0 : json["event_retention"],
    "footerLinks": json["footer_links"] == null ? void 0 : json["footer_links"],
    "gdprCompliance": json["gdpr_compliance"] == null ? void 0 : json["gdpr_compliance"],
    "impersonation": json["impersonation"] == null ? void 0 : json["impersonation"],
    "impersonationRequireReason": json["impersonation_require_reason"] == null ? void 0 : json["impersonation_require_reason"],
    "defaultTokenDuration": json["default_token_duration"] == null ? void 0 : json["default_token_duration"],
    "defaultTokenLength": json["default_token_length"] == null ? void 0 : json["default_token_length"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SettingsRequest.js
function SettingsRequestToJSON(json) {
  return SettingsRequestToJSONTyped(json, false);
}
function SettingsRequestToJSONTyped(value, ignoreDiscriminator = false) {
  if (value == null) {
    return value;
  }
  return {
    "avatars": value["avatars"],
    "default_user_change_name": value["defaultUserChangeName"],
    "default_user_change_email": value["defaultUserChangeEmail"],
    "default_user_change_username": value["defaultUserChangeUsername"],
    "event_retention": value["eventRetention"],
    "footer_links": value["footerLinks"],
    "gdpr_compliance": value["gdprCompliance"],
    "impersonation": value["impersonation"],
    "impersonation_require_reason": value["impersonationRequireReason"],
    "default_token_duration": value["defaultTokenDuration"],
    "default_token_length": value["defaultTokenLength"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SystemInfoRuntime.js
function SystemInfoRuntimeFromJSON(json) {
  return SystemInfoRuntimeFromJSONTyped(json, false);
}
function SystemInfoRuntimeFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "pythonVersion": json["python_version"],
    "environment": json["environment"],
    "architecture": json["architecture"],
    "platform": json["platform"],
    "uname": json["uname"],
    "opensslVersion": json["openssl_version"],
    "opensslFipsEnabled": json["openssl_fips_enabled"],
    "authentikVersion": json["authentik_version"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/SystemInfo.js
function SystemInfoFromJSON(json) {
  return SystemInfoFromJSONTyped(json, false);
}
function SystemInfoFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "httpHeaders": json["http_headers"],
    "httpHost": json["http_host"],
    "httpIsSecure": json["http_is_secure"],
    "runtime": SystemInfoRuntimeFromJSON(json["runtime"]),
    "brand": json["brand"],
    "serverTime": new Date(json["server_time"]),
    "embeddedOutpostDisabled": json["embedded_outpost_disabled"],
    "embeddedOutpostHost": json["embedded_outpost_host"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/Version.js
function VersionFromJSON(json) {
  return VersionFromJSONTyped(json, false);
}
function VersionFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "versionCurrent": json["version_current"],
    "versionLatest": json["version_latest"],
    "versionLatestValid": json["version_latest_valid"],
    "buildHash": json["build_hash"],
    "outdated": json["outdated"],
    "outpostOutdated": json["outpost_outdated"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/VersionHistory.js
function VersionHistoryFromJSON(json) {
  return VersionHistoryFromJSONTyped(json, false);
}
function VersionHistoryFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "id": json["id"],
    "timestamp": new Date(json["timestamp"]),
    "version": json["version"],
    "build": json["build"]
  };
}

// node_modules/@goauthentik/api/dist/esm/models/Worker.js
function WorkerFromJSON(json) {
  return WorkerFromJSONTyped(json, false);
}
function WorkerFromJSONTyped(json, ignoreDiscriminator) {
  if (json == null) {
    return json;
  }
  return {
    "workerId": json["worker_id"],
    "version": json["version"],
    "versionMatching": json["version_matching"]
  };
}

// node_modules/@goauthentik/api/dist/esm/apis/AdminApi.js
var __awaiter = function(thisArg, _arguments, P2, generator) {
  function adopt(value) {
    return value instanceof P2 ? value : new P2(function(resolve) {
      resolve(value);
    });
  }
  return new (P2 || (P2 = Promise))(function(resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e3) {
        reject(e3);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e3) {
        reject(e3);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var AdminApi = class extends BaseAPI {
  /**
   * Read-only view list all installed apps
   */
  adminAppsListRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/apps/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(AppFromJSON));
    });
  }
  /**
   * Read-only view list all installed apps
   */
  adminAppsList(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.adminAppsListRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Login Metrics per 1h
   */
  adminMetricsRetrieveRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/metrics/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LoginMetricsFromJSON(jsonValue));
    });
  }
  /**
   * Login Metrics per 1h
   */
  adminMetricsRetrieve(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.adminMetricsRetrieveRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Read-only view list all installed models
   */
  adminModelsListRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/models/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(AppFromJSON));
    });
  }
  /**
   * Read-only view list all installed models
   */
  adminModelsList(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.adminModelsListRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Settings view
   */
  adminSettingsPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/settings/`,
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedSettingsRequestToJSON(requestParameters["patchedSettingsRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SettingsFromJSON(jsonValue));
    });
  }
  /**
   * Settings view
   */
  adminSettingsPartialUpdate() {
    return __awaiter(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.adminSettingsPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Settings view
   */
  adminSettingsRetrieveRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/settings/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SettingsFromJSON(jsonValue));
    });
  }
  /**
   * Settings view
   */
  adminSettingsRetrieve(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.adminSettingsRetrieveRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Settings view
   */
  adminSettingsUpdateRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/settings/`,
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: SettingsRequestToJSON(requestParameters["settingsRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SettingsFromJSON(jsonValue));
    });
  }
  /**
   * Settings view
   */
  adminSettingsUpdate() {
    return __awaiter(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.adminSettingsUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get system information.
   */
  adminSystemCreateRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/system/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SystemInfoFromJSON(jsonValue));
    });
  }
  /**
   * Get system information.
   */
  adminSystemCreate(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.adminSystemCreateRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get system information.
   */
  adminSystemRetrieveRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/system/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SystemInfoFromJSON(jsonValue));
    });
  }
  /**
   * Get system information.
   */
  adminSystemRetrieve(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.adminSystemRetrieveRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * VersionHistory Viewset
   */
  adminVersionHistoryListRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["build"] != null) {
        queryParameters["build"] = requestParameters["build"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      if (requestParameters["version"] != null) {
        queryParameters["version"] = requestParameters["version"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/version/history/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(VersionHistoryFromJSON));
    });
  }
  /**
   * VersionHistory Viewset
   */
  adminVersionHistoryList() {
    return __awaiter(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.adminVersionHistoryListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * VersionHistory Viewset
   */
  adminVersionHistoryRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      if (requestParameters["id"] == null) {
        throw new RequiredError("id", 'Required parameter "id" was null or undefined when calling adminVersionHistoryRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/version/history/{id}/`.replace(`{${"id"}}`, encodeURIComponent(String(requestParameters["id"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => VersionHistoryFromJSON(jsonValue));
    });
  }
  /**
   * VersionHistory Viewset
   */
  adminVersionHistoryRetrieve(requestParameters, initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.adminVersionHistoryRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get running and latest version.
   */
  adminVersionRetrieveRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/version/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => VersionFromJSON(jsonValue));
    });
  }
  /**
   * Get running and latest version.
   */
  adminVersionRetrieve(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.adminVersionRetrieveRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get currently connected worker count.
   */
  adminWorkersListRaw(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/admin/workers/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(WorkerFromJSON));
    });
  }
  /**
   * Get currently connected worker count.
   */
  adminWorkersList(initOverrides) {
    return __awaiter(this, void 0, void 0, function* () {
      const response = yield this.adminWorkersListRaw(initOverrides);
      return yield response.value();
    });
  }
};

// node_modules/@goauthentik/api/dist/esm/apis/EnterpriseApi.js
var __awaiter2 = function(thisArg, _arguments, P2, generator) {
  function adopt(value) {
    return value instanceof P2 ? value : new P2(function(resolve) {
      resolve(value);
    });
  }
  return new (P2 || (P2 = Promise))(function(resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e3) {
        reject(e3);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e3) {
        reject(e3);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var EnterpriseApi = class extends BaseAPI {
  /**
   * License Viewset
   */
  enterpriseLicenseCreateRaw(requestParameters, initOverrides) {
    return __awaiter2(this, void 0, void 0, function* () {
      if (requestParameters["licenseRequest"] == null) {
        throw new RequiredError("licenseRequest", 'Required parameter "licenseRequest" was null or undefined when calling enterpriseLicenseCreate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/enterprise/license/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: LicenseRequestToJSON(requestParameters["licenseRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LicenseFromJSON(jsonValue));
    });
  }
  /**
   * License Viewset
   */
  enterpriseLicenseCreate(requestParameters, initOverrides) {
    return __awaiter2(this, void 0, void 0, function* () {
      const response = yield this.enterpriseLicenseCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * License Viewset
   */
  enterpriseLicenseDestroyRaw(requestParameters, initOverrides) {
    return __awaiter2(this, void 0, void 0, function* () {
      if (requestParameters["licenseUuid"] == null) {
        throw new RequiredError("licenseUuid", 'Required parameter "licenseUuid" was null or undefined when calling enterpriseLicenseDestroy().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/enterprise/license/{license_uuid}/`.replace(`{${"license_uuid"}}`, encodeURIComponent(String(requestParameters["licenseUuid"]))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * License Viewset
   */
  enterpriseLicenseDestroy(requestParameters, initOverrides) {
    return __awaiter2(this, void 0, void 0, function* () {
      yield this.enterpriseLicenseDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Forecast how many users will be required in a year
   */
  enterpriseLicenseForecastRetrieveRaw(initOverrides) {
    return __awaiter2(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/enterprise/license/forecast/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LicenseForecastFromJSON(jsonValue));
    });
  }
  /**
   * Forecast how many users will be required in a year
   */
  enterpriseLicenseForecastRetrieve(initOverrides) {
    return __awaiter2(this, void 0, void 0, function* () {
      const response = yield this.enterpriseLicenseForecastRetrieveRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get install_id
   */
  enterpriseLicenseInstallIdRetrieveRaw(initOverrides) {
    return __awaiter2(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/enterprise/license/install_id/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => InstallIDFromJSON(jsonValue));
    });
  }
  /**
   * Get install_id
   */
  enterpriseLicenseInstallIdRetrieve(initOverrides) {
    return __awaiter2(this, void 0, void 0, function* () {
      const response = yield this.enterpriseLicenseInstallIdRetrieveRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * License Viewset
   */
  enterpriseLicenseListRaw(requestParameters, initOverrides) {
    return __awaiter2(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["name"] != null) {
        queryParameters["name"] = requestParameters["name"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/enterprise/license/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedLicenseListFromJSON(jsonValue));
    });
  }
  /**
   * License Viewset
   */
  enterpriseLicenseList() {
    return __awaiter2(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.enterpriseLicenseListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * License Viewset
   */
  enterpriseLicensePartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter2(this, void 0, void 0, function* () {
      if (requestParameters["licenseUuid"] == null) {
        throw new RequiredError("licenseUuid", 'Required parameter "licenseUuid" was null or undefined when calling enterpriseLicensePartialUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/enterprise/license/{license_uuid}/`.replace(`{${"license_uuid"}}`, encodeURIComponent(String(requestParameters["licenseUuid"]))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedLicenseRequestToJSON(requestParameters["patchedLicenseRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LicenseFromJSON(jsonValue));
    });
  }
  /**
   * License Viewset
   */
  enterpriseLicensePartialUpdate(requestParameters, initOverrides) {
    return __awaiter2(this, void 0, void 0, function* () {
      const response = yield this.enterpriseLicensePartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * License Viewset
   */
  enterpriseLicenseRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter2(this, void 0, void 0, function* () {
      if (requestParameters["licenseUuid"] == null) {
        throw new RequiredError("licenseUuid", 'Required parameter "licenseUuid" was null or undefined when calling enterpriseLicenseRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/enterprise/license/{license_uuid}/`.replace(`{${"license_uuid"}}`, encodeURIComponent(String(requestParameters["licenseUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LicenseFromJSON(jsonValue));
    });
  }
  /**
   * License Viewset
   */
  enterpriseLicenseRetrieve(requestParameters, initOverrides) {
    return __awaiter2(this, void 0, void 0, function* () {
      const response = yield this.enterpriseLicenseRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get the total license status
   */
  enterpriseLicenseSummaryRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter2(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["cached"] != null) {
        queryParameters["cached"] = requestParameters["cached"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/enterprise/license/summary/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LicenseSummaryFromJSON(jsonValue));
    });
  }
  /**
   * Get the total license status
   */
  enterpriseLicenseSummaryRetrieve() {
    return __awaiter2(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.enterpriseLicenseSummaryRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * License Viewset
   */
  enterpriseLicenseUpdateRaw(requestParameters, initOverrides) {
    return __awaiter2(this, void 0, void 0, function* () {
      if (requestParameters["licenseUuid"] == null) {
        throw new RequiredError("licenseUuid", 'Required parameter "licenseUuid" was null or undefined when calling enterpriseLicenseUpdate().');
      }
      if (requestParameters["licenseRequest"] == null) {
        throw new RequiredError("licenseRequest", 'Required parameter "licenseRequest" was null or undefined when calling enterpriseLicenseUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/enterprise/license/{license_uuid}/`.replace(`{${"license_uuid"}}`, encodeURIComponent(String(requestParameters["licenseUuid"]))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: LicenseRequestToJSON(requestParameters["licenseRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => LicenseFromJSON(jsonValue));
    });
  }
  /**
   * License Viewset
   */
  enterpriseLicenseUpdate(requestParameters, initOverrides) {
    return __awaiter2(this, void 0, void 0, function* () {
      const response = yield this.enterpriseLicenseUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  enterpriseLicenseUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter2(this, void 0, void 0, function* () {
      if (requestParameters["licenseUuid"] == null) {
        throw new RequiredError("licenseUuid", 'Required parameter "licenseUuid" was null or undefined when calling enterpriseLicenseUsedByList().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/enterprise/license/{license_uuid}/used_by/`.replace(`{${"license_uuid"}}`, encodeURIComponent(String(requestParameters["licenseUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  enterpriseLicenseUsedByList(requestParameters, initOverrides) {
    return __awaiter2(this, void 0, void 0, function* () {
      const response = yield this.enterpriseLicenseUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
};

// node_modules/@goauthentik/api/dist/esm/apis/EventsApi.js
var __awaiter3 = function(thisArg, _arguments, P2, generator) {
  function adopt(value) {
    return value instanceof P2 ? value : new P2(function(resolve) {
      resolve(value);
    });
  }
  return new (P2 || (P2 = Promise))(function(resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e3) {
        reject(e3);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e3) {
        reject(e3);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var EventsApi = class extends BaseAPI {
  /**
   * Get all actions
   */
  eventsEventsActionsListRaw(initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/events/actions/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(TypeCreateFromJSON));
    });
  }
  /**
   * Get all actions
   */
  eventsEventsActionsList(initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsEventsActionsListRaw(initOverrides);
      return yield response.value();
    });
  }
  /**
   * Event Read-Only Viewset
   */
  eventsEventsCreateRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["eventRequest"] == null) {
        throw new RequiredError("eventRequest", 'Required parameter "eventRequest" was null or undefined when calling eventsEventsCreate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/events/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: EventRequestToJSON(requestParameters["eventRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EventFromJSON(jsonValue));
    });
  }
  /**
   * Event Read-Only Viewset
   */
  eventsEventsCreate(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsEventsCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Event Read-Only Viewset
   */
  eventsEventsDestroyRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["eventUuid"] == null) {
        throw new RequiredError("eventUuid", 'Required parameter "eventUuid" was null or undefined when calling eventsEventsDestroy().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/events/{event_uuid}/`.replace(`{${"event_uuid"}}`, encodeURIComponent(String(requestParameters["eventUuid"]))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Event Read-Only Viewset
   */
  eventsEventsDestroy(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      yield this.eventsEventsDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Event Read-Only Viewset
   */
  eventsEventsListRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["action"] != null) {
        queryParameters["action"] = requestParameters["action"];
      }
      if (requestParameters["brandName"] != null) {
        queryParameters["brand_name"] = requestParameters["brandName"];
      }
      if (requestParameters["clientIp"] != null) {
        queryParameters["client_ip"] = requestParameters["clientIp"];
      }
      if (requestParameters["contextAuthorizedApp"] != null) {
        queryParameters["context_authorized_app"] = requestParameters["contextAuthorizedApp"];
      }
      if (requestParameters["contextModelApp"] != null) {
        queryParameters["context_model_app"] = requestParameters["contextModelApp"];
      }
      if (requestParameters["contextModelName"] != null) {
        queryParameters["context_model_name"] = requestParameters["contextModelName"];
      }
      if (requestParameters["contextModelPk"] != null) {
        queryParameters["context_model_pk"] = requestParameters["contextModelPk"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      if (requestParameters["username"] != null) {
        queryParameters["username"] = requestParameters["username"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/events/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedEventListFromJSON(jsonValue));
    });
  }
  /**
   * Event Read-Only Viewset
   */
  eventsEventsList() {
    return __awaiter3(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.eventsEventsListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Event Read-Only Viewset
   */
  eventsEventsPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["eventUuid"] == null) {
        throw new RequiredError("eventUuid", 'Required parameter "eventUuid" was null or undefined when calling eventsEventsPartialUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/events/{event_uuid}/`.replace(`{${"event_uuid"}}`, encodeURIComponent(String(requestParameters["eventUuid"]))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedEventRequestToJSON(requestParameters["patchedEventRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EventFromJSON(jsonValue));
    });
  }
  /**
   * Event Read-Only Viewset
   */
  eventsEventsPartialUpdate(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsEventsPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get the count of events per month
   */
  eventsEventsPerMonthListRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["action"] != null) {
        queryParameters["action"] = requestParameters["action"];
      }
      if (requestParameters["query"] != null) {
        queryParameters["query"] = requestParameters["query"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/events/per_month/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(CoordinateFromJSON));
    });
  }
  /**
   * Get the count of events per month
   */
  eventsEventsPerMonthList() {
    return __awaiter3(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.eventsEventsPerMonthListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Event Read-Only Viewset
   */
  eventsEventsRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["eventUuid"] == null) {
        throw new RequiredError("eventUuid", 'Required parameter "eventUuid" was null or undefined when calling eventsEventsRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/events/{event_uuid}/`.replace(`{${"event_uuid"}}`, encodeURIComponent(String(requestParameters["eventUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EventFromJSON(jsonValue));
    });
  }
  /**
   * Event Read-Only Viewset
   */
  eventsEventsRetrieve(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsEventsRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get the top_n events grouped by user count
   */
  eventsEventsTopPerUserListRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["action"] != null) {
        queryParameters["action"] = requestParameters["action"];
      }
      if (requestParameters["topN"] != null) {
        queryParameters["top_n"] = requestParameters["topN"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/events/top_per_user/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(EventTopPerUserFromJSON));
    });
  }
  /**
   * Get the top_n events grouped by user count
   */
  eventsEventsTopPerUserList() {
    return __awaiter3(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.eventsEventsTopPerUserListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Event Read-Only Viewset
   */
  eventsEventsUpdateRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["eventUuid"] == null) {
        throw new RequiredError("eventUuid", 'Required parameter "eventUuid" was null or undefined when calling eventsEventsUpdate().');
      }
      if (requestParameters["eventRequest"] == null) {
        throw new RequiredError("eventRequest", 'Required parameter "eventRequest" was null or undefined when calling eventsEventsUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/events/{event_uuid}/`.replace(`{${"event_uuid"}}`, encodeURIComponent(String(requestParameters["eventUuid"]))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: EventRequestToJSON(requestParameters["eventRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EventFromJSON(jsonValue));
    });
  }
  /**
   * Event Read-Only Viewset
   */
  eventsEventsUpdate(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsEventsUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get event volume for specified filters and timeframe
   */
  eventsEventsVolumeListRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["action"] != null) {
        queryParameters["action"] = requestParameters["action"];
      }
      if (requestParameters["brandName"] != null) {
        queryParameters["brand_name"] = requestParameters["brandName"];
      }
      if (requestParameters["clientIp"] != null) {
        queryParameters["client_ip"] = requestParameters["clientIp"];
      }
      if (requestParameters["contextAuthorizedApp"] != null) {
        queryParameters["context_authorized_app"] = requestParameters["contextAuthorizedApp"];
      }
      if (requestParameters["contextModelApp"] != null) {
        queryParameters["context_model_app"] = requestParameters["contextModelApp"];
      }
      if (requestParameters["contextModelName"] != null) {
        queryParameters["context_model_name"] = requestParameters["contextModelName"];
      }
      if (requestParameters["contextModelPk"] != null) {
        queryParameters["context_model_pk"] = requestParameters["contextModelPk"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      if (requestParameters["username"] != null) {
        queryParameters["username"] = requestParameters["username"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/events/volume/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(CoordinateFromJSON));
    });
  }
  /**
   * Get event volume for specified filters and timeframe
   */
  eventsEventsVolumeList() {
    return __awaiter3(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.eventsEventsVolumeListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Notification Viewset
   */
  eventsNotificationsDestroyRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["uuid"] == null) {
        throw new RequiredError("uuid", 'Required parameter "uuid" was null or undefined when calling eventsNotificationsDestroy().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/notifications/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters["uuid"]))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Notification Viewset
   */
  eventsNotificationsDestroy(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      yield this.eventsNotificationsDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * Notification Viewset
   */
  eventsNotificationsListRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["body"] != null) {
        queryParameters["body"] = requestParameters["body"];
      }
      if (requestParameters["created"] != null) {
        queryParameters["created"] = requestParameters["created"].toISOString();
      }
      if (requestParameters["event"] != null) {
        queryParameters["event"] = requestParameters["event"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      if (requestParameters["seen"] != null) {
        queryParameters["seen"] = requestParameters["seen"];
      }
      if (requestParameters["severity"] != null) {
        queryParameters["severity"] = requestParameters["severity"];
      }
      if (requestParameters["user"] != null) {
        queryParameters["user"] = requestParameters["user"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/notifications/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedNotificationListFromJSON(jsonValue));
    });
  }
  /**
   * Notification Viewset
   */
  eventsNotificationsList() {
    return __awaiter3(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.eventsNotificationsListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Mark all the user\'s notifications as seen
   */
  eventsNotificationsMarkAllSeenCreateRaw(initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/notifications/mark_all_seen/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Mark all the user\'s notifications as seen
   */
  eventsNotificationsMarkAllSeenCreate(initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      yield this.eventsNotificationsMarkAllSeenCreateRaw(initOverrides);
    });
  }
  /**
   * Notification Viewset
   */
  eventsNotificationsPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["uuid"] == null) {
        throw new RequiredError("uuid", 'Required parameter "uuid" was null or undefined when calling eventsNotificationsPartialUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/notifications/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters["uuid"]))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedNotificationRequestToJSON(requestParameters["patchedNotificationRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => NotificationFromJSON(jsonValue));
    });
  }
  /**
   * Notification Viewset
   */
  eventsNotificationsPartialUpdate(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsNotificationsPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Notification Viewset
   */
  eventsNotificationsRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["uuid"] == null) {
        throw new RequiredError("uuid", 'Required parameter "uuid" was null or undefined when calling eventsNotificationsRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/notifications/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters["uuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => NotificationFromJSON(jsonValue));
    });
  }
  /**
   * Notification Viewset
   */
  eventsNotificationsRetrieve(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsNotificationsRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Notification Viewset
   */
  eventsNotificationsUpdateRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["uuid"] == null) {
        throw new RequiredError("uuid", 'Required parameter "uuid" was null or undefined when calling eventsNotificationsUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/notifications/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters["uuid"]))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: NotificationRequestToJSON(requestParameters["notificationRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => NotificationFromJSON(jsonValue));
    });
  }
  /**
   * Notification Viewset
   */
  eventsNotificationsUpdate(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsNotificationsUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  eventsNotificationsUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["uuid"] == null) {
        throw new RequiredError("uuid", 'Required parameter "uuid" was null or undefined when calling eventsNotificationsUsedByList().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/notifications/{uuid}/used_by/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters["uuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  eventsNotificationsUsedByList(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsNotificationsUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * NotificationRule Viewset
   */
  eventsRulesCreateRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["notificationRuleRequest"] == null) {
        throw new RequiredError("notificationRuleRequest", 'Required parameter "notificationRuleRequest" was null or undefined when calling eventsRulesCreate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/rules/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: NotificationRuleRequestToJSON(requestParameters["notificationRuleRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => NotificationRuleFromJSON(jsonValue));
    });
  }
  /**
   * NotificationRule Viewset
   */
  eventsRulesCreate(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsRulesCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * NotificationRule Viewset
   */
  eventsRulesDestroyRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["pbmUuid"] == null) {
        throw new RequiredError("pbmUuid", 'Required parameter "pbmUuid" was null or undefined when calling eventsRulesDestroy().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/rules/{pbm_uuid}/`.replace(`{${"pbm_uuid"}}`, encodeURIComponent(String(requestParameters["pbmUuid"]))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * NotificationRule Viewset
   */
  eventsRulesDestroy(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      yield this.eventsRulesDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * NotificationRule Viewset
   */
  eventsRulesListRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["groupName"] != null) {
        queryParameters["group__name"] = requestParameters["groupName"];
      }
      if (requestParameters["name"] != null) {
        queryParameters["name"] = requestParameters["name"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      if (requestParameters["severity"] != null) {
        queryParameters["severity"] = requestParameters["severity"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/rules/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedNotificationRuleListFromJSON(jsonValue));
    });
  }
  /**
   * NotificationRule Viewset
   */
  eventsRulesList() {
    return __awaiter3(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.eventsRulesListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * NotificationRule Viewset
   */
  eventsRulesPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["pbmUuid"] == null) {
        throw new RequiredError("pbmUuid", 'Required parameter "pbmUuid" was null or undefined when calling eventsRulesPartialUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/rules/{pbm_uuid}/`.replace(`{${"pbm_uuid"}}`, encodeURIComponent(String(requestParameters["pbmUuid"]))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedNotificationRuleRequestToJSON(requestParameters["patchedNotificationRuleRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => NotificationRuleFromJSON(jsonValue));
    });
  }
  /**
   * NotificationRule Viewset
   */
  eventsRulesPartialUpdate(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsRulesPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * NotificationRule Viewset
   */
  eventsRulesRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["pbmUuid"] == null) {
        throw new RequiredError("pbmUuid", 'Required parameter "pbmUuid" was null or undefined when calling eventsRulesRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/rules/{pbm_uuid}/`.replace(`{${"pbm_uuid"}}`, encodeURIComponent(String(requestParameters["pbmUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => NotificationRuleFromJSON(jsonValue));
    });
  }
  /**
   * NotificationRule Viewset
   */
  eventsRulesRetrieve(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsRulesRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * NotificationRule Viewset
   */
  eventsRulesUpdateRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["pbmUuid"] == null) {
        throw new RequiredError("pbmUuid", 'Required parameter "pbmUuid" was null or undefined when calling eventsRulesUpdate().');
      }
      if (requestParameters["notificationRuleRequest"] == null) {
        throw new RequiredError("notificationRuleRequest", 'Required parameter "notificationRuleRequest" was null or undefined when calling eventsRulesUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/rules/{pbm_uuid}/`.replace(`{${"pbm_uuid"}}`, encodeURIComponent(String(requestParameters["pbmUuid"]))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: NotificationRuleRequestToJSON(requestParameters["notificationRuleRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => NotificationRuleFromJSON(jsonValue));
    });
  }
  /**
   * NotificationRule Viewset
   */
  eventsRulesUpdate(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsRulesUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  eventsRulesUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["pbmUuid"] == null) {
        throw new RequiredError("pbmUuid", 'Required parameter "pbmUuid" was null or undefined when calling eventsRulesUsedByList().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/rules/{pbm_uuid}/used_by/`.replace(`{${"pbm_uuid"}}`, encodeURIComponent(String(requestParameters["pbmUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  eventsRulesUsedByList(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsRulesUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Read-only view set that returns all background tasks
   */
  eventsSystemTasksListRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["name"] != null) {
        queryParameters["name"] = requestParameters["name"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      if (requestParameters["status"] != null) {
        queryParameters["status"] = requestParameters["status"];
      }
      if (requestParameters["uid"] != null) {
        queryParameters["uid"] = requestParameters["uid"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/system_tasks/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedSystemTaskListFromJSON(jsonValue));
    });
  }
  /**
   * Read-only view set that returns all background tasks
   */
  eventsSystemTasksList() {
    return __awaiter3(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.eventsSystemTasksListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Read-only view set that returns all background tasks
   */
  eventsSystemTasksRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["uuid"] == null) {
        throw new RequiredError("uuid", 'Required parameter "uuid" was null or undefined when calling eventsSystemTasksRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/system_tasks/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters["uuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => SystemTaskFromJSON(jsonValue));
    });
  }
  /**
   * Read-only view set that returns all background tasks
   */
  eventsSystemTasksRetrieve(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsSystemTasksRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Run task
   */
  eventsSystemTasksRunCreateRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["uuid"] == null) {
        throw new RequiredError("uuid", 'Required parameter "uuid" was null or undefined when calling eventsSystemTasksRunCreate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/system_tasks/{uuid}/run/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters["uuid"]))),
        method: "POST",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Run task
   */
  eventsSystemTasksRunCreate(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      yield this.eventsSystemTasksRunCreateRaw(requestParameters, initOverrides);
    });
  }
  /**
   * NotificationTransport Viewset
   */
  eventsTransportsCreateRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["notificationTransportRequest"] == null) {
        throw new RequiredError("notificationTransportRequest", 'Required parameter "notificationTransportRequest" was null or undefined when calling eventsTransportsCreate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/transports/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: NotificationTransportRequestToJSON(requestParameters["notificationTransportRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => NotificationTransportFromJSON(jsonValue));
    });
  }
  /**
   * NotificationTransport Viewset
   */
  eventsTransportsCreate(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsTransportsCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * NotificationTransport Viewset
   */
  eventsTransportsDestroyRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["uuid"] == null) {
        throw new RequiredError("uuid", 'Required parameter "uuid" was null or undefined when calling eventsTransportsDestroy().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/transports/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters["uuid"]))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * NotificationTransport Viewset
   */
  eventsTransportsDestroy(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      yield this.eventsTransportsDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * NotificationTransport Viewset
   */
  eventsTransportsListRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["mode"] != null) {
        queryParameters["mode"] = requestParameters["mode"];
      }
      if (requestParameters["name"] != null) {
        queryParameters["name"] = requestParameters["name"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      if (requestParameters["sendOnce"] != null) {
        queryParameters["send_once"] = requestParameters["sendOnce"];
      }
      if (requestParameters["webhookUrl"] != null) {
        queryParameters["webhook_url"] = requestParameters["webhookUrl"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/transports/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedNotificationTransportListFromJSON(jsonValue));
    });
  }
  /**
   * NotificationTransport Viewset
   */
  eventsTransportsList() {
    return __awaiter3(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.eventsTransportsListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * NotificationTransport Viewset
   */
  eventsTransportsPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["uuid"] == null) {
        throw new RequiredError("uuid", 'Required parameter "uuid" was null or undefined when calling eventsTransportsPartialUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/transports/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters["uuid"]))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedNotificationTransportRequestToJSON(requestParameters["patchedNotificationTransportRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => NotificationTransportFromJSON(jsonValue));
    });
  }
  /**
   * NotificationTransport Viewset
   */
  eventsTransportsPartialUpdate(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsTransportsPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * NotificationTransport Viewset
   */
  eventsTransportsRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["uuid"] == null) {
        throw new RequiredError("uuid", 'Required parameter "uuid" was null or undefined when calling eventsTransportsRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/transports/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters["uuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => NotificationTransportFromJSON(jsonValue));
    });
  }
  /**
   * NotificationTransport Viewset
   */
  eventsTransportsRetrieve(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsTransportsRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Send example notification using selected transport. Requires Modify permissions.
   */
  eventsTransportsTestCreateRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["uuid"] == null) {
        throw new RequiredError("uuid", 'Required parameter "uuid" was null or undefined when calling eventsTransportsTestCreate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/transports/{uuid}/test/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters["uuid"]))),
        method: "POST",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => NotificationTransportTestFromJSON(jsonValue));
    });
  }
  /**
   * Send example notification using selected transport. Requires Modify permissions.
   */
  eventsTransportsTestCreate(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsTransportsTestCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * NotificationTransport Viewset
   */
  eventsTransportsUpdateRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["uuid"] == null) {
        throw new RequiredError("uuid", 'Required parameter "uuid" was null or undefined when calling eventsTransportsUpdate().');
      }
      if (requestParameters["notificationTransportRequest"] == null) {
        throw new RequiredError("notificationTransportRequest", 'Required parameter "notificationTransportRequest" was null or undefined when calling eventsTransportsUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/transports/{uuid}/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters["uuid"]))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: NotificationTransportRequestToJSON(requestParameters["notificationTransportRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => NotificationTransportFromJSON(jsonValue));
    });
  }
  /**
   * NotificationTransport Viewset
   */
  eventsTransportsUpdate(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsTransportsUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  eventsTransportsUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      if (requestParameters["uuid"] == null) {
        throw new RequiredError("uuid", 'Required parameter "uuid" was null or undefined when calling eventsTransportsUsedByList().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/events/transports/{uuid}/used_by/`.replace(`{${"uuid"}}`, encodeURIComponent(String(requestParameters["uuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  eventsTransportsUsedByList(requestParameters, initOverrides) {
    return __awaiter3(this, void 0, void 0, function* () {
      const response = yield this.eventsTransportsUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
};

// node_modules/@goauthentik/api/dist/esm/apis/RacApi.js
var __awaiter4 = function(thisArg, _arguments, P2, generator) {
  function adopt(value) {
    return value instanceof P2 ? value : new P2(function(resolve) {
      resolve(value);
    });
  }
  return new (P2 || (P2 = Promise))(function(resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e3) {
        reject(e3);
      }
    }
    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e3) {
        reject(e3);
      }
    }
    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }
    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};
var RacApi = class extends BaseAPI {
  /**
   * ConnectionToken Viewset
   */
  racConnectionTokensDestroyRaw(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      if (requestParameters["connectionTokenUuid"] == null) {
        throw new RequiredError("connectionTokenUuid", 'Required parameter "connectionTokenUuid" was null or undefined when calling racConnectionTokensDestroy().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/connection_tokens/{connection_token_uuid}/`.replace(`{${"connection_token_uuid"}}`, encodeURIComponent(String(requestParameters["connectionTokenUuid"]))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * ConnectionToken Viewset
   */
  racConnectionTokensDestroy(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      yield this.racConnectionTokensDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * ConnectionToken Viewset
   */
  racConnectionTokensListRaw(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["endpoint"] != null) {
        queryParameters["endpoint"] = requestParameters["endpoint"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["provider"] != null) {
        queryParameters["provider"] = requestParameters["provider"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      if (requestParameters["sessionUser"] != null) {
        queryParameters["session__user"] = requestParameters["sessionUser"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/connection_tokens/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedConnectionTokenListFromJSON(jsonValue));
    });
  }
  /**
   * ConnectionToken Viewset
   */
  racConnectionTokensList() {
    return __awaiter4(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.racConnectionTokensListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ConnectionToken Viewset
   */
  racConnectionTokensPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      if (requestParameters["connectionTokenUuid"] == null) {
        throw new RequiredError("connectionTokenUuid", 'Required parameter "connectionTokenUuid" was null or undefined when calling racConnectionTokensPartialUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/connection_tokens/{connection_token_uuid}/`.replace(`{${"connection_token_uuid"}}`, encodeURIComponent(String(requestParameters["connectionTokenUuid"]))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedConnectionTokenRequestToJSON(requestParameters["patchedConnectionTokenRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ConnectionTokenFromJSON(jsonValue));
    });
  }
  /**
   * ConnectionToken Viewset
   */
  racConnectionTokensPartialUpdate(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      const response = yield this.racConnectionTokensPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ConnectionToken Viewset
   */
  racConnectionTokensRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      if (requestParameters["connectionTokenUuid"] == null) {
        throw new RequiredError("connectionTokenUuid", 'Required parameter "connectionTokenUuid" was null or undefined when calling racConnectionTokensRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/connection_tokens/{connection_token_uuid}/`.replace(`{${"connection_token_uuid"}}`, encodeURIComponent(String(requestParameters["connectionTokenUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ConnectionTokenFromJSON(jsonValue));
    });
  }
  /**
   * ConnectionToken Viewset
   */
  racConnectionTokensRetrieve(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      const response = yield this.racConnectionTokensRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * ConnectionToken Viewset
   */
  racConnectionTokensUpdateRaw(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      if (requestParameters["connectionTokenUuid"] == null) {
        throw new RequiredError("connectionTokenUuid", 'Required parameter "connectionTokenUuid" was null or undefined when calling racConnectionTokensUpdate().');
      }
      if (requestParameters["connectionTokenRequest"] == null) {
        throw new RequiredError("connectionTokenRequest", 'Required parameter "connectionTokenRequest" was null or undefined when calling racConnectionTokensUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/connection_tokens/{connection_token_uuid}/`.replace(`{${"connection_token_uuid"}}`, encodeURIComponent(String(requestParameters["connectionTokenUuid"]))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: ConnectionTokenRequestToJSON(requestParameters["connectionTokenRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => ConnectionTokenFromJSON(jsonValue));
    });
  }
  /**
   * ConnectionToken Viewset
   */
  racConnectionTokensUpdate(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      const response = yield this.racConnectionTokensUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  racConnectionTokensUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      if (requestParameters["connectionTokenUuid"] == null) {
        throw new RequiredError("connectionTokenUuid", 'Required parameter "connectionTokenUuid" was null or undefined when calling racConnectionTokensUsedByList().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/connection_tokens/{connection_token_uuid}/used_by/`.replace(`{${"connection_token_uuid"}}`, encodeURIComponent(String(requestParameters["connectionTokenUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  racConnectionTokensUsedByList(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      const response = yield this.racConnectionTokensUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Endpoint Viewset
   */
  racEndpointsCreateRaw(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      if (requestParameters["endpointRequest"] == null) {
        throw new RequiredError("endpointRequest", 'Required parameter "endpointRequest" was null or undefined when calling racEndpointsCreate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/endpoints/`,
        method: "POST",
        headers: headerParameters,
        query: queryParameters,
        body: EndpointRequestToJSON(requestParameters["endpointRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EndpointFromJSON(jsonValue));
    });
  }
  /**
   * Endpoint Viewset
   */
  racEndpointsCreate(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      const response = yield this.racEndpointsCreateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Endpoint Viewset
   */
  racEndpointsDestroyRaw(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      if (requestParameters["pbmUuid"] == null) {
        throw new RequiredError("pbmUuid", 'Required parameter "pbmUuid" was null or undefined when calling racEndpointsDestroy().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/endpoints/{pbm_uuid}/`.replace(`{${"pbm_uuid"}}`, encodeURIComponent(String(requestParameters["pbmUuid"]))),
        method: "DELETE",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new VoidApiResponse(response);
    });
  }
  /**
   * Endpoint Viewset
   */
  racEndpointsDestroy(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      yield this.racEndpointsDestroyRaw(requestParameters, initOverrides);
    });
  }
  /**
   * List accessible endpoints
   */
  racEndpointsListRaw(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      const queryParameters = {};
      if (requestParameters["name"] != null) {
        queryParameters["name"] = requestParameters["name"];
      }
      if (requestParameters["ordering"] != null) {
        queryParameters["ordering"] = requestParameters["ordering"];
      }
      if (requestParameters["page"] != null) {
        queryParameters["page"] = requestParameters["page"];
      }
      if (requestParameters["pageSize"] != null) {
        queryParameters["page_size"] = requestParameters["pageSize"];
      }
      if (requestParameters["provider"] != null) {
        queryParameters["provider"] = requestParameters["provider"];
      }
      if (requestParameters["search"] != null) {
        queryParameters["search"] = requestParameters["search"];
      }
      if (requestParameters["superuserFullList"] != null) {
        queryParameters["superuser_full_list"] = requestParameters["superuserFullList"];
      }
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/endpoints/`,
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => PaginatedEndpointListFromJSON(jsonValue));
    });
  }
  /**
   * List accessible endpoints
   */
  racEndpointsList() {
    return __awaiter4(this, arguments, void 0, function* (requestParameters = {}, initOverrides) {
      const response = yield this.racEndpointsListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Endpoint Viewset
   */
  racEndpointsPartialUpdateRaw(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      if (requestParameters["pbmUuid"] == null) {
        throw new RequiredError("pbmUuid", 'Required parameter "pbmUuid" was null or undefined when calling racEndpointsPartialUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/endpoints/{pbm_uuid}/`.replace(`{${"pbm_uuid"}}`, encodeURIComponent(String(requestParameters["pbmUuid"]))),
        method: "PATCH",
        headers: headerParameters,
        query: queryParameters,
        body: PatchedEndpointRequestToJSON(requestParameters["patchedEndpointRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EndpointFromJSON(jsonValue));
    });
  }
  /**
   * Endpoint Viewset
   */
  racEndpointsPartialUpdate(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      const response = yield this.racEndpointsPartialUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Endpoint Viewset
   */
  racEndpointsRetrieveRaw(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      if (requestParameters["pbmUuid"] == null) {
        throw new RequiredError("pbmUuid", 'Required parameter "pbmUuid" was null or undefined when calling racEndpointsRetrieve().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/endpoints/{pbm_uuid}/`.replace(`{${"pbm_uuid"}}`, encodeURIComponent(String(requestParameters["pbmUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EndpointFromJSON(jsonValue));
    });
  }
  /**
   * Endpoint Viewset
   */
  racEndpointsRetrieve(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      const response = yield this.racEndpointsRetrieveRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Endpoint Viewset
   */
  racEndpointsUpdateRaw(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      if (requestParameters["pbmUuid"] == null) {
        throw new RequiredError("pbmUuid", 'Required parameter "pbmUuid" was null or undefined when calling racEndpointsUpdate().');
      }
      if (requestParameters["endpointRequest"] == null) {
        throw new RequiredError("endpointRequest", 'Required parameter "endpointRequest" was null or undefined when calling racEndpointsUpdate().');
      }
      const queryParameters = {};
      const headerParameters = {};
      headerParameters["Content-Type"] = "application/json";
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/endpoints/{pbm_uuid}/`.replace(`{${"pbm_uuid"}}`, encodeURIComponent(String(requestParameters["pbmUuid"]))),
        method: "PUT",
        headers: headerParameters,
        query: queryParameters,
        body: EndpointRequestToJSON(requestParameters["endpointRequest"])
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => EndpointFromJSON(jsonValue));
    });
  }
  /**
   * Endpoint Viewset
   */
  racEndpointsUpdate(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      const response = yield this.racEndpointsUpdateRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  racEndpointsUsedByListRaw(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      if (requestParameters["pbmUuid"] == null) {
        throw new RequiredError("pbmUuid", 'Required parameter "pbmUuid" was null or undefined when calling racEndpointsUsedByList().');
      }
      const queryParameters = {};
      const headerParameters = {};
      if (this.configuration && this.configuration.accessToken) {
        const token = this.configuration.accessToken;
        const tokenString = yield token("authentik", []);
        if (tokenString) {
          headerParameters["Authorization"] = `Bearer ${tokenString}`;
        }
      }
      const response = yield this.request({
        path: `/rac/endpoints/{pbm_uuid}/used_by/`.replace(`{${"pbm_uuid"}}`, encodeURIComponent(String(requestParameters["pbmUuid"]))),
        method: "GET",
        headers: headerParameters,
        query: queryParameters
      }, initOverrides);
      return new JSONApiResponse(response, (jsonValue) => jsonValue.map(UsedByFromJSON));
    });
  }
  /**
   * Get a list of all objects that use this object
   */
  racEndpointsUsedByList(requestParameters, initOverrides) {
    return __awaiter4(this, void 0, void 0, function* () {
      const response = yield this.racEndpointsUsedByListRaw(requestParameters, initOverrides);
      return yield response.value();
    });
  }
};

// src/common/ws.ts
var WebsocketClient = class {
  constructor() {
    this.retryDelay = 200;
    try {
      this.connect();
    } catch (error) {
      console.warn(`authentik/ws: failed to connect to ws ${error}`);
    }
  }
  connect() {
    if (navigator.webdriver) return;
    const apiURL = new URL(globalAK().api.base);
    const wsUrl = `${window.location.protocol.replace("http", "ws")}//${apiURL.host}${apiURL.pathname}ws/client/`;
    this.messageSocket = new WebSocket(wsUrl);
    this.messageSocket.addEventListener("open", () => {
      console.debug(`authentik/ws: connected to ${wsUrl}`);
      this.retryDelay = 200;
    });
    this.messageSocket.addEventListener("close", (e3) => {
      console.debug("authentik/ws: closed ws connection", e3);
      if (this.retryDelay > 6e3) {
        window.dispatchEvent(
          new CustomEvent(EVENT_MESSAGE, {
            bubbles: true,
            composed: true,
            detail: {
              level: "error" /* error */,
              message: msg("Connection error, reconnecting...")
            }
          })
        );
      }
      setTimeout(() => {
        console.debug(`authentik/ws: reconnecting ws in ${this.retryDelay}ms`);
        this.connect();
      }, this.retryDelay);
      this.retryDelay = this.retryDelay * 2;
    });
    this.messageSocket.addEventListener("message", (e3) => {
      const data = JSON.parse(e3.data);
      window.dispatchEvent(
        new CustomEvent(EVENT_WS_MESSAGE, {
          bubbles: true,
          composed: true,
          detail: data
        })
      );
    });
    this.messageSocket.addEventListener("error", () => {
      this.retryDelay = this.retryDelay * 2;
    });
  }
};

// src/elements/buttons/ActionButton/ak-action-button.ts
var ActionButton = class extends BaseTaskButton {
  constructor() {
    super();
    this.apiRequest = () => {
      throw new Error();
    };
    this.callAction = () => {
      return this.apiRequest();
    };
    this.onError = this.onError.bind(this);
  }
  async onError(error) {
    super.onError(error);
    const message = error instanceof Error ? error.toString() : await error.text();
    showMessage({
      level: "error" /* error */,
      message
    });
  }
};
__decorateClass([
  n({ attribute: false })
], ActionButton.prototype, "apiRequest", 2);
ActionButton = __decorateClass([
  t("ak-action-button")
], ActionButton);

// node_modules/ts-pattern/dist/index.js
var t2 = Symbol.for("@ts-pattern/matcher");
var e2 = Symbol.for("@ts-pattern/isVariadic");
var n2 = "@ts-pattern/anonymous-select-key";
var r2 = (t3) => Boolean(t3 && "object" == typeof t3);
var i3 = (e3) => e3 && !!e3[t2];
var s = (n3, o2, c3) => {
  if (i3(n3)) {
    const e3 = n3[t2](), { matched: r3, selections: i4 } = e3.match(o2);
    return r3 && i4 && Object.keys(i4).forEach((t3) => c3(t3, i4[t3])), r3;
  }
  if (r2(n3)) {
    if (!r2(o2)) return false;
    if (Array.isArray(n3)) {
      if (!Array.isArray(o2)) return false;
      let t3 = [], r3 = [], a2 = [];
      for (const s2 of n3.keys()) {
        const o3 = n3[s2];
        i3(o3) && o3[e2] ? a2.push(o3) : a2.length ? r3.push(o3) : t3.push(o3);
      }
      if (a2.length) {
        if (a2.length > 1) throw new Error("Pattern error: Using `...P.array(...)` several times in a single pattern is not allowed.");
        if (o2.length < t3.length + r3.length) return false;
        const e3 = o2.slice(0, t3.length), n4 = 0 === r3.length ? [] : o2.slice(-r3.length), i4 = o2.slice(t3.length, 0 === r3.length ? Infinity : -r3.length);
        return t3.every((t4, n5) => s(t4, e3[n5], c3)) && r3.every((t4, e4) => s(t4, n4[e4], c3)) && (0 === a2.length || s(a2[0], i4, c3));
      }
      return n3.length === o2.length && n3.every((t4, e3) => s(t4, o2[e3], c3));
    }
    return Reflect.ownKeys(n3).every((e3) => {
      const r3 = n3[e3];
      return (e3 in o2 || i3(a2 = r3) && "optional" === a2[t2]().matcherType) && s(r3, o2[e3], c3);
      var a2;
    });
  }
  return Object.is(o2, n3);
};
var o = (e3) => {
  var n3, s2, a2;
  return r2(e3) ? i3(e3) ? null != (n3 = null == (s2 = (a2 = e3[t2]()).getSelectionKeys) ? void 0 : s2.call(a2)) ? n3 : [] : Array.isArray(e3) ? c2(e3, o) : c2(Object.values(e3), o) : [];
};
var c2 = (t3, e3) => t3.reduce((t4, n3) => t4.concat(e3(n3)), []);
function a(...t3) {
  if (1 === t3.length) {
    const [e3] = t3;
    return (t4) => s(e3, t4, () => {
    });
  }
  if (2 === t3.length) {
    const [e3, n3] = t3;
    return s(e3, n3, () => {
    });
  }
  throw new Error(`isMatching wasn't given the right number of arguments: expected 1 or 2, received ${t3.length}.`);
}
function u(t3) {
  return Object.assign(t3, { optional: () => h(t3), and: (e3) => m(t3, e3), or: (e3) => d(t3, e3), select: (e3) => void 0 === e3 ? y(t3) : y(e3, t3) });
}
function l(t3) {
  return Object.assign(((t4) => Object.assign(t4, { [Symbol.iterator]() {
    let n3 = 0;
    const r3 = [{ value: Object.assign(t4, { [e2]: true }), done: false }, { done: true, value: void 0 }];
    return { next: () => {
      var t5;
      return null != (t5 = r3[n3++]) ? t5 : r3.at(-1);
    } };
  } }))(t3), { optional: () => l(h(t3)), select: (e3) => l(void 0 === e3 ? y(t3) : y(e3, t3)) });
}
function h(e3) {
  return u({ [t2]: () => ({ match: (t3) => {
    let n3 = {};
    const r3 = (t4, e4) => {
      n3[t4] = e4;
    };
    return void 0 === t3 ? (o(e3).forEach((t4) => r3(t4, void 0)), { matched: true, selections: n3 }) : { matched: s(e3, t3, r3), selections: n3 };
  }, getSelectionKeys: () => o(e3), matcherType: "optional" }) });
}
var f = (t3, e3) => {
  for (const n3 of t3) if (!e3(n3)) return false;
  return true;
};
var g = (t3, e3) => {
  for (const [n3, r3] of t3.entries()) if (!e3(r3, n3)) return false;
  return true;
};
function m(...e3) {
  return u({ [t2]: () => ({ match: (t3) => {
    let n3 = {};
    const r3 = (t4, e4) => {
      n3[t4] = e4;
    };
    return { matched: e3.every((e4) => s(e4, t3, r3)), selections: n3 };
  }, getSelectionKeys: () => c2(e3, o), matcherType: "and" }) });
}
function d(...e3) {
  return u({ [t2]: () => ({ match: (t3) => {
    let n3 = {};
    const r3 = (t4, e4) => {
      n3[t4] = e4;
    };
    return c2(e3, o).forEach((t4) => r3(t4, void 0)), { matched: e3.some((e4) => s(e4, t3, r3)), selections: n3 };
  }, getSelectionKeys: () => c2(e3, o), matcherType: "or" }) });
}
function p(e3) {
  return { [t2]: () => ({ match: (t3) => ({ matched: Boolean(e3(t3)) }) }) };
}
function y(...e3) {
  const r3 = "string" == typeof e3[0] ? e3[0] : void 0, i4 = 2 === e3.length ? e3[1] : "string" == typeof e3[0] ? void 0 : e3[0];
  return u({ [t2]: () => ({ match: (t3) => {
    let e4 = { [null != r3 ? r3 : n2]: t3 };
    return { matched: void 0 === i4 || s(i4, t3, (t4, n3) => {
      e4[t4] = n3;
    }), selections: e4 };
  }, getSelectionKeys: () => [null != r3 ? r3 : n2].concat(void 0 === i4 ? [] : o(i4)) }) });
}
function v(t3) {
  return "number" == typeof t3;
}
function b(t3) {
  return "string" == typeof t3;
}
function w(t3) {
  return "bigint" == typeof t3;
}
var S = u(p(function(t3) {
  return true;
}));
var O = S;
var j = (t3) => Object.assign(u(t3), { startsWith: (e3) => {
  return j(m(t3, (n3 = e3, p((t4) => b(t4) && t4.startsWith(n3)))));
  var n3;
}, endsWith: (e3) => {
  return j(m(t3, (n3 = e3, p((t4) => b(t4) && t4.endsWith(n3)))));
  var n3;
}, minLength: (e3) => j(m(t3, ((t4) => p((e4) => b(e4) && e4.length >= t4))(e3))), length: (e3) => j(m(t3, ((t4) => p((e4) => b(e4) && e4.length === t4))(e3))), maxLength: (e3) => j(m(t3, ((t4) => p((e4) => b(e4) && e4.length <= t4))(e3))), includes: (e3) => {
  return j(m(t3, (n3 = e3, p((t4) => b(t4) && t4.includes(n3)))));
  var n3;
}, regex: (e3) => {
  return j(m(t3, (n3 = e3, p((t4) => b(t4) && Boolean(t4.match(n3))))));
  var n3;
} });
var K = j(p(b));
var x = (t3) => Object.assign(u(t3), { between: (e3, n3) => x(m(t3, ((t4, e4) => p((n4) => v(n4) && t4 <= n4 && e4 >= n4))(e3, n3))), lt: (e3) => x(m(t3, ((t4) => p((e4) => v(e4) && e4 < t4))(e3))), gt: (e3) => x(m(t3, ((t4) => p((e4) => v(e4) && e4 > t4))(e3))), lte: (e3) => x(m(t3, ((t4) => p((e4) => v(e4) && e4 <= t4))(e3))), gte: (e3) => x(m(t3, ((t4) => p((e4) => v(e4) && e4 >= t4))(e3))), int: () => x(m(t3, p((t4) => v(t4) && Number.isInteger(t4)))), finite: () => x(m(t3, p((t4) => v(t4) && Number.isFinite(t4)))), positive: () => x(m(t3, p((t4) => v(t4) && t4 > 0))), negative: () => x(m(t3, p((t4) => v(t4) && t4 < 0))) });
var E = x(p(v));
var A = (t3) => Object.assign(u(t3), { between: (e3, n3) => A(m(t3, ((t4, e4) => p((n4) => w(n4) && t4 <= n4 && e4 >= n4))(e3, n3))), lt: (e3) => A(m(t3, ((t4) => p((e4) => w(e4) && e4 < t4))(e3))), gt: (e3) => A(m(t3, ((t4) => p((e4) => w(e4) && e4 > t4))(e3))), lte: (e3) => A(m(t3, ((t4) => p((e4) => w(e4) && e4 <= t4))(e3))), gte: (e3) => A(m(t3, ((t4) => p((e4) => w(e4) && e4 >= t4))(e3))), positive: () => A(m(t3, p((t4) => w(t4) && t4 > 0))), negative: () => A(m(t3, p((t4) => w(t4) && t4 < 0))) });
var P = A(p(w));
var T = u(p(function(t3) {
  return "boolean" == typeof t3;
}));
var B = u(p(function(t3) {
  return "symbol" == typeof t3;
}));
var _ = u(p(function(t3) {
  return null == t3;
}));
var k = u(p(function(t3) {
  return null != t3;
}));
var N = { __proto__: null, matcher: t2, optional: h, array: function(...e3) {
  return l({ [t2]: () => ({ match: (t3) => {
    if (!Array.isArray(t3)) return { matched: false };
    if (0 === e3.length) return { matched: true };
    const n3 = e3[0];
    let r3 = {};
    if (0 === t3.length) return o(n3).forEach((t4) => {
      r3[t4] = [];
    }), { matched: true, selections: r3 };
    const i4 = (t4, e4) => {
      r3[t4] = (r3[t4] || []).concat([e4]);
    };
    return { matched: t3.every((t4) => s(n3, t4, i4)), selections: r3 };
  }, getSelectionKeys: () => 0 === e3.length ? [] : o(e3[0]) }) });
}, set: function(...e3) {
  return u({ [t2]: () => ({ match: (t3) => {
    if (!(t3 instanceof Set)) return { matched: false };
    let n3 = {};
    if (0 === t3.size) return { matched: true, selections: n3 };
    if (0 === e3.length) return { matched: true };
    const r3 = (t4, e4) => {
      n3[t4] = (n3[t4] || []).concat([e4]);
    }, i4 = e3[0];
    return { matched: f(t3, (t4) => s(i4, t4, r3)), selections: n3 };
  }, getSelectionKeys: () => 0 === e3.length ? [] : o(e3[0]) }) });
}, map: function(...e3) {
  return u({ [t2]: () => ({ match: (t3) => {
    if (!(t3 instanceof Map)) return { matched: false };
    let n3 = {};
    if (0 === t3.size) return { matched: true, selections: n3 };
    const r3 = (t4, e4) => {
      n3[t4] = (n3[t4] || []).concat([e4]);
    };
    if (0 === e3.length) return { matched: true };
    var i4;
    if (1 === e3.length) throw new Error(`\`P.map\` wasn't given enough arguments. Expected (key, value), received ${null == (i4 = e3[0]) ? void 0 : i4.toString()}`);
    const [o2, c3] = e3;
    return { matched: g(t3, (t4, e4) => {
      const n4 = s(o2, e4, r3), i5 = s(c3, t4, r3);
      return n4 && i5;
    }), selections: n3 };
  }, getSelectionKeys: () => 0 === e3.length ? [] : [...o(e3[0]), ...o(e3[1])] }) });
}, intersection: m, union: d, not: function(e3) {
  return u({ [t2]: () => ({ match: (t3) => ({ matched: !s(e3, t3, () => {
  }) }), getSelectionKeys: () => [], matcherType: "not" }) });
}, when: p, select: y, any: S, _: O, string: K, number: E, bigint: P, boolean: T, symbol: B, nullish: _, nonNullable: k, instanceOf: function(t3) {
  return u(p(/* @__PURE__ */ function(t4) {
    return (e3) => e3 instanceof t4;
  }(t3)));
}, shape: function(t3) {
  return u(p(a(t3)));
} };
var W = class extends Error {
  constructor(t3) {
    let e3;
    try {
      e3 = JSON.stringify(t3);
    } catch (n3) {
      e3 = t3;
    }
    super(`Pattern matching error: no pattern matches value ${e3}`), this.input = void 0, this.input = t3;
  }
};
var $ = { matched: false, value: void 0 };
function z(t3) {
  return new I(t3, $);
}
var I = class _I {
  constructor(t3, e3) {
    this.input = void 0, this.state = void 0, this.input = t3, this.state = e3;
  }
  with(...t3) {
    if (this.state.matched) return this;
    const e3 = t3[t3.length - 1], r3 = [t3[0]];
    let i4;
    3 === t3.length && "function" == typeof t3[1] ? i4 = t3[1] : t3.length > 2 && r3.push(...t3.slice(1, t3.length - 1));
    let o2 = false, c3 = {};
    const a2 = (t4, e4) => {
      o2 = true, c3[t4] = e4;
    }, u2 = !r3.some((t4) => s(t4, this.input, a2)) || i4 && !Boolean(i4(this.input)) ? $ : { matched: true, value: e3(o2 ? n2 in c3 ? c3[n2] : c3 : this.input, this.input) };
    return new _I(this.input, u2);
  }
  when(t3, e3) {
    if (this.state.matched) return this;
    const n3 = Boolean(t3(this.input));
    return new _I(this.input, n3 ? { matched: true, value: e3(this.input, this.input) } : $);
  }
  otherwise(t3) {
    return this.state.matched ? this.state.value : t3(this.input);
  }
  exhaustive() {
    if (this.state.matched) return this.state.value;
    throw new W(this.input);
  }
  run() {
    return this.exhaustive();
  }
  returnType() {
    return this;
  }
};

// node_modules/@patternfly/patternfly/components/Avatar/avatar.css
var avatar_default = ".pf-c-avatar {\n  --pf-c-avatar--BorderColor: transparent;\n  --pf-c-avatar--BorderWidth: 0;\n  --pf-c-avatar--BorderRadius: var(--pf-global--BorderRadius--lg);\n  --pf-c-avatar--Width: 2.25rem;\n  --pf-c-avatar--Height: 2.25rem;\n  --pf-c-avatar--m-sm--Width: 1.5rem;\n  --pf-c-avatar--m-sm--Height: 1.5rem;\n  --pf-c-avatar--m-md--Width: 2.25rem;\n  --pf-c-avatar--m-md--Height: 2.25rem;\n  --pf-c-avatar--m-lg--Width: 4.5rem;\n  --pf-c-avatar--m-lg--Height: 4.5rem;\n  --pf-c-avatar--m-xl--Width: 8rem;\n  --pf-c-avatar--m-xl--Height: 8rem;\n  --pf-c-avatar--m-light--BorderColor: var(--pf-global--BorderColor--dark-100);\n  --pf-c-avatar--m-light--BorderWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-avatar--m-dark--BorderColor: var(--pf-global--palette--black-700);\n  --pf-c-avatar--m-dark--BorderWidth: var(--pf-global--BorderWidth--sm);\n  width: var(--pf-c-avatar--Width);\n  height: var(--pf-c-avatar--Height);\n  border: var(--pf-c-avatar--BorderWidth) solid var(--pf-c-avatar--BorderColor);\n  border-radius: var(--pf-c-avatar--BorderRadius);\n}\n.pf-c-avatar.pf-m-light {\n  --pf-c-avatar--BorderColor: var(--pf-c-avatar--m-light--BorderColor);\n  --pf-c-avatar--BorderWidth: var(--pf-c-avatar--m-light--BorderWidth);\n}\n.pf-c-avatar.pf-m-dark {\n  --pf-c-avatar--BorderColor: var(--pf-c-avatar--m-dark--BorderColor);\n  --pf-c-avatar--BorderWidth: var(--pf-c-avatar--m-dark--BorderWidth);\n}\n.pf-c-avatar.pf-m-sm {\n  --pf-c-avatar--Width: var(--pf-c-avatar--m-sm--Width);\n  --pf-c-avatar--Height: var(--pf-c-avatar--m-sm--Height);\n}\n@media (min-width: 576px) {\n  .pf-c-avatar.pf-m-sm {\n    --pf-c-avatar--Width: var(--pf-c-avatar--m-sm--Width-on-sm, var(--pf-c-avatar--m-sm--Width));\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-avatar.pf-m-sm {\n    --pf-c-avatar--Width: var(--pf-c-avatar--m-sm--Width-on-md, var(--pf-c-avatar--m-sm--Width-on-sm, var(--pf-c-avatar--m-sm--Width)));\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-avatar.pf-m-sm {\n    --pf-c-avatar--Width: var(--pf-c-avatar--m-sm--Width-on-lg, var(--pf-c-avatar--m-sm--Width-on-md, var(--pf-c-avatar--m-sm--Width-on-sm, var(--pf-c-avatar--m-sm--Width))));\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-avatar.pf-m-sm {\n    --pf-c-avatar--Width: var(--pf-c-avatar--m-sm--Width-on-xl, var(--pf-c-avatar--m-sm--Width-on-lg, var(--pf-c-avatar--m-sm--Width-on-md, var(--pf-c-avatar--m-sm--Width-on-sm, var(--pf-c-avatar--m-sm--Width)))));\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-avatar.pf-m-sm {\n    --pf-c-avatar--Width: var(--pf-c-avatar--m-sm--Width-on-2xl, var(--pf-c-avatar--m-sm--Width-on-xl, var(--pf-c-avatar--m-sm--Width-on-lg, var(--pf-c-avatar--m-sm--Width-on-md, var(--pf-c-avatar--m-sm--Width-on-sm, var(--pf-c-avatar--m-sm--Width))))));\n  }\n}\n@media (min-width: 576px) {\n  .pf-c-avatar.pf-m-sm {\n    --pf-c-avatar--Height: var(--pf-c-avatar--m-sm--Height-on-sm, var(--pf-c-avatar--m-sm--Height));\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-avatar.pf-m-sm {\n    --pf-c-avatar--Height: var(--pf-c-avatar--m-sm--Height-on-md, var(--pf-c-avatar--m-sm--Height-on-sm, var(--pf-c-avatar--m-sm--Height)));\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-avatar.pf-m-sm {\n    --pf-c-avatar--Height: var(--pf-c-avatar--m-sm--Height-on-lg, var(--pf-c-avatar--m-sm--Height-on-md, var(--pf-c-avatar--m-sm--Height-on-sm, var(--pf-c-avatar--m-sm--Height))));\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-avatar.pf-m-sm {\n    --pf-c-avatar--Height: var(--pf-c-avatar--m-sm--Height-on-xl, var(--pf-c-avatar--m-sm--Height-on-lg, var(--pf-c-avatar--m-sm--Height-on-md, var(--pf-c-avatar--m-sm--Height-on-sm, var(--pf-c-avatar--m-sm--Height)))));\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-avatar.pf-m-sm {\n    --pf-c-avatar--Height: var(--pf-c-avatar--m-sm--Height-on-2xl, var(--pf-c-avatar--m-sm--Height-on-xl, var(--pf-c-avatar--m-sm--Height-on-lg, var(--pf-c-avatar--m-sm--Height-on-md, var(--pf-c-avatar--m-sm--Height-on-sm, var(--pf-c-avatar--m-sm--Height))))));\n  }\n}\n.pf-c-avatar.pf-m-md {\n  --pf-c-avatar--Width: var(--pf-c-avatar--m-md--Width);\n  --pf-c-avatar--Height: var(--pf-c-avatar--m-md--Height);\n}\n@media (min-width: 576px) {\n  .pf-c-avatar.pf-m-md {\n    --pf-c-avatar--Width: var(--pf-c-avatar--m-md--Width-on-sm, var(--pf-c-avatar--m-md--Width));\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-avatar.pf-m-md {\n    --pf-c-avatar--Width: var(--pf-c-avatar--m-md--Width-on-md, var(--pf-c-avatar--m-md--Width-on-sm, var(--pf-c-avatar--m-md--Width)));\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-avatar.pf-m-md {\n    --pf-c-avatar--Width: var(--pf-c-avatar--m-md--Width-on-lg, var(--pf-c-avatar--m-md--Width-on-md, var(--pf-c-avatar--m-md--Width-on-sm, var(--pf-c-avatar--m-md--Width))));\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-avatar.pf-m-md {\n    --pf-c-avatar--Width: var(--pf-c-avatar--m-md--Width-on-xl, var(--pf-c-avatar--m-md--Width-on-lg, var(--pf-c-avatar--m-md--Width-on-md, var(--pf-c-avatar--m-md--Width-on-sm, var(--pf-c-avatar--m-md--Width)))));\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-avatar.pf-m-md {\n    --pf-c-avatar--Width: var(--pf-c-avatar--m-md--Width-on-2xl, var(--pf-c-avatar--m-md--Width-on-xl, var(--pf-c-avatar--m-md--Width-on-lg, var(--pf-c-avatar--m-md--Width-on-md, var(--pf-c-avatar--m-md--Width-on-sm, var(--pf-c-avatar--m-md--Width))))));\n  }\n}\n@media (min-width: 576px) {\n  .pf-c-avatar.pf-m-md {\n    --pf-c-avatar--Height: var(--pf-c-avatar--m-md--Height-on-sm, var(--pf-c-avatar--m-md--Height));\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-avatar.pf-m-md {\n    --pf-c-avatar--Height: var(--pf-c-avatar--m-md--Height-on-md, var(--pf-c-avatar--m-md--Height-on-sm, var(--pf-c-avatar--m-md--Height)));\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-avatar.pf-m-md {\n    --pf-c-avatar--Height: var(--pf-c-avatar--m-md--Height-on-lg, var(--pf-c-avatar--m-md--Height-on-md, var(--pf-c-avatar--m-md--Height-on-sm, var(--pf-c-avatar--m-md--Height))));\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-avatar.pf-m-md {\n    --pf-c-avatar--Height: var(--pf-c-avatar--m-md--Height-on-xl, var(--pf-c-avatar--m-md--Height-on-lg, var(--pf-c-avatar--m-md--Height-on-md, var(--pf-c-avatar--m-md--Height-on-sm, var(--pf-c-avatar--m-md--Height)))));\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-avatar.pf-m-md {\n    --pf-c-avatar--Height: var(--pf-c-avatar--m-md--Height-on-2xl, var(--pf-c-avatar--m-md--Height-on-xl, var(--pf-c-avatar--m-md--Height-on-lg, var(--pf-c-avatar--m-md--Height-on-md, var(--pf-c-avatar--m-md--Height-on-sm, var(--pf-c-avatar--m-md--Height))))));\n  }\n}\n.pf-c-avatar.pf-m-lg {\n  --pf-c-avatar--Width: var(--pf-c-avatar--m-lg--Width);\n  --pf-c-avatar--Height: var(--pf-c-avatar--m-lg--Height);\n}\n@media (min-width: 576px) {\n  .pf-c-avatar.pf-m-lg {\n    --pf-c-avatar--Width: var(--pf-c-avatar--m-lg--Width-on-sm, var(--pf-c-avatar--m-lg--Width));\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-avatar.pf-m-lg {\n    --pf-c-avatar--Width: var(--pf-c-avatar--m-lg--Width-on-md, var(--pf-c-avatar--m-lg--Width-on-sm, var(--pf-c-avatar--m-lg--Width)));\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-avatar.pf-m-lg {\n    --pf-c-avatar--Width: var(--pf-c-avatar--m-lg--Width-on-lg, var(--pf-c-avatar--m-lg--Width-on-md, var(--pf-c-avatar--m-lg--Width-on-sm, var(--pf-c-avatar--m-lg--Width))));\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-avatar.pf-m-lg {\n    --pf-c-avatar--Width: var(--pf-c-avatar--m-lg--Width-on-xl, var(--pf-c-avatar--m-lg--Width-on-lg, var(--pf-c-avatar--m-lg--Width-on-md, var(--pf-c-avatar--m-lg--Width-on-sm, var(--pf-c-avatar--m-lg--Width)))));\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-avatar.pf-m-lg {\n    --pf-c-avatar--Width: var(--pf-c-avatar--m-lg--Width-on-2xl, var(--pf-c-avatar--m-lg--Width-on-xl, var(--pf-c-avatar--m-lg--Width-on-lg, var(--pf-c-avatar--m-lg--Width-on-md, var(--pf-c-avatar--m-lg--Width-on-sm, var(--pf-c-avatar--m-lg--Width))))));\n  }\n}\n@media (min-width: 576px) {\n  .pf-c-avatar.pf-m-lg {\n    --pf-c-avatar--Height: var(--pf-c-avatar--m-lg--Height-on-sm, var(--pf-c-avatar--m-lg--Height));\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-avatar.pf-m-lg {\n    --pf-c-avatar--Height: var(--pf-c-avatar--m-lg--Height-on-md, var(--pf-c-avatar--m-lg--Height-on-sm, var(--pf-c-avatar--m-lg--Height)));\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-avatar.pf-m-lg {\n    --pf-c-avatar--Height: var(--pf-c-avatar--m-lg--Height-on-lg, var(--pf-c-avatar--m-lg--Height-on-md, var(--pf-c-avatar--m-lg--Height-on-sm, var(--pf-c-avatar--m-lg--Height))));\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-avatar.pf-m-lg {\n    --pf-c-avatar--Height: var(--pf-c-avatar--m-lg--Height-on-xl, var(--pf-c-avatar--m-lg--Height-on-lg, var(--pf-c-avatar--m-lg--Height-on-md, var(--pf-c-avatar--m-lg--Height-on-sm, var(--pf-c-avatar--m-lg--Height)))));\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-avatar.pf-m-lg {\n    --pf-c-avatar--Height: var(--pf-c-avatar--m-lg--Height-on-2xl, var(--pf-c-avatar--m-lg--Height-on-xl, var(--pf-c-avatar--m-lg--Height-on-lg, var(--pf-c-avatar--m-lg--Height-on-md, var(--pf-c-avatar--m-lg--Height-on-sm, var(--pf-c-avatar--m-lg--Height))))));\n  }\n}\n.pf-c-avatar.pf-m-xl {\n  --pf-c-avatar--Width: var(--pf-c-avatar--m-xl--Width);\n  --pf-c-avatar--Height: var(--pf-c-avatar--m-xl--Height);\n}\n@media (min-width: 576px) {\n  .pf-c-avatar.pf-m-xl {\n    --pf-c-avatar--Width: var(--pf-c-avatar--m-xl--Width-on-sm, var(--pf-c-avatar--m-xl--Width));\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-avatar.pf-m-xl {\n    --pf-c-avatar--Width: var(--pf-c-avatar--m-xl--Width-on-md, var(--pf-c-avatar--m-xl--Width-on-sm, var(--pf-c-avatar--m-xl--Width)));\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-avatar.pf-m-xl {\n    --pf-c-avatar--Width: var(--pf-c-avatar--m-xl--Width-on-lg, var(--pf-c-avatar--m-xl--Width-on-md, var(--pf-c-avatar--m-xl--Width-on-sm, var(--pf-c-avatar--m-xl--Width))));\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-avatar.pf-m-xl {\n    --pf-c-avatar--Width: var(--pf-c-avatar--m-xl--Width-on-xl, var(--pf-c-avatar--m-xl--Width-on-lg, var(--pf-c-avatar--m-xl--Width-on-md, var(--pf-c-avatar--m-xl--Width-on-sm, var(--pf-c-avatar--m-xl--Width)))));\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-avatar.pf-m-xl {\n    --pf-c-avatar--Width: var(--pf-c-avatar--m-xl--Width-on-2xl, var(--pf-c-avatar--m-xl--Width-on-xl, var(--pf-c-avatar--m-xl--Width-on-lg, var(--pf-c-avatar--m-xl--Width-on-md, var(--pf-c-avatar--m-xl--Width-on-sm, var(--pf-c-avatar--m-xl--Width))))));\n  }\n}\n@media (min-width: 576px) {\n  .pf-c-avatar.pf-m-xl {\n    --pf-c-avatar--Height: var(--pf-c-avatar--m-xl--Height-on-sm, var(--pf-c-avatar--m-xl--Height));\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-avatar.pf-m-xl {\n    --pf-c-avatar--Height: var(--pf-c-avatar--m-xl--Height-on-md, var(--pf-c-avatar--m-xl--Height-on-sm, var(--pf-c-avatar--m-xl--Height)));\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-avatar.pf-m-xl {\n    --pf-c-avatar--Height: var(--pf-c-avatar--m-xl--Height-on-lg, var(--pf-c-avatar--m-xl--Height-on-md, var(--pf-c-avatar--m-xl--Height-on-sm, var(--pf-c-avatar--m-xl--Height))));\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-avatar.pf-m-xl {\n    --pf-c-avatar--Height: var(--pf-c-avatar--m-xl--Height-on-xl, var(--pf-c-avatar--m-xl--Height-on-lg, var(--pf-c-avatar--m-xl--Height-on-md, var(--pf-c-avatar--m-xl--Height-on-sm, var(--pf-c-avatar--m-xl--Height)))));\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-avatar.pf-m-xl {\n    --pf-c-avatar--Height: var(--pf-c-avatar--m-xl--Height-on-2xl, var(--pf-c-avatar--m-xl--Height-on-xl, var(--pf-c-avatar--m-xl--Height-on-lg, var(--pf-c-avatar--m-xl--Height-on-md, var(--pf-c-avatar--m-xl--Height-on-sm, var(--pf-c-avatar--m-xl--Height))))));\n  }\n}";

// node_modules/@patternfly/patternfly/components/Brand/brand.css
var brand_default = ".pf-c-brand {\n  --pf-c-brand--Width: auto;\n  --pf-c-brand--Height: auto;\n  width: var(--pf-c-brand--Width--base);\n  height: var(--pf-c-brand--Height--base);\n  --pf-c-brand--Width--base: var(--pf-c-brand--Width);\n  --pf-c-brand--Height--base: var(--pf-c-brand--Height);\n}\n@media (min-width: 576px) {\n  .pf-c-brand {\n    --pf-c-brand--Width--base: var(--pf-c-brand--Width-on-sm, var(--pf-c-brand--Width));\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-brand {\n    --pf-c-brand--Width--base: var(--pf-c-brand--Width-on-md, var(--pf-c-brand--Width-on-sm, var(--pf-c-brand--Width)));\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-brand {\n    --pf-c-brand--Width--base: var(--pf-c-brand--Width-on-lg, var(--pf-c-brand--Width-on-md, var(--pf-c-brand--Width-on-sm, var(--pf-c-brand--Width))));\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-brand {\n    --pf-c-brand--Width--base: var(--pf-c-brand--Width-on-xl, var(--pf-c-brand--Width-on-lg, var(--pf-c-brand--Width-on-md, var(--pf-c-brand--Width-on-sm, var(--pf-c-brand--Width)))));\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-brand {\n    --pf-c-brand--Width--base: var(--pf-c-brand--Width-on-2xl, var(--pf-c-brand--Width-on-xl, var(--pf-c-brand--Width-on-lg, var(--pf-c-brand--Width-on-md, var(--pf-c-brand--Width-on-sm, var(--pf-c-brand--Width))))));\n  }\n}\n@media (min-width: 576px) {\n  .pf-c-brand {\n    --pf-c-brand--Height--base: var(--pf-c-brand--Height-on-sm, var(--pf-c-brand--Height));\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-brand {\n    --pf-c-brand--Height--base: var(--pf-c-brand--Height-on-md, var(--pf-c-brand--Height-on-sm, var(--pf-c-brand--Height)));\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-brand {\n    --pf-c-brand--Height--base: var(--pf-c-brand--Height-on-lg, var(--pf-c-brand--Height-on-md, var(--pf-c-brand--Height-on-sm, var(--pf-c-brand--Height))));\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-brand {\n    --pf-c-brand--Height--base: var(--pf-c-brand--Height-on-xl, var(--pf-c-brand--Height-on-lg, var(--pf-c-brand--Height-on-md, var(--pf-c-brand--Height-on-sm, var(--pf-c-brand--Height)))));\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-brand {\n    --pf-c-brand--Height--base: var(--pf-c-brand--Height-on-2xl, var(--pf-c-brand--Height-on-xl, var(--pf-c-brand--Height-on-lg, var(--pf-c-brand--Height-on-md, var(--pf-c-brand--Height-on-sm, var(--pf-c-brand--Height))))));\n  }\n}\n.pf-c-brand.pf-m-picture {\n  display: inline-flex;\n  max-width: 100%;\n}";

// node_modules/@patternfly/patternfly/components/Drawer/drawer.css
var drawer_default = '.pf-c-drawer {\n  --pf-c-drawer__section--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-drawer__section--m-light-200--BackgroundColor: var(--pf-global--BackgroundColor--200);\n  --pf-c-drawer__content--FlexBasis: 100%;\n  --pf-c-drawer__content--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-drawer__content--m-light-200--BackgroundColor: var(--pf-global--BackgroundColor--200);\n  --pf-c-drawer__content--ZIndex: var(--pf-global--ZIndex--xs);\n  --pf-c-drawer__panel--MinWidth: 50%;\n  --pf-c-drawer__panel--MaxHeight: auto;\n  --pf-c-drawer__panel--ZIndex: var(--pf-global--ZIndex--sm);\n  --pf-c-drawer__panel--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-drawer__panel--m-light-200--BackgroundColor: var(--pf-global--BackgroundColor--200);\n  --pf-c-drawer__panel--TransitionDuration: var(--pf-global--TransitionDuration);\n  --pf-c-drawer__panel--TransitionProperty: margin, transform, box-shadow, flex-basis;\n  --pf-c-drawer__panel--FlexBasis: 100%;\n  --pf-c-drawer__panel--md--FlexBasis--min: 1.5rem;\n  --pf-c-drawer__panel--md--FlexBasis: 50%;\n  --pf-c-drawer__panel--md--FlexBasis--max: 100%;\n  --pf-c-drawer__panel--xl--MinWidth: 28.125rem;\n  --pf-c-drawer__panel--xl--FlexBasis: 28.125rem;\n  --pf-c-drawer--m-panel-bottom__panel--md--MinHeight: 50%;\n  --pf-c-drawer--m-panel-bottom__panel--xl--MinHeight: 18.75rem;\n  --pf-c-drawer--m-panel-bottom__panel--xl--FlexBasis: 18.75rem;\n  --pf-c-drawer__panel--m-resizable--FlexDirection: row;\n  --pf-c-drawer__panel--m-resizable--md--FlexBasis--min: var(--pf-c-drawer__splitter--m-vertical--Width);\n  --pf-c-drawer__panel--m-resizable--MinWidth: 1.5rem;\n  --pf-c-drawer--m-panel-bottom__panel--m-resizable--FlexDirection: column;\n  --pf-c-drawer--m-panel-bottom__panel--m-resizable--md--FlexBasis--min: 1.5rem;\n  --pf-c-drawer--m-panel-bottom__panel--m-resizable--MinHeight: 1.5rem;\n  --pf-c-drawer--child--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-drawer--child--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-drawer--child--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-drawer--child--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-drawer--child--md--PaddingTop: var(--pf-global--spacer--lg);\n  --pf-c-drawer--child--md--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-drawer--child--md--PaddingBottom: var(--pf-global--spacer--lg);\n  --pf-c-drawer--child--md--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-drawer--child--m-padding--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-drawer--child--m-padding--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-drawer--child--m-padding--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-drawer--child--m-padding--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-drawer--child--m-padding--md--PaddingTop: var(--pf-global--spacer--lg);\n  --pf-c-drawer--child--m-padding--md--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-drawer--child--m-padding--md--PaddingBottom: var(--pf-global--spacer--lg);\n  --pf-c-drawer--child--m-padding--md--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-drawer__content--child--PaddingTop: 0;\n  --pf-c-drawer__content--child--PaddingRight: 0;\n  --pf-c-drawer__content--child--PaddingBottom: 0;\n  --pf-c-drawer__content--child--PaddingLeft: 0;\n  --pf-c-drawer__splitter--Height: 0.5625rem;\n  --pf-c-drawer__splitter--Width: 100%;\n  --pf-c-drawer__splitter--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-drawer__splitter--Cursor: row-resize;\n  --pf-c-drawer__splitter--m-vertical--Height: 100%;\n  --pf-c-drawer__splitter--m-vertical--Width: 0.5625rem;\n  --pf-c-drawer__splitter--m-vertical--Cursor: col-resize;\n  --pf-c-drawer--m-inline__splitter--focus--OutlineOffset: -0.0625rem;\n  --pf-c-drawer__splitter--after--BorderColor: var(--pf-global--BorderColor--100);\n  --pf-c-drawer__splitter--after--border-width--base: var(--pf-global--BorderWidth--sm);\n  --pf-c-drawer__splitter--after--BorderTopWidth: 0;\n  --pf-c-drawer__splitter--after--BorderRightWidth: var(--pf-c-drawer__splitter--after--border-width--base);\n  --pf-c-drawer__splitter--after--BorderBottomWidth: 0;\n  --pf-c-drawer__splitter--after--BorderLeftWidth: 0;\n  --pf-c-drawer--m-panel-left__splitter--after--BorderLeftWidth: var(--pf-c-drawer__splitter--after--border-width--base);\n  --pf-c-drawer--m-panel-bottom__splitter--after--BorderBottomWidth: var(--pf-c-drawer__splitter--after--border-width--base);\n  --pf-c-drawer--m-inline__splitter--m-vertical--Width: 0.625rem;\n  --pf-c-drawer--m-inline__splitter-handle--Left: 50%;\n  --pf-c-drawer--m-inline__splitter--after--BorderRightWidth: var(--pf-c-drawer__splitter--after--border-width--base);\n  --pf-c-drawer--m-inline__splitter--after--BorderLeftWidth: var(--pf-c-drawer__splitter--after--border-width--base);\n  --pf-c-drawer--m-inline--m-panel-bottom__splitter--Height: 0.625rem;\n  --pf-c-drawer--m-inline--m-panel-bottom__splitter-handle--Top: 50%;\n  --pf-c-drawer--m-inline--m-panel-bottom__splitter--after--BorderTopWidth: var(--pf-c-drawer__splitter--after--border-width--base);\n  --pf-c-drawer__splitter-handle--Top: 50%;\n  --pf-c-drawer__splitter-handle--Left: calc(50% - var(--pf-c-drawer__splitter--after--border-width--base));\n  --pf-c-drawer--m-panel-left__splitter-handle--Left: 50%;\n  --pf-c-drawer--m-panel-bottom__splitter-handle--Top: calc(50% - var(--pf-c-drawer__splitter--after--border-width--base));\n  --pf-c-drawer__splitter-handle--after--BorderColor: var(--pf-global--Color--200);\n  --pf-c-drawer__splitter-handle--after--BorderTopWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-drawer__splitter-handle--after--BorderRightWidth: 0;\n  --pf-c-drawer__splitter-handle--after--BorderBottomWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-drawer__splitter-handle--after--BorderLeftWidth: 0;\n  --pf-c-drawer__splitter--hover__splitter-handle--after--BorderColor: var(--pf-global--Color--100);\n  --pf-c-drawer__splitter--focus__splitter-handle--after--BorderColor: var(--pf-global--Color--100);\n  --pf-c-drawer__splitter--m-vertical__splitter-handle--after--BorderTopWidth: 0;\n  --pf-c-drawer__splitter--m-vertical__splitter-handle--after--BorderRightWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-drawer__splitter--m-vertical__splitter-handle--after--BorderBottomWidth: 0;\n  --pf-c-drawer__splitter--m-vertical__splitter-handle--after--BorderLeftWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-drawer__splitter-handle--after--Width: 0.75rem;\n  --pf-c-drawer__splitter-handle--after--Height: 0.25rem;\n  --pf-c-drawer__splitter--m-vertical__splitter-handle--after--Width: 0.25rem;\n  --pf-c-drawer__splitter--m-vertical__splitter-handle--after--Height: 0.75rem;\n  --pf-c-drawer__actions--MarginTop: calc(var(--pf-global--spacer--form-element) * -1);\n  --pf-c-drawer__actions--MarginRight: calc(var(--pf-global--spacer--form-element) * -1);\n  --pf-c-drawer__panel--BoxShadow: none;\n  --pf-c-drawer--m-expanded__panel--BoxShadow: var(--pf-global--BoxShadow--lg-left);\n  --pf-c-drawer--m-expanded--m-panel-left__panel--BoxShadow: var(--pf-global--BoxShadow--lg-right);\n  --pf-c-drawer--m-expanded--m-panel-bottom__panel--BoxShadow: var(--pf-global--BoxShadow--lg-top);\n  --pf-c-drawer__panel--after--Width: var(--pf-global--BorderWidth--sm);\n  --pf-c-drawer--m-panel-bottom__panel--after--Height: var(--pf-global--BorderWidth--sm);\n  --pf-c-drawer__panel--after--BackgroundColor: transparent;\n  --pf-c-drawer--m-inline--m-expanded__panel--after--BackgroundColor: var(--pf-global--BorderColor--100);\n  --pf-c-drawer--m-inline__panel--PaddingLeft: var(--pf-c-drawer__panel--after--Width);\n  --pf-c-drawer--m-panel-left--m-inline__panel--PaddingRight: var(--pf-c-drawer__panel--after--Width);\n  --pf-c-drawer--m-panel-bottom--m-inline__panel--PaddingTop: var(--pf-c-drawer__panel--after--Width);\n  display: flex;\n  flex-direction: column;\n  height: 100%;\n  overflow-x: hidden;\n}\n@media screen and (min-width: 768px) {\n  .pf-c-drawer {\n    --pf-c-drawer--child--PaddingTop: var(--pf-c-drawer--child--md--PaddingTop);\n    --pf-c-drawer--child--PaddingRight: var(--pf-c-drawer--child--md--PaddingRight);\n    --pf-c-drawer--child--PaddingBottom: var(--pf-c-drawer--child--md--PaddingBottom);\n    --pf-c-drawer--child--PaddingLeft: var(--pf-c-drawer--child--md--PaddingLeft);\n    --pf-c-drawer--child--m-padding--PaddingTop: var(--pf-c-drawer--child--m-padding--md--PaddingTop);\n    --pf-c-drawer--child--m-padding--PaddingRight: var(--pf-c-drawer--child--m-padding--md--PaddingRight);\n    --pf-c-drawer--child--m-padding--PaddingBottom: var(--pf-c-drawer--child--m-padding--md--PaddingBottom);\n    --pf-c-drawer--child--m-padding--PaddingLeft: var(--pf-c-drawer--child--m-padding--md--PaddingLeft);\n  }\n}\n@media screen and (min-width: 1200px) {\n  .pf-c-drawer {\n    --pf-c-drawer__panel--MinWidth: var(--pf-c-drawer__panel--xl--MinWidth);\n  }\n  .pf-c-drawer.pf-m-panel-bottom {\n    --pf-c-drawer__panel--MinWidth: auto;\n    --pf-c-drawer__panel--MinHeight: var(--pf-c-drawer--m-panel-bottom__panel--xl--MinHeight);\n  }\n}\n.pf-c-drawer.pf-m-inline > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border, .pf-m-resizable), .pf-c-drawer.pf-m-static > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border, .pf-m-resizable) {\n  padding-left: var(--pf-c-drawer--m-inline__panel--PaddingLeft);\n}\n.pf-c-drawer.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel {\n  order: 0;\n  margin-right: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n  transform: translateX(-100%);\n}\n.pf-c-drawer.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__content {\n  order: 1;\n}\n.pf-c-drawer.pf-m-panel-bottom > .pf-c-drawer__main {\n  flex-direction: column;\n}\n.pf-c-drawer.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n  transform: translateX(-100%);\n}\n.pf-c-drawer.pf-m-expanded.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel {\n  transform: translateX(0);\n}\n.pf-c-drawer.pf-m-expanded.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel {\n  transform: translate(0, -100%);\n}\n.pf-c-drawer.pf-m-resizing {\n  --pf-c-drawer__panel--TransitionProperty: none;\n  pointer-events: none;\n}\n.pf-c-drawer.pf-m-resizing .pf-c-drawer__splitter {\n  pointer-events: auto;\n}\n\n.pf-c-drawer__section {\n  flex-grow: 0;\n  background-color: var(--pf-c-drawer__section--BackgroundColor);\n}\n.pf-c-drawer__section.pf-m-no-background {\n  --pf-c-drawer__section--BackgroundColor: transparent;\n}\n.pf-c-drawer__section.pf-m-light-200 {\n  --pf-c-drawer__section--BackgroundColor: var(--pf-c-drawer__section--m-light-200--BackgroundColor);\n}\n\n.pf-c-drawer__main {\n  display: flex;\n  flex: 1;\n  overflow: hidden;\n}\n\n.pf-c-drawer__content,\n.pf-c-drawer__panel,\n.pf-c-drawer__panel-main {\n  display: flex;\n  flex-direction: column;\n  flex-shrink: 0;\n  overflow: auto;\n}\n\n.pf-c-drawer__content {\n  z-index: var(--pf-c-drawer__content--ZIndex);\n  flex-basis: var(--pf-c-drawer__content--FlexBasis);\n  order: 0;\n  background-color: var(--pf-c-drawer__content--BackgroundColor);\n}\n.pf-c-drawer__content.pf-m-no-background {\n  --pf-c-drawer__content--BackgroundColor: transparent;\n}\n.pf-c-drawer__content.pf-m-light-200 {\n  --pf-c-drawer__content--BackgroundColor: var(--pf-c-drawer__content--m-light-200--BackgroundColor);\n}\n.pf-c-drawer__content > .pf-c-drawer__body {\n  padding: var(--pf-c-drawer__content--child--PaddingTop) var(--pf-c-drawer__content--child--PaddingRight) var(--pf-c-drawer__content--child--PaddingBottom) var(--pf-c-drawer__content--child--PaddingLeft);\n}\n\n.pf-c-drawer__panel {\n  position: relative;\n  z-index: var(--pf-c-drawer__panel--ZIndex);\n  flex-basis: var(--pf-c-drawer__panel--FlexBasis);\n  order: 1;\n  max-height: var(--pf-c-drawer__panel--MaxHeight);\n  overflow: auto;\n  background-color: var(--pf-c-drawer__panel--BackgroundColor);\n  box-shadow: var(--pf-c-drawer__panel--BoxShadow);\n  transition-duration: var(--pf-c-drawer__panel--TransitionDuration);\n  transition-property: var(--pf-c-drawer__panel--TransitionProperty);\n  -webkit-overflow-scrolling: touch;\n}\n.pf-c-drawer__panel::after {\n  position: absolute;\n  top: 0;\n  left: 0;\n  width: var(--pf-c-drawer__panel--after--Width);\n  height: 100%;\n  content: "";\n  background-color: var(--pf-c-drawer__panel--after--BackgroundColor);\n}\n.pf-c-drawer__panel.pf-m-no-background {\n  --pf-c-drawer__panel--BackgroundColor: transparent;\n}\n.pf-c-drawer__panel.pf-m-light-200 {\n  --pf-c-drawer__panel--BackgroundColor: var(--pf-c-drawer__panel--m-light-200--BackgroundColor);\n}\n@media screen and (min-width: 768px) {\n  .pf-c-drawer__panel {\n    --pf-c-drawer__panel--FlexBasis:\n      max(\n        var(--pf-c-drawer__panel--md--FlexBasis--min),\n        min(var(--pf-c-drawer__panel--md--FlexBasis), var(--pf-c-drawer__panel--md--FlexBasis--max))\n      );\n  }\n}\n@media screen and (min-width: 1200px) {\n  .pf-c-drawer__panel {\n    --pf-c-drawer__panel--md--FlexBasis: var(--pf-c-drawer__panel--xl--FlexBasis);\n  }\n  .pf-c-drawer.pf-m-panel-bottom .pf-c-drawer__panel {\n    --pf-c-drawer__panel--md--FlexBasis: var(--pf-c-drawer--m-panel-bottom__panel--xl--FlexBasis);\n  }\n}\n\n.pf-c-drawer__panel-main {\n  flex-grow: 1;\n}\n\n@keyframes pf-remove-tab-focus {\n  to {\n    visibility: hidden;\n  }\n}\n.pf-c-drawer__panel[hidden] {\n  animation-name: pf-remove-tab-focus;\n  animation-delay: var(--pf-c-drawer__panel--TransitionDuration);\n  animation-fill-mode: forwards;\n}\n\n.pf-c-drawer__head {\n  display: grid;\n  grid-template-columns: auto;\n  grid-auto-columns: max-content;\n}\n.pf-c-drawer__head > * {\n  grid-column: 1;\n}\n\n.pf-c-drawer__actions {\n  grid-column: 2;\n  grid-row: 1;\n  display: flex;\n  align-self: baseline;\n  margin-top: var(--pf-c-drawer__actions--MarginTop);\n  margin-right: var(--pf-c-drawer__actions--MarginRight);\n}\n\n.pf-c-drawer__body {\n  min-height: 0;\n  padding: var(--pf-c-drawer--child--PaddingTop) var(--pf-c-drawer--child--PaddingRight) var(--pf-c-drawer--child--PaddingBottom) var(--pf-c-drawer--child--PaddingLeft);\n}\n.pf-c-drawer__body.pf-m-no-padding {\n  padding: 0;\n}\n.pf-c-drawer__body.pf-m-no-padding > .pf-c-drawer__actions,\n.pf-c-drawer__body.pf-m-no-padding > .pf-c-drawer__head > .pf-c-drawer__actions {\n  margin-top: 0;\n  margin-right: 0;\n}\n.pf-c-drawer__body.pf-m-padding {\n  padding: var(--pf-c-drawer--child--m-padding--PaddingTop) var(--pf-c-drawer--child--m-padding--PaddingRight) var(--pf-c-drawer--child--m-padding--PaddingBottom) var(--pf-c-drawer--child--m-padding--PaddingLeft);\n}\n.pf-c-drawer__body:not(.pf-m-no-padding) + * {\n  padding-top: 0;\n}\n.pf-c-drawer__body:last-child {\n  flex: 1 1;\n}\n\n.pf-c-drawer__body > .pf-c-page__main {\n  height: 100%;\n}\n\n.pf-c-drawer__splitter {\n  position: relative;\n  display: none;\n  width: var(--pf-c-drawer__splitter--Width);\n  height: var(--pf-c-drawer__splitter--Height);\n  cursor: var(--pf-c-drawer__splitter--Cursor);\n  visibility: hidden;\n  background-color: var(--pf-c-drawer__splitter--BackgroundColor);\n}\n.pf-c-drawer__splitter.pf-m-vertical {\n  --pf-c-drawer__splitter--Height: var(--pf-c-drawer__splitter--m-vertical--Height);\n  --pf-c-drawer__splitter--Width: var(--pf-c-drawer__splitter--m-vertical--Width);\n  --pf-c-drawer__splitter--Cursor: var(--pf-c-drawer__splitter--m-vertical--Cursor);\n  --pf-c-drawer__splitter-handle--after--Width: var(--pf-c-drawer__splitter--m-vertical__splitter-handle--after--Width);\n  --pf-c-drawer__splitter-handle--after--Height: var(--pf-c-drawer__splitter--m-vertical__splitter-handle--after--Height);\n  --pf-c-drawer__splitter-handle--after--BorderTopWidth: var(--pf-c-drawer__splitter--m-vertical__splitter-handle--after--BorderTopWidth);\n  --pf-c-drawer__splitter-handle--after--BorderRightWidth: var(--pf-c-drawer__splitter--m-vertical__splitter-handle--after--BorderRightWidth);\n  --pf-c-drawer__splitter-handle--after--BorderBottomWidth: var(--pf-c-drawer__splitter--m-vertical__splitter-handle--after--BorderBottomWidth);\n  --pf-c-drawer__splitter-handle--after--BorderLeftWidth: var(--pf-c-drawer__splitter--m-vertical__splitter-handle--after--BorderLeftWidth);\n}\n.pf-c-drawer__splitter:hover {\n  --pf-c-drawer__splitter-handle--after--BorderColor: var(--pf-c-drawer__splitter--hover__splitter-handle--after--BorderColor);\n}\n.pf-c-drawer__splitter:focus {\n  --pf-c-drawer__splitter-handle--after--BorderColor: var(--pf-c-drawer__splitter--focus__splitter-handle--after--BorderColor);\n}\n.pf-c-drawer__splitter::after {\n  position: absolute;\n  top: 0;\n  right: 0;\n  bottom: 0;\n  left: 0;\n  content: "";\n  border: solid var(--pf-c-drawer__splitter--after--BorderColor);\n  border-width: var(--pf-c-drawer__splitter--after--BorderTopWidth) var(--pf-c-drawer__splitter--after--BorderRightWidth) var(--pf-c-drawer__splitter--after--BorderBottomWidth) var(--pf-c-drawer__splitter--after--BorderLeftWidth);\n}\n\n.pf-c-drawer__splitter-handle {\n  position: absolute;\n  top: var(--pf-c-drawer__splitter-handle--Top);\n  left: var(--pf-c-drawer__splitter-handle--Left);\n  transform: translate(-50%, -50%);\n}\n.pf-c-drawer__splitter-handle::after {\n  display: block;\n  width: var(--pf-c-drawer__splitter-handle--after--Width);\n  height: var(--pf-c-drawer__splitter-handle--after--Height);\n  content: "";\n  border-color: var(--pf-c-drawer__splitter-handle--after--BorderColor);\n  border-style: solid;\n  border-width: var(--pf-c-drawer__splitter-handle--after--BorderTopWidth) var(--pf-c-drawer__splitter-handle--after--BorderRightWidth) var(--pf-c-drawer__splitter-handle--after--BorderBottomWidth) var(--pf-c-drawer__splitter-handle--after--BorderLeftWidth);\n}\n\n@media screen and (min-width: 768px) {\n  .pf-c-drawer {\n    min-width: var(--pf-c-drawer__panel--MinWidth);\n  }\n  .pf-c-drawer.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    box-shadow: var(--pf-c-drawer--m-expanded__panel--BoxShadow);\n  }\n  .pf-c-drawer > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-resizable {\n    --pf-c-drawer__panel--md--FlexBasis--min: var(--pf-c-drawer__panel--m-resizable--md--FlexBasis--min);\n    flex-direction: var(--pf-c-drawer__panel--m-resizable--FlexDirection);\n    min-width: var(--pf-c-drawer__panel--m-resizable--MinWidth);\n  }\n  .pf-c-drawer > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-resizable::after {\n    width: 0;\n    height: 0;\n  }\n  .pf-c-drawer > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-resizable > .pf-c-drawer__splitter {\n    flex-shrink: 0;\n  }\n  .pf-c-drawer > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-resizable > .pf-c-drawer__panel-main {\n    flex-shrink: 1;\n  }\n  .pf-c-drawer.pf-m-panel-left {\n    --pf-c-drawer--m-expanded__panel--BoxShadow: var(--pf-c-drawer--m-expanded--m-panel-left__panel--BoxShadow);\n  }\n  .pf-c-drawer.pf-m-panel-left.pf-m-inline > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border, .pf-m-resizable), .pf-c-drawer.pf-m-panel-left.pf-m-static > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border, .pf-m-resizable) {\n    padding-right: var(--pf-c-drawer--m-panel-left--m-inline__panel--PaddingRight);\n    padding-left: 0;\n  }\n  .pf-c-drawer.pf-m-panel-left.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel::after {\n    right: 0;\n    left: auto;\n  }\n  .pf-c-drawer.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-resizable > .pf-c-drawer__splitter {\n    --pf-c-drawer__splitter-handle--Left: var(--pf-c-drawer--m-panel-left__splitter-handle--Left);\n    --pf-c-drawer__splitter--after--BorderRightWidth: 0;\n    --pf-c-drawer__splitter--after--BorderLeftWidth: var(--pf-c-drawer--m-panel-left__splitter--after--BorderLeftWidth);\n    order: 1;\n  }\n  .pf-c-drawer.pf-m-panel-bottom {\n    --pf-c-drawer--m-expanded__panel--BoxShadow: var(--pf-c-drawer--m-expanded--m-panel-bottom__panel--BoxShadow);\n    --pf-c-drawer__panel--MaxHeight: 100%;\n    --pf-c-drawer__panel--FlexBasis--min: var(--pf-c-drawer--m-panel-bottom__panel--FlexBasis--min);\n    min-width: auto;\n    min-height: var(--pf-c-drawer--m-panel-bottom__panel--md--MinHeight);\n  }\n  .pf-c-drawer.pf-m-panel-bottom.pf-m-inline > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border, .pf-m-resizable), .pf-c-drawer.pf-m-panel-bottom.pf-m-static > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border, .pf-m-resizable) {\n    padding-top: var(--pf-c-drawer--m-panel-bottom--m-inline__panel--PaddingTop);\n    padding-left: 0;\n  }\n  .pf-c-drawer.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel::after {\n    top: 0;\n    left: auto;\n    width: 100%;\n    height: var(--pf-c-drawer--m-panel-bottom__panel--after--Height);\n  }\n  .pf-c-drawer.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-resizable {\n    --pf-c-drawer__panel--md--FlexBasis--min: var(--pf-c-drawer--m-panel-bottom__panel--m-resizable--md--FlexBasis--min);\n    --pf-c-drawer__panel--m-resizable--FlexDirection: var(--pf-c-drawer--m-panel-bottom__panel--m-resizable--FlexDirection);\n    --pf-c-drawer__panel--m-resizable--MinWidth: 0;\n    min-height: var(--pf-c-drawer--m-panel-bottom__panel--m-resizable--MinHeight);\n  }\n  .pf-c-drawer.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-resizable > .pf-c-drawer__splitter {\n    --pf-c-drawer__splitter-handle--Top: var(--pf-c-drawer--m-panel-bottom__splitter-handle--Top);\n    --pf-c-drawer__splitter--after--BorderRightWidth: 0;\n    --pf-c-drawer__splitter--after--BorderBottomWidth: var(--pf-c-drawer--m-panel-bottom__splitter--after--BorderBottomWidth);\n  }\n  .pf-c-drawer.pf-m-inline > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-resizable > .pf-c-drawer__splitter {\n    --pf-c-drawer__splitter--m-vertical--Width: var(--pf-c-drawer--m-inline__splitter--m-vertical--Width);\n    --pf-c-drawer__splitter-handle--Left: var(--pf-c-drawer--m-inline__splitter-handle--Left);\n    --pf-c-drawer__splitter--after--BorderRightWidth: var(--pf-c-drawer--m-inline__splitter--after--BorderRightWidth);\n    --pf-c-drawer__splitter--after--BorderLeftWidth: var(--pf-c-drawer--m-inline__splitter--after--BorderLeftWidth);\n    outline-offset: var(--pf-c-drawer--m-inline__splitter--focus--OutlineOffset);\n  }\n  .pf-c-drawer.pf-m-inline.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-resizable > .pf-c-drawer__splitter {\n    --pf-c-drawer__splitter--Height: var(--pf-c-drawer--m-inline--m-panel-bottom__splitter--Height);\n    --pf-c-drawer__splitter-handle--Top: var(--pf-c-drawer--m-inline--m-panel-bottom__splitter-handle--Top);\n    --pf-c-drawer__splitter--after--BorderTopWidth: var(--pf-c-drawer--m-inline--m-panel-bottom__splitter--after--BorderTopWidth);\n    --pf-c-drawer__splitter--after--BorderRightWidth: 0;\n    --pf-c-drawer__splitter--after--BorderLeftWidth: 0;\n  }\n  .pf-c-drawer > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-no-border,\n.pf-c-drawer.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel.pf-m-no-border {\n    --pf-c-drawer--m-expanded__panel--BoxShadow: none;\n  }\n  .pf-c-drawer__splitter {\n    display: block;\n    visibility: visible;\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-drawer__panel.pf-m-width-25 {\n    --pf-c-drawer__panel--md--FlexBasis: 25%;\n  }\n  .pf-c-drawer__panel.pf-m-width-33 {\n    --pf-c-drawer__panel--md--FlexBasis: 33%;\n  }\n  .pf-c-drawer__panel.pf-m-width-50 {\n    --pf-c-drawer__panel--md--FlexBasis: 50%;\n  }\n  .pf-c-drawer__panel.pf-m-width-66 {\n    --pf-c-drawer__panel--md--FlexBasis: 66%;\n  }\n  .pf-c-drawer__panel.pf-m-width-75 {\n    --pf-c-drawer__panel--md--FlexBasis: 75%;\n  }\n  .pf-c-drawer__panel.pf-m-width-100 {\n    --pf-c-drawer__panel--md--FlexBasis: 100%;\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-drawer__panel.pf-m-width-25-on-lg {\n    --pf-c-drawer__panel--md--FlexBasis: 25%;\n  }\n  .pf-c-drawer__panel.pf-m-width-33-on-lg {\n    --pf-c-drawer__panel--md--FlexBasis: 33%;\n  }\n  .pf-c-drawer__panel.pf-m-width-50-on-lg {\n    --pf-c-drawer__panel--md--FlexBasis: 50%;\n  }\n  .pf-c-drawer__panel.pf-m-width-66-on-lg {\n    --pf-c-drawer__panel--md--FlexBasis: 66%;\n  }\n  .pf-c-drawer__panel.pf-m-width-75-on-lg {\n    --pf-c-drawer__panel--md--FlexBasis: 75%;\n  }\n  .pf-c-drawer__panel.pf-m-width-100-on-lg {\n    --pf-c-drawer__panel--md--FlexBasis: 100%;\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-drawer__panel.pf-m-width-25-on-xl {\n    --pf-c-drawer__panel--md--FlexBasis: 25%;\n  }\n  .pf-c-drawer__panel.pf-m-width-33-on-xl {\n    --pf-c-drawer__panel--md--FlexBasis: 33%;\n  }\n  .pf-c-drawer__panel.pf-m-width-50-on-xl {\n    --pf-c-drawer__panel--md--FlexBasis: 50%;\n  }\n  .pf-c-drawer__panel.pf-m-width-66-on-xl {\n    --pf-c-drawer__panel--md--FlexBasis: 66%;\n  }\n  .pf-c-drawer__panel.pf-m-width-75-on-xl {\n    --pf-c-drawer__panel--md--FlexBasis: 75%;\n  }\n  .pf-c-drawer__panel.pf-m-width-100-on-xl {\n    --pf-c-drawer__panel--md--FlexBasis: 100%;\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-drawer__panel.pf-m-width-25-on-2xl {\n    --pf-c-drawer__panel--md--FlexBasis: 25%;\n  }\n  .pf-c-drawer__panel.pf-m-width-33-on-2xl {\n    --pf-c-drawer__panel--md--FlexBasis: 33%;\n  }\n  .pf-c-drawer__panel.pf-m-width-50-on-2xl {\n    --pf-c-drawer__panel--md--FlexBasis: 50%;\n  }\n  .pf-c-drawer__panel.pf-m-width-66-on-2xl {\n    --pf-c-drawer__panel--md--FlexBasis: 66%;\n  }\n  .pf-c-drawer__panel.pf-m-width-75-on-2xl {\n    --pf-c-drawer__panel--md--FlexBasis: 75%;\n  }\n  .pf-c-drawer__panel.pf-m-width-100-on-2xl {\n    --pf-c-drawer__panel--md--FlexBasis: 100%;\n  }\n}\n@media (min-width: 768px) {\n  .pf-c-drawer.pf-m-inline > .pf-c-drawer__main > .pf-c-drawer__content,\n.pf-c-drawer.pf-m-static > .pf-c-drawer__main > .pf-c-drawer__content {\n    flex-shrink: 1;\n  }\n  .pf-c-drawer.pf-m-inline > .pf-c-drawer__main > .pf-c-drawer__panel,\n.pf-c-drawer.pf-m-static > .pf-c-drawer__main > .pf-c-drawer__panel {\n    --pf-c-drawer--m-expanded__panel--BoxShadow: none;\n  }\n  .pf-c-drawer.pf-m-inline > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border)::after,\n.pf-c-drawer.pf-m-static > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border)::after {\n    background-color: var(--pf-c-drawer--m-inline--m-expanded__panel--after--BackgroundColor);\n  }\n  .pf-c-drawer.pf-m-inline > .pf-c-drawer__main > .pf-c-drawer__content {\n    overflow-x: auto;\n  }\n  .pf-c-drawer.pf-m-inline > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-left: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    transform: translateX(100%);\n  }\n  .pf-c-drawer.pf-m-inline.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-left: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-inline > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: unset;\n    visibility: visible;\n  }\n  .pf-c-drawer.pf-m-inline.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    margin-left: 0;\n    transform: translateX(-100%);\n  }\n  .pf-c-drawer.pf-m-inline.pf-m-panel-left.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-inline.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: unset;\n    visibility: visible;\n  }\n  .pf-c-drawer.pf-m-inline.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-bottom: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    transform: translateY(100%);\n  }\n  .pf-c-drawer.pf-m-inline.pf-m-panel-bottom.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-bottom: 0;\n    transform: translateY(0);\n  }\n  .pf-c-drawer.pf-m-static > .pf-c-drawer__main > .pf-c-drawer__panel {\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel {\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: none;\n    visibility: hidden;\n  }\n}\n@media (min-width: 992px) {\n  .pf-c-drawer.pf-m-inline-on-lg > .pf-c-drawer__main > .pf-c-drawer__content,\n.pf-c-drawer.pf-m-static-on-lg > .pf-c-drawer__main > .pf-c-drawer__content {\n    flex-shrink: 1;\n  }\n  .pf-c-drawer.pf-m-inline-on-lg > .pf-c-drawer__main > .pf-c-drawer__panel,\n.pf-c-drawer.pf-m-static-on-lg > .pf-c-drawer__main > .pf-c-drawer__panel {\n    --pf-c-drawer--m-expanded__panel--BoxShadow: none;\n  }\n  .pf-c-drawer.pf-m-inline-on-lg > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border)::after,\n.pf-c-drawer.pf-m-static-on-lg > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border)::after {\n    background-color: var(--pf-c-drawer--m-inline--m-expanded__panel--after--BackgroundColor);\n  }\n  .pf-c-drawer.pf-m-inline-on-lg > .pf-c-drawer__main > .pf-c-drawer__content {\n    overflow-x: auto;\n  }\n  .pf-c-drawer.pf-m-inline-on-lg > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-left: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    transform: translateX(100%);\n  }\n  .pf-c-drawer.pf-m-inline-on-lg.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-left: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-inline-on-lg > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: unset;\n    visibility: visible;\n  }\n  .pf-c-drawer.pf-m-inline-on-lg.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    margin-left: 0;\n    transform: translateX(-100%);\n  }\n  .pf-c-drawer.pf-m-inline-on-lg.pf-m-panel-left.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-inline-on-lg.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: unset;\n    visibility: visible;\n  }\n  .pf-c-drawer.pf-m-inline-on-lg.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-bottom: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    transform: translateY(100%);\n  }\n  .pf-c-drawer.pf-m-inline-on-lg.pf-m-panel-bottom.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-bottom: 0;\n    transform: translateY(0);\n  }\n  .pf-c-drawer.pf-m-static-on-lg > .pf-c-drawer__main > .pf-c-drawer__panel {\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static-on-lg.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static-on-lg.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel {\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static-on-lg > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: none;\n    visibility: hidden;\n  }\n}\n@media (min-width: 1200px) {\n  .pf-c-drawer.pf-m-inline-on-xl > .pf-c-drawer__main > .pf-c-drawer__content,\n.pf-c-drawer.pf-m-static-on-xl > .pf-c-drawer__main > .pf-c-drawer__content {\n    flex-shrink: 1;\n  }\n  .pf-c-drawer.pf-m-inline-on-xl > .pf-c-drawer__main > .pf-c-drawer__panel,\n.pf-c-drawer.pf-m-static-on-xl > .pf-c-drawer__main > .pf-c-drawer__panel {\n    --pf-c-drawer--m-expanded__panel--BoxShadow: none;\n  }\n  .pf-c-drawer.pf-m-inline-on-xl > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border)::after,\n.pf-c-drawer.pf-m-static-on-xl > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border)::after {\n    background-color: var(--pf-c-drawer--m-inline--m-expanded__panel--after--BackgroundColor);\n  }\n  .pf-c-drawer.pf-m-inline-on-xl > .pf-c-drawer__main > .pf-c-drawer__content {\n    overflow-x: auto;\n  }\n  .pf-c-drawer.pf-m-inline-on-xl > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-left: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    transform: translateX(100%);\n  }\n  .pf-c-drawer.pf-m-inline-on-xl.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-left: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-inline-on-xl > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: unset;\n    visibility: visible;\n  }\n  .pf-c-drawer.pf-m-inline-on-xl.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    margin-left: 0;\n    transform: translateX(-100%);\n  }\n  .pf-c-drawer.pf-m-inline-on-xl.pf-m-panel-left.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-inline-on-xl.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: unset;\n    visibility: visible;\n  }\n  .pf-c-drawer.pf-m-inline-on-xl.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-bottom: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    transform: translateY(100%);\n  }\n  .pf-c-drawer.pf-m-inline-on-xl.pf-m-panel-bottom.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-bottom: 0;\n    transform: translateY(0);\n  }\n  .pf-c-drawer.pf-m-static-on-xl > .pf-c-drawer__main > .pf-c-drawer__panel {\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static-on-xl.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static-on-xl.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel {\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static-on-xl > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: none;\n    visibility: hidden;\n  }\n}\n@media (min-width: 1450px) {\n  .pf-c-drawer.pf-m-inline-on-2xl > .pf-c-drawer__main > .pf-c-drawer__content,\n.pf-c-drawer.pf-m-static-on-2xl > .pf-c-drawer__main > .pf-c-drawer__content {\n    flex-shrink: 1;\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl > .pf-c-drawer__main > .pf-c-drawer__panel,\n.pf-c-drawer.pf-m-static-on-2xl > .pf-c-drawer__main > .pf-c-drawer__panel {\n    --pf-c-drawer--m-expanded__panel--BoxShadow: none;\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border)::after,\n.pf-c-drawer.pf-m-static-on-2xl > .pf-c-drawer__main > .pf-c-drawer__panel:not(.pf-m-no-border)::after {\n    background-color: var(--pf-c-drawer--m-inline--m-expanded__panel--after--BackgroundColor);\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl > .pf-c-drawer__main > .pf-c-drawer__content {\n    overflow-x: auto;\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-left: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    transform: translateX(100%);\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-left: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: unset;\n    visibility: visible;\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    margin-left: 0;\n    transform: translateX(-100%);\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl.pf-m-panel-left.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: unset;\n    visibility: visible;\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-bottom: calc(var(--pf-c-drawer__panel--FlexBasis) * -1);\n    transform: translateY(100%);\n  }\n  .pf-c-drawer.pf-m-inline-on-2xl.pf-m-panel-bottom.pf-m-expanded > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-bottom: 0;\n    transform: translateY(0);\n  }\n  .pf-c-drawer.pf-m-static-on-2xl > .pf-c-drawer__main > .pf-c-drawer__panel {\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static-on-2xl.pf-m-panel-left > .pf-c-drawer__main > .pf-c-drawer__panel {\n    margin-right: 0;\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static-on-2xl.pf-m-panel-bottom > .pf-c-drawer__main > .pf-c-drawer__panel {\n    transform: translateX(0);\n  }\n  .pf-c-drawer.pf-m-static-on-2xl > .pf-c-drawer__main > .pf-c-drawer__panel > .pf-c-drawer__body > .pf-c-drawer__head .pf-c-drawer__close {\n    display: none;\n    visibility: hidden;\n  }\n}\n:where(.pf-theme-dark) .pf-c-drawer {\n  --pf-c-drawer__panel--BackgroundColor: var(--pf-global--BackgroundColor--400);\n  --pf-c-drawer__splitter--BackgroundColor: transparent;\n}\n:where(.pf-theme-dark) .pf-c-drawer.pf-m-inline, :where(.pf-theme-dark) .pf-c-drawer.pf-m-static {\n  --pf-c-drawer__panel--BackgroundColor: var(--pf-global--BackgroundColor--100);\n}';

// node_modules/@patternfly/patternfly/components/NotificationBadge/notification-badge.css
var notification_badge_default = '.pf-c-notification-badge {\n  --pf-c-notification-badge--PaddingTop: var(--pf-global--spacer--form-element);\n  --pf-c-notification-badge--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-notification-badge--PaddingBottom: var(--pf-global--spacer--form-element);\n  --pf-c-notification-badge--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-notification-badge--MarginTop: calc(-1 * var(--pf-global--spacer--form-element));\n  --pf-c-notification-badge--MarginRight: calc(-1 * var(--pf-global--spacer--md));\n  --pf-c-notification-badge--MarginBottom: calc(-1 * var(--pf-global--spacer--form-element));\n  --pf-c-notification-badge--MarginLeft: calc(-1 * var(--pf-global--spacer--md));\n  --pf-c-notification-badge--after--BorderColor: transparent;\n  --pf-c-notification-badge--after--BorderRadius: var(--pf-global--BorderRadius--sm);\n  --pf-c-notification-badge--after--BorderWidth: 0;\n  --pf-c-notification-badge--after--Top: 0;\n  --pf-c-notification-badge--after--Right: 0;\n  --pf-c-notification-badge--after--Width: auto;\n  --pf-c-notification-badge--after--Height: auto;\n  --pf-c-notification-badge--after--BackgroundColor: transparent;\n  --pf-c-notification-badge--after--TranslateX: 0;\n  --pf-c-notification-badge--after--TranslateY: 0;\n  --pf-c-notification-badge__i--Width: auto;\n  --pf-c-notification-badge__i--Height: auto;\n  --pf-c-notification-badge--m-read--after--BorderColor: transparent;\n  --pf-c-notification-badge--m-read--after--BackgroundColor: transparent;\n  --pf-c-notification-badge--m-read--m-expanded--after--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-notification-badge--m-unread--Color: var(--pf-global--Color--light-100);\n  --pf-c-notification-badge--m-unread--after--BackgroundColor: var(--pf-global--active-color--100);\n  --pf-c-notification-badge--m-unread--hover--after--BackgroundColor: var(--pf-global--primary-color--200);\n  --pf-c-notification-badge--m-unread--m-expanded--after--BackgroundColor: var(--pf-global--primary-color--200);\n  --pf-c-notification-badge--m-attention--Color: var(--pf-global--Color--light-100);\n  --pf-c-notification-badge--m-attention--after--BackgroundColor: var(--pf-global--danger-color--100);\n  --pf-c-notification-badge--m-attention--hover--after--BackgroundColor: var(--pf-global--danger-color--200);\n  --pf-c-notification-badge--m-attention--m-expanded--after--BackgroundColor: var(--pf-global--danger-color--200);\n  --pf-c-notification-badge__count--MarginLeft: var(--pf-global--spacer--xs);\n  --pf-c-notification-badge--pf-icon-attention-bell--LineHeight: var(--pf-global--LineHeight--sm);\n  position: relative;\n  display: inline-block;\n  padding: var(--pf-c-notification-badge--PaddingTop) var(--pf-c-notification-badge--PaddingRight) var(--pf-c-notification-badge--PaddingBottom) var(--pf-c-notification-badge--PaddingLeft);\n  margin: var(--pf-c-notification-badge--MarginTop) var(--pf-c-notification-badge--MarginRight) var(--pf-c-notification-badge--MarginBottom) var(--pf-c-notification-badge--MarginLeft);\n  background-color: var(--pf-c-notification-badge--after--BackgroundColor);\n  border-radius: var(--pf-c-notification-badge--after--BorderRadius);\n}\n.pf-c-notification-badge::before {\n  position: absolute;\n  top: var(--pf-c-notification-badge--after--Top);\n  right: var(--pf-c-notification-badge--after--Right);\n  bottom: 0;\n  left: 0;\n  width: var(--pf-c-notification-badge--after--Width);\n  height: var(--pf-c-notification-badge--after--Height);\n  content: "";\n  border: var(--pf-c-notification-badge--after--BorderWidth) solid var(--pf-c-notification-badge--after--BorderColor);\n  border-radius: var(--pf-c-notification-badge--after--BorderRadius);\n  transform: translate(var(--pf-c-notification-badge--after--TranslateX), var(--pf-c-notification-badge--after--TranslateY));\n}\n.pf-c-notification-badge > i {\n  width: var(--pf-c-notification-badge__i--Width);\n  height: var(--pf-c-notification-badge__i--Height);\n}\n.pf-c-notification-badge > * {\n  position: relative;\n}\n.pf-c-notification-badge .pf-icon-attention-bell,\n.pf-c-notification-badge .pf-icon-bell {\n  display: inline-block;\n  line-height: var(--pf-c-notification-badge--pf-icon-attention-bell--LineHeight);\n}\n.pf-c-notification-badge .pf-icon-attention-bell::before,\n.pf-c-notification-badge .pf-icon-bell::before {\n  vertical-align: bottom;\n}\n.pf-c-notification-badge.pf-m-read {\n  --pf-c-notification-badge--after--BackgroundColor: var(--pf-c-notification-badge--m-read--after--BackgroundColor);\n  --pf-c-notification-badge--after--BorderColor: var(--pf-c-notification-badge--m-read--after--BorderColor);\n  color: var(--pf-c-notification-badge--m-read--Color, inherit);\n}\n.pf-c-notification-badge.pf-m-unread {\n  --pf-c-notification-badge--after--BackgroundColor: var(--pf-c-notification-badge--m-unread--after--BackgroundColor);\n  color: var(--pf-c-notification-badge--m-unread--Color);\n}\n.pf-c-notification-badge.pf-m-unread:hover {\n  --pf-c-notification-badge--after--BackgroundColor: var(--pf-c-notification-badge--m-unread--hover--after--BackgroundColor);\n}\n.pf-c-notification-badge.pf-m-attention {\n  --pf-c-notification-badge--after--BackgroundColor: var(--pf-c-notification-badge--m-attention--after--BackgroundColor);\n  color: var(--pf-c-notification-badge--m-attention--Color);\n}\n.pf-c-notification-badge.pf-m-attention:hover {\n  --pf-c-notification-badge--m-attention--after--BackgroundColor: var(--pf-c-notification-badge--m-attention--hover--after--BackgroundColor);\n}\n.pf-c-notification-badge.pf-m-expanded {\n  --pf-c-notification-badge--m-read--Color: var(--pf-global--Color--light-100);\n  --pf-c-notification-badge--m-read--after--BackgroundColor: var(--pf-c-notification-badge--m-read--m-expanded--after--BackgroundColor);\n  --pf-c-notification-badge--m-unread--after--BackgroundColor: var(--pf-c-notification-badge--m-unread--m-expanded--after--BackgroundColor);\n  --pf-c-notification-badge--m-attention--after--BackgroundColor: var(--pf-c-notification-badge--m-attention--m-expanded--after--BackgroundColor);\n}\n\n.pf-c-notification-badge__count {\n  margin-left: var(--pf-c-notification-badge__count--MarginLeft);\n}\n\n:where(.pf-theme-dark) .pf-c-notification-badge {\n  --pf-c-notification-badge--m-read--m-expanded--after--BackgroundColor: var(--pf-global--BackgroundColor--400);\n  --pf-c-notification-badge--m-unread--after--BackgroundColor: var(--pf-global--primary-color--300);\n  --pf-c-notification-badge--m-attention--Color: var(--pf-global--palette--black-900);\n}';

// src/components/ak-nav-buttons.ts
var NavigationButtons = class extends AKElement {
  constructor() {
    super(...arguments);
    this.notificationDrawerOpen = false;
    this.apiDrawerOpen = false;
    this.notificationsCount = 0;
  }
  static get styles() {
    return [
      patternfly_base_default,
      display_default,
      brand_default,
      page_default,
      avatar_default,
      button_default,
      drawer_default,
      dropdown_default,
      notification_badge_default,
      i`
                .pf-c-page__header-tools {
                    display: flex;
                }
                :host([theme="dark"]) .pf-c-page__header-tools {
                    color: var(--ak-dark-foreground) !important;
                }
                :host([theme="light"]) .pf-c-page__header-tools-item .fas,
                :host([theme="light"]) .pf-c-notification-badge__count,
                :host([theme="light"]) .pf-c-page__header-tools-group .pf-c-button {
                    color: var(--ak-global--Color--100) !important;
                }
            `
    ];
  }
  async firstUpdated() {
    this.me = await me();
    const notifications = await new EventsApi(DEFAULT_CONFIG).eventsNotificationsList({
      seen: false,
      ordering: "-created",
      pageSize: 1,
      user: this.me.user.pk
    });
    this.notificationsCount = notifications.pagination.count;
    this.uiConfig = await uiConfig();
  }
  renderApiDrawerTrigger() {
    if (!this.uiConfig?.enabledFeatures.apiDrawer) {
      return D;
    }
    const onClick = (ev) => {
      ev.stopPropagation();
      this.dispatchEvent(
        new Event(EVENT_API_DRAWER_TOGGLE, { bubbles: true, composed: true })
      );
    };
    return ke`<div class="pf-c-page__header-tools-item pf-m-hidden pf-m-visible-on-lg">
            <button class="pf-c-button pf-m-plain" type="button" @click=${onClick}>
                <pf-tooltip position="top" content=${msg("Open API drawer")}>
                    <i class="fas fa-code" aria-hidden="true"></i>
                </pf-tooltip>
            </button>
        </div>`;
  }
  renderNotificationDrawerTrigger() {
    if (!this.uiConfig?.enabledFeatures.notificationDrawer) {
      return D;
    }
    const onClick = (ev) => {
      ev.stopPropagation();
      this.dispatchEvent(
        new Event(EVENT_NOTIFICATION_DRAWER_TOGGLE, { bubbles: true, composed: true })
      );
    };
    return ke`<div class="pf-c-page__header-tools-item pf-m-hidden pf-m-visible-on-lg">
            <button
                class="pf-c-button pf-m-plain"
                type="button"
                aria-label="${msg("Unread notifications")}"
                @click=${onClick}
            >
                <span
                    class="pf-c-notification-badge ${this.notificationsCount > 0 ? "pf-m-unread" : ""}"
                >
                    <pf-tooltip position="top" content=${msg("Open Notification drawer")}>
                        <i class="fas fa-bell" aria-hidden="true"></i>
                    </pf-tooltip>
                    <span class="pf-c-notification-badge__count">${this.notificationsCount}</span>
                </span>
            </button>
        </div> `;
  }
  renderSettings() {
    if (!this.uiConfig?.enabledFeatures.settings) {
      return D;
    }
    return ke`<div class="pf-c-page__header-tools-item">
            <a
                class="pf-c-button pf-m-plain"
                type="button"
                href="${globalAK().api.base}if/user/#/settings"
            >
                <pf-tooltip position="top" content=${msg("Settings")}>
                    <i class="fas fa-cog" aria-hidden="true"></i>
                </pf-tooltip>
            </a>
        </div>`;
  }
  renderImpersonation() {
    if (!this.me?.original) {
      return D;
    }
    const onClick = async () => {
      await new CoreApi(DEFAULT_CONFIG).coreUsersImpersonateEndRetrieve();
      window.location.reload();
    };
    return ke`&nbsp;
            <div class="pf-c-page__header-tools">
                <div class="pf-c-page__header-tools-group">
                    <ak-action-button class="pf-m-warning pf-m-small" .apiRequest=${onClick}>
                        ${msg("Stop impersonation")}
                    </ak-action-button>
                </div>
            </div>`;
  }
  get userDisplayName() {
    return z(this.uiConfig?.navbar.userDisplay).with("username" /* username */, () => this.me?.user.username).with("name" /* name */, () => this.me?.user.name).with("email" /* email */, () => this.me?.user.email || "").with("none" /* none */, () => "").otherwise(() => this.me?.user.username);
  }
  render() {
    return ke`<div class="pf-c-page__header-tools">
            <div class="pf-c-page__header-tools-group">
                ${this.renderApiDrawerTrigger()}
                <!-- -->
                ${this.renderNotificationDrawerTrigger()}
                <!-- -->
                ${this.renderSettings()}
                <div class="pf-c-page__header-tools-item">
                    <a
                        href="${globalAK().api.base}flows/-/default/invalidation/"
                        class="pf-c-button pf-m-plain"
                    >
                        <pf-tooltip position="top" content=${msg("Sign out")}>
                            <i class="fas fa-sign-out-alt" aria-hidden="true"></i>
                        </pf-tooltip>
                    </a>
                </div>
                <slot name="extra"></slot>
            </div>
            ${this.renderImpersonation()}
            ${this.userDisplayName != "" ? ke`<div class="pf-c-page__header-tools-group">
                      <div class="pf-c-page__header-tools-item pf-m-hidden pf-m-visible-on-md">
                          ${this.userDisplayName}
                      </div>
                  </div>` : D}
            <img
                class="pf-c-avatar"
                src=${to(this.me?.user.avatar)}
                alt="${msg("Avatar image")}"
            />
        </div>`;
  }
};
__decorateClass([
  n({ type: Object })
], NavigationButtons.prototype, "uiConfig", 2);
__decorateClass([
  n({ type: Object })
], NavigationButtons.prototype, "me", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], NavigationButtons.prototype, "notificationDrawerOpen", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], NavigationButtons.prototype, "apiDrawerOpen", 2);
__decorateClass([
  n({ type: Number })
], NavigationButtons.prototype, "notificationsCount", 2);
NavigationButtons = __decorateClass([
  t("ak-nav-buttons")
], NavigationButtons);

// src/elements/Interface/VersionContextController.ts
var VersionContextController = class {
  constructor(host) {
    this.host = host;
    this.context = new i2(this.host, {
      context: authentikVersionContext,
      initialValue: void 0
    });
    this.fetch = this.fetch.bind(this);
    this.fetch();
  }
  fetch() {
    new AdminApi(DEFAULT_CONFIG).adminVersionRetrieve().then((version) => {
      this.context.setValue(version);
      this.host.version = version;
    });
  }
  hostConnected() {
    window.addEventListener(EVENT_REFRESH, this.fetch);
  }
  hostDisconnected() {
    window.removeEventListener(EVENT_REFRESH, this.fetch);
  }
  hostUpdate() {
    if (this.host.version !== this.context.value) {
      this.context.setValue(this.host.version);
    }
  }
};

// src/elements/Interface/BrandContextController.ts
var BrandContextController = class {
  constructor(host) {
    this.host = host;
    this.context = new i2(this.host, {
      context: authentikBrandContext,
      initialValue: void 0
    });
    this.fetch = this.fetch.bind(this);
    this.fetch();
  }
  fetch() {
    new CoreApi(DEFAULT_CONFIG).coreBrandsCurrentRetrieve().then((brand) => {
      this.context.setValue(brand);
      this.host.brand = brand;
    });
  }
  hostConnected() {
    window.addEventListener(EVENT_REFRESH, this.fetch);
  }
  hostDisconnected() {
    window.removeEventListener(EVENT_REFRESH, this.fetch);
  }
  hostUpdate() {
    if (this.host.brand !== this.context.value) {
      this.context.setValue(this.host.brand);
    }
  }
};

// src/elements/Interface/ConfigContextController.ts
var ConfigContextController = class {
  constructor(host) {
    this.host = host;
    this.context = new i2(this.host, {
      context: authentikConfigContext,
      initialValue: void 0
    });
    this.context.setValue(globalAK().config);
    this.host.config = globalAK().config;
    this.fetch = this.fetch.bind(this);
    this.fetch();
  }
  fetch() {
    new RootApi(DEFAULT_CONFIG).rootConfigRetrieve().then((config) => {
      this.context.setValue(config);
      this.host.config = config;
    });
  }
  hostConnected() {
    window.addEventListener(EVENT_REFRESH, this.fetch);
  }
  hostDisconnected() {
    window.removeEventListener(EVENT_REFRESH, this.fetch);
  }
  hostUpdate() {
    if (this.host.config !== this.context.value) {
      this.context.setValue(this.host.config);
    }
  }
};

// src/elements/Interface/EnterpriseContextController.ts
var EnterpriseContextController = class {
  constructor(host) {
    this.host = host;
    this.context = new i2(this.host, {
      context: authentikEnterpriseContext,
      initialValue: void 0
    });
    this.fetch = this.fetch.bind(this);
    this.fetch();
  }
  fetch() {
    new EnterpriseApi(DEFAULT_CONFIG).enterpriseLicenseSummaryRetrieve().then((enterprise) => {
      this.context.setValue(enterprise);
      this.host.licenseSummary = enterprise;
    });
  }
  hostConnected() {
    window.addEventListener(EVENT_REFRESH_ENTERPRISE, this.fetch);
  }
  hostDisconnected() {
    window.removeEventListener(EVENT_REFRESH_ENTERPRISE, this.fetch);
  }
  hostUpdate() {
    if (this.host.licenseSummary !== this.context.value) {
      this.context.setValue(this.host.licenseSummary);
    }
  }
};

// src/elements/Interface/Interface.ts
var brandContext = Symbol("brandContext");
var configContext = Symbol("configContext");
var modalController = Symbol("modalController");
var versionContext = Symbol("versionContext");
var _a;
var Interface = class extends (_a = AKElement, brandContext, configContext, modalController, _a) {
  constructor() {
    super();
    document.adoptedStyleSheets = [...document.adoptedStyleSheets, ensureCSSStyleSheet(patternfly_base_default)];
    this._initContexts();
    this.dataset.akInterfaceRoot = "true";
  }
  _initContexts() {
    this[brandContext] = new BrandContextController(this);
    this[configContext] = new ConfigContextController(this);
    this[modalController] = new ModalOrchestrationController(this);
  }
  _activateTheme(theme, ...roots) {
    if (theme === this._activeTheme) {
      return;
    }
    console.debug(
      `authentik/interface[${rootInterface()?.tagName.toLowerCase()}]: Enabling theme ${theme}`
    );
    roots.unshift(document);
    super._activateTheme(theme, ...roots);
  }
  async getTheme() {
    if (!this.uiConfig) {
      this.uiConfig = await uiConfig();
    }
    return this.uiConfig.theme?.base || UiThemeEnum.Automatic;
  }
};
__decorateClass([
  r()
], Interface.prototype, "uiConfig", 2);
__decorateClass([
  r()
], Interface.prototype, "config", 2);
__decorateClass([
  r()
], Interface.prototype, "brand", 2);
var enterpriseContext = Symbol("enterpriseContext");
var _a2;
var AuthenticatedInterface = class extends (_a2 = Interface, enterpriseContext, versionContext, _a2) {
  constructor() {
    super();
  }
  _initContexts() {
    super._initContexts();
    this[enterpriseContext] = new EnterpriseContextController(this);
    this[versionContext] = new VersionContextController(this);
  }
};
__decorateClass([
  r()
], AuthenticatedInterface.prototype, "licenseSummary", 2);
__decorateClass([
  r()
], AuthenticatedInterface.prototype, "version", 2);

// src/elements/utils/customEvents.ts
var customEvent = (name, details = {}) => new CustomEvent(name, {
  composed: true,
  bubbles: true,
  detail: details
});

// src/locale-codes.ts
var sourceLocale = `en`;
var targetLocales = [
  `de`,
  `en`,
  `es`,
  `fr`,
  `it`,
  `ko`,
  `nl`,
  `pl`,
  `pseudo-LOCALE`,
  `ru`,
  `tr`,
  `zh_TW`,
  `zh-CN`,
  `zh-Hans`,
  `zh-Hant`
];

// src/elements/ak-locale-context/helpers.ts
var DEFAULT_LOCALE = "en";
var TOMBSTONE = "\u26FC\u26FCtombstone\u26FC\u26FC";
var LOCALES2 = LOCALES.map(
  (locale) => locale.code === "en" ? { ...locale, locale: async () => enLocale } : locale
);
function getBestMatchLocale(locale) {
  return LOCALES2.find((l2) => l2.match.test(locale));
}
function findSupportedLocale(candidates) {
  const candidate = candidates.find((candidate2) => getBestMatchLocale(candidate2));
  return candidate ? getBestMatchLocale(candidate) : void 0;
}
function localeCodeFromUrl(param = "locale") {
  const url = new URL(window.location.href);
  return url.searchParams.get(param) || "";
}
var isLocaleCandidate = (v2) => typeof v2 === "string" && v2 !== "" && v2 !== TOMBSTONE;
function autoDetectLanguage(userReq = TOMBSTONE, brandReq = TOMBSTONE) {
  const localeCandidates = [
    localeCodeFromUrl("locale"),
    userReq,
    window.navigator?.language ?? TOMBSTONE,
    brandReq,
    globalAK()?.locale ?? TOMBSTONE,
    DEFAULT_LOCALE
  ].filter(isLocaleCandidate);
  const firstSupportedLocale = findSupportedLocale(localeCandidates);
  if (!firstSupportedLocale) {
    console.debug(
      `authentik/locale: No locale found for '[${localeCandidates}.join(',')]', falling back to ${DEFAULT_LOCALE}`
    );
    return DEFAULT_LOCALE;
  }
  return firstSupportedLocale.code;
}

// src/elements/ak-locale-context/configureLocale.ts
var getLocale = void 0;
var setLocale = void 0;
function initializeLocalization() {
  if (getLocale && setLocale) {
    return [getLocale, setLocale];
  }
  ({ getLocale, setLocale } = configureLocalization({
    sourceLocale,
    targetLocales,
    loadLocale: async (locale) => {
      const localeDef = getBestMatchLocale(locale);
      if (!localeDef) {
        console.warn(`Unrecognized locale: ${localeDef}`);
        return Promise.reject("");
      }
      return localeDef.locale();
    }
  }));
  return [getLocale, setLocale];
}

// src/elements/ak-locale-context/ak-locale-context.ts
var LocaleContext = class extends WithBrandConfig(AKElement) {
  constructor(code = DEFAULT_LOCALE) {
    super();
    this.locale = DEFAULT_LOCALE;
    this.param = "locale";
    this.notifyApplication = this.notifyApplication.bind(this);
    this.updateLocaleHandler = this.updateLocaleHandler.bind(this);
    try {
      const [getLocale2, setLocale2] = initializeLocalization();
      this.getLocale = getLocale2;
      this.setLocale = setLocale2;
      this.setLocale(code).then(() => {
        window.setTimeout(this.notifyApplication, 0);
      });
    } catch (e3) {
      throw new Error(`Developer error: Must have only one locale context per session: ${e3}`);
    }
  }
  connectedCallback() {
    super.connectedCallback();
    this.updateLocale();
    window.addEventListener(EVENT_LOCALE_REQUEST, this.updateLocaleHandler);
  }
  disconnectedCallback() {
    window.removeEventListener(EVENT_LOCALE_REQUEST, this.updateLocaleHandler);
    super.disconnectedCallback();
  }
  updateLocaleHandler(ev) {
    console.debug("authentik/locale: Locale update request received.");
    this.updateLocale(ev.detail.locale);
  }
  updateLocale(requestedLocale = void 0) {
    const localeRequest = autoDetectLanguage(requestedLocale, this.brand?.defaultLocale);
    const locale = getBestMatchLocale(localeRequest);
    if (!locale) {
      console.warn(`authentik/locale: failed to find locale for code ${localeRequest}`);
      return;
    }
    locale.locale().then(() => {
      console.debug(`authentik/locale: Setting Locale to ${locale.label()} (${locale.code})`);
      this.setLocale(locale.code).then(() => {
        window.setTimeout(this.notifyApplication, 0);
      });
    });
  }
  notifyApplication() {
    this.dispatchEvent(customEvent(EVENT_LOCALE_CHANGE));
  }
  render() {
    return ke`<slot></slot>`;
  }
};
__decorateClass([
  n({ attribute: true, type: String })
], LocaleContext.prototype, "locale", 2);
__decorateClass([
  n({ attribute: true, type: String })
], LocaleContext.prototype, "param", 2);
LocaleContext = __decorateClass([
  t("ak-locale-context")
], LocaleContext);

// src/elements/Interface/licenseSummaryProvider.ts
function WithLicenseSummary(superclass, subscribe = true) {
  class WithEnterpriseProvider extends superclass {
    get hasEnterpriseLicense() {
      return this.licenseSummary?.status !== LicenseSummaryStatusEnum.Unlicensed;
    }
  }
  __decorateClass([
    c({ context: authentikEnterpriseContext, subscribe })
  ], WithEnterpriseProvider.prototype, "licenseSummary", 2);
  return WithEnterpriseProvider;
}

// node_modules/@patternfly/patternfly/components/Banner/banner.css
var banner_default = ".pf-c-banner.pf-m-warning, .pf-c-banner.pf-m-gold, .pf-c-banner.pf-m-info, .pf-c-banner.pf-m-blue {\n  --pf-global--Color--100: var(--pf-global--Color--dark-100);\n  --pf-global--Color--200: var(--pf-global--Color--dark-200);\n  --pf-global--BorderColor--100: var(--pf-global--BorderColor--dark-100);\n  --pf-global--primary-color--100: var(--pf-global--primary-color--dark-100);\n  --pf-global--link--Color: var(--pf-global--link--Color--dark);\n  --pf-global--link--Color--hover: var(--pf-global--link--Color--dark--hover);\n  --pf-global--BackgroundColor--100: var(--pf-global--BackgroundColor--light-100);\n}\n\n.pf-c-banner {\n  --pf-global--Color--100: var(--pf-global--Color--light-100);\n  --pf-global--Color--200: var(--pf-global--Color--light-200);\n  --pf-global--BorderColor--100: var(--pf-global--BorderColor--light-100);\n  --pf-global--primary-color--100: var(--pf-global--primary-color--light-100);\n  --pf-global--link--Color: var(--pf-global--link--Color--light);\n  --pf-global--link--Color--hover: var(--pf-global--link--Color--light);\n  --pf-global--BackgroundColor--100: var(--pf-global--BackgroundColor--dark-100);\n}\n.pf-c-banner .pf-c-card {\n  --pf-c-card--BackgroundColor: var(--pf-global--BackgroundColor--dark-transparent-200);\n}\n.pf-c-banner .pf-c-button {\n  --pf-c-button--m-primary--Color: var(--pf-global--primary-color--dark-100);\n  --pf-c-button--m-primary--hover--Color: var(--pf-global--primary-color--dark-100);\n  --pf-c-button--m-primary--focus--Color: var(--pf-global--primary-color--dark-100);\n  --pf-c-button--m-primary--active--Color: var(--pf-global--primary-color--dark-100);\n  --pf-c-button--m-primary--BackgroundColor: var(--pf-global--BackgroundColor--light-100);\n  --pf-c-button--m-primary--hover--BackgroundColor: var(--pf-global--BackgroundColor--light-300);\n  --pf-c-button--m-primary--focus--BackgroundColor: var(--pf-global--BackgroundColor--light-300);\n  --pf-c-button--m-primary--active--BackgroundColor: var(--pf-global--BackgroundColor--light-300);\n  --pf-c-button--m-secondary--Color: var(--pf-global--Color--light-100);\n  --pf-c-button--m-secondary--hover--Color: var(--pf-global--Color--light-100);\n  --pf-c-button--m-secondary--focus--Color: var(--pf-global--Color--light-100);\n  --pf-c-button--m-secondary--active--Color: var(--pf-global--Color--light-100);\n  --pf-c-button--m-secondary--BorderColor: var(--pf-global--Color--light-100);\n  --pf-c-button--m-secondary--hover--BorderColor: var(--pf-global--Color--light-100);\n  --pf-c-button--m-secondary--focus--BorderColor: var(--pf-global--Color--light-100);\n  --pf-c-button--m-secondary--active--BorderColor: var(--pf-global--Color--light-100);\n}\n\n.pf-c-banner {\n  --pf-c-banner--PaddingTop: var(--pf-global--spacer--xs);\n  --pf-c-banner--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-banner--md--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-banner--PaddingBottom: var(--pf-global--spacer--xs);\n  --pf-c-banner--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-banner--md--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-banner--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-banner--Color: var(--pf-global--Color--100);\n  --pf-c-banner--BackgroundColor: var(--pf-global--BackgroundColor--dark-400);\n  --pf-c-banner--link--Color: var(--pf-c-banner--Color);\n  --pf-c-banner--link--TextDecoration: underline;\n  --pf-c-banner--link--hover--Color: var(--pf-c-banner--Color);\n  --pf-c-banner--link--hover--FontWeight: var(--pf-global--FontWeight--semi-bold);\n  --pf-c-banner--link--disabled--Color: var(--pf-c-banner--Color);\n  --pf-c-banner--link--disabled--TextDecoration: none;\n  --pf-c-banner--m-info--BackgroundColor: var(--pf-global--palette--blue-200);\n  --pf-c-banner--m-danger--BackgroundColor: var(--pf-global--danger-color--100);\n  --pf-c-banner--m-success--BackgroundColor: var(--pf-global--success-color--100);\n  --pf-c-banner--m-warning--BackgroundColor: var(--pf-global--warning-color--100);\n  --pf-c-banner--m-sticky--ZIndex: var(--pf-global--ZIndex--md);\n  --pf-c-banner--m-sticky--BoxShadow: var(--pf-global--BoxShadow--md-bottom);\n  color: var(--pf-global--Color--100);\n  overflow: hidden;\n  text-overflow: ellipsis;\n  white-space: nowrap;\n  padding: var(--pf-c-banner--PaddingTop) var(--pf-c-banner--PaddingRight) var(--pf-c-banner--PaddingBottom) var(--pf-c-banner--PaddingLeft);\n  flex-shrink: 0;\n  font-size: var(--pf-c-banner--FontSize);\n  color: var(--pf-c-banner--Color);\n  white-space: nowrap;\n  background-color: var(--pf-c-banner--BackgroundColor);\n}\n@media (min-width: 768px) {\n  .pf-c-banner {\n    --pf-c-banner--PaddingRight: var(--pf-c-banner--md--PaddingRight);\n    --pf-c-banner--PaddingLeft: var(--pf-c-banner--md--PaddingLeft);\n  }\n}\n.pf-c-banner.pf-m-info, .pf-c-banner.pf-m-blue {\n  color: var(--pf-global--Color--100);\n  --pf-c-banner--BackgroundColor: var(--pf-c-banner--m-info--BackgroundColor);\n}\n.pf-c-banner.pf-m-danger, .pf-c-banner.pf-m-red {\n  --pf-c-banner--BackgroundColor: var(--pf-c-banner--m-danger--BackgroundColor);\n}\n.pf-c-banner.pf-m-success, .pf-c-banner.pf-m-green {\n  --pf-c-banner--BackgroundColor: var(--pf-c-banner--m-success--BackgroundColor);\n}\n.pf-c-banner.pf-m-warning, .pf-c-banner.pf-m-gold {\n  color: var(--pf-global--Color--100);\n  --pf-c-banner--BackgroundColor: var(--pf-c-banner--m-warning--BackgroundColor);\n}\n.pf-c-banner.pf-m-sticky {\n  position: sticky;\n  top: 0;\n  z-index: var(--pf-c-banner--m-sticky--ZIndex);\n  box-shadow: var(--pf-c-banner--m-sticky--BoxShadow);\n}\n.pf-c-banner a {\n  color: var(--pf-c-banner--link--Color);\n  text-decoration: var(--pf-c-banner--link--TextDecoration);\n}\n.pf-c-banner a:hover:not(.pf-m-disabled) {\n  --pf-c-banner--link--Color: var(--pf-c-banner--link--hover--Color);\n  font-weight: var(--pf-c-banner--link--hover--FontWeight);\n}\n.pf-c-banner a.pf-m-disabled {\n  --pf-c-banner--link--Color: var(--pf-c-banner--link--disabled--Color);\n  --pf-c-banner--link--TextDecoration: var(--pf-c-banner--link--disabled--TextDecoration);\n  cursor: not-allowed;\n}\n.pf-c-banner .pf-c-button.pf-m-inline {\n  --pf-c-button--m-link--Color: var(--pf-c-banner--link--Color);\n  --pf-c-button--m-link--m-inline--hover--Color: var(--pf-c-banner--link--hover--Color);\n  --pf-c-button--disabled--Color: var(--pf-c-banner--link--disabled--Color);\n  text-decoration: var(--pf-c-banner--link--TextDecoration);\n}\n.pf-c-banner .pf-c-button.pf-m-inline:hover {\n  --pf-c-banner--link--Color: var(--pf-c-banner--link--hover--Color);\n  font-weight: var(--pf-c-banner--link--hover--FontWeight);\n}\n.pf-c-banner .pf-c-button.pf-m-inline:disabled, .pf-c-banner .pf-c-button.pf-m-inline.pf-m-disabled {\n  --pf-c-banner--link--TextDecoration: var(--pf-c-banner--link--disabled--TextDecoration);\n  cursor: not-allowed;\n}\n\n:where(.pf-theme-dark) .pf-c-banner {\n  --pf-global--Color--100: #e0e0e0;\n  --pf-global--Color--200: #aaabac;\n  --pf-global--BorderColor--100: #444548;\n  --pf-global--primary-color--100: #1fa7f8;\n  --pf-global--link--Color: #1fa7f8;\n  --pf-global--link--Color--hover: #73bcf7;\n  --pf-global--BackgroundColor--100: #1b1d21;\n}\n:where(.pf-theme-dark) .pf-c-banner .pf-c-card {\n  --pf-c-card--BackgroundColor: var(--pf-global--BackgroundColor--100);\n}\n:where(.pf-theme-dark) .pf-c-banner .pf-c-button {\n  --pf-c-button--m-primary--Color: var(--pf-global--Color--light-100);\n  --pf-c-button--m-primary--hover--Color: var(--pf-global--Color--light-100);\n  --pf-c-button--m-primary--focus--Color: var(--pf-global--Color--light-100);\n  --pf-c-button--m-primary--active--Color: var(--pf-global--Color--light-100);\n  --pf-c-button--m-primary--BackgroundColor: var(--pf-global--primary-color--300);\n  --pf-c-button--m-primary--hover--BackgroundColor: var(--pf-global--primary-color--200);\n  --pf-c-button--m-primary--focus--BackgroundColor: var(--pf-global--primary-color--200);\n  --pf-c-button--m-primary--active--BackgroundColor: var(--pf-global--primary-color--200);\n  --pf-c-button--m-secondary--Color: var(--pf-global--primary-color--100);\n  --pf-c-button--m-secondary--hover--Color: var(--pf-global--primary-color--100);\n  --pf-c-button--m-secondary--focus--Color: var(--pf-global--primary-color--100);\n  --pf-c-button--m-secondary--active--Color: var(--pf-global--primary-color--100);\n}\n\n:where(.pf-theme-dark) .pf-c-banner {\n  color: var(--pf-global--Color--100);\n}\n:where(.pf-theme-dark) .pf-c-banner.pf-m-info, :where(.pf-theme-dark) .pf-c-banner.pf-m-blue, :where(.pf-theme-dark) .pf-c-banner.pf-m-danger, :where(.pf-theme-dark) .pf-c-banner.pf-m-red, :where(.pf-theme-dark) .pf-c-banner.pf-m-success, :where(.pf-theme-dark) .pf-c-banner.pf-m-green, :where(.pf-theme-dark) .pf-c-banner.pf-m-warning, :where(.pf-theme-dark) .pf-c-banner.pf-m-gold {\n  color: var(--pf-global--palette--black-900);\n}";

// src/elements/banner/EnterpriseStatusBanner.ts
var EnterpriseStatusBanner = class extends WithLicenseSummary(AKElement) {
  constructor() {
    super(...arguments);
    this.interface = "";
  }
  static get styles() {
    return [banner_default];
  }
  renderStatusBanner() {
    switch (this.licenseSummary.status) {
      // user warning is both on admin interface and user interface
      case LicenseSummaryStatusEnum.LimitExceededUser:
        if (this.interface.toLowerCase() !== "user" && this.interface.toLowerCase() !== "admin") {
          return D;
        }
        break;
      case LicenseSummaryStatusEnum.ExpirySoon:
      case LicenseSummaryStatusEnum.Expired:
      case LicenseSummaryStatusEnum.LimitExceededAdmin:
        if (this.interface.toLowerCase() !== "admin") {
          return D;
        }
        break;
      case LicenseSummaryStatusEnum.Unlicensed:
      case LicenseSummaryStatusEnum.Valid:
        return D;
      case LicenseSummaryStatusEnum.ReadOnly:
      default:
        break;
    }
    let message = "";
    switch (this.licenseSummary.status) {
      case LicenseSummaryStatusEnum.LimitExceededAdmin:
      case LicenseSummaryStatusEnum.LimitExceededUser:
        message = msg(
          "Warning: The current user count has exceeded the configured licenses."
        );
        break;
      case LicenseSummaryStatusEnum.Expired:
        message = msg("Warning: One or more license(s) have expired.");
        break;
      case LicenseSummaryStatusEnum.ExpirySoon:
        message = msg(
          "Warning: One or more license(s) will expire within the next 2 weeks."
        );
        break;
      case LicenseSummaryStatusEnum.ReadOnly:
        message = msg(
          "Caution: This authentik instance has entered read-only mode due to expired/exceeded licenses."
        );
        break;
      default:
        break;
    }
    return ke`<div
            class="pf-c-banner pf-m-sticky ${this.licenseSummary?.status === LicenseSummaryStatusEnum.ReadOnly ? "pf-m-red" : "pf-m-gold"}"
        >
            ${message}
            <a href="${globalAK().api.base}if/admin/#/enterprise/licenses"
                >${msg("Click here for more info.")}</a
            >
        </div>`;
  }
  renderFlagBanner() {
    return ke`
            ${this.licenseSummary.licenseFlags.includes(LicenseFlagsEnum.Trial) ? ke`<div class="pf-c-banner pf-m-sticky pf-m-gold">
                      ${msg("This authentik instance uses a Trial license.")}
                  </div>` : D}
            ${this.licenseSummary.licenseFlags.includes(LicenseFlagsEnum.NonProduction) ? ke`<div class="pf-c-banner pf-m-sticky pf-m-gold">
                      ${msg("This authentik instance uses a Non-production license.")}
                  </div>` : D}
        `;
  }
  render() {
    return this.licenseSummary ? ke`${this.renderFlagBanner()}${this.renderStatusBanner()}` : D;
  }
};
__decorateClass([
  n()
], EnterpriseStatusBanner.prototype, "interface", 2);
EnterpriseStatusBanner = __decorateClass([
  t("ak-enterprise-status")
], EnterpriseStatusBanner);

// node_modules/@patternfly/patternfly/components/NotificationDrawer/notification-drawer.css
var notification_drawer_default = '.pf-c-notification-drawer {\n  --pf-c-notification-drawer--BackgroundColor: var(--pf-global--BackgroundColor--200);\n  --pf-c-notification-drawer__header--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__header--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__header--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__header--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__header--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-notification-drawer__header--BoxShadow: var(--pf-global--BoxShadow--sm-bottom);\n  --pf-c-notification-drawer__header--ZIndex: var(--pf-global--ZIndex--sm);\n  --pf-c-notification-drawer__header-title--FontSize: var(--pf-global--FontSize--xl);\n  --pf-c-notification-drawer__header-status--MarginLeft: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__body--ZIndex: var(--pf-global--ZIndex--xs);\n  --pf-c-notification-drawer__list-item--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__list-item--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__list-item--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__list-item--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__list-item--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-notification-drawer__list-item--BoxShadow: inset var(--pf-global--BoxShadow--sm-bottom);\n  --pf-c-notification-drawer__list-item--BorderBottomWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-notification-drawer__list-item--BorderBottomColor: transparent;\n  --pf-c-notification-drawer__list-item--OutlineOffset: -0.25rem;\n  --pf-c-notification-drawer__list-item--before--Width: var(--pf-global--BorderWidth--lg);\n  --pf-c-notification-drawer__list-item--before--Top: 0;\n  --pf-c-notification-drawer__list-item--before--Bottom: calc(var(--pf-c-notification-drawer__list-item--BorderBottomWidth) * -1);\n  --pf-c-notification-drawer__list-item--m-info__list-item-header-icon--Color: var(--pf-global--info-color--100);\n  --pf-c-notification-drawer__list-item--m-info__list-item--before--BackgroundColor: var(--pf-global--info-color--100);\n  --pf-c-notification-drawer__list-item--m-warning__list-item-header-icon--Color: var(--pf-global--warning-color--100);\n  --pf-c-notification-drawer__list-item--m-warning__list-item--before--BackgroundColor: var(--pf-global--warning-color--100);\n  --pf-c-notification-drawer__list-item--m-danger__list-item-header-icon--Color: var(--pf-global--danger-color--100);\n  --pf-c-notification-drawer__list-item--m-danger__list-item--before--BackgroundColor: var(--pf-global--danger-color--100);\n  --pf-c-notification-drawer__list-item--m-success__list-item-header-icon--Color: var(--pf-global--success-color--100);\n  --pf-c-notification-drawer__list-item--m-success__list-item--before--BackgroundColor: var(--pf-global--success-color--100);\n  --pf-c-notification-drawer__list-item--m-default__list-item-header-icon--Color: var(--pf-global--default-color--200);\n  --pf-c-notification-drawer__list-item--m-default__list-item--before--BackgroundColor: var(--pf-global--default-color--200);\n  --pf-c-notification-drawer__list-item--m-read--BackgroundColor: var(--pf-global--BackgroundColor--200);\n  --pf-c-notification-drawer__list-item--m-read--BorderBottomColor: var(--pf-global--BorderColor--100);\n  --pf-c-notification-drawer__list-item--m-read--before--Top: calc(var(--pf-c-notification-drawer__list-item--BorderBottomWidth) * -1);\n  --pf-c-notification-drawer__list-item--m-read--before--Bottom: 0;\n  --pf-c-notification-drawer__list-item--m-read--before--BackgroundColor: transparent;\n  --pf-c-notification-drawer__list-item--list-item--m-read--before--Top: 0;\n  --pf-c-notification-drawer__list-item--list-item--m-read--BoxShadow: inset var(--pf-global--BoxShadow--sm-bottom);\n  --pf-c-notification-drawer__list-item--m-hoverable--hover--ZIndex: var(--pf-global--ZIndex--xs);\n  --pf-c-notification-drawer__list-item--m-hoverable--hover--BoxShadow: var(--pf-global--BoxShadow--md-top), var(--pf-global--BoxShadow--md-bottom);\n  --pf-c-notification-drawer__list-item-header--MarginBottom: var(--pf-global--spacer--xs);\n  --pf-c-notification-drawer__list-item-header-icon--Color: inherit;\n  --pf-c-notification-drawer__list-item-header-icon--MarginRight: var(--pf-global--spacer--sm);\n  --pf-c-notification-drawer__list-item-header-title--FontWeight: var(--pf-global--FontWeight--bold);\n  --pf-c-notification-drawer__list-item-header-title--max-lines: 1;\n  --pf-c-notification-drawer__list-item--m-read__list-item-header-title--FontWeight: var(--pf-global--FontWeight--normal);\n  --pf-c-notification-drawer__list-item-description--MarginBottom: var(--pf-global--spacer--sm);\n  --pf-c-notification-drawer__list-item-timestamp--Color: var(--pf-global--Color--200);\n  --pf-c-notification-drawer__list-item-timestamp--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-notification-drawer__group--m-expanded--group--BorderTopWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-notification-drawer__group--m-expanded--group--BorderTopColor: var(--pf-global--BorderColor--100);\n  --pf-c-notification-drawer__group--m-expanded--MinHeight: 0;\n  --pf-c-notification-drawer__group-toggle--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__group-toggle--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__group-toggle--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__group-toggle--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__group-toggle--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-notification-drawer__group-toggle--BorderColor: var(--pf-global--BorderColor--100);\n  --pf-c-notification-drawer__group-toggle--BorderBottomWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-notification-drawer__group-toggle--OutlineOffset: -0.25rem;\n  --pf-c-notification-drawer__group-toggle-title--MarginRight: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__group-toggle-title--max-lines: 1;\n  --pf-c-notification-drawer__group-toggle-count--MarginRight: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__group-toggle-icon--MarginRight: var(--pf-global--spacer--md);\n  --pf-c-notification-drawer__group-toggle-icon--Color: var(--pf-global--Color--200);\n  --pf-c-notification-drawer__group-toggle-icon--Transition: .2s ease-in 0s;\n  --pf-c-notification-drawer__group--m-expanded__group-toggle-icon--Rotate: 90deg;\n  display: flex;\n  flex-direction: column;\n  height: 100%;\n  background-color: var(--pf-c-notification-drawer--BackgroundColor);\n}\n\n.pf-c-notification-drawer__header {\n  position: relative;\n  z-index: var(--pf-c-notification-drawer__header--ZIndex);\n  display: flex;\n  flex-shrink: 0;\n  align-items: baseline;\n  padding: var(--pf-c-notification-drawer__header--PaddingTop) var(--pf-c-notification-drawer__header--PaddingRight) var(--pf-c-notification-drawer__header--PaddingBottom) var(--pf-c-notification-drawer__header--PaddingLeft);\n  background-color: var(--pf-c-notification-drawer__header--BackgroundColor);\n  box-shadow: var(--pf-c-notification-drawer__header--BoxShadow);\n}\n\n.pf-c-notification-drawer__header-title {\n  font-size: var(--pf-c-notification-drawer__header-title--FontSize);\n}\n\n.pf-c-notification-drawer__header-status {\n  margin-left: var(--pf-c-notification-drawer__header-status--MarginLeft);\n}\n\n.pf-c-notification-drawer__header-action {\n  display: flex;\n  align-items: center;\n  margin-left: auto;\n}\n\n.pf-c-notification-drawer__body {\n  overflow-y: auto;\n  box-shadow: var(--pf-c-notification-drawer__body--ZIndex);\n}\n\n.pf-c-notification-drawer__list-item {\n  position: relative;\n  display: grid;\n  grid-template-columns: 1fr auto;\n  padding: var(--pf-c-notification-drawer__list-item--PaddingTop) var(--pf-c-notification-drawer__list-item--PaddingRight) var(--pf-c-notification-drawer__list-item--PaddingBottom) var(--pf-c-notification-drawer__list-item--PaddingLeft);\n  background-color: var(--pf-c-notification-drawer__list-item--BackgroundColor);\n  border-bottom: var(--pf-c-notification-drawer__list-item--BorderBottomWidth) solid var(--pf-c-notification-drawer__list-item--BorderBottomColor);\n  outline-offset: var(--pf-c-notification-drawer__list-item--OutlineOffset);\n  box-shadow: var(--pf-c-notification-drawer__list-item--BoxShadow);\n}\n.pf-c-notification-drawer__list-item.pf-m-read, .pf-c-notification-drawer__list-item:first-child {\n  --pf-c-notification-drawer__list-item--BoxShadow: none;\n}\n.pf-c-notification-drawer__list-item:not(.pf-m-read) + .pf-c-notification-drawer__list-item.pf-m-read {\n  --pf-c-notification-drawer__list-item--BoxShadow: var(--pf-c-notification-drawer__list-item--list-item--m-read--BoxShadow);\n  --pf-c-notification-drawer__list-item--before--Top: var(--pf-c-notification-drawer__list-item--list-item--m-read--before--Top);\n}\n.pf-c-notification-drawer__list-item::before {\n  position: absolute;\n  top: var(--pf-c-notification-drawer__list-item--before--Top);\n  bottom: var(--pf-c-notification-drawer__list-item--before--Bottom);\n  width: var(--pf-c-notification-drawer__list-item--before--Width);\n  content: "";\n  background-color: var(--pf-c-notification-drawer__list-item--before--BackgroundColor);\n}\n.pf-c-notification-drawer__list-item.pf-m-info {\n  --pf-c-notification-drawer__list-item--before--BackgroundColor: var(--pf-c-notification-drawer__list-item--m-info__list-item--before--BackgroundColor);\n  --pf-c-notification-drawer__list-item-header-icon--Color: var(--pf-c-notification-drawer__list-item--m-info__list-item-header-icon--Color);\n}\n.pf-c-notification-drawer__list-item.pf-m-warning {\n  --pf-c-notification-drawer__list-item--before--BackgroundColor: var(--pf-c-notification-drawer__list-item--m-warning__list-item--before--BackgroundColor);\n  --pf-c-notification-drawer__list-item-header-icon--Color: var(--pf-c-notification-drawer__list-item--m-warning__list-item-header-icon--Color);\n}\n.pf-c-notification-drawer__list-item.pf-m-danger {\n  --pf-c-notification-drawer__list-item--before--BackgroundColor: var(--pf-c-notification-drawer__list-item--m-danger__list-item--before--BackgroundColor);\n  --pf-c-notification-drawer__list-item-header-icon--Color: var(--pf-c-notification-drawer__list-item--m-danger__list-item-header-icon--Color);\n}\n.pf-c-notification-drawer__list-item.pf-m-success {\n  --pf-c-notification-drawer__list-item--before--BackgroundColor: var(--pf-c-notification-drawer__list-item--m-success__list-item--before--BackgroundColor);\n  --pf-c-notification-drawer__list-item-header-icon--Color: var(--pf-c-notification-drawer__list-item--m-success__list-item-header-icon--Color);\n}\n.pf-c-notification-drawer__list-item.pf-m-default {\n  --pf-c-notification-drawer__list-item--before--BackgroundColor: var(--pf-c-notification-drawer__list-item--m-default__list-item--before--BackgroundColor);\n  --pf-c-notification-drawer__list-item-header-icon--Color: var(--pf-c-notification-drawer__list-item--m-default__list-item-header-icon--Color);\n}\n.pf-c-notification-drawer__list-item.pf-m-read {\n  --pf-c-notification-drawer__list-item--BorderBottomColor: var(--pf-c-notification-drawer__list-item--m-read--BorderBottomColor);\n  --pf-c-notification-drawer__list-item--BackgroundColor: var(--pf-c-notification-drawer__list-item--m-read--BackgroundColor);\n  --pf-c-notification-drawer__list-item--before--Top: var(--pf-c-notification-drawer__list-item--m-read--before--Top);\n  --pf-c-notification-drawer__list-item--before--Bottom: var(--pf-c-notification-drawer__list-item--m-read--before--Bottom);\n  --pf-c-notification-drawer__list-item--before--BackgroundColor: var(--pf-c-notification-drawer__list-item--m-read--before--BackgroundColor);\n  --pf-c-notification-drawer__list-item-header-title--FontWeight: var(--pf-c-notification-drawer__list-item--m-read__list-item-header-title--FontWeight);\n  position: relative;\n}\n.pf-c-notification-drawer__list-item.pf-m-hoverable {\n  cursor: pointer;\n}\n.pf-c-notification-drawer__list-item.pf-m-hoverable:hover {\n  z-index: var(--pf-c-notification-drawer__list-item--m-hoverable--hover--ZIndex);\n  box-shadow: var(--pf-c-notification-drawer__list-item--m-hoverable--hover--BoxShadow);\n}\n\n.pf-c-notification-drawer__list-item-header {\n  display: flex;\n  align-items: baseline;\n  grid-column: 1/2;\n  grid-row: 1/2;\n  margin-bottom: var(--pf-c-notification-drawer__list-item-header--MarginBottom);\n}\n\n.pf-c-notification-drawer__list-item-header-icon {\n  margin-right: var(--pf-c-notification-drawer__list-item-header-icon--MarginRight);\n  color: var(--pf-c-notification-drawer__list-item-header-icon--Color);\n}\n\n.pf-c-notification-drawer__list-item-header-title {\n  font-weight: var(--pf-c-notification-drawer__list-item-header-title--FontWeight);\n  word-break: break-word;\n}\n.pf-c-notification-drawer__list-item-header-title.pf-m-truncate {\n  display: -webkit-box;\n  -webkit-box-orient: vertical;\n  -webkit-line-clamp: var(--pf-c-notification-drawer__list-item-header-title--max-lines);\n  overflow: hidden;\n}\n\n.pf-c-notification-drawer__list-item-action {\n  grid-column: 2/3;\n  grid-row: 1/3;\n}\n\n.pf-c-notification-drawer__list-item-description {\n  grid-row: 2/3;\n  grid-column: 1/2;\n  margin-bottom: var(--pf-c-notification-drawer__list-item-description--MarginBottom);\n  word-break: break-word;\n}\n\n.pf-c-notification-drawer__list-item-timestamp {\n  grid-row: 3/4;\n  grid-column: 1/2;\n  font-size: var(--pf-c-notification-drawer__list-item-timestamp--FontSize);\n  color: var(--pf-c-notification-drawer__list-item-timestamp--Color);\n}\n\n.pf-c-notification-drawer__group-list {\n  display: flex;\n  flex-direction: column;\n}\n\n.pf-c-notification-drawer__group.pf-m-expanded {\n  min-height: var(--pf-c-notification-drawer__group--m-expanded--MinHeight);\n}\n.pf-c-notification-drawer__group.pf-m-expanded + .pf-c-notification-drawer__group {\n  border-top: var(--pf-c-notification-drawer__group--m-expanded--group--BorderTopWidth) solid var(--pf-c-notification-drawer__group--m-expanded--group--BorderTopColor);\n}\n.pf-c-notification-drawer__group .pf-c-notification-drawer__list-item:last-child {\n  --pf-c-notification-drawer__list-item--BorderBottomWidth: 0;\n  --pf-c-notification-drawer__list-item--before--Bottom: 0;\n}\n\n.pf-c-notification-drawer__group-toggle {\n  display: flex;\n  align-items: baseline;\n  width: 100%;\n  padding: var(--pf-c-notification-drawer__group-toggle--PaddingTop) var(--pf-c-notification-drawer__group-toggle--PaddingRight) var(--pf-c-notification-drawer__group-toggle--PaddingBottom) var(--pf-c-notification-drawer__group-toggle--PaddingLeft);\n  background-color: var(--pf-c-notification-drawer__group-toggle--BackgroundColor);\n  border: solid var(--pf-c-notification-drawer__group-toggle--BorderColor);\n  border-width: 0 0 var(--pf-c-notification-drawer__group-toggle--BorderBottomWidth) 0;\n  outline-offset: var(--pf-c-notification-drawer__group-toggle--OutlineOffset);\n}\n\n.pf-c-notification-drawer__group-toggle-title {\n  display: -webkit-box;\n  -webkit-box-orient: vertical;\n  -webkit-line-clamp: var(--pf-c-notification-drawer__group-toggle-title--max-lines);\n  overflow: hidden;\n  flex: 1;\n  margin-right: var(--pf-c-notification-drawer__group-toggle-title--MarginRight);\n  text-align: left;\n  word-break: break-word;\n}\n\n.pf-c-notification-drawer__group-toggle-count {\n  margin-right: var(--pf-c-notification-drawer__group-toggle-count--MarginRight);\n  margin-left: auto;\n}\n\n.pf-c-notification-drawer__group-toggle-icon {\n  margin-right: var(--pf-c-notification-drawer__group-toggle-icon--MarginRight);\n  color: var(--pf-c-notification-drawer__group-toggle-icon--Color);\n  transition: var(--pf-c-notification-drawer__group-toggle-icon--Transition);\n}\n.pf-c-notification-drawer__group.pf-m-expanded .pf-c-notification-drawer__group-toggle-icon {\n  transform: rotate(var(--pf-c-notification-drawer__group--m-expanded__group-toggle-icon--Rotate));\n}\n\n:where(.pf-theme-dark) .pf-c-notification-drawer {\n  --pf-c-notification-drawer--BackgroundColor: var(--pf-global--BackgroundColor--300);\n  --pf-c-notification-drawer__header--BackgroundColor: var(--pf-global--BackgroundColor--300);\n  --pf-c-notification-drawer__list-item--BackgroundColor: var(--pf-global--BackgroundColor--300);\n  --pf-c-notification-drawer__list-item--BoxShadow: none;\n  --pf-c-notification-drawer__list-item--BorderBottomColor: var(--pf-global--BorderColor--100);\n  --pf-c-notification-drawer__list-item--m-read--BackgroundColor: var(--pf-global--BackgroundColor--100);\n  --pf-c-notification-drawer__list-item--list-item--m-read--BoxShadow: none;\n  --pf-c-notification-drawer__group-toggle--BackgroundColor: var(--pf-global--BackgroundColor--300);\n}';

// src/elements/notifications/APIDrawer.ts
var APIDrawer = class extends AKElement {
  constructor() {
    super();
    this.requests = [];
    window.addEventListener(EVENT_REQUEST_POST, (e3) => {
      this.requests.push(e3.detail);
      this.requests.sort((a2, b2) => a2.time - b2.time).reverse();
      if (this.requests.length > 50) {
        this.requests.shift();
      }
      this.requestUpdate();
    });
  }
  static get styles() {
    return [
      patternfly_base_default,
      notification_drawer_default,
      button_default,
      content_default,
      dropdown_default,
      i`
                :host {
                    --header-height: 114px;
                }
                .pf-c-notification-drawer__header {
                    height: var(--header-height);
                    align-items: center;
                }
                .pf-c-notification-drawer__header-action,
                .pf-c-notification-drawer__header-action-close,
                .pf-c-notification-drawer__header-action-close > .pf-c-button.pf-m-plain {
                    height: 100%;
                }
                .pf-c-notification-drawer__list-item-description {
                    white-space: pre-wrap;
                    font-family: monospace;
                }
                .pf-c-notification-drawer__body {
                    overflow-x: hidden;
                }
                .pf-c-notification-drawer__list {
                    max-height: calc(100vh - var(--header-height));
                }
            `
    ];
  }
  renderItem(item) {
    return ke`<li class="pf-c-notification-drawer__list-item pf-m-read">
            <div class="pf-c-notification-drawer__list-item-header">
                <h2 class="pf-c-notification-drawer__list-item-header-title">
                    ${item.method}: ${item.status}
                </h2>
            </div>
            <a
                class="pf-c-notification-drawer__list-item-description"
                target="_blank"
                href=${item.path}
                >${item.path}</a
            >
            <div class="pf-c-notification-drawer__list-item-timestamp">
                ${getRelativeTime(new Date(item.time))}
            </div>
        </li>`;
  }
  render() {
    return ke`<div class="pf-c-drawer__body pf-m-no-padding">
            <div class="pf-c-notification-drawer">
                <div class="pf-c-notification-drawer__header">
                    <div class="text">
                        <h1 class="pf-c-notification-drawer__header-title">
                            ${msg("API Requests")}
                        </h1>
                        <a href="${globalAK().api.base}api/v3/" target="_blank"
                            >${msg("Open API Browser")}</a
                        >
                    </div>
                    <div class="pf-c-notification-drawer__header-action">
                        <div class="pf-c-notification-drawer__header-action-close">
                            <button
                                @click=${() => {
      this.dispatchEvent(
        new CustomEvent(EVENT_API_DRAWER_TOGGLE, {
          bubbles: true,
          composed: true
        })
      );
    }}
                                class="pf-c-button pf-m-plain"
                                type="button"
                                aria-label=${msg("Close")}
                            >
                                <i class="fas fa-times" aria-hidden="true"></i>
                            </button>
                        </div>
                    </div>
                </div>
                <div class="pf-c-notification-drawer__body">
                    <ul class="pf-c-notification-drawer__list">
                        ${this.requests.map((n3) => this.renderItem(n3))}
                    </ul>
                </div>
            </div>
        </div>`;
  }
};
__decorateClass([
  n({ attribute: false })
], APIDrawer.prototype, "requests", 2);
APIDrawer = __decorateClass([
  t("ak-api-drawer")
], APIDrawer);

// src/elements/notifications/NotificationDrawer.ts
var NotificationDrawer = class extends AKElement {
  constructor() {
    super(...arguments);
    this.unread = 0;
  }
  static get styles() {
    return [patternfly_base_default, button_default, notification_drawer_default, content_default, dropdown_default].concat(i`
            .pf-c-drawer__body {
                height: 100%;
            }
            .pf-c-notification-drawer__body {
                flex-grow: 1;
                overflow-x: hidden;
            }
            .pf-c-notification-drawer__header {
                height: 114px;
                align-items: center;
            }
            .pf-c-notification-drawer__header-action,
            .pf-c-notification-drawer__header-action-close,
            .pf-c-notification-drawer__header-action-close > .pf-c-button.pf-m-plain {
                height: 100%;
            }
            .pf-c-notification-drawer__list-item-description {
                white-space: pre-wrap;
            }
        `);
  }
  firstUpdated() {
    me().then((user) => {
      new EventsApi(DEFAULT_CONFIG).eventsNotificationsList({
        seen: false,
        ordering: "-created",
        user: user.user.pk
      }).then((r3) => {
        this.notifications = r3;
        this.unread = r3.results.length;
      });
    });
  }
  renderItem(item) {
    let level = "";
    switch (item.severity) {
      case "notice":
        level = "pf-m-info";
        break;
      case "warning":
        level = "pf-m-warning";
        break;
      case "alert":
        level = "pf-m-danger";
        break;
      default:
        break;
    }
    return ke`<li class="pf-c-notification-drawer__list-item">
            <div class="pf-c-notification-drawer__list-item-header">
                <span class="pf-c-notification-drawer__list-item-header-icon ${level}">
                    <i class="fas fa-info-circle" aria-hidden="true"></i>
                </span>
                <h2 class="pf-c-notification-drawer__list-item-header-title">
                    ${actionToLabel(item.event?.action)}
                </h2>
            </div>
            <div class="pf-c-notification-drawer__list-item-action">
                ${item.event && ke`
                    <a
                        class="pf-c-dropdown__toggle pf-m-plain"
                        href="${globalAK().api.base}if/admin/#/events/log/${item.event?.pk}"
                    >
                        <pf-tooltip position="top" content=${msg("Show details")}>
                            <i class="fas fa-share-square"></i>
                        </pf-tooltip>
                    </a>
                `}
                <button
                    class="pf-c-dropdown__toggle pf-m-plain"
                    type="button"
                    @click=${() => {
      new EventsApi(DEFAULT_CONFIG).eventsNotificationsPartialUpdate({
        uuid: item.pk || "",
        patchedNotificationRequest: {
          seen: true
        }
      }).then(() => {
        this.firstUpdated();
        this.dispatchEvent(
          new CustomEvent(EVENT_REFRESH, {
            bubbles: true,
            composed: true
          })
        );
      });
    }}
                >
                    <i class="fas fa-times"></i>
                </button>
            </div>
            <p class="pf-c-notification-drawer__list-item-description">${item.body}</p>
            <small class="pf-c-notification-drawer__list-item-timestamp"
                ><pf-tooltip position="top" .content=${item.created?.toLocaleString()}>
                    ${getRelativeTime(item.created)}
                </pf-tooltip></small
            >
        </li>`;
  }
  clearNotifications() {
    new EventsApi(DEFAULT_CONFIG).eventsNotificationsMarkAllSeenCreate().then(() => {
      showMessage({
        level: "success" /* success */,
        message: msg("Successfully cleared notifications")
      });
      this.firstUpdated();
      this.dispatchEvent(
        new CustomEvent(EVENT_REFRESH, {
          bubbles: true,
          composed: true
        })
      );
      this.dispatchEvent(
        new CustomEvent(EVENT_NOTIFICATION_DRAWER_TOGGLE, {
          bubbles: true,
          composed: true
        })
      );
    });
  }
  renderEmpty() {
    return ke`<ak-empty-state header=${msg("No notifications found.")}>
            <div slot="body">${msg("You don't have any notifications currently.")}</div>
        </ak-empty-state>`;
  }
  render() {
    if (!this.notifications) {
      return ke``;
    }
    return ke`<div class="pf-c-drawer__body pf-m-no-padding">
            <div class="pf-c-notification-drawer">
                <div class="pf-c-notification-drawer__header">
                    <div class="text">
                        <h1 class="pf-c-notification-drawer__header-title">
                            ${msg("Notifications")}
                        </h1>
                        <span> ${msg(str`${this.unread} unread`)} </span>
                    </div>
                    <div class="pf-c-notification-drawer__header-action">
                        <div>
                            <button
                                @click=${() => {
      this.clearNotifications();
    }}
                                class="pf-c-button pf-m-plain"
                                type="button"
                                aria-label=${msg("Clear all")}
                            >
                                <i class="fa fa-trash" aria-hidden="true"></i>
                            </button>
                        </div>
                        <div class="pf-c-notification-drawer__header-action-close">
                            <button
                                @click=${() => {
      this.dispatchEvent(
        new CustomEvent(EVENT_NOTIFICATION_DRAWER_TOGGLE, {
          bubbles: true,
          composed: true
        })
      );
    }}
                                class="pf-c-button pf-m-plain"
                                type="button"
                                aria-label=${msg("Close")}
                            >
                                <i class="fas fa-times" aria-hidden="true"></i>
                            </button>
                        </div>
                    </div>
                </div>
                <div class="pf-c-notification-drawer__body">
                    <ul class="pf-c-notification-drawer__list">
                        ${this.notifications.pagination.count < 1 ? this.renderEmpty() : this.notifications.results.map((n3) => this.renderItem(n3))}
                    </ul>
                </div>
            </div>
        </div>`;
  }
};
__decorateClass([
  n({ attribute: false })
], NotificationDrawer.prototype, "notifications", 2);
__decorateClass([
  n({ type: Number })
], NotificationDrawer.prototype, "unread", 2);
NotificationDrawer = __decorateClass([
  t("ak-notification-drawer")
], NotificationDrawer);

// src/elements/router/Route.ts
var Route = class {
  constructor(url, callback) {
    this.url = url;
    this.callback = callback;
  }
  redirect(to2, raw = false) {
    this.callback = async () => {
      console.debug(`authentik/router: redirecting ${to2}`);
      if (!raw) {
        window.location.hash = `#${to2}`;
      } else {
        window.location.hash = to2;
      }
      return ke``;
    };
    return this;
  }
  then(render) {
    this.callback = async (args) => {
      return render(args);
    };
    return this;
  }
  thenAsync(render) {
    this.callback = render;
    return this;
  }
  render(args) {
    if (this.callback) {
      return ke`${be(
        this.callback(args),
        ke`<ak-empty-state ?loading=${true}></ak-empty-state>`
      )}`;
    }
    if (this.element) {
      return this.element;
    }
    throw new Error("Route does not have callback or element");
  }
  toString() {
    return `<Route url=${this.url} callback=${this.callback ? "true" : "false"}>`;
  }
};

// src/elements/router/Router404.ts
var Router404 = class extends AKElement {
  constructor() {
    super(...arguments);
    this.url = "";
  }
  static get styles() {
    return [patternfly_base_default, empty_state_default, title_default];
  }
  render() {
    return ke`<div class="pf-c-empty-state pf-m-full-height">
            <div class="pf-c-empty-state__content">
                <i class="fas fa-question-circle pf-c-empty-state__icon" aria-hidden="true"></i>
                <h1 class="pf-c-title pf-m-lg">${msg("Not found")}</h1>
                <div class="pf-c-empty-state__body">
                    ${msg(str`The URL "${this.url}" was not found.`)}
                </div>
                <a href="#/" class="pf-c-button pf-m-primary" type="button"
                    >${msg("Return home")}</a
                >
            </div>
        </div>`;
  }
};
__decorateClass([
  n()
], Router404.prototype, "url", 2);
Router404 = __decorateClass([
  t("ak-router-404")
], Router404);

// src/elements/router/RouterOutlet.ts
window.addEventListener("load", () => {
  if (!window.HashChangeEvent)
    (function() {
      let lastURL = document.URL;
      window.addEventListener("hashchange", function(event) {
        Object.defineProperty(event, "oldURL", {
          enumerable: true,
          configurable: true,
          value: lastURL
        });
        Object.defineProperty(event, "newURL", {
          enumerable: true,
          configurable: true,
          value: document.URL
        });
        lastURL = document.URL;
      });
    })();
});
function paramURL(url, params) {
  let finalUrl = "#";
  finalUrl += url;
  if (params) {
    finalUrl += ";";
    finalUrl += encodeURIComponent(JSON.stringify(params));
  }
  return finalUrl;
}
var RouterOutlet = class extends AKElement {
  constructor() {
    super();
    this.routes = [];
    window.addEventListener("hashchange", (ev) => this.navigate(ev));
  }
  static get styles() {
    return [
      i`
                :host {
                    background-color: transparent !important;
                }
                *:first-child {
                    flex-direction: column;
                }
            `
    ];
  }
  firstUpdated() {
    this.navigate();
  }
  navigate(ev) {
    let activeUrl = window.location.hash.slice(1, Infinity).split(ROUTE_SEPARATOR)[0];
    if (ev) {
      const oldPath = new URL(ev.oldURL).hash.slice(1, Infinity).split(ROUTE_SEPARATOR)[0];
      if (oldPath === activeUrl) return;
    }
    if (activeUrl === "") {
      activeUrl = this.defaultUrl || "/";
      window.location.hash = `#${activeUrl}`;
      console.debug(`authentik/router: defaulted URL to ${window.location.hash}`);
      return;
    }
    let matchedRoute = null;
    this.routes.some((route) => {
      const match = route.url.exec(activeUrl);
      if (match !== null) {
        matchedRoute = new RouteMatch(route);
        matchedRoute.arguments = match.groups || {};
        matchedRoute.fullUrl = activeUrl;
        console.debug("authentik/router: found match ", matchedRoute);
        return true;
      }
      return false;
    });
    if (!matchedRoute) {
      console.debug(`authentik/router: route "${activeUrl}" not defined`);
      const route = new Route(RegExp(""), async () => {
        return ke`<div class="pf-c-page__main">
                    <ak-router-404 url=${activeUrl}></ak-router-404>
                </div>`;
      });
      matchedRoute = new RouteMatch(route);
      matchedRoute.arguments = route.url.exec(activeUrl)?.groups || {};
      matchedRoute.fullUrl = activeUrl;
    }
    this.current = matchedRoute;
  }
  render() {
    return this.current?.render();
  }
};
__decorateClass([
  n({ attribute: false })
], RouterOutlet.prototype, "current", 2);
__decorateClass([
  n()
], RouterOutlet.prototype, "defaultUrl", 2);
__decorateClass([
  n({ attribute: false })
], RouterOutlet.prototype, "routes", 2);
RouterOutlet = __decorateClass([
  t("ak-router-outlet")
], RouterOutlet);

// src/elements/utils/images.ts
function themeImage(rawPath) {
  let enabledTheme = rootInterface()?.activeTheme;
  if (!enabledTheme || enabledTheme === UiThemeEnum.Automatic) {
    enabledTheme = window.matchMedia(QUERY_MEDIA_COLOR_LIGHT).matches ? UiThemeEnum.Light : UiThemeEnum.Dark;
  }
  return rawPath.replaceAll("%(theme)s", enabledTheme);
}

// src/elements/sidebar/SidebarBrand.ts
var MIN_WIDTH = 1200;
var DefaultBrand = {
  brandingLogo: "/static/dist/assets/icons/icon_left_brand.svg",
  brandingFavicon: "/static/dist/assets/icons/icon.png",
  brandingTitle: "authentik",
  uiFooterLinks: [],
  uiTheme: UiThemeEnum.Automatic,
  matchedDomain: "",
  defaultLocale: ""
};
var SidebarBrand = class extends WithBrandConfig(AKElement) {
  static get styles() {
    return [
      patternfly_base_default,
      patternfly_base_default,
      page_default,
      button_default,
      i`
                :host {
                    display: flex;
                    flex-direction: row;
                    align-items: center;
                    height: 114px;
                    min-height: 114px;
                    border-bottom: var(--pf-global--BorderWidth--sm);
                    border-bottom-style: solid;
                    border-bottom-color: var(--pf-global--BorderColor--100);
                }
                .pf-c-brand img {
                    padding: 0 0.5rem;
                    height: 42px;
                }
                button.pf-c-button.sidebar-trigger {
                    background-color: transparent;
                    border-radius: 0px;
                    height: 100%;
                    color: var(--ak-dark-foreground);
                }
            `
    ];
  }
  constructor() {
    super();
    window.addEventListener("resize", () => {
      this.requestUpdate();
    });
  }
  render() {
    return ke` ${window.innerWidth <= MIN_WIDTH ? ke`
                      <button
                          class="sidebar-trigger pf-c-button"
                          @click=${() => {
      this.dispatchEvent(
        new CustomEvent(EVENT_SIDEBAR_TOGGLE, {
          bubbles: true,
          composed: true
        })
      );
    }}
                      >
                          <i class="fas fa-bars"></i>
                      </button>
                  ` : ke``}
            <a href="#/" class="pf-c-page__header-brand-link">
                <div class="pf-c-brand ak-brand">
                    <img
                        src=${themeImage(this.brand?.brandingLogo ?? DefaultBrand.brandingLogo)}
                        alt="${msg("authentik Logo")}"
                        loading="lazy"
                    />
                </div>
            </a>`;
  }
};
SidebarBrand = __decorateClass([
  t("ak-sidebar-brand")
], SidebarBrand);

// src/elements/Interface/versionProvider.ts
function WithVersion(superclass, subscribe = true) {
  class WithBrandProvider extends superclass {
  }
  __decorateClass([
    c({ context: authentikVersionContext, subscribe })
  ], WithBrandProvider.prototype, "version", 2);
  return WithBrandProvider;
}

// node_modules/@patternfly/patternfly/components/Nav/nav.css
var nav_default = '.pf-c-nav {\n  --pf-c-nav--Transition: var(--pf-global--Transition);\n  --pf-c-nav--m-light__item--before--BorderColor: var(--pf-global--BorderColor--300);\n  --pf-c-nav--m-light__item--m-current--not--m-expanded__link--BackgroundColor: var(--pf-global--BackgroundColor--light-300);\n  --pf-c-nav--m-light__link--Color: var(--pf-global--Color--dark-100);\n  --pf-c-nav--m-light__link--hover--Color: var(--pf-global--Color--dark-100);\n  --pf-c-nav--m-light__link--focus--Color: var(--pf-global--Color--dark-100);\n  --pf-c-nav--m-light__link--active--Color: var(--pf-global--Color--dark-100);\n  --pf-c-nav--m-light__link--m-current--Color: var(--pf-global--Color--dark-100);\n  --pf-c-nav--m-light__link--hover--BackgroundColor: var(--pf-global--BackgroundColor--light-300);\n  --pf-c-nav--m-light__link--focus--BackgroundColor: var(--pf-global--BackgroundColor--light-300);\n  --pf-c-nav--m-light__link--active--BackgroundColor: var(--pf-global--BackgroundColor--light-300);\n  --pf-c-nav--m-light__link--m-current--BackgroundColor: var(--pf-global--BackgroundColor--light-300);\n  --pf-c-nav--m-light__link--before--BorderColor: var(--pf-global--BorderColor--300);\n  --pf-c-nav--m-light__link--after--BorderColor: var(--pf-global--active-color--100);\n  --pf-c-nav--m-light__link--m-current--after--BorderColor: var(--pf-global--active-color--100);\n  --pf-c-nav--m-light__section-title--Color: var(--pf-global--Color--dark-200);\n  --pf-c-nav--m-light__section-title--BorderBottomColor: var(--pf-global--BorderColor--300);\n  --pf-c-nav--m-light--c-divider--BackgroundColor: var(--pf-global--BorderColor--300);\n  --pf-c-nav--m-light__subnav__link--hover--after--BorderColor: var(--pf-global--BorderColor--dark-100);\n  --pf-c-nav--m-light__subnav__link--focus--after--BorderColor: var(--pf-global--BorderColor--dark-100);\n  --pf-c-nav--m-light__subnav__link--active--after--BorderColor: var(--pf-global--BorderColor--dark-100);\n  --pf-c-nav--m-light__subnav__link--m-current--after--BorderColor: var(--pf-global--active-color--100);\n  --pf-c-nav__item--MarginTop: 0;\n  --pf-c-nav__item--m-current--not--m-expanded__link--BackgroundColor: var(--pf-global--BackgroundColor--dark-400);\n  --pf-c-nav__link--m-current--not--m-expanded__link--after--BorderWidth: var(--pf-global--BorderWidth--xl);\n  --pf-c-nav__item__item__link--PaddingRight: var(--pf-global--spacer--xl);\n  --pf-c-nav__item__item__toggle--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-nav__item__toggle-icon--Rotate: 0;\n  --pf-c-nav__item--m-expanded__toggle-icon--Rotate: 90deg;\n  --pf-c-nav__item--before--BorderColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__item--before--BorderWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav__link--FontSize: var(--pf-global--FontSize--md);\n  --pf-c-nav__link--FontWeight: var(--pf-global--FontWeight--normal);\n  --pf-c-nav__link--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-nav__link--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-nav__link--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-nav__link--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-nav__link--xl--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-nav__link--xl--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-nav__link--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav__link--hover--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav__link--focus--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav__link--active--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav__link--m-current--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav__link--BackgroundColor: transparent;\n  --pf-c-nav__link--hover--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__link--focus--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__link--active--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__link--m-current--BackgroundColor: var(--pf-global--BackgroundColor--dark-400);\n  --pf-c-nav__link--OutlineOffset: calc(var(--pf-global--spacer--xs) * -1);\n  --pf-c-nav__link--before--BorderColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__link--before--BorderBottomWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav__link--hover--before--BorderBottomWidth: 0;\n  --pf-c-nav__link--focus--before--BorderBottomWidth: 0;\n  --pf-c-nav__link--active--before--BorderBottomWidth: 0;\n  --pf-c-nav__link--m-current--before--BorderBottomWidth: 0;\n  --pf-c-nav__link--after--BorderColor: var(--pf-global--active-color--400);\n  --pf-c-nav__link--hover--after--BorderColor: var(--pf-global--active-color--400);\n  --pf-c-nav__link--focus--after--BorderColor: var(--pf-global--active-color--400);\n  --pf-c-nav__link--active--after--BorderColor: var(--pf-global--active-color--400);\n  --pf-c-nav__link--m-current--after--BorderColor: var(--pf-global--active-color--400);\n  --pf-c-nav__link--after--BorderLeftWidth: 0;\n  --pf-c-nav__link--hover--after--BorderLeftWidth: 0;\n  --pf-c-nav__link--focus--after--BorderLeftWidth: 0;\n  --pf-c-nav__link--active--after--BorderLeftWidth: 0;\n  --pf-c-nav__link--m-current--after--BorderLeftWidth: var(--pf-global--BorderWidth--xl);\n  --pf-c-nav--m-horizontal__link--PaddingTop: var(--pf-global--spacer--sm);\n  --pf-c-nav--m-horizontal__link--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-nav--m-horizontal__link--PaddingBottom: var(--pf-global--spacer--sm);\n  --pf-c-nav--m-horizontal__link--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-nav--m-horizontal__link--lg--PaddingTop: var(--pf-global--spacer--lg);\n  --pf-c-nav--m-horizontal__link--lg--PaddingBottom: var(--pf-global--spacer--lg);\n  --pf-c-nav--m-horizontal__link--Right: var(--pf-global--spacer--md);\n  --pf-c-nav--m-horizontal__link--Left: var(--pf-global--spacer--md);\n  --pf-c-nav--m-horizontal__link--Color: var(--pf-global--Color--light-300);\n  --pf-c-nav--m-horizontal__link--hover--Color: var(--pf-global--active-color--400);\n  --pf-c-nav--m-horizontal__link--focus--Color: var(--pf-global--active-color--400);\n  --pf-c-nav--m-horizontal__link--active--Color: var(--pf-global--active-color--400);\n  --pf-c-nav--m-horizontal__link--m-current--Color: var(--pf-global--active-color--400);\n  --pf-c-nav--m-horizontal__link--BackgroundColor: transparent;\n  --pf-c-nav--m-horizontal__link--hover--BackgroundColor: transparent;\n  --pf-c-nav--m-horizontal__link--focus--BackgroundColor: transparent;\n  --pf-c-nav--m-horizontal__link--active--BackgroundColor: transparent;\n  --pf-c-nav--m-horizontal__link--m-current--BackgroundColor: transparent;\n  --pf-c-nav--m-horizontal__link--before--BorderColor: var(--pf-global--active-color--400);\n  --pf-c-nav--m-horizontal__link--before--BorderWidth: 0;\n  --pf-c-nav--m-horizontal__link--hover--before--BorderWidth: var(--pf-global--BorderWidth--lg);\n  --pf-c-nav--m-horizontal__link--focus--before--BorderWidth: var(--pf-global--BorderWidth--lg);\n  --pf-c-nav--m-horizontal__link--active--before--BorderWidth: var(--pf-global--BorderWidth--lg);\n  --pf-c-nav--m-horizontal__link--m-current--before--BorderWidth: var(--pf-global--BorderWidth--lg);\n  --pf-c-nav--m-tertiary__link--PaddingTop: var(--pf-global--spacer--sm);\n  --pf-c-nav--m-tertiary__link--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-nav--m-tertiary__link--PaddingBottom: var(--pf-global--spacer--sm);\n  --pf-c-nav--m-tertiary__link--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-nav--m-tertiary__link--Right: var(--pf-global--spacer--md);\n  --pf-c-nav--m-tertiary__link--Left: var(--pf-global--spacer--md);\n  --pf-c-nav--m-tertiary__link--Color: var(--pf-global--Color--dark-100);\n  --pf-c-nav--m-tertiary__link--hover--Color: var(--pf-global--active-color--100);\n  --pf-c-nav--m-tertiary__link--focus--Color: var(--pf-global--active-color--100);\n  --pf-c-nav--m-tertiary__link--active--Color: var(--pf-global--active-color--100);\n  --pf-c-nav--m-tertiary__link--m-current--Color: var(--pf-global--active-color--100);\n  --pf-c-nav--m-tertiary__link--BackgroundColor: transparent;\n  --pf-c-nav--m-tertiary__link--hover--BackgroundColor: transparent;\n  --pf-c-nav--m-tertiary__link--focus--BackgroundColor: transparent;\n  --pf-c-nav--m-tertiary__link--active--BackgroundColor: transparent;\n  --pf-c-nav--m-tertiary__link--m-current--BackgroundColor: transparent;\n  --pf-c-nav--m-tertiary__link--before--BorderColor: var(--pf-global--active-color--100);\n  --pf-c-nav--m-tertiary__link--before--BorderWidth: 0;\n  --pf-c-nav--m-tertiary__link--hover--before--BorderWidth: var(--pf-global--BorderWidth--lg);\n  --pf-c-nav--m-tertiary__link--focus--before--BorderWidth: var(--pf-global--BorderWidth--lg);\n  --pf-c-nav--m-tertiary__link--active--before--BorderWidth: var(--pf-global--BorderWidth--lg);\n  --pf-c-nav--m-tertiary__link--m-current--before--BorderWidth: var(--pf-global--BorderWidth--lg);\n  --pf-c-nav--m-tertiary__scroll-button--Color: var(--pf-global--Color--dark-100);\n  --pf-c-nav--m-tertiary__scroll-button--hover--Color: var(--pf-global--active-color--100);\n  --pf-c-nav--m-tertiary__scroll-button--focus--Color: var(--pf-global--active-color--100);\n  --pf-c-nav--m-tertiary__scroll-button--active--Color: var(--pf-global--active-color--100);\n  --pf-c-nav--m-tertiary__scroll-button--disabled--Color: var(--pf-global--disabled-color--200);\n  --pf-c-nav--m-tertiary__scroll-button--before--BorderColor: var(--pf-global--BorderColor--300);\n  --pf-c-nav--m-tertiary__scroll-button--disabled--before--BorderColor: var(--pf-global--disabled-color--300);\n  --pf-c-nav--m-horizontal-subnav__link--PaddingTop: var(--pf-global--spacer--sm);\n  --pf-c-nav--m-horizontal-subnav__link--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-nav--m-horizontal-subnav__link--PaddingBottom: var(--pf-global--spacer--sm);\n  --pf-c-nav--m-horizontal-subnav__link--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-nav--m-horizontal-subnav__link--xl--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-nav--m-horizontal-subnav__link--xl--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-nav--m-horizontal-subnav__link--xl--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-nav--m-horizontal-subnav__link--xl--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-nav--m-horizontal-subnav__link--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-nav--m-horizontal-subnav__link--Color: var(--pf-global--Color--light-200);\n  --pf-c-nav--m-horizontal-subnav__link--hover--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav--m-horizontal-subnav__link--focus--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav--m-horizontal-subnav__link--active--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav--m-horizontal-subnav__link--m-current--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav--m-horizontal-subnav__link--BackgroundColor: transparent;\n  --pf-c-nav--m-horizontal-subnav__link--hover--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav--m-horizontal-subnav__link--focus--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav--m-horizontal-subnav__link--active--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav--m-horizontal-subnav__link--m-current--BackgroundColor: var(--pf-global--BackgroundColor--dark-400);\n  --pf-c-nav--m-horizontal-subnav__link--before--BorderColor: transparent;\n  --pf-c-nav--m-horizontal-subnav__link--after--BorderColor: var(--pf-global--palette--black-800);\n  --pf-c-nav--m-horizontal-subnav__link--hover--after--BorderColor: var(--pf-global--palette--black-800);\n  --pf-c-nav--m-horizontal-subnav__link--active--after--BorderColor: var(--pf-global--palette--black-800);\n  --pf-c-nav--m-horizontal-subnav__link--m-current--after--BorderColor: var(--pf-global--palette--black-800);\n  --pf-c-nav--m-horizontal-subnav__link--after--BorderLeftWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav--m-horizontal-subnav__link--hover--after--BorderLeftWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav--m-horizontal-subnav__link--active--after--BorderLeftWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav--m-horizontal-subnav__link--m-current--after--BorderLeftWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav__subnav--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-nav__subnav--xl--PaddingLeft: var(--pf-c-nav__link--PaddingLeft);\n  --pf-c-nav__subnav__link--MarginTop: 0;\n  --pf-c-nav__subnav__link--PaddingTop: var(--pf-global--spacer--sm);\n  --pf-c-nav__subnav__link--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-nav__subnav__link--PaddingBottom: var(--pf-global--spacer--sm);\n  --pf-c-nav__subnav__link--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-nav__subnav__link--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-nav__subnav__link--hover--after--BorderColor: var(--pf-global--BorderColor--200);\n  --pf-c-nav__subnav__link--focus--after--BorderColor: var(--pf-global--BorderColor--200);\n  --pf-c-nav__subnav__link--active--after--BorderColor: var(--pf-global--BorderColor--200);\n  --pf-c-nav__subnav__link--m-current--after--BorderColor: var(--pf-global--active-color--400);\n  --pf-c-nav__subnav__link--hover--after--BorderWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav__subnav__link--focus--after--BorderWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav__subnav__link--active--after--BorderWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav__subnav__link--m-current--after--BorderWidth: var(--pf-global--BorderWidth--xl);\n  --pf-c-nav__subnav--MaxHeight: 0;\n  --pf-c-nav__subnav__subnav--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-nav__subnav__subnav__link--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-nav__subnav__subnav__link--FontSize: var(--pf-global--FontSize--xs);\n  --pf-c-nav__item--m-expanded__subnav--MaxHeight: 100%;\n  --pf-c-nav__subnav--c-divider--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-nav__subnav--c-divider--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-nav__section--MarginTop: var(--pf-global--spacer--sm);\n  --pf-c-nav__section__item--MarginTop: var(--pf-global--spacer--sm);\n  --pf-c-nav__section__link--PaddingTop: var(--pf-global--spacer--sm);\n  --pf-c-nav__section__link--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-nav__section__link--PaddingBottom: var(--pf-global--spacer--sm);\n  --pf-c-nav__section__link--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-nav__section__link--xl--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-nav__section__link--xl--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-nav__section__link--FontSize: var(--pf-global--FontSize--md);\n  --pf-c-nav__section__link--before--BorderBottomWidth: 0;\n  --pf-c-nav__section__link--hover--after--BorderColor: transparent;\n  --pf-c-nav__section__link--focus--after--BorderColor: transparent;\n  --pf-c-nav__section__link--active--after--BorderColor: transparent;\n  --pf-c-nav__section__link--m-current--after--BorderColor: var(--pf-global--active-color--400);\n  --pf-c-nav__section__link--hover--after--BorderWidth: 0;\n  --pf-c-nav__section__link--focus--after--BorderWidth: 0;\n  --pf-c-nav__section__link--active--after--BorderWidth: 0;\n  --pf-c-nav__section__link--m-current--after--BorderWidth: var(--pf-global--BorderWidth--xl);\n  --pf-c-nav__section--section--MarginTop: var(--pf-global--spacer--xl);\n  --pf-c-nav__section-title--PaddingTop: var(--pf-global--spacer--sm);\n  --pf-c-nav__section-title--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-nav__section-title--PaddingBottom: var(--pf-global--spacer--sm);\n  --pf-c-nav__section-title--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-nav__section-title--xl--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-nav__section-title--xl--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-nav__section-title--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-nav__section-title--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav__section-title--BorderBottomColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__section-title--BorderBottomWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav__scroll-button--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav__scroll-button--hover--Color: var(--pf-global--active-color--400);\n  --pf-c-nav__scroll-button--focus--Color: var(--pf-global--active-color--400);\n  --pf-c-nav__scroll-button--active--Color: var(--pf-global--active-color--400);\n  --pf-c-nav__scroll-button--disabled--Color: var(--pf-global--disabled-color--100);\n  --pf-c-nav__scroll-button--BackgroundColor: transparent;\n  --pf-c-nav__scroll-button--Width: var(--pf-global--target-size--MinWidth);\n  --pf-c-nav__scroll-button--OutlineOffset: calc(-1 * var(--pf-global--spacer--xs));\n  --pf-c-nav__scroll-button--Transition: margin .125s, transform .125s, opacity .125s;\n  --pf-c-nav__scroll-button--before--BorderColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__scroll-button--before--BorderWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav__scroll-button--before--BorderRightWidth: 0;\n  --pf-c-nav__scroll-button--before--BorderLeftWidth: 0;\n  --pf-c-nav__scroll-button--disabled--before--BorderColor: transparent;\n  --pf-c-nav__toggle--PaddingRight: var(--pf-global--spacer--sm);\n  --pf-c-nav__toggle--PaddingLeft: var(--pf-global--spacer--sm);\n  --pf-c-nav__toggle--FontSize: var(--pf-global--icon--FontSize--md);\n  --pf-c-nav__toggle-icon--Transition: var(--pf-global--TransitionDuration);\n  --pf-c-nav--c-divider--MarginTop: var(--pf-global--spacer--sm);\n  --pf-c-nav--c-divider--MarginBottom: var(--pf-global--spacer--sm);\n  --pf-c-nav--c-divider--PaddingRight: 0;\n  --pf-c-nav--c-divider--PaddingLeft: 0;\n  --pf-c-nav--c-divider--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__list--ScrollSnapTypeAxis: x;\n  --pf-c-nav__list--ScrollSnapTypeStrictness: proximity;\n  --pf-c-nav__list--ScrollSnapType: var(--pf-c-nav__list--ScrollSnapTypeAxis) var(--pf-c-nav__list--ScrollSnapTypeStrictness);\n  --pf-c-nav__item--ScrollSnapAlign: end;\n  --pf-c-nav__item--m-flyout--c-menu--top-offset: 0px;\n  --pf-c-nav__item--m-flyout--c-menu--left-offset: 0.25rem;\n  --pf-c-nav__item--m-flyout--c-menu--m-top--bottom-offset: 0px;\n  --pf-c-nav__item--m-flyout--c-menu--m-left--right-offset: 0.25rem;\n  --pf-c-nav__item--m-flyout--MarginTop: 0;\n  --pf-c-nav__item--m-flyout--hover__link--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__item--m-flyout--focus__link--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__item--m-flyout--active__link--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav__item--m-flyout--hover__link--before--BorderWidth: 0;\n  --pf-c-nav__item--m-flyout--focus__link--before--BorderWidth: 0;\n  --pf-c-nav__item--m-flyout--active__link--before--BorderWidth: 0;\n  --pf-c-nav__item--m-flyout__item--last-child__link--before--BorderBottomWidth: 0;\n  --pf-c-nav__item--m-flyout--c-menu--Top: calc(0px + var(--pf-c-nav__item--m-flyout--c-menu--top-offset));\n  --pf-c-nav__item--m-flyout--c-menu--c-menu--Top: calc(var(--pf-c-nav__item--m-flyout--c-menu--Top) - var(--pf-c-nav__item--before--BorderWidth));\n  --pf-c-nav__item--m-flyout--c-menu__list-item--first-child--c-menu--Top: 0;\n  --pf-c-nav__item--m-flyout--c-menu--Left: calc(100% - var(--pf-c-nav__item--m-flyout--c-menu--left-offset));\n  --pf-c-nav__item--m-flyout--c-menu--m-left--Right: calc(100% - var(--pf-c-nav__item--m-flyout--c-menu--m-left--right-offset));\n  --pf-c-nav__item--m-flyout--c-menu--m-top--Bottom: calc(0 + var(--pf-c-nav__item--m-flyout--c-menu--m-top--bottom-offset));\n  --pf-c-nav__item--m-flyout--c-menu--BackgroundColor: var(--pf-global--BackgroundColor--dark-300);\n  --pf-c-nav__item--m-flyout--c-menu__item--Color: var(--pf-c-nav__link--Color);\n  --pf-c-nav__item--m-flyout--c-menu__item--PaddingTop: var(--pf-global--spacer--sm);\n  --pf-c-nav__item--m-flyout--c-menu__item--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-nav__item--m-flyout--c-menu__item--PaddingBottom: var(--pf-global--spacer--sm);\n  --pf-c-nav__item--m-flyout--c-menu__item--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-nav__item--m-flyout--c-menu__item-description--Color: var(--pf-global--Color--light-200);\n  --pf-c-nav__item--m-flyout--c-menu__item--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-nav__item--m-flyout--c-menu__item--OutlineOffset: var(--pf-c-nav__link--OutlineOffset);\n  --pf-c-nav__item--m-flyout--c-menu__item--before--BorderBottomWidth: var(--pf-c-nav__item--before--BorderWidth);\n  --pf-c-nav__item--m-flyout--c-menu__item--before--BorderBottomColor: var(--pf-c-nav__item--before--BorderColor);\n  --pf-c-nav__item--m-flyout--c-menu__item--hover--after--BorderLeftWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav__item--m-flyout--c-menu__item--hover--after--BorderLeftColor: var(--pf-global--BorderColor--200);\n  --pf-c-nav__item--m-flyout--c-menu__item--hover--after--Top: calc(-1 * var(--pf-c-nav__item--m-flyout--c-menu__item--before--BorderBottomWidth));\n  --pf-c-nav__item--m-flyout--c-menu__list-item--hover--BackgroundColor: var(--pf-c-nav__link--hover--BackgroundColor);\n  --pf-c-nav__item--m-flyout--c-menu__list-item--focus-within--BackgroundColor: var(--pf-c-nav__link--focus--BackgroundColor);\n  --pf-c-nav__item--m-flyout--c-menu__list-item--active--BackgroundColor: var(--pf-c-nav__link--active--BackgroundColor);\n  --pf-c-nav__item--m-flyout--c-menu__list-item--first-child__item--hover--after--Top: 0;\n  --pf-c-nav__item--m-flyout--c-menu--BoxShadow: var(--pf-global--BoxShadow--lg);\n  --pf-c-nav--c-menu--BackgroundColor: var(--pf-global--BackgroundColor--dark-300);\n  --pf-c-nav--c-menu__list--PaddingTop: 0;\n  --pf-c-nav--c-menu__list--PaddingBottom: 0;\n  --pf-c-nav--c-menu__list-item--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav--c-menu__list-item--hover--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav--c-menu__list-item--active--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav--c-menu__list-item--focus-within--Color: var(--pf-global--Color--light-100);\n  --pf-c-nav--c-menu__list-item--hover--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav--c-menu__list-item--focus-within--BackgroundColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav--c-menu__list-item--m-drill-up--before--BorderBottomWidth: var(--pf-global--BorderWidth--lg);\n  --pf-c-nav--c-menu__list-item--m-drill-up__item--FontWeight: var(--pf-global--FontWeight--bold);\n  --pf-c-nav--c-menu__item--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-nav--c-menu__item--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-nav--c-menu__item--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-nav--c-menu__item--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-nav--c-menu__item--xl--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-nav--c-menu__item--xl--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-nav--c-menu__item--FontSize: var(--pf-global--FontSize--sm);\n  --pf-c-nav--c-menu__item--OutlineOffset: calc(var(--pf-global--spacer--xs) * -1);\n  --pf-c-nav--c-menu__item--before--BorderBottomWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav--c-menu__item--before--BorderBottomColor: var(--pf-global--BackgroundColor--dark-200);\n  --pf-c-nav--c-menu__item--after--BorderLeftWidth: 0;\n  --pf-c-nav--c-menu__item--after--BorderLeftColor: transparent;\n  --pf-c-nav--c-menu__item--m-current--BackgroundColor: var(--pf-global--BackgroundColor--dark-400);\n  --pf-c-nav--c-menu__item--m-current--after--BorderLeftWidth: var(--pf-global--BorderWidth--xl);\n  --pf-c-nav--c-menu__item--m-current--after--BorderColor: var(--pf-global--active-color--400);\n  --pf-c-nav--c-menu__item-description--Color: var(--pf-global--Color--400);\n  --pf-c-nav--c-menu--m-flyout--left-offset: 0.25rem;\n  --pf-c-nav--c-menu--m-flyout--m-left--right-offset: 0.25rem;\n  --pf-c-nav--c-menu--m-flyout--Top: 0;\n  --pf-c-nav--c-menu--m-flyout--c-menu--Top: calc(var(--pf-c-nav--c-menu--m-flyout--Top) * -1);\n  --pf-c-nav--c-menu--m-flyout--c-menu--Right: auto;\n  --pf-c-nav--c-menu--m-flyout--c-menu--Bottom: auto;\n  --pf-c-nav--c-menu--m-flyout--c-menu--Left: calc(100% - var(--pf-c-nav--c-menu--m-flyout--left-offset));\n  --pf-c-nav--c-menu--m-flyout--m-left--Right: calc(100% - var(--pf-c-nav--c-menu--m-flyout--m-left--right-offset));\n  --pf-c-nav--c-menu--m-flyout--m-top--Bottom: 0;\n  --pf-c-nav--c-menu--m-flyout--BoxShadow: var(--pf-global--BoxShadow--lg);\n  --pf-c-nav--c-menu--m-flyout__item--PaddingTop: var(--pf-global--spacer--sm);\n  --pf-c-nav--c-menu--m-flyout__item--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-nav--c-menu--m-flyout__item--PaddingBottom: var(--pf-global--spacer--sm);\n  --pf-c-nav--c-menu--m-flyout__item--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-nav--c-menu--m-flyout__item--hover--after--BorderLeftWidth: var(--pf-global--BorderWidth--sm);\n  --pf-c-nav--c-menu--m-flyout__item--hover--after--BorderLeftColor: var(--pf-global--BorderColor--200);\n  --pf-c-nav__toggle--m-start--MarginRight: var(--pf-global--spacer--sm);\n  position: relative;\n}\n@media screen and (min-width: 1200px) {\n  .pf-c-nav {\n    --pf-c-nav__link--PaddingRight: var(--pf-c-nav__link--xl--PaddingRight);\n    --pf-c-nav__link--PaddingLeft: var(--pf-c-nav__link--xl--PaddingLeft);\n    --pf-c-nav--m-horizontal-subnav__link--PaddingTop: var(--pf-c-nav--m-horizontal-subnav__link--xl--PaddingTop);\n    --pf-c-nav--m-horizontal-subnav__link--PaddingRight: var(--pf-c-nav--m-horizontal-subnav__link--xl--PaddingRight);\n    --pf-c-nav--m-horizontal-subnav__link--PaddingBottom: var(--pf-c-nav--m-horizontal-subnav__link--xl--PaddingBottom);\n    --pf-c-nav--m-horizontal-subnav__link--PaddingLeft: var(--pf-c-nav--m-horizontal-subnav__link--xl--PaddingLeft);\n    --pf-c-nav__section__link--PaddingRight: var(--pf-c-nav__section__link--xl--PaddingRight);\n    --pf-c-nav__section__link--PaddingLeft: var(--pf-c-nav__section__link--xl--PaddingLeft);\n    --pf-c-nav__section-title--PaddingRight: var(--pf-c-nav__section-title--xl--PaddingRight);\n    --pf-c-nav__section-title--PaddingLeft: var(--pf-c-nav__section-title--xl--PaddingLeft);\n    --pf-c-nav__subnav--PaddingLeft: var(--pf-c-nav__subnav--xl--PaddingLeft);\n    --pf-c-nav--c-menu__item--PaddingRight: var(--pf-c-nav--c-menu__item--xl--PaddingRight);\n    --pf-c-nav--c-menu__item--PaddingLeft: var(--pf-c-nav--c-menu__item--xl--PaddingLeft);\n  }\n}\n.pf-c-nav .pf-c-menu {\n  --pf-c-menu--MinWidth: 100%;\n  --pf-c-menu--BackgroundColor: var(--pf-c-nav--c-menu--BackgroundColor);\n  --pf-c-menu__list--PaddingTop: var(--pf-c-nav--c-menu__list--PaddingTop);\n  --pf-c-menu__list--PaddingBottom: var(--pf-c-nav--c-menu__list--PaddingBottom);\n  --pf-c-menu__item--PaddingTop: var(--pf-c-nav--c-menu__item--PaddingTop);\n  --pf-c-menu__item--PaddingRight: var(--pf-c-nav--c-menu__item--PaddingRight);\n  --pf-c-menu__item--PaddingBottom: var(--pf-c-nav--c-menu__item--PaddingBottom);\n  --pf-c-menu__item--PaddingLeft: var(--pf-c-nav--c-menu__item--PaddingLeft);\n  --pf-c-menu__list-item--Color: var(--pf-c-nav--c-menu__list-item--Color);\n  --pf-c-menu__list-item--hover--Color: var(--pf-c-nav--c-menu__list-item--hover--Color);\n  --pf-c-menu__list-item--active--Color: var(--pf-c-nav--c-menu__list-item--active--Color);\n  --pf-c-menu__list-item--focus-within--Color: var(--pf-c-nav--c-menu__list-item--focus-within--Color);\n  --pf-c-menu__list-item--hover--BackgroundColor: var(--pf-c-nav--c-menu__list-item--hover--BackgroundColor);\n  --pf-c-menu__list-item--focus-within--BackgroundColor: var(--pf-c-nav--c-menu__list-item--focus-within--BackgroundColor);\n  --pf-c-menu__item-description--Color: var(--pf-c-nav--c-menu__item-description--Color);\n}\n.pf-c-nav .pf-c-menu:first-child > .pf-c-menu__content {\n  border-bottom: var(--pf-c-nav--c-menu__item--before--BorderBottomWidth) solid var(--pf-c-nav--c-menu__item--before--BorderBottomColor);\n}\n.pf-c-nav .pf-c-menu.pf-m-flyout, .pf-c-nav .pf-c-menu.pf-m-flyout .pf-c-menu {\n  --pf-c-menu--BoxShadow: var(--pf-c-nav--c-menu--m-flyout--BoxShadow);\n  --pf-c-menu__list--PaddingTop: 0;\n  --pf-c-menu__list--PaddingBottom: 0;\n  --pf-c-menu__item--FontSize: var(--pf-c-nav--c-menu__item--FontSize);\n  --pf-c-menu__item--Color: var(--pf-c-nav--c-menu__item--Color, inherit);\n  --pf-c-menu__item--PaddingTop: var(--pf-c-nav--c-menu--m-flyout__item--PaddingTop);\n  --pf-c-menu__item--PaddingRight: var(--pf-c-nav--c-menu--m-flyout__item--PaddingRight);\n  --pf-c-menu__item--PaddingBottom: var(--pf-c-nav--c-menu--m-flyout__item--PaddingBottom);\n  --pf-c-menu__item--PaddingLeft: var(--pf-c-nav--c-menu--m-flyout__item--PaddingLeft);\n  top: var(--pf-c-nav--c-menu--m-flyout--c-menu--Top);\n  right: var(--pf-c-nav--c-menu--m-flyout--c-menu--Right);\n  bottom: var(--pf-c-nav--c-menu--m-flyout--c-menu--Bottom);\n  left: var(--pf-c-nav--c-menu--m-flyout--c-menu--Left);\n}\n.pf-c-nav .pf-c-menu.pf-m-flyout .pf-c-menu__item:hover {\n  --pf-c-nav--c-menu__item--after--BorderLeftWidth: var(--pf-c-nav--c-menu--m-flyout__item--hover--after--BorderLeftWidth);\n  --pf-c-nav--c-menu__item--after--BorderLeftColor: var(--pf-c-nav--c-menu--m-flyout__item--hover--after--BorderLeftColor);\n}\n.pf-c-nav .pf-c-menu.pf-m-top {\n  --pf-c-nav--c-menu--m-flyout--c-menu--Top: auto;\n  --pf-c-nav--c-menu--m-flyout--c-menu--Bottom: var(--pf-c-nav--c-menu--m-flyout--m-top--Bottom);\n}\n.pf-c-nav .pf-c-menu.pf-m-left {\n  --pf-c-nav--c-menu--m-flyout--c-menu--Right: var(--pf-c-nav--c-menu--m-flyout--m-left--Right);\n  --pf-c-nav--c-menu--m-flyout--c-menu--Left: auto;\n}\n.pf-c-nav .pf-c-menu .pf-c-divider {\n  margin-top: 0;\n  margin-bottom: 0;\n}\n.pf-c-nav .pf-c-menu__item {\n  position: relative;\n  outline-offset: var(--pf-c-nav--c-menu__item--OutlineOffset);\n}\n.pf-c-nav .pf-c-menu__item::before, .pf-c-nav .pf-c-menu__item::after {\n  position: absolute;\n  top: 0;\n  content: "";\n}\n.pf-c-nav .pf-c-menu__item::before {\n  right: 0;\n  bottom: calc(var(--pf-c-nav--c-menu__item--before--BorderBottomWidth) * -1);\n  left: 0;\n  border-bottom: var(--pf-c-nav--c-menu__item--before--BorderBottomWidth) solid var(--pf-c-nav--c-menu__item--before--BorderBottomColor);\n}\n.pf-c-nav .pf-c-menu__item::after {\n  bottom: 0;\n  left: 0;\n  border-left: var(--pf-c-nav--c-menu__item--after--BorderLeftWidth) solid var(--pf-c-nav--c-menu__item--after--BorderLeftColor);\n}\n.pf-c-nav .pf-c-menu__item.pf-m-current {\n  --pf-c-nav--c-menu__item--after--BorderLeftWidth: var(--pf-c-nav--c-menu__item--m-current--after--BorderLeftWidth);\n  --pf-c-nav--c-menu__item--after--BorderLeftColor: var(--pf-c-nav--c-menu__item--m-current--after--BorderColor);\n  background-color: var(--pf-c-nav--c-menu__item--m-current--BackgroundColor);\n}\n.pf-c-nav .pf-c-menu__list-item:where(.pf-m-drill-up) {\n  --pf-c-nav--c-menu__item--before--BorderBottomWidth: var(--pf-c-nav--c-menu__list-item--m-drill-up--before--BorderBottomWidth);\n}\n.pf-c-nav .pf-c-menu__list-item:where(.pf-m-drill-up) > .pf-c-menu__item {\n  --pf-c-menu__item--FontWeight: var(--pf-c-nav--c-menu__list-item--m-drill-up__item--FontWeight);\n}\n.pf-c-nav .pf-c-menu__item-toggle-icon {\n  margin-left: calc(var(--pf-c-menu__item-toggle-icon--PaddingLeft) * -1);\n}\n.pf-c-nav.pf-m-horizontal .pf-c-nav__link::after, .pf-c-nav.pf-m-tertiary .pf-c-nav__link::after {\n  content: none;\n}\n.pf-c-nav.pf-m-horizontal, .pf-c-nav.pf-m-tertiary, .pf-c-nav.pf-m-horizontal-subnav {\n  overflow: hidden;\n}\n.pf-c-nav.pf-m-horizontal,\n.pf-c-nav.pf-m-horizontal .pf-c-nav__list, .pf-c-nav.pf-m-tertiary,\n.pf-c-nav.pf-m-tertiary .pf-c-nav__list, .pf-c-nav.pf-m-horizontal-subnav,\n.pf-c-nav.pf-m-horizontal-subnav .pf-c-nav__list {\n  position: relative;\n  display: flex;\n}\n.pf-c-nav.pf-m-horizontal .pf-c-nav__list, .pf-c-nav.pf-m-tertiary .pf-c-nav__list, .pf-c-nav.pf-m-horizontal-subnav .pf-c-nav__list {\n  flex: 1;\n  max-width: 100%;\n  overflow-x: auto;\n  white-space: nowrap;\n  scroll-snap-type: var(--pf-c-nav__list--ScrollSnapType);\n  -webkit-overflow-scrolling: touch;\n  scrollbar-width: none;\n  -ms-overflow-style: -ms-autohiding-scrollbar;\n}\n.pf-c-nav.pf-m-horizontal .pf-c-nav__list::-webkit-scrollbar, .pf-c-nav.pf-m-tertiary .pf-c-nav__list::-webkit-scrollbar, .pf-c-nav.pf-m-horizontal-subnav .pf-c-nav__list::-webkit-scrollbar {\n  display: none;\n}\n.pf-c-nav.pf-m-horizontal .pf-c-nav__item, .pf-c-nav.pf-m-tertiary .pf-c-nav__item, .pf-c-nav.pf-m-horizontal-subnav .pf-c-nav__item {\n  display: flex;\n  scroll-snap-align: var(--pf-c-nav__item--ScrollSnapAlign);\n}\n.pf-c-nav.pf-m-horizontal .pf-c-nav__link, .pf-c-nav.pf-m-tertiary .pf-c-nav__link, .pf-c-nav.pf-m-horizontal-subnav .pf-c-nav__link {\n  align-items: center;\n  align-self: stretch;\n  white-space: nowrap;\n}\n.pf-c-nav.pf-m-horizontal .pf-c-nav__link::before, .pf-c-nav.pf-m-tertiary .pf-c-nav__link::before, .pf-c-nav.pf-m-horizontal-subnav .pf-c-nav__link::before {\n  top: auto;\n  bottom: 0;\n}\n.pf-c-nav.pf-m-horizontal .pf-c-nav__link::before {\n  right: var(--pf-c-nav--m-horizontal__link--Right);\n  left: var(--pf-c-nav--m-horizontal__link--Left);\n}\n.pf-c-nav.pf-m-tertiary .pf-c-nav__link::before {\n  right: var(--pf-c-nav--m-tertiary__link--Right);\n  left: var(--pf-c-nav--m-tertiary__link--Left);\n}\n.pf-c-nav.pf-m-light {\n  --pf-c-nav__item--before--BorderColor: var(--pf-c-nav--m-light__item--before--BorderColor);\n  --pf-c-nav__item--m-current--not--m-expanded__link--BackgroundColor: var(--pf-c-nav--m-light__item--m-current--not--m-expanded__link--BackgroundColor);\n  --pf-c-nav__link--Color: var(--pf-c-nav--m-light__link--Color);\n  --pf-c-nav__link--hover--Color: var(--pf-c-nav--m-light__link--hover--Color);\n  --pf-c-nav__link--focus--Color: var(--pf-c-nav--m-light__link--focus--Color);\n  --pf-c-nav__link--active--Color: var(--pf-c-nav--m-light__link--active--Color);\n  --pf-c-nav__link--m-current--Color: var(--pf-c-nav--m-light__link--m-current--Color);\n  --pf-c-nav__link--hover--BackgroundColor: var(--pf-c-nav--m-light__link--hover--BackgroundColor);\n  --pf-c-nav__link--focus--BackgroundColor: var(--pf-c-nav--m-light__link--focus--BackgroundColor);\n  --pf-c-nav__link--active--BackgroundColor: var(--pf-c-nav--m-light__link--active--BackgroundColor);\n  --pf-c-nav__link--m-current--BackgroundColor: var(--pf-c-nav--m-light__link--m-current--BackgroundColor);\n  --pf-c-nav__link--before--BorderColor: var(--pf-c-nav--m-light__link--before--BorderColor);\n  --pf-c-nav__link--after--BorderColor: var(--pf-c-nav--m-light__link--after--BorderColor);\n  --pf-c-nav__link--m-current--after--BorderColor: var(--pf-c-nav--m-light__link--m-current--after--BorderColor);\n  --pf-c-nav__subnav__link--hover--after--BorderColor: var(--pf-c-nav--m-light__subnav__link--hover--after--BorderColor);\n  --pf-c-nav__subnav__link--focus--after--BorderColor: var(--pf-c-nav--m-light__subnav__link--focus--after--BorderColor);\n  --pf-c-nav__subnav__link--active--after--BorderColor: var(--pf-c-nav--m-light__subnav__link--active--after--BorderColor);\n  --pf-c-nav__subnav__link--m-current--after--BorderColor: var(--pf-c-nav--m-light__subnav__link--m-current--after--BorderColor);\n  --pf-c-nav__section-title--Color: var(--pf-c-nav--m-light__section-title--Color);\n  --pf-c-nav__section-title--BorderBottomColor: var(--pf-c-nav--m-light__section-title--BorderBottomColor);\n}\n.pf-c-nav.pf-m-light .pf-c-divider {\n  --pf-c-divider--after--BackgroundColor: var(--pf-c-nav--m-light--c-divider--BackgroundColor);\n}\n.pf-c-nav.pf-m-horizontal {\n  --pf-c-nav__link--PaddingTop: var(--pf-c-nav--m-horizontal__link--PaddingTop);\n  --pf-c-nav__link--PaddingRight: var(--pf-c-nav--m-horizontal__link--PaddingRight);\n  --pf-c-nav__link--PaddingBottom: var(--pf-c-nav--m-horizontal__link--PaddingBottom);\n  --pf-c-nav__link--PaddingLeft: var(--pf-c-nav--m-horizontal__link--PaddingLeft);\n  --pf-c-nav__link--Right: var(--pf-c-nav--m-horizontal__link--Right);\n  --pf-c-nav__link--Left: var(--pf-c-nav--m-horizontal__link--Left);\n  --pf-c-nav__link--Color: var(--pf-c-nav--m-horizontal__link--Color);\n  --pf-c-nav__link--hover--Color: var(--pf-c-nav--m-horizontal__link--hover--Color);\n  --pf-c-nav__link--active--Color: var(--pf-c-nav--m-horizontal__link--active--Color);\n  --pf-c-nav__link--focus--Color: var(--pf-c-nav--m-horizontal__link--focus--Color);\n  --pf-c-nav__link--m-current--Color: var(--pf-c-nav--m-horizontal__link--m-current--Color);\n  --pf-c-nav__link--BackgroundColor: var(--pf-c-nav--m-horizontal__link--BackgroundColor);\n  --pf-c-nav__link--hover--BackgroundColor: var(--pf-c-nav--m-horizontal__link--hover--BackgroundColor);\n  --pf-c-nav__link--focus--BackgroundColor: var(--pf-c-nav--m-horizontal__link--focus--BackgroundColor);\n  --pf-c-nav__link--active--BackgroundColor: var(--pf-c-nav--m-horizontal__link--active--BackgroundColor);\n  --pf-c-nav__link--m-current--BackgroundColor: var(--pf-c-nav--m-horizontal__link--m-current--BackgroundColor);\n  --pf-c-nav__link--before--BorderColor: var(--pf-c-nav--m-horizontal__link--before--BorderColor);\n  --pf-c-nav__link--before--BorderBottomWidth: var(--pf-c-nav--m-horizontal__link--before--BorderWidth);\n  --pf-c-nav__link--hover--before--BorderBottomWidth: var(--pf-c-nav--m-horizontal__link--hover--before--BorderWidth);\n  --pf-c-nav__link--focus--before--BorderBottomWidth: var(--pf-c-nav--m-horizontal__link--focus--before--BorderWidth);\n  --pf-c-nav__link--active--before--BorderBottomWidth: var(--pf-c-nav--m-horizontal__link--active--before--BorderWidth);\n  --pf-c-nav__link--m-current--before--BorderBottomWidth: var(--pf-c-nav--m-horizontal__link--m-current--before--BorderWidth);\n}\n.pf-c-nav.pf-m-tertiary {\n  --pf-c-nav__link--PaddingTop: var(--pf-c-nav--m-tertiary__link--PaddingTop);\n  --pf-c-nav__link--PaddingRight: var(--pf-c-nav--m-tertiary__link--PaddingRight);\n  --pf-c-nav__link--PaddingBottom: var(--pf-c-nav--m-tertiary__link--PaddingBottom);\n  --pf-c-nav__link--PaddingLeft: var(--pf-c-nav--m-tertiary__link--PaddingLeft);\n  --pf-c-nav__link--Right: var(--pf-c-nav--m-tertiary__link--Right);\n  --pf-c-nav__link--Left: var(--pf-c-nav--m-tertiary__link--Left);\n  --pf-c-nav__link--Color: var(--pf-c-nav--m-tertiary__link--Color);\n  --pf-c-nav__link--hover--Color: var(--pf-c-nav--m-tertiary__link--hover--Color);\n  --pf-c-nav__link--active--Color: var(--pf-c-nav--m-tertiary__link--active--Color);\n  --pf-c-nav__link--focus--Color: var(--pf-c-nav--m-tertiary__link--focus--Color);\n  --pf-c-nav__link--m-current--Color: var(--pf-c-nav--m-tertiary__link--m-current--Color);\n  --pf-c-nav__link--BackgroundColor: var(--pf-c-nav--m-tertiary__link--BackgroundColor);\n  --pf-c-nav__link--hover--BackgroundColor: var(--pf-c-nav--m-tertiary__link--hover--BackgroundColor);\n  --pf-c-nav__link--focus--BackgroundColor: var(--pf-c-nav--m-tertiary__link--focus--BackgroundColor);\n  --pf-c-nav__link--active--BackgroundColor: var(--pf-c-nav--m-tertiary__link--active--BackgroundColor);\n  --pf-c-nav__link--m-current--BackgroundColor: var(--pf-c-nav--m-tertiary__link--m-current--BackgroundColor);\n  --pf-c-nav__link--before--BorderColor: var(--pf-c-nav--m-tertiary__link--before--BorderColor);\n  --pf-c-nav__link--before--BorderBottomWidth: var(--pf-c-nav--m-tertiary__link--before--BorderWidth);\n  --pf-c-nav__link--hover--before--BorderBottomWidth: var(--pf-c-nav--m-tertiary__link--hover--before--BorderWidth);\n  --pf-c-nav__link--focus--before--BorderBottomWidth: var(--pf-c-nav--m-tertiary__link--focus--before--BorderWidth);\n  --pf-c-nav__link--active--before--BorderBottomWidth: var(--pf-c-nav--m-tertiary__link--active--before--BorderWidth);\n  --pf-c-nav__link--m-current--before--BorderBottomWidth: var(--pf-c-nav--m-tertiary__link--m-current--before--BorderWidth);\n  --pf-c-nav__scroll-button--Color: var(--pf-c-nav--m-tertiary__scroll-button--Color);\n  --pf-c-nav__scroll-button--hover--Color: var(--pf-c-nav--m-tertiary__scroll-button--hover--Color);\n  --pf-c-nav__scroll-button--focus--Color: var(--pf-c-nav--m-tertiary__scroll-button--focus--Color);\n  --pf-c-nav__scroll-button--active--Color: var(--pf-c-nav--m-tertiary__scroll-button--active--Color);\n  --pf-c-nav__scroll-button--disabled--Color: var(--pf-c-nav--m-tertiary__scroll-button--disabled--Color);\n  --pf-c-nav__scroll-button--before--BorderColor: var(--pf-c-nav--m-tertiary__scroll-button--before--BorderColor);\n  --pf-c-nav__scroll-button--disabled--before--BorderColor: var(--pf-c-nav--m-tertiary__scroll-button--disabled--before--BorderColor);\n}\n.pf-c-nav.pf-m-horizontal-subnav {\n  --pf-c-nav__link--FontSize: var(--pf-c-nav--m-horizontal-subnav__link--FontSize);\n  --pf-c-nav__link--PaddingTop: var(--pf-c-nav--m-horizontal-subnav__link--PaddingTop);\n  --pf-c-nav__link--PaddingRight: var(--pf-c-nav--m-horizontal-subnav__link--PaddingRight);\n  --pf-c-nav__link--PaddingBottom: var(--pf-c-nav--m-horizontal-subnav__link--PaddingBottom);\n  --pf-c-nav__link--PaddingLeft: var(--pf-c-nav--m-horizontal-subnav__link--PaddingLeft);\n  --pf-c-nav__link--Color: var(--pf-c-nav--m-horizontal-subnav__link--Color);\n  --pf-c-nav__link--Right: var(--pf-c-nav--m-horizontal-subnav__link--Right);\n  --pf-c-nav__link--Left: var(--pf-c-nav--m-horizontal-subnav__link--Left);\n  --pf-c-nav__link--hover--Color: var(--pf-c-nav--m-horizontal-subnav__link--hover--Color);\n  --pf-c-nav__link--active--Color: var(--pf-c-nav--m-horizontal-subnav__link--active--Color);\n  --pf-c-nav__link--focus--Color: var(--pf-c-nav--m-horizontal-subnav__link--focus--Color);\n  --pf-c-nav__link--m-current--Color: var(--pf-c-nav--m-horizontal-subnav__link--m-current--Color);\n  --pf-c-nav__link--BackgroundColor: var(--pf-c-nav--m-horizontal-subnav__link--BackgroundColor);\n  --pf-c-nav__link--hover--BackgroundColor: var(--pf-c-nav--m-horizontal-subnav__link--hover--BackgroundColor);\n  --pf-c-nav__link--focus--BackgroundColor: var(--pf-c-nav--m-horizontal-subnav__link--focus--BackgroundColor);\n  --pf-c-nav__link--active--BackgroundColor: var(--pf-c-nav--m-horizontal-subnav__link--active--BackgroundColor);\n  --pf-c-nav__link--m-current--BackgroundColor: var(--pf-c-nav--m-horizontal-subnav__link--m-current--BackgroundColor);\n  --pf-c-nav__link--before--BorderColor: var(--pf-c-nav--m-horizontal-subnav__link--before--BorderColor);\n  --pf-c-nav__link--after--BorderColor: var(--pf-c-nav--m-horizontal-subnav__link--after--BorderColor);\n  --pf-c-nav__link--hover--after--BorderColor: var(--pf-c-nav--m-horizontal-subnav__link--hover--after--BorderColor);\n  --pf-c-nav__link--active--after--BorderColor: var(--pf-c-nav--m-horizontal-subnav__link--active--after--BorderColor);\n  --pf-c-nav__link--m-current--after--BorderColor: var(--pf-c-nav--m-horizontal-subnav__link--m-current--after--BorderColor);\n  --pf-c-nav__link--after--BorderLeftWidth: var(--pf-c-nav--m-horizontal-subnav__link--after--BorderLeftWidth);\n  --pf-c-nav__link--hover--after--BorderLeftWidth: var(--pf-c-nav--m-horizontal-subnav__link--hover--after--BorderLeftWidth);\n  --pf-c-nav__link--active--after--BorderLeftWidth: var(--pf-c-nav--m-horizontal-subnav__link--active--after--BorderLeftWidth);\n  --pf-c-nav__link--m-current--after--BorderLeftWidth: var(--pf-c-nav--m-horizontal-subnav__link--m-current--after--BorderLeftWidth);\n}\n.pf-c-nav.pf-m-horizontal-subnav.pf-m-scrollable .pf-c-nav__item:first-child {\n  --pf-c-nav__link--after--BorderLeftWidth: 0;\n  --pf-c-nav__link--hover--after--BorderLeftWidth: 0;\n  --pf-c-nav__link--active--after--BorderLeftWidth: 0;\n  --pf-c-nav__link--m-current--after--BorderLeftWidth: 0;\n}\n.pf-c-nav .pf-c-divider {\n  --pf-c-divider--after--BackgroundColor: var(--pf-c-nav--c-divider--BackgroundColor);\n  padding-right: var(--pf-c-nav--c-divider--PaddingRight);\n  padding-left: var(--pf-c-nav--c-divider--PaddingLeft);\n  margin-top: var(--pf-c-nav--c-divider--MarginTop);\n  margin-bottom: var(--pf-c-nav--c-divider--MarginBottom);\n}\n.pf-c-nav.pf-m-scrollable .pf-c-nav__scroll-button {\n  opacity: 1;\n}\n.pf-c-nav.pf-m-scrollable .pf-c-nav__scroll-button:nth-of-type(1) {\n  margin-right: 0;\n  transform: translateX(0);\n}\n.pf-c-nav.pf-m-scrollable .pf-c-nav__scroll-button:nth-of-type(2) {\n  margin-left: 0;\n  transform: translateX(0);\n}\n.pf-c-nav.pf-m-overflow-hidden {\n  overflow: hidden;\n}\n\n.pf-c-nav__list {\n  position: relative;\n  display: block;\n}\n\n.pf-c-nav__item {\n  position: relative;\n  margin-top: var(--pf-c-nav__item--MarginTop);\n}\n.pf-c-nav__item.pf-m-expandable {\n  --pf-c-nav__link--before--BorderBottomWidth: 0;\n}\n.pf-c-nav__item.pf-m-expandable::before {\n  position: absolute;\n  right: 0;\n  bottom: calc(var(--pf-c-nav__item--before--BorderWidth) * -1);\n  left: 0;\n  content: "";\n  border-bottom: var(--pf-c-nav__item--before--BorderWidth) solid var(--pf-c-nav__item--before--BorderColor);\n}\n.pf-c-nav__item .pf-c-nav__item:not(.pf-m-expanded) .pf-c-nav__toggle-icon {\n  transform: rotate(0);\n}\n.pf-c-nav__item .pf-c-nav__item.pf-m-expandable {\n  --pf-c-nav__toggle--FontSize: var(--pf-c-nav__item__item__toggle--FontSize);\n  --pf-c-nav__link--PaddingRight: var(--pf-c-nav__item__item__link--PaddingRight);\n}\n@media screen and (min-width: 1200px) {\n  .pf-c-nav__item .pf-c-nav__item.pf-m-expandable::before {\n    border-bottom: none;\n  }\n}\n.pf-c-nav__item .pf-c-nav__item.pf-m-expandable .pf-c-nav__list::before {\n  position: absolute;\n  top: 0;\n  right: 0;\n  bottom: 0;\n  left: 0;\n  pointer-events: none;\n  content: "";\n  border-left: var(--pf-c-nav__item--before--BorderWidth) solid var(--pf-c-nav__item--before--BorderColor);\n}\n.pf-c-nav__item .pf-c-nav__toggle-icon {\n  transform: rotate(var(--pf-c-nav__item__toggle-icon--Rotate));\n}\n.pf-c-nav__item.pf-m-flyout:hover {\n  --pf-c-nav__link--BackgroundColor: var(--pf-c-nav__item--m-flyout--hover__link--BackgroundColor);\n  --pf-c-nav__link--before--BorderBottomWidth: var(--pf-c-nav__item--m-flyout--hover__link--before--BorderWidth);\n}\n.pf-c-nav__item.pf-m-flyout:focus {\n  --pf-c-nav__link--BackgroundColor: var(--pf-c-nav__item--m-flyout--focus__link--BackgroundColor);\n  --pf-c-nav__link--before--BorderBottomWidth: var(--pf-c-nav__item--m-flyout--focus__link--before--BorderWidth);\n}\n.pf-c-nav__item.pf-m-flyout:active {\n  --pf-c-nav__link--BackgroundColor: var(--pf-c-nav__item--m-flyout--active__link--BackgroundColor);\n  --pf-c-nav__link--before--BorderBottomWidth: var(--pf-c-nav__item--m-flyout--active__link--before--BorderWidth);\n}\n.pf-c-nav__item.pf-m-flyout .pf-c-menu {\n  --pf-c-menu--MinWidth: 100%;\n  --pf-c-menu--BoxShadow: var(--pf-c-nav__item--m-flyout--c-menu--BoxShadow);\n  --pf-c-menu--BackgroundColor: var(--pf-c-nav__item--m-flyout--c-menu--BackgroundColor);\n  --pf-c-menu__list--PaddingTop: 0;\n  --pf-c-menu__list--PaddingBottom: 0;\n  --pf-c-menu__list-item--hover--BackgroundColor: var(--pf-c-nav__item--m-flyout--c-menu__list-item--hover--BackgroundColor);\n  --pf-c-menu__list-item--focus-within--BackgroundColor: var(--pf-c-nav__item--m-flyout--c-menu__list-item--focus-within--BackgroundColor);\n  --pf-c-menu__list-item--active--BackgroundColor: var(--pf-c-nav__item--m-flyout--c-menu__list-item--active--BackgroundColor);\n  --pf-c-menu__item--FontSize: var(--pf-c-nav__item--m-flyout--c-menu__item--FontSize);\n  --pf-c-menu__item--Color: var(--pf-c-nav__item--m-flyout--c-menu__item--Color);\n  --pf-c-menu__item--PaddingTop: var(--pf-c-nav__item--m-flyout--c-menu__item--PaddingTop);\n  --pf-c-menu__item--PaddingRight: var(--pf-c-nav__item--m-flyout--c-menu__item--PaddingRight);\n  --pf-c-menu__item--PaddingBottom: var(--pf-c-nav__item--m-flyout--c-menu__item--PaddingBottom);\n  --pf-c-menu__item--PaddingLeft: var(--pf-c-nav__item--m-flyout--c-menu__item--PaddingLeft);\n  --pf-c-menu__item-description--Color: var(--pf-c-nav__item--m-flyout--c-menu__item-description--Color);\n  --pf-c-nav--c-menu--m-flyout--c-menu--Bottom: var(--pf-c-nav__item--m-flyout--c-menu--m-top--Bottom);\n  --pf-c-nav--c-menu--m-flyout--c-menu--Right: var(--pf-c-nav__item--m-flyout--c-menu--m-left--Right);\n  position: absolute;\n  top: var(--pf-c-nav__item--m-flyout--c-menu--Top);\n  left: var(--pf-c-nav__item--m-flyout--c-menu--Left);\n}\n.pf-c-nav__item.pf-m-flyout .pf-c-menu .pf-c-menu {\n  top: var(--pf-c-nav__item--m-flyout--c-menu--c-menu--Top);\n}\n.pf-c-nav__item.pf-m-flyout .pf-c-menu .pf-c-menu__list-item:first-child {\n  --pf-c-nav__item--m-flyout--c-menu--c-menu--Top: var(--pf-c-nav__item--m-flyout--c-menu__list-item--first-child--c-menu--Top);\n  --pf-c-nav__item--m-flyout--c-menu__item--hover--after--Top: var(--pf-c-nav__item--m-flyout--c-menu__list-item--first-child__item--hover--after--Top);\n}\n.pf-c-nav__item.pf-m-flyout .pf-c-menu .pf-c-menu__item {\n  position: relative;\n  outline-offset: var(--pf-c-nav__item--m-flyout--c-menu__item--OutlineOffset);\n}\n.pf-c-nav__item.pf-m-flyout .pf-c-menu .pf-c-menu__item::before {\n  position: absolute;\n  right: 0;\n  bottom: 0;\n  left: 0;\n  content: "";\n  border-bottom: var(--pf-c-nav__item--m-flyout--c-menu__item--before--BorderBottomWidth) solid var(--pf-c-nav__item--m-flyout--c-menu__item--before--BorderBottomColor);\n}\n.pf-c-nav__item.pf-m-flyout .pf-c-menu .pf-c-menu__item:hover::after {\n  position: absolute;\n  top: var(--pf-c-nav__item--m-flyout--c-menu__item--hover--after--Top);\n  bottom: 0;\n  left: 0;\n  content: "";\n  border-left: var(--pf-c-nav__item--m-flyout--c-menu__item--hover--after--BorderLeftWidth) solid var(--pf-c-nav__item--m-flyout--c-menu__item--hover--after--BorderLeftColor);\n}\n.pf-c-nav__item.pf-m-drilldown.pf-m-expanded > .pf-c-nav__subnav {\n  left: 0;\n  z-index: var(--pf-c-nav__item--m-drilldown--m-expanded__subnav--ZIndex);\n}\n\n.pf-c-nav__link {\n  position: relative;\n  display: flex;\n  align-items: baseline;\n  padding: var(--pf-c-nav__link--PaddingTop) var(--pf-c-nav__link--PaddingRight) var(--pf-c-nav__link--PaddingBottom) var(--pf-c-nav__link--PaddingLeft);\n  font-size: var(--pf-c-nav__link--FontSize);\n  font-weight: var(--pf-c-nav__link--FontWeight);\n  color: var(--pf-c-nav__link--Color);\n  background-color: var(--pf-c-nav__link--BackgroundColor);\n  outline-offset: var(--pf-c-nav__link--OutlineOffset);\n}\n.pf-c-nav__link::after, .pf-c-nav__link::before {\n  position: absolute;\n  content: "";\n  border: 0 solid;\n}\n.pf-c-nav__link::before {\n  right: 0;\n  bottom: calc(var(--pf-c-nav__link--before--BorderBottomWidth) * -1);\n  left: 0;\n  border-color: var(--pf-c-nav__link--before--BorderColor);\n  border-bottom-width: var(--pf-c-nav__link--before--BorderBottomWidth);\n}\n.pf-c-nav__link::after {\n  top: 0;\n  bottom: 0;\n  left: 0;\n  border: 0 solid;\n  border-color: var(--pf-c-nav__link--after--BorderColor);\n  border-left-width: var(--pf-c-nav__link--after--BorderLeftWidth);\n}\n.pf-c-nav__link:hover, .pf-c-nav__link.pf-m-hover {\n  color: var(--pf-c-nav__link--hover--Color);\n  background-color: var(--pf-c-nav__link--hover--BackgroundColor);\n}\n.pf-c-nav__link:hover::before, .pf-c-nav__link.pf-m-hover::before {\n  border-bottom-width: var(--pf-c-nav__link--hover--before--BorderBottomWidth);\n}\n.pf-c-nav__link:hover::after, .pf-c-nav__link.pf-m-hover::after {\n  border-color: var(--pf-c-nav__link--hover--after--BorderColor);\n  border-left-width: var(--pf-c-nav__link--hover--after--BorderLeftWidth);\n}\n.pf-c-nav__link:focus {\n  color: var(--pf-c-nav__link--focus--Color);\n  background-color: var(--pf-c-nav__link--focus--BackgroundColor);\n}\n.pf-c-nav__link:focus::before {\n  border-bottom-width: var(--pf-c-nav__link--focus--before--BorderBottomWidth);\n}\n.pf-c-nav__link:focus::after {\n  border-color: var(--pf-c-nav__link--focus--after--BorderColor);\n  border-left-width: var(--pf-c-nav__link--focus--after--BorderLeftWidth);\n}\n.pf-c-nav__link:active {\n  color: var(--pf-c-nav__link--active--Color);\n  background-color: var(--pf-c-nav__link--active--BackgroundColor);\n}\n.pf-c-nav__link:active::before {\n  border-bottom-width: var(--pf-c-nav__link--active--before--BorderBottomWidth);\n}\n.pf-c-nav__link:active::after {\n  border-color: var(--pf-c-nav__link--active--after--BorderColor);\n  border-left-width: var(--pf-c-nav__link--active--after--BorderLeftWidth);\n}\n.pf-c-nav__link.pf-m-current, .pf-c-nav__link.pf-m-current:hover, .pf-c-nav__item.pf-m-current:not(.pf-m-expanded) .pf-c-nav__link {\n  color: var(--pf-c-nav__link--m-current--Color);\n  background-color: var(--pf-c-nav__link--m-current--BackgroundColor);\n}\n.pf-c-nav__link.pf-m-current::before, .pf-c-nav__link.pf-m-current:hover::before, .pf-c-nav__item.pf-m-current:not(.pf-m-expanded) .pf-c-nav__link::before {\n  border-bottom-width: var(--pf-c-nav__link--m-current--before--BorderBottomWidth);\n}\n.pf-c-nav__link.pf-m-current::after, .pf-c-nav__link.pf-m-current:hover::after, .pf-c-nav__item.pf-m-current:not(.pf-m-expanded) .pf-c-nav__link::after {\n  border-color: var(--pf-c-nav__link--m-current--after--BorderColor);\n  border-left-width: var(--pf-c-nav__link--m-current--after--BorderLeftWidth);\n}\n.pf-c-nav__link, .pf-c-nav__link:hover, .pf-c-nav__link:focus, .pf-c-nav__link:active {\n  width: 100%;\n  text-decoration: none;\n  border: none;\n}\n\n.pf-c-nav__subnav {\n  --pf-c-nav__link--PaddingTop: var(--pf-c-nav__subnav__link--PaddingTop);\n  --pf-c-nav__link--PaddingRight: var(--pf-c-nav__subnav__link--PaddingRight);\n  --pf-c-nav__link--PaddingBottom: var(--pf-c-nav__subnav__link--PaddingBottom);\n  --pf-c-nav__link--PaddingLeft: var(--pf-c-nav__subnav__link--PaddingLeft);\n  --pf-c-nav__link--FontSize: var(--pf-c-nav__subnav__link--FontSize);\n  --pf-c-nav__link--hover--after--BorderColor: var(--pf-c-nav__subnav__link--hover--after--BorderColor);\n  --pf-c-nav__link--focus--after--BorderColor: var(--pf-c-nav__subnav__link--focus--after--BorderColor);\n  --pf-c-nav__link--active--after--BorderColor: var(--pf-c-nav__subnav__link--active--after--BorderColor);\n  --pf-c-nav__link--m-current--after--BorderColor: var(--pf-c-nav__subnav__link--m-current--after--BorderColor);\n  --pf-c-nav__link--hover--after--BorderLeftWidth: var(--pf-c-nav__subnav__link--hover--after--BorderWidth);\n  --pf-c-nav__link--focus--after--BorderLeftWidth: var(--pf-c-nav__subnav__link--focus--after--BorderWidth);\n  --pf-c-nav__link--active--after--BorderLeftWidth: var(--pf-c-nav__subnav__link--active--after--BorderWidth);\n  --pf-c-nav__link--m-current--after--BorderLeftWidth: var(--pf-c-nav__subnav__link--m-current--after--BorderWidth);\n  --pf-c-nav--c-divider--PaddingRight: var(--pf-c-nav__subnav--c-divider--PaddingRight);\n  --pf-c-nav--c-divider--PaddingLeft: var(--pf-c-nav__subnav--c-divider--PaddingLeft);\n  max-height: var(--pf-c-nav__subnav--MaxHeight);\n  padding-bottom: var(--pf-c-nav__subnav--PaddingBottom);\n  padding-left: var(--pf-c-nav__subnav--PaddingLeft);\n  transition: var(--pf-c-nav--Transition);\n  scrollbar-width: none;\n  -ms-overflow-style: -ms-autohiding-scrollbar;\n}\n.pf-c-nav__subnav .pf-c-nav__subnav {\n  --pf-c-nav__link--FontSize: var(--pf-c-nav__subnav__subnav__link--FontSize);\n  --pf-c-nav__link--PaddingLeft: var(--pf-c-nav__subnav__subnav__link--PaddingLeft);\n  --pf-c-nav__subnav--PaddingLeft: var(--pf-c-nav__subnav__subnav--PaddingLeft);\n}\n.pf-c-nav__subnav.pf-m-flyout {\n  width: 100%;\n}\n.pf-c-nav__item.pf-m-expanded .pf-c-nav__subnav {\n  --pf-c-nav__subnav--MaxHeight: var(--pf-c-nav__item--m-expanded__subnav--MaxHeight);\n  overflow-y: auto;\n  opacity: 1;\n}\n.pf-c-nav__subnav::-webkit-scrollbar {\n  display: none;\n}\n\n.pf-c-nav__toggle {\n  flex: none;\n  padding-right: var(--pf-c-nav__toggle--PaddingRight);\n  padding-left: var(--pf-c-nav__toggle--PaddingLeft);\n  margin-left: auto;\n  font-size: var(--pf-c-nav__toggle--FontSize);\n  line-height: 1;\n}\n.pf-c-nav__toggle.pf-m-start {\n  margin-right: var(--pf-c-nav__toggle--m-start--MarginRight);\n  margin-left: calc(var(--pf-c-nav__toggle--PaddingRight) * -1);\n}\n\n.pf-c-nav__toggle-icon {\n  display: inline-block;\n  transition: var(--pf-c-nav__toggle-icon--Transition);\n}\n.pf-c-nav__item.pf-m-expanded .pf-c-nav__toggle-icon {\n  transform: rotate(var(--pf-c-nav__item--m-expanded__toggle-icon--Rotate));\n}\n\n.pf-c-nav__section {\n  --pf-c-nav__item--MarginTop: var(--pf-c-nav__section__item--MarginTop);\n  --pf-c-nav__link--PaddingTop: var(--pf-c-nav__section__link--PaddingTop);\n  --pf-c-nav__link--PaddingRight: var(--pf-c-nav__section__link--PaddingRight);\n  --pf-c-nav__link--PaddingBottom: var(--pf-c-nav__section__link--PaddingBottom);\n  --pf-c-nav__link--PaddingLeft: var(--pf-c-nav__section__link--PaddingLeft);\n  --pf-c-nav__link--FontSize: var(--pf-c-nav__section__link--FontSize);\n  --pf-c-nav__link--before--BorderBottomWidth: var(--pf-c-nav__section__link--before--BorderBottomWidth);\n  --pf-c-nav__link--hover--after--BorderColor: var(--pf-c-nav__section__link--hover--after--BorderColor);\n  --pf-c-nav__link--focus--after--BorderColor: var(--pf-c-nav__section__link--focus--after--BorderColor);\n  --pf-c-nav__link--active--after--BorderColor: var(--pf-c-nav__section__link--active--after--BorderColor);\n  --pf-c-nav__link--m-current--after--BorderColor: var(--pf-c-nav__section__link--m-current--after--BorderColor);\n  --pf-c-nav__link--hover--after--BorderLeftWidth: var(--pf-c-nav__section__link--hover--after--BorderWidth);\n  --pf-c-nav__link--focus--after--BorderLeftWidth: var(--pf-c-nav__section__link--focus--after--BorderWidth);\n  --pf-c-nav__link--active--after--BorderLeftWidth: var(--pf-c-nav__section__link--active--after--BorderWidth);\n  --pf-c-nav__link--m-current--after--BorderLeftWidth: var(--pf-c-nav__section__link--m-current--after--BorderWidth);\n  margin-top: var(--pf-c-nav__section--MarginTop);\n  --pf-c-nav--c-divider--MarginBottom: 0;\n}\n.pf-c-nav__section + .pf-c-nav__section {\n  --pf-c-nav__section--MarginTop: var(--pf-c-nav__section--section--MarginTop);\n}\n.pf-c-nav__section.pf-m-no-title {\n  --pf-c-nav__section--MarginTop: 0;\n}\n\n.pf-c-nav__section-title {\n  padding: var(--pf-c-nav__section-title--PaddingTop) var(--pf-c-nav__section-title--PaddingRight) var(--pf-c-nav__section-title--PaddingBottom) var(--pf-c-nav__section-title--PaddingLeft);\n  font-size: var(--pf-c-nav__section-title--FontSize);\n  color: var(--pf-c-nav__section-title--Color);\n  border-bottom: var(--pf-c-nav__section-title--BorderBottomWidth) solid var(--pf-c-nav__section-title--BorderBottomColor);\n}\n\n.pf-c-nav__scroll-button {\n  flex: none;\n  width: var(--pf-c-nav__scroll-button--Width);\n  color: var(--pf-c-nav__scroll-button--Color);\n  background-color: var(--pf-c-nav__scroll-button--BackgroundColor);\n  border: 0;\n  outline-offset: var(--pf-c-nav__scroll-button--OutlineOffset);\n  opacity: 0;\n  transition: var(--pf-c-nav__scroll-button--Transition);\n}\n.pf-c-nav__scroll-button::before {\n  position: absolute;\n  top: 0;\n  bottom: 0;\n  content: "";\n  border: solid var(--pf-c-nav__scroll-button--before--BorderColor);\n  border-width: 0 var(--pf-c-nav__scroll-button--before--BorderRightWidth) 0 var(--pf-c-nav__scroll-button--before--BorderLeftWidth);\n}\n.pf-c-nav__scroll-button:hover {\n  color: var(--pf-c-nav__scroll-button--hover--Color);\n}\n.pf-c-nav__scroll-button:focus {\n  color: var(--pf-c-nav__scroll-button--focus--Color);\n}\n.pf-c-nav__scroll-button:active {\n  color: var(--pf-c-nav__scroll-button--active--Color);\n}\n.pf-c-nav__scroll-button:disabled {\n  color: var(--pf-c-nav__scroll-button--disabled--Color);\n  border-color: var(--pf-c-nav__scroll-button--disabled--before--BorderColor);\n}\n.pf-c-nav__scroll-button:nth-of-type(1) {\n  --pf-c-nav__scroll-button--before--BorderRightWidth: var(--pf-c-nav__scroll-button--before--BorderWidth);\n  margin-right: calc(var(--pf-c-nav__scroll-button--Width) * -1);\n  transform: translateX(-100%);\n}\n.pf-c-nav__scroll-button:nth-of-type(1)::before {\n  right: 0;\n}\n.pf-c-nav__scroll-button:nth-of-type(2) {\n  --pf-c-nav__scroll-button--before--BorderLeftWidth: var(--pf-c-nav__scroll-button--before--BorderWidth);\n  margin-left: calc(var(--pf-c-nav__scroll-button--Width) * -1);\n  transform: translateX(100%);\n}\n.pf-c-nav__scroll-button:nth-of-type(2)::before {\n  left: 0;\n}\n\n:where(.pf-theme-dark) .pf-c-nav {\n  --pf-c-nav__item--item__link--after--Top: -1px;\n  --pf-c-nav__item--before--BorderColor: var(--pf-global--BorderColor--100);\n  --pf-c-nav__link--hover--BackgroundColor: var(--pf-global--BackgroundColor--300);\n  --pf-c-nav__link--focus--BackgroundColor: var(--pf-global--BackgroundColor--300);\n  --pf-c-nav__link--active--BackgroundColor: var(--pf-global--BackgroundColor--300);\n  --pf-c-nav__link--m-current--BackgroundColor: var(--pf-global--BackgroundColor--300);\n  --pf-c-nav__link--before--BorderColor: var(--pf-global--BorderColor--100);\n  --pf-c-nav--m-tertiary__scroll-button--before--BorderColor: var(--pf-global--BorderColor--100);\n  --pf-c-nav__section-title--Color: var(--pf-global--Color--200);\n  --pf-c-nav__section-title--BorderBottomColor: var(--pf-global--BorderColor--100);\n  --pf-c-nav__scroll-button--before--BorderColor: var(--pf-global--BorderColor--100);\n  --pf-c-nav--c-divider--BackgroundColor: var(--pf-global--BorderColor--100);\n  --pf-c-nav__link--hover--before--BorderBottomWidth: 0;\n  --pf-c-nav__link--focus--before--BorderBottomWidth: 0;\n  --pf-c-nav__link--active--before--BorderBottomWidth: 0;\n  --pf-c-nav__link--m-current--before--BorderBottomWidth: 0;\n}\n:where(.pf-theme-dark) .pf-c-nav__link::before {\n  bottom: 0;\n}\n:where(.pf-theme-dark) .pf-c-nav__link::after {\n  top: var(--pf-c-nav__item--item__link--after--Top);\n}\n:where(.pf-theme-dark) .pf-c-nav__item + .pf-c-nav__item {\n  --pf-c-nav__link--after--Top: var(--pf-c-nav__item--item__link--after--Top);\n}\n:where(.pf-theme-dark) .pf-c-nav__subnav {\n  --pf-c-nav__item--item__link--after--Top: 0;\n}\n:where(.pf-theme-dark) .pf-c-nav__section {\n  --pf-c-nav__item--item__link--after--Top: 0;\n}';

// src/elements/sidebar/SidebarVersion.ts
var SidebarVersion = class extends WithLicenseSummary(WithVersion(AKElement)) {
  static get styles() {
    return [
      patternfly_base_default,
      nav_default,
      avatar_default,
      button_default,
      i`
                :host {
                    display: flex;
                    width: 100%;
                    flex-direction: column;
                    justify-content: space-between;
                    padding: 1rem !important;
                }
                p {
                    text-align: center;
                    width: 100%;
                    font-size: var(--pf-global--FontSize--xs);
                }
            `
    ];
  }
  render() {
    if (!this.version || !this.licenseSummary) {
      return D;
    }
    let product = globalAK().brand.brandingTitle || DefaultBrand.brandingTitle;
    if (this.licenseSummary.status != LicenseSummaryStatusEnum.Unlicensed) {
      product += ` ${msg("Enterprise")}`;
    }
    return ke`<button
            class="pf-c-button pf-m-plain"
            @click=${() => {
      const int = rootInterface();
      int?.aboutModal?.onClick();
    }}
        >
            <p class="pf-c-title">${product}</p>
            <p class="pf-c-title">${msg(str`Version ${this.version?.versionCurrent || ""}`)}</p>
        </button>`;
  }
};
SidebarVersion = __decorateClass([
  t("ak-sidebar-version")
], SidebarVersion);

// src/elements/sidebar/Sidebar.ts
var Sidebar = class extends AKElement {
  static get styles() {
    return [
      patternfly_base_default,
      page_default,
      nav_default,
      i`
                :host {
                    z-index: 100;
                }
                .pf-c-nav__link.pf-m-current::after,
                .pf-c-nav__link.pf-m-current:hover::after,
                .pf-c-nav__item.pf-m-current:not(.pf-m-expanded) .pf-c-nav__link::after {
                    --pf-c-nav__link--m-current--after--BorderColor: #fd4b2d;
                }
                :host([theme="light"]) {
                    border-right-color: transparent !important;
                }

                .pf-c-nav__section + .pf-c-nav__section {
                    --pf-c-nav__section--section--MarginTop: var(--pf-global--spacer--sm);
                }
                .pf-c-nav__list .sidebar-brand {
                    max-height: 82px;
                    margin-bottom: -0.5rem;
                }
                nav {
                    display: flex;
                    flex-direction: column;
                    height: 100%;
                    overflow-y: hidden;
                }
                .pf-c-nav__list {
                    flex-grow: 1;
                    overflow-y: auto;
                }

                .pf-c-nav__link {
                    --pf-c-nav__link--PaddingTop: 0.5rem;
                    --pf-c-nav__link--PaddingRight: 0.5rem;
                    --pf-c-nav__link--PaddingBottom: 0.5rem;
                }
                .pf-c-nav__section-title {
                    font-size: 12px;
                }
                .pf-c-nav__item {
                    --pf-c-nav__item--MarginTop: 0px;
                }
            `
    ];
  }
  render() {
    return ke`<nav
            class="pf-c-nav ${this.activeTheme === UiThemeEnum.Light ? "pf-m-light" : ""}"
            aria-label=${msg("Global")}
        >
            <ak-sidebar-brand></ak-sidebar-brand>
            <ul class="pf-c-nav__list">
                <slot></slot>
            </ul>
            <ak-sidebar-version></ak-sidebar-version>
        </nav>`;
  }
};
Sidebar = __decorateClass([
  t("ak-sidebar")
], Sidebar);

// src/elements/sidebar/SidebarItem.ts
var SidebarItem = class extends AKElement {
  constructor() {
    super(...arguments);
    this.activeMatchers = [];
    this.expanded = false;
    this.isActive = false;
  }
  static get styles() {
    return [
      patternfly_base_default,
      page_default,
      nav_default,
      i`
                :host {
                    z-index: 100;
                    box-shadow: none !important;
                }
                :host([highlight]) .pf-c-nav__item {
                    background-color: var(--ak-accent);
                    margin: 16px;
                }
                :host([highlight]) .pf-c-nav__item .pf-c-nav__link {
                    padding-left: 0.5rem;
                }
                .pf-c-nav__link.pf-m-current::after,
                .pf-c-nav__link.pf-m-current:hover::after,
                .pf-c-nav__item.pf-m-current:not(.pf-m-expanded) .pf-c-nav__link::after {
                    --pf-c-nav__link--m-current--after--BorderColor: #fd4b2d;
                }

                .pf-c-nav__section + .pf-c-nav__section {
                    --pf-c-nav__section--section--MarginTop: var(--pf-global--spacer--sm);
                }
                .pf-c-nav__list .sidebar-brand {
                    max-height: 82px;
                    margin-bottom: -0.5rem;
                }
                nav {
                    display: flex;
                    flex-direction: column;
                    max-height: 100vh;
                    height: 100%;
                    overflow-y: hidden;
                }
                .pf-c-nav__list {
                    flex-grow: 1;
                    overflow-y: auto;
                }

                .pf-c-nav__link {
                    --pf-c-nav__link--PaddingTop: 0.5rem;
                    --pf-c-nav__link--PaddingRight: 0.5rem;
                    --pf-c-nav__link--PaddingBottom: 0.5rem;
                }
                .pf-c-nav__section-title {
                    font-size: 12px;
                }
                .pf-c-nav__item {
                    --pf-c-nav__item--MarginTop: 0px;
                }
            `
    ];
  }
  get childItems() {
    const children = Array.from(this.querySelectorAll("ak-sidebar-item") || []);
    children.forEach((child) => child.parent = this);
    return children;
  }
  set activeWhen(regexp) {
    regexp.forEach((r3) => {
      this.activeMatchers.push(new RegExp(r3));
    });
  }
  firstUpdated() {
    this.onHashChange();
    window.addEventListener("hashchange", () => this.onHashChange());
  }
  onHashChange() {
    const activePath = window.location.hash.slice(1, Infinity).split(ROUTE_SEPARATOR)[0];
    this.childItems.forEach((item) => {
      this.expandParentRecursive(activePath, item);
    });
    this.isActive = this.matchesPath(activePath);
  }
  matchesPath(path) {
    if (!this.path) {
      return false;
    }
    const ourPath = this.path.split(";")[0];
    const pathIsWholePath = new RegExp(`^${ourPath}$`).test(path);
    const pathIsAnActivePath = this.activeMatchers.some((v2) => v2.test(path));
    return pathIsWholePath || pathIsAnActivePath;
  }
  expandParentRecursive(activePath, item) {
    if (item.matchesPath(activePath) && item.parent) {
      item.parent.expanded = true;
      this.requestUpdate();
    }
    item.childItems.forEach((i4) => this.expandParentRecursive(activePath, i4));
  }
  render() {
    return this.renderInner();
  }
  renderWithChildren() {
    return ke`<li
            class="pf-c-nav__item ${this.expanded ? "pf-m-expandable pf-m-expanded" : ""}"
        >
            <button
                class="pf-c-nav__link"
                aria-expanded="true"
                @click=${() => {
      this.expanded = !this.expanded;
    }}
            >
                <slot name="label"></slot>
                <span class="pf-c-nav__toggle">
                    <span class="pf-c-nav__toggle-icon">
                        <i class="fas fa-angle-right" aria-hidden="true"></i>
                    </span>
                </span>
            </button>
            <section class="pf-c-nav__subnav" ?hidden=${!this.expanded}>
                <ul class="pf-c-nav__list">
                    <slot></slot>
                </ul>
            </section>
        </li>`;
  }
  renderWithPathAndChildren() {
    return ke`<li
            class="pf-c-nav__item ${this.expanded ? "pf-m-expandable pf-m-expanded" : ""}"
        >
            <slot name="label"></slot>
            <button
                class="pf-c-nav__link"
                aria-expanded="true"
                @click=${() => {
      this.expanded = !this.expanded;
    }}
            >
                <span class="pf-c-nav__toggle">
                    <span class="pf-c-nav__toggle-icon">
                        <i class="fas fa-angle-right" aria-hidden="true"></i>
                    </span>
                </span>
            </button>
            <section class="pf-c-nav__subnav" ?hidden=${!this.expanded}>
                <ul class="pf-c-nav__list">
                    <slot></slot>
                </ul>
            </section>
        </li>`;
  }
  renderWithPath() {
    return ke`
            <a
                href="${this.isAbsoluteLink ? "" : "#"}${this.path}"
                class="pf-c-nav__link ${this.isActive ? "pf-m-current" : ""}"
            >
                <slot name="label"></slot>
            </a>
        `;
  }
  renderWithLabel() {
    return ke`
            <span class="pf-c-nav__link">
                <slot name="label"></slot>
            </span>
        `;
  }
  renderInner() {
    if (this.childItems.length > 0) {
      return this.path ? this.renderWithPathAndChildren() : this.renderWithChildren();
    }
    return ke`<li class="pf-c-nav__item">
            ${this.path ? this.renderWithPath() : this.renderWithLabel()}
        </li>`;
  }
};
__decorateClass([
  n()
], SidebarItem.prototype, "path", 2);
__decorateClass([
  n({ type: Boolean })
], SidebarItem.prototype, "expanded", 2);
__decorateClass([
  n({ type: Boolean })
], SidebarItem.prototype, "isActive", 2);
__decorateClass([
  n({ type: Boolean })
], SidebarItem.prototype, "isAbsoluteLink", 2);
__decorateClass([
  n({ type: Boolean })
], SidebarItem.prototype, "highlight", 2);
__decorateClass([
  n({ attribute: false })
], SidebarItem.prototype, "activeWhen", 1);
SidebarItem = __decorateClass([
  t("ak-sidebar-item")
], SidebarItem);

// node_modules/@patternfly/patternfly/base/patternfly-fa-icons.css
var patternfly_fa_icons_default = '* .fa,\n* .fas,\n* .far,\n* .fal,\n* .fab {\n  -moz-osx-font-smoothing: grayscale;\n  -webkit-font-smoothing: antialiased;\n  display: inline-block;\n  font-style: normal;\n  font-variant: normal;\n  text-rendering: auto;\n  line-height: 1;\n}\n* .fa-lg {\n  font-size: 1.3333333333em;\n  line-height: 0.75em;\n  vertical-align: -0.0667em;\n}\n* .fa-xs {\n  font-size: 0.75em;\n}\n* .fa-sm {\n  font-size: 0.875em;\n}\n* .fa-1x {\n  font-size: 1em;\n}\n* .fa-2x {\n  font-size: 2em;\n}\n* .fa-3x {\n  font-size: 3em;\n}\n* .fa-4x {\n  font-size: 4em;\n}\n* .fa-5x {\n  font-size: 5em;\n}\n* .fa-6x {\n  font-size: 6em;\n}\n* .fa-7x {\n  font-size: 7em;\n}\n* .fa-8x {\n  font-size: 8em;\n}\n* .fa-9x {\n  font-size: 9em;\n}\n* .fa-10x {\n  font-size: 10em;\n}\n* .fa-fw {\n  text-align: center;\n  width: 1.25em;\n}\n* .fa-ul {\n  list-style-type: none;\n  margin-left: 2.5em;\n  padding-left: 0;\n}\n* .fa-ul > li {\n  position: relative;\n}\n* .fa-li {\n  left: -2em;\n  position: absolute;\n  text-align: center;\n  width: 2em;\n  line-height: inherit;\n}\n* .fa-border {\n  border: solid 0.08em #eee;\n  border-radius: 0.1em;\n  padding: 0.2em 0.25em 0.15em;\n}\n* .fa-pull-left {\n  float: left;\n}\n* .fa-pull-right {\n  float: right;\n}\n* .fa.fa-pull-left,\n* .fas.fa-pull-left,\n* .far.fa-pull-left,\n* .fal.fa-pull-left,\n* .fab.fa-pull-left {\n  margin-right: 0.3em;\n}\n* .fa.fa-pull-right,\n* .fas.fa-pull-right,\n* .far.fa-pull-right,\n* .fal.fa-pull-right,\n* .fab.fa-pull-right {\n  margin-left: 0.3em;\n}\n* .fa-spin {\n  animation: fa-spin 2s infinite linear;\n}\n* .fa-pulse {\n  animation: fa-spin 1s infinite steps(8);\n}\n@keyframes fa-spin {\n  0% {\n    transform: rotate(0deg);\n  }\n  100% {\n    transform: rotate(360deg);\n  }\n}\n* .fa-rotate-90 {\n  -ms-filter: "progid:DXImageTransform.Microsoft.BasicImage(rotation=1)";\n  transform: rotate(90deg);\n}\n* .fa-rotate-180 {\n  -ms-filter: "progid:DXImageTransform.Microsoft.BasicImage(rotation=2)";\n  transform: rotate(180deg);\n}\n* .fa-rotate-270 {\n  -ms-filter: "progid:DXImageTransform.Microsoft.BasicImage(rotation=3)";\n  transform: rotate(270deg);\n}\n* .fa-flip-horizontal {\n  -ms-filter: "progid:DXImageTransform.Microsoft.BasicImage(rotation=0, mirror=1)";\n  transform: scale(-1, 1);\n}\n* .fa-flip-vertical {\n  -ms-filter: "progid:DXImageTransform.Microsoft.BasicImage(rotation=2, mirror=1)";\n  transform: scale(1, -1);\n}\n* .fa-flip-horizontal.fa-flip-vertical {\n  -ms-filter: "progid:DXImageTransform.Microsoft.BasicImage(rotation=2, mirror=1)";\n  transform: scale(-1, -1);\n}\n* :root .fa-rotate-90,\n* :root .fa-rotate-180,\n* :root .fa-rotate-270,\n* :root .fa-flip-horizontal,\n* :root .fa-flip-vertical {\n  filter: none;\n}\n* .fa-stack {\n  display: inline-block;\n  height: 2em;\n  line-height: 2em;\n  position: relative;\n  vertical-align: middle;\n  width: 2.5em;\n}\n* .fa-stack-1x,\n* .fa-stack-2x {\n  left: 0;\n  position: absolute;\n  text-align: center;\n  width: 100%;\n}\n* .fa-stack-1x {\n  line-height: inherit;\n}\n* .fa-stack-2x {\n  font-size: 2em;\n}\n* .fa-inverse {\n  color: #fff;\n}\n* .fa-500px:before {\n  content: "\\f26e";\n}\n* .fa-accessible-icon:before {\n  content: "\\f368";\n}\n* .fa-accusoft:before {\n  content: "\\f369";\n}\n* .fa-acquisitions-incorporated:before {\n  content: "\\f6af";\n}\n* .fa-ad:before {\n  content: "\\f641";\n}\n* .fa-address-book:before {\n  content: "\\f2b9";\n}\n* .fa-address-card:before {\n  content: "\\f2bb";\n}\n* .fa-adjust:before {\n  content: "\\f042";\n}\n* .fa-adn:before {\n  content: "\\f170";\n}\n* .fa-adobe:before {\n  content: "\\f778";\n}\n* .fa-adversal:before {\n  content: "\\f36a";\n}\n* .fa-affiliatetheme:before {\n  content: "\\f36b";\n}\n* .fa-air-freshener:before {\n  content: "\\f5d0";\n}\n* .fa-algolia:before {\n  content: "\\f36c";\n}\n* .fa-align-center:before {\n  content: "\\f037";\n}\n* .fa-align-justify:before {\n  content: "\\f039";\n}\n* .fa-align-left:before {\n  content: "\\f036";\n}\n* .fa-align-right:before {\n  content: "\\f038";\n}\n* .fa-alipay:before {\n  content: "\\f642";\n}\n* .fa-allergies:before {\n  content: "\\f461";\n}\n* .fa-amazon:before {\n  content: "\\f270";\n}\n* .fa-amazon-pay:before {\n  content: "\\f42c";\n}\n* .fa-ambulance:before {\n  content: "\\f0f9";\n}\n* .fa-american-sign-language-interpreting:before {\n  content: "\\f2a3";\n}\n* .fa-amilia:before {\n  content: "\\f36d";\n}\n* .fa-anchor:before {\n  content: "\\f13d";\n}\n* .fa-android:before {\n  content: "\\f17b";\n}\n* .fa-angellist:before {\n  content: "\\f209";\n}\n* .fa-angle-double-down:before {\n  content: "\\f103";\n}\n* .fa-angle-double-left:before {\n  content: "\\f100";\n}\n* .fa-angle-double-right:before {\n  content: "\\f101";\n}\n* .fa-angle-double-up:before {\n  content: "\\f102";\n}\n* .fa-angle-down:before {\n  content: "\\f107";\n}\n* .fa-angle-left:before {\n  content: "\\f104";\n}\n* .fa-angle-right:before {\n  content: "\\f105";\n}\n* .fa-angle-up:before {\n  content: "\\f106";\n}\n* .fa-angry:before {\n  content: "\\f556";\n}\n* .fa-angrycreative:before {\n  content: "\\f36e";\n}\n* .fa-angular:before {\n  content: "\\f420";\n}\n* .fa-ankh:before {\n  content: "\\f644";\n}\n* .fa-app-store:before {\n  content: "\\f36f";\n}\n* .fa-app-store-ios:before {\n  content: "\\f370";\n}\n* .fa-apper:before {\n  content: "\\f371";\n}\n* .fa-apple:before {\n  content: "\\f179";\n}\n* .fa-apple-alt:before {\n  content: "\\f5d1";\n}\n* .fa-apple-pay:before {\n  content: "\\f415";\n}\n* .fa-archive:before {\n  content: "\\f187";\n}\n* .fa-archway:before {\n  content: "\\f557";\n}\n* .fa-arrow-alt-circle-down:before {\n  content: "\\f358";\n}\n* .fa-arrow-alt-circle-left:before {\n  content: "\\f359";\n}\n* .fa-arrow-alt-circle-right:before {\n  content: "\\f35a";\n}\n* .fa-arrow-alt-circle-up:before {\n  content: "\\f35b";\n}\n* .fa-arrow-circle-down:before {\n  content: "\\f0ab";\n}\n* .fa-arrow-circle-left:before {\n  content: "\\f0a8";\n}\n* .fa-arrow-circle-right:before {\n  content: "\\f0a9";\n}\n* .fa-arrow-circle-up:before {\n  content: "\\f0aa";\n}\n* .fa-arrow-down:before {\n  content: "\\f063";\n}\n* .fa-arrow-left:before {\n  content: "\\f060";\n}\n* .fa-arrow-right:before {\n  content: "\\f061";\n}\n* .fa-arrow-up:before {\n  content: "\\f062";\n}\n* .fa-arrows-alt:before {\n  content: "\\f0b2";\n}\n* .fa-arrows-alt-h:before {\n  content: "\\f337";\n}\n* .fa-arrows-alt-v:before {\n  content: "\\f338";\n}\n* .fa-artstation:before {\n  content: "\\f77a";\n}\n* .fa-assistive-listening-systems:before {\n  content: "\\f2a2";\n}\n* .fa-asterisk:before {\n  content: "\\f069";\n}\n* .fa-asymmetrik:before {\n  content: "\\f372";\n}\n* .fa-at:before {\n  content: "\\f1fa";\n}\n* .fa-atlas:before {\n  content: "\\f558";\n}\n* .fa-atlassian:before {\n  content: "\\f77b";\n}\n* .fa-atom:before {\n  content: "\\f5d2";\n}\n* .fa-audible:before {\n  content: "\\f373";\n}\n* .fa-audio-description:before {\n  content: "\\f29e";\n}\n* .fa-autoprefixer:before {\n  content: "\\f41c";\n}\n* .fa-avianex:before {\n  content: "\\f374";\n}\n* .fa-aviato:before {\n  content: "\\f421";\n}\n* .fa-award:before {\n  content: "\\f559";\n}\n* .fa-aws:before {\n  content: "\\f375";\n}\n* .fa-baby:before {\n  content: "\\f77c";\n}\n* .fa-baby-carriage:before {\n  content: "\\f77d";\n}\n* .fa-backspace:before {\n  content: "\\f55a";\n}\n* .fa-backward:before {\n  content: "\\f04a";\n}\n* .fa-balance-scale:before {\n  content: "\\f24e";\n}\n* .fa-ban:before {\n  content: "\\f05e";\n}\n* .fa-band-aid:before {\n  content: "\\f462";\n}\n* .fa-bandcamp:before {\n  content: "\\f2d5";\n}\n* .fa-barcode:before {\n  content: "\\f02a";\n}\n* .fa-bars:before {\n  content: "\\f0c9";\n}\n* .fa-baseball-ball:before {\n  content: "\\f433";\n}\n* .fa-basketball-ball:before {\n  content: "\\f434";\n}\n* .fa-bath:before {\n  content: "\\f2cd";\n}\n* .fa-battery-empty:before {\n  content: "\\f244";\n}\n* .fa-battery-full:before {\n  content: "\\f240";\n}\n* .fa-battery-half:before {\n  content: "\\f242";\n}\n* .fa-battery-quarter:before {\n  content: "\\f243";\n}\n* .fa-battery-three-quarters:before {\n  content: "\\f241";\n}\n* .fa-bed:before {\n  content: "\\f236";\n}\n* .fa-beer:before {\n  content: "\\f0fc";\n}\n* .fa-behance:before {\n  content: "\\f1b4";\n}\n* .fa-behance-square:before {\n  content: "\\f1b5";\n}\n* .fa-bell:before {\n  content: "\\f0f3";\n}\n* .fa-bell-slash:before {\n  content: "\\f1f6";\n}\n* .fa-bezier-curve:before {\n  content: "\\f55b";\n}\n* .fa-bible:before {\n  content: "\\f647";\n}\n* .fa-bicycle:before {\n  content: "\\f206";\n}\n* .fa-bimobject:before {\n  content: "\\f378";\n}\n* .fa-binoculars:before {\n  content: "\\f1e5";\n}\n* .fa-biohazard:before {\n  content: "\\f780";\n}\n* .fa-birthday-cake:before {\n  content: "\\f1fd";\n}\n* .fa-bitbucket:before {\n  content: "\\f171";\n}\n* .fa-bitcoin:before {\n  content: "\\f379";\n}\n* .fa-bity:before {\n  content: "\\f37a";\n}\n* .fa-black-tie:before {\n  content: "\\f27e";\n}\n* .fa-blackberry:before {\n  content: "\\f37b";\n}\n* .fa-blender:before {\n  content: "\\f517";\n}\n* .fa-blender-phone:before {\n  content: "\\f6b6";\n}\n* .fa-blind:before {\n  content: "\\f29d";\n}\n* .fa-blog:before {\n  content: "\\f781";\n}\n* .fa-blogger:before {\n  content: "\\f37c";\n}\n* .fa-blogger-b:before {\n  content: "\\f37d";\n}\n* .fa-bluetooth:before {\n  content: "\\f293";\n}\n* .fa-bluetooth-b:before {\n  content: "\\f294";\n}\n* .fa-bold:before {\n  content: "\\f032";\n}\n* .fa-bolt:before {\n  content: "\\f0e7";\n}\n* .fa-bomb:before {\n  content: "\\f1e2";\n}\n* .fa-bone:before {\n  content: "\\f5d7";\n}\n* .fa-bong:before {\n  content: "\\f55c";\n}\n* .fa-book:before {\n  content: "\\f02d";\n}\n* .fa-book-dead:before {\n  content: "\\f6b7";\n}\n* .fa-book-open:before {\n  content: "\\f518";\n}\n* .fa-book-reader:before {\n  content: "\\f5da";\n}\n* .fa-bookmark:before {\n  content: "\\f02e";\n}\n* .fa-bowling-ball:before {\n  content: "\\f436";\n}\n* .fa-box:before {\n  content: "\\f466";\n}\n* .fa-box-open:before {\n  content: "\\f49e";\n}\n* .fa-boxes:before {\n  content: "\\f468";\n}\n* .fa-braille:before {\n  content: "\\f2a1";\n}\n* .fa-brain:before {\n  content: "\\f5dc";\n}\n* .fa-briefcase:before {\n  content: "\\f0b1";\n}\n* .fa-briefcase-medical:before {\n  content: "\\f469";\n}\n* .fa-broadcast-tower:before {\n  content: "\\f519";\n}\n* .fa-broom:before {\n  content: "\\f51a";\n}\n* .fa-brush:before {\n  content: "\\f55d";\n}\n* .fa-btc:before {\n  content: "\\f15a";\n}\n* .fa-bug:before {\n  content: "\\f188";\n}\n* .fa-building:before {\n  content: "\\f1ad";\n}\n* .fa-bullhorn:before {\n  content: "\\f0a1";\n}\n* .fa-bullseye:before {\n  content: "\\f140";\n}\n* .fa-burn:before {\n  content: "\\f46a";\n}\n* .fa-buromobelexperte:before {\n  content: "\\f37f";\n}\n* .fa-bus:before {\n  content: "\\f207";\n}\n* .fa-bus-alt:before {\n  content: "\\f55e";\n}\n* .fa-business-time:before {\n  content: "\\f64a";\n}\n* .fa-buysellads:before {\n  content: "\\f20d";\n}\n* .fa-calculator:before {\n  content: "\\f1ec";\n}\n* .fa-calendar:before {\n  content: "\\f133";\n}\n* .fa-calendar-alt:before {\n  content: "\\f073";\n}\n* .fa-calendar-check:before {\n  content: "\\f274";\n}\n* .fa-calendar-day:before {\n  content: "\\f783";\n}\n* .fa-calendar-minus:before {\n  content: "\\f272";\n}\n* .fa-calendar-plus:before {\n  content: "\\f271";\n}\n* .fa-calendar-times:before {\n  content: "\\f273";\n}\n* .fa-calendar-week:before {\n  content: "\\f784";\n}\n* .fa-camera:before {\n  content: "\\f030";\n}\n* .fa-camera-retro:before {\n  content: "\\f083";\n}\n* .fa-campground:before {\n  content: "\\f6bb";\n}\n* .fa-canadian-maple-leaf:before {\n  content: "\\f785";\n}\n* .fa-candy-cane:before {\n  content: "\\f786";\n}\n* .fa-cannabis:before {\n  content: "\\f55f";\n}\n* .fa-capsules:before {\n  content: "\\f46b";\n}\n* .fa-car:before {\n  content: "\\f1b9";\n}\n* .fa-car-alt:before {\n  content: "\\f5de";\n}\n* .fa-car-battery:before {\n  content: "\\f5df";\n}\n* .fa-car-crash:before {\n  content: "\\f5e1";\n}\n* .fa-car-side:before {\n  content: "\\f5e4";\n}\n* .fa-caret-down:before {\n  content: "\\f0d7";\n}\n* .fa-caret-left:before {\n  content: "\\f0d9";\n}\n* .fa-caret-right:before {\n  content: "\\f0da";\n}\n* .fa-caret-square-down:before {\n  content: "\\f150";\n}\n* .fa-caret-square-left:before {\n  content: "\\f191";\n}\n* .fa-caret-square-right:before {\n  content: "\\f152";\n}\n* .fa-caret-square-up:before {\n  content: "\\f151";\n}\n* .fa-caret-up:before {\n  content: "\\f0d8";\n}\n* .fa-carrot:before {\n  content: "\\f787";\n}\n* .fa-cart-arrow-down:before {\n  content: "\\f218";\n}\n* .fa-cart-plus:before {\n  content: "\\f217";\n}\n* .fa-cash-register:before {\n  content: "\\f788";\n}\n* .fa-cat:before {\n  content: "\\f6be";\n}\n* .fa-cc-amazon-pay:before {\n  content: "\\f42d";\n}\n* .fa-cc-amex:before {\n  content: "\\f1f3";\n}\n* .fa-cc-apple-pay:before {\n  content: "\\f416";\n}\n* .fa-cc-diners-club:before {\n  content: "\\f24c";\n}\n* .fa-cc-discover:before {\n  content: "\\f1f2";\n}\n* .fa-cc-jcb:before {\n  content: "\\f24b";\n}\n* .fa-cc-mastercard:before {\n  content: "\\f1f1";\n}\n* .fa-cc-paypal:before {\n  content: "\\f1f4";\n}\n* .fa-cc-stripe:before {\n  content: "\\f1f5";\n}\n* .fa-cc-visa:before {\n  content: "\\f1f0";\n}\n* .fa-centercode:before {\n  content: "\\f380";\n}\n* .fa-centos:before {\n  content: "\\f789";\n}\n* .fa-certificate:before {\n  content: "\\f0a3";\n}\n* .fa-chair:before {\n  content: "\\f6c0";\n}\n* .fa-chalkboard:before {\n  content: "\\f51b";\n}\n* .fa-chalkboard-teacher:before {\n  content: "\\f51c";\n}\n* .fa-charging-station:before {\n  content: "\\f5e7";\n}\n* .fa-chart-area:before {\n  content: "\\f1fe";\n}\n* .fa-chart-bar:before {\n  content: "\\f080";\n}\n* .fa-chart-line:before {\n  content: "\\f201";\n}\n* .fa-chart-pie:before {\n  content: "\\f200";\n}\n* .fa-check:before {\n  content: "\\f00c";\n}\n* .fa-check-circle:before {\n  content: "\\f058";\n}\n* .fa-check-double:before {\n  content: "\\f560";\n}\n* .fa-check-square:before {\n  content: "\\f14a";\n}\n* .fa-chess:before {\n  content: "\\f439";\n}\n* .fa-chess-bishop:before {\n  content: "\\f43a";\n}\n* .fa-chess-board:before {\n  content: "\\f43c";\n}\n* .fa-chess-king:before {\n  content: "\\f43f";\n}\n* .fa-chess-knight:before {\n  content: "\\f441";\n}\n* .fa-chess-pawn:before {\n  content: "\\f443";\n}\n* .fa-chess-queen:before {\n  content: "\\f445";\n}\n* .fa-chess-rook:before {\n  content: "\\f447";\n}\n* .fa-chevron-circle-down:before {\n  content: "\\f13a";\n}\n* .fa-chevron-circle-left:before {\n  content: "\\f137";\n}\n* .fa-chevron-circle-right:before {\n  content: "\\f138";\n}\n* .fa-chevron-circle-up:before {\n  content: "\\f139";\n}\n* .fa-chevron-down:before {\n  content: "\\f078";\n}\n* .fa-chevron-left:before {\n  content: "\\f053";\n}\n* .fa-chevron-right:before {\n  content: "\\f054";\n}\n* .fa-chevron-up:before {\n  content: "\\f077";\n}\n* .fa-child:before {\n  content: "\\f1ae";\n}\n* .fa-chrome:before {\n  content: "\\f268";\n}\n* .fa-church:before {\n  content: "\\f51d";\n}\n* .fa-circle:before {\n  content: "\\f111";\n}\n* .fa-circle-notch:before {\n  content: "\\f1ce";\n}\n* .fa-city:before {\n  content: "\\f64f";\n}\n* .fa-clipboard:before {\n  content: "\\f328";\n}\n* .fa-clipboard-check:before {\n  content: "\\f46c";\n}\n* .fa-clipboard-list:before {\n  content: "\\f46d";\n}\n* .fa-clock:before {\n  content: "\\f017";\n}\n* .fa-clone:before {\n  content: "\\f24d";\n}\n* .fa-closed-captioning:before {\n  content: "\\f20a";\n}\n* .fa-cloud:before {\n  content: "\\f0c2";\n}\n* .fa-cloud-download-alt:before {\n  content: "\\f381";\n}\n* .fa-cloud-meatball:before {\n  content: "\\f73b";\n}\n* .fa-cloud-moon:before {\n  content: "\\f6c3";\n}\n* .fa-cloud-moon-rain:before {\n  content: "\\f73c";\n}\n* .fa-cloud-rain:before {\n  content: "\\f73d";\n}\n* .fa-cloud-showers-heavy:before {\n  content: "\\f740";\n}\n* .fa-cloud-sun:before {\n  content: "\\f6c4";\n}\n* .fa-cloud-sun-rain:before {\n  content: "\\f743";\n}\n* .fa-cloud-upload-alt:before {\n  content: "\\f382";\n}\n* .fa-cloudscale:before {\n  content: "\\f383";\n}\n* .fa-cloudsmith:before {\n  content: "\\f384";\n}\n* .fa-cloudversify:before {\n  content: "\\f385";\n}\n* .fa-cocktail:before {\n  content: "\\f561";\n}\n* .fa-code:before {\n  content: "\\f121";\n}\n* .fa-code-branch:before {\n  content: "\\f126";\n}\n* .fa-codepen:before {\n  content: "\\f1cb";\n}\n* .fa-codiepie:before {\n  content: "\\f284";\n}\n* .fa-coffee:before {\n  content: "\\f0f4";\n}\n* .fa-cog:before {\n  content: "\\f013";\n}\n* .fa-cogs:before {\n  content: "\\f085";\n}\n* .fa-coins:before {\n  content: "\\f51e";\n}\n* .fa-columns:before {\n  content: "\\f0db";\n}\n* .fa-comment:before {\n  content: "\\f075";\n}\n* .fa-comment-alt:before {\n  content: "\\f27a";\n}\n* .fa-comment-dollar:before {\n  content: "\\f651";\n}\n* .fa-comment-dots:before {\n  content: "\\f4ad";\n}\n* .fa-comment-slash:before {\n  content: "\\f4b3";\n}\n* .fa-comments:before {\n  content: "\\f086";\n}\n* .fa-comments-dollar:before {\n  content: "\\f653";\n}\n* .fa-compact-disc:before {\n  content: "\\f51f";\n}\n* .fa-compass:before {\n  content: "\\f14e";\n}\n* .fa-compress:before {\n  content: "\\f066";\n}\n* .fa-compress-arrows-alt:before {\n  content: "\\f78c";\n}\n* .fa-concierge-bell:before {\n  content: "\\f562";\n}\n* .fa-confluence:before {\n  content: "\\f78d";\n}\n* .fa-connectdevelop:before {\n  content: "\\f20e";\n}\n* .fa-contao:before {\n  content: "\\f26d";\n}\n* .fa-cookie:before {\n  content: "\\f563";\n}\n* .fa-cookie-bite:before {\n  content: "\\f564";\n}\n* .fa-copy:before {\n  content: "\\f0c5";\n}\n* .fa-copyright:before {\n  content: "\\f1f9";\n}\n* .fa-couch:before {\n  content: "\\f4b8";\n}\n* .fa-cpanel:before {\n  content: "\\f388";\n}\n* .fa-creative-commons:before {\n  content: "\\f25e";\n}\n* .fa-creative-commons-by:before {\n  content: "\\f4e7";\n}\n* .fa-creative-commons-nc:before {\n  content: "\\f4e8";\n}\n* .fa-creative-commons-nc-eu:before {\n  content: "\\f4e9";\n}\n* .fa-creative-commons-nc-jp:before {\n  content: "\\f4ea";\n}\n* .fa-creative-commons-nd:before {\n  content: "\\f4eb";\n}\n* .fa-creative-commons-pd:before {\n  content: "\\f4ec";\n}\n* .fa-creative-commons-pd-alt:before {\n  content: "\\f4ed";\n}\n* .fa-creative-commons-remix:before {\n  content: "\\f4ee";\n}\n* .fa-creative-commons-sa:before {\n  content: "\\f4ef";\n}\n* .fa-creative-commons-sampling:before {\n  content: "\\f4f0";\n}\n* .fa-creative-commons-sampling-plus:before {\n  content: "\\f4f1";\n}\n* .fa-creative-commons-share:before {\n  content: "\\f4f2";\n}\n* .fa-creative-commons-zero:before {\n  content: "\\f4f3";\n}\n* .fa-credit-card:before {\n  content: "\\f09d";\n}\n* .fa-critical-role:before {\n  content: "\\f6c9";\n}\n* .fa-crop:before {\n  content: "\\f125";\n}\n* .fa-crop-alt:before {\n  content: "\\f565";\n}\n* .fa-cross:before {\n  content: "\\f654";\n}\n* .fa-crosshairs:before {\n  content: "\\f05b";\n}\n* .fa-crow:before {\n  content: "\\f520";\n}\n* .fa-crown:before {\n  content: "\\f521";\n}\n* .fa-css3:before {\n  content: "\\f13c";\n}\n* .fa-css3-alt:before {\n  content: "\\f38b";\n}\n* .fa-cube:before {\n  content: "\\f1b2";\n}\n* .fa-cubes:before {\n  content: "\\f1b3";\n}\n* .fa-cut:before {\n  content: "\\f0c4";\n}\n* .fa-cuttlefish:before {\n  content: "\\f38c";\n}\n* .fa-d-and-d:before {\n  content: "\\f38d";\n}\n* .fa-d-and-d-beyond:before {\n  content: "\\f6ca";\n}\n* .fa-dashcube:before {\n  content: "\\f210";\n}\n* .fa-database:before {\n  content: "\\f1c0";\n}\n* .fa-deaf:before {\n  content: "\\f2a4";\n}\n* .fa-delicious:before {\n  content: "\\f1a5";\n}\n* .fa-democrat:before {\n  content: "\\f747";\n}\n* .fa-deploydog:before {\n  content: "\\f38e";\n}\n* .fa-deskpro:before {\n  content: "\\f38f";\n}\n* .fa-desktop:before {\n  content: "\\f108";\n}\n* .fa-dev:before {\n  content: "\\f6cc";\n}\n* .fa-deviantart:before {\n  content: "\\f1bd";\n}\n* .fa-dharmachakra:before {\n  content: "\\f655";\n}\n* .fa-dhl:before {\n  content: "\\f790";\n}\n* .fa-diagnoses:before {\n  content: "\\f470";\n}\n* .fa-diaspora:before {\n  content: "\\f791";\n}\n* .fa-dice:before {\n  content: "\\f522";\n}\n* .fa-dice-d20:before {\n  content: "\\f6cf";\n}\n* .fa-dice-d6:before {\n  content: "\\f6d1";\n}\n* .fa-dice-five:before {\n  content: "\\f523";\n}\n* .fa-dice-four:before {\n  content: "\\f524";\n}\n* .fa-dice-one:before {\n  content: "\\f525";\n}\n* .fa-dice-six:before {\n  content: "\\f526";\n}\n* .fa-dice-three:before {\n  content: "\\f527";\n}\n* .fa-dice-two:before {\n  content: "\\f528";\n}\n* .fa-digg:before {\n  content: "\\f1a6";\n}\n* .fa-digital-ocean:before {\n  content: "\\f391";\n}\n* .fa-digital-tachograph:before {\n  content: "\\f566";\n}\n* .fa-directions:before {\n  content: "\\f5eb";\n}\n* .fa-discord:before {\n  content: "\\f392";\n}\n* .fa-discourse:before {\n  content: "\\f393";\n}\n* .fa-divide:before {\n  content: "\\f529";\n}\n* .fa-dizzy:before {\n  content: "\\f567";\n}\n* .fa-dna:before {\n  content: "\\f471";\n}\n* .fa-dochub:before {\n  content: "\\f394";\n}\n* .fa-docker:before {\n  content: "\\f395";\n}\n* .fa-dog:before {\n  content: "\\f6d3";\n}\n* .fa-dollar-sign:before {\n  content: "\\f155";\n}\n* .fa-dolly:before {\n  content: "\\f472";\n}\n* .fa-dolly-flatbed:before {\n  content: "\\f474";\n}\n* .fa-donate:before {\n  content: "\\f4b9";\n}\n* .fa-door-closed:before {\n  content: "\\f52a";\n}\n* .fa-door-open:before {\n  content: "\\f52b";\n}\n* .fa-dot-circle:before {\n  content: "\\f192";\n}\n* .fa-dove:before {\n  content: "\\f4ba";\n}\n* .fa-download:before {\n  content: "\\f019";\n}\n* .fa-draft2digital:before {\n  content: "\\f396";\n}\n* .fa-drafting-compass:before {\n  content: "\\f568";\n}\n* .fa-dragon:before {\n  content: "\\f6d5";\n}\n* .fa-draw-polygon:before {\n  content: "\\f5ee";\n}\n* .fa-dribbble:before {\n  content: "\\f17d";\n}\n* .fa-dribbble-square:before {\n  content: "\\f397";\n}\n* .fa-dropbox:before {\n  content: "\\f16b";\n}\n* .fa-drum:before {\n  content: "\\f569";\n}\n* .fa-drum-steelpan:before {\n  content: "\\f56a";\n}\n* .fa-drumstick-bite:before {\n  content: "\\f6d7";\n}\n* .fa-drupal:before {\n  content: "\\f1a9";\n}\n* .fa-dumbbell:before {\n  content: "\\f44b";\n}\n* .fa-dumpster:before {\n  content: "\\f793";\n}\n* .fa-dumpster-fire:before {\n  content: "\\f794";\n}\n* .fa-dungeon:before {\n  content: "\\f6d9";\n}\n* .fa-dyalog:before {\n  content: "\\f399";\n}\n* .fa-earlybirds:before {\n  content: "\\f39a";\n}\n* .fa-ebay:before {\n  content: "\\f4f4";\n}\n* .fa-edge:before {\n  content: "\\f282";\n}\n* .fa-edit:before {\n  content: "\\f044";\n}\n* .fa-eject:before {\n  content: "\\f052";\n}\n* .fa-elementor:before {\n  content: "\\f430";\n}\n* .fa-ellipsis-h:before {\n  content: "\\f141";\n}\n* .fa-ellipsis-v:before {\n  content: "\\f142";\n}\n* .fa-ello:before {\n  content: "\\f5f1";\n}\n* .fa-ember:before {\n  content: "\\f423";\n}\n* .fa-empire:before {\n  content: "\\f1d1";\n}\n* .fa-envelope:before {\n  content: "\\f0e0";\n}\n* .fa-envelope-open:before {\n  content: "\\f2b6";\n}\n* .fa-envelope-open-text:before {\n  content: "\\f658";\n}\n* .fa-envelope-square:before {\n  content: "\\f199";\n}\n* .fa-envira:before {\n  content: "\\f299";\n}\n* .fa-equals:before {\n  content: "\\f52c";\n}\n* .fa-eraser:before {\n  content: "\\f12d";\n}\n* .fa-erlang:before {\n  content: "\\f39d";\n}\n* .fa-ethereum:before {\n  content: "\\f42e";\n}\n* .fa-ethernet:before {\n  content: "\\f796";\n}\n* .fa-etsy:before {\n  content: "\\f2d7";\n}\n* .fa-euro-sign:before {\n  content: "\\f153";\n}\n* .fa-exchange-alt:before {\n  content: "\\f362";\n}\n* .fa-exclamation:before {\n  content: "\\f12a";\n}\n* .fa-exclamation-circle:before {\n  content: "\\f06a";\n}\n* .fa-exclamation-triangle:before {\n  content: "\\f071";\n}\n* .fa-expand:before {\n  content: "\\f065";\n}\n* .fa-expand-arrows-alt:before {\n  content: "\\f31e";\n}\n* .fa-expeditedssl:before {\n  content: "\\f23e";\n}\n* .fa-external-link-alt:before {\n  content: "\\f35d";\n}\n* .fa-external-link-square-alt:before {\n  content: "\\f360";\n}\n* .fa-eye:before {\n  content: "\\f06e";\n}\n* .fa-eye-dropper:before {\n  content: "\\f1fb";\n}\n* .fa-eye-slash:before {\n  content: "\\f070";\n}\n* .fa-facebook:before {\n  content: "\\f09a";\n}\n* .fa-facebook-f:before {\n  content: "\\f39e";\n}\n* .fa-facebook-messenger:before {\n  content: "\\f39f";\n}\n* .fa-facebook-square:before {\n  content: "\\f082";\n}\n* .fa-fantasy-flight-games:before {\n  content: "\\f6dc";\n}\n* .fa-fast-backward:before {\n  content: "\\f049";\n}\n* .fa-fast-forward:before {\n  content: "\\f050";\n}\n* .fa-fax:before {\n  content: "\\f1ac";\n}\n* .fa-feather:before {\n  content: "\\f52d";\n}\n* .fa-feather-alt:before {\n  content: "\\f56b";\n}\n* .fa-fedex:before {\n  content: "\\f797";\n}\n* .fa-fedora:before {\n  content: "\\f798";\n}\n* .fa-female:before {\n  content: "\\f182";\n}\n* .fa-fighter-jet:before {\n  content: "\\f0fb";\n}\n* .fa-figma:before {\n  content: "\\f799";\n}\n* .fa-file:before {\n  content: "\\f15b";\n}\n* .fa-file-alt:before {\n  content: "\\f15c";\n}\n* .fa-file-archive:before {\n  content: "\\f1c6";\n}\n* .fa-file-audio:before {\n  content: "\\f1c7";\n}\n* .fa-file-code:before {\n  content: "\\f1c9";\n}\n* .fa-file-contract:before {\n  content: "\\f56c";\n}\n* .fa-file-csv:before {\n  content: "\\f6dd";\n}\n* .fa-file-download:before {\n  content: "\\f56d";\n}\n* .fa-file-excel:before {\n  content: "\\f1c3";\n}\n* .fa-file-export:before {\n  content: "\\f56e";\n}\n* .fa-file-image:before {\n  content: "\\f1c5";\n}\n* .fa-file-import:before {\n  content: "\\f56f";\n}\n* .fa-file-invoice:before {\n  content: "\\f570";\n}\n* .fa-file-invoice-dollar:before {\n  content: "\\f571";\n}\n* .fa-file-medical:before {\n  content: "\\f477";\n}\n* .fa-file-medical-alt:before {\n  content: "\\f478";\n}\n* .fa-file-pdf:before {\n  content: "\\f1c1";\n}\n* .fa-file-powerpoint:before {\n  content: "\\f1c4";\n}\n* .fa-file-prescription:before {\n  content: "\\f572";\n}\n* .fa-file-signature:before {\n  content: "\\f573";\n}\n* .fa-file-upload:before {\n  content: "\\f574";\n}\n* .fa-file-video:before {\n  content: "\\f1c8";\n}\n* .fa-file-word:before {\n  content: "\\f1c2";\n}\n* .fa-fill:before {\n  content: "\\f575";\n}\n* .fa-fill-drip:before {\n  content: "\\f576";\n}\n* .fa-film:before {\n  content: "\\f008";\n}\n* .fa-filter:before {\n  content: "\\f0b0";\n}\n* .fa-fingerprint:before {\n  content: "\\f577";\n}\n* .fa-fire:before {\n  content: "\\f06d";\n}\n* .fa-fire-alt:before {\n  content: "\\f7e4";\n}\n* .fa-fire-extinguisher:before {\n  content: "\\f134";\n}\n* .fa-firefox:before {\n  content: "\\f269";\n}\n* .fa-first-aid:before {\n  content: "\\f479";\n}\n* .fa-first-order:before {\n  content: "\\f2b0";\n}\n* .fa-first-order-alt:before {\n  content: "\\f50a";\n}\n* .fa-firstdraft:before {\n  content: "\\f3a1";\n}\n* .fa-fish:before {\n  content: "\\f578";\n}\n* .fa-fist-raised:before {\n  content: "\\f6de";\n}\n* .fa-flag:before {\n  content: "\\f024";\n}\n* .fa-flag-checkered:before {\n  content: "\\f11e";\n}\n* .fa-flag-usa:before {\n  content: "\\f74d";\n}\n* .fa-flask:before {\n  content: "\\f0c3";\n}\n* .fa-flickr:before {\n  content: "\\f16e";\n}\n* .fa-flipboard:before {\n  content: "\\f44d";\n}\n* .fa-flushed:before {\n  content: "\\f579";\n}\n* .fa-fly:before {\n  content: "\\f417";\n}\n* .fa-folder:before {\n  content: "\\f07b";\n}\n* .fa-folder-minus:before {\n  content: "\\f65d";\n}\n* .fa-folder-open:before {\n  content: "\\f07c";\n}\n* .fa-folder-plus:before {\n  content: "\\f65e";\n}\n* .fa-font:before {\n  content: "\\f031";\n}\n* .fa-font-awesome:before {\n  content: "\\f2b4";\n}\n* .fa-font-awesome-alt:before {\n  content: "\\f35c";\n}\n* .fa-font-awesome-flag:before {\n  content: "\\f425";\n}\n* .fa-font-awesome-logo-full:before {\n  content: "\\f4e6";\n}\n* .fa-fonticons:before {\n  content: "\\f280";\n}\n* .fa-fonticons-fi:before {\n  content: "\\f3a2";\n}\n* .fa-football-ball:before {\n  content: "\\f44e";\n}\n* .fa-fort-awesome:before {\n  content: "\\f286";\n}\n* .fa-fort-awesome-alt:before {\n  content: "\\f3a3";\n}\n* .fa-forumbee:before {\n  content: "\\f211";\n}\n* .fa-forward:before {\n  content: "\\f04e";\n}\n* .fa-foursquare:before {\n  content: "\\f180";\n}\n* .fa-free-code-camp:before {\n  content: "\\f2c5";\n}\n* .fa-freebsd:before {\n  content: "\\f3a4";\n}\n* .fa-frog:before {\n  content: "\\f52e";\n}\n* .fa-frown:before {\n  content: "\\f119";\n}\n* .fa-frown-open:before {\n  content: "\\f57a";\n}\n* .fa-fulcrum:before {\n  content: "\\f50b";\n}\n* .fa-funnel-dollar:before {\n  content: "\\f662";\n}\n* .fa-futbol:before {\n  content: "\\f1e3";\n}\n* .fa-galactic-republic:before {\n  content: "\\f50c";\n}\n* .fa-galactic-senate:before {\n  content: "\\f50d";\n}\n* .fa-gamepad:before {\n  content: "\\f11b";\n}\n* .fa-gas-pump:before {\n  content: "\\f52f";\n}\n* .fa-gavel:before {\n  content: "\\f0e3";\n}\n* .fa-gem:before {\n  content: "\\f3a5";\n}\n* .fa-genderless:before {\n  content: "\\f22d";\n}\n* .fa-get-pocket:before {\n  content: "\\f265";\n}\n* .fa-gg:before {\n  content: "\\f260";\n}\n* .fa-gg-circle:before {\n  content: "\\f261";\n}\n* .fa-ghost:before {\n  content: "\\f6e2";\n}\n* .fa-gift:before {\n  content: "\\f06b";\n}\n* .fa-gifts:before {\n  content: "\\f79c";\n}\n* .fa-git:before {\n  content: "\\f1d3";\n}\n* .fa-git-square:before {\n  content: "\\f1d2";\n}\n* .fa-github:before {\n  content: "\\f09b";\n}\n* .fa-github-alt:before {\n  content: "\\f113";\n}\n* .fa-github-square:before {\n  content: "\\f092";\n}\n* .fa-gitkraken:before {\n  content: "\\f3a6";\n}\n* .fa-gitlab:before {\n  content: "\\f296";\n}\n* .fa-gitter:before {\n  content: "\\f426";\n}\n* .fa-glass-cheers:before {\n  content: "\\f79f";\n}\n* .fa-glass-martini:before {\n  content: "\\f000";\n}\n* .fa-glass-martini-alt:before {\n  content: "\\f57b";\n}\n* .fa-glass-whiskey:before {\n  content: "\\f7a0";\n}\n* .fa-glasses:before {\n  content: "\\f530";\n}\n* .fa-glide:before {\n  content: "\\f2a5";\n}\n* .fa-glide-g:before {\n  content: "\\f2a6";\n}\n* .fa-globe:before {\n  content: "\\f0ac";\n}\n* .fa-globe-africa:before {\n  content: "\\f57c";\n}\n* .fa-globe-americas:before {\n  content: "\\f57d";\n}\n* .fa-globe-asia:before {\n  content: "\\f57e";\n}\n* .fa-globe-europe:before {\n  content: "\\f7a2";\n}\n* .fa-gofore:before {\n  content: "\\f3a7";\n}\n* .fa-golf-ball:before {\n  content: "\\f450";\n}\n* .fa-goodreads:before {\n  content: "\\f3a8";\n}\n* .fa-goodreads-g:before {\n  content: "\\f3a9";\n}\n* .fa-google:before {\n  content: "\\f1a0";\n}\n* .fa-google-drive:before {\n  content: "\\f3aa";\n}\n* .fa-google-play:before {\n  content: "\\f3ab";\n}\n* .fa-google-plus:before {\n  content: "\\f2b3";\n}\n* .fa-google-plus-g:before {\n  content: "\\f0d5";\n}\n* .fa-google-plus-square:before {\n  content: "\\f0d4";\n}\n* .fa-google-wallet:before {\n  content: "\\f1ee";\n}\n* .fa-gopuram:before {\n  content: "\\f664";\n}\n* .fa-graduation-cap:before {\n  content: "\\f19d";\n}\n* .fa-gratipay:before {\n  content: "\\f184";\n}\n* .fa-grav:before {\n  content: "\\f2d6";\n}\n* .fa-greater-than:before {\n  content: "\\f531";\n}\n* .fa-greater-than-equal:before {\n  content: "\\f532";\n}\n* .fa-grimace:before {\n  content: "\\f57f";\n}\n* .fa-grin:before {\n  content: "\\f580";\n}\n* .fa-grin-alt:before {\n  content: "\\f581";\n}\n* .fa-grin-beam:before {\n  content: "\\f582";\n}\n* .fa-grin-beam-sweat:before {\n  content: "\\f583";\n}\n* .fa-grin-hearts:before {\n  content: "\\f584";\n}\n* .fa-grin-squint:before {\n  content: "\\f585";\n}\n* .fa-grin-squint-tears:before {\n  content: "\\f586";\n}\n* .fa-grin-stars:before {\n  content: "\\f587";\n}\n* .fa-grin-tears:before {\n  content: "\\f588";\n}\n* .fa-grin-tongue:before {\n  content: "\\f589";\n}\n* .fa-grin-tongue-squint:before {\n  content: "\\f58a";\n}\n* .fa-grin-tongue-wink:before {\n  content: "\\f58b";\n}\n* .fa-grin-wink:before {\n  content: "\\f58c";\n}\n* .fa-grip-horizontal:before {\n  content: "\\f58d";\n}\n* .fa-grip-lines:before {\n  content: "\\f7a4";\n}\n* .fa-grip-lines-vertical:before {\n  content: "\\f7a5";\n}\n* .fa-grip-vertical:before {\n  content: "\\f58e";\n}\n* .fa-gripfire:before {\n  content: "\\f3ac";\n}\n* .fa-grunt:before {\n  content: "\\f3ad";\n}\n* .fa-guitar:before {\n  content: "\\f7a6";\n}\n* .fa-gulp:before {\n  content: "\\f3ae";\n}\n* .fa-h-square:before {\n  content: "\\f0fd";\n}\n* .fa-hacker-news:before {\n  content: "\\f1d4";\n}\n* .fa-hacker-news-square:before {\n  content: "\\f3af";\n}\n* .fa-hackerrank:before {\n  content: "\\f5f7";\n}\n* .fa-hammer:before {\n  content: "\\f6e3";\n}\n* .fa-hamsa:before {\n  content: "\\f665";\n}\n* .fa-hand-holding:before {\n  content: "\\f4bd";\n}\n* .fa-hand-holding-heart:before {\n  content: "\\f4be";\n}\n* .fa-hand-holding-usd:before {\n  content: "\\f4c0";\n}\n* .fa-hand-lizard:before {\n  content: "\\f258";\n}\n* .fa-hand-paper:before {\n  content: "\\f256";\n}\n* .fa-hand-peace:before {\n  content: "\\f25b";\n}\n* .fa-hand-point-down:before {\n  content: "\\f0a7";\n}\n* .fa-hand-point-left:before {\n  content: "\\f0a5";\n}\n* .fa-hand-point-right:before {\n  content: "\\f0a4";\n}\n* .fa-hand-point-up:before {\n  content: "\\f0a6";\n}\n* .fa-hand-pointer:before {\n  content: "\\f25a";\n}\n* .fa-hand-rock:before {\n  content: "\\f255";\n}\n* .fa-hand-scissors:before {\n  content: "\\f257";\n}\n* .fa-hand-spock:before {\n  content: "\\f259";\n}\n* .fa-hands:before {\n  content: "\\f4c2";\n}\n* .fa-hands-helping:before {\n  content: "\\f4c4";\n}\n* .fa-handshake:before {\n  content: "\\f2b5";\n}\n* .fa-hanukiah:before {\n  content: "\\f6e6";\n}\n* .fa-hashtag:before {\n  content: "\\f292";\n}\n* .fa-hat-wizard:before {\n  content: "\\f6e8";\n}\n* .fa-haykal:before {\n  content: "\\f666";\n}\n* .fa-hdd:before {\n  content: "\\f0a0";\n}\n* .fa-heading:before {\n  content: "\\f1dc";\n}\n* .fa-headphones:before {\n  content: "\\f025";\n}\n* .fa-headphones-alt:before {\n  content: "\\f58f";\n}\n* .fa-headset:before {\n  content: "\\f590";\n}\n* .fa-heart:before {\n  content: "\\f004";\n}\n* .fa-heart-broken:before {\n  content: "\\f7a9";\n}\n* .fa-heartbeat:before {\n  content: "\\f21e";\n}\n* .fa-helicopter:before {\n  content: "\\f533";\n}\n* .fa-highlighter:before {\n  content: "\\f591";\n}\n* .fa-hiking:before {\n  content: "\\f6ec";\n}\n* .fa-hippo:before {\n  content: "\\f6ed";\n}\n* .fa-hips:before {\n  content: "\\f452";\n}\n* .fa-hire-a-helper:before {\n  content: "\\f3b0";\n}\n* .fa-history:before {\n  content: "\\f1da";\n}\n* .fa-hockey-puck:before {\n  content: "\\f453";\n}\n* .fa-holly-berry:before {\n  content: "\\f7aa";\n}\n* .fa-home:before {\n  content: "\\f015";\n}\n* .fa-hooli:before {\n  content: "\\f427";\n}\n* .fa-hornbill:before {\n  content: "\\f592";\n}\n* .fa-horse:before {\n  content: "\\f6f0";\n}\n* .fa-horse-head:before {\n  content: "\\f7ab";\n}\n* .fa-hospital:before {\n  content: "\\f0f8";\n}\n* .fa-hospital-alt:before {\n  content: "\\f47d";\n}\n* .fa-hospital-symbol:before {\n  content: "\\f47e";\n}\n* .fa-hot-tub:before {\n  content: "\\f593";\n}\n* .fa-hotel:before {\n  content: "\\f594";\n}\n* .fa-hotjar:before {\n  content: "\\f3b1";\n}\n* .fa-hourglass:before {\n  content: "\\f254";\n}\n* .fa-hourglass-end:before {\n  content: "\\f253";\n}\n* .fa-hourglass-half:before {\n  content: "\\f252";\n}\n* .fa-hourglass-start:before {\n  content: "\\f251";\n}\n* .fa-house-damage:before {\n  content: "\\f6f1";\n}\n* .fa-houzz:before {\n  content: "\\f27c";\n}\n* .fa-hryvnia:before {\n  content: "\\f6f2";\n}\n* .fa-html5:before {\n  content: "\\f13b";\n}\n* .fa-hubspot:before {\n  content: "\\f3b2";\n}\n* .fa-i-cursor:before {\n  content: "\\f246";\n}\n* .fa-icicles:before {\n  content: "\\f7ad";\n}\n* .fa-id-badge:before {\n  content: "\\f2c1";\n}\n* .fa-id-card:before {\n  content: "\\f2c2";\n}\n* .fa-id-card-alt:before {\n  content: "\\f47f";\n}\n* .fa-igloo:before {\n  content: "\\f7ae";\n}\n* .fa-image:before {\n  content: "\\f03e";\n}\n* .fa-images:before {\n  content: "\\f302";\n}\n* .fa-imdb:before {\n  content: "\\f2d8";\n}\n* .fa-inbox:before {\n  content: "\\f01c";\n}\n* .fa-indent:before {\n  content: "\\f03c";\n}\n* .fa-industry:before {\n  content: "\\f275";\n}\n* .fa-infinity:before {\n  content: "\\f534";\n}\n* .fa-info:before {\n  content: "\\f129";\n}\n* .fa-info-circle:before {\n  content: "\\f05a";\n}\n* .fa-instagram:before {\n  content: "\\f16d";\n}\n* .fa-intercom:before {\n  content: "\\f7af";\n}\n* .fa-internet-explorer:before {\n  content: "\\f26b";\n}\n* .fa-invision:before {\n  content: "\\f7b0";\n}\n* .fa-ioxhost:before {\n  content: "\\f208";\n}\n* .fa-italic:before {\n  content: "\\f033";\n}\n* .fa-itunes:before {\n  content: "\\f3b4";\n}\n* .fa-itunes-note:before {\n  content: "\\f3b5";\n}\n* .fa-java:before {\n  content: "\\f4e4";\n}\n* .fa-jedi:before {\n  content: "\\f669";\n}\n* .fa-jedi-order:before {\n  content: "\\f50e";\n}\n* .fa-jenkins:before {\n  content: "\\f3b6";\n}\n* .fa-jira:before {\n  content: "\\f7b1";\n}\n* .fa-joget:before {\n  content: "\\f3b7";\n}\n* .fa-joint:before {\n  content: "\\f595";\n}\n* .fa-joomla:before {\n  content: "\\f1aa";\n}\n* .fa-journal-whills:before {\n  content: "\\f66a";\n}\n* .fa-js:before {\n  content: "\\f3b8";\n}\n* .fa-js-square:before {\n  content: "\\f3b9";\n}\n* .fa-jsfiddle:before {\n  content: "\\f1cc";\n}\n* .fa-kaaba:before {\n  content: "\\f66b";\n}\n* .fa-kaggle:before {\n  content: "\\f5fa";\n}\n* .fa-key:before {\n  content: "\\f084";\n}\n* .fa-keybase:before {\n  content: "\\f4f5";\n}\n* .fa-keyboard:before {\n  content: "\\f11c";\n}\n* .fa-keycdn:before {\n  content: "\\f3ba";\n}\n* .fa-khanda:before {\n  content: "\\f66d";\n}\n* .fa-kickstarter:before {\n  content: "\\f3bb";\n}\n* .fa-kickstarter-k:before {\n  content: "\\f3bc";\n}\n* .fa-kiss:before {\n  content: "\\f596";\n}\n* .fa-kiss-beam:before {\n  content: "\\f597";\n}\n* .fa-kiss-wink-heart:before {\n  content: "\\f598";\n}\n* .fa-kiwi-bird:before {\n  content: "\\f535";\n}\n* .fa-korvue:before {\n  content: "\\f42f";\n}\n* .fa-landmark:before {\n  content: "\\f66f";\n}\n* .fa-language:before {\n  content: "\\f1ab";\n}\n* .fa-laptop:before {\n  content: "\\f109";\n}\n* .fa-laptop-code:before {\n  content: "\\f5fc";\n}\n* .fa-laravel:before {\n  content: "\\f3bd";\n}\n* .fa-lastfm:before {\n  content: "\\f202";\n}\n* .fa-lastfm-square:before {\n  content: "\\f203";\n}\n* .fa-laugh:before {\n  content: "\\f599";\n}\n* .fa-laugh-beam:before {\n  content: "\\f59a";\n}\n* .fa-laugh-squint:before {\n  content: "\\f59b";\n}\n* .fa-laugh-wink:before {\n  content: "\\f59c";\n}\n* .fa-layer-group:before {\n  content: "\\f5fd";\n}\n* .fa-leaf:before {\n  content: "\\f06c";\n}\n* .fa-leanpub:before {\n  content: "\\f212";\n}\n* .fa-lemon:before {\n  content: "\\f094";\n}\n* .fa-less:before {\n  content: "\\f41d";\n}\n* .fa-less-than:before {\n  content: "\\f536";\n}\n* .fa-less-than-equal:before {\n  content: "\\f537";\n}\n* .fa-level-down-alt:before {\n  content: "\\f3be";\n}\n* .fa-level-up-alt:before {\n  content: "\\f3bf";\n}\n* .fa-life-ring:before {\n  content: "\\f1cd";\n}\n* .fa-lightbulb:before {\n  content: "\\f0eb";\n}\n* .fa-line:before {\n  content: "\\f3c0";\n}\n* .fa-link:before {\n  content: "\\f0c1";\n}\n* .fa-linkedin:before {\n  content: "\\f08c";\n}\n* .fa-linkedin-in:before {\n  content: "\\f0e1";\n}\n* .fa-linode:before {\n  content: "\\f2b8";\n}\n* .fa-linux:before {\n  content: "\\f17c";\n}\n* .fa-lira-sign:before {\n  content: "\\f195";\n}\n* .fa-list:before {\n  content: "\\f03a";\n}\n* .fa-list-alt:before {\n  content: "\\f022";\n}\n* .fa-list-ol:before {\n  content: "\\f0cb";\n}\n* .fa-list-ul:before {\n  content: "\\f0ca";\n}\n* .fa-location-arrow:before {\n  content: "\\f124";\n}\n* .fa-lock:before {\n  content: "\\f023";\n}\n* .fa-lock-open:before {\n  content: "\\f3c1";\n}\n* .fa-long-arrow-alt-down:before {\n  content: "\\f309";\n}\n* .fa-long-arrow-alt-left:before {\n  content: "\\f30a";\n}\n* .fa-long-arrow-alt-right:before {\n  content: "\\f30b";\n}\n* .fa-long-arrow-alt-up:before {\n  content: "\\f30c";\n}\n* .fa-low-vision:before {\n  content: "\\f2a8";\n}\n* .fa-luggage-cart:before {\n  content: "\\f59d";\n}\n* .fa-lyft:before {\n  content: "\\f3c3";\n}\n* .fa-magento:before {\n  content: "\\f3c4";\n}\n* .fa-magic:before {\n  content: "\\f0d0";\n}\n* .fa-magnet:before {\n  content: "\\f076";\n}\n* .fa-mail-bulk:before {\n  content: "\\f674";\n}\n* .fa-mailchimp:before {\n  content: "\\f59e";\n}\n* .fa-male:before {\n  content: "\\f183";\n}\n* .fa-mandalorian:before {\n  content: "\\f50f";\n}\n* .fa-map:before {\n  content: "\\f279";\n}\n* .fa-map-marked:before {\n  content: "\\f59f";\n}\n* .fa-map-marked-alt:before {\n  content: "\\f5a0";\n}\n* .fa-map-marker:before {\n  content: "\\f041";\n}\n* .fa-map-marker-alt:before {\n  content: "\\f3c5";\n}\n* .fa-map-pin:before {\n  content: "\\f276";\n}\n* .fa-map-signs:before {\n  content: "\\f277";\n}\n* .fa-markdown:before {\n  content: "\\f60f";\n}\n* .fa-marker:before {\n  content: "\\f5a1";\n}\n* .fa-mars:before {\n  content: "\\f222";\n}\n* .fa-mars-double:before {\n  content: "\\f227";\n}\n* .fa-mars-stroke:before {\n  content: "\\f229";\n}\n* .fa-mars-stroke-h:before {\n  content: "\\f22b";\n}\n* .fa-mars-stroke-v:before {\n  content: "\\f22a";\n}\n* .fa-mask:before {\n  content: "\\f6fa";\n}\n* .fa-mastodon:before {\n  content: "\\f4f6";\n}\n* .fa-maxcdn:before {\n  content: "\\f136";\n}\n* .fa-medal:before {\n  content: "\\f5a2";\n}\n* .fa-medapps:before {\n  content: "\\f3c6";\n}\n* .fa-medium:before {\n  content: "\\f23a";\n}\n* .fa-medium-m:before {\n  content: "\\f3c7";\n}\n* .fa-medkit:before {\n  content: "\\f0fa";\n}\n* .fa-medrt:before {\n  content: "\\f3c8";\n}\n* .fa-meetup:before {\n  content: "\\f2e0";\n}\n* .fa-megaport:before {\n  content: "\\f5a3";\n}\n* .fa-meh:before {\n  content: "\\f11a";\n}\n* .fa-meh-blank:before {\n  content: "\\f5a4";\n}\n* .fa-meh-rolling-eyes:before {\n  content: "\\f5a5";\n}\n* .fa-memory:before {\n  content: "\\f538";\n}\n* .fa-mendeley:before {\n  content: "\\f7b3";\n}\n* .fa-menorah:before {\n  content: "\\f676";\n}\n* .fa-mercury:before {\n  content: "\\f223";\n}\n* .fa-meteor:before {\n  content: "\\f753";\n}\n* .fa-microchip:before {\n  content: "\\f2db";\n}\n* .fa-microphone:before {\n  content: "\\f130";\n}\n* .fa-microphone-alt:before {\n  content: "\\f3c9";\n}\n* .fa-microphone-alt-slash:before {\n  content: "\\f539";\n}\n* .fa-microphone-slash:before {\n  content: "\\f131";\n}\n* .fa-microscope:before {\n  content: "\\f610";\n}\n* .fa-microsoft:before {\n  content: "\\f3ca";\n}\n* .fa-minus:before {\n  content: "\\f068";\n}\n* .fa-minus-circle:before {\n  content: "\\f056";\n}\n* .fa-minus-square:before {\n  content: "\\f146";\n}\n* .fa-mitten:before {\n  content: "\\f7b5";\n}\n* .fa-mix:before {\n  content: "\\f3cb";\n}\n* .fa-mixcloud:before {\n  content: "\\f289";\n}\n* .fa-mizuni:before {\n  content: "\\f3cc";\n}\n* .fa-mobile:before {\n  content: "\\f10b";\n}\n* .fa-mobile-alt:before {\n  content: "\\f3cd";\n}\n* .fa-modx:before {\n  content: "\\f285";\n}\n* .fa-monero:before {\n  content: "\\f3d0";\n}\n* .fa-money-bill:before {\n  content: "\\f0d6";\n}\n* .fa-money-bill-alt:before {\n  content: "\\f3d1";\n}\n* .fa-money-bill-wave:before {\n  content: "\\f53a";\n}\n* .fa-money-bill-wave-alt:before {\n  content: "\\f53b";\n}\n* .fa-money-check:before {\n  content: "\\f53c";\n}\n* .fa-money-check-alt:before {\n  content: "\\f53d";\n}\n* .fa-monument:before {\n  content: "\\f5a6";\n}\n* .fa-moon:before {\n  content: "\\f186";\n}\n* .fa-mortar-pestle:before {\n  content: "\\f5a7";\n}\n* .fa-mosque:before {\n  content: "\\f678";\n}\n* .fa-motorcycle:before {\n  content: "\\f21c";\n}\n* .fa-mountain:before {\n  content: "\\f6fc";\n}\n* .fa-mouse-pointer:before {\n  content: "\\f245";\n}\n* .fa-mug-hot:before {\n  content: "\\f7b6";\n}\n* .fa-music:before {\n  content: "\\f001";\n}\n* .fa-napster:before {\n  content: "\\f3d2";\n}\n* .fa-neos:before {\n  content: "\\f612";\n}\n* .fa-network-wired:before {\n  content: "\\f6ff";\n}\n* .fa-neuter:before {\n  content: "\\f22c";\n}\n* .fa-newspaper:before {\n  content: "\\f1ea";\n}\n* .fa-nimblr:before {\n  content: "\\f5a8";\n}\n* .fa-nintendo-switch:before {\n  content: "\\f418";\n}\n* .fa-node:before {\n  content: "\\f419";\n}\n* .fa-node-js:before {\n  content: "\\f3d3";\n}\n* .fa-not-equal:before {\n  content: "\\f53e";\n}\n* .fa-notes-medical:before {\n  content: "\\f481";\n}\n* .fa-npm:before {\n  content: "\\f3d4";\n}\n* .fa-ns8:before {\n  content: "\\f3d5";\n}\n* .fa-nutritionix:before {\n  content: "\\f3d6";\n}\n* .fa-object-group:before {\n  content: "\\f247";\n}\n* .fa-object-ungroup:before {\n  content: "\\f248";\n}\n* .fa-odnoklassniki:before {\n  content: "\\f263";\n}\n* .fa-odnoklassniki-square:before {\n  content: "\\f264";\n}\n* .fa-oil-can:before {\n  content: "\\f613";\n}\n* .fa-old-republic:before {\n  content: "\\f510";\n}\n* .fa-om:before {\n  content: "\\f679";\n}\n* .fa-opencart:before {\n  content: "\\f23d";\n}\n* .fa-openid:before {\n  content: "\\f19b";\n}\n* .fa-opera:before {\n  content: "\\f26a";\n}\n* .fa-optin-monster:before {\n  content: "\\f23c";\n}\n* .fa-osi:before {\n  content: "\\f41a";\n}\n* .fa-otter:before {\n  content: "\\f700";\n}\n* .fa-outdent:before {\n  content: "\\f03b";\n}\n* .fa-page4:before {\n  content: "\\f3d7";\n}\n* .fa-pagelines:before {\n  content: "\\f18c";\n}\n* .fa-paint-brush:before {\n  content: "\\f1fc";\n}\n* .fa-paint-roller:before {\n  content: "\\f5aa";\n}\n* .fa-palette:before {\n  content: "\\f53f";\n}\n* .fa-palfed:before {\n  content: "\\f3d8";\n}\n* .fa-pallet:before {\n  content: "\\f482";\n}\n* .fa-paper-plane:before {\n  content: "\\f1d8";\n}\n* .fa-paperclip:before {\n  content: "\\f0c6";\n}\n* .fa-parachute-box:before {\n  content: "\\f4cd";\n}\n* .fa-paragraph:before {\n  content: "\\f1dd";\n}\n* .fa-parking:before {\n  content: "\\f540";\n}\n* .fa-passport:before {\n  content: "\\f5ab";\n}\n* .fa-pastafarianism:before {\n  content: "\\f67b";\n}\n* .fa-paste:before {\n  content: "\\f0ea";\n}\n* .fa-patreon:before {\n  content: "\\f3d9";\n}\n* .fa-pause:before {\n  content: "\\f04c";\n}\n* .fa-pause-circle:before {\n  content: "\\f28b";\n}\n* .fa-paw:before {\n  content: "\\f1b0";\n}\n* .fa-paypal:before {\n  content: "\\f1ed";\n}\n* .fa-peace:before {\n  content: "\\f67c";\n}\n* .fa-pen:before {\n  content: "\\f304";\n}\n* .fa-pen-alt:before {\n  content: "\\f305";\n}\n* .fa-pen-fancy:before {\n  content: "\\f5ac";\n}\n* .fa-pen-nib:before {\n  content: "\\f5ad";\n}\n* .fa-pen-square:before {\n  content: "\\f14b";\n}\n* .fa-pencil-alt:before {\n  content: "\\f303";\n}\n* .fa-pencil-ruler:before {\n  content: "\\f5ae";\n}\n* .fa-penny-arcade:before {\n  content: "\\f704";\n}\n* .fa-people-carry:before {\n  content: "\\f4ce";\n}\n* .fa-percent:before {\n  content: "\\f295";\n}\n* .fa-percentage:before {\n  content: "\\f541";\n}\n* .fa-periscope:before {\n  content: "\\f3da";\n}\n* .fa-person-booth:before {\n  content: "\\f756";\n}\n* .fa-phabricator:before {\n  content: "\\f3db";\n}\n* .fa-phoenix-framework:before {\n  content: "\\f3dc";\n}\n* .fa-phoenix-squadron:before {\n  content: "\\f511";\n}\n* .fa-phone:before {\n  content: "\\f095";\n}\n* .fa-phone-slash:before {\n  content: "\\f3dd";\n}\n* .fa-phone-square:before {\n  content: "\\f098";\n}\n* .fa-phone-volume:before {\n  content: "\\f2a0";\n}\n* .fa-php:before {\n  content: "\\f457";\n}\n* .fa-pied-piper:before {\n  content: "\\f2ae";\n}\n* .fa-pied-piper-alt:before {\n  content: "\\f1a8";\n}\n* .fa-pied-piper-hat:before {\n  content: "\\f4e5";\n}\n* .fa-pied-piper-pp:before {\n  content: "\\f1a7";\n}\n* .fa-piggy-bank:before {\n  content: "\\f4d3";\n}\n* .fa-pills:before {\n  content: "\\f484";\n}\n* .fa-pinterest:before {\n  content: "\\f0d2";\n}\n* .fa-pinterest-p:before {\n  content: "\\f231";\n}\n* .fa-pinterest-square:before {\n  content: "\\f0d3";\n}\n* .fa-place-of-worship:before {\n  content: "\\f67f";\n}\n* .fa-plane:before {\n  content: "\\f072";\n}\n* .fa-plane-arrival:before {\n  content: "\\f5af";\n}\n* .fa-plane-departure:before {\n  content: "\\f5b0";\n}\n* .fa-play:before {\n  content: "\\f04b";\n}\n* .fa-play-circle:before {\n  content: "\\f144";\n}\n* .fa-playstation:before {\n  content: "\\f3df";\n}\n* .fa-plug:before {\n  content: "\\f1e6";\n}\n* .fa-plus:before {\n  content: "\\f067";\n}\n* .fa-plus-circle:before {\n  content: "\\f055";\n}\n* .fa-plus-square:before {\n  content: "\\f0fe";\n}\n* .fa-podcast:before {\n  content: "\\f2ce";\n}\n* .fa-poll:before {\n  content: "\\f681";\n}\n* .fa-poll-h:before {\n  content: "\\f682";\n}\n* .fa-poo:before {\n  content: "\\f2fe";\n}\n* .fa-poo-storm:before {\n  content: "\\f75a";\n}\n* .fa-poop:before {\n  content: "\\f619";\n}\n* .fa-portrait:before {\n  content: "\\f3e0";\n}\n* .fa-pound-sign:before {\n  content: "\\f154";\n}\n* .fa-power-off:before {\n  content: "\\f011";\n}\n* .fa-pray:before {\n  content: "\\f683";\n}\n* .fa-praying-hands:before {\n  content: "\\f684";\n}\n* .fa-prescription:before {\n  content: "\\f5b1";\n}\n* .fa-prescription-bottle:before {\n  content: "\\f485";\n}\n* .fa-prescription-bottle-alt:before {\n  content: "\\f486";\n}\n* .fa-print:before {\n  content: "\\f02f";\n}\n* .fa-procedures:before {\n  content: "\\f487";\n}\n* .fa-product-hunt:before {\n  content: "\\f288";\n}\n* .fa-project-diagram:before {\n  content: "\\f542";\n}\n* .fa-pushed:before {\n  content: "\\f3e1";\n}\n* .fa-puzzle-piece:before {\n  content: "\\f12e";\n}\n* .fa-python:before {\n  content: "\\f3e2";\n}\n* .fa-qq:before {\n  content: "\\f1d6";\n}\n* .fa-qrcode:before {\n  content: "\\f029";\n}\n* .fa-question:before {\n  content: "\\f128";\n}\n* .fa-question-circle:before {\n  content: "\\f059";\n}\n* .fa-quidditch:before {\n  content: "\\f458";\n}\n* .fa-quinscape:before {\n  content: "\\f459";\n}\n* .fa-quora:before {\n  content: "\\f2c4";\n}\n* .fa-quote-left:before {\n  content: "\\f10d";\n}\n* .fa-quote-right:before {\n  content: "\\f10e";\n}\n* .fa-quran:before {\n  content: "\\f687";\n}\n* .fa-r-project:before {\n  content: "\\f4f7";\n}\n* .fa-radiation:before {\n  content: "\\f7b9";\n}\n* .fa-radiation-alt:before {\n  content: "\\f7ba";\n}\n* .fa-rainbow:before {\n  content: "\\f75b";\n}\n* .fa-random:before {\n  content: "\\f074";\n}\n* .fa-raspberry-pi:before {\n  content: "\\f7bb";\n}\n* .fa-ravelry:before {\n  content: "\\f2d9";\n}\n* .fa-react:before {\n  content: "\\f41b";\n}\n* .fa-reacteurope:before {\n  content: "\\f75d";\n}\n* .fa-readme:before {\n  content: "\\f4d5";\n}\n* .fa-rebel:before {\n  content: "\\f1d0";\n}\n* .fa-receipt:before {\n  content: "\\f543";\n}\n* .fa-recycle:before {\n  content: "\\f1b8";\n}\n* .fa-red-river:before {\n  content: "\\f3e3";\n}\n* .fa-reddit:before {\n  content: "\\f1a1";\n}\n* .fa-reddit-alien:before {\n  content: "\\f281";\n}\n* .fa-reddit-square:before {\n  content: "\\f1a2";\n}\n* .fa-redhat:before {\n  content: "\\f7bc";\n}\n* .fa-redo:before {\n  content: "\\f01e";\n}\n* .fa-redo-alt:before {\n  content: "\\f2f9";\n}\n* .fa-registered:before {\n  content: "\\f25d";\n}\n* .fa-renren:before {\n  content: "\\f18b";\n}\n* .fa-reply:before {\n  content: "\\f3e5";\n}\n* .fa-reply-all:before {\n  content: "\\f122";\n}\n* .fa-replyd:before {\n  content: "\\f3e6";\n}\n* .fa-republican:before {\n  content: "\\f75e";\n}\n* .fa-researchgate:before {\n  content: "\\f4f8";\n}\n* .fa-resolving:before {\n  content: "\\f3e7";\n}\n* .fa-restroom:before {\n  content: "\\f7bd";\n}\n* .fa-retweet:before {\n  content: "\\f079";\n}\n* .fa-rev:before {\n  content: "\\f5b2";\n}\n* .fa-ribbon:before {\n  content: "\\f4d6";\n}\n* .fa-ring:before {\n  content: "\\f70b";\n}\n* .fa-road:before {\n  content: "\\f018";\n}\n* .fa-robot:before {\n  content: "\\f544";\n}\n* .fa-rocket:before {\n  content: "\\f135";\n}\n* .fa-rocketchat:before {\n  content: "\\f3e8";\n}\n* .fa-rockrms:before {\n  content: "\\f3e9";\n}\n* .fa-route:before {\n  content: "\\f4d7";\n}\n* .fa-rss:before {\n  content: "\\f09e";\n}\n* .fa-rss-square:before {\n  content: "\\f143";\n}\n* .fa-ruble-sign:before {\n  content: "\\f158";\n}\n* .fa-ruler:before {\n  content: "\\f545";\n}\n* .fa-ruler-combined:before {\n  content: "\\f546";\n}\n* .fa-ruler-horizontal:before {\n  content: "\\f547";\n}\n* .fa-ruler-vertical:before {\n  content: "\\f548";\n}\n* .fa-running:before {\n  content: "\\f70c";\n}\n* .fa-rupee-sign:before {\n  content: "\\f156";\n}\n* .fa-sad-cry:before {\n  content: "\\f5b3";\n}\n* .fa-sad-tear:before {\n  content: "\\f5b4";\n}\n* .fa-safari:before {\n  content: "\\f267";\n}\n* .fa-sass:before {\n  content: "\\f41e";\n}\n* .fa-satellite:before {\n  content: "\\f7bf";\n}\n* .fa-satellite-dish:before {\n  content: "\\f7c0";\n}\n* .fa-save:before {\n  content: "\\f0c7";\n}\n* .fa-schlix:before {\n  content: "\\f3ea";\n}\n* .fa-school:before {\n  content: "\\f549";\n}\n* .fa-screwdriver:before {\n  content: "\\f54a";\n}\n* .fa-scribd:before {\n  content: "\\f28a";\n}\n* .fa-scroll:before {\n  content: "\\f70e";\n}\n* .fa-sd-card:before {\n  content: "\\f7c2";\n}\n* .fa-search:before {\n  content: "\\f002";\n}\n* .fa-search-dollar:before {\n  content: "\\f688";\n}\n* .fa-search-location:before {\n  content: "\\f689";\n}\n* .fa-search-minus:before {\n  content: "\\f010";\n}\n* .fa-search-plus:before {\n  content: "\\f00e";\n}\n* .fa-searchengin:before {\n  content: "\\f3eb";\n}\n* .fa-seedling:before {\n  content: "\\f4d8";\n}\n* .fa-sellcast:before {\n  content: "\\f2da";\n}\n* .fa-sellsy:before {\n  content: "\\f213";\n}\n* .fa-server:before {\n  content: "\\f233";\n}\n* .fa-servicestack:before {\n  content: "\\f3ec";\n}\n* .fa-shapes:before {\n  content: "\\f61f";\n}\n* .fa-share:before {\n  content: "\\f064";\n}\n* .fa-share-alt:before {\n  content: "\\f1e0";\n}\n* .fa-share-alt-square:before {\n  content: "\\f1e1";\n}\n* .fa-share-square:before {\n  content: "\\f14d";\n}\n* .fa-shekel-sign:before {\n  content: "\\f20b";\n}\n* .fa-shield-alt:before {\n  content: "\\f3ed";\n}\n* .fa-ship:before {\n  content: "\\f21a";\n}\n* .fa-shipping-fast:before {\n  content: "\\f48b";\n}\n* .fa-shirtsinbulk:before {\n  content: "\\f214";\n}\n* .fa-shoe-prints:before {\n  content: "\\f54b";\n}\n* .fa-shopping-bag:before {\n  content: "\\f290";\n}\n* .fa-shopping-basket:before {\n  content: "\\f291";\n}\n* .fa-shopping-cart:before {\n  content: "\\f07a";\n}\n* .fa-shopware:before {\n  content: "\\f5b5";\n}\n* .fa-shower:before {\n  content: "\\f2cc";\n}\n* .fa-shuttle-van:before {\n  content: "\\f5b6";\n}\n* .fa-sign:before {\n  content: "\\f4d9";\n}\n* .fa-sign-in-alt:before {\n  content: "\\f2f6";\n}\n* .fa-sign-language:before {\n  content: "\\f2a7";\n}\n* .fa-sign-out-alt:before {\n  content: "\\f2f5";\n}\n* .fa-signal:before {\n  content: "\\f012";\n}\n* .fa-signature:before {\n  content: "\\f5b7";\n}\n* .fa-sim-card:before {\n  content: "\\f7c4";\n}\n* .fa-simplybuilt:before {\n  content: "\\f215";\n}\n* .fa-sistrix:before {\n  content: "\\f3ee";\n}\n* .fa-sitemap:before {\n  content: "\\f0e8";\n}\n* .fa-sith:before {\n  content: "\\f512";\n}\n* .fa-skating:before {\n  content: "\\f7c5";\n}\n* .fa-sketch:before {\n  content: "\\f7c6";\n}\n* .fa-skiing:before {\n  content: "\\f7c9";\n}\n* .fa-skiing-nordic:before {\n  content: "\\f7ca";\n}\n* .fa-skull:before {\n  content: "\\f54c";\n}\n* .fa-skull-crossbones:before {\n  content: "\\f714";\n}\n* .fa-skyatlas:before {\n  content: "\\f216";\n}\n* .fa-skype:before {\n  content: "\\f17e";\n}\n* .fa-slack:before {\n  content: "\\f198";\n}\n* .fa-slack-hash:before {\n  content: "\\f3ef";\n}\n* .fa-slash:before {\n  content: "\\f715";\n}\n* .fa-sleigh:before {\n  content: "\\f7cc";\n}\n* .fa-sliders-h:before {\n  content: "\\f1de";\n}\n* .fa-slideshare:before {\n  content: "\\f1e7";\n}\n* .fa-smile:before {\n  content: "\\f118";\n}\n* .fa-smile-beam:before {\n  content: "\\f5b8";\n}\n* .fa-smile-wink:before {\n  content: "\\f4da";\n}\n* .fa-smog:before {\n  content: "\\f75f";\n}\n* .fa-smoking:before {\n  content: "\\f48d";\n}\n* .fa-smoking-ban:before {\n  content: "\\f54d";\n}\n* .fa-sms:before {\n  content: "\\f7cd";\n}\n* .fa-snapchat:before {\n  content: "\\f2ab";\n}\n* .fa-snapchat-ghost:before {\n  content: "\\f2ac";\n}\n* .fa-snapchat-square:before {\n  content: "\\f2ad";\n}\n* .fa-snowboarding:before {\n  content: "\\f7ce";\n}\n* .fa-snowflake:before {\n  content: "\\f2dc";\n}\n* .fa-snowman:before {\n  content: "\\f7d0";\n}\n* .fa-snowplow:before {\n  content: "\\f7d2";\n}\n* .fa-socks:before {\n  content: "\\f696";\n}\n* .fa-solar-panel:before {\n  content: "\\f5ba";\n}\n* .fa-sort:before {\n  content: "\\f0dc";\n}\n* .fa-sort-alpha-down:before {\n  content: "\\f15d";\n}\n* .fa-sort-alpha-up:before {\n  content: "\\f15e";\n}\n* .fa-sort-amount-down:before {\n  content: "\\f160";\n}\n* .fa-sort-amount-up:before {\n  content: "\\f161";\n}\n* .fa-sort-down:before {\n  content: "\\f0dd";\n}\n* .fa-sort-numeric-down:before {\n  content: "\\f162";\n}\n* .fa-sort-numeric-up:before {\n  content: "\\f163";\n}\n* .fa-sort-up:before {\n  content: "\\f0de";\n}\n* .fa-soundcloud:before {\n  content: "\\f1be";\n}\n* .fa-sourcetree:before {\n  content: "\\f7d3";\n}\n* .fa-spa:before {\n  content: "\\f5bb";\n}\n* .fa-space-shuttle:before {\n  content: "\\f197";\n}\n* .fa-speakap:before {\n  content: "\\f3f3";\n}\n* .fa-spider:before {\n  content: "\\f717";\n}\n* .fa-spinner:before {\n  content: "\\f110";\n}\n* .fa-splotch:before {\n  content: "\\f5bc";\n}\n* .fa-spotify:before {\n  content: "\\f1bc";\n}\n* .fa-spray-can:before {\n  content: "\\f5bd";\n}\n* .fa-square:before {\n  content: "\\f0c8";\n}\n* .fa-square-full:before {\n  content: "\\f45c";\n}\n* .fa-square-root-alt:before {\n  content: "\\f698";\n}\n* .fa-squarespace:before {\n  content: "\\f5be";\n}\n* .fa-stack-exchange:before {\n  content: "\\f18d";\n}\n* .fa-stack-overflow:before {\n  content: "\\f16c";\n}\n* .fa-stamp:before {\n  content: "\\f5bf";\n}\n* .fa-star:before {\n  content: "\\f005";\n}\n* .fa-star-and-crescent:before {\n  content: "\\f699";\n}\n* .fa-star-half:before {\n  content: "\\f089";\n}\n* .fa-star-half-alt:before {\n  content: "\\f5c0";\n}\n* .fa-star-of-david:before {\n  content: "\\f69a";\n}\n* .fa-star-of-life:before {\n  content: "\\f621";\n}\n* .fa-staylinked:before {\n  content: "\\f3f5";\n}\n* .fa-steam:before {\n  content: "\\f1b6";\n}\n* .fa-steam-square:before {\n  content: "\\f1b7";\n}\n* .fa-steam-symbol:before {\n  content: "\\f3f6";\n}\n* .fa-step-backward:before {\n  content: "\\f048";\n}\n* .fa-step-forward:before {\n  content: "\\f051";\n}\n* .fa-stethoscope:before {\n  content: "\\f0f1";\n}\n* .fa-sticker-mule:before {\n  content: "\\f3f7";\n}\n* .fa-sticky-note:before {\n  content: "\\f249";\n}\n* .fa-stop:before {\n  content: "\\f04d";\n}\n* .fa-stop-circle:before {\n  content: "\\f28d";\n}\n* .fa-stopwatch:before {\n  content: "\\f2f2";\n}\n* .fa-store:before {\n  content: "\\f54e";\n}\n* .fa-store-alt:before {\n  content: "\\f54f";\n}\n* .fa-strava:before {\n  content: "\\f428";\n}\n* .fa-stream:before {\n  content: "\\f550";\n}\n* .fa-street-view:before {\n  content: "\\f21d";\n}\n* .fa-strikethrough:before {\n  content: "\\f0cc";\n}\n* .fa-stripe:before {\n  content: "\\f429";\n}\n* .fa-stripe-s:before {\n  content: "\\f42a";\n}\n* .fa-stroopwafel:before {\n  content: "\\f551";\n}\n* .fa-studiovinari:before {\n  content: "\\f3f8";\n}\n* .fa-stumbleupon:before {\n  content: "\\f1a4";\n}\n* .fa-stumbleupon-circle:before {\n  content: "\\f1a3";\n}\n* .fa-subscript:before {\n  content: "\\f12c";\n}\n* .fa-subway:before {\n  content: "\\f239";\n}\n* .fa-suitcase:before {\n  content: "\\f0f2";\n}\n* .fa-suitcase-rolling:before {\n  content: "\\f5c1";\n}\n* .fa-sun:before {\n  content: "\\f185";\n}\n* .fa-superpowers:before {\n  content: "\\f2dd";\n}\n* .fa-superscript:before {\n  content: "\\f12b";\n}\n* .fa-supple:before {\n  content: "\\f3f9";\n}\n* .fa-surprise:before {\n  content: "\\f5c2";\n}\n* .fa-suse:before {\n  content: "\\f7d6";\n}\n* .fa-swatchbook:before {\n  content: "\\f5c3";\n}\n* .fa-swimmer:before {\n  content: "\\f5c4";\n}\n* .fa-swimming-pool:before {\n  content: "\\f5c5";\n}\n* .fa-synagogue:before {\n  content: "\\f69b";\n}\n* .fa-sync:before {\n  content: "\\f021";\n}\n* .fa-sync-alt:before {\n  content: "\\f2f1";\n}\n* .fa-syringe:before {\n  content: "\\f48e";\n}\n* .fa-table:before {\n  content: "\\f0ce";\n}\n* .fa-table-tennis:before {\n  content: "\\f45d";\n}\n* .fa-tablet:before {\n  content: "\\f10a";\n}\n* .fa-tablet-alt:before {\n  content: "\\f3fa";\n}\n* .fa-tablets:before {\n  content: "\\f490";\n}\n* .fa-tachometer-alt:before {\n  content: "\\f3fd";\n}\n* .fa-tag:before {\n  content: "\\f02b";\n}\n* .fa-tags:before {\n  content: "\\f02c";\n}\n* .fa-tape:before {\n  content: "\\f4db";\n}\n* .fa-tasks:before {\n  content: "\\f0ae";\n}\n* .fa-taxi:before {\n  content: "\\f1ba";\n}\n* .fa-teamspeak:before {\n  content: "\\f4f9";\n}\n* .fa-teeth:before {\n  content: "\\f62e";\n}\n* .fa-teeth-open:before {\n  content: "\\f62f";\n}\n* .fa-telegram:before {\n  content: "\\f2c6";\n}\n* .fa-telegram-plane:before {\n  content: "\\f3fe";\n}\n* .fa-temperature-high:before {\n  content: "\\f769";\n}\n* .fa-temperature-low:before {\n  content: "\\f76b";\n}\n* .fa-tencent-weibo:before {\n  content: "\\f1d5";\n}\n* .fa-tenge:before {\n  content: "\\f7d7";\n}\n* .fa-terminal:before {\n  content: "\\f120";\n}\n* .fa-text-height:before {\n  content: "\\f034";\n}\n* .fa-text-width:before {\n  content: "\\f035";\n}\n* .fa-th:before {\n  content: "\\f00a";\n}\n* .fa-th-large:before {\n  content: "\\f009";\n}\n* .fa-th-list:before {\n  content: "\\f00b";\n}\n* .fa-the-red-yeti:before {\n  content: "\\f69d";\n}\n* .fa-theater-masks:before {\n  content: "\\f630";\n}\n* .fa-themeco:before {\n  content: "\\f5c6";\n}\n* .fa-themeisle:before {\n  content: "\\f2b2";\n}\n* .fa-thermometer:before {\n  content: "\\f491";\n}\n* .fa-thermometer-empty:before {\n  content: "\\f2cb";\n}\n* .fa-thermometer-full:before {\n  content: "\\f2c7";\n}\n* .fa-thermometer-half:before {\n  content: "\\f2c9";\n}\n* .fa-thermometer-quarter:before {\n  content: "\\f2ca";\n}\n* .fa-thermometer-three-quarters:before {\n  content: "\\f2c8";\n}\n* .fa-think-peaks:before {\n  content: "\\f731";\n}\n* .fa-thumbs-down:before {\n  content: "\\f165";\n}\n* .fa-thumbs-up:before {\n  content: "\\f164";\n}\n* .fa-thumbtack:before {\n  content: "\\f08d";\n}\n* .fa-ticket-alt:before {\n  content: "\\f3ff";\n}\n* .fa-times:before {\n  content: "\\f00d";\n}\n* .fa-times-circle:before {\n  content: "\\f057";\n}\n* .fa-tint:before {\n  content: "\\f043";\n}\n* .fa-tint-slash:before {\n  content: "\\f5c7";\n}\n* .fa-tired:before {\n  content: "\\f5c8";\n}\n* .fa-toggle-off:before {\n  content: "\\f204";\n}\n* .fa-toggle-on:before {\n  content: "\\f205";\n}\n* .fa-toilet:before {\n  content: "\\f7d8";\n}\n* .fa-toilet-paper:before {\n  content: "\\f71e";\n}\n* .fa-toolbox:before {\n  content: "\\f552";\n}\n* .fa-tools:before {\n  content: "\\f7d9";\n}\n* .fa-tooth:before {\n  content: "\\f5c9";\n}\n* .fa-torah:before {\n  content: "\\f6a0";\n}\n* .fa-torii-gate:before {\n  content: "\\f6a1";\n}\n* .fa-tractor:before {\n  content: "\\f722";\n}\n* .fa-trade-federation:before {\n  content: "\\f513";\n}\n* .fa-trademark:before {\n  content: "\\f25c";\n}\n* .fa-traffic-light:before {\n  content: "\\f637";\n}\n* .fa-train:before {\n  content: "\\f238";\n}\n* .fa-tram:before {\n  content: "\\f7da";\n}\n* .fa-transgender:before {\n  content: "\\f224";\n}\n* .fa-transgender-alt:before {\n  content: "\\f225";\n}\n* .fa-trash:before {\n  content: "\\f1f8";\n}\n* .fa-trash-alt:before {\n  content: "\\f2ed";\n}\n* .fa-tree:before {\n  content: "\\f1bb";\n}\n* .fa-trello:before {\n  content: "\\f181";\n}\n* .fa-tripadvisor:before {\n  content: "\\f262";\n}\n* .fa-trophy:before {\n  content: "\\f091";\n}\n* .fa-truck:before {\n  content: "\\f0d1";\n}\n* .fa-truck-loading:before {\n  content: "\\f4de";\n}\n* .fa-truck-monster:before {\n  content: "\\f63b";\n}\n* .fa-truck-moving:before {\n  content: "\\f4df";\n}\n* .fa-truck-pickup:before {\n  content: "\\f63c";\n}\n* .fa-tshirt:before {\n  content: "\\f553";\n}\n* .fa-tty:before {\n  content: "\\f1e4";\n}\n* .fa-tumblr:before {\n  content: "\\f173";\n}\n* .fa-tumblr-square:before {\n  content: "\\f174";\n}\n* .fa-tv:before {\n  content: "\\f26c";\n}\n* .fa-twitch:before {\n  content: "\\f1e8";\n}\n* .fa-twitter:before {\n  content: "\\f099";\n}\n* .fa-twitter-square:before {\n  content: "\\f081";\n}\n* .fa-typo3:before {\n  content: "\\f42b";\n}\n* .fa-uber:before {\n  content: "\\f402";\n}\n* .fa-ubuntu:before {\n  content: "\\f7df";\n}\n* .fa-uikit:before {\n  content: "\\f403";\n}\n* .fa-umbrella:before {\n  content: "\\f0e9";\n}\n* .fa-umbrella-beach:before {\n  content: "\\f5ca";\n}\n* .fa-underline:before {\n  content: "\\f0cd";\n}\n* .fa-undo:before {\n  content: "\\f0e2";\n}\n* .fa-undo-alt:before {\n  content: "\\f2ea";\n}\n* .fa-uniregistry:before {\n  content: "\\f404";\n}\n* .fa-universal-access:before {\n  content: "\\f29a";\n}\n* .fa-university:before {\n  content: "\\f19c";\n}\n* .fa-unlink:before {\n  content: "\\f127";\n}\n* .fa-unlock:before {\n  content: "\\f09c";\n}\n* .fa-unlock-alt:before {\n  content: "\\f13e";\n}\n* .fa-untappd:before {\n  content: "\\f405";\n}\n* .fa-upload:before {\n  content: "\\f093";\n}\n* .fa-ups:before {\n  content: "\\f7e0";\n}\n* .fa-usb:before {\n  content: "\\f287";\n}\n* .fa-user:before {\n  content: "\\f007";\n}\n* .fa-user-alt:before {\n  content: "\\f406";\n}\n* .fa-user-alt-slash:before {\n  content: "\\f4fa";\n}\n* .fa-user-astronaut:before {\n  content: "\\f4fb";\n}\n* .fa-user-check:before {\n  content: "\\f4fc";\n}\n* .fa-user-circle:before {\n  content: "\\f2bd";\n}\n* .fa-user-clock:before {\n  content: "\\f4fd";\n}\n* .fa-user-cog:before {\n  content: "\\f4fe";\n}\n* .fa-user-edit:before {\n  content: "\\f4ff";\n}\n* .fa-user-friends:before {\n  content: "\\f500";\n}\n* .fa-user-graduate:before {\n  content: "\\f501";\n}\n* .fa-user-injured:before {\n  content: "\\f728";\n}\n* .fa-user-lock:before {\n  content: "\\f502";\n}\n* .fa-user-md:before {\n  content: "\\f0f0";\n}\n* .fa-user-minus:before {\n  content: "\\f503";\n}\n* .fa-user-ninja:before {\n  content: "\\f504";\n}\n* .fa-user-plus:before {\n  content: "\\f234";\n}\n* .fa-user-secret:before {\n  content: "\\f21b";\n}\n* .fa-user-shield:before {\n  content: "\\f505";\n}\n* .fa-user-slash:before {\n  content: "\\f506";\n}\n* .fa-user-tag:before {\n  content: "\\f507";\n}\n* .fa-user-tie:before {\n  content: "\\f508";\n}\n* .fa-user-times:before {\n  content: "\\f235";\n}\n* .fa-users:before {\n  content: "\\f0c0";\n}\n* .fa-users-cog:before {\n  content: "\\f509";\n}\n* .fa-usps:before {\n  content: "\\f7e1";\n}\n* .fa-ussunnah:before {\n  content: "\\f407";\n}\n* .fa-utensil-spoon:before {\n  content: "\\f2e5";\n}\n* .fa-utensils:before {\n  content: "\\f2e7";\n}\n* .fa-vaadin:before {\n  content: "\\f408";\n}\n* .fa-vector-square:before {\n  content: "\\f5cb";\n}\n* .fa-venus:before {\n  content: "\\f221";\n}\n* .fa-venus-double:before {\n  content: "\\f226";\n}\n* .fa-venus-mars:before {\n  content: "\\f228";\n}\n* .fa-viacoin:before {\n  content: "\\f237";\n}\n* .fa-viadeo:before {\n  content: "\\f2a9";\n}\n* .fa-viadeo-square:before {\n  content: "\\f2aa";\n}\n* .fa-vial:before {\n  content: "\\f492";\n}\n* .fa-vials:before {\n  content: "\\f493";\n}\n* .fa-viber:before {\n  content: "\\f409";\n}\n* .fa-video:before {\n  content: "\\f03d";\n}\n* .fa-video-slash:before {\n  content: "\\f4e2";\n}\n* .fa-vihara:before {\n  content: "\\f6a7";\n}\n* .fa-vimeo:before {\n  content: "\\f40a";\n}\n* .fa-vimeo-square:before {\n  content: "\\f194";\n}\n* .fa-vimeo-v:before {\n  content: "\\f27d";\n}\n* .fa-vine:before {\n  content: "\\f1ca";\n}\n* .fa-vk:before {\n  content: "\\f189";\n}\n* .fa-vnv:before {\n  content: "\\f40b";\n}\n* .fa-volleyball-ball:before {\n  content: "\\f45f";\n}\n* .fa-volume-down:before {\n  content: "\\f027";\n}\n* .fa-volume-mute:before {\n  content: "\\f6a9";\n}\n* .fa-volume-off:before {\n  content: "\\f026";\n}\n* .fa-volume-up:before {\n  content: "\\f028";\n}\n* .fa-vote-yea:before {\n  content: "\\f772";\n}\n* .fa-vr-cardboard:before {\n  content: "\\f729";\n}\n* .fa-vuejs:before {\n  content: "\\f41f";\n}\n* .fa-walking:before {\n  content: "\\f554";\n}\n* .fa-wallet:before {\n  content: "\\f555";\n}\n* .fa-warehouse:before {\n  content: "\\f494";\n}\n* .fa-water:before {\n  content: "\\f773";\n}\n* .fa-weebly:before {\n  content: "\\f5cc";\n}\n* .fa-weibo:before {\n  content: "\\f18a";\n}\n* .fa-weight:before {\n  content: "\\f496";\n}\n* .fa-weight-hanging:before {\n  content: "\\f5cd";\n}\n* .fa-weixin:before {\n  content: "\\f1d7";\n}\n* .fa-whatsapp:before {\n  content: "\\f232";\n}\n* .fa-whatsapp-square:before {\n  content: "\\f40c";\n}\n* .fa-wheelchair:before {\n  content: "\\f193";\n}\n* .fa-whmcs:before {\n  content: "\\f40d";\n}\n* .fa-wifi:before {\n  content: "\\f1eb";\n}\n* .fa-wikipedia-w:before {\n  content: "\\f266";\n}\n* .fa-wind:before {\n  content: "\\f72e";\n}\n* .fa-window-close:before {\n  content: "\\f410";\n}\n* .fa-window-maximize:before {\n  content: "\\f2d0";\n}\n* .fa-window-minimize:before {\n  content: "\\f2d1";\n}\n* .fa-window-restore:before {\n  content: "\\f2d2";\n}\n* .fa-windows:before {\n  content: "\\f17a";\n}\n* .fa-wine-bottle:before {\n  content: "\\f72f";\n}\n* .fa-wine-glass:before {\n  content: "\\f4e3";\n}\n* .fa-wine-glass-alt:before {\n  content: "\\f5ce";\n}\n* .fa-wix:before {\n  content: "\\f5cf";\n}\n* .fa-wizards-of-the-coast:before {\n  content: "\\f730";\n}\n* .fa-wolf-pack-battalion:before {\n  content: "\\f514";\n}\n* .fa-won-sign:before {\n  content: "\\f159";\n}\n* .fa-wordpress:before {\n  content: "\\f19a";\n}\n* .fa-wordpress-simple:before {\n  content: "\\f411";\n}\n* .fa-wpbeginner:before {\n  content: "\\f297";\n}\n* .fa-wpexplorer:before {\n  content: "\\f2de";\n}\n* .fa-wpforms:before {\n  content: "\\f298";\n}\n* .fa-wpressr:before {\n  content: "\\f3e4";\n}\n* .fa-wrench:before {\n  content: "\\f0ad";\n}\n* .fa-x-ray:before {\n  content: "\\f497";\n}\n* .fa-xbox:before {\n  content: "\\f412";\n}\n* .fa-xing:before {\n  content: "\\f168";\n}\n* .fa-xing-square:before {\n  content: "\\f169";\n}\n* .fa-y-combinator:before {\n  content: "\\f23b";\n}\n* .fa-yahoo:before {\n  content: "\\f19e";\n}\n* .fa-yandex:before {\n  content: "\\f413";\n}\n* .fa-yandex-international:before {\n  content: "\\f414";\n}\n* .fa-yarn:before {\n  content: "\\f7e3";\n}\n* .fa-yelp:before {\n  content: "\\f1e9";\n}\n* .fa-yen-sign:before {\n  content: "\\f157";\n}\n* .fa-yin-yang:before {\n  content: "\\f6ad";\n}\n* .fa-yoast:before {\n  content: "\\f2b1";\n}\n* .fa-youtube:before {\n  content: "\\f167";\n}\n* .fa-youtube-square:before {\n  content: "\\f431";\n}\n* .fa-zhihu:before {\n  content: "\\f63f";\n}\n* .sr-only {\n  border: 0;\n  clip: rect(0, 0, 0, 0);\n  height: 1px;\n  margin: -1px;\n  overflow: hidden;\n  padding: 0;\n  position: absolute;\n  width: 1px;\n}\n* .sr-only-focusable:active, * .sr-only-focusable:focus {\n  clip: auto;\n  height: auto;\n  margin: 0;\n  overflow: visible;\n  position: static;\n  width: auto;\n}\n\n@font-face {\n  font-family: "Font Awesome 5 Free";\n  font-style: normal;\n  font-weight: 900;\n  src: url("./assets/fonts/webfonts/fa-solid-900.woff2") format("woff2"), url("./assets/fonts/webfonts/fa-solid-900.woff") format("woff");\n}\n.fa,\n.fas {\n  font-family: "Font Awesome 5 Free";\n  font-weight: 900;\n}';

// src/elements/AppIcon.ts
var AppIcon = class extends AKElement {
  constructor() {
    super(...arguments);
    this.size = "pf-m-md" /* Medium */;
  }
  static get styles() {
    return [
      patternfly_fa_icons_default,
      avatar_default,
      i`
                :host {
                    max-height: calc(var(--icon-height) + var(--icon-border) + var(--icon-border));
                }
                :host([size="pf-m-lg"]) {
                    --icon-height: 4rem;
                    --icon-border: 0.25rem;
                }
                :host([size="pf-m-md"]) {
                    --icon-height: 2rem;
                    --icon-border: 0.125rem;
                }
                :host([size="pf-m-sm"]) {
                    --icon-height: 1rem;
                    --icon-border: 0.125rem;
                }
                :host([size="pf-m-xl"]) {
                    --icon-height: 6rem;
                    --icon-border: 0.25rem;
                }
                .pf-c-avatar {
                    --pf-c-avatar--BorderRadius: 0;
                    --pf-c-avatar--Height: calc(
                        var(--icon-height) + var(--icon-border) + var(--icon-border)
                    );
                    --pf-c-avatar--Width: calc(
                        var(--icon-height) + var(--icon-border) + var(--icon-border)
                    );
                }
                .icon {
                    font-size: var(--icon-height);
                    color: var(--ak-global--Color--100);
                    padding: var(--icon-border);
                    max-height: calc(var(--icon-height) + var(--icon-border) + var(--icon-border));
                    line-height: calc(var(--icon-height) + var(--icon-border) + var(--icon-border));
                    filter: drop-shadow(5px 5px 5px rgba(128, 128, 128, 0.25));
                }
                div {
                    height: calc(var(--icon-height) + var(--icon-border) + var(--icon-border));
                }
            `
    ];
  }
  render() {
    return z([this.name, this.icon]).with(
      [void 0, void 0],
      () => ke`<div><i class="icon fas fa-question-circle"></i></div>`
    ).with(
      [N._, N.string.startsWith("fa://")],
      ([_name, icon]) => ke`<div><i class="icon fas ${icon.replaceAll("fa://", "")}"></i></div>`
    ).with(
      [N._, N.string],
      ([_name, icon]) => ke`<img class="icon pf-c-avatar" src="${icon}" alt="${msg("Application Icon")}" />`
    ).with(
      [N.string, void 0],
      ([name]) => ke`<span class="icon">${name.charAt(0).toUpperCase()}</span>`
    ).exhaustive();
  }
};
__decorateClass([
  n({ type: String })
], AppIcon.prototype, "name", 2);
__decorateClass([
  n({ type: String })
], AppIcon.prototype, "icon", 2);
__decorateClass([
  n({ reflect: true })
], AppIcon.prototype, "size", 2);
AppIcon = __decorateClass([
  t("ak-app-icon")
], AppIcon);

// node_modules/@patternfly/patternfly/components/ExpandableSection/expandable-section.css
var expandable_section_default = '.pf-c-expandable-section {\n  --pf-c-expandable-section__toggle--PaddingTop: var(--pf-global--spacer--form-element);\n  --pf-c-expandable-section__toggle--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-expandable-section__toggle--PaddingBottom: var(--pf-global--spacer--form-element);\n  --pf-c-expandable-section__toggle--PaddingLeft: 0;\n  --pf-c-expandable-section__toggle--MarginTop: 0;\n  --pf-c-expandable-section__toggle--Color: var(--pf-global--link--Color);\n  --pf-c-expandable-section__toggle--hover--Color: var(--pf-global--link--Color--hover);\n  --pf-c-expandable-section__toggle--active--Color: var(--pf-global--link--Color--hover);\n  --pf-c-expandable-section__toggle--focus--Color: var(--pf-global--link--Color--hover);\n  --pf-c-expandable-section__toggle--m-expanded--Color: var(--pf-global--link--Color--hover);\n  --pf-c-expandable-section__toggle-icon--MinWidth: 1em;\n  --pf-c-expandable-section__toggle-icon--Color: var(--pf-global--Color--100);\n  --pf-c-expandable-section__toggle-icon--Transition: .2s ease-in 0s;\n  --pf-c-expandable-section__toggle-icon--Rotate: 0;\n  --pf-c-expandable-section__toggle-icon--m-expand-top--Rotate: 0;\n  --pf-c-expandable-section--m-expanded__toggle-icon--Rotate: 90deg;\n  --pf-c-expandable-section--m-expanded__toggle-icon--m-expand-top--Rotate: -90deg;\n  --pf-c-expandable-section__toggle-text--MarginLeft: calc(var(--pf-global--spacer--xs) + var(--pf-global--spacer--sm));\n  --pf-c-expandable-section__content--MarginTop: var(--pf-global--spacer--md);\n  --pf-c-expandable-section__content--MaxWidth: auto;\n  --pf-c-expandable-section--m-limit-width__content--MaxWidth: 46.875rem;\n  --pf-c-expandable-section--m-display-lg--BoxShadow: var(--pf-global--BoxShadow--md);\n  --pf-c-expandable-section--m-display-lg__toggle--PaddingTop: var(--pf-global--spacer--md);\n  --pf-c-expandable-section--m-display-lg__toggle--PaddingRight: var(--pf-global--spacer--md);\n  --pf-c-expandable-section--m-display-lg__toggle--PaddingBottom: var(--pf-global--spacer--md);\n  --pf-c-expandable-section--m-display-lg__toggle--PaddingLeft: var(--pf-global--spacer--md);\n  --pf-c-expandable-section--m-display-lg__content--MarginTop: 0;\n  --pf-c-expandable-section--m-display-lg__content--PaddingRight: var(--pf-global--spacer--lg);\n  --pf-c-expandable-section--m-display-lg__content--PaddingBottom: var(--pf-global--spacer--lg);\n  --pf-c-expandable-section--m-display-lg__content--PaddingLeft: var(--pf-global--spacer--lg);\n  --pf-c-expandable-section--m-display-lg--after--BackgroundColor: transparent;\n  --pf-c-expandable-section--m-display-lg--after--Width: var(--pf-global--BorderWidth--lg);\n  --pf-c-expandable-section--m-display-lg--m-expanded--after--BackgroundColor: var(--pf-global--primary-color--100);\n  --pf-c-expandable-section--m-indented__content--PaddingLeft: calc(var(--pf-c-expandable-section__toggle-text--MarginLeft) + var(--pf-c-expandable-section__toggle-icon--MinWidth));\n  --pf-c-expandable-section--m-truncate__content--LineClamp: 3;\n  --pf-c-expandable-section--m-truncate__toggle--MarginTop: var(--pf-global--spacer--xs);\n}\n.pf-c-expandable-section.pf-m-expanded {\n  --pf-c-expandable-section__toggle--Color: var(--pf-c-expandable-section__toggle--m-expanded--Color);\n  --pf-c-expandable-section__toggle-icon--Rotate: var(--pf-c-expandable-section--m-expanded__toggle-icon--Rotate);\n  --pf-c-expandable-section__toggle-icon--m-expand-top--Rotate: var(--pf-c-expandable-section--m-expanded__toggle-icon--m-expand-top--Rotate);\n  --pf-c-expandable-section--m-display-lg--after--BackgroundColor: var(--pf-c-expandable-section--m-display-lg--m-expanded--after--BackgroundColor);\n}\n.pf-c-expandable-section.pf-m-detached, .pf-c-expandable-section.pf-m-truncate {\n  --pf-c-expandable-section__content--MarginTop: 0;\n}\n.pf-c-expandable-section.pf-m-limit-width {\n  --pf-c-expandable-section__content--MaxWidth: var(--pf-c-expandable-section--m-limit-width__content--MaxWidth);\n}\n.pf-c-expandable-section.pf-m-display-lg {\n  --pf-c-expandable-section__toggle--PaddingTop: var(--pf-c-expandable-section--m-display-lg__toggle--PaddingTop);\n  --pf-c-expandable-section__toggle--PaddingRight: var(--pf-c-expandable-section--m-display-lg__toggle--PaddingRight);\n  --pf-c-expandable-section__toggle--PaddingBottom: var(--pf-c-expandable-section--m-display-lg__toggle--PaddingBottom);\n  --pf-c-expandable-section__toggle--PaddingLeft: var(--pf-c-expandable-section--m-display-lg__toggle--PaddingLeft);\n  --pf-c-expandable-section__content--PaddingRight: var(--pf-c-expandable-section--m-display-lg__content--PaddingRight);\n  --pf-c-expandable-section__content--PaddingBottom: var(--pf-c-expandable-section--m-display-lg__content--PaddingBottom);\n  --pf-c-expandable-section__content--PaddingLeft: var(--pf-c-expandable-section--m-display-lg__content--PaddingLeft);\n  --pf-c-expandable-section__content--MarginTop: var(--pf-c-expandable-section--m-display-lg__content--MarginTop);\n  position: relative;\n  box-shadow: var(--pf-c-expandable-section--m-display-lg--BoxShadow);\n}\n.pf-c-expandable-section.pf-m-display-lg::after {\n  position: absolute;\n  top: 0;\n  bottom: 0;\n  left: 0;\n  width: var(--pf-c-expandable-section--m-display-lg--after--Width);\n  content: "";\n  background-color: var(--pf-c-expandable-section--m-display-lg--after--BackgroundColor);\n}\n.pf-c-expandable-section.pf-m-indented {\n  --pf-c-expandable-section__content--PaddingLeft: var(--pf-c-expandable-section--m-indented__content--PaddingLeft);\n}\n.pf-c-expandable-section.pf-m-truncate {\n  --pf-c-expandable-section__toggle--MarginTop: var(--pf-c-expandable-section--m-truncate__toggle--MarginTop);\n  --pf-c-expandable-section__toggle--PaddingTop: 0;\n  --pf-c-expandable-section__toggle--PaddingRight: 0;\n  --pf-c-expandable-section__toggle--PaddingBottom: 0;\n  --pf-c-expandable-section__toggle-text--MarginLeft: 0;\n}\n.pf-c-expandable-section.pf-m-truncate:not(.pf-m-expanded) .pf-c-expandable-section__content {\n  display: -webkit-box;\n  -webkit-box-orient: vertical;\n  -webkit-line-clamp: var(--pf-c-expandable-section--m-truncate__content--LineClamp);\n  overflow: hidden;\n}\n.pf-c-expandable-section.pf-m-detached {\n  --pf-c-expandable-section--m-truncate__toggle--MarginTop: 0;\n}\n\n.pf-c-expandable-section__toggle {\n  display: flex;\n  padding: var(--pf-c-expandable-section__toggle--PaddingTop) var(--pf-c-expandable-section__toggle--PaddingRight) var(--pf-c-expandable-section__toggle--PaddingBottom) var(--pf-c-expandable-section__toggle--PaddingLeft);\n  margin-top: var(--pf-c-expandable-section__toggle--MarginTop);\n  color: var(--pf-c-expandable-section__toggle--Color);\n  border: none;\n}\n.pf-c-expandable-section__toggle:hover {\n  --pf-c-expandable-section__toggle--Color: var(--pf-c-expandable-section__toggle--hover--Color);\n}\n.pf-c-expandable-section__toggle:active, .pf-c-expandable-section__toggle.pf-m-active {\n  --pf-c-expandable-section__toggle--Color: var(--pf-c-expandable-section__toggle--active--Color);\n}\n.pf-c-expandable-section__toggle:focus {\n  --pf-c-expandable-section__toggle--Color: var(--pf-c-expandable-section__toggle--focus--Color);\n}\n\n.pf-c-expandable-section__toggle-icon {\n  min-width: var(--pf-c-expandable-section__toggle-icon--MinWidth);\n  color: var(--pf-c-expandable-section__toggle-icon--Color);\n  transition: var(--pf-c-expandable-section__toggle-icon--Transition);\n  transform: rotate(var(--pf-c-expandable-section__toggle-icon--Rotate));\n}\n.pf-c-expandable-section__toggle-icon.pf-m-expand-top {\n  --pf-c-expandable-section__toggle-icon--Rotate: var(--pf-c-expandable-section__toggle-icon--m-expand-top--Rotate);\n}\n\n.pf-c-expandable-section__toggle-text {\n  margin-left: var(--pf-c-expandable-section__toggle-text--MarginLeft);\n}\n\n.pf-c-expandable-section__content {\n  max-width: var(--pf-c-expandable-section__content--MaxWidth);\n  padding-right: var(--pf-c-expandable-section__content--PaddingRight);\n  padding-bottom: var(--pf-c-expandable-section__content--PaddingBottom);\n  padding-left: var(--pf-c-expandable-section__content--PaddingLeft);\n  margin-top: var(--pf-c-expandable-section__content--MarginTop);\n}\n\n.pf-m-overpass-font .pf-c-expandable-section__toggle {\n  font-weight: var(--pf-global--FontWeight--semi-bold);\n}';

// src/elements/Expand.ts
var Expand = class extends AKElement {
  constructor() {
    super(...arguments);
    this.expanded = false;
    this.textOpen = msg("Show less");
    this.textClosed = msg("Show more");
  }
  static get styles() {
    return [
      patternfly_base_default,
      expandable_section_default,
      i`
                .pf-c-expandable-section.pf-m-display-lg {
                    background-color: var(--pf-global--BackgroundColor--100);
                }
            `
    ];
  }
  render() {
    return ke`<div
            class="pf-c-expandable-section pf-m-display-lg pf-m-indented ${this.expanded ? "pf-m-expanded" : ""}"
        >
            <button
                type="button"
                class="pf-c-expandable-section__toggle"
                aria-expanded="${this.expanded}"
                @click=${() => {
      this.expanded = !this.expanded;
    }}
            >
                <span class="pf-c-expandable-section__toggle-icon">
                    <i class="fas fa-angle-right" aria-hidden="true"></i>
                </span>
                <span class="pf-c-expandable-section__toggle-text"
                    >${this.expanded ? this.textOpen : this.textClosed}</span
                >
            </button>
            <div class="pf-c-expandable-section__content" ?hidden=${!this.expanded}>
                <slot></slot>
            </div>
        </div>`;
  }
};
__decorateClass([
  n({ type: Boolean })
], Expand.prototype, "expanded", 2);
__decorateClass([
  n({ type: String, attribute: "text-open" })
], Expand.prototype, "textOpen", 2);
__decorateClass([
  n({ type: String, attribute: "text-closed" })
], Expand.prototype, "textClosed", 2);
Expand = __decorateClass([
  t("ak-expand")
], Expand);

// src/elements/table/TableModal.ts
var TableModal = class extends Table {
  constructor() {
    super(...arguments);
    this.size = "pf-m-lg" /* Large */;
    this._open = false;
  }
  set open(value) {
    this._open = value;
    if (value) {
      this.fetch();
    }
  }
  get open() {
    return this._open;
  }
  static get styles() {
    return super.styles.concat(
      modal_box_default,
      bullseye_default,
      content_default,
      backdrop_default,
      page_default,
      stack_default,
      MODAL_BUTTON_STYLES
    );
  }
  async fetch() {
    if (!this.open) {
      return;
    }
    return super.fetch();
  }
  closeModal() {
    this.resetForms();
    this.open = false;
  }
  resetForms() {
    this.querySelectorAll("[slot=form]").forEach((form) => {
      if ("resetForm" in form) {
        form?.resetForm();
      }
    });
  }
  onClick() {
    this.open = true;
    this.dispatchEvent(new ModalShowEvent(this));
    this.querySelectorAll("*").forEach((child) => {
      if ("requestUpdate" in child) {
        child.requestUpdate();
      }
    });
  }
  renderModalInner() {
    return this.renderTable();
  }
  renderModal() {
    return ke`<div
            class="pf-c-backdrop"
            @click=${(e3) => {
      e3.stopPropagation();
    }}
        >
            <div class="pf-l-bullseye">
                <div class="pf-c-modal-box ${this.size}" role="dialog" aria-modal="true">
                    <button
                        @click=${() => this.open = false}
                        class="pf-c-button pf-m-plain"
                        type="button"
                        aria-label=${msg("Close dialog")}
                    >
                        <i class="fas fa-times" aria-hidden="true"></i>
                    </button>
                    ${this.renderModalInner()}
                </div>
            </div>
        </div>`;
  }
  render() {
    return ke` <slot name="trigger" @click=${() => this.onClick()}></slot>
            ${this.open ? this.renderModal() : ""}`;
  }
};
__decorateClass([
  n()
], TableModal.prototype, "size", 2);
__decorateClass([
  n({ type: Boolean })
], TableModal.prototype, "open", 1);

// src/user/LibraryApplication/RACLaunchEndpointModal.ts
var RACLaunchEndpointModal = class extends TableModal {
  constructor() {
    super(...arguments);
    this.clickable = true;
    this.clickHandler = (item) => {
      if (!item.launchUrl) {
        return;
      }
      if (this.app?.openInNewTab) {
        window.open(item.launchUrl);
      } else {
        window.location.assign(item.launchUrl);
      }
    };
  }
  searchEnabled() {
    return true;
  }
  async apiEndpoint() {
    const endpoints = await new RacApi(DEFAULT_CONFIG).racEndpointsList({
      ...await this.defaultEndpointConfig(),
      provider: this.app?.provider || 0
    });
    if (this.open && endpoints.pagination.count === 1) {
      this.clickHandler(endpoints.results[0]);
      this.open = false;
    }
    return endpoints;
  }
  columns() {
    return [new TableColumn(msg("Name"))];
  }
  row(item) {
    return [ke`${item.name}`];
  }
  renderModalInner() {
    return ke`<section class="pf-c-modal-box__header pf-c-page__main-section pf-m-light">
                <div class="pf-c-content">
                    <h1 class="pf-c-title pf-m-2xl">${msg("Select endpoint to connect to")}</h1>
                </div>
            </section>
            <section class="pf-c-modal-box__body pf-m-light">${this.renderTable()}</section>
            <footer class="pf-c-modal-box__footer">
                <ak-spinner-button
                    .callAction=${async () => {
      this.open = false;
    }}
                    class="pf-m-secondary"
                >
                    ${msg("Cancel")}
                </ak-spinner-button>
            </footer>`;
  }
};
__decorateClass([
  n({ attribute: false })
], RACLaunchEndpointModal.prototype, "app", 2);
RACLaunchEndpointModal = __decorateClass([
  t("ak-library-rac-endpoint-launch")
], RACLaunchEndpointModal);

// src/user/LibraryApplication/index.ts
var LibraryApplication = class extends AKElement {
  constructor() {
    super(...arguments);
    this.selected = false;
    this.background = "";
  }
  static get styles() {
    return [
      patternfly_base_default,
      card_default,
      button_default,
      i`
                .pf-c-card {
                    --pf-c-card--BoxShadow: var(--pf-global--BoxShadow--md);
                }
                .pf-c-card__header {
                    justify-content: space-between;
                    flex-direction: column;
                }
                .pf-c-card__header a {
                    display: flex;
                    flex-direction: column;
                    justify-content: center;
                }
                a:hover {
                    text-decoration: none;
                }
                .expander {
                    flex-grow: 1;
                }
                .pf-c-card__title {
                    text-align: center;
                    /* This is not ideal as it hard limits us to 2 lines of text for the title
                    of the application. In theory that should be fine for most cases, but ideally
                    we don't do this */
                    height: 48px;
                }
            `
    ];
  }
  renderExpansion(application) {
    const me2 = rootInterface()?.me;
    return ke`<ak-expand textOpen=${msg("Fewer details")} textClosed=${msg("More details")}>
            <div class="pf-c-content">
                <small>${application.metaPublisher}</small>
            </div>
            ${truncateWords(application.metaDescription || "", 10)}
            ${rootInterface()?.uiConfig?.enabledFeatures.applicationEdit && me2?.user.isSuperuser ? ke`
                      <a
                          class="pf-c-button pf-m-control pf-m-small pf-m-block"
                          href="${globalAK().api.base}if/admin/#/core/applications/${application?.slug}"
                      >
                          <i class="fas fa-edit"></i>&nbsp;${msg("Edit")}
                      </a>
                  ` : ke``}
        </ak-expand>`;
  }
  renderLaunch() {
    if (!this.application) {
      return ke``;
    }
    if (this.application?.launchUrl === "goauthentik.io://providers/rac/launch") {
      return ke`<div class="pf-c-card__header">
                    <a
                        @click=${() => {
        this.racEndpointLaunch?.onClick();
      }}
                    >
                        <ak-app-icon
                            size=${"pf-m-lg" /* Large */}
                            name=${this.application.name}
                            icon=${to(this.application.metaIcon || void 0)}
                        ></ak-app-icon>
                    </a>
                </div>
                <div class="pf-c-card__title">
                    <a
                        @click=${() => {
        this.racEndpointLaunch?.onClick();
      }}
                    >
                        ${this.application.name}
                    </a>
                </div>
                <ak-library-rac-endpoint-launch .app=${this.application}>
                </ak-library-rac-endpoint-launch>`;
    }
    return ke`<div class="pf-c-card__header">
                <a
                    href="${to(this.application.launchUrl ?? "")}"
                    target="${to(this.application.openInNewTab ? "_blank" : void 0)}"
                >
                    <ak-app-icon
                        size=${"pf-m-lg" /* Large */}
                        name=${this.application.name}
                        icon=${to(this.application.metaIcon || void 0)}
                    ></ak-app-icon>
                </a>
            </div>
            <div class="pf-c-card__title">
                <a
                    href="${to(this.application.launchUrl ?? "")}"
                    target="${to(this.application.openInNewTab ? "_blank" : void 0)}"
                    >${this.application.name}</a
                >
            </div>`;
  }
  render() {
    if (!this.application) {
      return ke`<ak-spinner></ak-spinner>`;
    }
    const me2 = rootInterface()?.me;
    const expandable = rootInterface()?.uiConfig?.enabledFeatures.applicationEdit && me2?.user.isSuperuser || this.application.metaPublisher !== "" || this.application.metaDescription !== "";
    const classes = { "pf-m-selectable": this.selected, "pf-m-selected": this.selected };
    const styles2 = this.background ? { background: this.background } : {};
    return ke` <div
            class="pf-c-card pf-m-hoverable pf-m-compact ${Rt(classes)}"
            style=${se(styles2)}
        >
            ${this.renderLaunch()}
            <div class="expander"></div>
            ${expandable ? this.renderExpansion(this.application) : D}
        </div>`;
  }
};
__decorateClass([
  n({ attribute: false })
], LibraryApplication.prototype, "application", 2);
__decorateClass([
  n({ type: Boolean })
], LibraryApplication.prototype, "selected", 2);
__decorateClass([
  n()
], LibraryApplication.prototype, "background", 2);
__decorateClass([
  e("ak-library-rac-endpoint-launch")
], LibraryApplication.prototype, "racEndpointLaunch", 2);
LibraryApplication = __decorateClass([
  t("ak-library-app")
], LibraryApplication);

// src/user/LibraryPage/LibraryPageImpl.css.ts
var styles = [patternfly_base_default, display_default, empty_state_default, page_default, content_default].concat(i`
    :host {
        display: block;
        padding: 3% 5%;
    }
    .header {
        display: flex;
        flex-direction: row;
        justify-content: space-between;
    }
    .header input {
        width: 30ch;
        box-sizing: border-box;
        border: 0;
        border-bottom: 1px solid;
        border-bottom-color: #fd4b2d;
        background-color: transparent;
        font-size: 1.5rem;
    }
    .header input:focus {
        outline: 0;
    }
    .pf-c-page__main {
        overflow: hidden;
    }
    .pf-c-page__main-section {
        background-color: transparent;
    }
`);
var LibraryPageImpl_css_default = styles;

// src/user/LibraryPage/LibraryPageImpl.utils.ts
var isFullUrlRe = new RegExp("://");
var isHttpRe = new RegExp("http(s?)://");
var isAuthentikSpecialRe = new RegExp("goauthentik.io://");
var isNotFullUrl = (url) => !isFullUrlRe.test(url);
var isHttp = (url) => isHttpRe.test(url);
var isAuthentikSpecial = (url) => isAuthentikSpecialRe.test(url);
var appHasLaunchUrl = (app) => {
  const url = app.launchUrl;
  return !!(typeof url === "string" && url !== "" && (isHttp(url) || isNotFullUrl(url) || isAuthentikSpecial(url)));
};

// node_modules/@patternfly/patternfly/utilities/Spacing/spacing.css
var spacing_default = ".pf-u-m-auto {\n  margin: auto !important;\n}\n\n.pf-u-m-0 {\n  margin: 0 !important;\n}\n\n.pf-u-m-xs {\n  margin: var(--pf-global--spacer--xs) !important;\n}\n\n.pf-u-m-sm {\n  margin: var(--pf-global--spacer--sm) !important;\n}\n\n.pf-u-m-md {\n  margin: var(--pf-global--spacer--md) !important;\n}\n\n.pf-u-m-lg {\n  margin: var(--pf-global--spacer--lg) !important;\n}\n\n.pf-u-m-xl {\n  margin: var(--pf-global--spacer--xl) !important;\n}\n\n.pf-u-m-2xl {\n  margin: var(--pf-global--spacer--2xl) !important;\n}\n\n.pf-u-m-3xl {\n  margin: var(--pf-global--spacer--3xl) !important;\n}\n\n.pf-u-m-4xl {\n  margin: var(--pf-global--spacer--4xl) !important;\n}\n\n.pf-u-mt-auto {\n  margin-top: auto !important;\n}\n\n.pf-u-mt-0 {\n  margin-top: 0 !important;\n}\n\n.pf-u-mt-xs {\n  margin-top: var(--pf-global--spacer--xs) !important;\n}\n\n.pf-u-mt-sm {\n  margin-top: var(--pf-global--spacer--sm) !important;\n}\n\n.pf-u-mt-md {\n  margin-top: var(--pf-global--spacer--md) !important;\n}\n\n.pf-u-mt-lg {\n  margin-top: var(--pf-global--spacer--lg) !important;\n}\n\n.pf-u-mt-xl {\n  margin-top: var(--pf-global--spacer--xl) !important;\n}\n\n.pf-u-mt-2xl {\n  margin-top: var(--pf-global--spacer--2xl) !important;\n}\n\n.pf-u-mt-3xl {\n  margin-top: var(--pf-global--spacer--3xl) !important;\n}\n\n.pf-u-mt-4xl {\n  margin-top: var(--pf-global--spacer--4xl) !important;\n}\n\n.pf-u-mr-auto {\n  margin-right: auto !important;\n}\n\n.pf-u-mr-0 {\n  margin-right: 0 !important;\n}\n\n.pf-u-mr-xs {\n  margin-right: var(--pf-global--spacer--xs) !important;\n}\n\n.pf-u-mr-sm {\n  margin-right: var(--pf-global--spacer--sm) !important;\n}\n\n.pf-u-mr-md {\n  margin-right: var(--pf-global--spacer--md) !important;\n}\n\n.pf-u-mr-lg {\n  margin-right: var(--pf-global--spacer--lg) !important;\n}\n\n.pf-u-mr-xl {\n  margin-right: var(--pf-global--spacer--xl) !important;\n}\n\n.pf-u-mr-2xl {\n  margin-right: var(--pf-global--spacer--2xl) !important;\n}\n\n.pf-u-mr-3xl {\n  margin-right: var(--pf-global--spacer--3xl) !important;\n}\n\n.pf-u-mr-4xl {\n  margin-right: var(--pf-global--spacer--4xl) !important;\n}\n\n.pf-u-mb-auto {\n  margin-bottom: auto !important;\n}\n\n.pf-u-mb-0 {\n  margin-bottom: 0 !important;\n}\n\n.pf-u-mb-xs {\n  margin-bottom: var(--pf-global--spacer--xs) !important;\n}\n\n.pf-u-mb-sm {\n  margin-bottom: var(--pf-global--spacer--sm) !important;\n}\n\n.pf-u-mb-md {\n  margin-bottom: var(--pf-global--spacer--md) !important;\n}\n\n.pf-u-mb-lg {\n  margin-bottom: var(--pf-global--spacer--lg) !important;\n}\n\n.pf-u-mb-xl {\n  margin-bottom: var(--pf-global--spacer--xl) !important;\n}\n\n.pf-u-mb-2xl {\n  margin-bottom: var(--pf-global--spacer--2xl) !important;\n}\n\n.pf-u-mb-3xl {\n  margin-bottom: var(--pf-global--spacer--3xl) !important;\n}\n\n.pf-u-mb-4xl {\n  margin-bottom: var(--pf-global--spacer--4xl) !important;\n}\n\n.pf-u-ml-auto {\n  margin-left: auto !important;\n}\n\n.pf-u-ml-0 {\n  margin-left: 0 !important;\n}\n\n.pf-u-ml-xs {\n  margin-left: var(--pf-global--spacer--xs) !important;\n}\n\n.pf-u-ml-sm {\n  margin-left: var(--pf-global--spacer--sm) !important;\n}\n\n.pf-u-ml-md {\n  margin-left: var(--pf-global--spacer--md) !important;\n}\n\n.pf-u-ml-lg {\n  margin-left: var(--pf-global--spacer--lg) !important;\n}\n\n.pf-u-ml-xl {\n  margin-left: var(--pf-global--spacer--xl) !important;\n}\n\n.pf-u-ml-2xl {\n  margin-left: var(--pf-global--spacer--2xl) !important;\n}\n\n.pf-u-ml-3xl {\n  margin-left: var(--pf-global--spacer--3xl) !important;\n}\n\n.pf-u-ml-4xl {\n  margin-left: var(--pf-global--spacer--4xl) !important;\n}\n\n.pf-u-mx-auto {\n  margin-right: auto !important;\n  margin-left: auto !important;\n}\n\n.pf-u-mx-0 {\n  margin-right: 0 !important;\n  margin-left: 0 !important;\n}\n\n.pf-u-mx-xs {\n  margin-right: var(--pf-global--spacer--xs) !important;\n  margin-left: var(--pf-global--spacer--xs) !important;\n}\n\n.pf-u-mx-sm {\n  margin-right: var(--pf-global--spacer--sm) !important;\n  margin-left: var(--pf-global--spacer--sm) !important;\n}\n\n.pf-u-mx-md {\n  margin-right: var(--pf-global--spacer--md) !important;\n  margin-left: var(--pf-global--spacer--md) !important;\n}\n\n.pf-u-mx-lg {\n  margin-right: var(--pf-global--spacer--lg) !important;\n  margin-left: var(--pf-global--spacer--lg) !important;\n}\n\n.pf-u-mx-xl {\n  margin-right: var(--pf-global--spacer--xl) !important;\n  margin-left: var(--pf-global--spacer--xl) !important;\n}\n\n.pf-u-mx-2xl {\n  margin-right: var(--pf-global--spacer--2xl) !important;\n  margin-left: var(--pf-global--spacer--2xl) !important;\n}\n\n.pf-u-mx-3xl {\n  margin-right: var(--pf-global--spacer--3xl) !important;\n  margin-left: var(--pf-global--spacer--3xl) !important;\n}\n\n.pf-u-mx-4xl {\n  margin-right: var(--pf-global--spacer--4xl) !important;\n  margin-left: var(--pf-global--spacer--4xl) !important;\n}\n\n.pf-u-my-auto {\n  margin-top: auto !important;\n  margin-bottom: auto !important;\n}\n\n.pf-u-my-0 {\n  margin-top: 0 !important;\n  margin-bottom: 0 !important;\n}\n\n.pf-u-my-xs {\n  margin-top: var(--pf-global--spacer--xs) !important;\n  margin-bottom: var(--pf-global--spacer--xs) !important;\n}\n\n.pf-u-my-sm {\n  margin-top: var(--pf-global--spacer--sm) !important;\n  margin-bottom: var(--pf-global--spacer--sm) !important;\n}\n\n.pf-u-my-md {\n  margin-top: var(--pf-global--spacer--md) !important;\n  margin-bottom: var(--pf-global--spacer--md) !important;\n}\n\n.pf-u-my-lg {\n  margin-top: var(--pf-global--spacer--lg) !important;\n  margin-bottom: var(--pf-global--spacer--lg) !important;\n}\n\n.pf-u-my-xl {\n  margin-top: var(--pf-global--spacer--xl) !important;\n  margin-bottom: var(--pf-global--spacer--xl) !important;\n}\n\n.pf-u-my-2xl {\n  margin-top: var(--pf-global--spacer--2xl) !important;\n  margin-bottom: var(--pf-global--spacer--2xl) !important;\n}\n\n.pf-u-my-3xl {\n  margin-top: var(--pf-global--spacer--3xl) !important;\n  margin-bottom: var(--pf-global--spacer--3xl) !important;\n}\n\n.pf-u-my-4xl {\n  margin-top: var(--pf-global--spacer--4xl) !important;\n  margin-bottom: var(--pf-global--spacer--4xl) !important;\n}\n\n.pf-u-p-auto {\n  padding: auto !important;\n}\n\n.pf-u-p-0 {\n  padding: 0 !important;\n}\n\n.pf-u-p-xs {\n  padding: var(--pf-global--spacer--xs) !important;\n}\n\n.pf-u-p-sm {\n  padding: var(--pf-global--spacer--sm) !important;\n}\n\n.pf-u-p-md {\n  padding: var(--pf-global--spacer--md) !important;\n}\n\n.pf-u-p-lg {\n  padding: var(--pf-global--spacer--lg) !important;\n}\n\n.pf-u-p-xl {\n  padding: var(--pf-global--spacer--xl) !important;\n}\n\n.pf-u-p-2xl {\n  padding: var(--pf-global--spacer--2xl) !important;\n}\n\n.pf-u-p-3xl {\n  padding: var(--pf-global--spacer--3xl) !important;\n}\n\n.pf-u-p-4xl {\n  padding: var(--pf-global--spacer--4xl) !important;\n}\n\n.pf-u-pt-auto {\n  padding-top: auto !important;\n}\n\n.pf-u-pt-0 {\n  padding-top: 0 !important;\n}\n\n.pf-u-pt-xs {\n  padding-top: var(--pf-global--spacer--xs) !important;\n}\n\n.pf-u-pt-sm {\n  padding-top: var(--pf-global--spacer--sm) !important;\n}\n\n.pf-u-pt-md {\n  padding-top: var(--pf-global--spacer--md) !important;\n}\n\n.pf-u-pt-lg {\n  padding-top: var(--pf-global--spacer--lg) !important;\n}\n\n.pf-u-pt-xl {\n  padding-top: var(--pf-global--spacer--xl) !important;\n}\n\n.pf-u-pt-2xl {\n  padding-top: var(--pf-global--spacer--2xl) !important;\n}\n\n.pf-u-pt-3xl {\n  padding-top: var(--pf-global--spacer--3xl) !important;\n}\n\n.pf-u-pt-4xl {\n  padding-top: var(--pf-global--spacer--4xl) !important;\n}\n\n.pf-u-pr-auto {\n  padding-right: auto !important;\n}\n\n.pf-u-pr-0 {\n  padding-right: 0 !important;\n}\n\n.pf-u-pr-xs {\n  padding-right: var(--pf-global--spacer--xs) !important;\n}\n\n.pf-u-pr-sm {\n  padding-right: var(--pf-global--spacer--sm) !important;\n}\n\n.pf-u-pr-md {\n  padding-right: var(--pf-global--spacer--md) !important;\n}\n\n.pf-u-pr-lg {\n  padding-right: var(--pf-global--spacer--lg) !important;\n}\n\n.pf-u-pr-xl {\n  padding-right: var(--pf-global--spacer--xl) !important;\n}\n\n.pf-u-pr-2xl {\n  padding-right: var(--pf-global--spacer--2xl) !important;\n}\n\n.pf-u-pr-3xl {\n  padding-right: var(--pf-global--spacer--3xl) !important;\n}\n\n.pf-u-pr-4xl {\n  padding-right: var(--pf-global--spacer--4xl) !important;\n}\n\n.pf-u-pb-auto {\n  padding-bottom: auto !important;\n}\n\n.pf-u-pb-0 {\n  padding-bottom: 0 !important;\n}\n\n.pf-u-pb-xs {\n  padding-bottom: var(--pf-global--spacer--xs) !important;\n}\n\n.pf-u-pb-sm {\n  padding-bottom: var(--pf-global--spacer--sm) !important;\n}\n\n.pf-u-pb-md {\n  padding-bottom: var(--pf-global--spacer--md) !important;\n}\n\n.pf-u-pb-lg {\n  padding-bottom: var(--pf-global--spacer--lg) !important;\n}\n\n.pf-u-pb-xl {\n  padding-bottom: var(--pf-global--spacer--xl) !important;\n}\n\n.pf-u-pb-2xl {\n  padding-bottom: var(--pf-global--spacer--2xl) !important;\n}\n\n.pf-u-pb-3xl {\n  padding-bottom: var(--pf-global--spacer--3xl) !important;\n}\n\n.pf-u-pb-4xl {\n  padding-bottom: var(--pf-global--spacer--4xl) !important;\n}\n\n.pf-u-pl-auto {\n  padding-left: auto !important;\n}\n\n.pf-u-pl-0 {\n  padding-left: 0 !important;\n}\n\n.pf-u-pl-xs {\n  padding-left: var(--pf-global--spacer--xs) !important;\n}\n\n.pf-u-pl-sm {\n  padding-left: var(--pf-global--spacer--sm) !important;\n}\n\n.pf-u-pl-md {\n  padding-left: var(--pf-global--spacer--md) !important;\n}\n\n.pf-u-pl-lg {\n  padding-left: var(--pf-global--spacer--lg) !important;\n}\n\n.pf-u-pl-xl {\n  padding-left: var(--pf-global--spacer--xl) !important;\n}\n\n.pf-u-pl-2xl {\n  padding-left: var(--pf-global--spacer--2xl) !important;\n}\n\n.pf-u-pl-3xl {\n  padding-left: var(--pf-global--spacer--3xl) !important;\n}\n\n.pf-u-pl-4xl {\n  padding-left: var(--pf-global--spacer--4xl) !important;\n}\n\n.pf-u-px-auto {\n  padding-right: auto !important;\n  padding-left: auto !important;\n}\n\n.pf-u-px-0 {\n  padding-right: 0 !important;\n  padding-left: 0 !important;\n}\n\n.pf-u-px-xs {\n  padding-right: var(--pf-global--spacer--xs) !important;\n  padding-left: var(--pf-global--spacer--xs) !important;\n}\n\n.pf-u-px-sm {\n  padding-right: var(--pf-global--spacer--sm) !important;\n  padding-left: var(--pf-global--spacer--sm) !important;\n}\n\n.pf-u-px-md {\n  padding-right: var(--pf-global--spacer--md) !important;\n  padding-left: var(--pf-global--spacer--md) !important;\n}\n\n.pf-u-px-lg {\n  padding-right: var(--pf-global--spacer--lg) !important;\n  padding-left: var(--pf-global--spacer--lg) !important;\n}\n\n.pf-u-px-xl {\n  padding-right: var(--pf-global--spacer--xl) !important;\n  padding-left: var(--pf-global--spacer--xl) !important;\n}\n\n.pf-u-px-2xl {\n  padding-right: var(--pf-global--spacer--2xl) !important;\n  padding-left: var(--pf-global--spacer--2xl) !important;\n}\n\n.pf-u-px-3xl {\n  padding-right: var(--pf-global--spacer--3xl) !important;\n  padding-left: var(--pf-global--spacer--3xl) !important;\n}\n\n.pf-u-px-4xl {\n  padding-right: var(--pf-global--spacer--4xl) !important;\n  padding-left: var(--pf-global--spacer--4xl) !important;\n}\n\n.pf-u-py-auto {\n  padding-top: auto !important;\n  padding-bottom: auto !important;\n}\n\n.pf-u-py-0 {\n  padding-top: 0 !important;\n  padding-bottom: 0 !important;\n}\n\n.pf-u-py-xs {\n  padding-top: var(--pf-global--spacer--xs) !important;\n  padding-bottom: var(--pf-global--spacer--xs) !important;\n}\n\n.pf-u-py-sm {\n  padding-top: var(--pf-global--spacer--sm) !important;\n  padding-bottom: var(--pf-global--spacer--sm) !important;\n}\n\n.pf-u-py-md {\n  padding-top: var(--pf-global--spacer--md) !important;\n  padding-bottom: var(--pf-global--spacer--md) !important;\n}\n\n.pf-u-py-lg {\n  padding-top: var(--pf-global--spacer--lg) !important;\n  padding-bottom: var(--pf-global--spacer--lg) !important;\n}\n\n.pf-u-py-xl {\n  padding-top: var(--pf-global--spacer--xl) !important;\n  padding-bottom: var(--pf-global--spacer--xl) !important;\n}\n\n.pf-u-py-2xl {\n  padding-top: var(--pf-global--spacer--2xl) !important;\n  padding-bottom: var(--pf-global--spacer--2xl) !important;\n}\n\n.pf-u-py-3xl {\n  padding-top: var(--pf-global--spacer--3xl) !important;\n  padding-bottom: var(--pf-global--spacer--3xl) !important;\n}\n\n.pf-u-py-4xl {\n  padding-top: var(--pf-global--spacer--4xl) !important;\n  padding-bottom: var(--pf-global--spacer--4xl) !important;\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-m-auto-on-sm {\n    margin: auto !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-m-0-on-sm {\n    margin: 0 !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-m-xs-on-sm {\n    margin: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-m-sm-on-sm {\n    margin: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-m-md-on-sm {\n    margin: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-m-lg-on-sm {\n    margin: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-m-xl-on-sm {\n    margin: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-m-2xl-on-sm {\n    margin: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-m-3xl-on-sm {\n    margin: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-m-4xl-on-sm {\n    margin: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mt-auto-on-sm {\n    margin-top: auto !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mt-0-on-sm {\n    margin-top: 0 !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mt-xs-on-sm {\n    margin-top: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mt-sm-on-sm {\n    margin-top: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mt-md-on-sm {\n    margin-top: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mt-lg-on-sm {\n    margin-top: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mt-xl-on-sm {\n    margin-top: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mt-2xl-on-sm {\n    margin-top: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mt-3xl-on-sm {\n    margin-top: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mt-4xl-on-sm {\n    margin-top: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mr-auto-on-sm {\n    margin-right: auto !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mr-0-on-sm {\n    margin-right: 0 !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mr-xs-on-sm {\n    margin-right: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mr-sm-on-sm {\n    margin-right: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mr-md-on-sm {\n    margin-right: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mr-lg-on-sm {\n    margin-right: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mr-xl-on-sm {\n    margin-right: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mr-2xl-on-sm {\n    margin-right: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mr-3xl-on-sm {\n    margin-right: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mr-4xl-on-sm {\n    margin-right: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mb-auto-on-sm {\n    margin-bottom: auto !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mb-0-on-sm {\n    margin-bottom: 0 !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mb-xs-on-sm {\n    margin-bottom: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mb-sm-on-sm {\n    margin-bottom: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mb-md-on-sm {\n    margin-bottom: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mb-lg-on-sm {\n    margin-bottom: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mb-xl-on-sm {\n    margin-bottom: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mb-2xl-on-sm {\n    margin-bottom: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mb-3xl-on-sm {\n    margin-bottom: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mb-4xl-on-sm {\n    margin-bottom: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-ml-auto-on-sm {\n    margin-left: auto !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-ml-0-on-sm {\n    margin-left: 0 !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-ml-xs-on-sm {\n    margin-left: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-ml-sm-on-sm {\n    margin-left: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-ml-md-on-sm {\n    margin-left: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-ml-lg-on-sm {\n    margin-left: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-ml-xl-on-sm {\n    margin-left: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-ml-2xl-on-sm {\n    margin-left: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-ml-3xl-on-sm {\n    margin-left: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-ml-4xl-on-sm {\n    margin-left: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mx-auto-on-sm {\n    margin-right: auto !important;\n    margin-left: auto !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mx-0-on-sm {\n    margin-right: 0 !important;\n    margin-left: 0 !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mx-xs-on-sm {\n    margin-right: var(--pf-global--spacer--xs) !important;\n    margin-left: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mx-sm-on-sm {\n    margin-right: var(--pf-global--spacer--sm) !important;\n    margin-left: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mx-md-on-sm {\n    margin-right: var(--pf-global--spacer--md) !important;\n    margin-left: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mx-lg-on-sm {\n    margin-right: var(--pf-global--spacer--lg) !important;\n    margin-left: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mx-xl-on-sm {\n    margin-right: var(--pf-global--spacer--xl) !important;\n    margin-left: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mx-2xl-on-sm {\n    margin-right: var(--pf-global--spacer--2xl) !important;\n    margin-left: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mx-3xl-on-sm {\n    margin-right: var(--pf-global--spacer--3xl) !important;\n    margin-left: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-mx-4xl-on-sm {\n    margin-right: var(--pf-global--spacer--4xl) !important;\n    margin-left: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-my-auto-on-sm {\n    margin-top: auto !important;\n    margin-bottom: auto !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-my-0-on-sm {\n    margin-top: 0 !important;\n    margin-bottom: 0 !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-my-xs-on-sm {\n    margin-top: var(--pf-global--spacer--xs) !important;\n    margin-bottom: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-my-sm-on-sm {\n    margin-top: var(--pf-global--spacer--sm) !important;\n    margin-bottom: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-my-md-on-sm {\n    margin-top: var(--pf-global--spacer--md) !important;\n    margin-bottom: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-my-lg-on-sm {\n    margin-top: var(--pf-global--spacer--lg) !important;\n    margin-bottom: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-my-xl-on-sm {\n    margin-top: var(--pf-global--spacer--xl) !important;\n    margin-bottom: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-my-2xl-on-sm {\n    margin-top: var(--pf-global--spacer--2xl) !important;\n    margin-bottom: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-my-3xl-on-sm {\n    margin-top: var(--pf-global--spacer--3xl) !important;\n    margin-bottom: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-my-4xl-on-sm {\n    margin-top: var(--pf-global--spacer--4xl) !important;\n    margin-bottom: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-p-auto-on-sm {\n    padding: auto !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-p-0-on-sm {\n    padding: 0 !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-p-xs-on-sm {\n    padding: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-p-sm-on-sm {\n    padding: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-p-md-on-sm {\n    padding: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-p-lg-on-sm {\n    padding: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-p-xl-on-sm {\n    padding: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-p-2xl-on-sm {\n    padding: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-p-3xl-on-sm {\n    padding: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-p-4xl-on-sm {\n    padding: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pt-auto-on-sm {\n    padding-top: auto !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pt-0-on-sm {\n    padding-top: 0 !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pt-xs-on-sm {\n    padding-top: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pt-sm-on-sm {\n    padding-top: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pt-md-on-sm {\n    padding-top: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pt-lg-on-sm {\n    padding-top: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pt-xl-on-sm {\n    padding-top: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pt-2xl-on-sm {\n    padding-top: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pt-3xl-on-sm {\n    padding-top: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pt-4xl-on-sm {\n    padding-top: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pr-auto-on-sm {\n    padding-right: auto !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pr-0-on-sm {\n    padding-right: 0 !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pr-xs-on-sm {\n    padding-right: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pr-sm-on-sm {\n    padding-right: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pr-md-on-sm {\n    padding-right: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pr-lg-on-sm {\n    padding-right: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pr-xl-on-sm {\n    padding-right: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pr-2xl-on-sm {\n    padding-right: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pr-3xl-on-sm {\n    padding-right: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pr-4xl-on-sm {\n    padding-right: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pb-auto-on-sm {\n    padding-bottom: auto !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pb-0-on-sm {\n    padding-bottom: 0 !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pb-xs-on-sm {\n    padding-bottom: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pb-sm-on-sm {\n    padding-bottom: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pb-md-on-sm {\n    padding-bottom: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pb-lg-on-sm {\n    padding-bottom: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pb-xl-on-sm {\n    padding-bottom: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pb-2xl-on-sm {\n    padding-bottom: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pb-3xl-on-sm {\n    padding-bottom: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pb-4xl-on-sm {\n    padding-bottom: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pl-auto-on-sm {\n    padding-left: auto !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pl-0-on-sm {\n    padding-left: 0 !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pl-xs-on-sm {\n    padding-left: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pl-sm-on-sm {\n    padding-left: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pl-md-on-sm {\n    padding-left: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pl-lg-on-sm {\n    padding-left: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pl-xl-on-sm {\n    padding-left: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pl-2xl-on-sm {\n    padding-left: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pl-3xl-on-sm {\n    padding-left: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-pl-4xl-on-sm {\n    padding-left: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-px-auto-on-sm {\n    padding-right: auto !important;\n    padding-left: auto !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-px-0-on-sm {\n    padding-right: 0 !important;\n    padding-left: 0 !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-px-xs-on-sm {\n    padding-right: var(--pf-global--spacer--xs) !important;\n    padding-left: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-px-sm-on-sm {\n    padding-right: var(--pf-global--spacer--sm) !important;\n    padding-left: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-px-md-on-sm {\n    padding-right: var(--pf-global--spacer--md) !important;\n    padding-left: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-px-lg-on-sm {\n    padding-right: var(--pf-global--spacer--lg) !important;\n    padding-left: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-px-xl-on-sm {\n    padding-right: var(--pf-global--spacer--xl) !important;\n    padding-left: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-px-2xl-on-sm {\n    padding-right: var(--pf-global--spacer--2xl) !important;\n    padding-left: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-px-3xl-on-sm {\n    padding-right: var(--pf-global--spacer--3xl) !important;\n    padding-left: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-px-4xl-on-sm {\n    padding-right: var(--pf-global--spacer--4xl) !important;\n    padding-left: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-py-auto-on-sm {\n    padding-top: auto !important;\n    padding-bottom: auto !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-py-0-on-sm {\n    padding-top: 0 !important;\n    padding-bottom: 0 !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-py-xs-on-sm {\n    padding-top: var(--pf-global--spacer--xs) !important;\n    padding-bottom: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-py-sm-on-sm {\n    padding-top: var(--pf-global--spacer--sm) !important;\n    padding-bottom: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-py-md-on-sm {\n    padding-top: var(--pf-global--spacer--md) !important;\n    padding-bottom: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-py-lg-on-sm {\n    padding-top: var(--pf-global--spacer--lg) !important;\n    padding-bottom: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-py-xl-on-sm {\n    padding-top: var(--pf-global--spacer--xl) !important;\n    padding-bottom: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-py-2xl-on-sm {\n    padding-top: var(--pf-global--spacer--2xl) !important;\n    padding-bottom: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-py-3xl-on-sm {\n    padding-top: var(--pf-global--spacer--3xl) !important;\n    padding-bottom: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 576px) {\n  .pf-u-py-4xl-on-sm {\n    padding-top: var(--pf-global--spacer--4xl) !important;\n    padding-bottom: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-m-auto-on-md {\n    margin: auto !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-m-0-on-md {\n    margin: 0 !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-m-xs-on-md {\n    margin: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-m-sm-on-md {\n    margin: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-m-md-on-md {\n    margin: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-m-lg-on-md {\n    margin: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-m-xl-on-md {\n    margin: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-m-2xl-on-md {\n    margin: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-m-3xl-on-md {\n    margin: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-m-4xl-on-md {\n    margin: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mt-auto-on-md {\n    margin-top: auto !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mt-0-on-md {\n    margin-top: 0 !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mt-xs-on-md {\n    margin-top: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mt-sm-on-md {\n    margin-top: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mt-md-on-md {\n    margin-top: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mt-lg-on-md {\n    margin-top: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mt-xl-on-md {\n    margin-top: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mt-2xl-on-md {\n    margin-top: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mt-3xl-on-md {\n    margin-top: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mt-4xl-on-md {\n    margin-top: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mr-auto-on-md {\n    margin-right: auto !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mr-0-on-md {\n    margin-right: 0 !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mr-xs-on-md {\n    margin-right: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mr-sm-on-md {\n    margin-right: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mr-md-on-md {\n    margin-right: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mr-lg-on-md {\n    margin-right: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mr-xl-on-md {\n    margin-right: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mr-2xl-on-md {\n    margin-right: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mr-3xl-on-md {\n    margin-right: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mr-4xl-on-md {\n    margin-right: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mb-auto-on-md {\n    margin-bottom: auto !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mb-0-on-md {\n    margin-bottom: 0 !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mb-xs-on-md {\n    margin-bottom: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mb-sm-on-md {\n    margin-bottom: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mb-md-on-md {\n    margin-bottom: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mb-lg-on-md {\n    margin-bottom: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mb-xl-on-md {\n    margin-bottom: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mb-2xl-on-md {\n    margin-bottom: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mb-3xl-on-md {\n    margin-bottom: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mb-4xl-on-md {\n    margin-bottom: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-ml-auto-on-md {\n    margin-left: auto !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-ml-0-on-md {\n    margin-left: 0 !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-ml-xs-on-md {\n    margin-left: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-ml-sm-on-md {\n    margin-left: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-ml-md-on-md {\n    margin-left: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-ml-lg-on-md {\n    margin-left: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-ml-xl-on-md {\n    margin-left: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-ml-2xl-on-md {\n    margin-left: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-ml-3xl-on-md {\n    margin-left: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-ml-4xl-on-md {\n    margin-left: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mx-auto-on-md {\n    margin-right: auto !important;\n    margin-left: auto !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mx-0-on-md {\n    margin-right: 0 !important;\n    margin-left: 0 !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mx-xs-on-md {\n    margin-right: var(--pf-global--spacer--xs) !important;\n    margin-left: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mx-sm-on-md {\n    margin-right: var(--pf-global--spacer--sm) !important;\n    margin-left: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mx-md-on-md {\n    margin-right: var(--pf-global--spacer--md) !important;\n    margin-left: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mx-lg-on-md {\n    margin-right: var(--pf-global--spacer--lg) !important;\n    margin-left: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mx-xl-on-md {\n    margin-right: var(--pf-global--spacer--xl) !important;\n    margin-left: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mx-2xl-on-md {\n    margin-right: var(--pf-global--spacer--2xl) !important;\n    margin-left: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mx-3xl-on-md {\n    margin-right: var(--pf-global--spacer--3xl) !important;\n    margin-left: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-mx-4xl-on-md {\n    margin-right: var(--pf-global--spacer--4xl) !important;\n    margin-left: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-my-auto-on-md {\n    margin-top: auto !important;\n    margin-bottom: auto !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-my-0-on-md {\n    margin-top: 0 !important;\n    margin-bottom: 0 !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-my-xs-on-md {\n    margin-top: var(--pf-global--spacer--xs) !important;\n    margin-bottom: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-my-sm-on-md {\n    margin-top: var(--pf-global--spacer--sm) !important;\n    margin-bottom: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-my-md-on-md {\n    margin-top: var(--pf-global--spacer--md) !important;\n    margin-bottom: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-my-lg-on-md {\n    margin-top: var(--pf-global--spacer--lg) !important;\n    margin-bottom: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-my-xl-on-md {\n    margin-top: var(--pf-global--spacer--xl) !important;\n    margin-bottom: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-my-2xl-on-md {\n    margin-top: var(--pf-global--spacer--2xl) !important;\n    margin-bottom: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-my-3xl-on-md {\n    margin-top: var(--pf-global--spacer--3xl) !important;\n    margin-bottom: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-my-4xl-on-md {\n    margin-top: var(--pf-global--spacer--4xl) !important;\n    margin-bottom: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-p-auto-on-md {\n    padding: auto !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-p-0-on-md {\n    padding: 0 !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-p-xs-on-md {\n    padding: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-p-sm-on-md {\n    padding: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-p-md-on-md {\n    padding: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-p-lg-on-md {\n    padding: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-p-xl-on-md {\n    padding: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-p-2xl-on-md {\n    padding: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-p-3xl-on-md {\n    padding: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-p-4xl-on-md {\n    padding: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pt-auto-on-md {\n    padding-top: auto !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pt-0-on-md {\n    padding-top: 0 !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pt-xs-on-md {\n    padding-top: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pt-sm-on-md {\n    padding-top: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pt-md-on-md {\n    padding-top: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pt-lg-on-md {\n    padding-top: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pt-xl-on-md {\n    padding-top: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pt-2xl-on-md {\n    padding-top: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pt-3xl-on-md {\n    padding-top: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pt-4xl-on-md {\n    padding-top: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pr-auto-on-md {\n    padding-right: auto !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pr-0-on-md {\n    padding-right: 0 !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pr-xs-on-md {\n    padding-right: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pr-sm-on-md {\n    padding-right: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pr-md-on-md {\n    padding-right: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pr-lg-on-md {\n    padding-right: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pr-xl-on-md {\n    padding-right: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pr-2xl-on-md {\n    padding-right: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pr-3xl-on-md {\n    padding-right: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pr-4xl-on-md {\n    padding-right: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pb-auto-on-md {\n    padding-bottom: auto !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pb-0-on-md {\n    padding-bottom: 0 !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pb-xs-on-md {\n    padding-bottom: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pb-sm-on-md {\n    padding-bottom: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pb-md-on-md {\n    padding-bottom: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pb-lg-on-md {\n    padding-bottom: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pb-xl-on-md {\n    padding-bottom: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pb-2xl-on-md {\n    padding-bottom: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pb-3xl-on-md {\n    padding-bottom: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pb-4xl-on-md {\n    padding-bottom: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pl-auto-on-md {\n    padding-left: auto !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pl-0-on-md {\n    padding-left: 0 !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pl-xs-on-md {\n    padding-left: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pl-sm-on-md {\n    padding-left: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pl-md-on-md {\n    padding-left: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pl-lg-on-md {\n    padding-left: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pl-xl-on-md {\n    padding-left: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pl-2xl-on-md {\n    padding-left: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pl-3xl-on-md {\n    padding-left: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-pl-4xl-on-md {\n    padding-left: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-px-auto-on-md {\n    padding-right: auto !important;\n    padding-left: auto !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-px-0-on-md {\n    padding-right: 0 !important;\n    padding-left: 0 !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-px-xs-on-md {\n    padding-right: var(--pf-global--spacer--xs) !important;\n    padding-left: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-px-sm-on-md {\n    padding-right: var(--pf-global--spacer--sm) !important;\n    padding-left: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-px-md-on-md {\n    padding-right: var(--pf-global--spacer--md) !important;\n    padding-left: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-px-lg-on-md {\n    padding-right: var(--pf-global--spacer--lg) !important;\n    padding-left: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-px-xl-on-md {\n    padding-right: var(--pf-global--spacer--xl) !important;\n    padding-left: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-px-2xl-on-md {\n    padding-right: var(--pf-global--spacer--2xl) !important;\n    padding-left: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-px-3xl-on-md {\n    padding-right: var(--pf-global--spacer--3xl) !important;\n    padding-left: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-px-4xl-on-md {\n    padding-right: var(--pf-global--spacer--4xl) !important;\n    padding-left: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-py-auto-on-md {\n    padding-top: auto !important;\n    padding-bottom: auto !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-py-0-on-md {\n    padding-top: 0 !important;\n    padding-bottom: 0 !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-py-xs-on-md {\n    padding-top: var(--pf-global--spacer--xs) !important;\n    padding-bottom: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-py-sm-on-md {\n    padding-top: var(--pf-global--spacer--sm) !important;\n    padding-bottom: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-py-md-on-md {\n    padding-top: var(--pf-global--spacer--md) !important;\n    padding-bottom: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-py-lg-on-md {\n    padding-top: var(--pf-global--spacer--lg) !important;\n    padding-bottom: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-py-xl-on-md {\n    padding-top: var(--pf-global--spacer--xl) !important;\n    padding-bottom: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-py-2xl-on-md {\n    padding-top: var(--pf-global--spacer--2xl) !important;\n    padding-bottom: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-py-3xl-on-md {\n    padding-top: var(--pf-global--spacer--3xl) !important;\n    padding-bottom: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 768px) {\n  .pf-u-py-4xl-on-md {\n    padding-top: var(--pf-global--spacer--4xl) !important;\n    padding-bottom: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-m-auto-on-lg {\n    margin: auto !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-m-0-on-lg {\n    margin: 0 !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-m-xs-on-lg {\n    margin: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-m-sm-on-lg {\n    margin: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-m-md-on-lg {\n    margin: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-m-lg-on-lg {\n    margin: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-m-xl-on-lg {\n    margin: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-m-2xl-on-lg {\n    margin: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-m-3xl-on-lg {\n    margin: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-m-4xl-on-lg {\n    margin: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mt-auto-on-lg {\n    margin-top: auto !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mt-0-on-lg {\n    margin-top: 0 !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mt-xs-on-lg {\n    margin-top: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mt-sm-on-lg {\n    margin-top: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mt-md-on-lg {\n    margin-top: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mt-lg-on-lg {\n    margin-top: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mt-xl-on-lg {\n    margin-top: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mt-2xl-on-lg {\n    margin-top: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mt-3xl-on-lg {\n    margin-top: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mt-4xl-on-lg {\n    margin-top: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mr-auto-on-lg {\n    margin-right: auto !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mr-0-on-lg {\n    margin-right: 0 !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mr-xs-on-lg {\n    margin-right: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mr-sm-on-lg {\n    margin-right: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mr-md-on-lg {\n    margin-right: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mr-lg-on-lg {\n    margin-right: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mr-xl-on-lg {\n    margin-right: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mr-2xl-on-lg {\n    margin-right: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mr-3xl-on-lg {\n    margin-right: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mr-4xl-on-lg {\n    margin-right: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mb-auto-on-lg {\n    margin-bottom: auto !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mb-0-on-lg {\n    margin-bottom: 0 !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mb-xs-on-lg {\n    margin-bottom: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mb-sm-on-lg {\n    margin-bottom: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mb-md-on-lg {\n    margin-bottom: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mb-lg-on-lg {\n    margin-bottom: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mb-xl-on-lg {\n    margin-bottom: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mb-2xl-on-lg {\n    margin-bottom: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mb-3xl-on-lg {\n    margin-bottom: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mb-4xl-on-lg {\n    margin-bottom: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-ml-auto-on-lg {\n    margin-left: auto !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-ml-0-on-lg {\n    margin-left: 0 !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-ml-xs-on-lg {\n    margin-left: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-ml-sm-on-lg {\n    margin-left: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-ml-md-on-lg {\n    margin-left: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-ml-lg-on-lg {\n    margin-left: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-ml-xl-on-lg {\n    margin-left: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-ml-2xl-on-lg {\n    margin-left: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-ml-3xl-on-lg {\n    margin-left: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-ml-4xl-on-lg {\n    margin-left: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mx-auto-on-lg {\n    margin-right: auto !important;\n    margin-left: auto !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mx-0-on-lg {\n    margin-right: 0 !important;\n    margin-left: 0 !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mx-xs-on-lg {\n    margin-right: var(--pf-global--spacer--xs) !important;\n    margin-left: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mx-sm-on-lg {\n    margin-right: var(--pf-global--spacer--sm) !important;\n    margin-left: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mx-md-on-lg {\n    margin-right: var(--pf-global--spacer--md) !important;\n    margin-left: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mx-lg-on-lg {\n    margin-right: var(--pf-global--spacer--lg) !important;\n    margin-left: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mx-xl-on-lg {\n    margin-right: var(--pf-global--spacer--xl) !important;\n    margin-left: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mx-2xl-on-lg {\n    margin-right: var(--pf-global--spacer--2xl) !important;\n    margin-left: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mx-3xl-on-lg {\n    margin-right: var(--pf-global--spacer--3xl) !important;\n    margin-left: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-mx-4xl-on-lg {\n    margin-right: var(--pf-global--spacer--4xl) !important;\n    margin-left: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-my-auto-on-lg {\n    margin-top: auto !important;\n    margin-bottom: auto !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-my-0-on-lg {\n    margin-top: 0 !important;\n    margin-bottom: 0 !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-my-xs-on-lg {\n    margin-top: var(--pf-global--spacer--xs) !important;\n    margin-bottom: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-my-sm-on-lg {\n    margin-top: var(--pf-global--spacer--sm) !important;\n    margin-bottom: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-my-md-on-lg {\n    margin-top: var(--pf-global--spacer--md) !important;\n    margin-bottom: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-my-lg-on-lg {\n    margin-top: var(--pf-global--spacer--lg) !important;\n    margin-bottom: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-my-xl-on-lg {\n    margin-top: var(--pf-global--spacer--xl) !important;\n    margin-bottom: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-my-2xl-on-lg {\n    margin-top: var(--pf-global--spacer--2xl) !important;\n    margin-bottom: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-my-3xl-on-lg {\n    margin-top: var(--pf-global--spacer--3xl) !important;\n    margin-bottom: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-my-4xl-on-lg {\n    margin-top: var(--pf-global--spacer--4xl) !important;\n    margin-bottom: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-p-auto-on-lg {\n    padding: auto !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-p-0-on-lg {\n    padding: 0 !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-p-xs-on-lg {\n    padding: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-p-sm-on-lg {\n    padding: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-p-md-on-lg {\n    padding: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-p-lg-on-lg {\n    padding: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-p-xl-on-lg {\n    padding: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-p-2xl-on-lg {\n    padding: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-p-3xl-on-lg {\n    padding: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-p-4xl-on-lg {\n    padding: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pt-auto-on-lg {\n    padding-top: auto !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pt-0-on-lg {\n    padding-top: 0 !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pt-xs-on-lg {\n    padding-top: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pt-sm-on-lg {\n    padding-top: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pt-md-on-lg {\n    padding-top: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pt-lg-on-lg {\n    padding-top: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pt-xl-on-lg {\n    padding-top: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pt-2xl-on-lg {\n    padding-top: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pt-3xl-on-lg {\n    padding-top: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pt-4xl-on-lg {\n    padding-top: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pr-auto-on-lg {\n    padding-right: auto !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pr-0-on-lg {\n    padding-right: 0 !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pr-xs-on-lg {\n    padding-right: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pr-sm-on-lg {\n    padding-right: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pr-md-on-lg {\n    padding-right: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pr-lg-on-lg {\n    padding-right: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pr-xl-on-lg {\n    padding-right: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pr-2xl-on-lg {\n    padding-right: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pr-3xl-on-lg {\n    padding-right: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pr-4xl-on-lg {\n    padding-right: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pb-auto-on-lg {\n    padding-bottom: auto !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pb-0-on-lg {\n    padding-bottom: 0 !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pb-xs-on-lg {\n    padding-bottom: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pb-sm-on-lg {\n    padding-bottom: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pb-md-on-lg {\n    padding-bottom: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pb-lg-on-lg {\n    padding-bottom: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pb-xl-on-lg {\n    padding-bottom: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pb-2xl-on-lg {\n    padding-bottom: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pb-3xl-on-lg {\n    padding-bottom: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pb-4xl-on-lg {\n    padding-bottom: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pl-auto-on-lg {\n    padding-left: auto !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pl-0-on-lg {\n    padding-left: 0 !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pl-xs-on-lg {\n    padding-left: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pl-sm-on-lg {\n    padding-left: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pl-md-on-lg {\n    padding-left: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pl-lg-on-lg {\n    padding-left: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pl-xl-on-lg {\n    padding-left: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pl-2xl-on-lg {\n    padding-left: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pl-3xl-on-lg {\n    padding-left: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-pl-4xl-on-lg {\n    padding-left: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-px-auto-on-lg {\n    padding-right: auto !important;\n    padding-left: auto !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-px-0-on-lg {\n    padding-right: 0 !important;\n    padding-left: 0 !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-px-xs-on-lg {\n    padding-right: var(--pf-global--spacer--xs) !important;\n    padding-left: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-px-sm-on-lg {\n    padding-right: var(--pf-global--spacer--sm) !important;\n    padding-left: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-px-md-on-lg {\n    padding-right: var(--pf-global--spacer--md) !important;\n    padding-left: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-px-lg-on-lg {\n    padding-right: var(--pf-global--spacer--lg) !important;\n    padding-left: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-px-xl-on-lg {\n    padding-right: var(--pf-global--spacer--xl) !important;\n    padding-left: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-px-2xl-on-lg {\n    padding-right: var(--pf-global--spacer--2xl) !important;\n    padding-left: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-px-3xl-on-lg {\n    padding-right: var(--pf-global--spacer--3xl) !important;\n    padding-left: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-px-4xl-on-lg {\n    padding-right: var(--pf-global--spacer--4xl) !important;\n    padding-left: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-py-auto-on-lg {\n    padding-top: auto !important;\n    padding-bottom: auto !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-py-0-on-lg {\n    padding-top: 0 !important;\n    padding-bottom: 0 !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-py-xs-on-lg {\n    padding-top: var(--pf-global--spacer--xs) !important;\n    padding-bottom: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-py-sm-on-lg {\n    padding-top: var(--pf-global--spacer--sm) !important;\n    padding-bottom: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-py-md-on-lg {\n    padding-top: var(--pf-global--spacer--md) !important;\n    padding-bottom: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-py-lg-on-lg {\n    padding-top: var(--pf-global--spacer--lg) !important;\n    padding-bottom: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-py-xl-on-lg {\n    padding-top: var(--pf-global--spacer--xl) !important;\n    padding-bottom: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-py-2xl-on-lg {\n    padding-top: var(--pf-global--spacer--2xl) !important;\n    padding-bottom: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-py-3xl-on-lg {\n    padding-top: var(--pf-global--spacer--3xl) !important;\n    padding-bottom: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 992px) {\n  .pf-u-py-4xl-on-lg {\n    padding-top: var(--pf-global--spacer--4xl) !important;\n    padding-bottom: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-m-auto-on-xl {\n    margin: auto !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-m-0-on-xl {\n    margin: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-m-xs-on-xl {\n    margin: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-m-sm-on-xl {\n    margin: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-m-md-on-xl {\n    margin: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-m-lg-on-xl {\n    margin: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-m-xl-on-xl {\n    margin: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-m-2xl-on-xl {\n    margin: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-m-3xl-on-xl {\n    margin: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-m-4xl-on-xl {\n    margin: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mt-auto-on-xl {\n    margin-top: auto !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mt-0-on-xl {\n    margin-top: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mt-xs-on-xl {\n    margin-top: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mt-sm-on-xl {\n    margin-top: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mt-md-on-xl {\n    margin-top: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mt-lg-on-xl {\n    margin-top: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mt-xl-on-xl {\n    margin-top: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mt-2xl-on-xl {\n    margin-top: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mt-3xl-on-xl {\n    margin-top: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mt-4xl-on-xl {\n    margin-top: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mr-auto-on-xl {\n    margin-right: auto !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mr-0-on-xl {\n    margin-right: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mr-xs-on-xl {\n    margin-right: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mr-sm-on-xl {\n    margin-right: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mr-md-on-xl {\n    margin-right: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mr-lg-on-xl {\n    margin-right: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mr-xl-on-xl {\n    margin-right: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mr-2xl-on-xl {\n    margin-right: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mr-3xl-on-xl {\n    margin-right: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mr-4xl-on-xl {\n    margin-right: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mb-auto-on-xl {\n    margin-bottom: auto !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mb-0-on-xl {\n    margin-bottom: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mb-xs-on-xl {\n    margin-bottom: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mb-sm-on-xl {\n    margin-bottom: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mb-md-on-xl {\n    margin-bottom: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mb-lg-on-xl {\n    margin-bottom: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mb-xl-on-xl {\n    margin-bottom: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mb-2xl-on-xl {\n    margin-bottom: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mb-3xl-on-xl {\n    margin-bottom: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mb-4xl-on-xl {\n    margin-bottom: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-ml-auto-on-xl {\n    margin-left: auto !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-ml-0-on-xl {\n    margin-left: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-ml-xs-on-xl {\n    margin-left: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-ml-sm-on-xl {\n    margin-left: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-ml-md-on-xl {\n    margin-left: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-ml-lg-on-xl {\n    margin-left: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-ml-xl-on-xl {\n    margin-left: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-ml-2xl-on-xl {\n    margin-left: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-ml-3xl-on-xl {\n    margin-left: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-ml-4xl-on-xl {\n    margin-left: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mx-auto-on-xl {\n    margin-right: auto !important;\n    margin-left: auto !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mx-0-on-xl {\n    margin-right: 0 !important;\n    margin-left: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mx-xs-on-xl {\n    margin-right: var(--pf-global--spacer--xs) !important;\n    margin-left: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mx-sm-on-xl {\n    margin-right: var(--pf-global--spacer--sm) !important;\n    margin-left: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mx-md-on-xl {\n    margin-right: var(--pf-global--spacer--md) !important;\n    margin-left: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mx-lg-on-xl {\n    margin-right: var(--pf-global--spacer--lg) !important;\n    margin-left: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mx-xl-on-xl {\n    margin-right: var(--pf-global--spacer--xl) !important;\n    margin-left: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mx-2xl-on-xl {\n    margin-right: var(--pf-global--spacer--2xl) !important;\n    margin-left: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mx-3xl-on-xl {\n    margin-right: var(--pf-global--spacer--3xl) !important;\n    margin-left: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-mx-4xl-on-xl {\n    margin-right: var(--pf-global--spacer--4xl) !important;\n    margin-left: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-my-auto-on-xl {\n    margin-top: auto !important;\n    margin-bottom: auto !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-my-0-on-xl {\n    margin-top: 0 !important;\n    margin-bottom: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-my-xs-on-xl {\n    margin-top: var(--pf-global--spacer--xs) !important;\n    margin-bottom: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-my-sm-on-xl {\n    margin-top: var(--pf-global--spacer--sm) !important;\n    margin-bottom: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-my-md-on-xl {\n    margin-top: var(--pf-global--spacer--md) !important;\n    margin-bottom: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-my-lg-on-xl {\n    margin-top: var(--pf-global--spacer--lg) !important;\n    margin-bottom: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-my-xl-on-xl {\n    margin-top: var(--pf-global--spacer--xl) !important;\n    margin-bottom: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-my-2xl-on-xl {\n    margin-top: var(--pf-global--spacer--2xl) !important;\n    margin-bottom: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-my-3xl-on-xl {\n    margin-top: var(--pf-global--spacer--3xl) !important;\n    margin-bottom: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-my-4xl-on-xl {\n    margin-top: var(--pf-global--spacer--4xl) !important;\n    margin-bottom: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-p-auto-on-xl {\n    padding: auto !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-p-0-on-xl {\n    padding: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-p-xs-on-xl {\n    padding: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-p-sm-on-xl {\n    padding: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-p-md-on-xl {\n    padding: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-p-lg-on-xl {\n    padding: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-p-xl-on-xl {\n    padding: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-p-2xl-on-xl {\n    padding: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-p-3xl-on-xl {\n    padding: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-p-4xl-on-xl {\n    padding: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pt-auto-on-xl {\n    padding-top: auto !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pt-0-on-xl {\n    padding-top: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pt-xs-on-xl {\n    padding-top: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pt-sm-on-xl {\n    padding-top: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pt-md-on-xl {\n    padding-top: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pt-lg-on-xl {\n    padding-top: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pt-xl-on-xl {\n    padding-top: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pt-2xl-on-xl {\n    padding-top: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pt-3xl-on-xl {\n    padding-top: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pt-4xl-on-xl {\n    padding-top: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pr-auto-on-xl {\n    padding-right: auto !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pr-0-on-xl {\n    padding-right: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pr-xs-on-xl {\n    padding-right: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pr-sm-on-xl {\n    padding-right: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pr-md-on-xl {\n    padding-right: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pr-lg-on-xl {\n    padding-right: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pr-xl-on-xl {\n    padding-right: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pr-2xl-on-xl {\n    padding-right: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pr-3xl-on-xl {\n    padding-right: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pr-4xl-on-xl {\n    padding-right: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pb-auto-on-xl {\n    padding-bottom: auto !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pb-0-on-xl {\n    padding-bottom: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pb-xs-on-xl {\n    padding-bottom: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pb-sm-on-xl {\n    padding-bottom: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pb-md-on-xl {\n    padding-bottom: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pb-lg-on-xl {\n    padding-bottom: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pb-xl-on-xl {\n    padding-bottom: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pb-2xl-on-xl {\n    padding-bottom: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pb-3xl-on-xl {\n    padding-bottom: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pb-4xl-on-xl {\n    padding-bottom: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pl-auto-on-xl {\n    padding-left: auto !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pl-0-on-xl {\n    padding-left: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pl-xs-on-xl {\n    padding-left: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pl-sm-on-xl {\n    padding-left: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pl-md-on-xl {\n    padding-left: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pl-lg-on-xl {\n    padding-left: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pl-xl-on-xl {\n    padding-left: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pl-2xl-on-xl {\n    padding-left: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pl-3xl-on-xl {\n    padding-left: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-pl-4xl-on-xl {\n    padding-left: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-px-auto-on-xl {\n    padding-right: auto !important;\n    padding-left: auto !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-px-0-on-xl {\n    padding-right: 0 !important;\n    padding-left: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-px-xs-on-xl {\n    padding-right: var(--pf-global--spacer--xs) !important;\n    padding-left: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-px-sm-on-xl {\n    padding-right: var(--pf-global--spacer--sm) !important;\n    padding-left: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-px-md-on-xl {\n    padding-right: var(--pf-global--spacer--md) !important;\n    padding-left: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-px-lg-on-xl {\n    padding-right: var(--pf-global--spacer--lg) !important;\n    padding-left: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-px-xl-on-xl {\n    padding-right: var(--pf-global--spacer--xl) !important;\n    padding-left: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-px-2xl-on-xl {\n    padding-right: var(--pf-global--spacer--2xl) !important;\n    padding-left: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-px-3xl-on-xl {\n    padding-right: var(--pf-global--spacer--3xl) !important;\n    padding-left: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-px-4xl-on-xl {\n    padding-right: var(--pf-global--spacer--4xl) !important;\n    padding-left: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-py-auto-on-xl {\n    padding-top: auto !important;\n    padding-bottom: auto !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-py-0-on-xl {\n    padding-top: 0 !important;\n    padding-bottom: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-py-xs-on-xl {\n    padding-top: var(--pf-global--spacer--xs) !important;\n    padding-bottom: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-py-sm-on-xl {\n    padding-top: var(--pf-global--spacer--sm) !important;\n    padding-bottom: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-py-md-on-xl {\n    padding-top: var(--pf-global--spacer--md) !important;\n    padding-bottom: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-py-lg-on-xl {\n    padding-top: var(--pf-global--spacer--lg) !important;\n    padding-bottom: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-py-xl-on-xl {\n    padding-top: var(--pf-global--spacer--xl) !important;\n    padding-bottom: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-py-2xl-on-xl {\n    padding-top: var(--pf-global--spacer--2xl) !important;\n    padding-bottom: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-py-3xl-on-xl {\n    padding-top: var(--pf-global--spacer--3xl) !important;\n    padding-bottom: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1200px) {\n  .pf-u-py-4xl-on-xl {\n    padding-top: var(--pf-global--spacer--4xl) !important;\n    padding-bottom: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-m-auto-on-2xl {\n    margin: auto !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-m-0-on-2xl {\n    margin: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-m-xs-on-2xl {\n    margin: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-m-sm-on-2xl {\n    margin: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-m-md-on-2xl {\n    margin: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-m-lg-on-2xl {\n    margin: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-m-xl-on-2xl {\n    margin: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-m-2xl-on-2xl {\n    margin: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-m-3xl-on-2xl {\n    margin: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-m-4xl-on-2xl {\n    margin: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mt-auto-on-2xl {\n    margin-top: auto !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mt-0-on-2xl {\n    margin-top: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mt-xs-on-2xl {\n    margin-top: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mt-sm-on-2xl {\n    margin-top: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mt-md-on-2xl {\n    margin-top: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mt-lg-on-2xl {\n    margin-top: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mt-xl-on-2xl {\n    margin-top: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mt-2xl-on-2xl {\n    margin-top: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mt-3xl-on-2xl {\n    margin-top: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mt-4xl-on-2xl {\n    margin-top: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mr-auto-on-2xl {\n    margin-right: auto !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mr-0-on-2xl {\n    margin-right: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mr-xs-on-2xl {\n    margin-right: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mr-sm-on-2xl {\n    margin-right: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mr-md-on-2xl {\n    margin-right: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mr-lg-on-2xl {\n    margin-right: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mr-xl-on-2xl {\n    margin-right: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mr-2xl-on-2xl {\n    margin-right: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mr-3xl-on-2xl {\n    margin-right: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mr-4xl-on-2xl {\n    margin-right: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mb-auto-on-2xl {\n    margin-bottom: auto !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mb-0-on-2xl {\n    margin-bottom: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mb-xs-on-2xl {\n    margin-bottom: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mb-sm-on-2xl {\n    margin-bottom: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mb-md-on-2xl {\n    margin-bottom: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mb-lg-on-2xl {\n    margin-bottom: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mb-xl-on-2xl {\n    margin-bottom: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mb-2xl-on-2xl {\n    margin-bottom: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mb-3xl-on-2xl {\n    margin-bottom: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mb-4xl-on-2xl {\n    margin-bottom: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-ml-auto-on-2xl {\n    margin-left: auto !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-ml-0-on-2xl {\n    margin-left: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-ml-xs-on-2xl {\n    margin-left: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-ml-sm-on-2xl {\n    margin-left: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-ml-md-on-2xl {\n    margin-left: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-ml-lg-on-2xl {\n    margin-left: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-ml-xl-on-2xl {\n    margin-left: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-ml-2xl-on-2xl {\n    margin-left: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-ml-3xl-on-2xl {\n    margin-left: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-ml-4xl-on-2xl {\n    margin-left: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mx-auto-on-2xl {\n    margin-right: auto !important;\n    margin-left: auto !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mx-0-on-2xl {\n    margin-right: 0 !important;\n    margin-left: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mx-xs-on-2xl {\n    margin-right: var(--pf-global--spacer--xs) !important;\n    margin-left: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mx-sm-on-2xl {\n    margin-right: var(--pf-global--spacer--sm) !important;\n    margin-left: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mx-md-on-2xl {\n    margin-right: var(--pf-global--spacer--md) !important;\n    margin-left: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mx-lg-on-2xl {\n    margin-right: var(--pf-global--spacer--lg) !important;\n    margin-left: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mx-xl-on-2xl {\n    margin-right: var(--pf-global--spacer--xl) !important;\n    margin-left: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mx-2xl-on-2xl {\n    margin-right: var(--pf-global--spacer--2xl) !important;\n    margin-left: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mx-3xl-on-2xl {\n    margin-right: var(--pf-global--spacer--3xl) !important;\n    margin-left: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-mx-4xl-on-2xl {\n    margin-right: var(--pf-global--spacer--4xl) !important;\n    margin-left: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-my-auto-on-2xl {\n    margin-top: auto !important;\n    margin-bottom: auto !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-my-0-on-2xl {\n    margin-top: 0 !important;\n    margin-bottom: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-my-xs-on-2xl {\n    margin-top: var(--pf-global--spacer--xs) !important;\n    margin-bottom: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-my-sm-on-2xl {\n    margin-top: var(--pf-global--spacer--sm) !important;\n    margin-bottom: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-my-md-on-2xl {\n    margin-top: var(--pf-global--spacer--md) !important;\n    margin-bottom: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-my-lg-on-2xl {\n    margin-top: var(--pf-global--spacer--lg) !important;\n    margin-bottom: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-my-xl-on-2xl {\n    margin-top: var(--pf-global--spacer--xl) !important;\n    margin-bottom: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-my-2xl-on-2xl {\n    margin-top: var(--pf-global--spacer--2xl) !important;\n    margin-bottom: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-my-3xl-on-2xl {\n    margin-top: var(--pf-global--spacer--3xl) !important;\n    margin-bottom: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-my-4xl-on-2xl {\n    margin-top: var(--pf-global--spacer--4xl) !important;\n    margin-bottom: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-p-auto-on-2xl {\n    padding: auto !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-p-0-on-2xl {\n    padding: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-p-xs-on-2xl {\n    padding: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-p-sm-on-2xl {\n    padding: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-p-md-on-2xl {\n    padding: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-p-lg-on-2xl {\n    padding: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-p-xl-on-2xl {\n    padding: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-p-2xl-on-2xl {\n    padding: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-p-3xl-on-2xl {\n    padding: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-p-4xl-on-2xl {\n    padding: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pt-auto-on-2xl {\n    padding-top: auto !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pt-0-on-2xl {\n    padding-top: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pt-xs-on-2xl {\n    padding-top: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pt-sm-on-2xl {\n    padding-top: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pt-md-on-2xl {\n    padding-top: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pt-lg-on-2xl {\n    padding-top: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pt-xl-on-2xl {\n    padding-top: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pt-2xl-on-2xl {\n    padding-top: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pt-3xl-on-2xl {\n    padding-top: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pt-4xl-on-2xl {\n    padding-top: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pr-auto-on-2xl {\n    padding-right: auto !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pr-0-on-2xl {\n    padding-right: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pr-xs-on-2xl {\n    padding-right: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pr-sm-on-2xl {\n    padding-right: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pr-md-on-2xl {\n    padding-right: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pr-lg-on-2xl {\n    padding-right: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pr-xl-on-2xl {\n    padding-right: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pr-2xl-on-2xl {\n    padding-right: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pr-3xl-on-2xl {\n    padding-right: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pr-4xl-on-2xl {\n    padding-right: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pb-auto-on-2xl {\n    padding-bottom: auto !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pb-0-on-2xl {\n    padding-bottom: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pb-xs-on-2xl {\n    padding-bottom: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pb-sm-on-2xl {\n    padding-bottom: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pb-md-on-2xl {\n    padding-bottom: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pb-lg-on-2xl {\n    padding-bottom: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pb-xl-on-2xl {\n    padding-bottom: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pb-2xl-on-2xl {\n    padding-bottom: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pb-3xl-on-2xl {\n    padding-bottom: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pb-4xl-on-2xl {\n    padding-bottom: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pl-auto-on-2xl {\n    padding-left: auto !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pl-0-on-2xl {\n    padding-left: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pl-xs-on-2xl {\n    padding-left: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pl-sm-on-2xl {\n    padding-left: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pl-md-on-2xl {\n    padding-left: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pl-lg-on-2xl {\n    padding-left: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pl-xl-on-2xl {\n    padding-left: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pl-2xl-on-2xl {\n    padding-left: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pl-3xl-on-2xl {\n    padding-left: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-pl-4xl-on-2xl {\n    padding-left: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-px-auto-on-2xl {\n    padding-right: auto !important;\n    padding-left: auto !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-px-0-on-2xl {\n    padding-right: 0 !important;\n    padding-left: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-px-xs-on-2xl {\n    padding-right: var(--pf-global--spacer--xs) !important;\n    padding-left: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-px-sm-on-2xl {\n    padding-right: var(--pf-global--spacer--sm) !important;\n    padding-left: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-px-md-on-2xl {\n    padding-right: var(--pf-global--spacer--md) !important;\n    padding-left: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-px-lg-on-2xl {\n    padding-right: var(--pf-global--spacer--lg) !important;\n    padding-left: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-px-xl-on-2xl {\n    padding-right: var(--pf-global--spacer--xl) !important;\n    padding-left: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-px-2xl-on-2xl {\n    padding-right: var(--pf-global--spacer--2xl) !important;\n    padding-left: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-px-3xl-on-2xl {\n    padding-right: var(--pf-global--spacer--3xl) !important;\n    padding-left: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-px-4xl-on-2xl {\n    padding-right: var(--pf-global--spacer--4xl) !important;\n    padding-left: var(--pf-global--spacer--4xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-py-auto-on-2xl {\n    padding-top: auto !important;\n    padding-bottom: auto !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-py-0-on-2xl {\n    padding-top: 0 !important;\n    padding-bottom: 0 !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-py-xs-on-2xl {\n    padding-top: var(--pf-global--spacer--xs) !important;\n    padding-bottom: var(--pf-global--spacer--xs) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-py-sm-on-2xl {\n    padding-top: var(--pf-global--spacer--sm) !important;\n    padding-bottom: var(--pf-global--spacer--sm) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-py-md-on-2xl {\n    padding-top: var(--pf-global--spacer--md) !important;\n    padding-bottom: var(--pf-global--spacer--md) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-py-lg-on-2xl {\n    padding-top: var(--pf-global--spacer--lg) !important;\n    padding-bottom: var(--pf-global--spacer--lg) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-py-xl-on-2xl {\n    padding-top: var(--pf-global--spacer--xl) !important;\n    padding-bottom: var(--pf-global--spacer--xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-py-2xl-on-2xl {\n    padding-top: var(--pf-global--spacer--2xl) !important;\n    padding-bottom: var(--pf-global--spacer--2xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-py-3xl-on-2xl {\n    padding-top: var(--pf-global--spacer--3xl) !important;\n    padding-bottom: var(--pf-global--spacer--3xl) !important;\n  }\n}\n\n@media screen and (min-width: 1450px) {\n  .pf-u-py-4xl-on-2xl {\n    padding-top: var(--pf-global--spacer--4xl) !important;\n    padding-bottom: var(--pf-global--spacer--4xl) !important;\n  }\n}";

// src/user/LibraryPage/ak-library-application-empty-list.ts
var LibraryPageApplicationEmptyList = class extends AKElement {
  constructor() {
    super(...arguments);
    this.isAdmin = false;
  }
  static get styles() {
    return [
      patternfly_base_default,
      empty_state_default,
      button_default,
      content_default,
      spacing_default,
      i`
                .cta {
                    display: inline-block;
                    font-weight: bold;
                }
            `
    ];
  }
  renderNewAppButton() {
    const href = paramURL("/core/applications", {
      createWizard: true
    });
    return ke`
            <div class="pf-u-pt-lg">
                <a
                    aria-disabled="false"
                    class="cta pf-c-button pf-m-secondary"
                    href="${globalAK().api.base}if/admin/${href}"
                    >${msg("Create a new application")}</a
                >
            </div>
            <div class="pf-c-empty-state__body">
                <a rel="noopener noreferrer" href="${docLink("/docs/applications")}" target="_blank"
                    >${msg("Refer to documentation")}</a
                >
            </div>
        `;
  }
  render() {
    return ke` <div class="pf-c-empty-state pf-m-full-height">
            <div class="pf-c-empty-state__content">
                <i class="fas fa-cubes pf-c-empty-state__icon" aria-hidden="true"></i>
                <h1 class="pf-c-title pf-m-lg">${msg("No Applications available.")}</h1>
                <div class="pf-c-empty-state__body">
                    ${msg("Either no applications are defined, or you don\u2019t have access to any.")}
                </div>
                ${this.isAdmin ? this.renderNewAppButton() : ke``}
            </div>
        </div>`;
  }
};
__decorateClass([
  n({ attribute: "isadmin", type: Boolean })
], LibraryPageApplicationEmptyList.prototype, "isAdmin", 2);
LibraryPageApplicationEmptyList = __decorateClass([
  t("ak-library-application-empty-list")
], LibraryPageApplicationEmptyList);

// node_modules/@patternfly/patternfly/layouts/Grid/grid.css
var grid_default = ".pf-l-grid {\n  --pf-l-grid--m-gutter--GridGap: var(--pf-global--gutter);\n  --pf-l-grid__item--GridColumnStart: auto;\n  --pf-l-grid__item--GridColumnEnd: span 12;\n  --pf-l-grid--item--Order: 0;\n  display: grid;\n  grid-template-columns: repeat(12, [col-start] 1fr);\n}\n.pf-l-grid > *,\n.pf-l-grid .pf-l-grid__item {\n  min-width: 0;\n  min-height: 0;\n  grid-column-start: var(--pf-l-grid__item--GridColumnStart);\n  grid-column-end: var(--pf-l-grid__item--GridColumnEnd);\n  order: var(--pf-l-grid--item--Order);\n}\n@media (min-width: 576px) {\n  .pf-l-grid > *,\n.pf-l-grid .pf-l-grid__item {\n    order: var(--pf-l-grid--item--Order-on-sm, var(--pf-l-grid--item--Order));\n  }\n}\n@media (min-width: 768px) {\n  .pf-l-grid > *,\n.pf-l-grid .pf-l-grid__item {\n    order: var(--pf-l-grid--item--Order-on-md, var(--pf-l-grid--item--Order-on-sm, var(--pf-l-grid--item--Order)));\n  }\n}\n@media (min-width: 992px) {\n  .pf-l-grid > *,\n.pf-l-grid .pf-l-grid__item {\n    order: var(--pf-l-grid--item--Order-on-lg, var(--pf-l-grid--item--Order-on-md, var(--pf-l-grid--item--Order-on-sm, var(--pf-l-grid--item--Order))));\n  }\n}\n@media (min-width: 1200px) {\n  .pf-l-grid > *,\n.pf-l-grid .pf-l-grid__item {\n    order: var(--pf-l-grid--item--Order-on-xl, var(--pf-l-grid--item--Order-on-lg, var(--pf-l-grid--item--Order-on-md, var(--pf-l-grid--item--Order-on-sm, var(--pf-l-grid--item--Order)))));\n  }\n}\n@media (min-width: 1450px) {\n  .pf-l-grid > *,\n.pf-l-grid .pf-l-grid__item {\n    order: var(--pf-l-grid--item--Order-on-2xl, var(--pf-l-grid--item--Order-on-xl, var(--pf-l-grid--item--Order-on-lg, var(--pf-l-grid--item--Order-on-md, var(--pf-l-grid--item--Order-on-sm, var(--pf-l-grid--item--Order))))));\n  }\n}\n.pf-l-grid.pf-m-all-1-col > * {\n  --pf-l-grid__item--GridColumnEnd: span 1;\n}\n.pf-l-grid.pf-m-all-2-col > * {\n  --pf-l-grid__item--GridColumnEnd: span 2;\n}\n.pf-l-grid.pf-m-all-3-col > * {\n  --pf-l-grid__item--GridColumnEnd: span 3;\n}\n.pf-l-grid.pf-m-all-4-col > * {\n  --pf-l-grid__item--GridColumnEnd: span 4;\n}\n.pf-l-grid.pf-m-all-5-col > * {\n  --pf-l-grid__item--GridColumnEnd: span 5;\n}\n.pf-l-grid.pf-m-all-6-col > * {\n  --pf-l-grid__item--GridColumnEnd: span 6;\n}\n.pf-l-grid.pf-m-all-7-col > * {\n  --pf-l-grid__item--GridColumnEnd: span 7;\n}\n.pf-l-grid.pf-m-all-8-col > * {\n  --pf-l-grid__item--GridColumnEnd: span 8;\n}\n.pf-l-grid.pf-m-all-9-col > * {\n  --pf-l-grid__item--GridColumnEnd: span 9;\n}\n.pf-l-grid.pf-m-all-10-col > * {\n  --pf-l-grid__item--GridColumnEnd: span 10;\n}\n.pf-l-grid.pf-m-all-11-col > * {\n  --pf-l-grid__item--GridColumnEnd: span 11;\n}\n.pf-l-grid.pf-m-all-12-col > * {\n  --pf-l-grid__item--GridColumnEnd: span 12;\n}\n@media screen and (min-width: 576px) {\n  .pf-l-grid.pf-m-all-1-col-on-sm > * {\n    --pf-l-grid__item--GridColumnEnd: span 1;\n  }\n  .pf-l-grid.pf-m-all-2-col-on-sm > * {\n    --pf-l-grid__item--GridColumnEnd: span 2;\n  }\n  .pf-l-grid.pf-m-all-3-col-on-sm > * {\n    --pf-l-grid__item--GridColumnEnd: span 3;\n  }\n  .pf-l-grid.pf-m-all-4-col-on-sm > * {\n    --pf-l-grid__item--GridColumnEnd: span 4;\n  }\n  .pf-l-grid.pf-m-all-5-col-on-sm > * {\n    --pf-l-grid__item--GridColumnEnd: span 5;\n  }\n  .pf-l-grid.pf-m-all-6-col-on-sm > * {\n    --pf-l-grid__item--GridColumnEnd: span 6;\n  }\n  .pf-l-grid.pf-m-all-7-col-on-sm > * {\n    --pf-l-grid__item--GridColumnEnd: span 7;\n  }\n  .pf-l-grid.pf-m-all-8-col-on-sm > * {\n    --pf-l-grid__item--GridColumnEnd: span 8;\n  }\n  .pf-l-grid.pf-m-all-9-col-on-sm > * {\n    --pf-l-grid__item--GridColumnEnd: span 9;\n  }\n  .pf-l-grid.pf-m-all-10-col-on-sm > * {\n    --pf-l-grid__item--GridColumnEnd: span 10;\n  }\n  .pf-l-grid.pf-m-all-11-col-on-sm > * {\n    --pf-l-grid__item--GridColumnEnd: span 11;\n  }\n  .pf-l-grid.pf-m-all-12-col-on-sm > * {\n    --pf-l-grid__item--GridColumnEnd: span 12;\n  }\n}\n@media screen and (min-width: 768px) {\n  .pf-l-grid.pf-m-all-1-col-on-md > * {\n    --pf-l-grid__item--GridColumnEnd: span 1;\n  }\n  .pf-l-grid.pf-m-all-2-col-on-md > * {\n    --pf-l-grid__item--GridColumnEnd: span 2;\n  }\n  .pf-l-grid.pf-m-all-3-col-on-md > * {\n    --pf-l-grid__item--GridColumnEnd: span 3;\n  }\n  .pf-l-grid.pf-m-all-4-col-on-md > * {\n    --pf-l-grid__item--GridColumnEnd: span 4;\n  }\n  .pf-l-grid.pf-m-all-5-col-on-md > * {\n    --pf-l-grid__item--GridColumnEnd: span 5;\n  }\n  .pf-l-grid.pf-m-all-6-col-on-md > * {\n    --pf-l-grid__item--GridColumnEnd: span 6;\n  }\n  .pf-l-grid.pf-m-all-7-col-on-md > * {\n    --pf-l-grid__item--GridColumnEnd: span 7;\n  }\n  .pf-l-grid.pf-m-all-8-col-on-md > * {\n    --pf-l-grid__item--GridColumnEnd: span 8;\n  }\n  .pf-l-grid.pf-m-all-9-col-on-md > * {\n    --pf-l-grid__item--GridColumnEnd: span 9;\n  }\n  .pf-l-grid.pf-m-all-10-col-on-md > * {\n    --pf-l-grid__item--GridColumnEnd: span 10;\n  }\n  .pf-l-grid.pf-m-all-11-col-on-md > * {\n    --pf-l-grid__item--GridColumnEnd: span 11;\n  }\n  .pf-l-grid.pf-m-all-12-col-on-md > * {\n    --pf-l-grid__item--GridColumnEnd: span 12;\n  }\n}\n@media screen and (min-width: 992px) {\n  .pf-l-grid.pf-m-all-1-col-on-lg > * {\n    --pf-l-grid__item--GridColumnEnd: span 1;\n  }\n  .pf-l-grid.pf-m-all-2-col-on-lg > * {\n    --pf-l-grid__item--GridColumnEnd: span 2;\n  }\n  .pf-l-grid.pf-m-all-3-col-on-lg > * {\n    --pf-l-grid__item--GridColumnEnd: span 3;\n  }\n  .pf-l-grid.pf-m-all-4-col-on-lg > * {\n    --pf-l-grid__item--GridColumnEnd: span 4;\n  }\n  .pf-l-grid.pf-m-all-5-col-on-lg > * {\n    --pf-l-grid__item--GridColumnEnd: span 5;\n  }\n  .pf-l-grid.pf-m-all-6-col-on-lg > * {\n    --pf-l-grid__item--GridColumnEnd: span 6;\n  }\n  .pf-l-grid.pf-m-all-7-col-on-lg > * {\n    --pf-l-grid__item--GridColumnEnd: span 7;\n  }\n  .pf-l-grid.pf-m-all-8-col-on-lg > * {\n    --pf-l-grid__item--GridColumnEnd: span 8;\n  }\n  .pf-l-grid.pf-m-all-9-col-on-lg > * {\n    --pf-l-grid__item--GridColumnEnd: span 9;\n  }\n  .pf-l-grid.pf-m-all-10-col-on-lg > * {\n    --pf-l-grid__item--GridColumnEnd: span 10;\n  }\n  .pf-l-grid.pf-m-all-11-col-on-lg > * {\n    --pf-l-grid__item--GridColumnEnd: span 11;\n  }\n  .pf-l-grid.pf-m-all-12-col-on-lg > * {\n    --pf-l-grid__item--GridColumnEnd: span 12;\n  }\n}\n@media screen and (min-width: 1200px) {\n  .pf-l-grid.pf-m-all-1-col-on-xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 1;\n  }\n  .pf-l-grid.pf-m-all-2-col-on-xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 2;\n  }\n  .pf-l-grid.pf-m-all-3-col-on-xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 3;\n  }\n  .pf-l-grid.pf-m-all-4-col-on-xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 4;\n  }\n  .pf-l-grid.pf-m-all-5-col-on-xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 5;\n  }\n  .pf-l-grid.pf-m-all-6-col-on-xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 6;\n  }\n  .pf-l-grid.pf-m-all-7-col-on-xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 7;\n  }\n  .pf-l-grid.pf-m-all-8-col-on-xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 8;\n  }\n  .pf-l-grid.pf-m-all-9-col-on-xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 9;\n  }\n  .pf-l-grid.pf-m-all-10-col-on-xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 10;\n  }\n  .pf-l-grid.pf-m-all-11-col-on-xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 11;\n  }\n  .pf-l-grid.pf-m-all-12-col-on-xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 12;\n  }\n}\n@media screen and (min-width: 1450px) {\n  .pf-l-grid.pf-m-all-1-col-on-2xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 1;\n  }\n  .pf-l-grid.pf-m-all-2-col-on-2xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 2;\n  }\n  .pf-l-grid.pf-m-all-3-col-on-2xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 3;\n  }\n  .pf-l-grid.pf-m-all-4-col-on-2xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 4;\n  }\n  .pf-l-grid.pf-m-all-5-col-on-2xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 5;\n  }\n  .pf-l-grid.pf-m-all-6-col-on-2xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 6;\n  }\n  .pf-l-grid.pf-m-all-7-col-on-2xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 7;\n  }\n  .pf-l-grid.pf-m-all-8-col-on-2xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 8;\n  }\n  .pf-l-grid.pf-m-all-9-col-on-2xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 9;\n  }\n  .pf-l-grid.pf-m-all-10-col-on-2xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 10;\n  }\n  .pf-l-grid.pf-m-all-11-col-on-2xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 11;\n  }\n  .pf-l-grid.pf-m-all-12-col-on-2xl > * {\n    --pf-l-grid__item--GridColumnEnd: span 12;\n  }\n}\n.pf-l-grid > .pf-m-1-col {\n  --pf-l-grid__item--GridColumnEnd: span 1;\n}\n.pf-l-grid > .pf-m-2-col {\n  --pf-l-grid__item--GridColumnEnd: span 2;\n}\n.pf-l-grid > .pf-m-3-col {\n  --pf-l-grid__item--GridColumnEnd: span 3;\n}\n.pf-l-grid > .pf-m-4-col {\n  --pf-l-grid__item--GridColumnEnd: span 4;\n}\n.pf-l-grid > .pf-m-5-col {\n  --pf-l-grid__item--GridColumnEnd: span 5;\n}\n.pf-l-grid > .pf-m-6-col {\n  --pf-l-grid__item--GridColumnEnd: span 6;\n}\n.pf-l-grid > .pf-m-7-col {\n  --pf-l-grid__item--GridColumnEnd: span 7;\n}\n.pf-l-grid > .pf-m-8-col {\n  --pf-l-grid__item--GridColumnEnd: span 8;\n}\n.pf-l-grid > .pf-m-9-col {\n  --pf-l-grid__item--GridColumnEnd: span 9;\n}\n.pf-l-grid > .pf-m-10-col {\n  --pf-l-grid__item--GridColumnEnd: span 10;\n}\n.pf-l-grid > .pf-m-11-col {\n  --pf-l-grid__item--GridColumnEnd: span 11;\n}\n.pf-l-grid > .pf-m-12-col {\n  --pf-l-grid__item--GridColumnEnd: span 12;\n}\n.pf-l-grid > .pf-m-offset-1-col {\n  --pf-l-grid__item--GridColumnStart: col-start calc(1 + 1);\n}\n.pf-l-grid > .pf-m-offset-2-col {\n  --pf-l-grid__item--GridColumnStart: col-start calc(2 + 1);\n}\n.pf-l-grid > .pf-m-offset-3-col {\n  --pf-l-grid__item--GridColumnStart: col-start calc(3 + 1);\n}\n.pf-l-grid > .pf-m-offset-4-col {\n  --pf-l-grid__item--GridColumnStart: col-start calc(4 + 1);\n}\n.pf-l-grid > .pf-m-offset-5-col {\n  --pf-l-grid__item--GridColumnStart: col-start calc(5 + 1);\n}\n.pf-l-grid > .pf-m-offset-6-col {\n  --pf-l-grid__item--GridColumnStart: col-start calc(6 + 1);\n}\n.pf-l-grid > .pf-m-offset-7-col {\n  --pf-l-grid__item--GridColumnStart: col-start calc(7 + 1);\n}\n.pf-l-grid > .pf-m-offset-8-col {\n  --pf-l-grid__item--GridColumnStart: col-start calc(8 + 1);\n}\n.pf-l-grid > .pf-m-offset-9-col {\n  --pf-l-grid__item--GridColumnStart: col-start calc(9 + 1);\n}\n.pf-l-grid > .pf-m-offset-10-col {\n  --pf-l-grid__item--GridColumnStart: col-start calc(10 + 1);\n}\n.pf-l-grid > .pf-m-offset-11-col {\n  --pf-l-grid__item--GridColumnStart: col-start calc(11 + 1);\n}\n.pf-l-grid > .pf-m-offset-12-col {\n  --pf-l-grid__item--GridColumnStart: col-start calc(12 + 1);\n}\n.pf-l-grid > .pf-m-1-row {\n  grid-row: span 1;\n}\n.pf-l-grid > .pf-m-2-row {\n  grid-row: span 2;\n}\n.pf-l-grid > .pf-m-3-row {\n  grid-row: span 3;\n}\n.pf-l-grid > .pf-m-4-row {\n  grid-row: span 4;\n}\n.pf-l-grid > .pf-m-5-row {\n  grid-row: span 5;\n}\n.pf-l-grid > .pf-m-6-row {\n  grid-row: span 6;\n}\n.pf-l-grid > .pf-m-7-row {\n  grid-row: span 7;\n}\n.pf-l-grid > .pf-m-8-row {\n  grid-row: span 8;\n}\n.pf-l-grid > .pf-m-9-row {\n  grid-row: span 9;\n}\n.pf-l-grid > .pf-m-10-row {\n  grid-row: span 10;\n}\n.pf-l-grid > .pf-m-11-row {\n  grid-row: span 11;\n}\n.pf-l-grid > .pf-m-12-row {\n  grid-row: span 12;\n}\n@media screen and (min-width: 576px) {\n  .pf-l-grid > .pf-m-1-col-on-sm {\n    --pf-l-grid__item--GridColumnEnd: span 1;\n  }\n  .pf-l-grid > .pf-m-2-col-on-sm {\n    --pf-l-grid__item--GridColumnEnd: span 2;\n  }\n  .pf-l-grid > .pf-m-3-col-on-sm {\n    --pf-l-grid__item--GridColumnEnd: span 3;\n  }\n  .pf-l-grid > .pf-m-4-col-on-sm {\n    --pf-l-grid__item--GridColumnEnd: span 4;\n  }\n  .pf-l-grid > .pf-m-5-col-on-sm {\n    --pf-l-grid__item--GridColumnEnd: span 5;\n  }\n  .pf-l-grid > .pf-m-6-col-on-sm {\n    --pf-l-grid__item--GridColumnEnd: span 6;\n  }\n  .pf-l-grid > .pf-m-7-col-on-sm {\n    --pf-l-grid__item--GridColumnEnd: span 7;\n  }\n  .pf-l-grid > .pf-m-8-col-on-sm {\n    --pf-l-grid__item--GridColumnEnd: span 8;\n  }\n  .pf-l-grid > .pf-m-9-col-on-sm {\n    --pf-l-grid__item--GridColumnEnd: span 9;\n  }\n  .pf-l-grid > .pf-m-10-col-on-sm {\n    --pf-l-grid__item--GridColumnEnd: span 10;\n  }\n  .pf-l-grid > .pf-m-11-col-on-sm {\n    --pf-l-grid__item--GridColumnEnd: span 11;\n  }\n  .pf-l-grid > .pf-m-12-col-on-sm {\n    --pf-l-grid__item--GridColumnEnd: span 12;\n  }\n  .pf-l-grid > .pf-m-offset-1-col-on-sm {\n    --pf-l-grid__item--GridColumnStart: col-start calc(1 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-2-col-on-sm {\n    --pf-l-grid__item--GridColumnStart: col-start calc(2 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-3-col-on-sm {\n    --pf-l-grid__item--GridColumnStart: col-start calc(3 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-4-col-on-sm {\n    --pf-l-grid__item--GridColumnStart: col-start calc(4 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-5-col-on-sm {\n    --pf-l-grid__item--GridColumnStart: col-start calc(5 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-6-col-on-sm {\n    --pf-l-grid__item--GridColumnStart: col-start calc(6 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-7-col-on-sm {\n    --pf-l-grid__item--GridColumnStart: col-start calc(7 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-8-col-on-sm {\n    --pf-l-grid__item--GridColumnStart: col-start calc(8 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-9-col-on-sm {\n    --pf-l-grid__item--GridColumnStart: col-start calc(9 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-10-col-on-sm {\n    --pf-l-grid__item--GridColumnStart: col-start calc(10 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-11-col-on-sm {\n    --pf-l-grid__item--GridColumnStart: col-start calc(11 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-12-col-on-sm {\n    --pf-l-grid__item--GridColumnStart: col-start calc(12 + 1);\n  }\n  .pf-l-grid > .pf-m-1-row-on-sm {\n    grid-row: span 1;\n  }\n  .pf-l-grid > .pf-m-2-row-on-sm {\n    grid-row: span 2;\n  }\n  .pf-l-grid > .pf-m-3-row-on-sm {\n    grid-row: span 3;\n  }\n  .pf-l-grid > .pf-m-4-row-on-sm {\n    grid-row: span 4;\n  }\n  .pf-l-grid > .pf-m-5-row-on-sm {\n    grid-row: span 5;\n  }\n  .pf-l-grid > .pf-m-6-row-on-sm {\n    grid-row: span 6;\n  }\n  .pf-l-grid > .pf-m-7-row-on-sm {\n    grid-row: span 7;\n  }\n  .pf-l-grid > .pf-m-8-row-on-sm {\n    grid-row: span 8;\n  }\n  .pf-l-grid > .pf-m-9-row-on-sm {\n    grid-row: span 9;\n  }\n  .pf-l-grid > .pf-m-10-row-on-sm {\n    grid-row: span 10;\n  }\n  .pf-l-grid > .pf-m-11-row-on-sm {\n    grid-row: span 11;\n  }\n  .pf-l-grid > .pf-m-12-row-on-sm {\n    grid-row: span 12;\n  }\n}\n@media screen and (min-width: 768px) {\n  .pf-l-grid > .pf-m-1-col-on-md {\n    --pf-l-grid__item--GridColumnEnd: span 1;\n  }\n  .pf-l-grid > .pf-m-2-col-on-md {\n    --pf-l-grid__item--GridColumnEnd: span 2;\n  }\n  .pf-l-grid > .pf-m-3-col-on-md {\n    --pf-l-grid__item--GridColumnEnd: span 3;\n  }\n  .pf-l-grid > .pf-m-4-col-on-md {\n    --pf-l-grid__item--GridColumnEnd: span 4;\n  }\n  .pf-l-grid > .pf-m-5-col-on-md {\n    --pf-l-grid__item--GridColumnEnd: span 5;\n  }\n  .pf-l-grid > .pf-m-6-col-on-md {\n    --pf-l-grid__item--GridColumnEnd: span 6;\n  }\n  .pf-l-grid > .pf-m-7-col-on-md {\n    --pf-l-grid__item--GridColumnEnd: span 7;\n  }\n  .pf-l-grid > .pf-m-8-col-on-md {\n    --pf-l-grid__item--GridColumnEnd: span 8;\n  }\n  .pf-l-grid > .pf-m-9-col-on-md {\n    --pf-l-grid__item--GridColumnEnd: span 9;\n  }\n  .pf-l-grid > .pf-m-10-col-on-md {\n    --pf-l-grid__item--GridColumnEnd: span 10;\n  }\n  .pf-l-grid > .pf-m-11-col-on-md {\n    --pf-l-grid__item--GridColumnEnd: span 11;\n  }\n  .pf-l-grid > .pf-m-12-col-on-md {\n    --pf-l-grid__item--GridColumnEnd: span 12;\n  }\n  .pf-l-grid > .pf-m-offset-1-col-on-md {\n    --pf-l-grid__item--GridColumnStart: col-start calc(1 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-2-col-on-md {\n    --pf-l-grid__item--GridColumnStart: col-start calc(2 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-3-col-on-md {\n    --pf-l-grid__item--GridColumnStart: col-start calc(3 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-4-col-on-md {\n    --pf-l-grid__item--GridColumnStart: col-start calc(4 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-5-col-on-md {\n    --pf-l-grid__item--GridColumnStart: col-start calc(5 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-6-col-on-md {\n    --pf-l-grid__item--GridColumnStart: col-start calc(6 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-7-col-on-md {\n    --pf-l-grid__item--GridColumnStart: col-start calc(7 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-8-col-on-md {\n    --pf-l-grid__item--GridColumnStart: col-start calc(8 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-9-col-on-md {\n    --pf-l-grid__item--GridColumnStart: col-start calc(9 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-10-col-on-md {\n    --pf-l-grid__item--GridColumnStart: col-start calc(10 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-11-col-on-md {\n    --pf-l-grid__item--GridColumnStart: col-start calc(11 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-12-col-on-md {\n    --pf-l-grid__item--GridColumnStart: col-start calc(12 + 1);\n  }\n  .pf-l-grid > .pf-m-1-row-on-md {\n    grid-row: span 1;\n  }\n  .pf-l-grid > .pf-m-2-row-on-md {\n    grid-row: span 2;\n  }\n  .pf-l-grid > .pf-m-3-row-on-md {\n    grid-row: span 3;\n  }\n  .pf-l-grid > .pf-m-4-row-on-md {\n    grid-row: span 4;\n  }\n  .pf-l-grid > .pf-m-5-row-on-md {\n    grid-row: span 5;\n  }\n  .pf-l-grid > .pf-m-6-row-on-md {\n    grid-row: span 6;\n  }\n  .pf-l-grid > .pf-m-7-row-on-md {\n    grid-row: span 7;\n  }\n  .pf-l-grid > .pf-m-8-row-on-md {\n    grid-row: span 8;\n  }\n  .pf-l-grid > .pf-m-9-row-on-md {\n    grid-row: span 9;\n  }\n  .pf-l-grid > .pf-m-10-row-on-md {\n    grid-row: span 10;\n  }\n  .pf-l-grid > .pf-m-11-row-on-md {\n    grid-row: span 11;\n  }\n  .pf-l-grid > .pf-m-12-row-on-md {\n    grid-row: span 12;\n  }\n}\n@media screen and (min-width: 992px) {\n  .pf-l-grid > .pf-m-1-col-on-lg {\n    --pf-l-grid__item--GridColumnEnd: span 1;\n  }\n  .pf-l-grid > .pf-m-2-col-on-lg {\n    --pf-l-grid__item--GridColumnEnd: span 2;\n  }\n  .pf-l-grid > .pf-m-3-col-on-lg {\n    --pf-l-grid__item--GridColumnEnd: span 3;\n  }\n  .pf-l-grid > .pf-m-4-col-on-lg {\n    --pf-l-grid__item--GridColumnEnd: span 4;\n  }\n  .pf-l-grid > .pf-m-5-col-on-lg {\n    --pf-l-grid__item--GridColumnEnd: span 5;\n  }\n  .pf-l-grid > .pf-m-6-col-on-lg {\n    --pf-l-grid__item--GridColumnEnd: span 6;\n  }\n  .pf-l-grid > .pf-m-7-col-on-lg {\n    --pf-l-grid__item--GridColumnEnd: span 7;\n  }\n  .pf-l-grid > .pf-m-8-col-on-lg {\n    --pf-l-grid__item--GridColumnEnd: span 8;\n  }\n  .pf-l-grid > .pf-m-9-col-on-lg {\n    --pf-l-grid__item--GridColumnEnd: span 9;\n  }\n  .pf-l-grid > .pf-m-10-col-on-lg {\n    --pf-l-grid__item--GridColumnEnd: span 10;\n  }\n  .pf-l-grid > .pf-m-11-col-on-lg {\n    --pf-l-grid__item--GridColumnEnd: span 11;\n  }\n  .pf-l-grid > .pf-m-12-col-on-lg {\n    --pf-l-grid__item--GridColumnEnd: span 12;\n  }\n  .pf-l-grid > .pf-m-offset-1-col-on-lg {\n    --pf-l-grid__item--GridColumnStart: col-start calc(1 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-2-col-on-lg {\n    --pf-l-grid__item--GridColumnStart: col-start calc(2 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-3-col-on-lg {\n    --pf-l-grid__item--GridColumnStart: col-start calc(3 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-4-col-on-lg {\n    --pf-l-grid__item--GridColumnStart: col-start calc(4 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-5-col-on-lg {\n    --pf-l-grid__item--GridColumnStart: col-start calc(5 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-6-col-on-lg {\n    --pf-l-grid__item--GridColumnStart: col-start calc(6 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-7-col-on-lg {\n    --pf-l-grid__item--GridColumnStart: col-start calc(7 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-8-col-on-lg {\n    --pf-l-grid__item--GridColumnStart: col-start calc(8 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-9-col-on-lg {\n    --pf-l-grid__item--GridColumnStart: col-start calc(9 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-10-col-on-lg {\n    --pf-l-grid__item--GridColumnStart: col-start calc(10 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-11-col-on-lg {\n    --pf-l-grid__item--GridColumnStart: col-start calc(11 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-12-col-on-lg {\n    --pf-l-grid__item--GridColumnStart: col-start calc(12 + 1);\n  }\n  .pf-l-grid > .pf-m-1-row-on-lg {\n    grid-row: span 1;\n  }\n  .pf-l-grid > .pf-m-2-row-on-lg {\n    grid-row: span 2;\n  }\n  .pf-l-grid > .pf-m-3-row-on-lg {\n    grid-row: span 3;\n  }\n  .pf-l-grid > .pf-m-4-row-on-lg {\n    grid-row: span 4;\n  }\n  .pf-l-grid > .pf-m-5-row-on-lg {\n    grid-row: span 5;\n  }\n  .pf-l-grid > .pf-m-6-row-on-lg {\n    grid-row: span 6;\n  }\n  .pf-l-grid > .pf-m-7-row-on-lg {\n    grid-row: span 7;\n  }\n  .pf-l-grid > .pf-m-8-row-on-lg {\n    grid-row: span 8;\n  }\n  .pf-l-grid > .pf-m-9-row-on-lg {\n    grid-row: span 9;\n  }\n  .pf-l-grid > .pf-m-10-row-on-lg {\n    grid-row: span 10;\n  }\n  .pf-l-grid > .pf-m-11-row-on-lg {\n    grid-row: span 11;\n  }\n  .pf-l-grid > .pf-m-12-row-on-lg {\n    grid-row: span 12;\n  }\n}\n@media screen and (min-width: 1200px) {\n  .pf-l-grid > .pf-m-1-col-on-xl {\n    --pf-l-grid__item--GridColumnEnd: span 1;\n  }\n  .pf-l-grid > .pf-m-2-col-on-xl {\n    --pf-l-grid__item--GridColumnEnd: span 2;\n  }\n  .pf-l-grid > .pf-m-3-col-on-xl {\n    --pf-l-grid__item--GridColumnEnd: span 3;\n  }\n  .pf-l-grid > .pf-m-4-col-on-xl {\n    --pf-l-grid__item--GridColumnEnd: span 4;\n  }\n  .pf-l-grid > .pf-m-5-col-on-xl {\n    --pf-l-grid__item--GridColumnEnd: span 5;\n  }\n  .pf-l-grid > .pf-m-6-col-on-xl {\n    --pf-l-grid__item--GridColumnEnd: span 6;\n  }\n  .pf-l-grid > .pf-m-7-col-on-xl {\n    --pf-l-grid__item--GridColumnEnd: span 7;\n  }\n  .pf-l-grid > .pf-m-8-col-on-xl {\n    --pf-l-grid__item--GridColumnEnd: span 8;\n  }\n  .pf-l-grid > .pf-m-9-col-on-xl {\n    --pf-l-grid__item--GridColumnEnd: span 9;\n  }\n  .pf-l-grid > .pf-m-10-col-on-xl {\n    --pf-l-grid__item--GridColumnEnd: span 10;\n  }\n  .pf-l-grid > .pf-m-11-col-on-xl {\n    --pf-l-grid__item--GridColumnEnd: span 11;\n  }\n  .pf-l-grid > .pf-m-12-col-on-xl {\n    --pf-l-grid__item--GridColumnEnd: span 12;\n  }\n  .pf-l-grid > .pf-m-offset-1-col-on-xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(1 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-2-col-on-xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(2 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-3-col-on-xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(3 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-4-col-on-xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(4 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-5-col-on-xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(5 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-6-col-on-xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(6 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-7-col-on-xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(7 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-8-col-on-xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(8 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-9-col-on-xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(9 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-10-col-on-xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(10 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-11-col-on-xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(11 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-12-col-on-xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(12 + 1);\n  }\n  .pf-l-grid > .pf-m-1-row-on-xl {\n    grid-row: span 1;\n  }\n  .pf-l-grid > .pf-m-2-row-on-xl {\n    grid-row: span 2;\n  }\n  .pf-l-grid > .pf-m-3-row-on-xl {\n    grid-row: span 3;\n  }\n  .pf-l-grid > .pf-m-4-row-on-xl {\n    grid-row: span 4;\n  }\n  .pf-l-grid > .pf-m-5-row-on-xl {\n    grid-row: span 5;\n  }\n  .pf-l-grid > .pf-m-6-row-on-xl {\n    grid-row: span 6;\n  }\n  .pf-l-grid > .pf-m-7-row-on-xl {\n    grid-row: span 7;\n  }\n  .pf-l-grid > .pf-m-8-row-on-xl {\n    grid-row: span 8;\n  }\n  .pf-l-grid > .pf-m-9-row-on-xl {\n    grid-row: span 9;\n  }\n  .pf-l-grid > .pf-m-10-row-on-xl {\n    grid-row: span 10;\n  }\n  .pf-l-grid > .pf-m-11-row-on-xl {\n    grid-row: span 11;\n  }\n  .pf-l-grid > .pf-m-12-row-on-xl {\n    grid-row: span 12;\n  }\n}\n@media screen and (min-width: 1450px) {\n  .pf-l-grid > .pf-m-1-col-on-2xl {\n    --pf-l-grid__item--GridColumnEnd: span 1;\n  }\n  .pf-l-grid > .pf-m-2-col-on-2xl {\n    --pf-l-grid__item--GridColumnEnd: span 2;\n  }\n  .pf-l-grid > .pf-m-3-col-on-2xl {\n    --pf-l-grid__item--GridColumnEnd: span 3;\n  }\n  .pf-l-grid > .pf-m-4-col-on-2xl {\n    --pf-l-grid__item--GridColumnEnd: span 4;\n  }\n  .pf-l-grid > .pf-m-5-col-on-2xl {\n    --pf-l-grid__item--GridColumnEnd: span 5;\n  }\n  .pf-l-grid > .pf-m-6-col-on-2xl {\n    --pf-l-grid__item--GridColumnEnd: span 6;\n  }\n  .pf-l-grid > .pf-m-7-col-on-2xl {\n    --pf-l-grid__item--GridColumnEnd: span 7;\n  }\n  .pf-l-grid > .pf-m-8-col-on-2xl {\n    --pf-l-grid__item--GridColumnEnd: span 8;\n  }\n  .pf-l-grid > .pf-m-9-col-on-2xl {\n    --pf-l-grid__item--GridColumnEnd: span 9;\n  }\n  .pf-l-grid > .pf-m-10-col-on-2xl {\n    --pf-l-grid__item--GridColumnEnd: span 10;\n  }\n  .pf-l-grid > .pf-m-11-col-on-2xl {\n    --pf-l-grid__item--GridColumnEnd: span 11;\n  }\n  .pf-l-grid > .pf-m-12-col-on-2xl {\n    --pf-l-grid__item--GridColumnEnd: span 12;\n  }\n  .pf-l-grid > .pf-m-offset-1-col-on-2xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(1 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-2-col-on-2xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(2 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-3-col-on-2xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(3 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-4-col-on-2xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(4 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-5-col-on-2xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(5 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-6-col-on-2xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(6 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-7-col-on-2xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(7 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-8-col-on-2xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(8 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-9-col-on-2xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(9 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-10-col-on-2xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(10 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-11-col-on-2xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(11 + 1);\n  }\n  .pf-l-grid > .pf-m-offset-12-col-on-2xl {\n    --pf-l-grid__item--GridColumnStart: col-start calc(12 + 1);\n  }\n  .pf-l-grid > .pf-m-1-row-on-2xl {\n    grid-row: span 1;\n  }\n  .pf-l-grid > .pf-m-2-row-on-2xl {\n    grid-row: span 2;\n  }\n  .pf-l-grid > .pf-m-3-row-on-2xl {\n    grid-row: span 3;\n  }\n  .pf-l-grid > .pf-m-4-row-on-2xl {\n    grid-row: span 4;\n  }\n  .pf-l-grid > .pf-m-5-row-on-2xl {\n    grid-row: span 5;\n  }\n  .pf-l-grid > .pf-m-6-row-on-2xl {\n    grid-row: span 6;\n  }\n  .pf-l-grid > .pf-m-7-row-on-2xl {\n    grid-row: span 7;\n  }\n  .pf-l-grid > .pf-m-8-row-on-2xl {\n    grid-row: span 8;\n  }\n  .pf-l-grid > .pf-m-9-row-on-2xl {\n    grid-row: span 9;\n  }\n  .pf-l-grid > .pf-m-10-row-on-2xl {\n    grid-row: span 10;\n  }\n  .pf-l-grid > .pf-m-11-row-on-2xl {\n    grid-row: span 11;\n  }\n  .pf-l-grid > .pf-m-12-row-on-2xl {\n    grid-row: span 12;\n  }\n}\n.pf-l-grid.pf-m-gutter {\n  grid-gap: var(--pf-l-grid--m-gutter--GridGap);\n}";

// src/user/LibraryPage/ak-library-application-list.ts
var LAYOUTS = /* @__PURE__ */ new Map([
  [
    "row",
    ["pf-m-12-col", "pf-m-all-6-col-on-sm pf-m-all-4-col-on-md pf-m-all-5-col-on-lg pf-m-all-2-col-on-xl"]
  ],
  [
    "2-column",
    ["pf-m-6-col", "pf-m-all-12-col-on-sm pf-m-all-12-col-on-md pf-m-all-4-col-on-lg pf-m-all-4-col-on-xl"]
  ],
  [
    "3-column",
    ["pf-m-4-col", "pf-m-all-12-col-on-sm pf-m-all-12-col-on-md pf-m-all-6-col-on-lg pf-m-all-6-col-on-xl"]
  ]
]);
var LibraryPageApplicationList = class extends AKElement {
  constructor() {
    super(...arguments);
    this.layout = "row";
    this.background = void 0;
    this.selected = "";
    this.apps = [];
  }
  static get styles() {
    return [
      patternfly_base_default,
      empty_state_default,
      content_default,
      grid_default,
      i`
                .app-group-header {
                    margin-bottom: 1em;
                    margin-top: 1.2em;
                }
            `
    ];
  }
  get currentLayout() {
    const layout = LAYOUTS.get(this.layout);
    if (!layout) {
      console.warn(`Unrecognized layout: ${this.layout || "-undefined-"}`);
      return LAYOUTS.get("row");
    }
    return layout;
  }
  render() {
    const [groupClass, groupGrid] = this.currentLayout;
    return ke`<div class="pf-l-grid pf-m-gutter">
            ${this.apps.map(([group, apps]) => {
      return ke`<div class="pf-l-grid__item ${groupClass}">
                    <div class="pf-c-content app-group-header">
                        <h2>${group}</h2>
                    </div>
                    <div class="pf-l-grid pf-m-gutter ${groupGrid}">
                        ${apps.map((app) => {
        return ke`<ak-library-app
                                class="pf-l-grid__item"
                                .application=${app}
                                background=${to(this.background)}
                                ?selected=${app.slug === this.selected}
                            ></ak-library-app>`;
      })}
                    </div>
                </div> `;
    })}
        </div>`;
  }
};
__decorateClass([
  n({ attribute: true })
], LibraryPageApplicationList.prototype, "layout", 2);
__decorateClass([
  n({ attribute: true })
], LibraryPageApplicationList.prototype, "background", 2);
__decorateClass([
  n({ attribute: true })
], LibraryPageApplicationList.prototype, "selected", 2);
__decorateClass([
  n({ attribute: false })
], LibraryPageApplicationList.prototype, "apps", 2);
LibraryPageApplicationList = __decorateClass([
  t("ak-library-application-list")
], LibraryPageApplicationList);

// src/user/LibraryPage/ak-library-application-search-empty.ts
var LibraryPageApplicationSearchEmpty = class extends AKElement {
  static get styles() {
    return [patternfly_base_default, empty_state_default, content_default, spacing_default];
  }
  render() {
    return ke` <div class="pf-c-empty-state pf-m-full-height">
            <div class="pf-c-empty-state__content">
                <i class="fas fa-cubes pf-c-empty-state__icon" aria-hidden="true"></i>
                <h1 class="pf-c-title pf-m-lg">${msg("Search returned no results.")}</h1>
            </div>
        </div>`;
  }
};
LibraryPageApplicationSearchEmpty = __decorateClass([
  t("ak-library-application-search-empty")
], LibraryPageApplicationSearchEmpty);

// node_modules/fuse.js/dist/fuse.mjs
function isArray(value) {
  return !Array.isArray ? getTag(value) === "[object Array]" : Array.isArray(value);
}
var INFINITY = 1 / 0;
function baseToString(value) {
  if (typeof value == "string") {
    return value;
  }
  let result = value + "";
  return result == "0" && 1 / value == -INFINITY ? "-0" : result;
}
function toString(value) {
  return value == null ? "" : baseToString(value);
}
function isString(value) {
  return typeof value === "string";
}
function isNumber(value) {
  return typeof value === "number";
}
function isBoolean(value) {
  return value === true || value === false || isObjectLike(value) && getTag(value) == "[object Boolean]";
}
function isObject(value) {
  return typeof value === "object";
}
function isObjectLike(value) {
  return isObject(value) && value !== null;
}
function isDefined(value) {
  return value !== void 0 && value !== null;
}
function isBlank(value) {
  return !value.trim().length;
}
function getTag(value) {
  return value == null ? value === void 0 ? "[object Undefined]" : "[object Null]" : Object.prototype.toString.call(value);
}
var INCORRECT_INDEX_TYPE = "Incorrect 'index' type";
var LOGICAL_SEARCH_INVALID_QUERY_FOR_KEY = (key) => `Invalid value for key ${key}`;
var PATTERN_LENGTH_TOO_LARGE = (max) => `Pattern length exceeds max of ${max}.`;
var MISSING_KEY_PROPERTY = (name) => `Missing ${name} property in key`;
var INVALID_KEY_WEIGHT_VALUE = (key) => `Property 'weight' in key '${key}' must be a positive integer`;
var hasOwn = Object.prototype.hasOwnProperty;
var KeyStore = class {
  constructor(keys) {
    this._keys = [];
    this._keyMap = {};
    let totalWeight = 0;
    keys.forEach((key) => {
      let obj = createKey(key);
      this._keys.push(obj);
      this._keyMap[obj.id] = obj;
      totalWeight += obj.weight;
    });
    this._keys.forEach((key) => {
      key.weight /= totalWeight;
    });
  }
  get(keyId) {
    return this._keyMap[keyId];
  }
  keys() {
    return this._keys;
  }
  toJSON() {
    return JSON.stringify(this._keys);
  }
};
function createKey(key) {
  let path = null;
  let id = null;
  let src = null;
  let weight = 1;
  let getFn = null;
  if (isString(key) || isArray(key)) {
    src = key;
    path = createKeyPath(key);
    id = createKeyId(key);
  } else {
    if (!hasOwn.call(key, "name")) {
      throw new Error(MISSING_KEY_PROPERTY("name"));
    }
    const name = key.name;
    src = name;
    if (hasOwn.call(key, "weight")) {
      weight = key.weight;
      if (weight <= 0) {
        throw new Error(INVALID_KEY_WEIGHT_VALUE(name));
      }
    }
    path = createKeyPath(name);
    id = createKeyId(name);
    getFn = key.getFn;
  }
  return { path, id, weight, src, getFn };
}
function createKeyPath(key) {
  return isArray(key) ? key : key.split(".");
}
function createKeyId(key) {
  return isArray(key) ? key.join(".") : key;
}
function get(obj, path) {
  let list = [];
  let arr = false;
  const deepGet = (obj2, path2, index) => {
    if (!isDefined(obj2)) {
      return;
    }
    if (!path2[index]) {
      list.push(obj2);
    } else {
      let key = path2[index];
      const value = obj2[key];
      if (!isDefined(value)) {
        return;
      }
      if (index === path2.length - 1 && (isString(value) || isNumber(value) || isBoolean(value))) {
        list.push(toString(value));
      } else if (isArray(value)) {
        arr = true;
        for (let i4 = 0, len = value.length; i4 < len; i4 += 1) {
          deepGet(value[i4], path2, index + 1);
        }
      } else if (path2.length) {
        deepGet(value, path2, index + 1);
      }
    }
  };
  deepGet(obj, isString(path) ? path.split(".") : path, 0);
  return arr ? list : list[0];
}
var MatchOptions = {
  // Whether the matches should be included in the result set. When `true`, each record in the result
  // set will include the indices of the matched characters.
  // These can consequently be used for highlighting purposes.
  includeMatches: false,
  // When `true`, the matching function will continue to the end of a search pattern even if
  // a perfect match has already been located in the string.
  findAllMatches: false,
  // Minimum number of characters that must be matched before a result is considered a match
  minMatchCharLength: 1
};
var BasicOptions = {
  // When `true`, the algorithm continues searching to the end of the input even if a perfect
  // match is found before the end of the same input.
  isCaseSensitive: false,
  // When true, the matching function will continue to the end of a search pattern even if
  includeScore: false,
  // List of properties that will be searched. This also supports nested properties.
  keys: [],
  // Whether to sort the result list, by score
  shouldSort: true,
  // Default sort function: sort by ascending score, ascending index
  sortFn: (a2, b2) => a2.score === b2.score ? a2.idx < b2.idx ? -1 : 1 : a2.score < b2.score ? -1 : 1
};
var FuzzyOptions = {
  // Approximately where in the text is the pattern expected to be found?
  location: 0,
  // At what point does the match algorithm give up. A threshold of '0.0' requires a perfect match
  // (of both letters and location), a threshold of '1.0' would match anything.
  threshold: 0.6,
  // Determines how close the match must be to the fuzzy location (specified above).
  // An exact letter match which is 'distance' characters away from the fuzzy location
  // would score as a complete mismatch. A distance of '0' requires the match be at
  // the exact location specified, a threshold of '1000' would require a perfect match
  // to be within 800 characters of the fuzzy location to be found using a 0.8 threshold.
  distance: 100
};
var AdvancedOptions = {
  // When `true`, it enables the use of unix-like search commands
  useExtendedSearch: false,
  // The get function to use when fetching an object's properties.
  // The default will search nested paths *ie foo.bar.baz*
  getFn: get,
  // When `true`, search will ignore `location` and `distance`, so it won't matter
  // where in the string the pattern appears.
  // More info: https://fusejs.io/concepts/scoring-theory.html#fuzziness-score
  ignoreLocation: false,
  // When `true`, the calculation for the relevance score (used for sorting) will
  // ignore the field-length norm.
  // More info: https://fusejs.io/concepts/scoring-theory.html#field-length-norm
  ignoreFieldNorm: false,
  // The weight to determine how much field length norm effects scoring.
  fieldNormWeight: 1
};
var Config = {
  ...BasicOptions,
  ...MatchOptions,
  ...FuzzyOptions,
  ...AdvancedOptions
};
var SPACE = /[^ ]+/g;
function norm(weight = 1, mantissa = 3) {
  const cache = /* @__PURE__ */ new Map();
  const m2 = Math.pow(10, mantissa);
  return {
    get(value) {
      const numTokens = value.match(SPACE).length;
      if (cache.has(numTokens)) {
        return cache.get(numTokens);
      }
      const norm2 = 1 / Math.pow(numTokens, 0.5 * weight);
      const n3 = parseFloat(Math.round(norm2 * m2) / m2);
      cache.set(numTokens, n3);
      return n3;
    },
    clear() {
      cache.clear();
    }
  };
}
var FuseIndex = class {
  constructor({
    getFn = Config.getFn,
    fieldNormWeight = Config.fieldNormWeight
  } = {}) {
    this.norm = norm(fieldNormWeight, 3);
    this.getFn = getFn;
    this.isCreated = false;
    this.setIndexRecords();
  }
  setSources(docs = []) {
    this.docs = docs;
  }
  setIndexRecords(records = []) {
    this.records = records;
  }
  setKeys(keys = []) {
    this.keys = keys;
    this._keysMap = {};
    keys.forEach((key, idx) => {
      this._keysMap[key.id] = idx;
    });
  }
  create() {
    if (this.isCreated || !this.docs.length) {
      return;
    }
    this.isCreated = true;
    if (isString(this.docs[0])) {
      this.docs.forEach((doc, docIndex) => {
        this._addString(doc, docIndex);
      });
    } else {
      this.docs.forEach((doc, docIndex) => {
        this._addObject(doc, docIndex);
      });
    }
    this.norm.clear();
  }
  // Adds a doc to the end of the index
  add(doc) {
    const idx = this.size();
    if (isString(doc)) {
      this._addString(doc, idx);
    } else {
      this._addObject(doc, idx);
    }
  }
  // Removes the doc at the specified index of the index
  removeAt(idx) {
    this.records.splice(idx, 1);
    for (let i4 = idx, len = this.size(); i4 < len; i4 += 1) {
      this.records[i4].i -= 1;
    }
  }
  getValueForItemAtKeyId(item, keyId) {
    return item[this._keysMap[keyId]];
  }
  size() {
    return this.records.length;
  }
  _addString(doc, docIndex) {
    if (!isDefined(doc) || isBlank(doc)) {
      return;
    }
    let record = {
      v: doc,
      i: docIndex,
      n: this.norm.get(doc)
    };
    this.records.push(record);
  }
  _addObject(doc, docIndex) {
    let record = { i: docIndex, $: {} };
    this.keys.forEach((key, keyIndex) => {
      let value = key.getFn ? key.getFn(doc) : this.getFn(doc, key.path);
      if (!isDefined(value)) {
        return;
      }
      if (isArray(value)) {
        let subRecords = [];
        const stack = [{ nestedArrIndex: -1, value }];
        while (stack.length) {
          const { nestedArrIndex, value: value2 } = stack.pop();
          if (!isDefined(value2)) {
            continue;
          }
          if (isString(value2) && !isBlank(value2)) {
            let subRecord = {
              v: value2,
              i: nestedArrIndex,
              n: this.norm.get(value2)
            };
            subRecords.push(subRecord);
          } else if (isArray(value2)) {
            value2.forEach((item, k2) => {
              stack.push({
                nestedArrIndex: k2,
                value: item
              });
            });
          } else ;
        }
        record.$[keyIndex] = subRecords;
      } else if (isString(value) && !isBlank(value)) {
        let subRecord = {
          v: value,
          n: this.norm.get(value)
        };
        record.$[keyIndex] = subRecord;
      }
    });
    this.records.push(record);
  }
  toJSON() {
    return {
      keys: this.keys,
      records: this.records
    };
  }
};
function createIndex(keys, docs, { getFn = Config.getFn, fieldNormWeight = Config.fieldNormWeight } = {}) {
  const myIndex = new FuseIndex({ getFn, fieldNormWeight });
  myIndex.setKeys(keys.map(createKey));
  myIndex.setSources(docs);
  myIndex.create();
  return myIndex;
}
function parseIndex(data, { getFn = Config.getFn, fieldNormWeight = Config.fieldNormWeight } = {}) {
  const { keys, records } = data;
  const myIndex = new FuseIndex({ getFn, fieldNormWeight });
  myIndex.setKeys(keys);
  myIndex.setIndexRecords(records);
  return myIndex;
}
function computeScore$1(pattern, {
  errors = 0,
  currentLocation = 0,
  expectedLocation = 0,
  distance = Config.distance,
  ignoreLocation = Config.ignoreLocation
} = {}) {
  const accuracy = errors / pattern.length;
  if (ignoreLocation) {
    return accuracy;
  }
  const proximity = Math.abs(expectedLocation - currentLocation);
  if (!distance) {
    return proximity ? 1 : accuracy;
  }
  return accuracy + proximity / distance;
}
function convertMaskToIndices(matchmask = [], minMatchCharLength = Config.minMatchCharLength) {
  let indices = [];
  let start = -1;
  let end = -1;
  let i4 = 0;
  for (let len = matchmask.length; i4 < len; i4 += 1) {
    let match = matchmask[i4];
    if (match && start === -1) {
      start = i4;
    } else if (!match && start !== -1) {
      end = i4 - 1;
      if (end - start + 1 >= minMatchCharLength) {
        indices.push([start, end]);
      }
      start = -1;
    }
  }
  if (matchmask[i4 - 1] && i4 - start >= minMatchCharLength) {
    indices.push([start, i4 - 1]);
  }
  return indices;
}
var MAX_BITS = 32;
function search(text, pattern, patternAlphabet, {
  location = Config.location,
  distance = Config.distance,
  threshold = Config.threshold,
  findAllMatches = Config.findAllMatches,
  minMatchCharLength = Config.minMatchCharLength,
  includeMatches = Config.includeMatches,
  ignoreLocation = Config.ignoreLocation
} = {}) {
  if (pattern.length > MAX_BITS) {
    throw new Error(PATTERN_LENGTH_TOO_LARGE(MAX_BITS));
  }
  const patternLen = pattern.length;
  const textLen = text.length;
  const expectedLocation = Math.max(0, Math.min(location, textLen));
  let currentThreshold = threshold;
  let bestLocation = expectedLocation;
  const computeMatches = minMatchCharLength > 1 || includeMatches;
  const matchMask = computeMatches ? Array(textLen) : [];
  let index;
  while ((index = text.indexOf(pattern, bestLocation)) > -1) {
    let score = computeScore$1(pattern, {
      currentLocation: index,
      expectedLocation,
      distance,
      ignoreLocation
    });
    currentThreshold = Math.min(score, currentThreshold);
    bestLocation = index + patternLen;
    if (computeMatches) {
      let i4 = 0;
      while (i4 < patternLen) {
        matchMask[index + i4] = 1;
        i4 += 1;
      }
    }
  }
  bestLocation = -1;
  let lastBitArr = [];
  let finalScore = 1;
  let binMax = patternLen + textLen;
  const mask = 1 << patternLen - 1;
  for (let i4 = 0; i4 < patternLen; i4 += 1) {
    let binMin = 0;
    let binMid = binMax;
    while (binMin < binMid) {
      const score2 = computeScore$1(pattern, {
        errors: i4,
        currentLocation: expectedLocation + binMid,
        expectedLocation,
        distance,
        ignoreLocation
      });
      if (score2 <= currentThreshold) {
        binMin = binMid;
      } else {
        binMax = binMid;
      }
      binMid = Math.floor((binMax - binMin) / 2 + binMin);
    }
    binMax = binMid;
    let start = Math.max(1, expectedLocation - binMid + 1);
    let finish = findAllMatches ? textLen : Math.min(expectedLocation + binMid, textLen) + patternLen;
    let bitArr = Array(finish + 2);
    bitArr[finish + 1] = (1 << i4) - 1;
    for (let j2 = finish; j2 >= start; j2 -= 1) {
      let currentLocation = j2 - 1;
      let charMatch = patternAlphabet[text.charAt(currentLocation)];
      if (computeMatches) {
        matchMask[currentLocation] = +!!charMatch;
      }
      bitArr[j2] = (bitArr[j2 + 1] << 1 | 1) & charMatch;
      if (i4) {
        bitArr[j2] |= (lastBitArr[j2 + 1] | lastBitArr[j2]) << 1 | 1 | lastBitArr[j2 + 1];
      }
      if (bitArr[j2] & mask) {
        finalScore = computeScore$1(pattern, {
          errors: i4,
          currentLocation,
          expectedLocation,
          distance,
          ignoreLocation
        });
        if (finalScore <= currentThreshold) {
          currentThreshold = finalScore;
          bestLocation = currentLocation;
          if (bestLocation <= expectedLocation) {
            break;
          }
          start = Math.max(1, 2 * expectedLocation - bestLocation);
        }
      }
    }
    const score = computeScore$1(pattern, {
      errors: i4 + 1,
      currentLocation: expectedLocation,
      expectedLocation,
      distance,
      ignoreLocation
    });
    if (score > currentThreshold) {
      break;
    }
    lastBitArr = bitArr;
  }
  const result = {
    isMatch: bestLocation >= 0,
    // Count exact matches (those with a score of 0) to be "almost" exact
    score: Math.max(1e-3, finalScore)
  };
  if (computeMatches) {
    const indices = convertMaskToIndices(matchMask, minMatchCharLength);
    if (!indices.length) {
      result.isMatch = false;
    } else if (includeMatches) {
      result.indices = indices;
    }
  }
  return result;
}
function createPatternAlphabet(pattern) {
  let mask = {};
  for (let i4 = 0, len = pattern.length; i4 < len; i4 += 1) {
    const char = pattern.charAt(i4);
    mask[char] = (mask[char] || 0) | 1 << len - i4 - 1;
  }
  return mask;
}
var BitapSearch = class {
  constructor(pattern, {
    location = Config.location,
    threshold = Config.threshold,
    distance = Config.distance,
    includeMatches = Config.includeMatches,
    findAllMatches = Config.findAllMatches,
    minMatchCharLength = Config.minMatchCharLength,
    isCaseSensitive = Config.isCaseSensitive,
    ignoreLocation = Config.ignoreLocation
  } = {}) {
    this.options = {
      location,
      threshold,
      distance,
      includeMatches,
      findAllMatches,
      minMatchCharLength,
      isCaseSensitive,
      ignoreLocation
    };
    this.pattern = isCaseSensitive ? pattern : pattern.toLowerCase();
    this.chunks = [];
    if (!this.pattern.length) {
      return;
    }
    const addChunk = (pattern2, startIndex) => {
      this.chunks.push({
        pattern: pattern2,
        alphabet: createPatternAlphabet(pattern2),
        startIndex
      });
    };
    const len = this.pattern.length;
    if (len > MAX_BITS) {
      let i4 = 0;
      const remainder = len % MAX_BITS;
      const end = len - remainder;
      while (i4 < end) {
        addChunk(this.pattern.substr(i4, MAX_BITS), i4);
        i4 += MAX_BITS;
      }
      if (remainder) {
        const startIndex = len - MAX_BITS;
        addChunk(this.pattern.substr(startIndex), startIndex);
      }
    } else {
      addChunk(this.pattern, 0);
    }
  }
  searchIn(text) {
    const { isCaseSensitive, includeMatches } = this.options;
    if (!isCaseSensitive) {
      text = text.toLowerCase();
    }
    if (this.pattern === text) {
      let result2 = {
        isMatch: true,
        score: 0
      };
      if (includeMatches) {
        result2.indices = [[0, text.length - 1]];
      }
      return result2;
    }
    const {
      location,
      distance,
      threshold,
      findAllMatches,
      minMatchCharLength,
      ignoreLocation
    } = this.options;
    let allIndices = [];
    let totalScore = 0;
    let hasMatches = false;
    this.chunks.forEach(({ pattern, alphabet, startIndex }) => {
      const { isMatch, score, indices } = search(text, pattern, alphabet, {
        location: location + startIndex,
        distance,
        threshold,
        findAllMatches,
        minMatchCharLength,
        includeMatches,
        ignoreLocation
      });
      if (isMatch) {
        hasMatches = true;
      }
      totalScore += score;
      if (isMatch && indices) {
        allIndices = [...allIndices, ...indices];
      }
    });
    let result = {
      isMatch: hasMatches,
      score: hasMatches ? totalScore / this.chunks.length : 1
    };
    if (hasMatches && includeMatches) {
      result.indices = allIndices;
    }
    return result;
  }
};
var BaseMatch = class {
  constructor(pattern) {
    this.pattern = pattern;
  }
  static isMultiMatch(pattern) {
    return getMatch(pattern, this.multiRegex);
  }
  static isSingleMatch(pattern) {
    return getMatch(pattern, this.singleRegex);
  }
  search() {
  }
};
function getMatch(pattern, exp) {
  const matches = pattern.match(exp);
  return matches ? matches[1] : null;
}
var ExactMatch = class extends BaseMatch {
  constructor(pattern) {
    super(pattern);
  }
  static get type() {
    return "exact";
  }
  static get multiRegex() {
    return /^="(.*)"$/;
  }
  static get singleRegex() {
    return /^=(.*)$/;
  }
  search(text) {
    const isMatch = text === this.pattern;
    return {
      isMatch,
      score: isMatch ? 0 : 1,
      indices: [0, this.pattern.length - 1]
    };
  }
};
var InverseExactMatch = class extends BaseMatch {
  constructor(pattern) {
    super(pattern);
  }
  static get type() {
    return "inverse-exact";
  }
  static get multiRegex() {
    return /^!"(.*)"$/;
  }
  static get singleRegex() {
    return /^!(.*)$/;
  }
  search(text) {
    const index = text.indexOf(this.pattern);
    const isMatch = index === -1;
    return {
      isMatch,
      score: isMatch ? 0 : 1,
      indices: [0, text.length - 1]
    };
  }
};
var PrefixExactMatch = class extends BaseMatch {
  constructor(pattern) {
    super(pattern);
  }
  static get type() {
    return "prefix-exact";
  }
  static get multiRegex() {
    return /^\^"(.*)"$/;
  }
  static get singleRegex() {
    return /^\^(.*)$/;
  }
  search(text) {
    const isMatch = text.startsWith(this.pattern);
    return {
      isMatch,
      score: isMatch ? 0 : 1,
      indices: [0, this.pattern.length - 1]
    };
  }
};
var InversePrefixExactMatch = class extends BaseMatch {
  constructor(pattern) {
    super(pattern);
  }
  static get type() {
    return "inverse-prefix-exact";
  }
  static get multiRegex() {
    return /^!\^"(.*)"$/;
  }
  static get singleRegex() {
    return /^!\^(.*)$/;
  }
  search(text) {
    const isMatch = !text.startsWith(this.pattern);
    return {
      isMatch,
      score: isMatch ? 0 : 1,
      indices: [0, text.length - 1]
    };
  }
};
var SuffixExactMatch = class extends BaseMatch {
  constructor(pattern) {
    super(pattern);
  }
  static get type() {
    return "suffix-exact";
  }
  static get multiRegex() {
    return /^"(.*)"\$$/;
  }
  static get singleRegex() {
    return /^(.*)\$$/;
  }
  search(text) {
    const isMatch = text.endsWith(this.pattern);
    return {
      isMatch,
      score: isMatch ? 0 : 1,
      indices: [text.length - this.pattern.length, text.length - 1]
    };
  }
};
var InverseSuffixExactMatch = class extends BaseMatch {
  constructor(pattern) {
    super(pattern);
  }
  static get type() {
    return "inverse-suffix-exact";
  }
  static get multiRegex() {
    return /^!"(.*)"\$$/;
  }
  static get singleRegex() {
    return /^!(.*)\$$/;
  }
  search(text) {
    const isMatch = !text.endsWith(this.pattern);
    return {
      isMatch,
      score: isMatch ? 0 : 1,
      indices: [0, text.length - 1]
    };
  }
};
var FuzzyMatch = class extends BaseMatch {
  constructor(pattern, {
    location = Config.location,
    threshold = Config.threshold,
    distance = Config.distance,
    includeMatches = Config.includeMatches,
    findAllMatches = Config.findAllMatches,
    minMatchCharLength = Config.minMatchCharLength,
    isCaseSensitive = Config.isCaseSensitive,
    ignoreLocation = Config.ignoreLocation
  } = {}) {
    super(pattern);
    this._bitapSearch = new BitapSearch(pattern, {
      location,
      threshold,
      distance,
      includeMatches,
      findAllMatches,
      minMatchCharLength,
      isCaseSensitive,
      ignoreLocation
    });
  }
  static get type() {
    return "fuzzy";
  }
  static get multiRegex() {
    return /^"(.*)"$/;
  }
  static get singleRegex() {
    return /^(.*)$/;
  }
  search(text) {
    return this._bitapSearch.searchIn(text);
  }
};
var IncludeMatch = class extends BaseMatch {
  constructor(pattern) {
    super(pattern);
  }
  static get type() {
    return "include";
  }
  static get multiRegex() {
    return /^'"(.*)"$/;
  }
  static get singleRegex() {
    return /^'(.*)$/;
  }
  search(text) {
    let location = 0;
    let index;
    const indices = [];
    const patternLen = this.pattern.length;
    while ((index = text.indexOf(this.pattern, location)) > -1) {
      location = index + patternLen;
      indices.push([index, location - 1]);
    }
    const isMatch = !!indices.length;
    return {
      isMatch,
      score: isMatch ? 0 : 1,
      indices
    };
  }
};
var searchers = [
  ExactMatch,
  IncludeMatch,
  PrefixExactMatch,
  InversePrefixExactMatch,
  InverseSuffixExactMatch,
  SuffixExactMatch,
  InverseExactMatch,
  FuzzyMatch
];
var searchersLen = searchers.length;
var SPACE_RE = / +(?=(?:[^\"]*\"[^\"]*\")*[^\"]*$)/;
var OR_TOKEN = "|";
function parseQuery(pattern, options = {}) {
  return pattern.split(OR_TOKEN).map((item) => {
    let query = item.trim().split(SPACE_RE).filter((item2) => item2 && !!item2.trim());
    let results = [];
    for (let i4 = 0, len = query.length; i4 < len; i4 += 1) {
      const queryItem = query[i4];
      let found = false;
      let idx = -1;
      while (!found && ++idx < searchersLen) {
        const searcher = searchers[idx];
        let token = searcher.isMultiMatch(queryItem);
        if (token) {
          results.push(new searcher(token, options));
          found = true;
        }
      }
      if (found) {
        continue;
      }
      idx = -1;
      while (++idx < searchersLen) {
        const searcher = searchers[idx];
        let token = searcher.isSingleMatch(queryItem);
        if (token) {
          results.push(new searcher(token, options));
          break;
        }
      }
    }
    return results;
  });
}
var MultiMatchSet = /* @__PURE__ */ new Set([FuzzyMatch.type, IncludeMatch.type]);
var ExtendedSearch = class {
  constructor(pattern, {
    isCaseSensitive = Config.isCaseSensitive,
    includeMatches = Config.includeMatches,
    minMatchCharLength = Config.minMatchCharLength,
    ignoreLocation = Config.ignoreLocation,
    findAllMatches = Config.findAllMatches,
    location = Config.location,
    threshold = Config.threshold,
    distance = Config.distance
  } = {}) {
    this.query = null;
    this.options = {
      isCaseSensitive,
      includeMatches,
      minMatchCharLength,
      findAllMatches,
      ignoreLocation,
      location,
      threshold,
      distance
    };
    this.pattern = isCaseSensitive ? pattern : pattern.toLowerCase();
    this.query = parseQuery(this.pattern, this.options);
  }
  static condition(_2, options) {
    return options.useExtendedSearch;
  }
  searchIn(text) {
    const query = this.query;
    if (!query) {
      return {
        isMatch: false,
        score: 1
      };
    }
    const { includeMatches, isCaseSensitive } = this.options;
    text = isCaseSensitive ? text : text.toLowerCase();
    let numMatches = 0;
    let allIndices = [];
    let totalScore = 0;
    for (let i4 = 0, qLen = query.length; i4 < qLen; i4 += 1) {
      const searchers2 = query[i4];
      allIndices.length = 0;
      numMatches = 0;
      for (let j2 = 0, pLen = searchers2.length; j2 < pLen; j2 += 1) {
        const searcher = searchers2[j2];
        const { isMatch, indices, score } = searcher.search(text);
        if (isMatch) {
          numMatches += 1;
          totalScore += score;
          if (includeMatches) {
            const type = searcher.constructor.type;
            if (MultiMatchSet.has(type)) {
              allIndices = [...allIndices, ...indices];
            } else {
              allIndices.push(indices);
            }
          }
        } else {
          totalScore = 0;
          numMatches = 0;
          allIndices.length = 0;
          break;
        }
      }
      if (numMatches) {
        let result = {
          isMatch: true,
          score: totalScore / numMatches
        };
        if (includeMatches) {
          result.indices = allIndices;
        }
        return result;
      }
    }
    return {
      isMatch: false,
      score: 1
    };
  }
};
var registeredSearchers = [];
function register(...args) {
  registeredSearchers.push(...args);
}
function createSearcher(pattern, options) {
  for (let i4 = 0, len = registeredSearchers.length; i4 < len; i4 += 1) {
    let searcherClass = registeredSearchers[i4];
    if (searcherClass.condition(pattern, options)) {
      return new searcherClass(pattern, options);
    }
  }
  return new BitapSearch(pattern, options);
}
var LogicalOperator = {
  AND: "$and",
  OR: "$or"
};
var KeyType = {
  PATH: "$path",
  PATTERN: "$val"
};
var isExpression = (query) => !!(query[LogicalOperator.AND] || query[LogicalOperator.OR]);
var isPath = (query) => !!query[KeyType.PATH];
var isLeaf = (query) => !isArray(query) && isObject(query) && !isExpression(query);
var convertToExplicit = (query) => ({
  [LogicalOperator.AND]: Object.keys(query).map((key) => ({
    [key]: query[key]
  }))
});
function parse(query, options, { auto = true } = {}) {
  const next = (query2) => {
    let keys = Object.keys(query2);
    const isQueryPath = isPath(query2);
    if (!isQueryPath && keys.length > 1 && !isExpression(query2)) {
      return next(convertToExplicit(query2));
    }
    if (isLeaf(query2)) {
      const key = isQueryPath ? query2[KeyType.PATH] : keys[0];
      const pattern = isQueryPath ? query2[KeyType.PATTERN] : query2[key];
      if (!isString(pattern)) {
        throw new Error(LOGICAL_SEARCH_INVALID_QUERY_FOR_KEY(key));
      }
      const obj = {
        keyId: createKeyId(key),
        pattern
      };
      if (auto) {
        obj.searcher = createSearcher(pattern, options);
      }
      return obj;
    }
    let node = {
      children: [],
      operator: keys[0]
    };
    keys.forEach((key) => {
      const value = query2[key];
      if (isArray(value)) {
        value.forEach((item) => {
          node.children.push(next(item));
        });
      }
    });
    return node;
  };
  if (!isExpression(query)) {
    query = convertToExplicit(query);
  }
  return next(query);
}
function computeScore(results, { ignoreFieldNorm = Config.ignoreFieldNorm }) {
  results.forEach((result) => {
    let totalScore = 1;
    result.matches.forEach(({ key, norm: norm2, score }) => {
      const weight = key ? key.weight : null;
      totalScore *= Math.pow(
        score === 0 && weight ? Number.EPSILON : score,
        (weight || 1) * (ignoreFieldNorm ? 1 : norm2)
      );
    });
    result.score = totalScore;
  });
}
function transformMatches(result, data) {
  const matches = result.matches;
  data.matches = [];
  if (!isDefined(matches)) {
    return;
  }
  matches.forEach((match) => {
    if (!isDefined(match.indices) || !match.indices.length) {
      return;
    }
    const { indices, value } = match;
    let obj = {
      indices,
      value
    };
    if (match.key) {
      obj.key = match.key.src;
    }
    if (match.idx > -1) {
      obj.refIndex = match.idx;
    }
    data.matches.push(obj);
  });
}
function transformScore(result, data) {
  data.score = result.score;
}
function format(results, docs, {
  includeMatches = Config.includeMatches,
  includeScore = Config.includeScore
} = {}) {
  const transformers = [];
  if (includeMatches) transformers.push(transformMatches);
  if (includeScore) transformers.push(transformScore);
  return results.map((result) => {
    const { idx } = result;
    const data = {
      item: docs[idx],
      refIndex: idx
    };
    if (transformers.length) {
      transformers.forEach((transformer) => {
        transformer(result, data);
      });
    }
    return data;
  });
}
var Fuse = class {
  constructor(docs, options = {}, index) {
    this.options = { ...Config, ...options };
    if (this.options.useExtendedSearch && false) {
      throw new Error(EXTENDED_SEARCH_UNAVAILABLE);
    }
    this._keyStore = new KeyStore(this.options.keys);
    this.setCollection(docs, index);
  }
  setCollection(docs, index) {
    this._docs = docs;
    if (index && !(index instanceof FuseIndex)) {
      throw new Error(INCORRECT_INDEX_TYPE);
    }
    this._myIndex = index || createIndex(this.options.keys, this._docs, {
      getFn: this.options.getFn,
      fieldNormWeight: this.options.fieldNormWeight
    });
  }
  add(doc) {
    if (!isDefined(doc)) {
      return;
    }
    this._docs.push(doc);
    this._myIndex.add(doc);
  }
  remove(predicate = () => false) {
    const results = [];
    for (let i4 = 0, len = this._docs.length; i4 < len; i4 += 1) {
      const doc = this._docs[i4];
      if (predicate(doc, i4)) {
        this.removeAt(i4);
        i4 -= 1;
        len -= 1;
        results.push(doc);
      }
    }
    return results;
  }
  removeAt(idx) {
    this._docs.splice(idx, 1);
    this._myIndex.removeAt(idx);
  }
  getIndex() {
    return this._myIndex;
  }
  search(query, { limit = -1 } = {}) {
    const {
      includeMatches,
      includeScore,
      shouldSort,
      sortFn,
      ignoreFieldNorm
    } = this.options;
    let results = isString(query) ? isString(this._docs[0]) ? this._searchStringList(query) : this._searchObjectList(query) : this._searchLogical(query);
    computeScore(results, { ignoreFieldNorm });
    if (shouldSort) {
      results.sort(sortFn);
    }
    if (isNumber(limit) && limit > -1) {
      results = results.slice(0, limit);
    }
    return format(results, this._docs, {
      includeMatches,
      includeScore
    });
  }
  _searchStringList(query) {
    const searcher = createSearcher(query, this.options);
    const { records } = this._myIndex;
    const results = [];
    records.forEach(({ v: text, i: idx, n: norm2 }) => {
      if (!isDefined(text)) {
        return;
      }
      const { isMatch, score, indices } = searcher.searchIn(text);
      if (isMatch) {
        results.push({
          item: text,
          idx,
          matches: [{ score, value: text, norm: norm2, indices }]
        });
      }
    });
    return results;
  }
  _searchLogical(query) {
    const expression = parse(query, this.options);
    const evaluate = (node, item, idx) => {
      if (!node.children) {
        const { keyId, searcher } = node;
        const matches = this._findMatches({
          key: this._keyStore.get(keyId),
          value: this._myIndex.getValueForItemAtKeyId(item, keyId),
          searcher
        });
        if (matches && matches.length) {
          return [
            {
              idx,
              item,
              matches
            }
          ];
        }
        return [];
      }
      const res = [];
      for (let i4 = 0, len = node.children.length; i4 < len; i4 += 1) {
        const child = node.children[i4];
        const result = evaluate(child, item, idx);
        if (result.length) {
          res.push(...result);
        } else if (node.operator === LogicalOperator.AND) {
          return [];
        }
      }
      return res;
    };
    const records = this._myIndex.records;
    const resultMap = {};
    const results = [];
    records.forEach(({ $: item, i: idx }) => {
      if (isDefined(item)) {
        let expResults = evaluate(expression, item, idx);
        if (expResults.length) {
          if (!resultMap[idx]) {
            resultMap[idx] = { idx, item, matches: [] };
            results.push(resultMap[idx]);
          }
          expResults.forEach(({ matches }) => {
            resultMap[idx].matches.push(...matches);
          });
        }
      }
    });
    return results;
  }
  _searchObjectList(query) {
    const searcher = createSearcher(query, this.options);
    const { keys, records } = this._myIndex;
    const results = [];
    records.forEach(({ $: item, i: idx }) => {
      if (!isDefined(item)) {
        return;
      }
      let matches = [];
      keys.forEach((key, keyIndex) => {
        matches.push(
          ...this._findMatches({
            key,
            value: item[keyIndex],
            searcher
          })
        );
      });
      if (matches.length) {
        results.push({
          idx,
          item,
          matches
        });
      }
    });
    return results;
  }
  _findMatches({ key, value, searcher }) {
    if (!isDefined(value)) {
      return [];
    }
    let matches = [];
    if (isArray(value)) {
      value.forEach(({ v: text, i: idx, n: norm2 }) => {
        if (!isDefined(text)) {
          return;
        }
        const { isMatch, score, indices } = searcher.searchIn(text);
        if (isMatch) {
          matches.push({
            score,
            key,
            value: text,
            idx,
            norm: norm2,
            indices
          });
        }
      });
    } else {
      const { v: text, n: norm2 } = value;
      const { isMatch, score, indices } = searcher.searchIn(text);
      if (isMatch) {
        matches.push({ score, key, value: text, norm: norm2, indices });
      }
    }
    return matches;
  }
};
Fuse.version = "7.0.0";
Fuse.createIndex = createIndex;
Fuse.parseIndex = parseIndex;
Fuse.config = Config;
{
  Fuse.parseQuery = parse;
}
{
  register(ExtendedSearch);
}

// src/user/LibraryPage/events.ts
var LibraryPageSearchUpdated = class _LibraryPageSearchUpdated extends Event {
  /**
   * @attr apps: The list of those entries found by the current search.
   */
  constructor(apps) {
    super(_LibraryPageSearchUpdated.eventName, { composed: true, bubbles: true });
    this.apps = apps;
  }
  static {
    this.eventName = "authentik.library.search-updated";
  }
};
var LibraryPageSearchReset = class _LibraryPageSearchReset extends Event {
  static {
    this.eventName = "authentik.library.search-reset";
  }
  constructor() {
    super(_LibraryPageSearchReset.eventName, { composed: true, bubbles: true });
  }
};
var LibraryPageSearchEmpty = class _LibraryPageSearchEmpty extends Event {
  static {
    this.eventName = "authentik.library.search-empty";
  }
  constructor() {
    super(_LibraryPageSearchEmpty.eventName, { composed: true, bubbles: true });
  }
};
var LibraryPageSearchSelected = class _LibraryPageSearchSelected extends Event {
  static {
    this.eventName = "authentik.library.search-item-selected";
  }
  constructor() {
    super(_LibraryPageSearchSelected.eventName, { composed: true, bubbles: true });
  }
};

// src/user/LibraryPage/ak-library-application-search.ts
var LibraryPageApplicationSearch = class extends AKElement {
  constructor() {
    super();
    this.query = getURLParam("search", void 0);
    this.fuse = new Fuse([], {
      keys: [
        { name: "name", weight: 3 },
        "slug",
        "group",
        { name: "metaDescription", weight: 0.5 },
        { name: "metaPublisher", weight: 0.5 }
      ],
      findAllMatches: true,
      includeScore: true,
      shouldSort: true,
      ignoreFieldNorm: true,
      useExtendedSearch: true,
      threshold: 0.3
    });
  }
  static get styles() {
    return [
      patternfly_base_default,
      display_default,
      i`
                input {
                    width: 30ch;
                    box-sizing: border-box;
                    border: 0;
                    border-bottom: 1px solid;
                    border-bottom-color: var(--ak-accent);
                    background-color: transparent;
                    font-size: 1.5rem;
                }
                input:focus {
                    outline: 0;
                }
                :host([theme="dark"]) input {
                    color: var(--ak-dark-foreground) !important;
                }
            `
    ];
  }
  set apps(value) {
    this.fuse.setCollection(value);
  }
  onSelected(apps) {
    this.dispatchEvent(new LibraryPageSearchUpdated(apps.map((app) => app.item)));
  }
  connectedCallback() {
    super.connectedCallback();
    if (!this.query) {
      return;
    }
    const matchingApps = this.fuse.search(this.query);
    if (matchingApps.length < 1) {
      return;
    }
    this.onSelected(matchingApps);
  }
  resetSearch() {
    if (this.searchInput) {
      this.searchInput.value = "";
    }
    this.query = "";
    updateURLParams({
      search: this.query
    });
    this.dispatchEvent(new LibraryPageSearchReset());
  }
  onInput(ev) {
    this.query = ev.target.value;
    if (this.query === "") {
      return this.resetSearch();
    }
    updateURLParams({
      search: this.query
    });
    const apps = this.fuse.search(this.query);
    if (apps.length < 1) {
      this.dispatchEvent(new LibraryPageSearchEmpty());
      return;
    }
    this.onSelected(apps);
  }
  onKeyDown(ev) {
    switch (ev.key) {
      case "Escape": {
        this.resetSearch();
        return;
      }
      case "Enter": {
        this.dispatchEvent(new LibraryPageSearchSelected());
        return;
      }
    }
  }
  render() {
    return ke`<input
            @input=${this.onInput}
            @keydown=${this.onKeyDown}
            type="text"
            class="pf-u-display-none pf-u-display-block-on-md"
            autofocus
            placeholder=${msg("Search...")}
            value=${to(this.query)}
        />`;
  }
};
__decorateClass([
  n({ attribute: false })
], LibraryPageApplicationSearch.prototype, "apps", 1);
__decorateClass([
  n()
], LibraryPageApplicationSearch.prototype, "query", 2);
__decorateClass([
  e("input")
], LibraryPageApplicationSearch.prototype, "searchInput", 2);
LibraryPageApplicationSearch = __decorateClass([
  t("ak-library-application-search")
], LibraryPageApplicationSearch);

// src/user/LibraryPage/ak-library-impl.ts
var LibraryPage = class extends AKElement {
  constructor() {
    super(...arguments);
    this.isAdmin = false;
    this.filteredApps = [];
  }
  static get styles() {
    return LibraryPageImpl_css_default;
  }
  pageTitle() {
    return msg("My Applications");
  }
  connectedCallback() {
    super.connectedCallback();
    this.filteredApps = this.apps;
    if (this.filteredApps === void 0) {
      throw new Error(
        "Application.results should never be undefined when passed to the Library Page."
      );
    }
    this.addEventListener(LibraryPageSearchUpdated.eventName, this.searchUpdated);
    this.addEventListener(LibraryPageSearchReset.eventName, this.searchReset);
    this.addEventListener(LibraryPageSearchEmpty.eventName, this.searchEmpty);
    this.addEventListener(LibraryPageSearchSelected.eventName, this.launchRequest);
  }
  disconnectedCallback() {
    this.removeEventListener(LibraryPageSearchUpdated.eventName, this.searchUpdated);
    this.removeEventListener(LibraryPageSearchReset.eventName, this.searchReset);
    this.removeEventListener(LibraryPageSearchEmpty.eventName, this.searchEmpty);
    this.removeEventListener(LibraryPageSearchSelected.eventName, this.launchRequest);
    super.disconnectedCallback();
  }
  searchUpdated(event) {
    event.stopPropagation();
    const apps = event.apps;
    if (apps.length <= 0) {
      throw new Error(
        "LibaryPageSearchUpdated had empty results body. This must not happen."
      );
    }
    this.filteredApps = apps;
    this.selectedApp = apps[0];
  }
  launchRequest(event) {
    event.stopPropagation();
    if (!this.selectedApp?.launchUrl) {
      return;
    }
    if (!this.selectedApp.openInNewTab) {
      window.location.assign(this.selectedApp?.launchUrl);
    } else {
      window.open(this.selectedApp.launchUrl);
    }
  }
  searchReset(event) {
    event.stopPropagation();
    this.filteredApps = this.apps;
    this.selectedApp = void 0;
  }
  searchEmpty(event) {
    event.stopPropagation();
    this.filteredApps = [];
    this.selectedApp = void 0;
  }
  renderApps() {
    const selected = this.selectedApp?.slug;
    const layout = this.uiConfig.layout;
    const background = this.uiConfig.background;
    const groupedApps = groupBy(
      this.filteredApps.filter(appHasLaunchUrl),
      (app) => app.group || ""
    );
    return ke`<ak-library-application-list
            layout="${layout}"
            background="${to(background)}"
            selected="${to(selected)}"
            .apps=${groupedApps}
        ></ak-library-application-list>`;
  }
  renderSearch() {
    return ke`<ak-library-application-search
            .apps=${this.apps}
        ></ak-library-application-search>`;
  }
  renderNoAppsFound() {
    return ke`<ak-library-application-search-empty></ak-library-application-search-empty>`;
  }
  renderSearchEmpty() {
    return D;
  }
  renderState() {
    if (!this.apps.some(appHasLaunchUrl)) {
      return ke`<ak-library-application-empty-list
                ?isadmin=${this.isAdmin}
            ></ak-library-application-empty-list>`;
    }
    return this.filteredApps.some(appHasLaunchUrl) ? this.renderApps() : this.renderNoAppsFound();
  }
  render() {
    return ke`<main role="main" class="pf-c-page__main" tabindex="-1" id="main-content">
            <div class="pf-c-content header">
                <h1 role="heading" aria-level="1" id="library-page-title">
                    ${msg("My applications")}
                </h1>
                ${this.uiConfig.searchEnabled ? this.renderSearch() : D}
            </div>
            <section class="pf-c-page__main-section">${this.renderState()}</section>
        </main>`;
  }
};
__decorateClass([
  n({ attribute: "isadmin", type: Boolean })
], LibraryPage.prototype, "isAdmin", 2);
__decorateClass([
  n({ attribute: false, type: Array })
], LibraryPage.prototype, "apps", 2);
__decorateClass([
  n({ attribute: false })
], LibraryPage.prototype, "uiConfig", 2);
__decorateClass([
  r()
], LibraryPage.prototype, "selectedApp", 2);
__decorateClass([
  r()
], LibraryPage.prototype, "filteredApps", 2);
__decorateClass([
  bound
], LibraryPage.prototype, "searchUpdated", 1);
__decorateClass([
  bound
], LibraryPage.prototype, "launchRequest", 1);
__decorateClass([
  bound
], LibraryPage.prototype, "searchReset", 1);
__decorateClass([
  bound
], LibraryPage.prototype, "searchEmpty", 1);
LibraryPage = __decorateClass([
  t("ak-library-impl")
], LibraryPage);

// src/user/LibraryPage/ak-library.ts
var coreApi = () => new CoreApi(DEFAULT_CONFIG);
var LibraryPage2 = class extends AKElement {
  constructor() {
    super();
    this.ready = false;
    this.isAdmin = false;
    this.apps = [];
    const uiConfig2 = rootInterface()?.uiConfig;
    if (!uiConfig2) {
      throw new Error("Could not retrieve uiConfig. Reason: unknown. Check logs.");
    }
    this.uiConfig = {
      layout: uiConfig2.layout.type,
      background: uiConfig2.theme.cardBackground,
      searchEnabled: uiConfig2.enabledFeatures.search
    };
    Promise.all([this.fetchApplications(), me()]).then(([applications, meStatus]) => {
      this.isAdmin = meStatus.user.isSuperuser;
      this.apps = applications;
      this.ready = true;
    });
  }
  async fetchApplications() {
    const applicationListParams = (page = 1) => ({
      ordering: "name",
      page,
      pageSize: 100,
      onlyWithLaunchUrl: true
    });
    const applicationListFetch = await coreApi().coreApplicationsList(applicationListParams(1));
    const pageCount = applicationListFetch.pagination.totalPages;
    if (pageCount === 1) {
      return applicationListFetch.results;
    }
    const applicationLaterPages = await Promise.allSettled(
      Array.from({ length: pageCount - 1 }).map(
        (_a3, idx) => coreApi().coreApplicationsList(applicationListParams(idx + 2))
      )
    );
    return applicationLaterPages.reduce(
      function(acc, result) {
        if (result.status === "rejected") {
          const reason = JSON.stringify(result.reason, null, 2);
          throw new Error(`Could not retrieve list of applications. Reason: ${reason}`);
        }
        return [...acc, ...result.value.results];
      },
      [...applicationListFetch.results]
    );
  }
  pageTitle() {
    return msg("My Applications");
  }
  loading() {
    return ke`<ak-empty-state ?loading="${true}" header=${msg("Loading")}> </ak-empty-state>`;
  }
  running() {
    return ke`<ak-library-impl
            ?isadmin=${this.isAdmin}
            .apps=${this.apps}
            .uiConfig=${this.uiConfig}
        ></ak-library-impl>`;
  }
  render() {
    return this.ready ? this.running() : this.loading();
  }
};
__decorateClass([
  r()
], LibraryPage2.prototype, "ready", 2);
__decorateClass([
  r()
], LibraryPage2.prototype, "isAdmin", 2);
__decorateClass([
  r()
], LibraryPage2.prototype, "apps", 2);
__decorateClass([
  r()
], LibraryPage2.prototype, "uiConfig", 2);
LibraryPage2 = __decorateClass([
  localized(),
  t("ak-library")
], LibraryPage2);

// src/user/Routes.ts
var ROUTES = [
  // Prevent infinite Shell loops
  new Route(new RegExp("^/$")).redirect("/library"),
  new Route(new RegExp("^#.*")).redirect("/library"),
  new Route(new RegExp("^/library$"), async () => ke`<ak-library></ak-library>`),
  new Route(new RegExp("^/settings$"), async () => {
    await import("./UserSettingsPage-RQGTI5II.js");
    return ke`<ak-user-settings></ak-user-settings>`;
  })
];

// src/user/UserInterface.ts
var customStyles = i`
    .pf-c-page__main,
    .pf-c-drawer__content,
    .pf-c-page__drawer {
        z-index: auto !important;
        background-color: transparent !important;
    }
    .pf-c-page__header {
        background-color: transparent !important;
        box-shadow: none !important;
        color: black !important;
    }
    :host([theme="light"]) .pf-c-button.pf-m-secondary {
        color: var(--ak-global--Color--100) !important;
    }
    .pf-c-page {
        background-color: transparent;
    }
    .display-none {
        display: none;
    }
    .pf-c-brand {
        min-height: 32px;
        height: 32px;
    }
    .has-notifications {
        color: #2b9af3;
    }
    .background-wrapper {
        height: 100vh;
        width: 100%;
        position: fixed;
        z-index: -1;
        top: 0;
        left: 0;
        background-color: var(--pf-c-page--BackgroundColor) !important;
    }
    .background-default-slant {
        background-color: white; /*var(--ak-accent);*/
        clip-path: polygon(0 0, 100% 0, 100% 100%, 0 calc(100% - 5vw));
        height: 50vh;
    }
    :host([theme="dark"]) .background-default-slant {
        background-color: black;
    }
    ak-locale-context {
        display: flex;
        flex-direction: column;
    }
    .pf-c-drawer__main {
        min-height: calc(100vh - 76px);
        max-height: calc(100vh - 76px);
    }
`;
var UserInterfacePresentation = class extends AKElement {
  constructor() {
    super(...arguments);
    this.notificationDrawerOpen = false;
    this.apiDrawerOpen = false;
    this.notificationsCount = 0;
  }
  static get styles() {
    return [
      patternfly_base_default,
      display_default,
      brand_default,
      page_default,
      avatar_default,
      button_default,
      drawer_default,
      dropdown_default,
      notification_badge_default,
      customStyles
    ];
  }
  get canAccessAdmin() {
    return this.me.user.isSuperuser || // TODO: somehow add `access_admin_interface` to the API schema
    this.me.user.systemPermissions.includes("access_admin_interface");
  }
  get isFullyConfigured() {
    return Boolean(this.uiConfig && this.me && this.brand);
  }
  renderAdminInterfaceLink() {
    if (!this.canAccessAdmin) {
      return D;
    }
    return ke`<a
                class="pf-c-button pf-m-secondary pf-m-small pf-u-display-none pf-u-display-block-on-md"
                href="${globalAK().api.base}if/admin/"
                slot="extra"
            >
                ${msg("Admin interface")}
            </a>
            <a
                class="pf-c-button pf-m-secondary pf-m-small pf-u-display-none-on-md pf-u-display-block"
                href="${globalAK().api.base}if/admin/"
                slot="extra"
            >
                ${msg("Admin")}
            </a>`;
  }
  render() {
    if (!this.isFullyConfigured) {
      throw new Error("ak-interface-user-presentation misused; no valid values passed");
    }
    return ke`<ak-locale-context>
            <ak-enterprise-status interface="user"></ak-enterprise-status>
            <div class="pf-c-page">
                <div class="background-wrapper" style="${this.uiConfig.theme.background}">
                    ${(this.uiConfig.theme.background || "") === "" ? ke`<div class="background-default-slant"></div>` : ke``}
                </div>
                <header class="pf-c-page__header">
                    <div class="pf-c-page__header-brand">
                        <a href="#/" class="pf-c-page__header-brand-link">
                            <img
                                class="pf-c-brand"
                                src="${themeImage(this.brand.brandingLogo)}"
                                alt="${this.brand.brandingTitle}"
                            />
                        </a>
                    </div>
                    <ak-nav-buttons .uiConfig=${this.uiConfig} .me=${this.me}
                        >${this.renderAdminInterfaceLink()}</ak-nav-buttons
                    >
                </header>
                <div class="pf-c-page__drawer">
                    <div
                        class="pf-c-drawer ${this.notificationDrawerOpen || this.apiDrawerOpen ? "pf-m-expanded" : "pf-m-collapsed"}"
                    >
                        <div class="pf-c-drawer__main">
                            <div class="pf-c-drawer__content">
                                <div class="pf-c-drawer__body">
                                    <main class="pf-c-page__main">
                                        <ak-router-outlet
                                            role="main"
                                            class="pf-l-bullseye__item pf-c-page__main"
                                            tabindex="-1"
                                            id="main-content"
                                            defaultUrl="/library"
                                            .routes=${ROUTES}
                                        >
                                        </ak-router-outlet>
                                    </main>
                                </div>
                            </div>
                            <ak-notification-drawer
                                class="pf-c-drawer__panel pf-m-width-33 ${this.notificationDrawerOpen ? "" : "display-none"}"
                                ?hidden=${!this.notificationDrawerOpen}
                            ></ak-notification-drawer>
                            <ak-api-drawer
                                class="pf-c-drawer__panel pf-m-width-33 ${this.apiDrawerOpen ? "" : "display-none"}"
                                ?hidden=${!this.apiDrawerOpen}
                            ></ak-api-drawer>
                        </div>
                    </div>
                </div>
            </div>
        </ak-locale-context>`;
  }
};
__decorateClass([
  n({ type: Object })
], UserInterfacePresentation.prototype, "uiConfig", 2);
__decorateClass([
  n({ type: Object })
], UserInterfacePresentation.prototype, "me", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], UserInterfacePresentation.prototype, "notificationDrawerOpen", 2);
__decorateClass([
  n({ type: Boolean, reflect: true })
], UserInterfacePresentation.prototype, "apiDrawerOpen", 2);
__decorateClass([
  n({ type: Number })
], UserInterfacePresentation.prototype, "notificationsCount", 2);
__decorateClass([
  n({ type: Object })
], UserInterfacePresentation.prototype, "brand", 2);
UserInterfacePresentation = __decorateClass([
  t("ak-interface-user-presentation")
], UserInterfacePresentation);
var UserInterface = class extends AuthenticatedInterface {
  constructor() {
    super();
    this.notificationDrawerOpen = getURLParam("notificationDrawerOpen", false);
    this.apiDrawerOpen = getURLParam("apiDrawerOpen", false);
    this.notificationsCount = 0;
    this.ws = new WebsocketClient();
    this.fetchConfigurationDetails();
    configureSentry(true);
    this.toggleNotificationDrawer = this.toggleNotificationDrawer.bind(this);
    this.toggleApiDrawer = this.toggleApiDrawer.bind(this);
    this.fetchConfigurationDetails = this.fetchConfigurationDetails.bind(this);
  }
  connectedCallback() {
    super.connectedCallback();
    window.addEventListener(EVENT_NOTIFICATION_DRAWER_TOGGLE, this.toggleNotificationDrawer);
    window.addEventListener(EVENT_API_DRAWER_TOGGLE, this.toggleApiDrawer);
    window.addEventListener(EVENT_WS_MESSAGE, this.fetchConfigurationDetails);
  }
  disconnectedCallback() {
    window.removeEventListener(EVENT_NOTIFICATION_DRAWER_TOGGLE, this.toggleNotificationDrawer);
    window.removeEventListener(EVENT_API_DRAWER_TOGGLE, this.toggleApiDrawer);
    window.removeEventListener(EVENT_WS_MESSAGE, this.fetchConfigurationDetails);
    super.disconnectedCallback();
  }
  toggleNotificationDrawer() {
    this.notificationDrawerOpen = !this.notificationDrawerOpen;
    updateURLParams({
      notificationDrawerOpen: this.notificationDrawerOpen
    });
  }
  toggleApiDrawer() {
    this.apiDrawerOpen = !this.apiDrawerOpen;
    updateURLParams({
      apiDrawerOpen: this.apiDrawerOpen
    });
  }
  fetchConfigurationDetails() {
    me().then((me2) => {
      this.me = me2;
      new EventsApi(DEFAULT_CONFIG).eventsNotificationsList({
        seen: false,
        ordering: "-created",
        pageSize: 1,
        user: this.me.user.pk
      }).then((notifications) => {
        this.notificationsCount = notifications.pagination.count;
      });
    });
  }
  get isFullyConfigured() {
    return Boolean(this.uiConfig && this.me);
  }
  render() {
    if (!this.isFullyConfigured) {
      return D;
    }
    return ke`<ak-interface-user-presentation
            .uiConfig=${this.uiConfig}
            .me=${this.me}
            .brand=${this.brand ?? DefaultBrand}
            ?notificationDrawerOpen=${this.notificationDrawerOpen}
            ?apiDrawerOpen=${this.apiDrawerOpen}
            notificationsCount=${this.notificationsCount}
        ></ak-interface-user-presentation>`;
  }
};
__decorateClass([
  n({ type: Boolean })
], UserInterface.prototype, "notificationDrawerOpen", 2);
__decorateClass([
  r()
], UserInterface.prototype, "apiDrawerOpen", 2);
__decorateClass([
  r()
], UserInterface.prototype, "notificationsCount", 2);
__decorateClass([
  r()
], UserInterface.prototype, "me", 2);
UserInterface = __decorateClass([
  t("ak-interface-user")
], UserInterface);
export {
  UserInterface
};
//# sourceMappingURL=UserInterface-2025.2.4.js.map
